(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     88495,       2018]
NotebookOptionsPosition[     85900,       1941]
NotebookOutlinePosition[     86342,       1958]
CellTagsIndexPosition[     86299,       1955]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", 
  "***********************************************************************************************************************)"}\
]], "Input",
 CellChangeTimes->{{3.46026062878125*^9, 3.460260639203125*^9}, {
  3.47520919296875*^9, 3.475209199046875*^9}, {3.4752263993368254`*^9, 
  3.475226403993165*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"isrestart", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"isparallel", "=", "True"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"primodel", "=", 
     RowBox[{
      RowBox[{"\"\<P1\>\"", "\[Equal]", ">", "lam"}], "=", "rho"}]}], ";", 
    " ", 
    RowBox[{"primodel", "=", 
     RowBox[{
      RowBox[{"\"\<P2\>\"", "\[Equal]", ">", "lam"}], "=", 
      RowBox[{
       RowBox[{"rho", "/", "theta"}], " ", "as", " ", "used", " ", "in", " ", 
       "lamarc"}]}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"primodel", "=", "\"\<P1\>\""}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"ascertainmodel", "=", 
    RowBox[{"\"\<M1\>\"", " ", "or", " ", "\"\<M2\>\""}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ascertainmodel", "=", "\"\<M1\>\""}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"ngroupofchain", " ", "*", " ", "nchainofgroup"}], " ", "=", " ", 
    RowBox[{"total", " ", "number", " ", "of", " ", "mcmc", " ", "chains"}]}],
    "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ngroupofchain", "=", "2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nchainofgroup", "=", "16"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"heatingAR", "=", "0.5"}], ";"}], " ", 
  RowBox[{"(*", 
   RowBox[{"target", " ", "accept", " ", "ratio", " ", "when", " ", 
    RowBox[{"permuting", "/", "swapping"}], " ", "chains", " ", "within", " ",
     "each", " ", "group"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"datafile", "=", "\"\<Data_Standard.txt\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"outcompact", "=", 
  RowBox[{
  "\"\<SMARTree_OutCompact_\>\"", "<>", "ascertainmodel", "<>", "primodel", 
   "<>", "\"\<_\>\"", "<>", "datafile"}]}], "\[IndentingNewLine]", 
 RowBox[{"outcold", "=", 
  RowBox[{
  "\"\<SMARTree_OutCold_\>\"", "<>", "ascertainmodel", "<>", "primodel", 
   "<>", "\"\<_\>\"", "<>", "datafile"}]}], "\[IndentingNewLine]", 
 RowBox[{"outset", "=", 
  RowBox[{
  "\"\<SMARTree_OutSetting_\>\"", "<>", "ascertainmodel", "<>", "primodel", 
   "<>", "\"\<_\>\"", "<>", "datafile"}]}], "\[IndentingNewLine]", 
 RowBox[{"outstate", "=", 
  RowBox[{
  "\"\<SMARTree_MCMCState_\>\"", "<>", "ascertainmodel", "<>", "primodel", 
   "<>", "\"\<_\>\"", "<>", "datafile"}]}]}], "Input",
 CellChangeTimes->{{3.5691197868590717`*^9, 3.5691197998498154`*^9}, {
   3.5691198384430227`*^9, 3.569119858550173*^9}, {3.569120710533903*^9, 
   3.569120756165513*^9}, {3.569120872922191*^9, 3.569120873494224*^9}, {
   3.5691209684136534`*^9, 3.5691210503633404`*^9}, {3.569121082207162*^9, 
   3.5691210826551876`*^9}, {3.5691218789367323`*^9, 3.569121883323983*^9}, {
   3.569123123885939*^9, 3.5691231270231185`*^9}, {3.5691246718864794`*^9, 
   3.569124675173668*^9}, {3.569124812271509*^9, 3.5691248248192267`*^9}, {
   3.569126480619933*^9, 3.569126587854067*^9}, {3.5691885323878016`*^9, 
   3.569188594848374*^9}, {3.5694680808653173`*^9, 3.5694680931800213`*^9}, {
   3.5694689017352686`*^9, 3.569468902134291*^9}, {3.5694689875521765`*^9, 
   3.5694689961496687`*^9}, {3.569469195860091*^9, 3.5694692253957806`*^9}, {
   3.5694699275499415`*^9, 3.5694699311641483`*^9}, {3.5694701131345563`*^9, 
   3.569470127311367*^9}, {3.5694703176502542`*^9, 3.569470320185399*^9}, {
   3.5694899197675548`*^9, 3.569489923402361*^9}, {3.569533964200055*^9, 
   3.5695340268926406`*^9}, {3.569534062598683*^9, 3.5695341133965883`*^9}, {
   3.5695341563940477`*^9, 3.5695341568650746`*^9}, {3.5695342013016167`*^9, 
   3.56953421133119*^9}, {3.569534256539776*^9, 3.5695342595259466`*^9}, 
   3.569546226431676*^9, {3.5695469982138195`*^9, 3.5695469987718515`*^9}, {
   3.5695495668887396`*^9, 3.5695495715900087`*^9}, {3.569549767349205*^9, 
   3.569549789623479*^9}, {3.569550032220355*^9, 3.5695500324973707`*^9}, {
   3.569550179567783*^9, 3.569550181199876*^9}, {3.5695502728401175`*^9, 
   3.5695502797275114`*^9}, {3.5695503247990894`*^9, 3.569550337454813*^9}, {
   3.569551078926223*^9, 3.5695510827604427`*^9}, {3.5695520540289955`*^9, 
   3.569552057969221*^9}, {3.569552204273589*^9, 3.5695522415497212`*^9}, {
   3.569552334340029*^9, 3.5695523550972157`*^9}, {3.569552562332069*^9, 
   3.569552562894101*^9}, {3.5695529236907377`*^9, 3.5695529242497697`*^9}, {
   3.574717466009091*^9, 3.5747174688170958`*^9}, {3.574717804170885*^9, 
   3.5747178049664865`*^9}, {3.574718276899016*^9, 3.5747182807054224`*^9}, {
   3.5747183548835526`*^9, 3.574718379983997*^9}, {3.5747184149748583`*^9, 
   3.574718417626863*^9}, 3.5747228934160004`*^9, {3.5747230951619554`*^9, 
   3.5747231775457*^9}, 3.5747235282959166`*^9, {3.5747235692771883`*^9, 
   3.5747235725687943`*^9}, {3.5747236589149456`*^9, 3.5747236671985607`*^9}, 
   3.574723747460701*^9, 3.5747239485450544`*^9, 3.5747250036003785`*^9, 
   3.574725161160655*^9, 3.574725664959553*^9, {3.574725715784442*^9, 
   3.5747257219932528`*^9}, {3.574725843876267*^9, 3.5747258508182793`*^9}, {
   3.574726039760619*^9, 3.57472604030662*^9}, {3.5747297566089573`*^9, 
   3.5747297589645615`*^9}, {3.5747298181978655`*^9, 3.57472982072507*^9}, 
   3.5747299877555637`*^9, 3.5748493723250184`*^9, 3.574849441856741*^9, {
   3.574903967009988*^9, 3.574903967602789*^9}, {3.574906030848813*^9, 
   3.574906033032817*^9}, {3.5749082817611537`*^9, 3.574908282400755*^9}, {
   3.5749104768615828`*^9, 3.574910477478986*^9}, {3.574933005030694*^9, 
   3.5749330156699123`*^9}, {3.574980184576083*^9, 3.5749801870096874`*^9}, 
   3.574980253529804*^9, 3.5749806485694733`*^9, {3.574981669223126*^9, 
   3.574981669785635*^9}, 3.5750202563237047`*^9, {3.5750269112130294`*^9, 
   3.5750269118682303`*^9}, {3.575031779172219*^9, 3.57503177995222*^9}, 
   3.5750318613172817`*^9, {3.575070280652694*^9, 3.5750702870487056`*^9}, {
   3.5750794862298555`*^9, 3.575079486838257*^9}, {3.575111007657836*^9, 
   3.5751110136950464`*^9}, {3.5751113460520177`*^9, 3.575111348516822*^9}, {
   3.5751123765393653`*^9, 3.5751123782865686`*^9}, 3.5751170168490705`*^9, 
   3.5751188525058713`*^9, 3.5751189368600197`*^9, {3.575123252003336*^9, 
   3.575123253157738*^9}, {3.575123846655204*^9, 3.57512384997801*^9}, {
   3.5751239335161567`*^9, 3.575123959287402*^9}, {3.5751263871628323`*^9, 
   3.5751263881378355`*^9}, 3.575152283185444*^9, {3.575157122014126*^9, 
   3.575157122918927*^9}, {3.575159586619399*^9, 3.5751595942478123`*^9}, {
   3.5751605339681416`*^9, 3.5751605342645416`*^9}, {3.5751605717826076`*^9, 
   3.5751605869146347`*^9}, 3.57516107396309*^9, 3.575165680502438*^9, {
   3.57516706192935*^9, 3.5751670807741833`*^9}, {3.575167117091447*^9, 
   3.5751671210850544`*^9}, 3.5751719689782267`*^9, {3.5751724145219374`*^9, 
   3.5751724151147385`*^9}, {3.575185197752375*^9, 3.5751852021203833`*^9}, {
   3.575203332559677*^9, 3.575203332707179*^9}, {3.5752037441984997`*^9, 
   3.5752037806140585`*^9}, {3.5752038176571283`*^9, 
   3.5752038179021316`*^9}, {3.5752048095751657`*^9, 3.575204810167967*^9}, {
   3.5752072930760984`*^9, 3.575207293622099*^9}, 3.5752097525574875`*^9, {
   3.5752127694076405`*^9, 3.5752127706400433`*^9}, {3.5752130923604083`*^9, 
   3.57521309339001*^9}, {3.5752474452085595`*^9, 3.5752474457077603`*^9}, {
   3.575253309015024*^9, 3.575253309873026*^9}, {3.5752541233324556`*^9, 
   3.575254123800456*^9}, {3.5752625573671923`*^9, 3.57526258979245*^9}, {
   3.5752626703509912`*^9, 3.5752627010674453`*^9}, {3.575262759286747*^9, 
   3.5752627821719875`*^9}, {3.575263104640154*^9, 3.5752631050301547`*^9}, {
   3.5752635203368845`*^9, 3.5752635208360853`*^9}, {3.5752641356809654`*^9, 
   3.575264168004222*^9}, {3.575265244264968*^9, 3.5752652471041727`*^9}, {
   3.5753852413839593`*^9, 3.57538524191436*^9}, {3.5753853652169766`*^9, 
   3.5753853916590233`*^9}, 3.575385754671661*^9, {3.5753859791076555`*^9, 
   3.5753860016496944`*^9}, {3.5753862677945805`*^9, 
   3.5753862759377947`*^9}, {3.575387131391698*^9, 3.5753871399873133`*^9}, {
   3.5774389851804514`*^9, 3.57743905227617*^9}, {3.5778649522401447`*^9, 
   3.5778649640138183`*^9}, {3.577865276335682*^9, 3.5778652899484606`*^9}, {
   3.5778832824244933`*^9, 3.577883284514897*^9}, {3.5778860007669744`*^9, 
   3.577886001744031*^9}, {3.577936974184384*^9, 3.5779370052908382`*^9}, {
   3.5779376605943604`*^9, 3.577937664728368*^9}, {3.577962740500083*^9, 
   3.577962746839445*^9}, {3.577972901231243*^9, 3.5779729018402777`*^9}, {
   3.578124413249694*^9, 3.5781244190841045`*^9}, {3.578124493699035*^9, 
   3.578124526006692*^9}, {3.5781315199108467`*^9, 3.5781315227500515`*^9}, {
   3.5781374500444946`*^9, 3.578137452368899*^9}, 3.5795379350441294`*^9, 
   3.5795381874585667`*^9, 3.5796240552639675`*^9, {3.5797233341865273`*^9, 
   3.5797233365596633`*^9}, {3.579803701982311*^9, 3.5798037063815184`*^9}, {
   3.5799672999818873`*^9, 3.579967314764733*^9}, {3.5800605533842683`*^9, 
   3.5800605575806756`*^9}, {3.5801442229832907`*^9, 3.5801442338097095`*^9}, 
   3.5801446550889764`*^9, {3.5803124576403522`*^9, 3.5803124597714744`*^9}, {
   3.581738719893539*^9, 3.581738751873595*^9}, 3.5817508761650534`*^9, {
   3.5817509936176596`*^9, 3.5817510127432933`*^9}, {3.5817693329536495`*^9, 
   3.5817693393028603`*^9}, {3.5818229354975567`*^9, 3.581822935653557*^9}, {
   3.5818539868185196`*^9, 3.5818539946653337`*^9}, {3.5824331987787924`*^9, 
   3.5824331990907927`*^9}, {3.582433379005909*^9, 3.5824333858387213`*^9}, 
   3.5824368955520687`*^9, {3.582437138094695*^9, 3.582437140419099*^9}, {
   3.5824378627957706`*^9, 3.582438014646437*^9}, {3.5824392456055984`*^9, 
   3.5824392476960025`*^9}, {3.5824392794576583`*^9, 3.582439279956859*^9}, {
   3.582439825350417*^9, 3.5824398255220175`*^9}, {3.5824512220508747`*^9, 
   3.5824512223316755`*^9}, {3.5824520954926105`*^9, 3.5824520959918113`*^9}, 
   3.5824521429166937`*^9, {3.5826528559501457`*^9, 3.582652942780112*^9}, {
   3.583601592011724*^9, 3.5836015954655437`*^9}, {3.5856655639724245`*^9, 
   3.5856655863724556`*^9}, {3.5857632444083147`*^9, 3.585763261595298*^9}}],

Cell[BoxData["\<\"P1\"\>"], "Output",
 CellChangeTimes->{3.5857633987651434`*^9}],

Cell[BoxData["\<\"SMARTree_OutCompact_M1P1_Data_Standard.txt\"\>"], "Output",
 CellChangeTimes->{3.585763398772144*^9}],

Cell[BoxData["\<\"SMARTree_OutCold_M1P1_Data_Standard.txt\"\>"], "Output",
 CellChangeTimes->{3.585763398773144*^9}],

Cell[BoxData["\<\"SMARTree_OutSetting_M1P1_Data_Standard.txt\"\>"], "Output",
 CellChangeTimes->{3.585763398774144*^9}],

Cell[BoxData["\<\"SMARTree_MCMCState_M1P1_Data_Standard.txt\"\>"], "Output",
 CellChangeTimes->{3.585763398775144*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  "***********************************************************************************************************************)"}\
]], "Input",
 CellChangeTimes->{{3.46026062878125*^9, 3.460260639203125*^9}, {
  3.47520919296875*^9, 3.475209199046875*^9}, {3.4752263993368254`*^9, 
  3.475226403993165*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"Import", " ", "packages"}], "*)"}]], "Input",
 CellChangeTimes->{{3.5691232105948987`*^9, 3.569123223455634*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"workdir", "=", 
   RowBox[{"NotebookDirectory", "[", "]"}]}], ";"}], "\n", 
 RowBox[{"packagedir", "=", 
  RowBox[{
   RowBox[{"ParentDirectory", "[", 
    RowBox[{"NotebookDirectory", "[", "]"}], "]"}], "<>", 
   "\"\<\\\\Mathematica Packages\>\""}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetDirectory", "[", "packagedir", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Get", "[", "\"\<Genealogy`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Get", "[", "\"\<SMARTree`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetDirectory", "[", "workdir", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{"isparallel", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"DistributeDefinitions", "[", 
      RowBox[{"workdir", ",", "packagedir"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ParallelEvaluate", "[", 
      RowBox[{"SetDirectory", "[", "packagedir", "]"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ParallelEvaluate", "[", 
      RowBox[{"Get", "[", "\"\<Genealogy`\>\"", "]"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ParallelEvaluate", "[", 
      RowBox[{"Get", "[", "\"\<SMARTree`\>\"", "]"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ParallelEvaluate", "[", 
      RowBox[{"SetDirectory", "[", "workdir", "]"}], "]"}], ";"}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5824370461793337`*^9, 3.582437056615752*^9}, {
   3.582437088439808*^9, 3.582437121246666*^9}, 3.582452857645552*^9, 
   3.5836016802666388`*^9}],

Cell[BoxData["\<\"D:\\\\Chaozhi\\\\ChaozhiUW\\\\UWProjects\\\\UWProject2\\\\\
SMARTree_MathematicaCode\\\\Mathematica Packages\"\>"], "Output",
 CellChangeTimes->{3.5857633988011456`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "compat"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Combinatorica Graph and Permutations functionality has \
been superseded by preloaded functionality. The package now being loaded may \
conflict with this. Please see the Compatibility Guide for details.\"\>"}]], \
"Message", "MSG",
 CellChangeTimes->{3.5857633989231524`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "obspkg"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(\\\"PlotLegends`\\\"\\)\[NoBreak] is now \
obsolete. The legacy version being loaded may conflict with current \
Mathematica functionality. See the Compatibility Guide for updating \
information.\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.5857633996101913`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "compat"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Combinatorica Graph and Permutations functionality has \
been superseded by preloaded functionality. The package now being loaded may \
conflict with this. Please see the Compatibility Guide for details.\"\>"}]], \
"Message", "MSG",
 ShowCellLabel->True,
 CellChangeTimes->{3.5857634033114033`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "compat"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Combinatorica Graph and Permutations functionality has \
been superseded by preloaded functionality. The package now being loaded may \
conflict with this. Please see the Compatibility Guide for details.\"\>"}]], \
"Message", "MSG",
 ShowCellLabel->True,
 CellChangeTimes->{3.585763403336405*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "compat"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Combinatorica Graph and Permutations functionality has \
been superseded by preloaded functionality. The package now being loaded may \
conflict with this. Please see the Compatibility Guide for details.\"\>"}]], \
"Message", "MSG",
 ShowCellLabel->True,
 CellChangeTimes->{3.585763403360406*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "compat"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Combinatorica Graph and Permutations functionality has \
been superseded by preloaded functionality. The package now being loaded may \
conflict with this. Please see the Compatibility Guide for details.\"\>"}]], \
"Message", "MSG",
 ShowCellLabel->True,
 CellChangeTimes->{3.5857634033854074`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "compat"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Combinatorica Graph and Permutations functionality has \
been superseded by preloaded functionality. The package now being loaded may \
conflict with this. Please see the Compatibility Guide for details.\"\>"}]], \
"Message", "MSG",
 ShowCellLabel->True,
 CellChangeTimes->{3.585763403406409*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "compat"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Combinatorica Graph and Permutations functionality has \
been superseded by preloaded functionality. The package now being loaded may \
conflict with this. Please see the Compatibility Guide for details.\"\>"}]], \
"Message", "MSG",
 ShowCellLabel->True,
 CellChangeTimes->{3.58576340342841*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "compat"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Combinatorica Graph and Permutations functionality has \
been superseded by preloaded functionality. The package now being loaded may \
conflict with this. Please see the Compatibility Guide for details.\"\>"}]], \
"Message", "MSG",
 ShowCellLabel->True,
 CellChangeTimes->{3.5857634034514112`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "compat"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Combinatorica Graph and Permutations functionality has \
been superseded by preloaded functionality. The package now being loaded may \
conflict with this. Please see the Compatibility Guide for details.\"\>"}]], \
"Message", "MSG",
 ShowCellLabel->True,
 CellChangeTimes->{3.5857634036624236`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "obspkg"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\\"PlotLegends`\\\"\\) is now obsolete. The legacy \
version being loaded may conflict with current Mathematica functionality. See \
the Compatibility Guide for updating information.\"\>"}]], "Message", "MSG",
 ShowCellLabel->True,
 CellChangeTimes->{3.585763404708483*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "obspkg"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\\"PlotLegends`\\\"\\) is now obsolete. The legacy \
version being loaded may conflict with current Mathematica functionality. See \
the Compatibility Guide for updating information.\"\>"}]], "Message", "MSG",
 ShowCellLabel->True,
 CellChangeTimes->{3.585763404735485*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "obspkg"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\\"PlotLegends`\\\"\\) is now obsolete. The legacy \
version being loaded may conflict with current Mathematica functionality. See \
the Compatibility Guide for updating information.\"\>"}]], "Message", "MSG",
 ShowCellLabel->True,
 CellChangeTimes->{3.5857634047584863`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "obspkg"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\\"PlotLegends`\\\"\\) is now obsolete. The legacy \
version being loaded may conflict with current Mathematica functionality. See \
the Compatibility Guide for updating information.\"\>"}]], "Message", "MSG",
 ShowCellLabel->True,
 CellChangeTimes->{3.5857634047834873`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "obspkg"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\\"PlotLegends`\\\"\\) is now obsolete. The legacy \
version being loaded may conflict with current Mathematica functionality. See \
the Compatibility Guide for updating information.\"\>"}]], "Message", "MSG",
 ShowCellLabel->True,
 CellChangeTimes->{3.585763404807489*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "obspkg"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\\"PlotLegends`\\\"\\) is now obsolete. The legacy \
version being loaded may conflict with current Mathematica functionality. See \
the Compatibility Guide for updating information.\"\>"}]], "Message", "MSG",
 ShowCellLabel->True,
 CellChangeTimes->{3.58576340483049*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "obspkg"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\\"PlotLegends`\\\"\\) is now obsolete. The legacy \
version being loaded may conflict with current Mathematica functionality. See \
the Compatibility Guide for updating information.\"\>"}]], "Message", "MSG",
 ShowCellLabel->True,
 CellChangeTimes->{3.5857634048974943`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "obspkg"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\\"PlotLegends`\\\"\\) is now obsolete. The legacy \
version being loaded may conflict with current Mathematica functionality. See \
the Compatibility Guide for updating information.\"\>"}]], "Message", "MSG",
 ShowCellLabel->True,
 CellChangeTimes->{3.5857634050985055`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  "***********************************************************************************************************************)"}\
]], "Input",
 CellChangeTimes->{{3.46026062878125*^9, 3.460260639203125*^9}, {
  3.47520919296875*^9, 3.475209199046875*^9}, {3.4752263993368254`*^9, 
  3.475226403993165*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"Import", " ", "data", " ", "and", " ", "Setup", " ", "priors"}], 
  "*)"}]], "Input",
 CellChangeTimes->{{3.569123237681448*^9, 3.5691232417846823`*^9}, {
  3.5691235090339684`*^9, 3.5691235119551353`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"temp", "=", 
   RowBox[{"ReadList", "[", "datafile", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"nbp", ",", "nsq"}], "}"}], "=", 
   RowBox[{"temp", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"temp", "=", 
   RowBox[{"Rest", "[", "temp", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"snpls", "=", 
    RowBox[{"Transpose", "[", 
     RowBox[{"Append", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", "temp", "]"}], ",", 
       RowBox[{"Table", "[", 
        RowBox[{"0", ",", 
         RowBox[{"{", 
          RowBox[{"Length", "[", "temp", "]"}], "}"}]}], "]"}]}], "]"}], 
     "]"}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
      "The", " ", "prior", " ", "distribution", " ", "of", " ", "theta", " ", 
       "is", " ", 
       RowBox[{"Gamma", "[", 
        RowBox[{"shape", ",", " ", "scale"}], "]"}]}], ",", " ", 
      RowBox[{"truncated", " ", "to", " ", "be", " ", "in", " ", "the", " ", 
       RowBox[{"range", " ", "[", 
        RowBox[{"min", ",", " ", "max"}], "]"}]}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"pritheta", "=", 
     RowBox[{"{", 
      RowBox[{"shape", ",", "scale", ",", "min", ",", "max"}], "}"}]}], ";"}],
    "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pritheta", "=", 
    RowBox[{"{", 
     RowBox[{"1", ",", "Infinity", ",", "0", ",", "0.01"}], "}"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
       "The", " ", "prior", " ", "distribution", " ", "of", " ", "lambda", 
        " ", "is", " ", 
        RowBox[{"Gamma", "[", 
         RowBox[{"shape", ",", " ", "scale"}], "]"}]}], ",", " ", 
       RowBox[{"truncated", " ", "to", " ", "be", " ", "in", " ", "the", " ", 
        RowBox[{"range", " ", "[", 
         RowBox[{"min", ",", " ", "max"}], "]"}]}]}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"prilambda", "=", 
      RowBox[{"{", 
       RowBox[{"shape", ",", "scale", ",", "min", ",", "max"}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", " ", "primodel"}], "\[Equal]", "\"\<P2\>\""}]}], ",", 
    RowBox[{"lambda", "=", 
     RowBox[{"rho", "/", "theta"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"prilambda", "=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"primodel", "\[Equal]", "\"\<P1\>\""}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "Infinity", ",", "0", ",", "0.01"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "Infinity", ",", "0", ",", "10"}], "}"}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
      "The", " ", "prior", " ", "distribution", " ", "of", " ", "epsilon", 
       " ", "is", " ", 
       RowBox[{"Beta", "[", 
        RowBox[{"alpha", ",", "beta"}], "]"}]}], ",", " ", 
      RowBox[{"truncated", " ", "to", " ", "be", " ", "in", " ", "the", " ", 
       RowBox[{"range", " ", "[", 
        RowBox[{"min", ",", " ", "max"}], "]"}]}]}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"prieps", "=", 
     RowBox[{"{", 
      RowBox[{"alpha", ",", "beta", ",", "min", ",", "max"}], "}"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"prieps", "=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"primodel", "\[Equal]", "\"\<P1\>\""}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0", ",", "0.1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "0.00099", ",", "0.00101"}], "}"}]}], 
    "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5691233315098143`*^9, 3.569123405755061*^9}, {
   3.5691235315882587`*^9, 3.5691236544272842`*^9}, 3.5691252227339864`*^9, {
   3.5691252806893015`*^9, 3.5691253123571124`*^9}, {3.569136649698374*^9, 
   3.569136801086033*^9}, {3.5691884410525775`*^9, 3.569188452844252*^9}, {
   3.5691886172346544`*^9, 3.5691886226049614`*^9}, {3.575263116293374*^9, 
   3.5752631311134005`*^9}, {3.575264344471732*^9, 3.5752643446433325`*^9}, {
   3.582437348730265*^9, 3.5824373493230667`*^9}, {3.582437660186414*^9, 
   3.5824376607480145`*^9}, {3.5824513073528247`*^9, 
   3.5824513190216455`*^9}, {3.5824513727313404`*^9, 3.582451436551052*^9}, {
   3.582451513755588*^9, 3.582451591911725*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  "***********************************************************************************************************************)"}\
]], "Input",
 CellChangeTimes->{{3.46026062878125*^9, 3.460260639203125*^9}, {
  3.47520919296875*^9, 3.475209199046875*^9}, {3.4752263993368254`*^9, 
  3.475226403993165*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "set", " ", "parallel", " ", "temperating", " ", "and", " ", "set", " ", 
   "initial", " ", "values", " ", "of", " ", "mcmc", " ", "chains"}], 
  "*)"}]], "Input",
 CellChangeTimes->{{3.5691261611596613`*^9, 3.5691261777426095`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"If", "[", 
  RowBox[{"isrestart", ",", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"mcstate", " ", "file", " ", "save", " ", 
     RowBox[{"{", 
      RowBox[{"adpheat", " ", "and", " ", "mcstate"}], "}"}]}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Get", "[", "outstate", "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ngroupofchain", ",", "nchainofgroup"}], "}"}], "=", 
     RowBox[{"Most", "[", 
      RowBox[{"Dimensions", "[", "mcstate", "]"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"itsave", "\[Equal]", "0"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"adpheat", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"InitialProposalScale", "[", "heatingAR", "]"}], ",", 
          RowBox[{"{", "ngroupofchain", "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"adpheat", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", 
           RowBox[{"-", "1"}]}], "]"}], "]"}], "=", 
        RowBox[{
         RowBox[{
          RowBox[{"Mean", "[", 
           RowBox[{"Differences", "[", "#", "]"}], "]"}], "&"}], "/@", 
         RowBox[{"mcstate", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "All", ",", "1"}], "]"}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"mcstate", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", "5", ",", "All", ",", "2"}], "]"}], 
         "]"}], "=", "0.5"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"mcstate", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "All", ",", "5", ",", "All", ",", "3"}], "]"}], 
         "]"}], "=", "0.05"}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"!", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"FileExistsQ", "[", "outcold", "]"}], "&&", 
         RowBox[{"FileExistsQ", "[", "outcompact", "]"}]}], ")"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Put", "[", "outcold", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Put", "[", "outcompact", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"itsaved", "=", "0"}], ";"}]}], "\[IndentingNewLine]", "]"}]}],
    ",", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"set", " ", "adpheat", " ", "and", " ", "mcstate"}], ";", 
     "\[IndentingNewLine]", "  ", 
     RowBox[{"chainheat", ":", " ", 
      RowBox[{"sets", " ", "of", " ", "inverse", " ", "temperatures"}]}]}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"itsaved", "=", "0"}], ";", "\[IndentingNewLine]", 
    RowBox[{"deltheat", "=", "0.005"}], ";", "\[IndentingNewLine]", 
    RowBox[{"chainheat", "=", 
     RowBox[{"1", "-", 
      RowBox[{"deltheat", " ", 
       RowBox[{"Range", "[", 
        RowBox[{
         RowBox[{"nchainofgroup", "-", "1"}], ",", "0", ",", 
         RowBox[{"-", "1"}]}], "]"}]}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"adpheat", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"InitialProposalScale", "[", "heatingAR", "]"}], ",", 
       RowBox[{"{", "ngroupofchain", "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"adpheat", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", 
        RowBox[{"-", "1"}]}], "]"}], "]"}], "=", "deltheat"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"mcstate", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"h", ",", "0"}], "}"}], ",", 
         RowBox[{"initializeSMARTchain", "[", 
          RowBox[{
          "snpls", ",", "nsq", ",", "nbp", ",", "pritheta", ",", "prieps", 
           ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "Infinity", ",", "0.00039", ",", "0.00041"}], 
            "}"}], ",", "\"\<P1\>\"", ",", "ascertainmodel"}], "]"}]}], "]"}],
        ",", 
       RowBox[{"{", "ngroupofchain", "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"h", ",", "chainheat"}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Put", "[", "outcold", "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Put", "[", "outcompact", "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"saveSMARTchain", "[", 
     RowBox[{
     "mcstate", ",", "nsq", ",", "adpheat", ",", "outcompact", ",", 
      "outcold"}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Quiet", "[", 
     RowBox[{"DeleteFile", "[", "outstate", "]"}], "]"}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Save", "[", 
     RowBox[{"outstate", ",", 
      RowBox[{"{", 
       RowBox[{"mcstate", ",", "adpheat", ",", "itsaved"}], "}"}]}], "]"}], 
    ";"}]}], "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", "mcstate", "]"}]}], "Input",
 CellChangeTimes->{{3.5691249154234095`*^9, 3.569125005591566*^9}, {
   3.5691260290291038`*^9, 3.569126029423126*^9}, {3.569126106225519*^9, 
   3.569126113788952*^9}, {3.569126191363389*^9, 3.5691262004439077`*^9}, 
   3.5691265993367233`*^9, 3.569126705554799*^9, {3.5691298053930993`*^9, 
   3.569129814507621*^9}, {3.569137095762888*^9, 3.5691370974419837`*^9}, {
   3.56913754915482*^9, 3.5691376234460692`*^9}, {3.5691376634413567`*^9, 
   3.569137664994446*^9}, {3.5691377247708645`*^9, 3.569137730598198*^9}, 
   3.5691377667822676`*^9, {3.5691876818341527`*^9, 3.5691877133049526`*^9}, {
   3.5695421850792623`*^9, 3.5695421854542837`*^9}, {3.5695515294489913`*^9, 
   3.569551541431677*^9}, 3.569551582736039*^9, {3.5747180175480595`*^9, 
   3.5747180181408606`*^9}, {3.574718063880642*^9, 3.574718073724259*^9}, {
   3.5747229703397355`*^9, 3.5747229708077364`*^9}, {3.5748490489193316`*^9, 
   3.5748490495277324`*^9}, {3.5749082268861437`*^9, 3.5749082547761*^9}, {
   3.574916605907802*^9, 3.5749166061418023`*^9}, {3.574916640695863*^9, 
   3.5749166410858636`*^9}, {3.574933093189849*^9, 3.5749331212854986`*^9}, {
   3.5749340621099305`*^9, 3.57493406744514*^9}, {3.574936420371355*^9, 
   3.5749364423125043`*^9}, {3.5749809076620035`*^9, 
   3.5749809756318274`*^9}, {3.5749810106633897`*^9, 
   3.5749810117447915`*^9}, {3.5750220721901875`*^9, 
   3.5750220726893883`*^9}, {3.575022106276247*^9, 3.5750221457755165`*^9}, {
   3.57502325872955*^9, 3.5750232641606894`*^9}, {3.5750235176126785`*^9, 
   3.5750235205298834`*^9}, {3.5750269295742617`*^9, 3.575026933068668*^9}, 
   3.575031276398673*^9, {3.5750318262543116`*^9, 3.575031826472712*^9}, {
   3.5750703284667783`*^9, 3.5750703359703913`*^9}, {3.5750717536087723`*^9, 
   3.575071754045573*^9}, {3.5750794964946737`*^9, 3.5750794969782743`*^9}, {
   3.575108700194383*^9, 3.5751087163092117`*^9}, {3.575108764544496*^9, 
   3.5751087881161375`*^9}, {3.5751088351970205`*^9, 
   3.5751088356962214`*^9}, {3.5751090892434664`*^9, 3.575109110584304*^9}, 
   3.5751107870890484`*^9, {3.5751109229184875`*^9, 3.575110923402088*^9}, {
   3.5751109579873486`*^9, 3.5751109819801908`*^9}, {3.5751187967357736`*^9, 
   3.5751188180610113`*^9}, {3.5751190175121613`*^9, 
   3.5751190276365795`*^9}, {3.5751232260136905`*^9, 
   3.5751232266844916`*^9}, {3.575125198760858*^9, 3.5751251995208592`*^9}, {
   3.5751252659198647`*^9, 3.57512527640935*^9}, {3.575125392462335*^9, 
   3.575125406299516*^9}, {3.5751601554958763`*^9, 3.575160160831086*^9}, {
   3.575166207576033*^9, 3.57516621139804*^9}, {3.5751724288271627`*^9, 
   3.575172430761566*^9}, {3.575172473443241*^9, 3.575172489168069*^9}, {
   3.5752036126089783`*^9, 3.5752036145140076`*^9}, {3.575203837187428*^9, 
   3.5752038428975153`*^9}, {3.5752048022119527`*^9, 3.575204804567557*^9}, {
   3.575210454185774*^9, 3.5752104811582212`*^9}, {3.5752105205170903`*^9, 
   3.575210521421892*^9}, {3.57521275210721*^9, 3.575212760796426*^9}, {
   3.575213072829174*^9, 3.575213081034788*^9}, {3.575213161900531*^9, 
   3.575213164318535*^9}, {3.575253333897068*^9, 3.575253337999875*^9}, {
   3.575253672729663*^9, 3.575253674710867*^9}, {3.5752541372164803`*^9, 
   3.575254137793681*^9}, {3.575262561313999*^9, 3.5752625652920065`*^9}, 
   3.5752628385348864`*^9, 3.575262884258567*^9, 3.575263545203328*^9, {
   3.5752645212356424`*^9, 3.5752645217504435`*^9}, {3.57538532751171*^9, 
   3.575385346060143*^9}, 3.5753856773735247`*^9, {3.5753857554984617`*^9, 
   3.5753857582752666`*^9}, {3.57538629061742*^9, 3.575386292536224*^9}, {
   3.575386613849988*^9, 3.575386617687595*^9}, {3.5753871960070114`*^9, 
   3.5753871964750123`*^9}, {3.577883967598278*^9, 3.5778839748834906`*^9}, {
   3.5779368766062126`*^9, 3.5779368986334515`*^9}, {3.5779377948013964`*^9, 
   3.5779378120238266`*^9}, {3.5781262732261057`*^9, 3.57812627575331*^9}, {
   3.5781303598121033`*^9, 3.578130360794905*^9}, {3.578137270539979*^9, 
   3.578137330787285*^9}, {3.578137676962493*^9, 3.5781376809093*^9}, {
   3.579967327871483*^9, 3.5799673334498014`*^9}, {3.5824372531644974`*^9, 
   3.5824372533048973`*^9}, {3.582437787477838*^9, 3.582437789318641*^9}, {
   3.582438085189761*^9, 3.582438085798162*^9}, {3.582451467236306*^9, 
   3.5824514755511208`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2", ",", "16", ",", "8"}], "}"}]], "Output",
 CellChangeTimes->{3.585763410129793*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  "***********************************************************************************************************************)"}\
]], "Input",
 CellChangeTimes->{{3.46026062878125*^9, 3.460260639203125*^9}, {
  3.47520919296875*^9, 3.475209199046875*^9}, {3.4752263993368254`*^9, 
  3.475226403993165*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"setup", " ", "MCMC"}], "*)"}]], "Input",
 CellChangeTimes->{{3.5691262271974382`*^9, 3.569126235561917*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"rjfreq", "=", 
   RowBox[{"Ceiling", "[", 
    RowBox[{"nbp", "/", "5000"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"adpmax", "=", "2000"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"adprate", "=", 
   RowBox[{"3.", "/", "adpmax"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"itmin", "=", 
   RowBox[{"1", "+", "itsaved"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"itmax", "=", "10000000"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"printfreq", "=", "100"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"savefreq", "=", "2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"swapfreq", "=", "nchainofgroup"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"isprint", "=", "False"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5691262240712595`*^9, 3.569126267906767*^9}, 
   3.5691268962647066`*^9, {3.569127156506592*^9, 3.5691271566385994`*^9}, {
   3.5691276130647054`*^9, 3.569127623157283*^9}, {3.569128376879393*^9, 
   3.5691283870049725`*^9}, {3.569129055551211*^9, 3.569129057366315*^9}, {
   3.569129145187338*^9, 3.5691291463384037`*^9}, {3.569137177564566*^9, 
   3.569137179483676*^9}, 3.5692877403895316`*^9, 3.5692879782431493`*^9, 
   3.5694088488803167`*^9, {3.5694091831794376`*^9, 3.569409185208554*^9}, {
   3.5694097926602983`*^9, 3.569409796505518*^9}, {3.5694643964925833`*^9, 
   3.569464396647592*^9}, 3.5694678143200717`*^9, 3.5694682968076687`*^9, {
   3.5694684832583327`*^9, 3.569468492146841*^9}, {3.569468660055445*^9, 
   3.5694686881720533`*^9}, {3.569469454402879*^9, 3.569469458921138*^9}, {
   3.56946961596412*^9, 3.5694696170121803`*^9}, 3.569470312265946*^9, {
   3.569543697843049*^9, 3.569543700461199*^9}, {3.5695495464375696`*^9, 
   3.5695495512258434`*^9}, {3.5695499119784775`*^9, 3.569549912595513*^9}, {
   3.569552375015355*^9, 3.569552375900406*^9}, {3.56955257371072*^9, 
   3.569552574904788*^9}, {3.5695526364163065`*^9, 3.5695526410715723`*^9}, {
   3.5695526820509167`*^9, 3.5695526848260756`*^9}, {3.569553039406356*^9, 
   3.5695530405814233`*^9}, {3.5747227265589066`*^9, 
   3.5747227276353083`*^9}, {3.574724919641031*^9, 3.574724920343032*^9}, {
   3.5747260520846405`*^9, 3.574726062489859*^9}, {3.5747261371827908`*^9, 
   3.5747261401311955`*^9}, {3.57473029772895*^9, 3.5747303228293943`*^9}, {
   3.5747306064856925`*^9, 3.5747306083420954`*^9}, {3.574730711817077*^9, 
   3.5747307124254785`*^9}, {3.574812445683175*^9, 3.574812447960779*^9}, {
   3.574812610793865*^9, 3.5748126111994658`*^9}, {3.5748128838411446`*^9, 
   3.5748128884275527`*^9}, {3.574844608130333*^9, 3.574844612716741*^9}, {
   3.57484906520576*^9, 3.574849066063761*^9}, 3.574898884605505*^9, {
   3.574903972813198*^9, 3.574903973390399*^9}, 3.5749803037166924`*^9, 
   3.5749816603904905`*^9, {3.574981709623747*^9, 3.5749817098612504`*^9}, 
   3.5750115822509584`*^9, {3.5750221927627993`*^9, 3.575022196038805*^9}, 
   3.5750411347474356`*^9, {3.575070268593873*^9, 3.5750702688902736`*^9}, {
   3.5750710015155926`*^9, 3.575071001796393*^9}, {3.5751116519730616`*^9, 
   3.575111653954265*^9}, {3.5751188282478285`*^9, 3.575118829885832*^9}, {
   3.5751202528314667`*^9, 3.5751202567002735`*^9}, {3.5751203806048927`*^9, 
   3.575120380932493*^9}, {3.575123872208049*^9, 3.575123872410849*^9}, {
   3.5751604787752447`*^9, 3.5751604791184444`*^9}, 3.575167133783477*^9, {
   3.5751734171750193`*^9, 3.57517341744022*^9}, 3.5751852094679956`*^9, 
   3.5752072768604617`*^9, {3.575209758438698*^9, 3.575209761277903*^9}, {
   3.5752127369127836`*^9, 3.5752127404071903`*^9}, {3.575213054592742*^9, 
   3.575213058555149*^9}, {3.5752474513081703`*^9, 3.5752474516201706`*^9}, {
   3.575253319529443*^9, 3.5752533203094444`*^9}, {3.5752541432380905`*^9, 
   3.575254145016494*^9}, 3.5752634345055337`*^9, {3.575385959670021*^9, 
   3.5753859598416214`*^9}, {3.5778649880731945`*^9, 3.577864990847353*^9}, {
   3.5778652146261525`*^9, 3.577865215003174*^9}, {3.5778832941089134`*^9, 
   3.5778832946081142`*^9}, {3.577883467748923*^9, 3.5778834746597347`*^9}, {
   3.5778841674564357`*^9, 3.57788418127806*^9}, {3.577885980767831*^9, 
   3.5778859917034564`*^9}, 3.57788686944466*^9, 3.577887602122567*^9, {
   3.5778887028515253`*^9, 3.577888707374784*^9}, 3.577898356818701*^9, {
   3.577976127390769*^9, 3.577976138001376*^9}, 3.5780532091956615`*^9, 
   3.5780533223114605`*^9, 3.578056908128643*^9, 3.578057042101679*^9, {
   3.578057085313754*^9, 3.578057086109356*^9}, {3.578124438412538*^9, 
   3.5781244387089386`*^9}, {3.5781315122980328`*^9, 
   3.5781315127816343`*^9}, {3.5795381995082555`*^9, 3.5795382001862946`*^9}, 
   3.5801442735117793`*^9, {3.5801447976888266`*^9, 3.580144798968029*^9}, 
   3.5824391810214853`*^9, {3.582439224623562*^9, 3.5824392265267653`*^9}, {
   3.582452157003518*^9, 3.58245215779912*^9}, {3.582652980809287*^9, 
   3.5826529861045895`*^9}}],

Cell[BoxData["10000000"], "Output",
 CellChangeTimes->{3.5857634102538004`*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"mymap", "=", 
   RowBox[{"If", "[", 
    RowBox[{"isparallel", ",", "ParallelMap", ",", "Map"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{"isparallel", ",", 
    StyleBox["\[IndentingNewLine]", "Text"], 
    RowBox[{
     RowBox[{"DistributeDefinitions", "[", 
      RowBox[{
      "nsq", ",", "nbp", ",", "pritheta", ",", "prilambda", ",", "prieps", 
       ",", "adprate", ",", "rjfreq", ",", "isprint"}], "]"}], ";", 
     StyleBox["\[IndentingNewLine]", "Text"], 
     RowBox[{"SetSharedVariable", "[", 
      RowBox[{"isadp", ",", "mcstate"}], "]"}], ";"}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.569126355597782*^9, 3.5691263684425173`*^9}, {
   3.569137035897463*^9, 3.5691370649031224`*^9}, {3.5750115622673235`*^9, 
   3.5750115637337255`*^9}, {3.5750222004848127`*^9, 3.5750222015144143`*^9}, 
   3.582437350259068*^9, 3.5824376615436163`*^9}],

Cell[BoxData[
 RowBox[{"(*", 
  "***********************************************************************************************************************)"}\
]], "Input",
 CellChangeTimes->{{3.46026062878125*^9, 3.460260639203125*^9}, {
  3.47520919296875*^9, 3.475209199046875*^9}, {3.4752263993368254`*^9, 
  3.475226403993165*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Quiet", "[", 
   RowBox[{"DeleteFile", "[", "outset", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Save", "[", 
   RowBox[{"outset", ",", 
    RowBox[{"{", 
     RowBox[{
     "isrestart", ",", "isparallel", ",", "ascertainmodel", ",", 
      "ngroupofchain", ",", "nchainofgroup", ",", "heatingAR", ",", 
      "datafile", ",", "outcompact", ",", "outcold", ",", "outset", ",", 
      "outstate", ",", "workdir", ",", "packagedir", ",", "nbp", ",", "nsq", 
      ",", "pritheta", ",", "prilambda", ",", "prieps", ",", "rjfreq", ",", 
      "adpmax", ",", "adprate", ",", "itmin", ",", "itmax", ",", "printfreq", 
      ",", "savefreq", ",", "swapfreq", ",", "isprint"}], "}"}]}], "]"}], 
  ";"}]}], "Input",
 CellChangeTimes->{3.575385759258069*^9, 3.582437350929869*^9, 
  3.5824376621364174`*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"strcompact", "=", 
   RowBox[{"OpenAppend", "[", "outcompact", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"strcold", "=", 
   RowBox[{"OpenAppend", "[", "outcold", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Do", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"itsaved", "=", "it"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Mod", "[", 
          RowBox[{"it", ",", "100"}], "]"}], "\[Equal]", "0"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Quiet", "[", 
          RowBox[{"DeleteFile", "[", "outstate", "]"}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"Save", "[", 
          RowBox[{"outstate", ",", 
           RowBox[{"{", 
            RowBox[{"mcstate", ",", "adpheat", ",", "itsaved"}], "}"}]}], 
          "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"isadp", "=", 
       RowBox[{"it", "\[LessEqual]", "adpmax"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"mcstate", "=", 
       RowBox[{"Partition", "[", 
        RowBox[{
         RowBox[{"mymap", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"updateSMARTchain", "[", 
             RowBox[{
             "#", ",", "nsq", ",", "nbp", ",", "pritheta", ",", "prieps", ",",
               "prilambda", ",", "primodel", ",", "ascertainmodel", ",", 
              "isadp", ",", "adprate", ",", "rjfreq", ",", "isprint"}], "]"}],
             "&"}], ",", 
           RowBox[{"Flatten", "[", 
            RowBox[{"mcstate", ",", "1"}], "]"}]}], "]"}], ",", 
         "nchainofgroup"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"nchainofgroup", ">", "1"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Do", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"mcstate", "[", 
               RowBox[{"[", "i", "]"}], "]"}], ",", 
              RowBox[{"adpheat", "[", 
               RowBox[{"[", "i", "]"}], "]"}]}], "}"}], "=", 
            RowBox[{"permuteSMARTchain", "[", 
             RowBox[{
              RowBox[{"mcstate", "[", 
               RowBox[{"[", "i", "]"}], "]"}], ",", "isadp", ",", "adprate", 
              ",", 
              RowBox[{"adpheat", "[", 
               RowBox[{"[", "i", "]"}], "]"}], ",", "swapfreq"}], "]"}]}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"Length", "[", "mcstate", "]"}]}], "}"}]}], "]"}], 
         ";"}]}], "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"Do", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"mcstate", "[", 
               RowBox[{"[", "i", "]"}], "]"}], ",", 
              RowBox[{"adpheat", "[", 
               RowBox[{"[", "i", "]"}], "]"}]}], "}"}], "=", 
            RowBox[{"swapSMARTchain", "[", 
             RowBox[{
              RowBox[{"mcstate", "[", 
               RowBox[{"[", "i", "]"}], "]"}], ",", "isadp", ",", "adprate", 
              ",", 
              RowBox[{"adpheat", "[", 
               RowBox[{"[", "i", "]"}], "]"}], ",", "swapfreq"}], "]"}]}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"Length", "[", "mcstate", "]"}]}], "}"}]}], "]"}], ";"}],
         "*)"}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Mod", "[", 
          RowBox[{"it", ",", "savefreq"}], "]"}], "\[Equal]", "0"}], ",", 
        RowBox[{"saveSMARTchain", "[", 
         RowBox[{
         "mcstate", ",", "nsq", ",", "adpheat", ",", "outcompact", ",", 
          "outcold"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"it", "\[Equal]", "itmin"}], "||", 
         RowBox[{
          RowBox[{"Mod", "[", 
           RowBox[{"it", ",", "printfreq"}], "]"}], "\[Equal]", "0"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"temp", "=", 
          RowBox[{"Flatten", "[", 
           RowBox[{"mcstate", ",", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"temp", "=", 
          RowBox[{"Transpose", "[", 
           RowBox[{"Append", "[", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"temp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", "3"}], "}"}]}], "]"}], "]"}], "]"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"Length", "[", "#", "]"}], "&"}], "/@", 
              RowBox[{"temp", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "4"}], "]"}], "]"}]}]}], "]"}], "]"}]}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"temp", "=", 
          RowBox[{"Prepend", "[", 
           RowBox[{"temp", ",", 
            RowBox[{"{", 
             RowBox[{"\"\<1/T\>\"", ",", 
              RowBox[{"{", 
               RowBox[{
               "\"\<\[Theta]\>\"", ",", "\"\<\[Epsilon]\>\"", ",", 
                "\"\<\[Rho]\>\""}], "}"}], ",", "\"\<#cp\>\""}], "}"}]}], 
           "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"Print", "[", 
          RowBox[{"\"\<it=\>\"", ",", "it", ",", "\"\<;\>\"", ",", 
           RowBox[{"DateString", "[", "]"}], ",", "\"\<; chains=\>\"", ",", 
           RowBox[{"temp", "//", "MatrixForm"}]}], "]"}]}]}], 
       "\[IndentingNewLine]", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"it", ",", "itmin", ",", "itmax"}], "}"}]}], "]"}], ";"}], "//",
   "AbsoluteTiming"}], "\[IndentingNewLine]", 
 RowBox[{"Close", "[", "strcold", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Close", "[", "strcompact", "]"}]}], "Input",
 CellChangeTimes->{{3.569126414927176*^9, 3.5691264374794655`*^9}, {
   3.5691267467241535`*^9, 3.5691267775239153`*^9}, 3.569127211970764*^9, {
   3.569128265091999*^9, 3.5691282711973486`*^9}, {3.569128330336731*^9, 
   3.569128372822161*^9}, {3.5691298312995815`*^9, 3.569129848470563*^9}, {
   3.569136821981228*^9, 3.5691368330888634`*^9}, {3.569137830376905*^9, 
   3.5691378335040836`*^9}, 3.569137901142953*^9, {3.5691879776860743`*^9, 
   3.569187981365285*^9}, {3.569542090724866*^9, 3.5695421020315123`*^9}, 
   3.5695501976158147`*^9, {3.5695515521242886`*^9, 3.569551575774641*^9}, 
   3.5695523803076577`*^9, 3.5747159331772966`*^9, {3.5747184901835904`*^9, 
   3.5747184956280003`*^9}, {3.5747225922894707`*^9, 3.574722601680687*^9}, {
   3.5748493513575816`*^9, 3.574849360093597*^9}, {3.574862268209357*^9, 
   3.5748622773041725`*^9}, {3.574903330417644*^9, 3.5749033363612547`*^9}, {
   3.574908263336316*^9, 3.574908272938035*^9}, {3.574980690502347*^9, 
   3.57498069234315*^9}, {3.5751108417359447`*^9, 3.575110861454379*^9}, 
   3.575118843099055*^9, 3.5751189202459908`*^9, {3.575119984943566*^9, 
   3.5751200149288197`*^9}, {3.5752625660720077`*^9, 
   3.5752625667584085`*^9}, {3.5752635663101654`*^9, 3.575263571614175*^9}, {
   3.575263846205857*^9, 3.5752638465958576`*^9}, {3.5752642424943533`*^9, 
   3.575264245271158*^9}, 3.5753857601004705`*^9, {3.577886878436175*^9, 
   3.5778869109360332`*^9}, 3.577886946206051*^9, {3.577887003906351*^9, 
   3.5778870433376064`*^9}, {3.5779369220646925`*^9, 
   3.5779369241706963`*^9}, {3.5779372836889305`*^9, 
   3.5779372921285458`*^9}, {3.5779377185952625`*^9, 3.577937744772108*^9}, {
   3.5781245045566545`*^9, 3.578124517473477*^9}, {3.5796240701151934`*^9, 
   3.579624078133607*^9}, {3.581750844668598*^9, 3.5817508533890133`*^9}, {
   3.5817509057739058`*^9, 3.5817509139639196`*^9}, {3.5817509550855923`*^9, 
   3.5817509669728127`*^9}, {3.581822685580717*^9, 3.5818226866883187`*^9}, 
   3.58243735152267*^9, 3.5824376628228188`*^9, {3.5824377732662134`*^9, 
   3.582437774795016*^9}, {3.582438097045782*^9, 3.5824380977945833`*^9}, 
   3.5826529738968916`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"it=\"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\";\"\>", 
   "\[InvisibleSpace]", "\<\"Sat 17 Aug 2013 23:23:35\"\>", 
   "\[InvisibleSpace]", "\<\"; chains=\"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"\<\"1/T\"\>", 
        RowBox[{"{", 
         RowBox[{"\<\"\[Theta]\"\>", ",", "\<\"\[Epsilon]\"\>", 
          ",", "\<\"\[Rho]\"\>"}], "}"}], "\<\"#cp\"\>"},
       {"0.9254672882032454`", 
        RowBox[{"{", 
         RowBox[{
         "0.005208857240026472`", ",", "0.07579784297629111`", ",", 
          "0.00040568063520621256`"}], "}"}], "68"},
       {"0.9304361356563624`", 
        RowBox[{"{", 
         RowBox[{
         "0.004352048208431065`", ",", "0.01658002405699599`", ",", 
          "0.0003959475683436103`"}], "}"}], "42"},
       {"0.9354049831094793`", 
        RowBox[{"{", 
         RowBox[{
         "0.007119870644878691`", ",", "0.06813377351248318`", ",", 
          "0.00039885073331320087`"}], "}"}], "48"},
       {"0.9403738305625963`", 
        RowBox[{"{", 
         RowBox[{
         "0.008641306158923256`", ",", "0.05119201953656671`", ",", 
          "0.0003956963973850777`"}], "}"}], "69"},
       {"0.9453426780157133`", 
        RowBox[{"{", 
         RowBox[{
         "0.0027234870949538175`", ",", "0.03189876552905879`", ",", 
          "0.00039763250354540197`"}], "}"}], "50"},
       {"0.9503115254688302`", 
        RowBox[{"{", 
         RowBox[{
         "0.007874748628171576`", ",", "0.09235986865829338`", ",", 
          "0.00040031587967844276`"}], "}"}], "37"},
       {"0.9552803729219472`", 
        RowBox[{"{", 
         RowBox[{
         "0.0055450378567408025`", ",", "0.08252098288775467`", ",", 
          "0.00040426240218419595`"}], "}"}], "58"},
       {"0.9602492203750642`", 
        RowBox[{"{", 
         RowBox[{
         "0.007569630056357293`", ",", "0.07071652713651422`", ",", 
          "0.00040438353237928017`"}], "}"}], "59"},
       {"0.9652180678281812`", 
        RowBox[{"{", 
         RowBox[{
         "0.0007229158338830505`", ",", "0.055074763088072576`", ",", 
          "0.0004047910449938428`"}], "}"}], "53"},
       {"0.9701869152812982`", 
        RowBox[{"{", 
         RowBox[{
         "0.006123767229186236`", ",", "0.012191934124052173`", ",", 
          "0.0003954884138393281`"}], "}"}], "90"},
       {"0.9751557627344152`", 
        RowBox[{"{", 
         RowBox[{
         "0.005298679701785863`", ",", "0.04998461393313902`", ",", 
          "0.00039734498768896376`"}], "}"}], "52"},
       {"0.980124610187532`", 
        RowBox[{"{", 
         RowBox[{
         "0.00069038164520791`", ",", "0.006110334049630239`", ",", 
          "0.00040917384674605113`"}], "}"}], "63"},
       {"0.985093457640649`", 
        RowBox[{"{", 
         RowBox[{
         "0.0008642606121187432`", ",", "0.0004758455549558338`", ",", 
          "0.00040712371757880964`"}], "}"}], "65"},
       {"0.990062305093766`", 
        RowBox[{"{", 
         RowBox[{
         "0.0066375842228941166`", ",", "0.03720488926319909`", ",", 
          "0.00040766965761285647`"}], "}"}], "68"},
       {"0.995031152546883`", 
        RowBox[{"{", 
         RowBox[{
         "0.0080475741545729`", ",", "0.021101045642103022`", ",", 
          "0.00040507914638431626`"}], "}"}], "46"},
       {"1.`", 
        RowBox[{"{", 
         RowBox[{
         "0.002857062125255565`", ",", "0.02071310293134454`", ",", 
          "0.00039877858317695255`"}], "}"}], "55"},
       {"0.9256998393771504`", 
        RowBox[{"{", 
         RowBox[{
         "0.009886817571840055`", ",", "0.08057500793792394`", ",", 
          "0.00040019162567881794`"}], "}"}], "63"},
       {"0.9306531834186738`", 
        RowBox[{"{", 
         RowBox[{
         "0.0053707096800974605`", ",", "0.03856150706197803`", ",", 
          "0.0003964889517854528`"}], "}"}], "51"},
       {"0.935606527460197`", 
        RowBox[{"{", 
         RowBox[{
         "0.006679270150589873`", ",", "0.07409112334041756`", ",", 
          "0.0004054674835783274`"}], "}"}], "72"},
       {"0.9405598715017204`", 
        RowBox[{"{", 
         RowBox[{
         "0.0012357491002734644`", ",", "0.07964196514691424`", ",", 
          "0.0003924048797840975`"}], "}"}], "56"},
       {"0.9455132155432436`", 
        RowBox[{"{", 
         RowBox[{
         "0.00740175732674128`", ",", "0.09576012059552941`", ",", 
          "0.0004095922022011497`"}], "}"}], "53"},
       {"0.950466559584767`", 
        RowBox[{"{", 
         RowBox[{
         "0.0076540282881162585`", ",", "0.008976110498923662`", ",", 
          "0.00039730776651261413`"}], "}"}], "31"},
       {"0.9554199036262903`", 
        RowBox[{"{", 
         RowBox[{
         "0.00008869567149960046`", ",", "0.01564059822735442`", ",", 
          "0.0003970978804181781`"}], "}"}], "57"},
       {"0.9603732476678135`", 
        RowBox[{"{", 
         RowBox[{
         "0.009000406233027372`", ",", "0.02968034139478104`", ",", 
          "0.00039156120711828966`"}], "}"}], "68"},
       {"0.9653265917093369`", 
        RowBox[{"{", 
         RowBox[{
         "0.006163475705564499`", ",", "0.09077803941571494`", ",", 
          "0.00039859074701485535`"}], "}"}], "57"},
       {"0.9702799357508601`", 
        RowBox[{"{", 
         RowBox[{
         "0.008005302135571895`", ",", "0.03918094099883018`", ",", 
          "0.00040364916314555757`"}], "}"}], "26"},
       {"0.9752332797923835`", 
        RowBox[{"{", 
         RowBox[{
         "0.003635622322426417`", ",", "0.0696290586310544`", ",", 
          "0.0004034615606386816`"}], "}"}], "74"},
       {"0.9801866238339068`", 
        RowBox[{"{", 
         RowBox[{
         "0.003979914265782546`", ",", "0.01975032375110186`", ",", 
          "0.0003985957286376968`"}], "}"}], "68"},
       {"0.9851399678754301`", 
        RowBox[{"{", 
         RowBox[{
         "0.0036615179565796414`", ",", "0.0928735200074624`", ",", 
          "0.00040453802628574606`"}], "}"}], "61"},
       {"0.9900933119169534`", 
        RowBox[{"{", 
         RowBox[{
         "0.0024983579285823444`", ",", "0.043832727644713465`", ",", 
          "0.00039357747999876436`"}], "}"}], "43"},
       {"0.9950466559584767`", 
        RowBox[{"{", 
         RowBox[{
         "0.0028437388547438453`", ",", "0.034350373316786253`", ",", 
          "0.0003938087408727854`"}], "}"}], "46"},
       {"1.`", 
        RowBox[{"{", 
         RowBox[{
         "0.008384294149314095`", ",", "0.0019068057686859596`", ",", 
          "0.00040627452626791665`"}], "}"}], "74"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["it=", 1, ";", "Sat 17 Aug 2013 23:23:35", "; chains=", 
   MatrixForm[{{"1/T", {"\[Theta]", "\[Epsilon]", "\[Rho]"}, "#cp"}, {
     0.9254672882032454, {0.005208857240026472, 0.07579784297629111, 
      0.00040568063520621256`}, 68}, {
     0.9304361356563624, {0.004352048208431065, 0.01658002405699599, 
      0.0003959475683436103}, 42}, {
     0.9354049831094793, {0.007119870644878691, 0.06813377351248318, 
      0.00039885073331320087`}, 48}, {
     0.9403738305625963, {0.008641306158923256, 0.05119201953656671, 
      0.0003956963973850777}, 69}, {
     0.9453426780157133, {0.0027234870949538175`, 0.03189876552905879, 
      0.00039763250354540197`}, 50}, {
     0.9503115254688302, {0.007874748628171576, 0.09235986865829338, 
      0.00040031587967844276`}, 37}, {
     0.9552803729219472, {0.0055450378567408025`, 0.08252098288775467, 
      0.00040426240218419595`}, 58}, {
     0.9602492203750642, {0.007569630056357293, 0.07071652713651422, 
      0.00040438353237928017`}, 59}, {
     0.9652180678281812, {0.0007229158338830505, 0.055074763088072576`, 
      0.0004047910449938428}, 53}, {
     0.9701869152812982, {0.006123767229186236, 0.012191934124052173`, 
      0.0003954884138393281}, 90}, {
     0.9751557627344152, {0.005298679701785863, 0.04998461393313902, 
      0.00039734498768896376`}, 52}, {
     0.980124610187532, {0.00069038164520791, 0.006110334049630239, 
      0.00040917384674605113`}, 63}, {
     0.985093457640649, {0.0008642606121187432, 0.0004758455549558338, 
      0.00040712371757880964`}, 65}, {
     0.990062305093766, {0.0066375842228941166`, 0.03720488926319909, 
      0.00040766965761285647`}, 68}, {
     0.995031152546883, {0.0080475741545729, 0.021101045642103022`, 
      0.00040507914638431626`}, 46}, {
     1., {0.002857062125255565, 0.02071310293134454, 0.00039877858317695255`},
       55}, {0.9256998393771504, {0.009886817571840055, 0.08057500793792394, 
      0.00040019162567881794`}, 63}, {
     0.9306531834186738, {0.0053707096800974605`, 0.03856150706197803, 
      0.0003964889517854528}, 51}, {
     0.935606527460197, {0.006679270150589873, 0.07409112334041756, 
      0.0004054674835783274}, 72}, {
     0.9405598715017204, {0.0012357491002734644`, 0.07964196514691424, 
      0.0003924048797840975}, 56}, {
     0.9455132155432436, {0.00740175732674128, 0.09576012059552941, 
      0.0004095922022011497}, 53}, {
     0.950466559584767, {0.0076540282881162585`, 0.008976110498923662, 
      0.00039730776651261413`}, 31}, {
     0.9554199036262903, {0.00008869567149960046, 0.01564059822735442, 
      0.0003970978804181781}, 57}, {
     0.9603732476678135, {0.009000406233027372, 0.02968034139478104, 
      0.00039156120711828966`}, 68}, {
     0.9653265917093369, {0.006163475705564499, 0.09077803941571494, 
      0.00039859074701485535`}, 57}, {
     0.9702799357508601, {0.008005302135571895, 0.03918094099883018, 
      0.00040364916314555757`}, 26}, {
     0.9752332797923835, {0.003635622322426417, 0.0696290586310544, 
      0.0004034615606386816}, 74}, {
     0.9801866238339068, {0.003979914265782546, 0.01975032375110186, 
      0.0003985957286376968}, 68}, {
     0.9851399678754301, {0.0036615179565796414`, 0.0928735200074624, 
      0.00040453802628574606`}, 61}, {
     0.9900933119169534, {0.0024983579285823444`, 0.043832727644713465`, 
      0.00039357747999876436`}, 43}, {
     0.9950466559584767, {0.0028437388547438453`, 0.034350373316786253`, 
      0.0003938087408727854}, 46}, {
     1., {0.008384294149314095, 0.0019068057686859596`, 
      0.00040627452626791665`}, 74}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.5857634156361084`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"it=\"\>", "\[InvisibleSpace]", "100", 
   "\[InvisibleSpace]", "\<\";\"\>", 
   "\[InvisibleSpace]", "\<\"Sat 17 Aug 2013 23:33:57\"\>", 
   "\[InvisibleSpace]", "\<\"; chains=\"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"\<\"1/T\"\>", 
        RowBox[{"{", 
         RowBox[{"\<\"\[Theta]\"\>", ",", "\<\"\[Epsilon]\"\>", 
          ",", "\<\"\[Rho]\"\>"}], "}"}], "\<\"#cp\"\>"},
       {"0.9927886991276844`", 
        RowBox[{"{", 
         RowBox[{
         "0.0017103514874110722`", ",", "0.0020002817779762694`", ",", 
          "0.0004280681286641207`"}], "}"}], "40"},
       {"0.9932694525191721`", 
        RowBox[{"{", 
         RowBox[{
         "0.0009941711055771578`", ",", "0.000802514959242771`", ",", 
          "0.00013451670752940607`"}], "}"}], "24"},
       {"0.9937502059106598`", 
        RowBox[{"{", 
         RowBox[{
         "0.004380009538484946`", ",", "0.0009247452589307686`", ",", 
          "0.0008511578706531483`"}], "}"}], "33"},
       {"0.9942309593021476`", 
        RowBox[{"{", 
         RowBox[{
         "0.0013465631378868261`", ",", "0.0010283616983069676`", ",", 
          "0.00022157058269756883`"}], "}"}], "33"},
       {"0.9947117126936352`", 
        RowBox[{"{", 
         RowBox[{
         "0.0037228560872334415`", ",", "0.0011137812558947922`", ",", 
          "0.0003370081522666097`"}], "}"}], "19"},
       {"0.9951924660851229`", 
        RowBox[{"{", 
         RowBox[{
         "0.0017947743903005832`", ",", "0.0019965639051722304`", ",", 
          "0.0003031051234890371`"}], "}"}], "55"},
       {"0.9956732194766106`", 
        RowBox[{"{", 
         RowBox[{
         "0.003108660363961318`", ",", "0.0008869863536297794`", ",", 
          "0.00029558105067853613`"}], "}"}], "24"},
       {"0.9961539728680984`", 
        RowBox[{"{", 
         RowBox[{
         "0.0054812403591504`", ",", "0.0004917885169024143`", ",", 
          "0.00016233803566706461`"}], "}"}], "13"},
       {"0.996634726259586`", 
        RowBox[{"{", 
         RowBox[{
         "0.004975779755624849`", ",", "0.001360907319951758`", ",", 
          "0.00017269493322226009`"}], "}"}], "23"},
       {"0.9971154796510737`", 
        RowBox[{"{", 
         RowBox[{
         "0.0025929230078867746`", ",", "0.0008886157684964773`", ",", 
          "0.0002303387405419798`"}], "}"}], "26"},
       {"0.9975962330425615`", 
        RowBox[{"{", 
         RowBox[{
         "0.003848591194540772`", ",", "0.0011423317616796283`", ",", 
          "0.00018919594630084126`"}], "}"}], "32"},
       {"0.9980769864340492`", 
        RowBox[{"{", 
         RowBox[{
         "0.0023024300631397385`", ",", "0.0014433015573568054`", ",", 
          "0.0006096193822204937`"}], "}"}], "59"},
       {"0.9985577398255369`", 
        RowBox[{"{", 
         RowBox[{
         "0.002344922169926897`", ",", "0.001234560458520383`", ",", 
          "0.00023832663529571894`"}], "}"}], "20"},
       {"0.9990384932170245`", 
        RowBox[{"{", 
         RowBox[{
         "0.002022196771269078`", ",", "0.0017683811341492324`", ",", 
          "0.0002745596951616482`"}], "}"}], "25"},
       {"0.9995192466085123`", 
        RowBox[{"{", 
         RowBox[{
         "0.0010202122103013865`", ",", "0.0011649460132651494`", ",", 
          "0.00013317018880399685`"}], "}"}], "33"},
       {"1.`", 
        RowBox[{"{", 
         RowBox[{
         "0.0017602175245195776`", ",", "0.001294193559466434`", ",", 
          "0.00014923650087950437`"}], "}"}], "25"},
       {"0.9919207594214562`", 
        RowBox[{"{", 
         RowBox[{
         "0.001433977306390016`", ",", "0.002804653776913831`", ",", 
          "0.0004254088766681097`"}], "}"}], "78"},
       {"0.9924593754600257`", 
        RowBox[{"{", 
         RowBox[{
         "0.0017877745774522481`", ",", "0.002241144168516296`", ",", 
          "0.0011502558236897702`"}], "}"}], "46"},
       {"0.9929979914985954`", 
        RowBox[{"{", 
         RowBox[{
         "0.002324744309085267`", ",", "0.0010006414384213437`", ",", 
          "0.0001904973726764691`"}], "}"}], "21"},
       {"0.993536607537165`", 
        RowBox[{"{", 
         RowBox[{
         "0.002416822236050227`", ",", "0.0012761015325526912`", ",", 
          "0.0005782602523303986`"}], "}"}], "42"},
       {"0.9940752235757345`", 
        RowBox[{"{", 
         RowBox[{
         "0.0013215127649120507`", ",", "0.0007966473492395091`", ",", 
          "0.0003106500922989868`"}], "}"}], "32"},
       {"0.9946138396143042`", 
        RowBox[{"{", 
         RowBox[{
         "0.00045047253455522977`", ",", "0.0018139508434884557`", ",", 
          "0.00004795575817445236`"}], "}"}], "16"},
       {"0.9951524556528737`", 
        RowBox[{"{", 
         RowBox[{
         "0.003147930765787922`", ",", "0.0018185657635673182`", ",", 
          "0.00040808231245505265`"}], "}"}], "27"},
       {"0.9956910716914433`", 
        RowBox[{"{", 
         RowBox[{
         "0.003470328411442881`", ",", "0.001474097100544071`", ",", 
          "0.00046281151235116294`"}], "}"}], "15"},
       {"0.9962296877300129`", 
        RowBox[{"{", 
         RowBox[{
         "0.0021431570400724936`", ",", "0.0006268548198247162`", ",", 
          "0.00022532770128106956`"}], "}"}], "28"},
       {"0.9967683037685825`", 
        RowBox[{"{", 
         RowBox[{
         "0.00325544771634727`", ",", "0.0024702547187681386`", ",", 
          "0.0004109113109357035`"}], "}"}], "49"},
       {"0.997306919807152`", 
        RowBox[{"{", 
         RowBox[{
         "0.002652132203853142`", ",", "0.0013332217495086547`", ",", 
          "0.0003145986141400449`"}], "}"}], "18"},
       {"0.9978455358457217`", 
        RowBox[{"{", 
         RowBox[{
         "0.001900648090398713`", ",", "0.0009462084021031355`", ",", 
          "0.00011055365255504873`"}], "}"}], "16"},
       {"0.9983841518842912`", 
        RowBox[{"{", 
         RowBox[{
         "0.0020279076904893734`", ",", "0.001489988560202277`", ",", 
          "0.0002645395764447162`"}], "}"}], "19"},
       {"0.9989227679228608`", 
        RowBox[{"{", 
         RowBox[{
         "0.00274243469319874`", ",", "0.0018122804772170425`", ",", 
          "0.00013606918294710953`"}], "}"}], "14"},
       {"0.9994613839614304`", 
        RowBox[{"{", 
         RowBox[{
         "0.0030606517532720083`", ",", "0.0013198396636808411`", ",", 
          "0.0002873555921199862`"}], "}"}], "20"},
       {"1.`", 
        RowBox[{"{", 
         RowBox[{
         "0.0013879178324269475`", ",", "0.0007655558195690026`", ",", 
          "0.00032555986701869534`"}], "}"}], "33"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["it=", 100, ";", "Sat 17 Aug 2013 23:33:57", "; chains=", 
   MatrixForm[{{"1/T", {"\[Theta]", "\[Epsilon]", "\[Rho]"}, "#cp"}, {
     0.9927886991276844, {0.0017103514874110722`, 0.0020002817779762694`, 
      0.0004280681286641207}, 40}, {
     0.9932694525191721, {0.0009941711055771578, 0.000802514959242771, 
      0.00013451670752940607`}, 24}, {
     0.9937502059106598, {0.004380009538484946, 0.0009247452589307686, 
      0.0008511578706531483}, 33}, {
     0.9942309593021476, {0.0013465631378868261`, 0.0010283616983069676`, 
      0.00022157058269756883`}, 33}, {
     0.9947117126936352, {0.0037228560872334415`, 0.0011137812558947922`, 
      0.0003370081522666097}, 19}, {
     0.9951924660851229, {0.0017947743903005832`, 0.0019965639051722304`, 
      0.0003031051234890371}, 55}, {
     0.9956732194766106, {0.003108660363961318, 0.0008869863536297794, 
      0.00029558105067853613`}, 24}, {
     0.9961539728680984, {0.0054812403591504, 0.0004917885169024143, 
      0.00016233803566706461`}, 13}, {
     0.996634726259586, {0.004975779755624849, 0.001360907319951758, 
      0.00017269493322226009`}, 23}, {
     0.9971154796510737, {0.0025929230078867746`, 0.0008886157684964773, 
      0.0002303387405419798}, 26}, {
     0.9975962330425615, {0.003848591194540772, 0.0011423317616796283`, 
      0.00018919594630084126`}, 32}, {
     0.9980769864340492, {0.0023024300631397385`, 0.0014433015573568054`, 
      0.0006096193822204937}, 59}, {
     0.9985577398255369, {0.002344922169926897, 0.001234560458520383, 
      0.00023832663529571894`}, 20}, {
     0.9990384932170245, {0.002022196771269078, 0.0017683811341492324`, 
      0.0002745596951616482}, 25}, {
     0.9995192466085123, {0.0010202122103013865`, 0.0011649460132651494`, 
      0.00013317018880399685`}, 33}, {
     1., {0.0017602175245195776`, 0.001294193559466434, 
      0.00014923650087950437`}, 25}, {
     0.9919207594214562, {0.001433977306390016, 0.002804653776913831, 
      0.0004254088766681097}, 78}, {
     0.9924593754600257, {0.0017877745774522481`, 0.002241144168516296, 
      0.0011502558236897702`}, 46}, {
     0.9929979914985954, {0.002324744309085267, 0.0010006414384213437`, 
      0.0001904973726764691}, 21}, {
     0.993536607537165, {0.002416822236050227, 0.0012761015325526912`, 
      0.0005782602523303986}, 42}, {
     0.9940752235757345, {0.0013215127649120507`, 0.0007966473492395091, 
      0.0003106500922989868}, 32}, {
     0.9946138396143042, {0.00045047253455522977`, 0.0018139508434884557`, 
      0.00004795575817445236}, 16}, {
     0.9951524556528737, {0.003147930765787922, 0.0018185657635673182`, 
      0.00040808231245505265`}, 27}, {
     0.9956910716914433, {0.003470328411442881, 0.001474097100544071, 
      0.00046281151235116294`}, 15}, {
     0.9962296877300129, {0.0021431570400724936`, 0.0006268548198247162, 
      0.00022532770128106956`}, 28}, {
     0.9967683037685825, {0.00325544771634727, 0.0024702547187681386`, 
      0.0004109113109357035}, 49}, {
     0.997306919807152, {0.002652132203853142, 0.0013332217495086547`, 
      0.0003145986141400449}, 18}, {
     0.9978455358457217, {0.001900648090398713, 0.0009462084021031355, 
      0.00011055365255504873`}, 16}, {
     0.9983841518842912, {0.0020279076904893734`, 0.001489988560202277, 
      0.0002645395764447162}, 19}, {
     0.9989227679228608, {0.00274243469319874, 0.0018122804772170425`, 
      0.00013606918294710953`}, 14}, {
     0.9994613839614304, {0.0030606517532720083`, 0.0013198396636808411`, 
      0.0002873555921199862}, 20}, {
     1., {0.0013879178324269475`, 0.0007655558195690026, 
      0.00032555986701869534`}, 33}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.585764037068652*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"it=\"\>", "\[InvisibleSpace]", "200", 
   "\[InvisibleSpace]", "\<\";\"\>", 
   "\[InvisibleSpace]", "\<\"Sat 17 Aug 2013 23:45:56\"\>", 
   "\[InvisibleSpace]", "\<\"; chains=\"\>", "\[InvisibleSpace]", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"\<\"1/T\"\>", 
        RowBox[{"{", 
         RowBox[{"\<\"\[Theta]\"\>", ",", "\<\"\[Epsilon]\"\>", 
          ",", "\<\"\[Rho]\"\>"}], "}"}], "\<\"#cp\"\>"},
       {"0.9915079053278748`", 
        RowBox[{"{", 
         RowBox[{
         "0.002341992008073643`", ",", "0.0012525843850236809`", ",", 
          "0.00019881160731833415`"}], "}"}], "27"},
       {"0.9920740449726831`", 
        RowBox[{"{", 
         RowBox[{
         "0.0015570830900522527`", ",", "0.0008070810554956008`", ",", 
          "0.00024540318530354827`"}], "}"}], "29"},
       {"0.9926401846174915`", 
        RowBox[{"{", 
         RowBox[{
         "0.0017024790615501662`", ",", "0.0010105173891084604`", ",", 
          "0.00006780273593798667`"}], "}"}], "7"},
       {"0.9932063242622998`", 
        RowBox[{"{", 
         RowBox[{
         "0.0017345746653885624`", ",", "0.0011159360917740151`", ",", 
          "0.00014467559222239957`"}], "}"}], "25"},
       {"0.9937724639071082`", 
        RowBox[{"{", 
         RowBox[{
         "0.0013209554663286198`", ",", "0.0010615563210767717`", ",", 
          "0.0004080034550716854`"}], "}"}], "36"},
       {"0.9943386035519165`", 
        RowBox[{"{", 
         RowBox[{
         "0.001499766100920788`", ",", "0.0008430452820664297`", ",", 
          "0.00041663653378591116`"}], "}"}], "50"},
       {"0.9949047431967248`", 
        RowBox[{"{", 
         RowBox[{
         "0.0023111369462883906`", ",", "0.001129836883097376`", ",", 
          "0.00023406013582188409`"}], "}"}], "23"},
       {"0.9954708828415332`", 
        RowBox[{"{", 
         RowBox[{
         "0.005183875967078435`", ",", "0.0008138897083741871`", ",", 
          "0.00013355703146419791`"}], "}"}], "11"},
       {"0.9960370224863415`", 
        RowBox[{"{", 
         RowBox[{
         "0.0011744535475042125`", ",", "0.0009198957760470567`", ",", 
          "0.0001260307238492525`"}], "}"}], "26"},
       {"0.9966031621311499`", 
        RowBox[{"{", 
         RowBox[{
         "0.0022991264727150254`", ",", "0.0007137620217170977`", ",", 
          "0.00021480096373199044`"}], "}"}], "24"},
       {"0.9971693017759583`", 
        RowBox[{"{", 
         RowBox[{
         "0.0011215165333153148`", ",", "0.0013674836087960377`", ",", 
          "0.00016278208134332085`"}], "}"}], "25"},
       {"0.9977354414207666`", 
        RowBox[{"{", 
         RowBox[{
         "0.0016801539892632405`", ",", "0.0006338866901013221`", ",", 
          "0.0002133311272976818`"}], "}"}], "32"},
       {"0.998301581065575`", 
        RowBox[{"{", 
         RowBox[{
         "0.003240311713337695`", ",", "0.0007035552443429593`", ",", 
          "0.0005210102001423317`"}], "}"}], "43"},
       {"0.9988677207103833`", 
        RowBox[{"{", 
         RowBox[{
         "0.001859744277821257`", ",", "0.0011260761303730597`", ",", 
          "0.0001504888528315782`"}], "}"}], "21"},
       {"0.9994338603551917`", 
        RowBox[{"{", 
         RowBox[{
         "0.001987992501351059`", ",", "0.0011321354403214115`", ",", 
          "0.00013823576198820326`"}], "}"}], "14"},
       {"1.`", 
        RowBox[{"{", 
         RowBox[{
         "0.001748282987647708`", ",", "0.0009331455028637563`", ",", 
          "0.00013026690211022322`"}], "}"}], "15"},
       {"0.9956831761713475`", 
        RowBox[{"{", 
         RowBox[{
         "0.0011694990911883232`", ",", "0.001845952244596853`", ",", 
          "0.0001896078325948325`"}], "}"}], "26"},
       {"0.9959709644265909`", 
        RowBox[{"{", 
         RowBox[{
         "0.0016070060638512951`", ",", "0.001194378912217387`", ",", 
          "0.000263411257437021`"}], "}"}], "25"},
       {"0.9962587526818345`", 
        RowBox[{"{", 
         RowBox[{
         "0.0013954223896053336`", ",", "0.0012437384558021019`", ",", 
          "0.0000646444729574195`"}], "}"}], "17"},
       {"0.996546540937078`", 
        RowBox[{"{", 
         RowBox[{
         "0.000993110059095585`", ",", "0.0006169992992616533`", ",", 
          "0.00015184178229974291`"}], "}"}], "26"},
       {"0.9968343291923215`", 
        RowBox[{"{", 
         RowBox[{
         "0.0018640201436880362`", ",", "0.0011456387961269608`", ",", 
          "0.00021108808066132203`"}], "}"}], "27"},
       {"0.997122117447565`", 
        RowBox[{"{", 
         RowBox[{
         "0.0009088798910808815`", ",", "0.0009163858549647922`", ",", 
          "0.00011304083514648058`"}], "}"}], "15"},
       {"0.9974099057028085`", 
        RowBox[{"{", 
         RowBox[{
         "0.001214481204482272`", ",", "0.00040202085074474137`", ",", 
          "0.00014356082665285613`"}], "}"}], "20"},
       {"0.997697693958052`", 
        RowBox[{"{", 
         RowBox[{
         "0.004776452869281999`", ",", "0.0015939928944892203`", ",", 
          "0.00026663528802803657`"}], "}"}], "12"},
       {"0.9979854822132955`", 
        RowBox[{"{", 
         RowBox[{
         "0.0019239481527229053`", ",", "0.0012395643148735082`", ",", 
          "0.00039447979424080435`"}], "}"}], "39"},
       {"0.998273270468539`", 
        RowBox[{"{", 
         RowBox[{
         "0.0015964976427109696`", ",", "0.0008587723922329647`", ",", 
          "0.00018068272955725005`"}], "}"}], "16"},
       {"0.9985610587237825`", 
        RowBox[{"{", 
         RowBox[{
         "0.0013723065239138136`", ",", "0.0009568770818336411`", ",", 
          "0.00006806610863482188`"}], "}"}], "7"},
       {"0.998848846979026`", 
        RowBox[{"{", 
         RowBox[{
         "0.002659527299031712`", ",", "0.0012821985031576306`", ",", 
          "0.0004640129338150502`"}], "}"}], "64"},
       {"0.9991366352342695`", 
        RowBox[{"{", 
         RowBox[{
         "0.0011581445149038518`", ",", "0.0010067754261419857`", ",", 
          "0.00028915591018132704`"}], "}"}], "41"},
       {"0.999424423489513`", 
        RowBox[{"{", 
         RowBox[{
         "0.002154006371085739`", ",", "0.0005368234538669474`", ",", 
          "0.00023407007933103134`"}], "}"}], "38"},
       {"0.9997122117447566`", 
        RowBox[{"{", 
         RowBox[{
         "0.0026078041514038613`", ",", "0.0011878464362652843`", ",", 
          "0.00011117551391309763`"}], "}"}], "11"},
       {"1.`", 
        RowBox[{"{", 
         RowBox[{
         "0.001448739372926722`", ",", "0.000792951792065885`", ",", 
          "0.00009878530856318225`"}], "}"}], "15"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}],
  SequenceForm["it=", 200, ";", "Sat 17 Aug 2013 23:45:56", "; chains=", 
   MatrixForm[{{"1/T", {"\[Theta]", "\[Epsilon]", "\[Rho]"}, "#cp"}, {
     0.9915079053278748, {0.002341992008073643, 0.0012525843850236809`, 
      0.00019881160731833415`}, 27}, {
     0.9920740449726831, {0.0015570830900522527`, 0.0008070810554956008, 
      0.00024540318530354827`}, 29}, {
     0.9926401846174915, {0.0017024790615501662`, 0.0010105173891084604`, 
      0.00006780273593798667}, 7}, {
     0.9932063242622998, {0.0017345746653885624`, 0.0011159360917740151`, 
      0.00014467559222239957`}, 25}, {
     0.9937724639071082, {0.0013209554663286198`, 0.0010615563210767717`, 
      0.0004080034550716854}, 36}, {
     0.9943386035519165, {0.001499766100920788, 0.0008430452820664297, 
      0.00041663653378591116`}, 50}, {
     0.9949047431967248, {0.0023111369462883906`, 0.001129836883097376, 
      0.00023406013582188409`}, 23}, {
     0.9954708828415332, {0.005183875967078435, 0.0008138897083741871, 
      0.00013355703146419791`}, 11}, {
     0.9960370224863415, {0.0011744535475042125`, 0.0009198957760470567, 
      0.0001260307238492525}, 26}, {
     0.9966031621311499, {0.0022991264727150254`, 0.0007137620217170977, 
      0.00021480096373199044`}, 24}, {
     0.9971693017759583, {0.0011215165333153148`, 0.0013674836087960377`, 
      0.00016278208134332085`}, 25}, {
     0.9977354414207666, {0.0016801539892632405`, 0.0006338866901013221, 
      0.0002133311272976818}, 32}, {
     0.998301581065575, {0.003240311713337695, 0.0007035552443429593, 
      0.0005210102001423317}, 43}, {
     0.9988677207103833, {0.001859744277821257, 0.0011260761303730597`, 
      0.0001504888528315782}, 21}, {
     0.9994338603551917, {0.001987992501351059, 0.0011321354403214115`, 
      0.00013823576198820326`}, 14}, {
     1., {0.001748282987647708, 0.0009331455028637563, 
      0.00013026690211022322`}, 15}, {
     0.9956831761713475, {0.0011694990911883232`, 0.001845952244596853, 
      0.0001896078325948325}, 26}, {
     0.9959709644265909, {0.0016070060638512951`, 0.001194378912217387, 
      0.000263411257437021}, 25}, {
     0.9962587526818345, {0.0013954223896053336`, 0.0012437384558021019`, 
      0.0000646444729574195}, 17}, {
     0.996546540937078, {0.000993110059095585, 0.0006169992992616533, 
      0.00015184178229974291`}, 26}, {
     0.9968343291923215, {0.0018640201436880362`, 0.0011456387961269608`, 
      0.00021108808066132203`}, 27}, {
     0.997122117447565, {0.0009088798910808815, 0.0009163858549647922, 
      0.00011304083514648058`}, 15}, {
     0.9974099057028085, {0.001214481204482272, 0.00040202085074474137`, 
      0.00014356082665285613`}, 20}, {
     0.997697693958052, {0.004776452869281999, 0.0015939928944892203`, 
      0.00026663528802803657`}, 12}, {
     0.9979854822132955, {0.0019239481527229053`, 0.0012395643148735082`, 
      0.00039447979424080435`}, 39}, {
     0.998273270468539, {0.0015964976427109696`, 0.0008587723922329647, 
      0.00018068272955725005`}, 16}, {
     0.9985610587237825, {0.0013723065239138136`, 0.0009568770818336411, 
      0.00006806610863482188}, 7}, {
     0.998848846979026, {0.002659527299031712, 0.0012821985031576306`, 
      0.0004640129338150502}, 64}, {
     0.9991366352342695, {0.0011581445149038518`, 0.0010067754261419857`, 
      0.00028915591018132704`}, 41}, {
     0.999424423489513, {0.002154006371085739, 0.0005368234538669474, 
      0.00023407007933103134`}, 38}, {
     0.9997122117447566, {0.0026078041514038613`, 0.0011878464362652843`, 
      0.00011117551391309763`}, 11}, {
     1., {0.001448739372926722, 0.000792951792065885, 0.00009878530856318225},
       15}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.5857647564968014`*^9}]
}, Open  ]],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{3.585764903999238*^9}],

Cell[BoxData["\<\"SMARTree_OutCold_M1P1_Data_Standard.txt\"\>"], "Output",
 CellChangeTimes->{3.58576490403424*^9}],

Cell[BoxData["\<\"SMARTree_OutCompact_M1P1_Data_Standard.txt\"\>"], "Output",
 CellChangeTimes->{3.58576490403824*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  "***********************************************************************************************************************)"}\
]], "Input",
 CellChangeTimes->{{3.46026062878125*^9, 3.460260639203125*^9}, {
  3.47520919296875*^9, 3.475209199046875*^9}, {3.4752263993368254`*^9, 
  3.475226403993165*^9}}]
},
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"VersionedStylesheet"->{"Default.nb"[8.] -> False}},
ShowSelection->True,
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 333, 6, 31, "Input"],
Cell[CellGroupData[{
Cell[903, 30, 10143, 164, 312, "Input"],
Cell[11049, 196, 81, 1, 31, "Output"],
Cell[11133, 199, 119, 1, 31, "Output"],
Cell[11255, 202, 116, 1, 31, "Output"],
Cell[11374, 205, 119, 1, 31, "Output"],
Cell[11496, 208, 118, 1, 31, "Output"]
}, Open  ]],
Cell[11629, 212, 333, 6, 31, "Input"],
Cell[11965, 220, 154, 3, 31, "Input"],
Cell[CellGroupData[{
Cell[12144, 227, 1613, 37, 272, "Input"],
Cell[13760, 266, 187, 2, 31, "Output"],
Cell[13950, 270, 399, 9, 21, "Message"],
Cell[14352, 281, 405, 9, 21, "Message"],
Cell[14760, 292, 421, 10, 21, "Message"],
Cell[15184, 304, 419, 10, 21, "Message"],
Cell[15606, 316, 419, 10, 21, "Message"],
Cell[16028, 328, 421, 10, 21, "Message"],
Cell[16452, 340, 419, 10, 21, "Message"],
Cell[16874, 352, 418, 10, 21, "Message"],
Cell[17295, 364, 421, 10, 21, "Message"],
Cell[17719, 376, 421, 10, 21, "Message"],
Cell[18143, 388, 403, 9, 21, "Message"],
Cell[18549, 399, 403, 9, 21, "Message"],
Cell[18955, 410, 405, 9, 21, "Message"],
Cell[19363, 421, 405, 9, 21, "Message"],
Cell[19771, 432, 403, 9, 21, "Message"],
Cell[20177, 443, 402, 9, 21, "Message"],
Cell[20582, 454, 405, 9, 21, "Message"],
Cell[20990, 465, 405, 9, 21, "Message"]
}, Open  ]],
Cell[21410, 477, 333, 6, 31, "Input"],
Cell[21746, 485, 247, 5, 31, "Input"],
Cell[21996, 492, 4498, 117, 292, "Input"],
Cell[26497, 611, 333, 6, 31, "Input"],
Cell[26833, 619, 277, 6, 31, "Input"],
Cell[CellGroupData[{
Cell[27135, 629, 9239, 184, 632, "Input"],
Cell[36377, 815, 126, 3, 31, "Output"]
}, Open  ]],
Cell[36518, 821, 333, 6, 31, "Input"],
Cell[36854, 829, 149, 3, 31, "Input"],
Cell[CellGroupData[{
Cell[37028, 836, 4922, 77, 192, "Input"],
Cell[41953, 915, 79, 1, 31, "Output"]
}, Open  ]],
Cell[42047, 919, 971, 22, 112, "Input"],
Cell[43021, 943, 333, 6, 31, "Input"],
Cell[43357, 951, 859, 19, 72, "Input"],
Cell[CellGroupData[{
Cell[44241, 974, 8197, 183, 492, "Input"],
Cell[CellGroupData[{
Cell[52463, 1161, 10826, 251, 500, "Print"],
Cell[63292, 1414, 10946, 252, 500, "Print"],
Cell[74241, 1668, 10976, 252, 500, "Print"]
}, Open  ]],
Cell[85232, 1923, 77, 1, 31, "Output"],
Cell[85312, 1926, 115, 1, 31, "Output"],
Cell[85430, 1929, 118, 1, 31, "Output"]
}, Open  ]],
Cell[85563, 1933, 333, 6, 31, "Input"]
}
]
*)

(* End of internal cache information *)
