(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[   1961508,      38247]
NotebookOptionsPosition[   1954310,      38031]
NotebookOutlinePosition[   1954752,      38048]
CellTagsIndexPosition[   1954709,      38045]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
 RowBox[{"Needs", "[", "\"\<ErrorBarPlots`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{
    RowBox[{"DirectoryName", "[", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], ",", "1"}], "]"}], "<>", 
    "\"\<\\\\Mathematica Packages\>\""}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Get", "[", "\"\<Genealogy`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Get", "[", "\"\<SMARTree`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Get", "[", "\"\<Toolbox`\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"SetDirectory", "[", 
  RowBox[{"NotebookDirectory", "[", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.569122356237032*^9, 3.569122411855213*^9}, {
   3.5691229136709156`*^9, 3.5691229236184845`*^9}, {3.5691229982057505`*^9, 
   3.56912299853677*^9}, {3.569123095496315*^9, 3.569123096054347*^9}, {
   3.569137802234295*^9, 3.5691378118228436`*^9}, {3.5694090869979362`*^9, 
   3.56940911118932*^9}, {3.5694893576233673`*^9, 3.5694894107882605`*^9}, {
   3.5694898522662363`*^9, 3.5694898915783052`*^9}, 3.5694913889035506`*^9, 
   3.574735477829033*^9, {3.574735599510977*^9, 3.5747356178522143`*^9}, {
   3.574770569643018*^9, 3.574770575945429*^9}, {3.5748976808852797`*^9, 
   3.5748976810100803`*^9}, 3.575215152839428*^9, {3.579576195645844*^9, 
   3.579576199873451*^9}, {3.5808131277276726`*^9, 3.580813128148875*^9}, {
   3.5857625664645386`*^9, 3.5857625673165874`*^9}, 3.585762606598834*^9}],

Cell[BoxData["\<\"D:\\\\Chaozhi\\\\ChaozhiUW\\\\UWProjects\\\\UWProject2\\\\\
SMARTree_MathematicaCode\\\\InferSMARTree\"\>"], "Output",
 CellChangeTimes->{3.5857641225065393`*^9, 3.5857648605597534`*^9, 
  3.585764919666134*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"acf", "[", 
    RowBox[{
     RowBox[{"x", ":", 
      RowBox[{"{", "__Real", "}"}]}], ",", "kk_Integer"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"p", "=", 
        RowBox[{"Mean", "[", "x", "]"}]}], ",", 
       RowBox[{"l", "=", 
        RowBox[{"Length", "[", "x", "]"}]}]}], "}"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Sum", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
              "x", "\[LeftDoubleBracket]", "t", "\[RightDoubleBracket]"}], 
              "-", "p"}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"x", "\[LeftDoubleBracket]", 
               RowBox[{"t", "-", "k"}], "\[RightDoubleBracket]"}], "-", "p"}],
              ")"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"t", ",", 
             RowBox[{"k", "+", "1"}], ",", "l"}], "}"}]}], "]"}], "/", 
         RowBox[{"(", 
          RowBox[{"l", "-", "k"}], ")"}]}], "/", 
        RowBox[{"Sum", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
               "x", "\[LeftDoubleBracket]", "t", "\[RightDoubleBracket]"}], 
               "-", "p"}], ")"}], "^", "2"}], ")"}], "/", "l"}], ",", 
          RowBox[{"{", 
           RowBox[{"t", ",", "1", ",", "l"}], "}"}]}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"k", ",", "0", ",", "kk"}], "}"}]}], "]"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"f", "[", 
    RowBox[{"n_", ",", "x_"}], "]"}], ":=", 
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{"n", "-", "1"}], ")"}], " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"Exp", "[", 
        RowBox[{
         RowBox[{"-", "x"}], "/", "2"}], "]"}]}], ")"}], "^", 
     RowBox[{"(", 
      RowBox[{"n", "-", "2"}], ")"}]}], " ", 
    RowBox[{"Exp", "[", 
     RowBox[{
      RowBox[{"-", "x"}], "/", "2"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"mf", "[", "n_", "]"}], ":=", 
    RowBox[{"2", " ", 
     RowBox[{"HarmonicNumber", "[", 
      RowBox[{"n", "-", "1"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Clear", "[", 
     RowBox[{"n", ",", "x"}], "]"}], "\[IndentingNewLine]", 
    RowBox[{"Integrate", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"x", "-", 
          RowBox[{"mf", "[", "n", "]"}]}], ")"}], "^", "2"}], " ", 
       RowBox[{"f", "[", 
        RowBox[{"n", ",", "x"}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "0", ",", "Infinity"}], "}"}], ",", 
      RowBox[{"Assumptions", "\[Rule]", 
       RowBox[{"(", 
        RowBox[{"n", ">", "1"}], ")"}]}]}], "]"}]}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"vf", "[", "n_", "]"}], ":=", 
  RowBox[{
   FractionBox["2", "3"], " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["\[Pi]", "2"], "-", 
     RowBox[{"6", " ", 
      RowBox[{"PolyGamma", "[", 
       RowBox[{"1", ",", "n"}], "]"}]}]}], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cdff", "[", 
   RowBox[{"n_", ",", "x_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", 
     RowBox[{"Exp", "[", 
      RowBox[{
       RowBox[{"-", "x"}], "/", "2"}], "]"}]}], ")"}], "^", 
   RowBox[{"(", 
    RowBox[{"n", "-", "1"}], ")"}]}]}]}], "Input",
 CellChangeTimes->{{3.5152579902188253`*^9, 3.5152579929956303`*^9}, {
   3.5152581511185083`*^9, 3.5152581718041444`*^9}, {3.5153550184553347`*^9, 
   3.5153550201869383`*^9}, {3.5153757423519044`*^9, 
   3.5153757889959865`*^9}, {3.5153758414120784`*^9, 3.515375843767683*^9}, {
   3.524319288908052*^9, 3.5243192893604527`*^9}, {3.5351143225343704`*^9, 
   3.535114331894387*^9}, 3.5826015146520505`*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"withdata", "=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"bool", "=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"primodel", "=", "\"\<P1\>\""}], "\[IndentingNewLine]", 
 RowBox[{"ascertainmodel", "=", "\"\<M1\>\""}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"id", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<Standard\>\"", ",", "\"\<ExtraSeqs\>\"", ",", "\"\<ExtraBP\>\"", 
     ",", "\"\<RecHotspot\>\"", ",", "\"\<RecMutHotspot\>\""}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dataid", "=", 
   RowBox[{"id", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"datafile", "=", 
   RowBox[{"\"\<Data_\>\"", "<>", "dataid", "<>", "\"\<.txt\>\""}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"outcold", "=", 
  RowBox[{
  "\"\<SMARTree_OutCold_\>\"", "<>", "ascertainmodel", "<>", "primodel", 
   "<>", "\"\<_\>\"", "<>", "datafile"}]}]}], "Input",
 CellChangeTimes->{{3.5691197868590717`*^9, 3.5691197998498154`*^9}, {
   3.5691198384430227`*^9, 3.569119858550173*^9}, {3.569120710533903*^9, 
   3.569120756165513*^9}, {3.569120872922191*^9, 3.569120873494224*^9}, {
   3.5691209684136534`*^9, 3.5691210503633404`*^9}, {3.569121082207162*^9, 
   3.5691210826551876`*^9}, {3.5691218789367323`*^9, 3.569121883323983*^9}, {
   3.569123123885939*^9, 3.5691231270231185`*^9}, {3.5691246718864794`*^9, 
   3.569124675173668*^9}, {3.569124812271509*^9, 3.5691248248192267`*^9}, {
   3.569126480619933*^9, 3.569126587854067*^9}, {3.5691885323878016`*^9, 
   3.569188594848374*^9}, {3.5694680808653173`*^9, 3.5694680931800213`*^9}, {
   3.5694689017352686`*^9, 3.569468902134291*^9}, {3.5694689875521765`*^9, 
   3.5694689961496687`*^9}, {3.569469195860091*^9, 3.5694692253957806`*^9}, {
   3.5694699275499415`*^9, 3.5694699311641483`*^9}, {3.5694701131345563`*^9, 
   3.569470127311367*^9}, {3.5694703176502542`*^9, 3.569470320185399*^9}, {
   3.5694899197675548`*^9, 3.569489923402361*^9}, {3.569533964200055*^9, 
   3.5695340268926406`*^9}, {3.569534062598683*^9, 3.5695341133965883`*^9}, {
   3.5695341563940477`*^9, 3.5695341568650746`*^9}, {3.5695342013016167`*^9, 
   3.56953421133119*^9}, {3.569534256539776*^9, 3.5695342595259466`*^9}, 
   3.569546226431676*^9, {3.5695469982138195`*^9, 3.5695469987718515`*^9}, {
   3.5695495668887396`*^9, 3.5695495715900087`*^9}, {3.569549767349205*^9, 
   3.569549789623479*^9}, {3.569550032220355*^9, 3.5695500324973707`*^9}, {
   3.569550179567783*^9, 3.569550181199876*^9}, {3.5695502728401175`*^9, 
   3.5695502797275114`*^9}, {3.5695503247990894`*^9, 3.569550337454813*^9}, {
   3.569551078926223*^9, 3.5695510827604427`*^9}, {3.5695520540289955`*^9, 
   3.569552057969221*^9}, {3.569552204273589*^9, 3.5695522415497212`*^9}, {
   3.569552334340029*^9, 3.5695523550972157`*^9}, {3.569552562332069*^9, 
   3.569552562894101*^9}, {3.5695529236907377`*^9, 3.5695529242497697`*^9}, {
   3.574717466009091*^9, 3.5747174688170958`*^9}, {3.574717804170885*^9, 
   3.5747178049664865`*^9}, {3.574718276899016*^9, 3.5747182807054224`*^9}, {
   3.5747183548835526`*^9, 3.574718379983997*^9}, {3.5747184149748583`*^9, 
   3.574718417626863*^9}, 3.5747228934160004`*^9, {3.5747230951619554`*^9, 
   3.5747231775457*^9}, 3.5747235282959166`*^9, {3.5747235692771883`*^9, 
   3.5747235725687943`*^9}, {3.5747236589149456`*^9, 3.5747236671985607`*^9}, 
   3.574723747460701*^9, 3.5747239485450544`*^9, 3.5747250036003785`*^9, 
   3.574725161160655*^9, 3.574725664959553*^9, {3.574725715784442*^9, 
   3.5747257219932528`*^9}, {3.574725843876267*^9, 3.5747258508182793`*^9}, {
   3.574726039760619*^9, 3.57472604030662*^9}, {3.5747297566089573`*^9, 
   3.5747297589645615`*^9}, {3.5747298181978655`*^9, 3.57472982072507*^9}, 
   3.5747299877555637`*^9, {3.574736087593877*^9, 3.5747361002298985`*^9}, {
   3.5747363118442707`*^9, 3.5747363156974773`*^9}, 3.57477060502388*^9, 
   3.5752663347000866`*^9, {3.5778837279652567`*^9, 3.577883747948892*^9}, {
   3.5778866321190863`*^9, 3.577886632275095*^9}, {3.577937165598323*^9, 
   3.577937166113124*^9}, {3.57793719792158*^9, 3.5779371982959805`*^9}, {
   3.5779373615018673`*^9, 3.577937361813868*^9}, {3.577938274733371*^9, 
   3.577938278180977*^9}, {3.5779671496312704`*^9, 3.5779671500822964`*^9}, {
   3.579576092299662*^9, 3.579576092752063*^9}, 3.5795765043307867`*^9, 
   3.579668604327343*^9, 3.579668984421211*^9, 3.5797686406167307`*^9, 
   3.5797690124745836`*^9, 3.5798541987613325`*^9, 3.5799254259481134`*^9, 
   3.580025566711703*^9, 3.5808121200951977`*^9, {3.5808123388280044`*^9, 
   3.5808123415425262`*^9}, {3.580813112689176*^9, 3.5808131131259785`*^9}, 
   3.5810754622864246`*^9, 3.5813940810256796`*^9, 3.5817579528340197`*^9, 
   3.581822758217245*^9, 3.5818228408505898`*^9, 3.581847025791746*^9, {
   3.5818471929000397`*^9, 3.581847196207246*^9}, {3.5819268511449904`*^9, 
   3.581926855216643*^9}, {3.581998543640998*^9, 3.581998549038667*^9}, {
   3.5824330169488735`*^9, 3.5824330234072847`*^9}, 3.582433089879001*^9, 
   3.582433159829524*^9, 3.5826016946239667`*^9, {3.5826024977971783`*^9, 
   3.5826025052851915`*^9}, {3.5826112878318167`*^9, 
   3.5826113073474507`*^9}, {3.5826124442228465`*^9, 3.582612503814951*^9}, {
   3.5826125449990234`*^9, 3.5826125489458303`*^9}, {3.5857632892338786`*^9, 
   3.585763308598986*^9}}],

Cell[BoxData["\<\"P1\"\>"], "Output",
 CellChangeTimes->{3.5857641227435527`*^9, 3.5857648606017556`*^9, 
  3.585764919702136*^9}],

Cell[BoxData["\<\"M1\"\>"], "Output",
 CellChangeTimes->{3.5857641227435527`*^9, 3.5857648606017556`*^9, 
  3.585764919703136*^9}],

Cell[BoxData["\<\"SMARTree_OutCold_M1P1_Data_Standard.txt\"\>"], "Output",
 CellChangeTimes->{3.5857641227435527`*^9, 3.5857648606017556`*^9, 
  3.585764919704136*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
  "******)"}]], "Input",
 CellChangeTimes->{{3.4940977943255997`*^9, 3.494097801075859*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.582611340279109*^9, 3.5826113419171114`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"getsnptbl", "[", 
   RowBox[{"yls_", ",", "xls_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"yls2", ",", "map"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"yls2", "=", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"yls", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}], "\[Equal]", "nbp"}],
         ",", "yls", ",", 
        RowBox[{"Append", "[", 
         RowBox[{"yls", ",", 
          RowBox[{"{", 
           RowBox[{"nbp", ",", 
            RowBox[{"yls", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], "}"}]}], 
         "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"map", "=", 
      RowBox[{"IndexByInterpolation", "[", 
       RowBox[{"yls2", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "1"}], "]"}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"yls2", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"map", "[", "xls", "]"}], ",", "2"}], "]"}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Block", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"temp", ",", "seed"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"temp", "=", 
       RowBox[{"ReadList", "[", 
        RowBox[{"\"\<TrueValues_\>\"", "<>", "dataid", "<>", "\"\<.txt\>\""}],
         "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", 
          RowBox[{"First", "[", "temp", "]"}], "]"}], ">", "6"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "nbp", ",", "nsq", ",", "truerho", ",", "truetheta", ",", 
           "trueepsilon", ",", "seed", ",", "hotstart", ",", "hotwidth", ",", 
           "hotratio"}], "}"}], "=", 
         RowBox[{"First", "[", "temp", "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "nbp", ",", "nsq", ",", "truerho", ",", "truetheta", ",", 
            "trueepsilon", ",", "seed"}], "}"}], "=", 
          RowBox[{"First", "[", "temp", "]"}]}], ";"}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"popunit", "=", 
       RowBox[{"10", "^", 
        RowBox[{"(", 
         RowBox[{"-", "3"}], ")"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"truerho", "/=", "popunit"}], ";", "\[IndentingNewLine]", 
      RowBox[{"truetheta", "/=", "popunit"}], ";", "\[IndentingNewLine]", 
      RowBox[{"trueepsilon", "/=", "popunit"}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", 
          RowBox[{"First", "[", "temp", "]"}], "]"}], ">", "6"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ls", "=", 
          RowBox[{"Split", "[", 
           RowBox[{
            RowBox[{"Rest", "[", "temp", "]"}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"Head", "[", 
               RowBox[{"#1", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", 
              RowBox[{"Head", "[", 
               RowBox[{"#2", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "&"}]}], "]"}]}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"errind", "=", 
          RowBox[{"Flatten", "[", 
           RowBox[{
            RowBox[{"ls", "[", 
             RowBox[{"[", 
              RowBox[{"1", ";;", ";;", "2"}], "]"}], "]"}], ",", "1"}], 
           "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"treels", "=", 
          RowBox[{"Flatten", "[", 
           RowBox[{
            RowBox[{"ls", "[", 
             RowBox[{"[", 
              RowBox[{"2", ";;", ";;", "2"}], "]"}], "]"}], ",", "1"}], 
           "]"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"treels", "=", 
          RowBox[{"DeleteDuplicates", "[", "treels", "]"}]}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"errind", ",", "treels"}], "}"}], "=", 
          RowBox[{"Split", "[", 
           RowBox[{
            RowBox[{"Rest", "[", "temp", "]"}], ",", 
            RowBox[{
             RowBox[{
              RowBox[{"Head", "[", 
               RowBox[{"#1", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", 
              RowBox[{"Head", "[", 
               RowBox[{"#2", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "&"}]}], "]"}]}], 
         ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"truetreeloc", ",", "truetreels"}], "}"}], "=", 
       RowBox[{"Transpose", "[", "treels", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"truetreetbl", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"TotalBranchHeight", "[", "#", "]"}], "&"}], "/@", 
        "truetreels"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"ysnp", "=", 
       RowBox[{"Rest", "[", 
        RowBox[{"ReadList", "[", "datafile", "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"trueaf", "=", 
       RowBox[{"ysnp", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", 
          RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"prithetashape", "=", "1"}], ";", "\[IndentingNewLine]", 
      RowBox[{"prithetascale", "=", "Infinity"}], ";", "\[IndentingNewLine]", 
      RowBox[{"prithetamin", "=", "0"}], ";", "\[IndentingNewLine]", 
      RowBox[{"prithetamax", "=", "0.01"}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"prithetamin", ",", "prithetamax", ",", "prithetascale"}], 
        "}"}], "/=", "popunit"}], ";", "\[IndentingNewLine]", 
      RowBox[{"prirhoshape", "=", "1"}], ";", "\[IndentingNewLine]", 
      RowBox[{"prirhoscale", "=", "Infinity"}], ";", "\[IndentingNewLine]", 
      RowBox[{"prirhomin", "=", "0"}], ";", "\[IndentingNewLine]", 
      RowBox[{"prirhomax", "=", "0.01"}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"prirhomin", ",", "prirhomax", ",", "prirhoscale"}], "}"}], "/=",
        "popunit"}], ";", "\[IndentingNewLine]", 
      RowBox[{"priepsmin", "=", "0"}], ";", "\[IndentingNewLine]", 
      RowBox[{"priepsmax", "=", "0.1"}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"priepsmin", ",", "priepsmax"}], "}"}], "/=", "popunit"}], 
      ";"}]}], "\[IndentingNewLine]", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"thetadist", "=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"prithetascale", "\[Equal]", "Infinity"}], ",", 
    RowBox[{"UniformDistribution", "[", 
     RowBox[{"{", 
      RowBox[{"prithetamin", ",", "prithetamax"}], "}"}], "]"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"TruncatedDistribution", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"prithetamin", ",", "prithetamax"}], "}"}], ",", 
      RowBox[{"GammaDistribution", "[", 
       RowBox[{"prithetashape", ",", "prithetascale"}], "]"}]}], "]"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"rhodist", "=", 
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"prirhoscale", "\[Equal]", "Infinity"}], ",", 
    RowBox[{"UniformDistribution", "[", 
     RowBox[{"{", 
      RowBox[{"prirhomin", ",", "prirhomax"}], "}"}], "]"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"TruncatedDistribution", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"prirhomin", ",", "prirhomax"}], "}"}], ",", 
      RowBox[{"GammaDistribution", "[", 
       RowBox[{"prirhoshape", ",", "prirhoscale"}], "]"}]}], "]"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"epsdist", "=", 
  RowBox[{"UniformDistribution", "[", 
   RowBox[{"{", 
    RowBox[{"prirhomin", ",", "priepsmax"}], "}"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.494798508966254*^9, 3.4947985105600653`*^9}, {
   3.49479943845507*^9, 3.4947994389707146`*^9}, {3.4947994889570093`*^9, 
   3.4947995047701163`*^9}, {3.4948810239496746`*^9, 
   3.4948810244184427`*^9}, {3.4949474888431444`*^9, 3.494947489515045*^9}, {
   3.495161045519342*^9, 3.4951610467829447`*^9}, {3.505852498891985*^9, 
   3.5058525092986345`*^9}, {3.505852779027742*^9, 3.505852814560356*^9}, 
   3.5088248626601887`*^9, {3.508825424443977*^9, 3.508825425192778*^9}, {
   3.5088560823325777`*^9, 3.508856083018979*^9}, {3.51262187209194*^9, 
   3.512621877691948*^9}, 3.512759574841961*^9, {3.5131287308251395`*^9, 
   3.5131287324007425`*^9}, {3.513528594581524*^9, 3.5135286152643557`*^9}, {
   3.513528739197359*^9, 3.51352873960296*^9}, {3.513529391450902*^9, 
   3.513529391669302*^9}, {3.51352942466336*^9, 3.513529426784964*^9}, {
   3.5135515538512936`*^9, 3.5135515550836954`*^9}, 3.5135537124495683`*^9, {
   3.5135543186208324`*^9, 3.5135543236752415`*^9}, {3.513554645541008*^9, 
   3.513554646071409*^9}, 3.513555173709936*^9, {3.513555805278847*^9, 
   3.51355580690125*^9}, {3.513561221568677*^9, 3.513561222676279*^9}, 
   3.513782405034427*^9, 3.5137956511612854`*^9, {3.513798279022045*^9, 
   3.51379828179885*^9}, {3.513867421392151*^9, 3.5138674217509513`*^9}, 
   3.513876158247404*^9, 3.513916657618632*^9, 3.5139169533020315`*^9, {
   3.513991956773346*^9, 3.513991958614149*^9}, 3.513993715507437*^9, 
   3.514056563612421*^9, 3.5140583876319056`*^9, {3.514065888460104*^9, 
   3.5140658887877045`*^9}, {3.5140660117315207`*^9, 
   3.5140660170355296`*^9}, {3.514086904425982*^9, 3.514086905861184*^9}, {
   3.514087982929478*^9, 3.5140879848014812`*^9}, {3.514088513950076*^9, 
   3.5140885141216764`*^9}, 3.514089363520565*^9, {3.5140894194154634`*^9, 
   3.514089421225066*^9}, 3.5141553509364934`*^9, 3.51415795593967*^9, {
   3.514162580228597*^9, 3.5141625805093975`*^9}, 3.5141647052124915`*^9, 
   3.514164848801544*^9, {3.5142556219174705`*^9, 3.514255622260671*^9}, 
   3.5142563655433598`*^9, 3.514285638990277*^9, 3.514332880487591*^9, 
   3.514469547168135*^9, {3.5147431161878815`*^9, 3.5147431692747746`*^9}, {
   3.514743317943036*^9, 3.5147433298302565`*^9}, 3.5147454780760317`*^9, {
   3.514819513121424*^9, 3.514819514229026*^9}, 3.514819809710145*^9, {
   3.5148303262954197`*^9, 3.5148303272470217`*^9}, 3.5148312728768854`*^9, {
   3.5148313634662447`*^9, 3.514831365977849*^9}, 3.514832334425926*^9, 
   3.5148326541004753`*^9, 3.5148331765286846`*^9, 3.5148338370410457`*^9, 
   3.5148389463614798`*^9, 3.5148395736119833`*^9, {3.514843859423356*^9, 
   3.514843862262561*^9}, 3.5148449240729356`*^9, 3.514845500455903*^9, {
   3.514846816178158*^9, 3.514846816316166*^9}, {3.514847887862121*^9, 
   3.514847888174122*^9}, {3.5148552358653927`*^9, 3.5148552383301973`*^9}, {
   3.5148571848870163`*^9, 3.5148571850430164`*^9}, 3.5148604608661427`*^9, 
   3.514861725124563*^9, 3.514861964616184*^9, 3.5148623826479197`*^9, 
   3.514862950691531*^9, 3.5148642292456603`*^9, 3.5148656592184505`*^9, 
   3.514944274456249*^9, 3.5149458938180933`*^9, 3.5149468387893324`*^9, 
   3.5149471951983523`*^9, 3.515200297725978*^9, {3.5152493127867837`*^9, 
   3.515249313488785*^9}, {3.515258422293784*^9, 3.515258422574585*^9}, {
   3.5152593627042465`*^9, 3.515259363484248*^9}, {3.5152607784845357`*^9, 
   3.5152607787653365`*^9}, {3.5156978209813237`*^9, 
   3.5156978215897245`*^9}, {3.5157129621908407`*^9, 
   3.5157129625988646`*^9}, {3.515723772985896*^9, 3.5157237737658978`*^9}, 
   3.5159693735441785`*^9, {3.5159743363498554`*^9, 3.5159743366498723`*^9}, {
   3.5159753972615356`*^9, 3.5159753981405864`*^9}, {3.5160520832874403`*^9, 
   3.516052092381961*^9}, {3.5160550673951187`*^9, 3.5160550678319197`*^9}, {
   3.5160557067320414`*^9, 3.516055707075242*^9}, {3.516059817996463*^9, 
   3.5160598196656656`*^9}, {3.516060862379817*^9, 3.516060864501421*^9}, 
   3.516061851801461*^9, {3.516065546876999*^9, 3.516065548171801*^9}, {
   3.5161567871323423`*^9, 3.5161567884427443`*^9}, {3.5161625411752815`*^9, 
   3.516162542610484*^9}, {3.5164906942645025`*^9, 3.5164906952317047`*^9}, {
   3.5169852334105115`*^9, 3.516985233669526*^9}, {3.516993617207528*^9, 
   3.516993617827529*^9}, {3.5170160868961835`*^9, 3.517016089969389*^9}, 
   3.517018687345852*^9, {3.5170720976619434`*^9, 3.517072098083144*^9}, {
   3.517410202765489*^9, 3.5174102078978987`*^9}, {3.5174130556011763`*^9, 
   3.5174130575355797`*^9}, {3.518652966891639*^9, 3.5186529899916716`*^9}, {
   3.5186553089149094`*^9, 3.5186553091549096`*^9}, {3.5186561018747463`*^9, 
   3.518656102154747*^9}, 3.5196649064224625`*^9, {3.5196655782708817`*^9, 
   3.5196655788908825`*^9}, {3.5202919545976915`*^9, 3.520291954769292*^9}, {
   3.520617602770405*^9, 3.5206176038604064`*^9}, 3.520618378351491*^9, 
   3.520697924214883*^9, {3.520786030117346*^9, 3.520786030366946*^9}, {
   3.5207893746783175`*^9, 3.520789374834318*^9}, {3.5207907871424694`*^9, 
   3.5207907877352705`*^9}, {3.5220220357363205`*^9, 
   3.5220220404163284`*^9}, {3.5221918182458577`*^9, 3.5221918245638685`*^9}, 
   3.522191892969989*^9, {3.522191923670843*^9, 3.5221919271496487`*^9}, 
   3.522192340285175*^9, 3.5221982982267437`*^9, 3.5222513053961687`*^9, {
   3.5222579973687754`*^9, 3.5222579982828283`*^9}, 3.5222941836185107`*^9, {
   3.522330295463924*^9, 3.522330299028979*^9}, {3.522539605326341*^9, 
   3.522539607260744*^9}, {3.522540865832756*^9, 3.522540869529963*^9}, 
   3.522549192498004*^9, {3.5225559945149703`*^9, 3.522555995045371*^9}, 
   3.522595002521777*^9, 3.5225960263739753`*^9, {3.522601340675666*^9, 
   3.5226013408881693`*^9}, {3.5226020948297496`*^9, 3.522602095844765*^9}, {
   3.522689483194635*^9, 3.5226894836521416`*^9}, 3.522692213946794*^9, 
   3.5226928103854313`*^9, {3.5230689294691896`*^9, 3.523068933447197*^9}, {
   3.5230701282349377`*^9, 3.523070128656139*^9}, {3.523070433886275*^9, 
   3.5230704353526773`*^9}, 3.5230717484069834`*^9, {3.5230718004174747`*^9, 
   3.5230718006202755`*^9}, 3.5230719053744593`*^9, {3.523072856944931*^9, 
   3.5230728647293444`*^9}, {3.523109007767185*^9, 3.5231090102475896`*^9}, {
   3.523142971052683*^9, 3.5231429897571154`*^9}, {3.523145043110722*^9, 
   3.5231450460903273`*^9}, {3.5231458146412773`*^9, 3.523145819602086*^9}, 
   3.5231505287993293`*^9, {3.5235579144617505`*^9, 3.523557917020155*^9}, {
   3.5235601051426315`*^9, 3.523560109339039*^9}, {3.523651269634571*^9, 
   3.523651270508173*^9}, {3.5236593953321495`*^9, 3.5236593955037494`*^9}, {
   3.5239114513370433`*^9, 3.5239114535054474`*^9}, {3.5239182294883623`*^9, 
   3.5239182304783773`*^9}, 3.5239189591855373`*^9, {3.5239195750844*^9, 
   3.5239195753044004`*^9}, 3.523994604645683*^9, 3.5239967330084195`*^9, {
   3.524014369864175*^9, 3.524014373364194*^9}, {3.5240207207972965`*^9, 
   3.5240207228072996`*^9}, 3.5240993632290096`*^9, 3.5241110093279552`*^9, {
   3.5241112587109933`*^9, 3.524111258866994*^9}, {3.5244066408623796`*^9, 
   3.52440664115878*^9}, {3.524411210822941*^9, 3.524411210978941*^9}, {
   3.5245793856945295`*^9, 3.524579389750537*^9}, {3.524579648140396*^9, 
   3.524579649169998*^9}, {3.524802561884214*^9, 3.524802563147816*^9}, 
   3.52480338334788*^9, 3.5248635858854465`*^9, 3.5248752476917696`*^9, 
   3.5248786233399005`*^9, 3.5248791718946505`*^9, 3.5248809367994385`*^9, 
   3.5248812712603865`*^9, 3.524882636253279*^9, 3.524883559129815*^9, 
   3.5249213427839255`*^9, 3.524978098594782*^9, {3.5249790037225523`*^9, 
   3.5249790161682644`*^9}, {3.52500866051971*^9, 3.525008749954667*^9}, {
   3.525008821402793*^9, 3.525008829655207*^9}, {3.5250089614754386`*^9, 
   3.5250090001479063`*^9}, {3.525127510112669*^9, 3.525127527866684*^9}, {
   3.525134477310195*^9, 3.5251344806173844`*^9}, {3.52514677914782*^9, 
   3.5251467820899887`*^9}, {3.5251469545008497`*^9, 
   3.5251469598901577`*^9}, {3.525148084480481*^9, 3.525148089901791*^9}, {
   3.525170922202724*^9, 3.525170922607747*^9}, {3.5253101388879294`*^9, 
   3.525310179747987*^9}, {3.5253155615396123`*^9, 3.5253155622796135`*^9}, {
   3.52557410286654*^9, 3.5255741071253476`*^9}, {3.5256555960863075`*^9, 
   3.5256555974934483`*^9}, {3.525880037238859*^9, 3.5258800405772653`*^9}, {
   3.526265193672043*^9, 3.5262652063080654`*^9}, {3.5263535142819448`*^9, 
   3.5263535165751486`*^9}, {3.5263539143878603`*^9, 
   3.5263539153178616`*^9}, {3.526393365867093*^9, 3.5263933670200076`*^9}, {
   3.5263935673371353`*^9, 3.5263935684325294`*^9}, {3.5264505867750063`*^9, 
   3.5264505884161005`*^9}, {3.526490123167925*^9, 3.5264901242443247`*^9}, {
   3.5268315584988437`*^9, 3.526831559263245*^9}, {3.5268317732523766`*^9, 
   3.5268317741843786`*^9}, {3.5268350278165474`*^9, 3.526835028026548*^9}, {
   3.5268456966995497`*^9, 3.5268456969959497`*^9}, {3.5269236063346586`*^9, 
   3.526923609139819*^9}, {3.5277068206128197`*^9, 3.5277068233116245`*^9}, {
   3.5277075291816645`*^9, 3.5277075449220924`*^9}, {3.527707603936996*^9, 
   3.5277076140770135`*^9}, {3.527708657313246*^9, 3.5277086584832478`*^9}, {
   3.5277110660388527`*^9, 3.527711069143258*^9}, {3.5277124556268935`*^9, 
   3.527712457249296*^9}, {3.5287667317761335`*^9, 3.528766732992935*^9}, {
   3.5287678534258795`*^9, 3.5287678545358963`*^9}, {3.5291159344921293`*^9, 
   3.5291159348041306`*^9}, {3.5291181297293396`*^9, 
   3.5291181299321404`*^9}, {3.529119634672086*^9, 3.529119635062086*^9}, {
   3.5291253688809834`*^9, 3.529125369192984*^9}, {3.5291572768012*^9, 
   3.529157279390805*^9}, {3.5291931489541407`*^9, 3.5291931538681493`*^9}, {
   3.5292377709761715`*^9, 3.529237771818573*^9}, {3.52959144985889*^9, 
   3.5295914584389052`*^9}, {3.5296105876904464`*^9, 3.5296106016092424`*^9}, 
   3.5296416609017324`*^9, {3.529991979362759*^9, 3.529991988161175*^9}, {
   3.5299920848511443`*^9, 3.529992087347149*^9}, {3.5299927343547826`*^9, 
   3.529992734754783*^9}, {3.530039847120474*^9, 3.5300398500220785`*^9}, {
   3.530071842760488*^9, 3.53007184385249*^9}, {3.530110521100997*^9, 
   3.5301105218861985`*^9}, {3.5301190682703066`*^9, 3.530119078581925*^9}, {
   3.530124570847623*^9, 3.5301245766976333`*^9}, {3.530125240197998*^9, 
   3.5301252404631987`*^9}, {3.53012538317225*^9, 3.5301253834530497`*^9}, {
   3.530291690941947*^9, 3.530291691503548*^9}, {3.5307361623975134`*^9, 
   3.530736189541561*^9}, {3.5307362583220816`*^9, 3.5307363275706034`*^9}, 
   3.530737355597809*^9, 3.5307593987652473`*^9, {3.530760730375411*^9, 
   3.530760736987789*^9}, {3.530763737638204*^9, 3.530763738028205*^9}, {
   3.530803303024104*^9, 3.5308033043813066`*^9}, 3.5347218814825897`*^9, 
   3.534783945914305*^9, {3.534784045275588*^9, 3.5347840642915783`*^9}, {
   3.5347850271381893`*^9, 3.5347850280444565`*^9}, {3.534786046532761*^9, 
   3.534786047032771*^9}, {3.5347864797442036`*^9, 3.534786484838052*^9}, {
   3.5347865464486094`*^9, 3.5347865499486766`*^9}, {3.534787557483646*^9, 
   3.534787565452549*^9}, 3.534858761813766*^9, {3.534902436855856*^9, 
   3.534902440537462*^9}, {3.5349025192084007`*^9, 3.5349025203004026`*^9}, {
   3.534902662479052*^9, 3.5349026662074585`*^9}, {3.534909564860383*^9, 
   3.534909578760007*^9}, {3.5349103729830823`*^9, 3.5349103799310923`*^9}, {
   3.5349105968156962`*^9, 3.5349105972132015`*^9}, {3.5349112131101*^9, 
   3.5349112164932933`*^9}, {3.5349132059251127`*^9, 
   3.5349132073911963`*^9}, {3.534955359201333*^9, 3.5349553785816994`*^9}, {
   3.534955984792449*^9, 3.53495598515125*^9}, {3.5349658833449583`*^9, 
   3.5349658835789585`*^9}, {3.5349693618883724`*^9, 
   3.5349693622783732`*^9}, {3.534987844084088*^9, 3.5349878501941814`*^9}, {
   3.534988965054081*^9, 3.534988970732491*^9}, {3.5349919888406167`*^9, 
   3.5349919892930174`*^9}, {3.5350768796550407`*^9, 3.5350768797018404`*^9}, 
   3.536693568403823*^9, {3.5366943226623335`*^9, 3.536694342787977*^9}, {
   3.5366945072932415`*^9, 3.536694516512286*^9}, {3.536694573107847*^9, 
   3.5366945979523926`*^9}, {3.5366946312347074`*^9, 3.536694642156932*^9}, {
   3.5366946872990017`*^9, 3.53669471539365*^9}, {3.5366947465508976`*^9, 
   3.536694750113511*^9}, 3.536694902493387*^9, 3.5366950176064463`*^9, {
   3.536695466089547*^9, 3.536695467808352*^9}, {3.5390339681003256`*^9, 
   3.5390339682878313`*^9}, {3.542570888339017*^9, 3.5425708885418167`*^9}, {
   3.542571104929797*^9, 3.5425711051013975`*^9}, {3.5425775985686646`*^9, 
   3.5425775992394657`*^9}, 3.5425793190735846`*^9, 3.545426646291592*^9, 
   3.548887156353338*^9, {3.5488872842891626`*^9, 3.5488873028687954`*^9}, 
   3.5488876454602633`*^9, {3.548891185507403*^9, 3.5488911904058113`*^9}, {
   3.5507194725801735`*^9, 3.55071952212586*^9}, 3.5507241237936416`*^9, 
   3.55087447960245*^9, 3.55167291652312*^9, 3.5516772840311995`*^9, 
   3.552386494073024*^9, 3.5524273358469934`*^9, {3.555846318477341*^9, 
   3.555846330590034*^9}, {3.555846488233051*^9, 3.5558464887040777`*^9}, {
   3.5558467350821695`*^9, 3.555846744102686*^9}, {3.5558474354732294`*^9, 
   3.555847458803564*^9}, {3.556700794456046*^9, 3.5567008728673677`*^9}, {
   3.574736193018862*^9, 3.574736250302162*^9}, {3.5778838023929873`*^9, 
   3.5778838342804437`*^9}, {3.577883865168498*^9, 3.577883925649804*^9}, 
   3.5778840198895693`*^9, {3.57793718094875*^9, 3.5779371904335666`*^9}, 
   3.5779372300716367`*^9, {3.5826017251688204`*^9, 3.5826017819841204`*^9}, {
   3.5826113463007193`*^9, 3.582611348562723*^9}}],

Cell[BoxData[
 RowBox[{"UniformDistribution", "[", 
  RowBox[{"{", 
   RowBox[{"0", ",", "10.`"}], "}"}], "]"}]], "Output",
 CellChangeTimes->{3.5857641230005674`*^9, 3.5857648606507587`*^9, 
  3.5857649197411385`*^9}],

Cell[BoxData[
 RowBox[{"UniformDistribution", "[", 
  RowBox[{"{", 
   RowBox[{"0", ",", "10.`"}], "}"}], "]"}]], "Output",
 CellChangeTimes->{3.5857641230005674`*^9, 3.5857648606507587`*^9, 
  3.5857649197421384`*^9}],

Cell[BoxData[
 RowBox[{"UniformDistribution", "[", 
  RowBox[{"{", 
   RowBox[{"0", ",", "100.`"}], "}"}], "]"}]], "Output",
 CellChangeTimes->{3.5857641230005674`*^9, 3.5857648606507587`*^9, 
  3.5857649197431383`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Mean", "[", 
   RowBox[{"Flatten", "[", 
    RowBox[{"errind", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "3"}], "]"}], "]"}], "]"}], "]"}], "//", 
  "N"}], "\[IndentingNewLine]", 
 RowBox[{"Tally", "[", 
  RowBox[{"errind", "[", 
   RowBox[{"[", 
    RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.577891298510988*^9, 3.5778913429255285`*^9}, {
  3.5826017996433516`*^9, 3.5826018001581526`*^9}}],

Cell[BoxData["0.004615384615384616`"], "Output",
 CellChangeTimes->{3.5857641230895724`*^9, 3.5857648606887608`*^9, 
  3.5857649197531385`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "127"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "3"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5857641230895724`*^9, 3.5857648606887608`*^9, 
  3.585764919754139*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dimensions", "[", "ysnp", "]"}]], "Input",
 CellChangeTimes->{{3.583392701473572*^9, 3.5833927051735773`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"130", ",", "3"}], "}"}]], "Output",
 CellChangeTimes->{3.5857641232615824`*^9, 3.585764860724763*^9, 
  3.5857649197641397`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixPlot", "[", 
  RowBox[{
   RowBox[{"ysnp", "[", 
    RowBox[{"[", 
     RowBox[{
      RowBox[{";;", "20"}], ",", "2"}], "]"}], "]"}], ",", 
   RowBox[{"MaxPlotPoints", "\[Rule]", "Infinity"}], ",", 
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<SNP\>\"", ",", "\"\<Chr\>\""}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.526615273145139*^9, 3.526615352876879*^9}, {
  3.5266153888037424`*^9, 3.5266154410014343`*^9}, {3.526616288226079*^9, 
  3.5266162885060797`*^9}, {3.5266182445006275`*^9, 3.52661824621663*^9}, {
  3.58260195253922*^9, 3.5826019730688562`*^9}, {3.5826021024086833`*^9, 
  3.58260210599669*^9}, {3.5826021383355465`*^9, 3.582602253713349*^9}}],

Cell[BoxData[
 GraphicsBox[RasterBox[CompressedData["
1:eJxTTMoPSmVmYGAQAWIuIAaxIeCDPan0nJmzgfC2PQMKIF09qeLUMn/Uv9T1
70CZM1Di1PIvrd1DLXcOlDlDJR8NVHwN1/Q80vxLa5rW4TDY3D9Q5gy29Ekt
f1HLnFH/jvp3MJszUO6kFj3q31H/Dgb/Drb8Syo92NqBo+0N7DQA4Aa3mQ==

   "], {{0, 0}, {10, 20}}, {0, 1}],
  Frame->True,
  FrameLabel->{
    FormBox["\"Chr\"", TraditionalForm], 
    FormBox["\"SNP\"", TraditionalForm]},
  FrameTicks->{{{{19.5, 
       FormBox["1", TraditionalForm]}, {15.5, 
       FormBox["5", TraditionalForm]}, {10.5, 
       FormBox["10", TraditionalForm]}, {5.5, 
       FormBox["15", TraditionalForm]}, {0.5, 
       FormBox["20", TraditionalForm]}}, {{19.5, 
       FormBox["1", TraditionalForm]}, {15.5, 
       FormBox["5", TraditionalForm]}, {10.5, 
       FormBox["10", TraditionalForm]}, {5.5, 
       FormBox["15", TraditionalForm]}, {0.5, 
       FormBox["20", TraditionalForm]}}}, {{{0.5, 
       FormBox["1", TraditionalForm]}, {1.5, 
       FormBox["2", TraditionalForm]}, {2.5, 
       FormBox["3", TraditionalForm]}, {3.5, 
       FormBox["4", TraditionalForm]}, {4.5, 
       FormBox["5", TraditionalForm]}, {5.5, 
       FormBox["6", TraditionalForm]}, {6.5, 
       FormBox["7", TraditionalForm]}, {7.5, 
       FormBox["8", TraditionalForm]}, {8.5, 
       FormBox["9", TraditionalForm]}, {9.5, 
       FormBox["10", TraditionalForm]}}, {{0.5, 
       FormBox["1", TraditionalForm]}, {1.5, 
       FormBox["2", TraditionalForm]}, {2.5, 
       FormBox["3", TraditionalForm]}, {3.5, 
       FormBox["4", TraditionalForm]}, {4.5, 
       FormBox["5", TraditionalForm]}, {5.5, 
       FormBox["6", TraditionalForm]}, {6.5, 
       FormBox["7", TraditionalForm]}, {7.5, 
       FormBox["8", TraditionalForm]}, {8.5, 
       FormBox["9", TraditionalForm]}, {9.5, 
       FormBox["10", TraditionalForm]}}}}]], "Output",
 CellChangeTimes->{3.585764123410591*^9, 3.5857648607787657`*^9, 
  3.585764919792141*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
  "******)"}]], "Input",
 CellChangeTimes->{{3.4940977943255997`*^9, 3.494097801075859*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"tocoalescenttree", "[", 
    RowBox[{"{", 
     RowBox[{"tls_", ",", "al_"}], "}"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"tlist", ",", "alist", ",", "elist"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"tlist", "=", 
       RowBox[{"PadLeft", "[", 
        RowBox[{"tls", ",", 
         RowBox[{
          RowBox[{"2", " ", 
           RowBox[{"Length", "[", "tls", "]"}]}], "-", "1"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"alist", "=", 
       RowBox[{"Most", "[", "al", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"elist", "=", 
       RowBox[{"SplitBy", "[", 
        RowBox[{
         RowBox[{"SortBy", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Range", "[", 
               RowBox[{"Length", "[", "alist", "]"}], "]"}], ",", "alist"}], 
             "}"}], "]"}], ",", "Last"}], "]"}], ",", "Last"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"CoalescentTree", "[", 
       RowBox[{"tlist", ",", "elist"}], "]"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.529342172041554*^9, 3.529342172228754*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"rescold0", "=", 
    RowBox[{"Drop", "[", 
     RowBox[{
      RowBox[{"ReadList", "[", "outcold", "]"}], ",", "0"}], "]"}]}], ";"}], "//",
   "AbsoluteTiming"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", "rescold0", "]"}]}], "Input",
 CellChangeTimes->{{3.5352049971499033`*^9, 3.5352049999468317`*^9}, {
   3.5389219108761525`*^9, 3.5389219164388304`*^9}, {3.5389463122529*^9, 
   3.538946312909179*^9}, {3.538947415915448*^9, 3.5389474164467154`*^9}, {
   3.53895026933488*^9, 3.5389502701005297`*^9}, {3.5510555979122925`*^9, 
   3.5510555986454935`*^9}, {3.5510579937475457`*^9, 3.551057994062564*^9}, {
   3.5510651325970144`*^9, 3.551065134250617*^9}, {3.5511449544128585`*^9, 
   3.5511449550836596`*^9}, {3.5511466256044455`*^9, 3.551146625854046*^9}, 
   3.5511467556462736`*^9, {3.551147322231922*^9, 3.551147338453826*^9}, {
   3.5511483993455896`*^9, 3.55114839967319*^9}, {3.551151184695859*^9, 
   3.55115118531586*^9}, {3.551160259009712*^9, 3.551160259280913*^9}, {
   3.551178733025481*^9, 3.5511787338522825`*^9}, {3.551181084045273*^9, 
   3.551181084345273*^9}, {3.5511833729534492`*^9, 3.5511833736398506`*^9}, {
   3.5512176544890194`*^9, 3.5512176547860365`*^9}, {3.551220053189023*^9, 
   3.5512200535166235`*^9}, {3.5516591826200914`*^9, 
   3.5516591829000916`*^9}, {3.5517352146313305`*^9, 3.551735214834131*^9}, {
   3.5518250173559713`*^9, 3.5518250211623783`*^9}, {3.5521331170820417`*^9, 
   3.5521331180804434`*^9}, 3.5522984511151094`*^9, {3.552560699987282*^9, 
   3.552560700427283*^9}, {3.5527401630923862`*^9, 3.5527401632639866`*^9}, 
   3.553498696520337*^9, 3.553500170798006*^9, {3.553505567189251*^9, 
   3.553505568811653*^9}, 3.5535073877299557`*^9, 3.5535075442606306`*^9, 
   3.553545986345519*^9, {3.5747362857142243`*^9, 3.5747362878046284`*^9}, 
   3.5749134030057325`*^9, {3.574915359092457*^9, 3.574915359997258*^9}, {
   3.575011793316818*^9, 3.575011793691219*^9}, 3.5750123331581607`*^9, {
   3.575019852781991*^9, 3.575019853515192*^9}, {3.5750200207932916`*^9, 
   3.575020022212894*^9}, 3.575020784279113*^9, 3.575031025395302*^9, {
   3.5750320233915157`*^9, 3.575032023859516*^9}, {3.575034270368332*^9, 
   3.5750342709299326`*^9}, {3.57503726429739*^9, 3.5750372651397915`*^9}, {
   3.575040319575691*^9, 3.5750403197316914`*^9}, 3.575040557704571*^9, 
   3.5750407694809055`*^9, {3.5750412690796604`*^9, 3.5750412693136606`*^9}, {
   3.575041341727709*^9, 3.575041343630912*^9}, {3.575069550654233*^9, 
   3.5750695515122347`*^9}, {3.575070957866716*^9, 3.575070958038316*^9}, {
   3.575123572246054*^9, 3.575123572737155*^9}, {3.5751242616480103`*^9, 
   3.575124261799019*^9}, {3.57512462112755*^9, 3.5751246242375546`*^9}, {
   3.575125851925702*^9, 3.5751258520973024`*^9}, 3.5751612765606456`*^9, 
   3.5751618984713383`*^9, {3.575162840166992*^9, 3.575162840884593*^9}, {
   3.575163372929735*^9, 3.5751633792633467`*^9}, {3.575163651332325*^9, 
   3.575163651613126*^9}, 3.575163695324403*^9, 3.5751637749157424`*^9, 
   3.575164047417021*^9, {3.575165508451206*^9, 3.575165508825607*^9}, {
   3.5751659136496077`*^9, 3.575165913805608*^9}, 3.5751663357427845`*^9, 
   3.575166507180122*^9, 3.575167330653433*^9, 3.5751732139430017`*^9, {
   3.575173827144514*^9, 3.5751738274565144`*^9}, 3.5751745096225405`*^9, {
   3.5751748314803333`*^9, 3.5751748329623365`*^9}, 3.5751748821648226`*^9, {
   3.5751751472716885`*^9, 3.57517514834809*^9}, {3.5751762625472727`*^9, 
   3.575176263077674*^9}, {3.5751853857483053`*^9, 3.5751853858887057`*^9}, {
   3.5751942108818865`*^9, 3.5751942113498874`*^9}, {3.5752027688755894`*^9, 
   3.57520276912519*^9}, {3.5752029455307236`*^9, 3.5752029456732264`*^9}, 
   3.575205422815734*^9, 3.5752058174916706`*^9, {3.575206153542713*^9, 
   3.5752061539483137`*^9}, {3.5752073403903074`*^9, 
   3.5752073405463076`*^9}, {3.5752094829761252`*^9, 3.575209483319326*^9}, {
   3.5752098366416354`*^9, 3.5752098368288355`*^9}, {3.575212864444008*^9, 
   3.575212867392413*^9}, {3.5752129645025835`*^9, 3.5752129649393845`*^9}, {
   3.5752151695626574`*^9, 3.5752151697342577`*^9}, 3.575266346821308*^9, 
   3.5778854213688354`*^9, 3.5778860809455605`*^9, 3.57788665176621*^9, {
   3.577891858905041*^9, 3.5778918618792114`*^9}, 3.5779373454026394`*^9, {
   3.5781370355411663`*^9, 3.5781370361339674`*^9}, {3.5808131438893757`*^9, 
   3.5808131459797897`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.416023799999999999155164687181240879`5.639718089851091", ",", "Null"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.5857641240336266`*^9, 3.585764861433803*^9, 
  3.5857649202311664`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"111", ",", "2", ",", "7"}], "}"}]], "Output",
 CellChangeTimes->{3.5857641240336266`*^9, 3.585764861433803*^9, 
  3.5857649202331667`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"burnin", "=", 
  RowBox[{"-", 
   RowBox[{"Floor", "[", 
    RowBox[{"3", " ", 
     RowBox[{
      RowBox[{"Length", "[", "rescold0", "]"}], "/", "6"}]}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"thin", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"1", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
    RowBox[{"rescold", "=", 
     RowBox[{"Join", "@@", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"rescold0", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"burnin", ";;", ";;", "thin"}], ",", "i"}], "]"}], "]"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", 
          RowBox[{
           RowBox[{"Dimensions", "[", "rescold0", "]"}], "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], "]"}]}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"rescold", "=", 
      RowBox[{"rescold0", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"burnin", ";;", ";;", "thin"}], ",", "1"}], "]"}], "]"}]}], 
     ";"}]}], "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"rescold", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "3", ",", 
      RowBox[{";;", "3"}]}], "]"}], "]"}], "/=", "popunit"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"rescold", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "4", ",", "All", ",", "2"}], "]"}], "]"}], "=", 
    RowBox[{"Map", "[", 
     RowBox[{"tocoalescenttree", ",", 
      RowBox[{"rescold", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "4", ",", "All", ",", "2"}], "]"}], "]"}], ",", 
      RowBox[{"{", "2", "}"}]}], "]"}]}], ";"}], "//", 
  "Timing"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", "rescold", "]"}]}], "Input",
 CellChangeTimes->{{3.556092238461794*^9, 3.5560922390538273`*^9}, 
   3.5567076494125223`*^9, {3.574736329643902*^9, 3.574736344151927*^9}, {
   3.574806385744649*^9, 3.5748064054630833`*^9}, {3.5748064493927603`*^9, 
   3.574806453854368*^9}, {3.574806498049246*^9, 3.574806499000848*^9}, {
   3.574850446684441*^9, 3.5748504488528447`*^9}, 3.5748977017269163`*^9, {
   3.574898451802144*^9, 3.5748984522701445`*^9}, 3.574900567257779*^9, 
   3.5749025239680786`*^9, 3.5749121427296*^9, {3.5749357821161966`*^9, 
   3.5749358006802297`*^9}, {3.574978043003104*^9, 3.574978075747562*^9}, {
   3.574981229659938*^9, 3.574981230330739*^9}, 3.5750103189555407`*^9, {
   3.5750104175519123`*^9, 3.575010417817113*^9}, {3.5750104517627726`*^9, 
   3.575010454430377*^9}, {3.575010802248588*^9, 3.5750108025293884`*^9}, {
   3.5750117877944083`*^9, 3.5750117900720124`*^9}, {3.5750266897978144`*^9, 
   3.575026714898258*^9}, 3.5750267962836013`*^9, 3.5750371791056404`*^9, {
   3.5750372687433977`*^9, 3.5750372704906015`*^9}, 3.575040315535284*^9, 
   3.575040468631482*^9, 3.5750407845354366`*^9, {3.5750695466762257`*^9, 
   3.575069547066227*^9}, {3.575151291183571*^9, 3.5751512918075724`*^9}, {
   3.575151611408393*^9, 3.575151629722825*^9}, 3.5751525615219088`*^9, 
   3.575155430771595*^9, 3.5751564093957562`*^9, {3.575157062328421*^9, 
   3.5751570626560216`*^9}, {3.5751573563625402`*^9, 3.5751573623841505`*^9}, 
   3.575161914554966*^9, 3.575162809403738*^9, 3.5751636932495985`*^9, 
   3.5751646688194733`*^9, {3.575165511228011*^9, 3.5751655132872148`*^9}, {
   3.5751664073604193`*^9, 3.575166408093621*^9}, 3.5751745073605366`*^9, {
   3.575194146313373*^9, 3.575194146750174*^9}, 3.5751942090878835`*^9, {
   3.5751951902028413`*^9, 3.575195210482877*^9}, 3.5751957858732977`*^9, {
   3.5752017590219393`*^9, 3.575201779677676*^9}, 3.5752040757283573`*^9, 
   3.575206573299382*^9, {3.5752472211855655`*^9, 3.575247221559966*^9}, 
   3.5752472913388886`*^9, {3.575252650558566*^9, 3.5752526815090203`*^9}, {
   3.5752731253985567`*^9, 3.575273135507375*^9}, {3.575275201800212*^9, 
   3.575275230863063*^9}, 3.5752834417195644`*^9, 3.57528511162533*^9, 
   3.5752852146781597`*^9, {3.575293076780427*^9, 3.5752930771704283`*^9}, {
   3.575293891747316*^9, 3.5752938920593166`*^9}, {3.575343554833084*^9, 
   3.5753435673583083`*^9}, {3.575361011217823*^9, 3.5753610117403307`*^9}, 
   3.57536136464445*^9, {3.5753642582353067`*^9, 3.575364259327308*^9}, {
   3.575367039279234*^9, 3.5753670404804363`*^9}, {3.575370162737319*^9, 
   3.5753701647341228`*^9}, 3.575379508376673*^9, {3.5778837630965185`*^9, 
   3.5778837787589464`*^9}, 3.5778840496232224`*^9, 3.5778847422899942`*^9, 
   3.577884915101878*^9, 3.5778870628127203`*^9, {3.5778920347781005`*^9, 
   3.5778920352641287`*^9}, {3.577892286076474*^9, 3.577892290757742*^9}, {
   3.577898004675559*^9, 3.577898022784595*^9}, {3.578115432310463*^9, 
   3.578115432606863*^9}, {3.578123493429289*^9, 3.5781234936788898`*^9}, {
   3.579576100130876*^9, 3.5795761038904824`*^9}, {3.579576304806436*^9, 
   3.579576367300146*^9}, {3.579576537730445*^9, 3.57957654055405*^9}, {
   3.5796687868632636`*^9, 3.5796687889380674`*^9}, {3.579768646591541*^9, 
   3.5797686480891438`*^9}, {3.5797688463498917`*^9, 3.579768848424695*^9}, {
   3.579854024585827*^9, 3.579854024960227*^9}, {3.5799252947362833`*^9, 
   3.5799252978718886`*^9}, {3.579925609498036*^9, 3.5799256112452393`*^9}, {
   3.580025584402134*^9, 3.5800255846673346`*^9}, {3.5801440000347924`*^9, 
   3.5801440007367935`*^9}, {3.580144111749194*^9, 3.5801441133247967`*^9}, {
   3.580812231681237*^9, 3.580812233631487*^9}, {3.580812356004375*^9, 
   3.5808123610278006`*^9}, {3.580972589874859*^9, 3.580972637658272*^9}, {
   3.5810758633427277`*^9, 3.581075869161538*^9}, {3.5813928269698772`*^9, 
   3.58139282859228*^9}, {3.581392878746368*^9, 3.5813928807743716`*^9}, {
   3.5814874187350817`*^9, 3.581487420965886*^9}, {3.5814875222256637`*^9, 
   3.581487525142869*^9}, {3.5815692348558774`*^9, 3.581569285306366*^9}, {
   3.581652840198206*^9, 3.5816528419922085`*^9}, {3.581652991315671*^9, 
   3.581652992704074*^9}, {3.581738638180995*^9, 3.5817386396941977`*^9}, {
   3.5817692945735817`*^9, 3.581769295883984*^9}, {3.581822763770855*^9, 
   3.581822765018857*^9}, {3.5818472023380566`*^9, 3.581847217438883*^9}, {
   3.581926750567235*^9, 3.581926751097642*^9}, {3.5819271825712395`*^9, 
   3.581927183850456*^9}, {3.5819984090580726`*^9, 3.581998410789695*^9}, {
   3.581998485701855*^9, 3.581998487558279*^9}, {3.581998534873686*^9, 
   3.5819985361529016`*^9}, {3.5819986360409822`*^9, 3.581998636774192*^9}, {
   3.5820972704522595`*^9, 3.582097271856262*^9}, {3.582099723396566*^9, 
   3.582099724613368*^9}, {3.5821751954043765`*^9, 3.582175198337214*^9}, {
   3.5821752819854865`*^9, 3.5821752835455065`*^9}, {3.582175453010479*^9, 
   3.5821754547733016`*^9}, {3.5824330654337583`*^9, 3.582433067056161*^9}, {
   3.582433122732659*^9, 3.582433124417462*^9}, {3.585762624618865*^9, 
   3.585762625107893*^9}, {3.5857627081506424`*^9, 3.585762713994977*^9}, {
   3.58576331792752*^9, 3.585763318208536*^9}}],

Cell[BoxData[
 RowBox[{"-", "55"}]], "Output",
 CellChangeTimes->{3.5857641240816293`*^9, 3.5857648614648046`*^9, 
  3.5857649202441673`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.15600100000000000077804429565730970353`5.21372729556415", ",", "Null"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.5857641240816293`*^9, 3.5857648614648046`*^9, 
  3.5857649204091763`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"110", ",", "7"}], "}"}]], "Output",
 CellChangeTimes->{3.5857641240816293`*^9, 3.5857648614648046`*^9, 
  3.5857649204181767`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**"}], "******)"}]], "Input",
 CellChangeTimes->{{3.534030002656375*^9, 3.5340300076951838`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"temp", "=", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"#", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "}"}], ",", 
         RowBox[{"Log", "[", 
          RowBox[{"#", "[", 
           RowBox[{"[", "3", "]"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"Log", "[", 
           RowBox[{"N", "[", 
            RowBox[{"Length", "[", 
             RowBox[{"#", "[", 
              RowBox[{"[", "4", "]"}], "]"}], "]"}], "]"}], "]"}], "}"}]}], 
        "]"}], "&"}], ",", "rescold0", ",", 
      RowBox[{"{", "2", "}"}]}], "]"}]}], ";"}], "//", 
  "Timing"}], "\[IndentingNewLine]", 
 RowBox[{"MCMCDiagostic", "[", 
  RowBox[{
   RowBox[{"temp", "[", 
    RowBox[{"[", 
     RowBox[{
      RowBox[{"2", " ", "burnin"}], ";;", ";;", "thin"}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "\"\<logl\>\"", ",", "\"\<theta\>\"", ",", "\"\<epsilon\>\"", ",", 
     "\"\<rho\>\"", ",", "\"\<#cp\>\""}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.537539723645381*^9, 3.537539804016722*^9}, {
  3.53810667321906*^9, 3.538106690067089*^9}, {3.548829519333871*^9, 
  3.548829521034274*^9}, {3.5528205850447664`*^9, 3.552820591954378*^9}, {
  3.5528206658750057`*^9, 3.5528206663050065`*^9}, {3.5528250039953594`*^9, 
  3.5528250346650133`*^9}, {3.5752018642610245`*^9, 3.575201878940651*^9}, {
  3.5778837834545546`*^9, 3.577883783828955*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.`", ",", "Null"}], "}"}]], "Output",
 CellChangeTimes->{3.5857641243186426`*^9, 3.585764861867828*^9, 
  3.585764920435178*^9}],

Cell[CellGroupData[{

Cell[BoxData["\<\"-----------------------Start----------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.5857641243206425`*^9, 3.5857648618748283`*^9, 
  3.5857649204371777`*^9}],

Cell[BoxData["\<\"Geweke Convergence Diagnositics for the 2nd half \
chains:\"\>"], "Print",
 CellChangeTimes->{3.5857641243206425`*^9, 3.5857648618748283`*^9, 
  3.585764920438178*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Chain 1: \\n\"\>", "\[InvisibleSpace]", 
   TagBox[
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"logl\"\>",
         HoldForm], 
        TagBox["\<\"theta\"\>",
         HoldForm], 
        TagBox["\<\"epsilon\"\>",
         HoldForm], 
        TagBox["\<\"rho\"\>",
         HoldForm], 
        TagBox["\<\"#cp\"\>",
         HoldForm]},
       {
        TagBox["\<\"Z-Score\"\>",
         HoldForm], 
        RowBox[{"-", "2.3346472440104855`"}], "2.2433957194166068`", 
        RowBox[{"-", "1.1645551708990394`"}], "2.3299376662849056`", 
        "1.8920186207636305`"},
       {
        TagBox["\<\"P-Value\"\>",
         HoldForm], "0.01956185635549255`", "0.024871307686725116`", 
        "0.24419909880906365`", "0.01980944587961799`", 
        "0.058488499868131635`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[2.0999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
    Function[BoxForm`e$, 
     TableForm[
     BoxForm`e$, 
      TableHeadings -> {{"Z-Score", "P-Value"}, {
        "logl", "theta", "epsilon", "rho", "#cp"}}]]]}],
  SequenceForm["Chain 1: \n", 
   TableForm[{{-2.3346472440104855`, 
    2.2433957194166068`, -1.1645551708990394`, 2.3299376662849056`, 
    1.8920186207636305`}, {0.01956185635549255, 0.024871307686725116`, 
    0.24419909880906365`, 0.01980944587961799, 0.058488499868131635`}}, 
    TableHeadings -> {{"Z-Score", "P-Value"}, {
      "logl", "theta", "epsilon", "rho", "#cp"}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.5857641243206425`*^9, 3.5857648618748283`*^9, 
  3.585764920440178*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Chain 2: \\n\"\>", "\[InvisibleSpace]", 
   TagBox[
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"logl\"\>",
         HoldForm], 
        TagBox["\<\"theta\"\>",
         HoldForm], 
        TagBox["\<\"epsilon\"\>",
         HoldForm], 
        TagBox["\<\"rho\"\>",
         HoldForm], 
        TagBox["\<\"#cp\"\>",
         HoldForm]},
       {
        TagBox["\<\"Z-Score\"\>",
         HoldForm], 
        RowBox[{"-", "1.276569119620956`"}], "1.7331890911161667`", 
        "0.7142724932939257`", "1.359628504910561`", "1.3091251868226303`"},
       {
        TagBox["\<\"P-Value\"\>",
         HoldForm], "0.20175440987184032`", "0.08306206532433959`", 
        "0.4750586977171633`", "0.17394751305924686`", "0.1904919488246666`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[2.0999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
    Function[BoxForm`e$, 
     TableForm[
     BoxForm`e$, 
      TableHeadings -> {{"Z-Score", "P-Value"}, {
        "logl", "theta", "epsilon", "rho", "#cp"}}]]]}],
  SequenceForm["Chain 2: \n", 
   TableForm[{{-1.276569119620956, 1.7331890911161667`, 0.7142724932939257, 
    1.359628504910561, 1.3091251868226303`}, {0.20175440987184032`, 
    0.08306206532433959, 0.4750586977171633, 0.17394751305924686`, 
    0.1904919488246666}}, 
    TableHeadings -> {{"Z-Score", "P-Value"}, {
      "logl", "theta", "epsilon", "rho", "#cp"}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.5857641243206425`*^9, 3.5857648618748283`*^9, 
  3.585764920443178*^9}],

Cell[BoxData["\<\"--------------------------------------------------------\"\>\
"], "Print",
 CellChangeTimes->{3.5857641243206425`*^9, 3.5857648618748283`*^9, 
  3.5857649204451785`*^9}],

Cell[BoxData["\<\"Brooks, Gelman, and Rubin Convergence Diagnositics:\"\>"], \
"Print",
 CellChangeTimes->{3.5857641243206425`*^9, 3.5857648618748283`*^9, 
  3.585764920447179*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Potential Scale Reduction Factors for the 2nd half \
chains:\\n\"\>", "\[InvisibleSpace]", 
   TagBox[
    TagBox[GridBox[{
       {
        StyleBox["\[Null]",
         ShowStringCharacters->False], 
        TagBox["\<\"logl\"\>",
         HoldForm], 
        TagBox["\<\"theta\"\>",
         HoldForm], 
        TagBox["\<\"epsilon\"\>",
         HoldForm], 
        TagBox["\<\"rho\"\>",
         HoldForm], 
        TagBox["\<\"#cp\"\>",
         HoldForm]},
       {
        TagBox["\<\"PSRF\"\>",
         HoldForm], "0.9911240130521386`", "1.0123950000501873`", 
        "1.006948719100542`", "1.0040453112978898`", "1.0002622267826329`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxDividers->{
       "Columns" -> {False, True, {False}, False}, "ColumnsIndexed" -> {}, 
        "Rows" -> {False, True, {False}, False}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[2.0999999999999996`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     {OutputFormsDump`HeadedRows, OutputFormsDump`HeadedColumns}],
    Function[BoxForm`e$, 
     TableForm[
     BoxForm`e$, 
      TableHeadings -> {{"PSRF"}, {
        "logl", "theta", "epsilon", "rho", "#cp"}}]]]}],
  SequenceForm["Potential Scale Reduction Factors for the 2nd half chains:\n", 
   TableForm[{{0.9911240130521386, 1.0123950000501873`, 1.006948719100542, 
    1.0040453112978898`, 1.0002622267826329`}}, 
    TableHeadings -> {{"PSRF"}, {"logl", "theta", "epsilon", "rho", "#cp"}}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.5857641243206425`*^9, 3.5857648618748283`*^9, 
  3.585764920450179*^9}],

Cell[BoxData["\<\"Trace plot of PSRF:\"\>"], "Print",
 CellChangeTimes->{3.5857641243206425`*^9, 3.5857648618748283`*^9, 
  3.585764920452179*^9}],

Cell[BoxData[
 GraphicsBox[{InsetBox[
    GraphicsBox[{{}, {{}, {}, 
       {RGBColor[0.24720000000000014`, 0.24, 0.6], Thickness[Large], 
        LineBox[{{0.9823670983191616, 0.9906448705783807}, {
         1.0876984435261963`, 1.065380106874099}, {0.9811859284209692, 
         1.027235956863382}, {0.9854758557312072, 0.9973145124422098}, {
         0.9799256756869467, 0.9936242840970759}}]}}, {}},
     AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
     Axes->True,
     AxesOrigin->{0.9799256756869467, 0.9906448705783807},
     DisplayFunction:>$DisplayFunction,
     FormatType->TraditionalForm,
     Frame->True,
     FrameLabel->{{
        FormBox["\"psrf\"", TraditionalForm], None}, {
        FormBox["\"iteration\"", TraditionalForm], None}},
     GridLines->Automatic,
     Method->{},
     PlotRange->{All, All},
     PlotRangeClipping->True,
     PlotRangePadding->{Automatic, Automatic}], {-1, -0.6180339887498948}, {
    Left, Bottom}, {2, 1.2360679774997896`}], GraphicsGroupBox[{
     {GrayLevel[0], 
      RectangleBox[{1.1500000000000001`, -0.25}, \
{1.9500000000000002`, 0.07380952380952381}]}, 
     {GrayLevel[1], EdgeForm[{GrayLevel[0], Thickness[0.001]}], 
      GraphicsGroupBox[{
        RectangleBox[{1.1, -0.2}, \
{1.9000000000000001`, 0.12380952380952381`}], InsetBox[
         GraphicsBox[{{InsetBox[
             GraphicsBox[{
               {Hue[0.67, 0.6, 0.6], Thickness[Large], 
                LineBox[{{0, 0.5}, {1, 0.5}}]}, {}},
              PlotRange->{{0, 1}, {0, 1}}], {0.08, 0.08}, {
             Left, Bottom}, {1, 1}], 
            InsetBox["\<\"logl\"\>", {1.2100000000000002`, 0.58}, {-1, 0}, 
             Automatic, {1, 0}]}, {}},
          AspectRatio->0.40476190476190477`,
          FormatType->TraditionalForm,
          PlotRange->{{-0.1, 3.26}, {-0.1, 1.26}}], {1.1, -0.2}, {
         Left, Bottom}, {0.8, 0.3238095238095238}]}]}}]},
  AspectRatio->Automatic,
  Background->None,
  ColorOutput->Automatic,
  ImageSize->600,
  PlotRange->All]], "Print",
 CellChangeTimes->{3.5857641243206425`*^9, 3.5857648618748283`*^9, 
  3.585764921435235*^9}],

Cell[BoxData["\<\"----------------------The \
End--------------------------\"\>"], "Print",
 CellChangeTimes->{3.5857641243206425`*^9, 3.5857648618748283`*^9, 
  3.585764921447236*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"thick", "=", "Thick"}]], "Input"],

Cell[BoxData[
 RowBox[{"Thickness", "[", "Large", "]"}]], "Output",
 CellChangeTimes->{3.5857641263977613`*^9, 3.5857648637509356`*^9, 
  3.5857649214772377`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"linethick", "=", "0.003"}], ";"}]], "Input",
 CellChangeTimes->{3.541331964676144*^9, 3.5560883532483153`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"linegray", "=", 
   RowBox[{"GrayLevel", "[", "0.65", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5567006708687696`*^9, 3.5567006738483753`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"linestyle", "=", 
  RowBox[{"{", 
   RowBox[{"Black", ",", "Thick"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.5560911574709644`*^9, 3.5560911678965607`*^9}, {
   3.556091304633382*^9, 3.556091308759618*^9}, {3.5560917555501723`*^9, 
   3.5560917562992153`*^9}, {3.556092174641143*^9, 3.5560921926201715`*^9}, {
   3.556100460405176*^9, 3.556100465382461*^9}, {3.5561033528786163`*^9, 
   3.556103364684292*^9}, {3.5561034751266084`*^9, 3.5561034770007153`*^9}, 
   3.556267935345456*^9, 3.5562696736763115`*^9, {3.5567076622221518`*^9, 
   3.5567076754132776`*^9}, 3.5571177512714767`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"GrayLevel", "[", "0", "]"}], ",", 
   RowBox[{"Thickness", "[", "Large", "]"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5857641264597654`*^9, 3.585764863790938*^9, 
  3.585764921501239*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**"}], "******)"}]], "Input",
 CellChangeTimes->{{3.534030002656375*^9, 3.5340300076951838`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GraphicsRow", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ListLinePlot", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"rescold0", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{";;", ";;", "5"}], ",", "All", ",", "2"}], "]"}], "]"}], 
        "]"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Blue", ",", "Red"}], "}"}]}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], ",", 
     RowBox[{"ListLinePlot", "[", 
      RowBox[{
       RowBox[{"Flatten", "[", 
        RowBox[{"Transpose", "[", 
         RowBox[{"rescold0", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{";;", ";;", "5"}], ",", "All", ",", "2"}], "]"}], "]"}], 
         "]"}], "]"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], "}"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "600"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.550961277312076*^9, 3.5509612873116937`*^9}, {
  3.5510448598678684`*^9, 3.551044867511882*^9}, {3.5528207365219193`*^9, 
  3.5528207743361845`*^9}, {3.5749155554500017`*^9, 3.574915581470847*^9}, {
  3.5749451635571537`*^9, 3.5749451770979776`*^9}, {3.575037245967358*^9, 
  3.5750372740630074`*^9}, {3.5778929122892914`*^9, 3.577892920771776*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{{}, {{}, {}, 
        {RGBColor[0, 0, 1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQB2IQDQEf7BlQgQMfl8K3p2HLDkC4HA7fTuqcadFZDOUL
OFSciHRfw7YAyhdxuNDyd+P/p7OhfAmHRymM9S/rYfIyDuYWoR94n8yA8hUc
xJOd5blDYOqVHORL9G8JpU+F8lUcHvTKL53jDuOrOSzYbKj/oHoalK/h8KHc
9qEgC0xey+HTdeb01i8weR0Hf/uuWRZcMPP1HGqUVVqqE6dA+QYOdU7ZS34L
wtQbOljk8fXHR8LkjRy8Ph925P0+Gco3dnixaJHInQaYehOHUOeqiK+WMPWm
Dq4GE2dMKISpN3No0J+7Vm4fTN7c4ZzJvij2rMkHANbbZnI=
          "]]}, 
        {RGBColor[1, 0, 0], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQB2IQDQEf7BlQgUOeuDrjk+wNByBcDocnE2ezz85YB+UL
OFgZu87k9VgA5Ys4uLQu0WaMWgblSzg8EOY423dzFpQv45DZdGaKzPu5UL6C
g3mYynu5+1OgfCUH2RMlOVe8p0L5Kg6N5numyc6cAeWrOfxapyX/P3s6lK/h
sGhFedashzB5LQehy2vjfn+G6ddx4JwYk7Rm+2QoX8/B+sn1Pem5ML6Bg+qh
Xze2K8PUGzpsZhIwkOOC8Y0c0lQ4Xx28AVNv7LDXW/vby6SZUL6Jw0Kdacfj
TsDkTR3a19av8q6D8c0c+D75pZ7/OwnKN3f4sf6nUeSfSQcAaUlrMw==
          "]]}}, {}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      Axes->True,
      AxesLabel->{None, None},
      AxesOrigin->{1., -4203.890642588825},
      Method->{},
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {192., -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[{{}, {{}, {}, 
        {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQA2IQDQEf7BlQgQMfl8K3p2HLDkC4HA7fTuqcadFZDOUL
OFSciHRfw7YAyhdxuNDyd+P/p7OhfAmHRymM9S/rYfIyDuYWoR94n8yA8hUc
xJOd5blDYOqVHORL9G8JpU+F8lUcHvTKL53jDuOrOSzYbKj/oHoalK/h8KHc
9qEgC0xey+HTdeb01i8weR0Hf/uuWRZcMPP1HGqUVVqqE6dA+QYOdU7ZS34L
wtQbOljk8fXHR8LkjRy8Ph925P0+Gco3dnixaJHInQaYehOHUOeqiK+WMPWm
Dq4GE2dMKISpN3No0J+7Vm4fTN7c4ZzJvij2LJi8hQNqcFs65ImrMz7J3gCV
t3J4MnE2++yMdVC+tYOVsetMXg9YeNo4uLQu0WaMWgbl2zo8EOY423dzFpRv
55DZdGaKzPu5UL69g3mYynu5+zD3ODjInijJueINDb8GB4dG8z3TZGfC4sfR
4dc6Lfn/2dOh8o4Oi1aUZ816CJN3chC6vDbu92eYficHzokxSWu2w/zn7GD9
5Pqe9Fwov8HZQfXQrxvblWHx5eKwmUnAQI4Lpt/FIU2F89XBGzD9rg57vbW/
vUyaCZV3dVioM+143AmYvJtD+9r6Vd51MPPdHPg++aWe/zsJKu/u8GP9T6PI
P5MOAADac9Uh
          "]]}}, {}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      Axes->True,
      AxesLabel->{None, None},
      AxesOrigin->{1., -4203.890642588825},
      Method->{},
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {576., -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}]}, {}},
  ContentSelectable->True,
  ImageSize->600,
  PlotRangePadding->{6, 5}]], "Output",
 CellChangeTimes->{3.585764126527769*^9, 3.585764863859942*^9, 
  3.5857649215392413`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
  "******)"}]], "Input",
 CellChangeTimes->{{3.4940977943255997`*^9, 3.494097801075859*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"ls", "=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Length", "[", "#", "]"}], "&"}], ",", 
     RowBox[{"rescold0", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{";;", ";;", "5"}], ",", "All", ",", "4"}], "]"}], "]"}], ",", 
     RowBox[{"{", "2", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Join", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"ListLogPlot", "[", 
     RowBox[{
      RowBox[{"Transpose", "[", "ls", "]"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Blue", ",", "Red"}], "}"}]}]}], "]"}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"ListLogPlot", "[", 
      RowBox[{
       RowBox[{"ls", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{";;", ";;", "1"}], ",", "i"}], "]"}], "]"}], ",", 
       RowBox[{"Joined", "\[Rule]", "True"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"All", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Min", "[", "ls", "]"}], ",", 
            RowBox[{"1.1", 
             RowBox[{"Max", "[", "ls", "]"}]}]}], "}"}]}], "}"}]}]}], "]"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       RowBox[{
        RowBox[{"Dimensions", "[", "ls", "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], "]"}]}], 
  "\[IndentingNewLine]", "]"}]}], "Input",
 CellChangeTimes->{{3.575011246911769*^9, 3.575011266848604*^9}, {
  3.57501129887646*^9, 3.5750115135172377`*^9}, {3.5750130136595783`*^9, 
  3.575013016841984*^9}, {3.5751548622410564`*^9, 3.575154868871068*^9}, {
  3.575154941645196*^9, 3.5751549420039964`*^9}, {3.575161027989809*^9, 
  3.57516102850461*^9}, {3.575168993162408*^9, 3.575168996937615*^9}, {
  3.575175889402208*^9, 3.5751758955330186`*^9}, {3.577892418202031*^9, 
  3.5778924350059924`*^9}, {3.5778929273351517`*^9, 3.5778929279471865`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{{}, {}, 
      {RGBColor[0, 0, 1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQB2IQDQEf7MOjjNYVKfE7QAUcFB3TO0v/CUD5HA7Fq63t
Ny2C8QUc5P+dPW3xgQvKF3HIcZqwl28hH5Qv4WAf/iXGT1oQypdx+Ma7s/GP
KQ+Ur+Cga6sXsv8ZL5Sv5GDc+/a74wFOKF8Fja+GxtdwaJuYbVUtzw7lazko
e027FrUC5h4dh8//dkU2scPcq+cg7+FrKbaKFco3QHO/ocPEx8XVTt9h5hk5
BPYYarO0skD5xg5R2hM9zlVwQ/kmDjqbWdjM+mDqTdHMN3M4cdS2vGQXB5Rv
7vDe8tc/Jz02BwAxHVSQ
        "]]}, 
      {RGBColor[1, 0, 0], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQB2IQDQEf7JecXFzGXcLnABVwsA//EuMnLQjlczjo2uqF
7H/GC+ULOPAWGVlfboLxRRzCo4zWFSnxQ/kSDnuPW73TeMwD5cs4FK+2tt+0
SADKV3B4b/nrn5MeG5Sv5PBh88W/taKcUL4KmvlqDhd3XP1y4wc3lK/hsMLx
8NFjkjB5LTT9Omjm6zkE9hhqs7SyQPkGDhNamHfcj+WC8g0d2iZmW1XLs0P5
Rmj6jR2u8XZk/PSD2WfiUFX/62D2Kpi8qYO8h6+l2CpWKN/Mwce8fvtjPWYo
39xBLHTr7o3ZTA4A0l5YEg==
        "]]}}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{None, None},
    AxesOrigin->{0., 2.302585092994046},
    CoordinatesToolOptions:>{"DisplayFunction" -> ({
        Part[#, 1], 
        Exp[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        Part[#, 1], 
        Exp[
         Part[#, 2]]}& )},
    FrameTicks->{{{{2.302585092994046, 
         FormBox["10", TraditionalForm]}, {4.605170185988092, 
         FormBox["100", TraditionalForm]}, {3.912023005428146, 
         FormBox["50", TraditionalForm]}, {6.214608098422191, 
         FormBox["500", TraditionalForm]}, {2.995732273553991, 
         FormBox["20", TraditionalForm]}, {5.298317366548036, 
         FormBox["200", TraditionalForm]}, {3.4011973816621555`, 
         FormBox["30", TraditionalForm]}, {5.703782474656201, 
         FormBox["300", TraditionalForm]}, {2.70805020110221, 
         FormBox["15", TraditionalForm]}, {5.0106352940962555`, 
         FormBox["150", TraditionalForm]}, {4.248495242049359, 
         FormBox["70", TraditionalForm]}, {6.551080335043404, 
         FormBox["700", TraditionalForm]}, {2.3978952727983707`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.4849066497880004`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.5649493574615367`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.6390573296152584`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.772588722239781, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.833213344056216, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.8903717578961645`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.9444389791664403`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {3.6888794541139363`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.0943445622221, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.382026634673881, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.499809670330265, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.700480365792417, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.787491742782046, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.867534450455582, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.941642422609304, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.075173815233827, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.135798437050262, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.19295685089021, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.247024072160486, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.991464547107982, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {6.396929655216146, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}}, {{2.302585092994046, 
         FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
         FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
         FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
         FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
         FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
         FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
         FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
         FormBox["\"\"", TraditionalForm]}, {2.70805020110221, 
         FormBox["\"\"", TraditionalForm]}, {5.0106352940962555`, 
         FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
         FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
         FormBox["\"\"", TraditionalForm]}, {2.3978952727983707`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.4849066497880004`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.5649493574615367`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.6390573296152584`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.772588722239781, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.833213344056216, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.8903717578961645`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.9444389791664403`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {3.6888794541139363`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.0943445622221, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.382026634673881, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.499809670330265, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.700480365792417, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.787491742782046, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.867534450455582, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.941642422609304, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.075173815233827, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.135798437050262, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.19295685089021, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.247024072160486, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.991464547107982, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {6.396929655216146, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}}}, {Automatic, Automatic}},
    GridLines->{None, None},
    Method->{},
    PlotRange->{{0., 23.}, {2.302585092994046, 4.276666119016055}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], {
       Scaled[0.02], 
       Scaled[0.02]}},
    Ticks->{Automatic, {{2.302585092994046, 
        FormBox["10", TraditionalForm]}, {4.605170185988092, 
        FormBox["100", TraditionalForm]}, {3.912023005428146, 
        FormBox["50", TraditionalForm]}, {6.214608098422191, 
        FormBox["500", TraditionalForm]}, {2.995732273553991, 
        FormBox["20", TraditionalForm]}, {5.298317366548036, 
        FormBox["200", TraditionalForm]}, {3.4011973816621555`, 
        FormBox["30", TraditionalForm]}, {5.703782474656201, 
        FormBox["300", TraditionalForm]}, {2.70805020110221, 
        FormBox["15", TraditionalForm]}, {5.0106352940962555`, 
        FormBox["150", TraditionalForm]}, {4.248495242049359, 
        FormBox["70", TraditionalForm]}, {6.551080335043404, 
        FormBox["700", TraditionalForm]}, {2.3978952727983707`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {2.4849066497880004`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {2.5649493574615367`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {2.6390573296152584`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {2.772588722239781, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {2.833213344056216, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {2.8903717578961645`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {2.9444389791664403`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {3.6888794541139363`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {4.0943445622221, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {4.382026634673881, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {4.499809670330265, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {4.700480365792417, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {4.787491742782046, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {4.867534450455582, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {4.941642422609304, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {5.075173815233827, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {5.135798437050262, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {5.19295685089021, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {5.247024072160486, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {5.991464547107982, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {6.396929655216146, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}}}], ",", 
   GraphicsBox[{{{}, {}, 
      {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQB2IQDQEf7MOjjNYVKfE7QAUcFB3TO0v/CUD5HA7Fq63t
Ny2C8QUc5P+dPW3xgQvKF3HIcZqwl28hH5Qv4WAf/iXGT1oQypdx+Ma7s/GP
KQ+Ur+Cga6sXsv8ZL5Sv5GDc+/a74wFOKF8Fja+GxtdwaJuYbVUtzw7lazko
e027FrUC5h4dh8//dkU2scPcq+cg7+FrKbaKFco3QHO/ocPEx8XVTt9h5hk5
BPYYarO0skD5xg5R2hM9zlVwQ/kmDjqbWdjM+mDqTdHMN3M4cdS2vGQXB5Rv
7vDe8tc/Jz02BwAxHVSQ
        "]]}}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{None, None},
    AxesOrigin->{1., 2.302585092994046},
    CoordinatesToolOptions:>{"DisplayFunction" -> ({
        Part[#, 1], 
        Exp[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        Part[#, 1], 
        Exp[
         Part[#, 2]]}& )},
    FrameTicks->{{{{2.302585092994046, 
         FormBox["10", TraditionalForm]}, {4.605170185988092, 
         FormBox["100", TraditionalForm]}, {3.912023005428146, 
         FormBox["50", TraditionalForm]}, {6.214608098422191, 
         FormBox["500", TraditionalForm]}, {2.995732273553991, 
         FormBox["20", TraditionalForm]}, {5.298317366548036, 
         FormBox["200", TraditionalForm]}, {3.4011973816621555`, 
         FormBox["30", TraditionalForm]}, {5.703782474656201, 
         FormBox["300", TraditionalForm]}, {2.70805020110221, 
         FormBox["15", TraditionalForm]}, {5.0106352940962555`, 
         FormBox["150", TraditionalForm]}, {4.248495242049359, 
         FormBox["70", TraditionalForm]}, {6.551080335043404, 
         FormBox["700", TraditionalForm]}, {2.3978952727983707`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.4849066497880004`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.5649493574615367`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.6390573296152584`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.772588722239781, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.833213344056216, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.8903717578961645`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.9444389791664403`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {3.6888794541139363`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.0943445622221, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.382026634673881, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.499809670330265, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.700480365792417, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.787491742782046, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.867534450455582, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.941642422609304, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.075173815233827, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.135798437050262, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.19295685089021, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.247024072160486, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.991464547107982, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {6.396929655216146, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}}, {{2.302585092994046, 
         FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
         FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
         FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
         FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
         FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
         FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
         FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
         FormBox["\"\"", TraditionalForm]}, {2.70805020110221, 
         FormBox["\"\"", TraditionalForm]}, {5.0106352940962555`, 
         FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
         FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
         FormBox["\"\"", TraditionalForm]}, {2.3978952727983707`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.4849066497880004`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.5649493574615367`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.6390573296152584`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.772588722239781, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.833213344056216, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.8903717578961645`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.9444389791664403`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {3.6888794541139363`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.0943445622221, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.382026634673881, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.499809670330265, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.700480365792417, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.787491742782046, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.867534450455582, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.941642422609304, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.075173815233827, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.135798437050262, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.19295685089021, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.247024072160486, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.991464547107982, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {6.396929655216146, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}}}, {Automatic, Automatic}},
    GridLines->{None, None},
    Method->{},
    PlotRange->{{1., 23.}, {2.302585092994046, 4.37197629882038}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], {None, None}},
    Ticks->{Automatic, {{2.302585092994046, 
        FormBox["10", TraditionalForm]}, {4.605170185988092, 
        FormBox["100", TraditionalForm]}, {3.912023005428146, 
        FormBox["50", TraditionalForm]}, {6.214608098422191, 
        FormBox["500", TraditionalForm]}, {2.995732273553991, 
        FormBox["20", TraditionalForm]}, {5.298317366548036, 
        FormBox["200", TraditionalForm]}, {3.4011973816621555`, 
        FormBox["30", TraditionalForm]}, {5.703782474656201, 
        FormBox["300", TraditionalForm]}, {2.70805020110221, 
        FormBox["15", TraditionalForm]}, {5.0106352940962555`, 
        FormBox["150", TraditionalForm]}, {4.248495242049359, 
        FormBox["70", TraditionalForm]}, {6.551080335043404, 
        FormBox["700", TraditionalForm]}, {2.3978952727983707`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {2.4849066497880004`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {2.5649493574615367`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {2.6390573296152584`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {2.772588722239781, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {2.833213344056216, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {2.8903717578961645`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {2.9444389791664403`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {3.6888794541139363`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {4.0943445622221, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {4.382026634673881, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {4.499809670330265, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {4.700480365792417, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {4.787491742782046, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {4.867534450455582, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {4.941642422609304, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {5.075173815233827, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {5.135798437050262, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {5.19295685089021, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {5.247024072160486, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {5.991464547107982, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {6.396929655216146, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}}}], ",", 
   GraphicsBox[{{{}, {}, 
      {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQB2IQDQEf7JecXFzGXcLnABVwsA//EuMnLQjlczjo2uqF
7H/GC+ULOPAWGVlfboLxRRzCo4zWFSnxQ/kSDnuPW73TeMwD5cs4FK+2tt+0
SADKV3B4b/nrn5MeG5Sv5PBh88W/taKcUL4KmvlqDhd3XP1y4wc3lK/hsMLx
8NFjkjB5LTT9Omjm6zkE9hhqs7SyQPkGDhNamHfcj+WC8g0d2iZmW1XLs0P5
Rmj6jR2u8XZk/PSD2WfiUFX/62D2Kpi8qYO8h6+l2CpWKN/Mwce8fvtjPWYo
39xBLHTr7o3ZTA4A0l5YEg==
        "]]}}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{None, None},
    AxesOrigin->{1., 2.302585092994046},
    CoordinatesToolOptions:>{"DisplayFunction" -> ({
        Part[#, 1], 
        Exp[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        Part[#, 1], 
        Exp[
         Part[#, 2]]}& )},
    FrameTicks->{{{{2.302585092994046, 
         FormBox["10", TraditionalForm]}, {4.605170185988092, 
         FormBox["100", TraditionalForm]}, {3.912023005428146, 
         FormBox["50", TraditionalForm]}, {6.214608098422191, 
         FormBox["500", TraditionalForm]}, {2.995732273553991, 
         FormBox["20", TraditionalForm]}, {5.298317366548036, 
         FormBox["200", TraditionalForm]}, {3.4011973816621555`, 
         FormBox["30", TraditionalForm]}, {5.703782474656201, 
         FormBox["300", TraditionalForm]}, {2.70805020110221, 
         FormBox["15", TraditionalForm]}, {5.0106352940962555`, 
         FormBox["150", TraditionalForm]}, {4.248495242049359, 
         FormBox["70", TraditionalForm]}, {6.551080335043404, 
         FormBox["700", TraditionalForm]}, {2.3978952727983707`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.4849066497880004`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.5649493574615367`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.6390573296152584`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.772588722239781, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.833213344056216, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.8903717578961645`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.9444389791664403`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {3.6888794541139363`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.0943445622221, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.382026634673881, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.499809670330265, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.700480365792417, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.787491742782046, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.867534450455582, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.941642422609304, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.075173815233827, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.135798437050262, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.19295685089021, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.247024072160486, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.991464547107982, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {6.396929655216146, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}}, {{2.302585092994046, 
         FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
         FormBox["\"\"", TraditionalForm]}, {3.912023005428146, 
         FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
         FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
         FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
         FormBox["\"\"", TraditionalForm]}, {3.4011973816621555`, 
         FormBox["\"\"", TraditionalForm]}, {5.703782474656201, 
         FormBox["\"\"", TraditionalForm]}, {2.70805020110221, 
         FormBox["\"\"", TraditionalForm]}, {5.0106352940962555`, 
         FormBox["\"\"", TraditionalForm]}, {4.248495242049359, 
         FormBox["\"\"", TraditionalForm]}, {6.551080335043404, 
         FormBox["\"\"", TraditionalForm]}, {2.3978952727983707`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.4849066497880004`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.5649493574615367`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.6390573296152584`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.772588722239781, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.833213344056216, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.8903717578961645`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {2.9444389791664403`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {3.6888794541139363`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.0943445622221, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.382026634673881, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.499809670330265, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.700480365792417, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.787491742782046, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.867534450455582, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {4.941642422609304, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.075173815233827, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.135798437050262, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.19295685089021, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.247024072160486, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {5.991464547107982, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {6.396929655216146, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}}}, {Automatic, Automatic}},
    GridLines->{None, None},
    Method->{},
    PlotRange->{{1., 23.}, {2.302585092994046, 4.37197629882038}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], {None, None}},
    Ticks->{Automatic, {{2.302585092994046, 
        FormBox["10", TraditionalForm]}, {4.605170185988092, 
        FormBox["100", TraditionalForm]}, {3.912023005428146, 
        FormBox["50", TraditionalForm]}, {6.214608098422191, 
        FormBox["500", TraditionalForm]}, {2.995732273553991, 
        FormBox["20", TraditionalForm]}, {5.298317366548036, 
        FormBox["200", TraditionalForm]}, {3.4011973816621555`, 
        FormBox["30", TraditionalForm]}, {5.703782474656201, 
        FormBox["300", TraditionalForm]}, {2.70805020110221, 
        FormBox["15", TraditionalForm]}, {5.0106352940962555`, 
        FormBox["150", TraditionalForm]}, {4.248495242049359, 
        FormBox["70", TraditionalForm]}, {6.551080335043404, 
        FormBox["700", TraditionalForm]}, {2.3978952727983707`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {2.4849066497880004`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {2.5649493574615367`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {2.6390573296152584`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {2.772588722239781, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {2.833213344056216, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {2.8903717578961645`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {2.9444389791664403`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {3.6888794541139363`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {4.0943445622221, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {4.382026634673881, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {4.499809670330265, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {4.700480365792417, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {4.787491742782046, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {4.867534450455582, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {4.941642422609304, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {5.075173815233827, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {5.135798437050262, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {5.19295685089021, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {5.247024072160486, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {5.991464547107982, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {6.396929655216146, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}}}]}], "}"}]], "Output",
 CellChangeTimes->{3.5857641267827835`*^9, 3.5857648641089563`*^9, 
  3.585764921682249*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"ListLogPlot", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"rescold0", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{";;", ";;", "5"}], ",", "All", ",", "3", ",", "i"}], "]"}], 
       "]"}], "]"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"Joined", "\[Rule]", "True"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Blue", ",", "Red"}], "}"}]}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.550961333409775*^9, 3.5509613467321978`*^9}, {
   3.551044835672226*^9, 3.5510448449230423`*^9}, {3.5510890079890785`*^9, 
   3.5510890328243227`*^9}, {3.574806007770585*^9, 3.574806011405391*^9}, {
   3.5749156409537516`*^9, 3.57491565702178*^9}, {3.574945235832081*^9, 
   3.574945260090123*^9}, {3.5750104050718904`*^9, 3.575010405446291*^9}, {
   3.5750108311710386`*^9, 3.5750108314362392`*^9}, {3.575011216101715*^9, 
   3.5750112164605155`*^9}, {3.5750210702700677`*^9, 
   3.5750210706444683`*^9}, {3.57504088905165*^9, 3.575040930529542*^9}, 
   3.577892404964274*^9, {3.5778929348775835`*^9, 3.577892935963646*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{{}, {}, 
      {RGBColor[0, 0, 1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQB2IQDQEf7DWsZScLfBM5ABVw+HSgPOONmQyUz4HGF3A4
qPN0pvkJSShfxKEu5GD9JHZRKF/CoXmdyJITz2HmyTi8kpN96cEBk1dw2Lbt
XtzDFAkoX8lhi8OX9dFLYepVHDbqvP844y9MvZrDdu6QKR1xMPs0HBI32sTe
TISp13LIq11z6cMtMShfx0Hy2mejNz4w9XoOG/s3PmpZIQ7lGzisOb3Lf9l1
mP2GDt5r1dnNu2HqjRw6j833P24B4xs7TAzpD+C5JAXlmzh47tb7+m01TL+p
Q+HO94wNqTD1Zg5C2cH+q6Rg6s0dgk4aNzTGSB4AAHn8aHI=
        "]]}, 
      {RGBColor[1, 0, 0], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQB2IQDQEf7G+7ftnx7rv4AaiAQ7q+cXvndSEon8Phw4ZT
+8KKYfICDqjqRRxYMlefd4gWgfIlHHr2WufWaYpC+TIOx3X3nXr3CqZewWHZ
oSUprxRg8koOx8sSkxboSED5Kg4nDpUFbIqE8dUcbtZJTL4XKAXlazistKuY
ViQOk9dyeLO6gk3SDcbXcZjAFP+oiBdmn55D4Ke5uTK9slC+gcNii85Fxkdh
8oYOO268+r+pAqbfyKF7i6bO8wSYemOHy58Wb99rD5M3cdAXtHiU/ATmHlOH
r+zCxZ9VYXwzB/EDN77enQvjmzvUpiXeuPNb/AAAKA1raw==
        "]]}}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{None, None},
    AxesOrigin->{0., -7.387803757443707},
    CoordinatesToolOptions:>{"DisplayFunction" -> ({
        Part[#, 1], 
        Exp[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        Part[#, 1], 
        Exp[
         Part[#, 2]]}& )},
    FrameTicks->{{{{-6.907755278982137, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.0010\"", 0.001, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 4}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-4.605170185988091, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.0100\"", 0.01, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 4}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-5.298317366548036, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.0050\"", 0.005, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 4}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-2.995732273553991, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.0500\"", 0.05, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 4}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-6.214608098422191, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.0020\"", 0.002, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 4}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-3.912023005428146, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.0200\"", 0.02, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 4}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-5.809142990314028, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.0030\"", 0.003, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 4}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-3.506557897319982, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.0300\"", 0.03, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 4}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-6.502290170873972, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.0015\"", 0.0015, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 4}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-4.199705077879927, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.0150\"", 0.015, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 4}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-4.961845129926823, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.0070\"", 0.007, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 4}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-2.659260036932778, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.0700\"", 0.07, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 4}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-6.812445099177812, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-6.725433722188182, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-6.6453910145146455`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-6.571283042360924, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-6.437751649736401, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-6.3771270279199666`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-6.319968614080018, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-6.2659013928097425`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-5.521460917862246, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-5.115995809754082, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.8283137373023015`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.710530701645918, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.487387150331708, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.382026634673882, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.286716454869556, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.135166556742356, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.074541934925921, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.017383521085972, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-3.9633162998156966`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-3.2188758248682006`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-2.8134107167600364`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}}, {{-6.907755278982137, 
         FormBox["\"\"", TraditionalForm]}, {-4.605170185988091, 
         FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
         FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
         FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
         FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
         FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
         FormBox["\"\"", TraditionalForm]}, {-3.506557897319982, 
         FormBox["\"\"", TraditionalForm]}, {-6.502290170873972, 
         FormBox["\"\"", TraditionalForm]}, {-4.199705077879927, 
         FormBox["\"\"", TraditionalForm]}, {-4.961845129926823, 
         FormBox["\"\"", TraditionalForm]}, {-2.659260036932778, 
         FormBox["\"\"", TraditionalForm]}, {-6.812445099177812, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-6.725433722188182, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-6.6453910145146455`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-6.571283042360924, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-6.437751649736401, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-6.3771270279199666`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-6.319968614080018, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-6.2659013928097425`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-5.521460917862246, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-5.115995809754082, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.8283137373023015`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.710530701645918, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.487387150331708, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.382026634673882, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.286716454869556, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.135166556742356, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.074541934925921, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.017383521085972, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-3.9633162998156966`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-3.2188758248682006`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-2.8134107167600364`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}}}, {Automatic, Automatic}},
    GridLines->{None, None},
    Method->{},
    PlotRange->{{0., 23.}, {-7.387803757443707, -4.7104855656615205`}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], {
       Scaled[0.02], 
       Scaled[0.02]}},
    Ticks->{Automatic, {{-6.907755278982137, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.0010\"", 0.001, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 4}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-4.605170185988091, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.0100\"", 0.01, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 4}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-5.298317366548036, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.0050\"", 0.005, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 4}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-2.995732273553991, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.0500\"", 0.05, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 4}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-6.214608098422191, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.0020\"", 0.002, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 4}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-3.912023005428146, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.0200\"", 0.02, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 4}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-5.809142990314028, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.0030\"", 0.003, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 4}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-3.506557897319982, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.0300\"", 0.03, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 4}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-6.502290170873972, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.0015\"", 0.0015, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 4}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-4.199705077879927, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.0150\"", 0.015, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 4}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-4.961845129926823, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.0070\"", 0.007, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 4}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-2.659260036932778, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.0700\"", 0.07, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 4}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-6.812445099177812, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-6.725433722188182, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-6.6453910145146455`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-6.571283042360924, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-6.437751649736401, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-6.3771270279199666`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-6.319968614080018, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-6.2659013928097425`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-5.521460917862246, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-5.115995809754082, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-4.8283137373023015`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-4.710530701645918, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-4.487387150331708, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-4.382026634673882, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-4.286716454869556, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-4.135166556742356, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-4.074541934925921, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-4.017383521085972, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-3.9633162998156966`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-3.2188758248682006`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-2.8134107167600364`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}}}], ",", 
   GraphicsBox[{{{}, {}, 
      {RGBColor[0, 0, 1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQB2IQDQEf7M+sLL/++Dv7AaiAg+3m8z/YZslB+RwO5QV2
afb7JaF8AYe+95P/cz4UgvJFHJR1Z9X//yQK5Us45D38xb3qmgiUL+Nw9Kqj
W7mmOJSv4KAfl7D0brgYlK/ksPw0n+zcnVJQvooDy+vDVTffwvhqDg/vl98r
mwnjaziIzj3CdScI5j4thyvlGe8F38PkdRx4Cnf7qmdLQ/l6Dttzgz8sE4Px
DRzefLrp1vlBFso3dPh8pq1cug+m38hh92KlS1k7YeqNHVh+S+z6IQPjmzh0
LSzqXpME45s6HF4zKzf1BYxv5nD5W/trx3YY39yhVezRtfIfkgcA1adt0g==

        "]]}, 
      {RGBColor[1, 0, 0], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQB2IQDQEf7KVFJ3+4w8J5ACrgcM3TbkmcMg+Uz+Gwy3xV
g+QPLihfwOFvfN3OL3GCUL6Iw5LLb1LW6fFB+RIO6/gPfHg+VQzKl3GYUXpm
fo+NDJSv4PD/KPODRn1JKF/JIUdZ8t2Tv1JQvoqD8O0Mg0O+0lC+msNHk7OG
0pth+jUcsu5wZjJNhslrOZxNO9VjuAWmX8dhzrPZ+S8WwOT1HHSUzopopEhA
+QYOV/QfbmOxhMkbOhzacf3lie0wvpHDr3Xp4mpxML6xwzTmev5JmjC+iUPL
3CPFwgdh7jF12NrsoCTVD+ObOZS9V7D5Hw9Tb+5gX7llwrJAqQMASnRlcA==

        "]]}}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{None, None},
    AxesOrigin->{0., -7.65041722076131},
    CoordinatesToolOptions:>{"DisplayFunction" -> ({
        Part[#, 1], 
        Exp[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        Part[#, 1], 
        Exp[
         Part[#, 2]]}& )},
    FrameTicks->{{{{-6.907755278982137, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.001\"", 0.001, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-6.214608098422191, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.002\"", 0.002, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-5.298317366548036, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.005\"", 0.005, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-4.605170185988092, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.010\"", 0.01, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-3.912023005428146, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.020\"", 0.02, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-2.995732273553991, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.050\"", 0.05, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-2.302585092994046, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.100\"", 0.1, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-1.6094379124341003`, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.200\"", 0.2, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-0.6931471805599453, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.500\"", 0.5, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-5.809142990314028, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-5.521460917862246, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-5.115995809754082, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.961845129926823, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.8283137373023015`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.710530701645918, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-3.506557897319982, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-3.2188758248682006`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-2.8134107167600364`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-2.6592600369327783`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-2.5257286443082556`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-2.4079456086518722`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-1.2039728043259361`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-0.916290731874155, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}}, {{-6.907755278982137, 
         FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
         FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
         FormBox["\"\"", TraditionalForm]}, {-4.605170185988092, 
         FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
         FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
         FormBox["\"\"", TraditionalForm]}, {-2.302585092994046, 
         FormBox["\"\"", TraditionalForm]}, {-1.6094379124341003`, 
         FormBox["\"\"", TraditionalForm]}, {-0.6931471805599453, 
         FormBox["\"\"", TraditionalForm]}, {-5.809142990314028, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-5.521460917862246, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-5.115995809754082, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.961845129926823, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.8283137373023015`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.710530701645918, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-3.506557897319982, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-3.2188758248682006`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-2.8134107167600364`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-2.6592600369327783`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-2.5257286443082556`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-2.4079456086518722`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-1.2039728043259361`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-0.916290731874155, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}}}, {Automatic, Automatic}},
    GridLines->{None, None},
    Method->{},
    PlotRange->{{0., 23.}, {-7.65041722076131, -2.9960400422471363`}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], {
       Scaled[0.02], 
       Scaled[0.02]}},
    Ticks->{Automatic, {{-6.907755278982137, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.001\"", 0.001, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-6.214608098422191, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.002\"", 0.002, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-5.298317366548036, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.005\"", 0.005, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-4.605170185988092, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.010\"", 0.01, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-3.912023005428146, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.020\"", 0.02, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-2.995732273553991, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.050\"", 0.05, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-2.302585092994046, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.100\"", 0.1, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-1.6094379124341003`, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.200\"", 0.2, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-0.6931471805599453, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.500\"", 0.5, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-5.809142990314028, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-5.521460917862246, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-5.115995809754082, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-4.961845129926823, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-4.8283137373023015`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-4.710530701645918, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-3.506557897319982, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-3.2188758248682006`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-2.8134107167600364`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-2.6592600369327783`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-2.5257286443082556`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-2.4079456086518722`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-1.2039728043259361`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-0.916290731874155, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}}}], ",", 
   GraphicsBox[{{{}, {}, 
      {RGBColor[0, 0, 1], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQB2IQDQEf7P/u2dS4JEj+AFTAIcX0j/F+SxifA40v4PDU
JeTZ71QRKF/EweW5M3eSLUxewuF5fXt2/DkpKF/GIWlnyf69s2SgfAWH0xfr
DW/lwNQrObAnGr0Nc4fJqzhkOnwou31ZDspXc+hyC6zYOk8RytdwEEqU1bnU
ogTlazksOncqd3q6ApSv48CWLDKra5YslK/n0Hzv8MyqqTB5A4d5qTuvHA2E
8Q0dzCMufbFfDDPfyEEujrV7Htx8Y4f7s/bLsBfC5E0c7q8+b3bcFqbf1GH+
LlGfgCcweTOH03zl1YocML65wwHPp+d63RUPAABqVGYO
        "]]}, 
      {RGBColor[1, 0, 0], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQB2IQDQEf7G0OfnyfGiN/ACrgcCtcOmxFIozP4fCxyeHz
6WgYX8ABVb2IQ5jrhFf5/jC+hMO8wwflvi6UhvJlHPYtbXfUmigH5Ss47H6g
N3vjKgUoX8lhqW3ctRRdmH4VhxLRGrf2Yph6NYfVf+LLw/lh6jUcdJLLpz7i
hanXcohnVfK/VwiT13E4xStjz7NZEcrXc2jUtF7RraEM5Rs4eMmqnwv9Lwvl
GzqETbe5OfkITL2Rw+mW5OvunDD1xg5LljL/UHkIs8/EwVVJWziuDyZv6mDL
YTDrc6ESlG/mMFVK4JjzOZi8uUNu/X2Gt4cUDwAA2t5hsw==
        "]]}}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{None, None},
    AxesOrigin->{0., -9.90286082216816},
    CoordinatesToolOptions:>{"DisplayFunction" -> ({
        Part[#, 1], 
        Exp[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        Part[#, 1], 
        Exp[
         Part[#, 2]]}& )},
    FrameTicks->{{{{-9.210340371976182, 
         FormBox[
          TemplateBox[{"\[Times]", "\"\[Times]\"", "1", 
            TemplateBox[{"10", 
              RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> 
             SuperscriptBox]}, "RowWithSeparators"], 
          TraditionalForm]}, {-8.517193191416238, 
         FormBox[
          TemplateBox[{"\[Times]", "\"\[Times]\"", "2", 
            TemplateBox[{"10", 
              RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> 
             SuperscriptBox]}, "RowWithSeparators"], 
          TraditionalForm]}, {-7.600902459542082, 
         FormBox[
          TemplateBox[{"\[Times]", "\"\[Times]\"", "5", 
            TemplateBox[{"10", 
              RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> 
             SuperscriptBox]}, "RowWithSeparators"], 
          TraditionalForm]}, {-6.907755278982137, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.001\"", 0.001, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-6.214608098422191, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.002\"", 0.002, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-5.298317366548036, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.005\"", 0.005, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-4.605170185988092, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.010\"", 0.01, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-3.912023005428146, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.020\"", 0.02, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-2.995732273553991, 
         FormBox[
          TagBox[
           InterpretationBox["\"0.050\"", 0.05, AutoDelete -> True], 
           NumberForm[#, {
             DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
          TraditionalForm]}, {-7.957577403480815, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-7.418580902748128, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-7.264430222920869, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-7.1308988302963465`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-7.013115794639964, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-5.809142990314028, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-5.521460917862246, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-5.115995809754082, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.961845129926823, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.8283137373023015`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.710530701645918, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-3.506557897319982, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-3.2188758248682006`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}}, {{-9.210340371976182, 
         FormBox["\"\"", TraditionalForm]}, {-8.517193191416238, 
         FormBox["\"\"", TraditionalForm]}, {-7.600902459542082, 
         FormBox["\"\"", TraditionalForm]}, {-6.907755278982137, 
         FormBox["\"\"", TraditionalForm]}, {-6.214608098422191, 
         FormBox["\"\"", TraditionalForm]}, {-5.298317366548036, 
         FormBox["\"\"", TraditionalForm]}, {-4.605170185988092, 
         FormBox["\"\"", TraditionalForm]}, {-3.912023005428146, 
         FormBox["\"\"", TraditionalForm]}, {-2.995732273553991, 
         FormBox["\"\"", TraditionalForm]}, {-7.957577403480815, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-7.418580902748128, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-7.264430222920869, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-7.1308988302963465`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-7.013115794639964, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-5.809142990314028, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-5.521460917862246, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-5.115995809754082, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.961845129926823, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.8283137373023015`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-4.710530701645918, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-3.506557897319982, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}, {-3.2188758248682006`, 
         FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
          Thickness[0.001]}}}}, {Automatic, Automatic}},
    GridLines->{None, None},
    Method->{},
    PlotRange->{{0., 23.}, {-9.90286082216816, -5.099593733685855}},
    PlotRangeClipping->True,
    PlotRangePadding->{
      Scaled[0.02], {
       Scaled[0.02], 
       Scaled[0.02]}},
    Ticks->{Automatic, {{-9.210340371976182, 
        FormBox[
         TemplateBox[{"\[Times]", "\"\[Times]\"", "1", 
           TemplateBox[{"10", 
             RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> 
            SuperscriptBox]}, "RowWithSeparators"], 
         TraditionalForm]}, {-8.517193191416238, 
        FormBox[
         TemplateBox[{"\[Times]", "\"\[Times]\"", "2", 
           TemplateBox[{"10", 
             RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> 
            SuperscriptBox]}, "RowWithSeparators"], 
         TraditionalForm]}, {-7.600902459542082, 
        FormBox[
         TemplateBox[{"\[Times]", "\"\[Times]\"", "5", 
           TemplateBox[{"10", 
             RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> 
            SuperscriptBox]}, "RowWithSeparators"], 
         TraditionalForm]}, {-6.907755278982137, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.001\"", 0.001, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-6.214608098422191, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.002\"", 0.002, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-5.298317366548036, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.005\"", 0.005, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-4.605170185988092, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.010\"", 0.01, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-3.912023005428146, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.020\"", 0.02, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-2.995732273553991, 
        FormBox[
         TagBox[
          InterpretationBox["\"0.050\"", 0.05, AutoDelete -> True], 
          NumberForm[#, {
            DirectedInfinity[1], 3}, NumberPadding -> {"", "0"}]& ], 
         TraditionalForm]}, {-7.957577403480815, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-7.418580902748128, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-7.264430222920869, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-7.1308988302963465`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-7.013115794639964, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-5.809142990314028, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-5.521460917862246, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-5.115995809754082, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-4.961845129926823, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-4.8283137373023015`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-4.710530701645918, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-3.506557897319982, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}, {-3.2188758248682006`, 
        FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
         Thickness[0.001]}}}}]}], "}"}]], "Output",
 CellChangeTimes->{3.585764127037798*^9, 3.5857648643559704`*^9, 
  3.585764921820257*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
  "******)"}]], "Input",
 CellChangeTimes->{{3.4940977943255997`*^9, 3.494097801075859*^9}}],

Cell[BoxData[{
 RowBox[{"Clear", "[", 
  RowBox[{"listmcplot", ",", "listhisplot"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"listmcplot", "[", 
     RowBox[{
     "mc_", ",", "truevalue_", ",", "lab_", ",", "withdata_", ",", 
      "opts___"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"dim", ",", "g1", ",", "g2"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"dim", "=", 
        RowBox[{"Length", "[", "lab", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"g1", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"mc", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "i"}], "]"}], "]"}], ",", 
            RowBox[{"Joined", "\[Rule]", "True"}], ",", 
            RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
            RowBox[{"AxesLabel", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"\"\<\[Times]\>\"", "<>", 
                RowBox[{"ToString", "[", "thin", "]"}], "<>", "\"\< t\>\""}], 
               ",", 
               RowBox[{"lab", "[", 
                RowBox[{"[", "i", "]"}], "]"}]}], "}"}]}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"g2", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{"0", ",", 
               RowBox[{"truevalue", "[", 
                RowBox[{"[", "i", "]"}], "]"}]}], "}"}], "}"}], ",", 
            RowBox[{"PlotMarkers", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"Automatic", ",", "15"}], "}"}]}], ",", 
            RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
            RowBox[{"PlotStyle", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"Blue", ",", "Red"}], "}"}]}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"withdata", ",", 
         RowBox[{
          RowBox[{
           RowBox[{"Show", "[", 
            RowBox[{"#", ",", "opts"}], "]"}], "&"}], "/@", 
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{"g1", ",", "g2"}], "}"}], "]"}]}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"Show", "[", 
            RowBox[{"#", ",", "opts"}], "]"}], "&"}], "/@", "g1"}]}], 
        "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"listhisplot", "[", 
    RowBox[{
    "mc_", ",", "truevalue_", ",", "lab_", ",", "withdata_", ",", "ticks_", 
     ",", "opts___"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"dim", ",", "g1", ",", "g2", ",", "g11"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"dim", "=", 
       RowBox[{"Length", "[", "lab", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"g1", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"smoothHistogram", "[", 
            RowBox[{
             RowBox[{"mc", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "i"}], "]"}], "]"}], ",", "20", ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "1"}], "}"}], ",", 
             RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
             RowBox[{"AxesOrigin", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Min", "[", 
                 RowBox[{"mc", "[", 
                  RowBox[{"[", 
                   RowBox[{"All", ",", "i"}], "]"}], "]"}], "]"}], ",", "0"}],
                "}"}]}], ",", 
             RowBox[{"AxesLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"lab", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], ",", "\"\<pdf\>\""}], 
               "}"}]}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}], ";"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"g11", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Histogram", "[", 
            RowBox[{
             RowBox[{"mc", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "i"}], "]"}], "]"}], ",", "Automatic", 
             ",", "\"\<ProbabilityDensity\>\"", ",", 
             RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
             RowBox[{"AxesLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"lab", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], ",", "\"\<pdf\>\""}], 
               "}"}]}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}], ";"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"g1", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Histogram", "[", 
          RowBox[{
           RowBox[{"mc", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "i"}], "]"}], "]"}], ",", "Automatic", ",", 
           "\"\<PDF\>\"", ",", 
           RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
           RowBox[{"Ticks", "\[Rule]", 
            RowBox[{"ticks", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}], ",", 
           RowBox[{"AxesLabel", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"lab", "[", 
               RowBox[{"[", "i", "]"}], "]"}], ",", "\"\<pdf\>\""}], 
             "}"}]}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"g2", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"ListPlot", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"truevalue", "[", 
               RowBox[{"[", "i", "]"}], "]"}], ",", "0"}], "}"}], "}"}], ",", 
           RowBox[{"PlotMarkers", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"Automatic", ",", "25"}], "}"}]}], ",", 
           RowBox[{"PlotStyle", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"Blue", ",", "Red"}], "}"}]}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "dim"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{"withdata", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"Show", "[", 
           RowBox[{"#", ",", "opts"}], "]"}], "&"}], "/@", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"g1", ",", "g2"}], "}"}], "]"}]}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"Show", "[", 
           RowBox[{"#", ",", "opts"}], "]"}], "&"}], "/@", "g1"}]}], 
       "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.477911840528593*^9, 3.477911845700468*^9}, {
   3.4869325423603935`*^9, 3.486932543735464*^9}, {3.4869344661307607`*^9, 
   3.4869344728654804`*^9}, {3.4869345236337047`*^9, 
   3.4869345239462204`*^9}, {3.4947989747497644`*^9, 3.49479897554667*^9}, {
   3.4947992861992235`*^9, 3.494799308575083*^9}, 3.494799728200571*^9, {
   3.4947998036565933`*^9, 3.49479988417531*^9}, {3.494799916535928*^9, 
   3.4947999199735594`*^9}, {3.5060919485630217`*^9, 3.506092022237726*^9}, {
   3.506092065129998*^9, 3.506092070411451*^9}, {3.5088261575526648`*^9, 
   3.5088261582546654`*^9}, {3.5088569290406647`*^9, 
   3.5088569331122723`*^9}, {3.5088620346989536`*^9, 3.5088620503613815`*^9}, 
   3.5147488339903264`*^9, {3.5147502841167536`*^9, 3.5147502855047555`*^9}, 
   3.514750319432409*^9, {3.5152908531464663`*^9, 3.5152908547864685`*^9}, 
   3.5199447326792517`*^9, 3.519946893540785*^9, {3.520702653370199*^9, 
   3.52070273943032*^9}, {3.5243211471133165`*^9, 3.524321210636628*^9}, {
   3.524323458858468*^9, 3.5243234608705835`*^9}, {3.524323578758326*^9, 
   3.524323589095917*^9}, {3.52505281158018*^9, 3.525052820560193*^9}, {
   3.5250529154103255`*^9, 3.5250529214403343`*^9}, {3.5250531603806686`*^9, 
   3.5250531644206743`*^9}, {3.525527928230873*^9, 3.5255279345002317`*^9}, {
   3.525527981708932*^9, 3.5255279858911715`*^9}, {3.5255283840709457`*^9, 
   3.52552838659309*^9}, {3.525529181307545*^9, 3.5255291865548453`*^9}, {
   3.5256380438780017`*^9, 3.52563805436122*^9}, {3.5256388272750916`*^9, 
   3.525638851938735*^9}, {3.5256561821299067`*^9, 3.525656185943288*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"truehyper", "=", 
  RowBox[{"{", 
   RowBox[{"truetheta", ",", "trueepsilon", ",", "truerho"}], 
   "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"hyperlab", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<\[Theta]\>\"", ",", "\"\<\[CurlyEpsilon]\>\"", ",", "\"\<r\>\""}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"reshyper", "=", 
   RowBox[{"rescold", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "3"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Dimensions", "[", "reshyper", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Mean", "[", "reshyper", "]"}]}], "Input",
 CellChangeTimes->{{3.4948697312973037`*^9, 3.4948697356724715`*^9}, {
  3.514742939860772*^9, 3.514742956256401*^9}, {3.5154405554624434`*^9, 
  3.51544055905045*^9}, {3.5220218211579437`*^9, 3.522021873964036*^9}, {
  3.5220221177300644`*^9, 3.5220221219888716`*^9}, {3.5220267637105*^9, 
  3.522026766658905*^9}, {3.522610179089327*^9, 3.522610180442129*^9}, {
  3.5251832753605585`*^9, 3.525183275765581*^9}, {3.526600274603387*^9, 
  3.526600276962522*^9}, {3.5271942013054476`*^9, 3.5271942013604507`*^9}, {
  3.5291578019582925`*^9, 3.5291578030970945`*^9}, {3.5291578482123737`*^9, 
  3.5291578495695763`*^9}, {3.5291585803831205`*^9, 3.5291585808199205`*^9}, {
  3.5558462196896906`*^9, 3.555846229619259*^9}, {3.5558462712616405`*^9, 
  3.5558462812822137`*^9}, {3.5558464181500425`*^9, 3.5558464230823245`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.`", ",", "1.`", ",", "0.4`"}], "}"}]], "Output",
 CellChangeTimes->{3.585764127141804*^9, 3.585764864473977*^9, 
  3.58576492186926*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"110", ",", "3"}], "}"}]], "Output",
 CellChangeTimes->{3.585764127141804*^9, 3.585764864473977*^9, 
  3.5857649218732605`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2.162735054209282`", ",", "1.1089625322581664`", ",", 
   "0.22748942824870455`"}], "}"}]], "Output",
 CellChangeTimes->{3.585764127141804*^9, 3.585764864473977*^9, 
  3.5857649218752604`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DistributionFitTest", "[", 
  RowBox[{
   RowBox[{"reshyper", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "1"}], "]"}], "]"}], ",", "thetadist"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"DistributionFitTest", "[", 
  RowBox[{
   RowBox[{"reshyper", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "2"}], "]"}], "]"}], ",", "epsdist"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"DistributionFitTest", "[", 
  RowBox[{
   RowBox[{"reshyper", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "3"}], "]"}], "]"}], ",", "rhodist"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.515427974305853*^9, 3.5154280325881863`*^9}, {
   3.5160522447486753`*^9, 3.5160522559073133`*^9}, {3.5165857232213354`*^9, 
   3.5165857250013375`*^9}, {3.5166444281920977`*^9, 3.516644429306162*^9}, {
   3.5166711600843787`*^9, 3.5166711634539847`*^9}, {3.516677300396288*^9, 
   3.516677301316289*^9}, {3.516748776026043*^9, 3.5167487774911265`*^9}, {
   3.5169375624735928`*^9, 3.5169375634035945`*^9}, {3.5169986642628546`*^9, 
   3.5169986659632573`*^9}, {3.5170724666517916`*^9, 
   3.5170724675409937`*^9}, {3.5170781226858015`*^9, 3.517078124250826*^9}, {
   3.5170833415544567`*^9, 3.517083350852073*^9}, {3.5171669439678783`*^9, 
   3.5171669452678795`*^9}, {3.5171701102590017`*^9, 3.517170111959405*^9}, {
   3.5171707762123785`*^9, 3.517170784901594*^9}, {3.517170973771126*^9, 
   3.5171709742235265`*^9}, {3.5171710412568445`*^9, 
   3.5171710677612906`*^9}, {3.5171734240037146`*^9, 3.517173426792874*^9}, 
   3.518652980951659*^9, {3.518705384965176*^9, 3.5187053867747793`*^9}, {
   3.519266934475832*^9, 3.519266935801834*^9}, {3.5196847832110186`*^9, 
   3.5196847878286266`*^9}, {3.519687612709898*^9, 3.5196876177331066`*^9}, {
   3.519689698310865*^9, 3.5196897054868774`*^9}, {3.5198370758493667`*^9, 
   3.51983707767457*^9}, {3.51985785681418*^9, 3.5198578590137835`*^9}, {
   3.519957846583263*^9, 3.519957847509316*^9}, {3.520016920677761*^9, 
   3.5200169222221637`*^9}, {3.520016962797835*^9, 3.5200169636870365`*^9}, {
   3.520292071675897*^9, 3.5202920786335096`*^9}, {3.5202930421264086`*^9, 
   3.5202930445444126`*^9}, {3.5220219050236907`*^9, 
   3.5220219162557106`*^9}, {3.522022046453539*^9, 3.522022060072363*^9}, 
   3.5223303850002995`*^9, {3.522330787126476*^9, 3.522330802821717*^9}, {
   3.523069000074914*^9, 3.5230690024617186`*^9}, {3.5308924224008865`*^9, 
   3.530892423836089*^9}, {3.534721905303831*^9, 3.5347219072070346`*^9}}],

Cell[BoxData["1.2212453270876722`*^-15"], "Output",
 CellChangeTimes->{3.5857641271828065`*^9, 3.5857648646359863`*^9, 
  3.5857649218972616`*^9}],

Cell[BoxData["1.3100631690576847`*^-14"], "Output",
 CellChangeTimes->{3.5857641271828065`*^9, 3.5857648646359863`*^9, 
  3.5857649219112625`*^9}],

Cell[BoxData["2.7755575615628914`*^-15"], "Output",
 CellChangeTimes->{3.5857641271828065`*^9, 3.5857648646359863`*^9, 
  3.585764921924263*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"temp", "=", 
   RowBox[{"MapThread", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"{", "#1", "}"}], ",", "#3", ",", 
        RowBox[{"{", "#2", "}"}]}], "]"}], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{"truehyper", ",", 
       RowBox[{
        RowBox[{
         RowBox[{"Commonest", "[", "#", "]"}], "&"}], "/@", 
        RowBox[{"Transpose", "[", "reshyper", "]"}]}], ",", 
       RowBox[{"Quantile", "[", 
        RowBox[{"reshyper", ",", 
         RowBox[{"{", 
          RowBox[{"0.5", ",", "0.025", ",", "0.975"}], "}"}]}], "]"}]}], 
      "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"temp", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", 
      RowBox[{"-", "1"}]}], "]"}], "]"}], "=", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Length", "[", "#", "]"}], ",", 
       RowBox[{"Mean", "[", "#", "]"}]}], "}"}], "&"}], "/@", 
    RowBox[{"temp", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", 
       RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Prepend", "[", 
   RowBox[{"temp", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<true\>\"", ",", "\"\<q0.5\>\"", ",", "\"\<q0.025\>\"", ",", 
      "\"\<q0.975\>\"", ",", "\"\<mode\>\""}], "}"}]}], "]"}], "//", 
  "MatrixForm"}]}], "Input",
 CellChangeTimes->{{3.5567078101784563`*^9, 3.5567078386259155`*^9}, {
  3.556707900479143*^9, 3.556707934945713*^9}, {3.556707969124985*^9, 
  3.556707992756033*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"\<\"true\"\>", "\<\"q0.5\"\>", "\<\"q0.025\"\>", "\<\"q0.975\"\>", "\<\
\"mode\"\>"},
     {"1.`", "1.9299382742674775`", "0.9224640858565704`", 
      "4.795996024389738`", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1.202879184006418`"}], "}"}]},
     {"1.`", "1.0934029124348277`", "0.3270178964510375`", 
      "1.772365035134811`", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0.7551827637436557`"}], "}"}]},
     {"0.4`", "0.20026272077472976`", "0.05668156772191409`", 
      "0.5534435719641332`", 
      RowBox[{"{", 
       RowBox[{"4", ",", "0.2805227479813415`"}], "}"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.5857641272718115`*^9, 3.5857648649660053`*^9, 
  3.5857649219402637`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"ticks", "=", 
   RowBox[{"{", 
    RowBox[{"Automatic", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"!", "withdata"}], ",", "Automatic", ",", "Automatic"}], 
        "]"}], ",", "Automatic"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Automatic", ",", "Automatic"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"gh1", "=", 
  RowBox[{"listmcplot", "[", 
   RowBox[{
   "reshyper", ",", "truehyper", ",", "hyperlab", ",", "withdata", ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{
       RowBox[{"FontSize", "\[Rule]", "14"}], ",", 
       RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}]}], "]"}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gh2", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"PosteriorPDFPlot", "[", 
      RowBox[{
       RowBox[{"reshyper", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "i"}], "]"}], "]"}], ",", "1", ",", 
       RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
       RowBox[{"PlotRangePadding", "\[Rule]", "None"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", "linestyle"}], ",", 
       RowBox[{"AxesLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"hyperlab", "[", 
           RowBox[{"[", "i", "]"}], "]"}], ",", "\"\<pdf\>\""}], "}"}]}]}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       RowBox[{"Length", "[", "hyperlab", "]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pri1", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"PDF", "[", 
      RowBox[{"thetadist", ",", "x"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{"Max", "[", 
        RowBox[{"reshyper", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "1"}], "]"}], "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Gray", ",", 
        RowBox[{"Thickness", "[", "linethick", "]"}], ",", "Dashed"}], 
       "}"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pri2", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"PDF", "[", 
      RowBox[{"epsdist", ",", "x"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{"Max", "[", 
        RowBox[{"reshyper", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Gray", ",", 
        RowBox[{"Thickness", "[", "linethick", "]"}], ",", "Dashed"}], 
       "}"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pri3", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"PDF", "[", 
      RowBox[{"rhodist", ",", "x"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{"Max", "[", 
        RowBox[{"reshyper", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "3"}], "]"}], "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Gray", ",", 
        RowBox[{"Thickness", "[", "linethick", "]"}], ",", "Dashed"}], 
       "}"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"gh3", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Show", "[", 
     RowBox[{"#", ",", 
      RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
      RowBox[{"AxesOrigin", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}]}], ",", 
      RowBox[{"PlotRangePadding", "\[Rule]", "None"}]}], "]"}], "&"}], "/@", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{"gh2", ",", 
      RowBox[{"{", 
       RowBox[{"pri1", ",", "pri2", ",", "pri3"}], "}"}]}], "}"}], 
    "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.5560913683590264`*^9, 3.556091368678045*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{{}, 
      {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJxdVHswlXkYPoXqsCPrMiJtuYwkl5JbJR7kFsJxcA5qiw67aTGl0ZVv2yNN
uaxiFpWNZVWjnRpMY0OfLrsS6aZWDXZTi067HXKr09HuTu/vn/1mznzznOd9
f+/z/t73+cwT0kSy2QKBIPXf33/vj4/Sq6hMs/FQ9qQX/YGm6lM2FUkfCM9D
xoWkwomlc/ER68El3mhp4JZZhA2xNnWPcWGSNuEF4MZfGuyMZ/FmeNK/Wa0t
1CC8BGfyVJ/2DwoJW8AoTJ4i0dAnbIXQsthQxY/vqb41WlXmj2VZSsI2cFPq
Wtt2zKN4W3Rnvk+0bZ4i3g5vbun3rZLNEHbAs+O1IR5lWhS/AnFFjg36vp8Q
XonvT1SLrxqwfpwwNq1svZ+4kPAquF5yCTzwjOl3RsTwyMI9egLCLujrq/9y
cr4eYVcoFi1ZpCd7R/XdMKH0MevZoku8O76bUVVPyFTEr0ar1leaWpMsfg0s
khoNXfJ0KH4tsveG1K9UMn0eEOt+/vWAhOlfh4r0hvE5f7B+PRG3oLv3B3c1
YS9kxng2XLs+m+IBx3vTgv03TD5iDtCy6Nu9vYrp8YYqbX+ZzkPaB84bKacf
ntQufUO8DzRym/mmn+l8zgeN+bp++pZsX3zRdvFJebsVy/eFifTKW9+gUeLX
Y+b5XYfG63R/3HoYR3+bJTWeIN4P2d61PTdB53F+GL6kkPN32Hz9kdkbnyiv
J8z5Q1E2q2RqmukPwOiH0WITRwM6PwD7Di9/FeI0Tnwg7h74/eSoI90HF4hR
Vfdnrn1MXxBEFaotnWns/CCYndfok2pOE78BjyvnJz+Q/0X8BmwVpNiIFUx/
MGr2vlQ6vXtNfDCa9531sHJn+xyCwded+o9KaB+4EGRJTqc07mHzC8WO28fs
s86z+wlFoN3dabedLH8jblZkmpfLmf6N0Lza0V6XxPYvDDl198rNcmifuDC0
vE29eOU30iMIh5lpwTfticQjHJddB+yCzMmPXDhuW/PHrIeI58NhINc2eRnG
/B0B+2LDhK4M8iMi8GZbS3D6DtLHRSD2p2TFg85Byo/AVmnVLbE3ux8Rpny1
j44eoH2GCDqm9hoveJoPJ4I6VCx74UXz50WYrLzjdEjA/BuJ3Ln5y4wSqH9E
wr5TaFnUw+4jEsW+fxbstyC/8pEYyBDKbAvZ/MWoWF2fLDzD6otRO5bTonlw
jOqL0XZ/1/ZfXxPmxbA7FVWjq55D9aMQWWjesPZv4hGF+yOVWbvqnlN+FMIC
BzdHtNH+8FE4ET9WfOEX0ieIxqah49tCcmi+iEa3LCnAezd9L7loxDh22S2u
ong+Gv1a6oLVjcz/MfCY7nA+MkT9IAYj65b1OsmZH2PgmufnOeNJfuX/hwUS
iNTX4mp2a1J9CWyttJ7OOsL8JkG9YvGKs6U0L16CUu2DrSWG5CeBFJmbnKKF
DtQfpDhsecM534bNT4op56rlzpdpH3kpznWNdHiasu9bLB4tqOttUpPfEIvZ
/Wss/CtYfixaX6Wl5yey+cVickyV8dSP9R8Haz2TIbEXm18chnNz26dGaD+4
OIyf8/9COKKBfwBYsvsI
        "]]}, {}}, {{}, 
      GraphicsComplexBox[{{0., 1.}, {0., 1.}, {0., 1.}, {0., 1.}}, {
        {RGBColor[1, 0, 0], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->15], 3], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->15], 4]}, {}}], {}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{
      FormBox["\"\[Times]1 t\"", TraditionalForm], 
      FormBox["\"\[Theta]\"", TraditionalForm]},
    AxesOrigin->{1., 0.6187533948663699},
    LabelStyle->Directive[FontSize -> 14, FontFamily -> "Times"],
    Method->{},
    PlotRangeClipping->True], ",", 
   GraphicsBox[{{{}, 
      {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJxdlHlQk2cQxkMcBRqglTKAVQSBoqCFAAoUi3kIh+GQIyEhJFYBC44Hp0Pw
QIhW1KKttmoPEC1FGdSqCFqx1jHQUlEQS8UDyxRRUU5BNBINmLbDvv80M5nM
L7v77bPXNys5Q5zC5XA46f9+//ud+AwLShxy76cufSqgP9BSFi6ssG0lNsGS
+pHWcyV64ndwv6p0fcdgG7EVioJ/PdHJe05si5OHurKKq5n/DGy6vqH8YPY1
YgfofJ1vHWkZJnaE01mnrXdm9RA749PTQ5fSO5ndBcMDXHve30+I5yD75U83
jvSNELuh4OjKzBLlGPE8cK9c2yIM7SN2x+vuTGODmPnzwZf6uj5++IbYE3+8
fW12l/tLYi+cd79X+Z0Xq8cbtfJ0T+frOuL5mOJWrG8Z7SJegFe6kkXlXky/
D5rGZLsLfZ4R+6J0W6Z2bAPT44dSYbGViQ3T8yHkxz/gOQ2/IPZHZemttdtU
rP6FkJv1VRyuZfaPkGI6U7W+ZoA4AHUzbEWrvmV6F8EoT/rAO2iIWIBLTQv2
9d9ldiDz1Y4q+2ODE6wGrjp9Yr4/n+kNRJrnWwcHk0ivOhAjuX6nHH2YXiHe
b/eKWzqsJbsQa4LKj+Uo2P4EIY2T1ffL3gdkD0Jynzc3K4TVE4yDZqbZCZMo
nzoY/tooO8OefrKHQPnF+CFBEdMXAoUs+s91saz/oTh3qMJozc+UTx2KimoX
raSD/DmLISy02anwe0T2xXgjGExtLmDxItRFuqy2+ZrlF8Hqdk+3diPVwwnD
2YIDdgWrSa86DEs3m98VtLP9CEfYSp7znhTSqw5HfMuR283mr8geAYO5Pufk
Q/b8COSqIvJ3L2T5IzHdsEzs5kr9VEfi6oXo+XnWLP8SLFNZjzR0Uz71Ehw+
JXJUeFM9nCgMbfcszZhH+6COgqlHb/Fci1GyR6Niu/XmWUqmPxobLf2ML65j
+mIwlmFj0ax9OMGIgetxj792cpl/DPwmy2xfuNJ+a2KwdrDQ7tFVpj8WU7mC
VdtMiRGLQP+m1706Vk8sbo6mV+fqjTARH4sUafvqyvVsf8Q4b/R8Jj+S9hNi
1D3NtGz0JVaLcXu2vnrZOapHI0aywKNhXi3bTwlcptakmuyg+UOC/YKLK/PB
5i1BY2doK38T9VMjQVSV7olIxPobB0v9l9W6aJY/DvFJWyt+s+qm+Di0HW0w
dILFx6E+7MLy9w6ze5LinlZ/4nQhzR9S2Bln7S23ZvOW4kDPnXuTBqhejRQ3
y6wuS358TPEydAjs6x870nwhQ06b764pHixehqEIqaPDOLFGBoF9PH/Xdna/
8UgodipqTyQ74rFWz+NW/UD9UscjfPI0Xo4bvY80/2OOHGbC5mepqXQvkOOr
stMBZ+bQPNVy5GmSLi5XMf1ytAqLZvDD2PwTECC6ktGxvJfiE/BuYH+7j4HF
J+BM2gmLuezeNAlI/Pz7SsstrH4FLq9Y8fG+b5h+BWojvKdqLFj9CtQ0NqnO
W5G/RoH9ez+TjNez950SZTnTunTjpA9KdN6omZ5Yx+5BCff036McfF4K/gFH
vhsB
        "]]}, {}}, {{}, 
      GraphicsComplexBox[{{0., 1.}, {0., 1.}, {0., 1.}, {0., 1.}}, {
        {RGBColor[1, 0, 0], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->15], 3], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->15], 4]}, {}}], {}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{
      FormBox["\"\[Times]1 t\"", TraditionalForm], 
      FormBox["\"\[CurlyEpsilon]\"", TraditionalForm]},
    AxesOrigin->{1., 0.2066226766797675},
    LabelStyle->Directive[FontSize -> 14, FontFamily -> "Times"],
    Method->{},
    PlotRangeClipping->True], ",", 
   GraphicsBox[{{{}, 
      {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJxdkwtMk1cYhgsGASMKzgu4OVHQgFMnd3RCX0UKLbdyKS1lrFHAKV7QOXER
kN8NUGBD3ebCpcJgQjArN4HNFbWtQy6KKy3oAsIGKmpwGROJbIJkW/zOlvAn
zZ+n73n/857vfN+KHckRiaY8Hm//P79/36+eP/iPNfHFtZobfPoD0z6POhc2
tRNbwF68yqTwrIHYGqkdU/uPTnURL0SRVKdPyWG6LQyx7vlx//EbqLyZFV3/
Ifu+PYbNk4qr7zL/SpTpcnfamTPdEY1Jxqm23PvEq/HlOO/ekZAfiZ0wLEgw
nHMYJF6DE9qrPvMGrxOvhahuvW1j38/E65EfW/WwyILttwETjl2bdk4OELtA
1LPHyL32E7Er+nOay2SBbL0bdOe44ifZN4ndkX4xu3Ak2EjsAS+XN884X2F5
PBEptxwYC60h9sLLNveGZ2/3Enujttgo04ex+mxEnmjJSd7oNeJNSHB7XWpV
oCF+B399ppyVUsrybUb9Hoel4uPM74OToo/7VZ8y3ReaomXxbjsuEfNhd224
c5ecrQeezrZ7nqnufsUcwK+y3D2yupP0LYgr6DhsoWsmfQtiWqxd8+61kL4V
keln1ibU0H1xW3HwgwbTBa2tpPtBNfxkLEPB/H7I6g801C5tI30bHqxIqko3
Z/tvm6H7Y9n1vgOKwQrS/VGJAyVN9TrSBXAcP9WjzqR6cQK4CJxenFVpSQ9A
s/Wqs4m2tJ4LgE6a6nvoXdY/gYi/FmBptY7ycoHIbf99edpQB+lC3B5dk+JR
TswJceF8+QGbe0wXYf6idaXdGXdIF0GY4Bn43QTLHwTRXDlWWrHzBWGy18q/
qoLVJxjTs4ZGzMPY/sFInpwOSN7N+jcEVgVdZeuF1E9cCO6O9egdilj9Q3FJ
9es4fwPdJxeKRF+HPq8G1q9hmMfnTSie3yY9DGnCye7FPswvRnZoxUeXD9J+
EOOF2WCtOpbVU4ydUTbSY8dp/rVimHydYX1UTd/jhSOH23xZ8hvVF+GQ7eqp
eOx4i/zhuDGm9TRprCd/OJLlSx59sugi+SMwGt4uMzrRfSECaXsHfNwSaJ64
CAhd3L/d/ozmTRsBSb53kL5piPyRUJpsfNw7TDoicSpX4jXgR/PFzWBtJObk
3co+XdNA/ig4xx9KybvC8kdBkH2kZbWC3XcUVJkvh8x0lE8bhe4nilGLB9+T
X4LTvo++0ofQfEKCrJKFcQoDnY+ToHnOg5Y7rqRrJWgL7Vq8wJrdfzQmcr7w
E3pQPRENIz9cVWpg54/G5fJGjdye+ksbjX0Zo7NLBP3kl8I1XZ02t5X6DVK4
ex/qsHmL5Zci6PM795OMlEcrRWp5iD7OrJr8MpiWxaab2fWRfwZzMnyzru5i
3BDVWyvDe3/uU87vYv0Vg7qqosPTwh/IHwMT/+nzie+zfoyB8xVL5S8ayqeN
wRnjhu1tWTQPPDlmVQ/nHgumvJCjUq3c1XTuAvnl4O4PeMj2XiW/HF7jyuLC
Rla/WNguSVQ+fUh5EAve8vm+3p1s3v/nvwGyNBBw
        "]]}, {}}, {{}, 
      GraphicsComplexBox[{{0., 0.4}, {0., 0.4}, {0., 0.4}, {0., 0.4}}, {
        {RGBColor[1, 0, 0], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->15], 3], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->15], 4]}, {}}], {}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{
      FormBox["\"\[Times]1 t\"", TraditionalForm], 
      FormBox["\"r\"", TraditionalForm]},
    AxesOrigin->{1., 0.04272745373362794},
    LabelStyle->Directive[FontSize -> 14, FontFamily -> "Times"],
    Method->{},
    PlotRangeClipping->True]}], "}"}]], "Output",
 CellChangeTimes->{3.585764127374818*^9, 3.5857648653190255`*^9, 
  3.5857649219962673`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{{}, {}, 
      {GrayLevel[0], Thickness[Large], LineBox[CompressedData["
1:eJwVVHk8FN4XRQgzlhnNZGaE7CKksoTuk62UkqTQQknIlqxJpE3ZR5bwLZF9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        "]]}}, {{}, {}, 
      {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
       LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQXXwqXW/awSa7WTNBYKf9zqA8VweTjfYw/uX3IZL2
Jgfh/E22ra2Vby/C+aG+ZpfnLboF56/4mM/EOu0hnO9vkywTYf4Mzn+8+uCD
CZ2v4HyF2XZq6Rbv4fyjz27rbXjxEc4vEDo3fz7vFzj/Q63/xbsJ3+D859Vs
N/p6fsD5JbN3hweu/QXnX/31f3rSnz9w/to3lWufKf+H83X6Dx68s4fBAcY/
a+H60u8RI5y/cnVy9a/PTHB+wb6TuWdlWOD8olmnTt00ZIXz48SEO3jj2OB8
0cW3GE+1sMP5HD9tnu2fzgHnP333TOvuQU44/+9a7VvGN7jg/Ae1712FX3LD
+Wvf/hKUEuSF87epLfSIUuVDuPd/3/2DAfxw/pYvtZKR1gJwvsG5xh+5RxD8
heUr28UiBeH8Da1yZ24/RvBVZC7nPc0WgvP7mlYfbPqP4E/1vXjSplMYzp/4
QqqpS04Eztd+sfH9l5VI/IKO3YuNROF8hRNN5s+OIfibWk5luAaKwflWgmZe
Fs8RfHW1h535VeII9fNv1h1mloDzjV5+VV49A8H3nx5ft15ZEs6/dJbD/Mdq
BN/rytX5V+yl4PwE+w97z55E8OeZHbC8ICYN59/WnbD1UjKCDwCQ37QC
        "]]}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{
      FormBox["\"\[Theta]\"", TraditionalForm], 
      FormBox["\"pdf\"", TraditionalForm]},
    AxesOrigin->{0, 0},
    Method->{},
    PlotRange->All,
    PlotRangeClipping->True,
    PlotRangePadding->None], ",", 
   GraphicsBox[{{{}, {}, 
      {GrayLevel[0], Thickness[Large], LineBox[CompressedData["
1:eJxF13k4VO/7B/AxFCUR0iKJohV9IhXxPgltkiwlIiJLRQiVtUTZS0UUyhJC
ImurXanse8jEMCNLJmPG1vSb3z/f/jrX67rOfT/Luc99niNz9pLhOTKJRPrB
QyL9//X+yKqASI9akEgUsXwdF03ZU25EbhjXWwJInt+OIrfmM6cpietvhcMq
3yzwNcnbe3l9LcryjlmKf3MCn2mve7z8Z5QlxK/k++YL96qn9pkdXItVTs11
ReBEwsajNXu+olH/BJXdlYBVx3au5Pyph/Hok+6prhfYkUF3mF/egDejjb0O
5jk4zBP/elahAavHeCjdPTnwyiebsy0a0DNmQy3ve4meFY0JE+8bkM++z6r5
nYtjLoVRDM1GqM2c/Htv+hWW7TFYQeU04sB8n8hWvmIkDj7HwOIm+PhMR1G1
i7HlHq9Dv0QTsudFxBKDiqE1UlRCUWyC0J99y5fxl8AtQcqs17IJ9X9SVrEX
vUYrz0h8+4cmmP21l60UfouYz0GytX7NsCdPKJtLluJrzrPq+ZBmCK16mP35
ZCnI96sdtkc3I19JU07tQSmczBe8fJjVDF9F3bDwhWXQHg1Ut+tsxkfzBz4X
/Mvg1Zj6PW6gGatptN0pCWXILai6UTfeDGc39alvb8uwxpfvk8qCFoiH9Dsd
ni6DofWGCw4iLbAXV90SIFGOYB3tpfGSLXjzJGTotUo5Pmy2zWuQb4HQ1t5k
hmE5JoUCjXl3tMCyaPuZza7l2PQ7ha2q0QL3Jp0VFu7lsGyvfHT+4D8/eDOg
kWj0z58TeX80Wf6zqv3+jXs8/jlZ6abT07B/vlZGnnUu+WeD4wG3NAb/OefB
9ZIrsa3/s2Cn38+8I23/s+dPKrE2q/1/pswffhi6uPN/nr/nfmeKr/t/DhTb
tsf/a+//PH3MVVU34vv/fDG8SFlIv+9/Dunmn9T0++e0LadeueT8s0ozz72Q
mn+uvJbpmvz9n0Pr/H7k/PxnQxmj429Z/xz+5j7FhoeC0dWCvfsDyuFC9V15
np+C1vfblwR8KIfxUgcDFyEK3lmdUC+bLceu3YbBnmIUPOL1Oc9RrQAnTH46
QJoCq0MfP3m9rECEckPH410UsFotgi4/rURmwLqHdfYUrB4N5dgGVOOdYWtO
sRMF9UuiRkLeV6NBNrgm6TIF4QoPO3Omq8Gs+DXl4U8Bxznl1bRzDTR4S43X
PqSgk/HWLtz8IxpvWoheqqEghj1an69SC1bgowgRuR8Q5T32hEz7Cq3b4oFG
/T+wIGLRuka5ZojcaKh12D8AQedcHzXBLtxQ3rPzQAUV6zwoh2u1KFjHOjTa
85GKHPPQB6UGFHwoMUtxq6Nij5bK90JLCuY1fJYldlJhLBzsmuxFgefB0jHm
OBVBz5VivV9RcN5CJy1ZchC0Xr9BBdkfML59fAXHfRC5ulLX7/H04/ehs/X3
vQahrvCxNli4H1FLLgdtvj6IT2KuYv5S/aiPejBpHDaIH5SqtAt7+nEovqMh
K2kQ4t4X67Rd+6GZZxF8qn4Q116+Xc2m9GNTt+NMwcYhaK00KzQvGwBrv/Zd
RYUh6Kz1yRGsH0Bl9tqNGTu43pCY/rZ7AJZ+LcaPNYZwaHt/nCR7AFtpL0bE
93Otynf/Cx+VW3/BAZEHh3B4r3y4tygV92U0cm8YDeHowfN+3QpUWIWuODBn
OgR9/fArYepUKE4yet0th3DcOMdF/RAVc+Zf3cdtuDZrdBw5QcWnqjRBB8ch
BC52K+yzpiJG4UbyD+chEHm3A6LPU2ETY77H3H0IcycTjh25TAXHXsRe338I
bs8+DRcFUvG18eefj4FDUNT7XnQxgoq4PdUP9oUOgf578qZsDBUqgl4VKtFD
OENIr41Mp8IxZ0BKMos7/24Pw3OfqWhlFrXS2oewYdn6t2Iig0i2iLpg3TME
SvHu4NqVg7hUc4Hc/WMIjyz1TfxlBrE4dt32+tEhiGRf+/VzxyCgHhpWQKZh
XrdxfYXJIDJvWGjdUKShzcc33OXxIPyX8uWuvkVDIL3Dok5+CNdm9cIPkYeR
ebAsIuUmHc+7T5fzn/sJT4sn+aSSn/D1kFxzZ3AEqev/VJZJjkFcwmCVx8gI
dl0/vWC93BgyiwIlzBkjqO15qxukOIZ29pjIxj8jGI32qj20bwyKXmULSsVH
sUNgur7Zbgzf/c79Gt8/ig+jv7uoeWNwl3402npoFAaHDCUPvB3D4rL64TfH
RvHjWd7p51VjUOXZTb1lPooFZ1z6nDrGEHlzcdfay6M40jRGZc2PAcEvK/ST
R9FVSP8lcHAc7ZuopSoZo7goevC/C8fHcbF25fvVOaP445zuVmc2jtjFAcVD
r0exbpPdVJTTOBSzigq+lo7iVWC1KtNzHFVHRvJeVY9C+8eGqyeuj8NsVPpl
7JdRtGkEvi4JGcdEuHG2X9MoqpbZuOjHjOOWQshz245RkGN81YtSxrGm/n3a
4d5REKtjF67NG8dB4Y1JEsOjeCtbFz/2ZRxPo2aic0hjeKW8qzac5xd4Hu93
XHqGu64rfV6LOn/h4snulEjbMe45YBEplPoL7WKXvy89P4aG5SpBixm/kB2e
bCTsMYZFZlUfFyyYgKkfj6ZI2BiOTq9sXrh2ArnWpaKixWNoVakYEjCYgOUm
9XfLhcfR90JcRKhgAm8LdwhLlY6D/eT12eU+DIRpOzh5cePOb0yf5ihMoi3j
0d8Xjdy8gpGNfyuY6GxQtHrVMgHPnbm7umuZ+MaqKCtqn8C9M82JRY1MfNce
uVHaM4HP+RJOTt+ZoFPU+ZroE9A4/WRR9wwT8yt7BZgkBuRe5GoVbZ+CbIi0
qNp/DEzotxRcTJzChtx8N00VBpZcm5I8+GwKGzsOtGjtYmBLyoqb67OnsE3O
5cERDQZs2ebHv72egmp5mYTFIQY6nlDHDrRN4dCMteR1awbeT0zJr1/Cgt46
lnegLQPdq1dGckRZ0D8Q2hNszwBbW22qaxULhtGvEqKcGFCM86u8u5GF0//x
rku5xkDyPn4rjhYLlqYPr6dz9+XDhc0fuw6xYO2/9UeWPwM90UcUCw1YsKsz
Si4IYkDi5535C5YsODBp5NfBDOwQf2Vz4BwLFyR9bN6HMWCg2fpZ9iILLo6p
G2qiGAi9tzKu6xoLoTZSHu8eMCAbtHVx9HUWUi1iql89ZODNFU1vg9ssfDgp
LPH8EQMDxidtFgSz0HE82O5JAgPk4Td7Rn1ZmDjCUxz9lAEZ37UiLZdZWKzr
xR+ewoDGsoCh144saKpdzLj6nAH3PYfu3zZhwVRlcNo5m4G7ddmOzkdYcFO0
PHTuJQPZ1iKEyT4W0mQNfh4v5I4X0jEqq8CCkKDKtq3lDJz4dk73Ax8L8gte
+MhUcfM51655NjsF4q9c3YqP3HxkhcmwiSm4T65w5qtj4NMW5pNTPVPo6Z57
2dvJgKp3wAwzfwqZ2ZXKdycYkFzzJHurzRQGfvVrmR37jcwny64tXMcEYyJQ
SJU0CZF4ktKqagaO63POs0onIXmAyf7qPI7ccrmwiopJCNhoH3ljPg6RnUez
IqsnMe73IDGd+743SsaPyH+ZxOsiFZ0A2XEYDO+5eLJ9EgbyHvd2tY/BINDD
qWR0Ev4LWNuSNcag/2b0ktcqJoYr2dZXlowiR0H8ru4aJhr6DhTazoxgaZJ6
rqg0EwVzDwUMh0ZQfzt0InMDE9eVd7/cVjYCfZNNrt1KTKxIuTr/4/IIjk7Y
uO3VZUIvYCZGr/sn9OS73TluTOQSc19kModReZEW+M6DiY2813guPRyGWv7k
A6+rTDypZqm+CxzGZmJJIcuXiduHfyedODOMhWYaU+PBTFgaD18JEx9GecQT
j75EJhY6dKyf8qNjd2tWUEISE75bTE5pXaQjd3VJtHkqE+OjzZF3TtGRmN5Y
2PGciV7X+pnNKnT4lPOwGgqYyPGubrAcpmGSf+nCyGIm5DT3L8hup+G8/moJ
vTdMJJDK1WYqaTjVvUP1UykTQUHvnt1PpKFRBrq3uH1g/oBaNyWMhoMOR05o
VzPhtLhERPEaDaU5J+3In5gY/LpT19uOBtUpG8+yz0ycvpPv/cmIhhfqLrf8
6phY9EFSQ1aXhg0BPjF7uX3j5FS2ufUBGuI/BafNNjORuk3T6+lBGsSEo4tK
2pj4bdMQ23eIhlCTpBrPTibw2Kp47REayPEv2lW6mYhoZrRZ6NEwsamGlUth
YtM+cbEefRrsLzUvvDTAhMfVZ/9JGtDwvfC7hMIQExUvVQ3MjtNQp8VWfT7C
3d+1pyI6ufPLPL3pShKLiQdzCfxtpjTIpKjcPsPtWz92KMmLm9EQO0w8lJpn
QvF8mbaROQ23PU8Vx/FM4XNn/40mCxps74ayo5ZM4W/hxvm6szRIV41eCZCd
wkWXvImaizQIOGiv9pGbQruF6noZZ+58BePfeWyaAo68NfG+REOF0REeR8Up
iMlXv1Fy4+YbeB56TG0Kb7o7A2Ov0JBBtk9YYzgF/gOkVecDaPhv34+KohtT
SJY6tk8olob9H9qERihT6Po8GmXEfX68yrIGj++xcKZJXmilOB0HKzxTEqJZ
iL7Er+y5nI7w419YT2JZ+CJEN22VoEPcxT0hNZGF3Yefp95dRYf8i5qfLzJZ
WFa5de8iaW78xgtBZRUsVBVsvzC7mRsvWfBm8DcLm2LVantAR2OmwFL6FHc8
Vclfavu4+dQsrH9Oc8drnROP06IjwXShwC8OC+Rl761MdOjIiTY1mV7MRncI
pusOc+OF//xavJ6NCG/tjaUm3Hg+XbntRmz8ttQPSrpAh4udv8OGE2ykh1Xr
znDr/cunkqyVp9g4XbJX4LgzHQERW3fwnGHj47KtYSRXOhgSy9B8no34Kv6o
M5501G/uMXUPYEN3S3m81A06toQvj3cIYmP+xG5LjwA6gsb1+04Hs5F386V0
Hff8sze//JxOJBuSvQnJPrfoyNqb7ibxiA3GHa+M7jA6go+5hZfksfF4Srkg
LoYOal5WQ3YBGwayWR6Mh3RAfFA0qZiNBcdkdx2Ko4PVeTIu5D0bLhkib6Yf
03HurEaaWS0bOuZjpSeT6Cir8hzW/8rG7G3bGy+T6VizMXfb/gY2XhZ0a/Gn
0tE6Ipu/tY2N1Us/Vxel0aHlIVA2T2HjV1nal+XZ3Pe9Yx8vY4CNZ2NSEU4v
6Jjd4607OMSG2epo/eocOvI4Y1/rRtmovnyzyT2PjiXWG0UqfrHh9XT23tdX
dDhUWhkV/WZDqc7VeEMBHeuCW7oSp9l4JG/V0VLE7R8/l0jdn2PjmFFH7NYS
Ojr0dK1uc9jgu65vdvM1HTte+qd480yjYvu75x9y6Yhc9nroEt802j7sWv47
gY6fl39vtuWfxrBe/nU57v7ptm91Ml08jT/fFEdNr9Lx51HiJCEyjS1sucpS
Qzq0w0JMyGLTiG5gsFS59RTq7V5cuXwaCzPeb8lRokPi9GFvXclp0E1N7sUv
oUNRikXWk5/GizeB1tdqaLB8clT05N5pqPoN/N2hxu1PKfPbnRymsW9B0t40
mSHcyDZzjiubhqnYmqLwiQGcXD3u3e4/g5txmzM2nvmOT+TBneY7ZlGyh1iy
2r8NN/Lydq/YOYuTHNMmvdNtULPyU2/ZNQtWhWuM/542ZL9fse+IxixU9FLW
DU62IurqYT31g7NIsVy4M9ehFWbjL89KWs5yz61fLXQNWzDa5XWnO2QWtnWm
L93kmvAs+MC9h+GzIN9zdX9GboLlLvFoozuzSD4RuqezrxGND148+vJgFn19
bys1HjWi8Bjl2dsns9D/vbZTQLgRftU67x4XznK/6595NBl1WJYnMmz+YxZ8
Ff2pMQ9rsff9Jj8jKtceVU3CerWwqyXEjtBmsWZTGieYVIs3P1w01Ma4+SId
Tb0dP8FWtClq5cws/MwmBK3UPyJy7bC8yPwsHgo17+76VYPXW3je8f+dRUxZ
/jnD1Bos3f/fEItvDjnyV0q1hWpQcjlKrU1kDn2//7ht7qtCv//zhq9ic5h+
1vck+X4VhMLLbask5sA2Lf8qebAKZ1MZkflr5iBcGii/NK8S4bmLNmRJz2GT
m53R7XOVKHon8zpZdg775A5eJ62uhGDb8YGoTXM4FSb47XdABVR/OF4N2ToH
U82xhRd3VcBq7IbQDcU5uDLqlQdHyhE6E5d89b85hKbmWlk+LUfBgle7XFTm
QPf8oNdzqRzfl33+ar9rDn53oxVFz5Vj0dp+6zNqcxDJvChy0Kwclqqi4frE
HHb3rm7N1y5HsNYWGd39c6hnMQqH95QjX1+rSEN3DlYitQ+llcohYO9G2aY3
h+D9V8zDVpUj72GziqDpHHqet/SfHS8D38y93o+X5nDdM5yxLLYMWW/FlPY9
mUOQ9LwUpb0UZSa9/QuS55CevmXkfUUpWn+lxXxOnUOj0qmSxzml4KxX4xhl
zkGUKDI8easUhuFWdXaFc4i1crldv7MU06dfXAj/ModXSdSJdw8+QJejm9HB
nkPH+rrKOMP3+EF4yTgbzGPLpkRHo/o3cJAtSfMX+YOpUvshz1OFCPU71dlZ
+QdaMbqVa/blQrSDTyG25g8yNx9PklHIxSOl3Bsna/9A7L25v/yqXGRSFm5t
r/+D2o8/PK36X6JWq8C3pesPpGxU7W9rvYQAv/D6+l9/UBzXd6CNnIPbd6qc
KiU56Fm4Y5HrzSwspV+qCFjLwTuFA9Ve5lmIISRXaMlwEGF8+kagchbSGK5l
ZfIcbE++NfNwIBM1RtJiH/7jwFOje/jD/kwsXOlVUnKAAx73wM9L+J4j0kVO
6OphDpofxd2S6MmARG2j9a6jHKSW52itK8iAvNdGwSJDDnSFu94o22Ygp7n5
jIcJBytVxz019mZAdatfgYopB8OneZUPiGdAp6fVIt+Cg8eZCllmVen4qnL9
lZsVB15NWva28ekwjtjKv8OGA73pk+ud3dPRM9huzjjHgZS0U98VvXTYagbk
5jpw8Cjn1+3NO9MxGqOwwOUCB7xas+cUZdLh/qvzlJIzBxfb+LSVhdIR+FSJ
N+cyBxrzq0gag2nwPSH/M8OTA6rCcOLdhjR4LpFqSrnGQfiZEg3q6zQ4Xl38
JM6fg5aKE95hkWnQNxhUCwrjwDHkPqtrVxpWkB67nU7hIF5CaMwz9Bkyzyzs
X9zCwdx20rdcpVQ0ru0ts9/xF6/PDeVv8EpC8YrxLY7Uv9z/mLt3pDpicVV1
5H66IYk4IqajnFoRhhyXjpOyxiRiAf9vRuTFMFAzKyUTTEhE6Wxi7jWJMBhI
x6fcMyURKv3TCsfOh2KzwNF8X0sS0Z+bvWl2WQi+deU0G50nEV764msNrG9h
r6/bMlIAicgMGRCY/3sdbsWWbV43ScQ537sfh55fRwbjcNxUIImQdtW41WR0
HeJ262VGbpOIjXmK/PrH/DGm37q9PYJEBOrHzKck+iBxnapBdhyJKAg5Rzum
cQWkqplI0zwSsYkk4HVsygFbqzX7X78iEQNry5dIFtjjRM3NnZIFJCJBw+vJ
kJsdXnwS6uktIhFbvEarfCdsYFYns9nmHYk4QU+SNu2wwK16O5+q9yRiZr24
zi9jc+Q1ZDXIlZIIZ+tb5281m0KgeacnvZxE3P52vrCgzgiF7YcqnT6SCNEE
+xjZ4P2gdERKNHzixivFViQt1MCSrhbH7Z+596+1NuXM78CubyvfR30hEUWb
jHsKh2RwtttCZPIriSBZNZTdtmVoRvYk2xjXcy0c/LUD8njdSysqbCAR15d5
G9zZvBMiFFeLq80koizGXfRCojbUfxTldrVwLXn3496UQ7Drn+NVb+P6aZbP
0gx9vKcGZf7pIBFWJ10nO02NcX44jh3Qy7VNhoXPWUvE/Px+mPqdRFDEJOPd
3KxQPrI+UYdCItZNWS9Kz7fGyvEX2gIDJOJpya8BYVVbVP8uj4qgc60pGPdD
zRHr5oe3xk5yx5NLuqGV7Iq2pWpWLxbxELt3dI4MZnmj5EOqzzZBHiI398Sa
xWY+iHcWjstawkPEKrXpKQr4wrae2vRcmIdwUGh+4WnrB2bEnf1py3mIYPGh
4puR3HoQGpR/IsNDbBOhXBM/cBPGgnfH7u7hIdz5W//sLAlGC/+Ql7sjD0Gd
7Q3YWxcF6Q+VF/oqeAidi48/e7EeIzDxmrBmFQ8x/l+4qtHaeND9lPLjq3kI
L7ZP8lbdeLzC49lTn3iILwGWXj3R8dAtdwtpreMhnONktmjuTIBTlUx6bSd3
vjXpITzuiXj72b8/f5yH8BAx21B19SnWZe28JTrBQxy6bGiWG/4UgWEjm10Z
PIRw++G78U+fQl/vpKsik4coeaw+7/7pKfrrFEnPZ3iIxRulWuVWJmFRU69U
Ih+ZSNSg3LxdnISTHeqngleTiY/n7QYOs5Lhbreihm8NmTih9MiULpiCe1O/
d9yQIhOTk3V1QTIpqBPLXOK1jkxI++4sKdNLwX6DlWUX5MmE5x2+CNWUFCjV
MuWP7SATcgXJqrIGqdAzbbz/RZlMFFxtzyo9l4rztCzSwZ1k4rjGYhkL71Q8
W2DzjdhNJnxqXAVj01IhqdUUsUOTTLR2EhShP6ngf/uCufwwmQj48z1k5vkz
bDgcYn3vCJlYViH6N6b0GbS6bOuXHiUTObd03VXansGXLZnBb0AmvgnnWF4i
pWFSOdR8xoRM/Cfrqzx4Ig0ilec+eZwkE2VDuRkBF9OgaLhv529TMmGRRZVa
F8Dtfy7TS0fMyUSIip6A+Ys03Prb4m1vQSZWzPj7TlekITXyJX3Akrue9/m/
ozvT0JdtV9FjTSYoupK9jbzpmFfXUjplQyYuCR4zdF6VjtVfpOLbbMnEksaA
j4JK6dhtNiNgaEcmnj8o2vtcOx0mw60e9fZkojDs6oSpVDrcrub2H3YkE+v4
L16K+Z2Gu/zhxz6eJxPOAWfGWz6m4Yvc/s1lTmRC/pruqL5bGugFa2P2XiIT
Ucw9F8IPpGGh9iz5tQuZ6Luk8LN2TRr2nc3rybtMJmLtxOnaH5+hOFH6bso1
MrHYuH9Abc0zfGYahS/0JhPnyjwdjJmp6DkcHOzoQya+bxMcc/qaCjJ74rqS
P5mIXqDCeurDfZ7HKlzfBpIJzeIgAf7eFPT/tTVquUMmTFZvVmhJSMZS60wJ
3jQyEUi55HlB+inOrd+ZcLaZTHC6Zpft1onB3TnD/vEWMhHpL71r/Wg03rS4
bPRu49abnPbppfejIRKYnXe/k0y4u0SkUSkP8Ia6vqbqO5nYwL9OPcrnPkTS
RH/Jj5AJYRUd25/5d/Fu0wQxwstL1ElKO+3RuQUaaemtKwt4iRE7h2Lh+0EQ
7dr6hZefl1j0Ko9niBII+xB7kzWLeYmSg9ox93xuQvTnd8ejIrxEqodj6Uj+
dThk1d17uYaXYCfar9+r44n7N0c61NfyEso7Z4vpFHd8MF8k9Umal7j0JVwv
2ucyxJbopFNkeYn66TyP8XwXfLj47u2yzbzE4WfTd/bp2GFY+xspcQsvUdkk
9fqRjw3EpaZ1tmzjJdQ5Wv2T+VZwrFNu1FLiJRh5qx31dE7gwbPjyxu28xL9
i8+95eQb4IPvJTPzHbxEZ72l5FkdXQybRDyhKfMSl3lo/hE6qhBXzKJe3slL
TPUdXaX9ykTz/wAUEtV4
        "]]}}, {{}, {}, 
      {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
       LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQLZV37tzhBRl21SLr3B9Wtdh3XXpjyTV9mj2MP3fq
g/Uc05fB+bumJt6279oO5xskMpyfX3MQzr91vDQ3S/w4nH9urx7LRe2zcH5A
kP1dnZyLcH4cb6eJff0VOH/6htRX35qvw/n2Z3g37A+5Bef3rL9eGJZ0F85f
0rpN8b/sAzh/xvJTO5c2P0SYv/a9/2b2x3B+TP6v3JOFT+B8HVGxLrdfT+F8
If3q0GnVz+F8fdZjK949egHny+9X/LU24xWc72aafLn0yms436F/66olcW/h
fP/YQMNlD9/B+aeKX8pHqH6A86+vMlom8BLB/78/r+Ds/I9wvlG//6TPQZ/g
fL8LFsa+op/h/Lb3IhKrTyH4yxt+Vtv0f4HzL59uMjcP+ArnS3/9Z2bG8g3O
95nQvDXjOII/k/N3+fza73D+RxvxSfYGPxDueWStLfwJwe9PDeZ4vewnnH81
qjjlW9YvON9Mr42FTek3nL9ot+2fuqsI/o9df4u0Z/yB8zNnbNC94/sXzj/8
PDv9gNA/OF/j4+kfvFcQ/JU35M7Fd/yH8zklbSd+UmVwgPHPmKTEmjci+FPW
xl7dcAvBD4y/zXPEmhHOl2kISouchuDXLfbpfHECwb9/zG1N+W8EHwAgepBe

        "]]}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{
      FormBox["\"\[CurlyEpsilon]\"", TraditionalForm], 
      FormBox["\"pdf\"", TraditionalForm]},
    AxesOrigin->{0, 0},
    Method->{},
    PlotRange->All,
    PlotRangeClipping->True,
    PlotRangePadding->None], ",", 
   GraphicsBox[{{{}, {}, 
      {GrayLevel[0], Thickness[Large], LineBox[CompressedData["
1:eJwVlHc01f8fxyXkXrkkZZWREiEpZeb5qa+WNGiYZYQSUbKzSmSVRFpGZioa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        "]]}}, {{}, {}, 
      {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
       LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQXZv17O+yw152s2aCwE5796udrGt6Kuxh/MxU/8hV
PR1wvtiXiRG/psyE8w9/v5TznmExnP9BM+CtnsRKOD/bvvbGtM3r4fzvM+TN
+d9vgvMfNEeYp7ttg/OZObuvq/bthPNX/WH3LZm7B87/8fDO92vv9sP5T6T+
7X7SfBDOfzWRy2cix2GE+xgPf3NfdwTOv7dCoeeY+TE4/6yHlo3/o+Nw/s2t
BjbcrSfhfPWoO2r93KfhfI/vxjqym8/A+atPG8gU252D8x/NuKl2+dV5OH/2
zP0Om49fgPPTmFIfP+i+iJBPT5g8OeESnF+Ysc5CS/0ynH/1/K/WWy8R/MXG
cx/w770C5wsZTzLQbLoK57/Wu9t7PPwanB80UW1yveZ1OD+q/1Cv9FsE/0zn
lqk2B2/A+fflf05ybL8J5zfK2FgkeN6C83tEr75ilrkN51usOjCp+wGC72fN
5DFj6x04nzVj2qeOmrtwvvdvDdfJ9vfg/F9dgkuVhO/D+V7bfH5NvYHgM7/P
03MPfwDna2zbZhxwAMGXPb3c2FvpIZzvfs95V0cPgu9k32m94z2C33L57IQv
AY/g/N+pe3OKdyH4Tm5hzk9kHsP5cx7vlrkWjOB/bVD8drwLwQcAMrXDHQ==

        "]]}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{
      FormBox["\"r\"", TraditionalForm], 
      FormBox["\"pdf\"", TraditionalForm]},
    AxesOrigin->{0, 0},
    Method->{},
    PlotRange->All,
    PlotRangeClipping->True,
    PlotRangePadding->None]}], "}"}]], "Output",
 CellChangeTimes->{3.585764127374818*^9, 3.5857648653190255`*^9, 
  3.585764922067271*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"acfgh1", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"ListLinePlot", "[", 
     RowBox[{
      RowBox[{"acf", "[", 
       RowBox[{
        RowBox[{"N", "[", 
         RowBox[{
          RowBox[{"Take", "[", 
           RowBox[{"reshyper", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "i"}], "]"}], "]"}], "]"}], ",", 
          RowBox[{"Min", "[", 
           RowBox[{"500", ",", 
            RowBox[{"Length", "[", "reshyper", "]"}]}], "]"}]}], "]"}], ",", 
        "50"}], "]"}], ",", 
      RowBox[{"AxesOrigin", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}]}], ",", 
      RowBox[{"AxesLabel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\"\<\[Times]\>\"", "<>", 
          RowBox[{"ToString", "[", "thin", "]"}], "<>", "\"\< lag\>\""}], ",", 
         RowBox[{"\"\<acf of \>\"", "<>", 
          RowBox[{"hyperlab", "[", 
           RowBox[{"[", "i", "]"}], "]"}]}]}], "}"}]}], ",", 
      RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", 
      RowBox[{"Length", "[", "hyperlab", "]"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{
  3.5138692877918353`*^9, {3.513869770534683*^9, 3.5138697754642916`*^9}, {
   3.513869833636794*^9, 3.513869841031207*^9}, {3.5138700798364267`*^9, 
   3.513870080413627*^9}, {3.513877101658633*^9, 3.513877104498161*^9}, {
   3.5220267084084024`*^9, 3.5220267285480375`*^9}, {3.5265007002357244`*^9, 
   3.526500707650725*^9}, {3.526512741728583*^9, 3.5265127612137322`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{}, {{}, {}, 
      {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwBmIQDQEf7FFpBgf+6A/n7mhUQfkcDhvqJe2t1s2D8gUc
VO/xRq3fdwTKF3H49X4Jq1NpKJQv4fDuaoEg87ZVUL6Mw6oHZ1sOcK6F8hUc
GKVVUmJED+yH8JUc1nxim2s/ZwqUr+JQyyTaLW1zDKpezSF4kc6jFbeOQ/ka
DoHH+XYKWx+C8rUc7rWuNpbua4DydRy+FKluEenfAeXrObzbLdZslHQFyjdw
uC85adGNgy1QvqFDe9iGINtvu6B8IwcD+Y99h12OQt1j7CB5mY0nJWgdlG/i
IGMj6BSgDFNv6sDUzljyoW81VN7MgZN7cfyOo3ugfHOHZa8fLP5vCJO3cNB1
qX7Sv30NVL+lw+QNx2odT6yH8q0czh7paqrRng5Vb+3w4tvZYB2pQ1C+jUNl
z6ErExiLoOptHdz36SpdfrUbyrdzcDrD3dvc1w7l2zsoXLfnmcIIs8/BITpf
pGm34EmIeQ0ODkbhE/fJ7pkENd/RYdb21JxfB8oh6hscHZ7beHk3T1kBlXdy
yM/SLZS0gcZng5ODRdpMd5GMi1B5Zwfxrn82Bs0roPLODio+87q50zZC7Xdx
0N+y8BmnEDT+G1wcZr0s+1DvUAGVd3VQNWxqefZ/G1S/q4OGlaqQ18o1UPPd
HLZq/LZ3lT4JlXdzmPZrYy+b3FSovLuDyt2mWad1Yf5zd7Ari+y/XrAYar6H
g/709U829m6Byns4mGUdj2ufuROq39OhP3XqSsnUBKj5ng7x9rqPi3KO7QcA
SfThoA==
        "]]}}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{
      FormBox["\"\[Times]1 lag\"", TraditionalForm], 
      FormBox["\"acf of \[Theta]\"", TraditionalForm]},
    AxesOrigin->{0, 0},
    Method->{},
    PlotRange->{All, All},
    PlotRangeClipping->True,
    PlotRangePadding->{Automatic, Automatic}], ",", 
   GraphicsBox[{{}, {{}, {}, 
      {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJw1kmtIk1EcxodNCy2mXaQwLDM1xiaaWulme+buiJRl1Bcvk8IZ2EL2wcqR
NcsNZNgqDYRw2WW2ZunYbJqJzRkJKQwLyyzKVlINyw8yQrHL/u+Bw8vv/J6H
c877vkmV2kMnIlgsVtbf+e8ZHj9FK//HvIgWcFnTr3tp8Q2FcQ18sSrN/cVW
8rFYamqJV557TLwR686vHJ21OSm/GTx3tvPDKTvxVpR8TBAmjHUTb0ewvLH8
nttO/R3wBwNP2+pl5Hei2Wx6grI+4lT0L2sWfepHlN+FVM5gtTfnAXkuklxX
/XyDlTwP7ZPjmaxN3cTpsPcFuHrhFcpnoCrO/O2L+hlxJm77jiyXBuspvxtd
aWmfdB43+SwEE7V1GSZm/2wUpaWnrJ/wEOdAIC6dGpA2UX4P2N7vfMO0hfxe
5Dr4PE5NL/l92DahbTMYbeRz8SbgYvuLmP3yELfCcr5e7SIWwNMR2MJ3MO9P
CCvHlNie0kv9fJydu3XMMm0hvx8VtV8l8irmfiJ4uNEDs9eZ8wO26tDMDfXz
MDcAF4aMx8t0VsqLoTAnL+TbX4S5QYxXvx6yjTFO6heg2I/kd9xr1C9ApIAT
v+rgXepLUHig2mYIFVNfAttSxWR2Qyf1pYjSR8SeXPBSX4qOwYuFU5oe6ssQ
ap6PdJtd5GXwn4nuEqztob4chuFR4fjvOvJyjOUFWkfeDpJX4FJJ91x7403y
CugrHZ9jZMz/qERx6mHBTKSXzqfEyOzpxtFC5vur8J7DT67pGSavQu2PO+Ko
DS2iP1Yt9U0=
        "]]}}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{
      FormBox["\"\[Times]1 lag\"", TraditionalForm], 
      FormBox["\"acf of \[CurlyEpsilon]\"", TraditionalForm]},
    AxesOrigin->{0, 0},
    Method->{},
    PlotRange->{All, All},
    PlotRangeClipping->True,
    PlotRangePadding->{Automatic, Automatic}], ",", 
   GraphicsBox[{{}, {{}, {}, 
      {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJw10m1IU1Ecx/GpFT6UU1MLU8myEAmdOjVzuZ+b27xIYBOERmQZC1RGbKFZ
RM1Vw8jEmS8WORNdmGs6mTQ1IyvJFBIXYcOEpvYkzmXZsheWlvj3wOHyvZ/L
4R7OiSk+K5V7s1islP9z7bk+vvNXVtfGAp9e4K6J/Skgv5/aF67xIvPiymvq
IOwbz2P8Fi0D6x0KN/tBBttkJN+JO5bhcs+36+SR0Euybpa4DOS7MaJzRgVf
1ZDvQYi5YsfSi1byWPx4N8HI5huo92Ome2ukvrOXvo+DSleuYp4/IY/HzOgZ
y6Sij/wA1LE1F0YLu8kTcML4sixQayPnYFOEMoObYiNPQpvSUfn5aAt5Mirf
TtpPKVTUKbgmOuddIh2k5uKVJXGiasRKnYq/7QNRT/1vU6fB39PqCTFYaf10
RC9GaO5duUR+EB9/WsXQDpJnQLnXZ5U7Ukd+CNxHg/LN5h7qTNhPFzgCm+9T
85BYPK9IyxyiPoww8ZdbyzEbnYWq6uP1PcaL1HwYxv58GDOYqYH80COFx1qo
1YCrd3lcWvGGPBtKT6M1bI72q86GPMoRvz2oi1yAeTfPa1u7bv3/1QKEF+0q
ZmQN5EI4S23hSyfpfNRC1H/1vTHb9Yz2m4PkqUYJW24iz8Fl80JBUmkfuQhD
fhz9e6aaXARRk5e20bVxXmIEx/OcqbN0H9RilMl+cboSB8glYB4n/OZEd5JL
0CGcPp/Ht5PnwhHwUDM9PEyeC256TduUu4OcwZxpLE7W1E/OYEutoNZHUsf/
Bzfw+V8=
        "]]}}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{
      FormBox["\"\[Times]1 lag\"", TraditionalForm], 
      FormBox["\"acf of r\"", TraditionalForm]},
    AxesOrigin->{0, 0},
    Method->{},
    PlotRange->{All, All},
    PlotRangeClipping->True,
    PlotRangePadding->{Automatic, Automatic}]}], "}"}]], "Output",
 CellChangeTimes->{3.585764127701836*^9, 3.5857648668041105`*^9, 
  3.5857649221922784`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
  "******)"}]], "Input",
 CellChangeTimes->{{3.4940977943255997`*^9, 3.494097801075859*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
  "******)"}]], "Input",
 CellChangeTimes->{{3.4940977943255997`*^9, 3.494097801075859*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"ls", "=", 
   RowBox[{
    RowBox[{"DeleteCases", "[", 
     RowBox[{
      RowBox[{"Flatten", "[", 
       RowBox[{"rescold", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "4", ",", "All", ",", "1"}], "]"}], "]"}], "]"}],
       ",", "1"}], "]"}], "/", "1000"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gcp", "=", 
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"PosteriorPDFPlot", "[", 
      RowBox[{"ls", ",", "1", ",", 
       RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
       RowBox[{"PlotRangePadding", "\[Rule]", "None"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", "linestyle"}], ",", 
       RowBox[{"AxesLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<x\>\"", ",", "\"\<pdf\>\""}], "}"}]}]}], "]"}], ",", 
     RowBox[{"Plot", "[", 
      RowBox[{
       RowBox[{"PDF", "[", 
        RowBox[{
         RowBox[{"UniformDistribution", "[", 
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{
             RowBox[{"nbp", "/", "1000"}], "+", "1"}]}], "}"}], "]"}], ",", 
         "x"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "0", ",", 
         RowBox[{"nbp", "/", "1000"}]}], "}"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Gray", ",", 
          RowBox[{"Thickness", "[", "linethick", "]"}], ",", "Dashed"}], 
         "}"}]}]}], "]"}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<kbp\>\"", ",", "\"\<pdf\>\""}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{"withdata", ",", 
    RowBox[{"gcp", "=", 
     RowBox[{"Show", "[", 
      RowBox[{"gcp", ",", 
       RowBox[{"ListPlot", "[", 
        RowBox[{
         RowBox[{"Thread", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Rest", "[", 
             RowBox[{"truetreeloc", "/", "1000"}], "]"}], ",", "0"}], "}"}], 
          "]"}], ",", 
         RowBox[{"PlotMarkers", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"\"\<|\>\"", ",", "20"}], "}"}]}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", "Black"}]}], "]"}]}], "]"}]}]}], 
   "]"}], ";"}], "\[IndentingNewLine]", "gcp"}], "Input",
 CellChangeTimes->{{3.5151542331332865`*^9, 3.5151542727573557`*^9}, 
   3.5151546479696155`*^9, {3.5151553807839174`*^9, 3.5151554013239465`*^9}, {
   3.5151554935340757`*^9, 3.515155514984105*^9}, {3.5206809584687862`*^9, 
   3.5206810138332834`*^9}, {3.520681107605048*^9, 3.520681109867052*^9}, {
   3.5206981668889093`*^9, 3.5206981714441175`*^9}, {3.5206987598189526`*^9, 
   3.5206988482711077`*^9}, {3.520735615523278*^9, 3.5207356167556806`*^9}, 
   3.520785828810192*^9, 3.5220273759248753`*^9, {3.522027451460208*^9, 
   3.522027452037409*^9}, {3.5226007397754364`*^9, 3.5226007404504466`*^9}, {
   3.524257549560072*^9, 3.524257553450077*^9}, {3.5242576347702117`*^9, 
   3.5242576353202124`*^9}, {3.5242576993303165`*^9, 
   3.5242577516862044`*^9}, {3.524322842750496*^9, 3.5243228459953017`*^9}, {
   3.524322886071772*^9, 3.524322905790207*^9}, {3.5243231572242155`*^9, 
   3.524323158054263*^9}, {3.524974622206944*^9, 3.5249746491514854`*^9}, {
   3.524975405549749*^9, 3.524975415209301*^9}, {3.5249755013372273`*^9, 
   3.524975508141617*^9}, {3.5291586114271746`*^9, 3.529158635513617*^9}, {
   3.529283797837824*^9, 3.529283813593852*^9}, {3.5560728224641995`*^9, 
   3.5560728349389133`*^9}, {3.5560729072640495`*^9, 3.556072927856228*^9}, 
   3.5560729632092495`*^9, {3.5560734339618397`*^9, 3.5560734346638412`*^9}, {
   3.5560887978637457`*^9, 3.556088798773798*^9}, 3.5560893109560537`*^9, 
   3.5562678921645803`*^9, {3.5562697192283916`*^9, 3.556269722239197*^9}, {
   3.5567006963573937`*^9, 3.556700697852417*^9}}],

Cell[BoxData[
 GraphicsBox[{{{{}, {}, 
     {GrayLevel[0], Thickness[Large], LineBox[CompressedData["
1:eJwVV3k81O8Td3RIzsqZW650WMeSa8aydlV0OJJc0SoquQuRr6yVc7E5djdR
EkpKSJRKdySVhEiOolLuSNJvf399XvP6vJ6Z97zned4zo+pzbDdNgI+P7zs/
H9//v5vNc0Wd8/Pv8fEhPVHJxHJBuby+oen0Pb4msSMTytLwIqh6G83tONy/
xb/5gbImbK2v67K+eAG89aMlypSJ4HJGSTF/xW1oGzPmP6dsCz1BrxsfmrfA
CYec3znKLnB+qFx8b0cvtMU8nslW9oO4Apk69Ys/IVaqNzRLOQKG37SYH9cd
g9oOOjn+VAQ4LI9/8OLmGPzM3SQT0hcBYiYRn018xsFTPq5+1/nj0FP46Wdf
yASAsjq/pHIkRIbU8G9iTYGAjn96htJJqJLy0nrRMQs2BVFOT8T+gy+Vt79O
yc/Bp0UHi0bL/0Bu65qril5zcNJLXbM28D+Ii32uFzw8B9UqLbOXWv8Dh2ED
U9m537DuoiKHnh4P3+uE7P3kFmBZ6f1+G7EEWLVp7xb+TXz47MayYw9FGUD7
VfH9rT0fFswLZ6eZMqCuUaCg5CgfhlmL39pzkAGeO64KbK/gQ6V3Mv++32fA
laB/zTkb+DFiTjtjTVgS2Ny85LlBVwDXwbZKWvcZyI2el/i3VQB/M3a83bw8
Gb5Z73j4OkAAX7U5zv42SAZm+5zW8XIBjPJxh/S0ZBjk2nfbvRDAHVe8fV3r
k4FIu5Cq8E0ANaYPMNSGk6F3ZtvEAx1BfE0/+qoWU0CvsfAiy04QL7cGT8Ud
TYGExBnng/6CGCsTIbONnQLvHbYKmZ4RREfvKDOppymwXuZ8vUiZIOqUxXr1
TaVATN/Ukb5ngrg4EX+6TCUV2i5TlatGBLHdlHE51D4V1IPOvU4QWoLrHpzs
f3wkFSJMJk/v0V6Ci4Eyk3AwFZ7zUYjrqUuwU6FKoH5/Kig854wsHFyCN15s
X23ongpNe8n2Fy4vwQOa8Ybau1JBPDpP+ofmUnzROxohYZYKpXcty+I1lmHe
9qY/n8RS4QMppbVCTQgJ648uja9NAdZMdtUnKyEcGTjwRuZGCjiUcnNW7xfC
8xz38xVXUqBJ9Jpn5HkhFBXdvqWrMAXKO9t+2iiswK9j64/qpaTAiUBp8R4p
YSyqGWn/6JUC0uyiHcIrRFDC6kCx2YoU2Dlxq81vTBzH9uyzntmXDBKHVlpf
01+D+CtCbsVQEly0LCf5asgidczL1oDOq7+SODOOKItj1LBg0ikGyC2G9p6j
yOLZC0ncXZEMyLhrcaLTXxYHnG9MHjvKgGjz1xX212Tx5B2B81edGeBoOidr
YiyH189cmtXQZIAg0XZMxE4eZdZ9L5V9mgiNUlfM17vJ492Yf2+1HiRC5Ix4
MuWwPB54v/ofsSERxqq71sWnyeP1ZHNn58pE+GBw1G32tTxunUjjz8pNhJsE
1uN+t7UY26jntvJQIvhuHODUHlHAz64RKxeFEmG3gKpAQowCHro7PKktmAj4
3uvQrnQFHFXd2+34lw4K//UajlYq4PQ3s7KyCTp0tHe+VJ1SQMEYfopzNx0e
lckYjgkqIqM/ZFNcOx2qYl3Yd9Yo4krbIakrrXTI0G7320NUxFXiT4f4HtKB
evLVv9RIRVQrSo2/eoUOxF1ifm7Jinhp6aL/+0t00NC0b9HiKKJOwLFdAoV0
EGh7kdd0RxEJBrtVXFl0GC9e8S/jpSJW5z5cfjqdDh8jqTSPj4posmA4VpFE
hxYHRvP6MUW8413S0RlPhwb1J4S5f4qIj2UaBWPoUD63JO+xhBI+6TyWmJlI
h7yX1otZqkoYFzB6XJNJh7DjD15stFbCqbTPbjsv0mFT8x1f30Ql7G5/r1L8
nMdH4Z/nerlKyPJzWrXlLR1WhpvqLV5WQoe5NsHWHjqMKNUt5D1Xwqa1L77M
jtGhKOTm2VYRZSzzuXN1m3QirJEvf7olWxlPjBeaTPkkQkx1s5TQThVcIxKw
k7SQCE1/DS0+7lFBJ9cZmv5SBghRCg5Ue6lgTnFctJoYA7K7gm56H1NBWYvc
EgEVBpQtSu26na6CioGPFpqsGfCO6p0a8FIFNduUyqxTGLCxd1rg5VZVNGa9
5SfLJ0HvUqXxTLIauilY3KSYnAGnQfPZANo6bDM3oKUXp4BP2FsJ1f2aqPTv
vXzBcBrg85KZ4UOamJvV8uzkeBooKUV1XwvSRAnNBxH7fqdB91OVYvM4TRSw
L38juzIddq0NNHY9r4mf2SeTszelAzYJeWb0amIFUXU+KTwdlCQsr/zdq4UW
gQFdoYIZsHBAkvlovxbW8nsxdotkQPftobAUfy3cfNbRiCCVATm+KZZykVqo
esc886dmBoje6nxtmKeFS4XF7fy38s57hM4d7tDClks36zwzM+DDlVJy925t
rAxcbC4WZ8I3/c0Ht+7TxtTFnEtha5gwd7smqd5XG/3TN5+ykWPCmmdNzeww
bVS75q0/pMaE7UM9u/blaOPZH0156kQmuB32DW0u0MaQmH0hU6ZMODT5lWV2
WRt3iE5vewhMoPPNvl9bp40rNmr887FjQqOCpGdPlzaePMKgXXBnQsvF3FPb
B7Rx74IyhOxnQvd6paI737SRmFonS/JjwsiN4qYNU9q4SmHXpORhJsya6A5x
/2jj+JWvzf3HmLDs/o2lokt0kKp2I/xOBA8vxUQrRkQHVYY1XF6eYoKeMznA
Q1EHXwWJy4xlMsGypznlpYYOlhglzP5j8/Lx3V1hsUkHY+fn3ksUM8E/2Gtc
EXRwU8JAnn4tEy6kRUZ89NbB9Nwa+YhuJlxfw5fn4K+DNPf1fxIHeflwEm83
Buugher5D7mjTPhQlr1QEK+DP8qTuLcXeXieVMR7Fevg9sZ9Sn/VMiFxsT/9
07AOCn/mV0s4nAn+x7ZeHghcj4n6DjpZC5mQ9sV37TO/DVhtPTr+S44FT7/a
3VlI2oTurEOf2w7kQK2dsTl7px5e6W+pHCvOg6D4dlq8kx5u1yzsdarIA92G
4IwAVz0cCwhdWV+TB4Ubrg6Yeuuh4bTcwYQneZAsrnrmwzE9vLPsoJLcSB54
vhPuUMjQw1Zd/jSSbj4s3f/x2PmXejgebhRw9kY+3M+Pzme81sPseqG8+dv5
EPVG9uGxdzx//z489mrKh5/WjtLYq4fHk+JV17/Nh07NZ3c+jeohH+dVZ+N0
PlwdvbFCTYSAq+77U0aM2eCnscNAWIKAN5dYhNsjG1Q9R90nVxPQxU7iYhWV
DTmvNK83rSUg503t4sm9bIir4rj46hJQ/bNgrWQ0G5xO0C8WbyWgkXDBOrNG
NmhuPXm434GA7U/Xabk8ZcPvtaEGSo4EDKdf0QluY0PBPe+HufsIWMN3e9Pl
ATYEZ+5JafcioHMjEJq+s8HG18FR8gABf0U/MeidZsPXZeaDyUcISJx9a7J6
OQfudOpfeRpEwPfVbmabJDiQXq4TuiSc5z+k38JOjgP7T6qYWUUSUFrvEB5Q
44Chg4xgbAwBb/34STqly4FlKmLN9f8RcLfJpVKFjRzomliSPUsn4JXGxOe9
6hy4+vCPm2EyAZeQD30rkOdA7NlJteB0Ano22630luTAzoNfv1VkEbB+l+4G
VSEOqG/5VPUth8dnp4j9wCIbnvW8JB04T8AnQ6/SD4yyYfW6Mp891wmou+i8
yp/HR2mV1wWLNwSc1fORC4lhQ1SCS0BUBw/PLWtTgzA22LvY69/qJmC5hca+
6QA2TP42bdIb5MXfOsKNcGWDhZX0gPo0AR/5BqpEG7DhzasWVWFpfWTmRGkl
fM2Hv6Nbijr26qPmQpZRjnM+EK85qzd76KNDWvDyme35EHQs+NK9/foYprSz
y9EmH4YmSstK/fWxEUVjJA3yoeWXTFVUpD460RmPUiXygc33q0kpXx8TxU46
nm7OA+M1VUN+nfr4WYUWHGSVB8Fm67VnXQywmGxcsXVjLoy/iiODvyFGrT0y
1tHBgku3IsaTIozw3eju89SULLgSS3kdHmWEw1niMnXxWXCDLFvlE2uEv01a
0rWisuDu29uh5olGqEgnxy7zz4J3Ywu/xs4aIU3RxOORbRYs1T7916XGCKft
FdeiQBbQ8jKENaaNcFXlcI5xZCYc9vL+LjlnhOuci8UuB2VCsCahZfGPERL/
eCdKH8rk9a83aZ2CRHSjdIfPuGTC2TYpydTVRCzqa3G6aZgJj4W4MlP6RCRI
VK3aPM6E5ldH5vqIRLSuDUwuGGbC6xyLrhZTIjq56wqI9TGhd10fu4RExBOl
xROjL5kwg2pKbruJeB9z28qvMOHP8qlFWxcivvniSJW/yAT+Vw/7DNyIOJQq
cf8MT+9EPWhFoj5EFOo6U3noDJN3X4jx8zQiyp2y1eqMY4Lc92W+w/5E1NUQ
PE85wQSNyNJ1D4KJuCP4ZLrmQSbYdL25KBBBxMy9vrReDyb4bPmrZhNFxHar
reYsJybE5WtdoMcSUXY9YfW2bUwo+L1L9Wk8ETmm0Ro7HZhwZ+/JQiEGEfmk
zu7p38PT+9slyltTiEgbu3bm//ovHfVH8WU2ETcXD/xghTHBsFvjnFgeEVmx
C8qasUzYbbpTYSeXiL9dpXffYjAhY75Y/m0xER+Lbq3t4uUnFO0g01VDRPfj
N2KVHjBB88OJHPl6Hj+7mq9XvuDhN7so5d5IRI0NnwewnYf3z+zqvidEHPsk
S/Hl8f07ukji83siJm6NEy8VzYRvJ6dXTPwm4nXFHYUEt0wQ6lU6o79IxDVz
h940+WaCpoWdUJiAMUa9iV/idDQTfP+eWzYrbIy2jNpDEXGZ0BNDEfy71hh7
xhUJDSWZ8DKWvSBkaYzLHo0+sJnKhOtxOKYSb4zuAcmDe1KzYJnPGutjcSY4
YOC1Z9kzFmTlMNbdi9yCSZIOHVFzOaAjuZ9LTDJF/eZWTowrT4/9aIbaqabY
acvetG8/7z01+LfIMU0xron2wCSA9/78QhYWck3x9e2FL1PR+VDbcNr94WVT
DCxdrx9wPh9IfiUKO5+aYhk98ZnLl3xwa/jO9V9mhkpoObOZpw9XJcYN9wmb
4ZOGFUmiPP34S5tu2S5mhkeM38l/p7OhUOLvwmZpM2zYdARLctnwhSbm8UvD
DF0V2SkKDWwIkSAoniabYfb8jOoKAQ48ohnVhNmZoVnEg+ovwhyQathi72dv
hv0TqZRHqzlQRyPF2Dmbod5X9aOnNDiwWO/YK04zw5fvd9XNUHl6KOEazu9v
hhGOitve7uJAEc1ddOqIGSq8Gum97saByXrvS0NBZti0tToo3ZcDNhI0i44w
Mwx4ckrwyBEO5ND83z09YYarSdty7MI5MFJ/9Ojtkzz8d6V1tGI5YCoRsvRK
nBmu8g30ukjnQAot4hw3gWenTY27JXJg2rH97UCSGWYQjD6rMjjgSdIX1kkz
w5UdEV0jPFtf+WdEzVkzFFSefxBxhgOdnbSdrSVmOH2dLzsrlQOa250F+Z6b
YUe7qNGLLA406Rv6+4qaI1tBO3LLeQ7M/ZswXJ9jjmpX3fll6zjA/iHidvuC
BZr/+nVudIQDy2t8hYzPWaL/jW1GJ6S5YF4WcS68yBJfx9KeWMhwIeTcGf3q
S5Zouv3UHkFZLnykV7oTrlniyuGqyHQ5LtS6/Lmue88SKxTkG4sVuOA3l7VX
pd8SJxkjtq/VuPDIrKl8hQbgSU+66/rNXJjf/A6oOoBDuue/jvFsvXUj7Ykb
Ae1/10XV6HGBKyL2T5AIqMQa5aI+F0J79zou2gLef+7Y72LEBbVTE38mDwEu
NVILOG3GhbgmFfueq4DpK+9F91C4oFjiyn1zHbCh6eEIi8qF+jPM78+qAUci
nznb23Fheidfcs0dQNLI682NW7lwqK/vSXoL4MyjocHz9lzYtVCAVqOA7rHC
230dufCzryPDeBzwjJH47bVOXEh9KNa3cRqwdnS1ZjvPfpIcGyO/ACixT5GP
7MKFcyKbe38vRXxorFetuZcLkhwx+bdSiOsnnBW+eXLhU2q5VasM4p5StzMX
vLhwLdbW/7kcYoKX1y83by5s94mtu8dbnz6+PNTWvJ8LiTo/Xa5qIGaVRydU
HOCC09rk2MtaiI374yZoNC6oi2qWXNBB/C5L91Ty48L9cY+ZvI2IZEa6ScZB
Ht+3XmbTjRB/+xaNBgVw4VmZf0OcMaLG2pK9Ooe5kMtZOhi9BXH3m/In/Tzb
L61I+LgZ4qkzlQbsI1wwPGWhH2KBeBWrC3cf5YJAcNfeo4DYNVsnujKQC699
wv87ZIX4rSJwXIUXr9BJsszXGlHAw6ZxrQcXAm0r2jzJiCoi8qnSPD7NTezm
9lIQLRvG9kry6rFy/WdlZztE14DHWiLAhVJRxWPb7BHTnwU95NflwkB7qqiJ
M+LfhKfzowJc2LPUxkRnDy9/y8P28r850GL0x0d+L2LsnFghZYwDtTn+dQvu
iP8Ou5AvfOBAsqut74MDPDyOnzP2VHOA0POvbmsY4kpVQY0mGgfiBkMOeGQj
yt+13JH7jA1Kk64N8a8RiTM1F63S88Fb39Vwv6sVfrVHC+mhHEjympkgdlgh
7fr9K9yDLHheKJvn2mmFGaoWj9vdWSA8YGYZ1W2F9Vm3P4rsZkHKgfjkux+t
cE14lWSMOQvS/cXVbYatsGlL8XEPSRZkh+o47ZqzQo2HDGulhmwoYHjUHpYn
4ed3Dh/Oi2VD37M49zQFEopTmqffC2aDinCxQKUSCU3rKGISv7OgKPWbw6Qa
CVlstIobzILizOPDJ3RJSPLSv+xdlwXlnEzZRHMSFo5Ihar6ZEFN5eOoQk8S
ev/pEb5Ykwnlh/78PedNwkqbiu+ZVzKhQJXwH8eHhEvSY1riinj7RTaXkeNH
wgoVpXTPtExwPR7KSg0k4QzZS1KelgnzlqrXTsSSkMnsl8lckwk/Z10IEXEk
HOq6MXdKOBMGrqdWh8aTcIt6fFcgXyY0q83VByaSsLdGjbOdt99wl716eiCd
hOs/+CoJPeLtU60n+3cWkPCxxpd1p0KZoM+oOuBQSEK5Y7VLA/15/RdHhrdd
IGFgXeIXdy8miFc5/rQtIeGqbVqlprz54NPZ9X/Mr5HQK+iQ7i/eftnu4B1r
ep2E1bdNRD7LMuH58hx+kyoSCgqu+PFWjAlVkfxCBrUk3KHr6OE7kwEl+sYp
enUknLs7pWTVnwHs70fENtWTsGgn65PSywxIL76QqXuHhFsHDS8s1GXAaY/O
NTqNJPwa/s63uzgDTkiL5WneJ+G3FY/3PcvKgCOvrNeuayLhfOn7uMH8DPBO
iixQfUTCFdRvlxYLM8DJqlJV+QkJZYcXXsiVZgB1fqhY4RkJtRPFxw0rM8Di
pry2/AsSmmuoSe2szQBNjcRNUq0k9PSleCU+ygD5jw03VrXx+BBwSyhqzgCx
3AlDiTckjC06UnbnTQbMCnmYrezg1b8vc2ryUwY8GzWg8n8k4cC+HobX3wzw
HUpone4j4dOkyf90BZiw+OGd00g/Cc8N/oLLS5lg0Hx8/6vPJKTk/2soEOHN
X2UNUed+8P4vkaxOk2dCqJ91xZa/JKR+MCg+zNvflT7tXhWiYI0FSZEJWoFM
CH8b3DPgZo0Og0vI53uZoN07YOY6YI1Bckcqgl5lwv23E32PvG1QYfuOINUb
WaDZc61/xMcGv8rP1U9VZ0Ha0OFBEZoN1n0tXPqEd5/dZj5/cfK3QSfGJDvg
fhZMS3f/GAq2wZSms49vvsoCbbemP0tO2+C8SY+87c8syPiUJUO+ZIMdGv6P
A3Sz4dfIDjn/yzZYPC0pYbE5G9wnRNamldlg8MN6N3GDbNAWYCi9q7DBlftF
xm+aZkOTerQGrdYGrbmV8n/teOf9fA3oT23wxqpfxzIOZYPnD4Mdj7/aYMa/
ePnqS9lw2FDEqe+7DZZ3lTDDyrLhRPSQ6+8fNvj45otlRhXZkLXirM/GSRv8
c3DVVE11NjzW+BV+dt4G/dqKmm89zIYNnnVc2koyWhTdP9nQnw1bLjGLTomS
0TV6aDL6czbYjh4qyRcnY5izkL/512zwjpK7/nI1GctX7HS+O54N2TlRD40U
yCgV0rfx3r9smG81/7Z0IxlHSYsfmxRZsFxaakx5MxmXK6o5n1ZlwRqPH1Nb
CGRUmyU3W2uwYNP3c3+PGvHiXUm79WgDC8z0IwSSjMkYSr+xka7HAmqkw/IL
W8iY7vXuItmQBU73NUXumJGxdMtvuWUmLNi//J9EhwUZH65WZD4xY0Ggw3up
cSDjxx+4jAEsiDpbKS9MIuMvPrgwQmYBo4ehvM6GjLlzwg89t7OApe69ztKW
jCbjHYPtPP18Bg+MSxzIWN+67GDFERa8S8w3v7+TjG5P3jDUQ1kw8DLYqns3
GefvFpTmR7JgYZ/aNrE9ZDSrIH6jJ7JA78RpzwgvMt5N8TvqWciC3Otkum0Q
GRupT0LF21ngekzvoHkIGaeqnkVJd7NAdtNaO/0wMq5TbP5P8RML8q6Miyid
ICNj4lWG7igL2CUc1swpMjqxu65QlpyFAu7ExeIMHr/fRwdPGZ6FkqRzTQKV
ZFTKWO00zjoLNd4z/xp/kDHmnbfha+cc6DLoJDeH22KY+z5B2blcGJhybWud
tkWVpEmvvNh8SDIq6L//yxZPLqNczU7Ih83HByer5myxJ4Ezl56cDyfnj0rl
Lthi3n82mfScfJDmP+3mtYSCEtE5TSHX8mGbWMXQ2GoKCgaaath/zIdqbf7f
EgYU/OIY/43fkg1uAbbCgkYUtH7TQfxrzQb+qylrZ4gUvLBT9/ScHRscNktb
dplS0NO+fe2YMxtGjHRPF5Eo2GGrad9zlA2K1s6i+rsp+GLLi8rac2xI9ChT
dQymYIXyqvDDf9lQd3ht/LFQCk4qFr4bEeTA98i0gZRwCpoqbCL68ebznTnB
Fx9FUvCp7NZZbxkOrH21RYMYT8HPkvGRLgQOXMcX2nLZFFRcMhljxevPgw7m
Z4zOUpAmEPex8TAHpD2ufd2Vy4vHJwbmIRyIjswqT+bw/P/V4TM+xQHbKrcN
Cxcp6Pprf/yGfA6cuN+SKltCwXPTYwNlvHn4SqvlD8NSXrzJGGutEg5IfFe7
dvQqBUPG8peo3eTAB/Xvm/uqKcgceZ0o85IDYvoezD+1FOz84jXMesvhTT6v
xmVu8/B9/kFZ1c2BUAerXYYNPHyD0aUZnzhQ4n7zxs67PHz9K1aIDvPm9QCN
VUfv8fjoy/VP/sGBlZG5IWce8PB2t53azvNvyVjx9tJDCg6+ufk6t4ADQWej
DZoe8+rRnKM+eIwDFy/+yP74lILbHkWGb7LiQMcNr+n55xScvuP+NHIVB8xa
rWsMWinofk3tsEQNG5YtFzG+1EFBmcxrVRbz+WAiFZv7oJNXvzOZS84058Nh
9fHZ3m4KnooPc2nn5kMbtNdJ91FwONR0PgDygXOCa5o0TMEilydWeQl5oPdt
g+XhOQpuUPjYNimWC9JBN6J95yloU7ZY4zGYAwszRrf3LVDQg6jMeXYrB57z
g+F2Pioe3+lNK/DOAR+5Xes3ClGxKWHgt13VWWBRw6XHZKi458cXtSJnFsyV
3P0ZYkzF+MaxsB3cTLjn63A+KoKKPQ8E9F0dk2DhevR/FSeoOHxY673wJANM
Fkt9P0VRUVl6+8m7TAZU5Qlq256iolHA2SdqrYlQ/LLuumQSFetXae/7QaXD
GWP1ptJ8Kub52ifEW8aD48q5oY47VLwsrFex1/EEMF01nq64R8W7npGzjczj
0HJpd5n5AypuuNlkta41Amyx4uiFx1Tcu8+54yc1HEzCfX4dbaWi79Wof6ct
Q0Cxr2X50k9UtOAmX3R3PARuG+a/Gg9QMcBG0USr1Q9yIrVaAoaoSPlR2TJB
pYHEmnhm2wgVCy3ezSRa+oCAnbEcd4KK/veA6ePoCpY5B/60TlFxnSTt9izV
GaIHM3v5f1ExZn/yQKrlbpiOGS06OE9F9eXl/oGOVCA0yyWwF6jYcXm6Ic+S
BIGyFL+Xi1SUyIxVSHQ0gXJaGJWP3w7nKrXiaxy1YbiqaL2BoB0+pV5Pba+i
WP4PyCfSag==
       "]]}}, {{}, {}, 
     {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
      LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQrdT/d/E8uY12ImAwxf7UxNuFL9Lv28P4XnvZ/Z6l
v4fzz/KacbLEMjjA+E79rgeW+3PA+an6v3gNeQXgfF/N1I9i7iJw/qYrtaUn
LSTgfGshrfUs9TJwfvrvSXOXRijA+fnHnhuv91WC87ui2FT/5qjA+cnHq9MM
M9Tg/IPskoHZkRpwvqFgw7SXJVpwfsJnWx2/HB04f+G8ozLfe/Xg/M19Vrcv
BRnA+SW7bAPm+hjC+ftPLf3UGW0E52e6W+7NjDCG8+esMNyanWUC50/8vLex
oNwUzn+2qrQso8gMzj/iNmlGU5M5nM/of+tRf4MFnM/guI1xQaUlnN8h/t33
UrsVnF8QlXzoe7M1nP+w0STFfqoNnC8yeeatzoW2cP4yAa3K47PtEOFVJO+q
vtoezp+nsEDGNsQBzt9b84sh4wKCr+jN/kc53BHO33Jes/vmFQS/59g/A4VY
Jzh/cvHLrIQ7CH6NqBy/UqQznL9Sk/VUyQMEn+0Lo+TBOBc4f7nBxrp5zxF8
zaRVfn9zXeH82547N4W+RvAvLa7StS92g/N/bA60UfqE4P/fUbS1Lc8dzvc2
cHOt+YrgH4/Vz8wu9oDzrdgDNmzdieCv21Dw/f9/BB8AFP/2Og==
       "]]}}}, {{}, GraphicsComplexBox[CompressedData["
1:eJzt04krhEEUAPBtQ3KHkJC7FdK6Fotd1pljc5W0SRsld0JCciRJkuQOyZVC
kiRJjkW7SpKSkJAkSWySUGYm3mv9C3bq6+vXNzPfezPvOclLU/O4HA6ngTz0
3dFXYt68oRJxfob+rF1WrvAGPDhAxzPY+vTgLe1GR/zruKsay/lYc7Hmekfw
9itP1tnkBE6Wm2UGL7mA2yJybg/lruDiu4+Z5yN0ooDOcAd7Lw4/Te/ywL2S
9qK7Wg9w9mq8EbfQC+xy9l5fsOYDlnVuvfLO+X/2R4+Q3RMEvmAWzhx6Wf11
XH2PZvvL/MCtVuSAutFdj3WigBG0CU1gzx8cRcL/UKLd9Bp7JIWB4H56PQYC
MP3cboRm8XWg2f/Cg8B+dKiDwcqq9VFb0xDwpmosetkCzc5Hhr535+vPnqP3
yXR1mBBMLv+qJh2dTwPIQBesVXTbKNCXUlJx5aHg1BWHloeUcM38itAsP2MR
mBbr2A6aFNul1F4MptfvOY3+JMuTrtGsPg0jwGEGJ+Nlw2i2/yRaSAN2iASz
8teVgKeGFI4LvugLV5JBGrqWHpAKHUnK3fkMzfJ7jAKzfnlBs/i50WBWr3lo
T1Zw6FKaAD8GPFFGM4zVzK8yDqztf23/a/v///b/N7160e0=
     "], {
      {GrayLevel[0], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 65], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 66], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 67], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 68], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 69], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 70], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 71], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 72], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 73], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 74], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 75], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 76], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 77], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 78], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 79], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 80], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 81], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 82], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 83], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 84], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 85], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 86], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 87], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 88], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 89], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 90], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 91], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 92], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 93], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 94], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 95], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 96], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 97], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 98], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 99], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 100], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 101], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 102], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 103], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 104], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 105], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 106], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 107], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 108], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 109], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 110], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 111], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 112], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 113], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 114], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 115], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 116], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 117], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 118], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 119], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 120], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 121], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 122], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 123], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 124], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 125], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 126], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 127], InsetBox[
        StyleBox["\<\"|\"\>",
         StripOnInput->False,
         FontSize->20], 128]}, {}}], {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{
    FormBox["\"kbp\"", TraditionalForm], 
    FormBox["\"pdf\"", TraditionalForm]},
  AxesOrigin->{0, 0.},
  Method->{},
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->None]], "Output",
 CellChangeTimes->{3.585764127888847*^9, 3.5857648674371467`*^9, 
  3.585764922285284*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"dist1", "=", 
   RowBox[{"EmpiricalDistribution", "[", 
    RowBox[{"Rest", "[", 
     RowBox[{"truetreeloc", "/", "1000"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dist2", "=", 
   RowBox[{"EmpiricalDistribution", "[", 
    RowBox[{
     RowBox[{"DeleteCases", "[", 
      RowBox[{
       RowBox[{"Flatten", "[", 
        RowBox[{"rescold", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "4", ",", "All", ",", "1"}], "]"}], "]"}], 
        "]"}], ",", "1"}], "]"}], "/", "1000"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"gcpcpf", "=", 
  RowBox[{"Show", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"DiscretePlot", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"CDF", "[", 
         RowBox[{"dist1", ",", "x"}], "]"}], ",", 
        RowBox[{"CDF", "[", 
         RowBox[{"dist2", ",", "x"}], "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "0", ",", 
        RowBox[{"nbp", "/", "1000."}], ",", "0.1"}], "}"}], ",", 
      RowBox[{"Filling", "\[Rule]", "None"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Black", ",", 
           RowBox[{"Thickness", "[", "linethick", "]"}]}], "}"}], ",", 
         "linestyle"}], "}"}]}]}], "]"}], ",", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{"x", "/", 
       RowBox[{"(", 
        RowBox[{"nbp", "/", "1000"}], ")"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "0", ",", 
        RowBox[{"nbp", "/", "1000"}]}], "}"}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Gray", ",", 
         RowBox[{"Thickness", "[", "linethick", "]"}], ",", "Dashed"}], 
        "}"}]}]}], "]"}], ",", 
    RowBox[{"AxesLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<kbp\>\"", ",", "\"\<cdf\>\""}], "}"}]}]}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.52431717736788*^9, 3.5243171908450985`*^9}, {
   3.5243172723260136`*^9, 3.524317281186026*^9}, {3.5243173228820844`*^9, 
   3.5243173251520877`*^9}, {3.524317507912744*^9, 3.524317570992832*^9}, {
   3.5243176467229385`*^9, 3.5243176512729445`*^9}, {3.524318158751057*^9, 
   3.524318159181058*^9}, {3.524322854076116*^9, 3.524322856962121*^9}, 
   3.5243229863643484`*^9, {3.524408613295044*^9, 3.524408654603916*^9}, {
   3.5244086848679695`*^9, 3.524408686381172*^9}, {3.5249750990852203`*^9, 
   3.5249752949294214`*^9}, {3.524976038197934*^9, 3.524976181225115*^9}, {
   3.5249762187602615`*^9, 3.524976230930958*^9}, {3.529158657026055*^9, 
   3.5291586604736605`*^9}, {3.5560732759221506`*^9, 
   3.5560733613437123`*^9}, {3.5560734001409807`*^9, 3.556073405054989*^9}, 
   3.5560734699979033`*^9, {3.5560886573407087`*^9, 3.556088664833137*^9}, {
   3.5560887539202323`*^9, 3.5560887540802417`*^9}, {3.556089328972084*^9, 
   3.5560893440419464`*^9}, {3.556091417062812*^9, 3.55609141947095*^9}}],

Cell[BoxData[
 GraphicsBox[{{{
     {GrayLevel[0], Thickness[0.003]}, 
     {GrayLevel[0], Thickness[Large]}}, {
     {GrayLevel[0], Thickness[0.003], LineBox[CompressedData["
1:eJxl2MtrXHUYxvHTi/fxUk0v06s1OsZcG08aG03SMUYTYVbushU8Ll3MP3D+
gCzcHleuBpfCcaHgYhARlaOg9cKIl2r11NZWK6OiKGIzz/v7PbyPAT186ZzP
PH0pRTz57AvPPLcnSZJd1//5/fq/dif//3mp2Pl546zv92IvpDs/56xfPItf
H8TG83xsfP5C7OeznZ/a+mV7/1LsD6qdnyux8bwmn//V+hXzh7Hx/m+x8X1/
xMbzz9jw/hLvb/H+Ee9f8ZK2/zwb/q62f393bHzfnrb39oq3V7wbrF8178bY
8G6KjefNseGx4d0i3q3i3SZeQ7yGeLeLd4d4d4p3l3yeDZ89ej3dJ9+3T7y7
xQv9mnls7LknNjw2nmOx4Y2JNybefvH2i3dAvAPiHRDvoHgHxTsk3iHxDonX
FK8p3mHxDot3WLwj4h0R76h4R8U7Kt4x8Y6Jd1y84+IdF++EeCfEuzc2/nyx
4Yd+3d5n4/vYeJ6MDY8N76R4od80j43nfbHhseGx4bHhsfEcj437jIs3Lt64
eKH75t0fGx4bXui3zGPDY+P5gPXb5rHhseGx4bHxbInXEq8lXku8lngPWr9j
HhseGx4bHhvPCfEmxJsQb0K80O+a91BseGx4bHih3zePjedkbHhseGx4k+JN
ijcl3pR4U+JNiTcl3rR40+JNixe6Mo+N50xseGx4bHgz4s2INyverHiz4s2K
NyvenHhz4s2JNyde6A/NOxV79PkmG3/fsEfvd9j4vlPey8UrxCvFq8SrxUvm
Zd+899J573XmvZfNey8XrxCvFK8Srw79ke17ODb2sbGPjX2hP7Z9bOxjYx8b
+0Kfs31s7GPjmVp/YvvY+PPDxj429oX+1PaxsS/0Z/DK0J/bPjb2sfFciI19
bOxb8F5nwXvZgvdy8QrxSvGq0APbx8bzdGzsY2MfG/tOey877b1cvEK8UrxK
vFq8ZFH2LXovXfReZ9F72aL38tBf2D429rGxj419bDwf8V4z9Je2j419bOxj
Yx8b+0J/ZfvY2MfGPjaeZ2Jj3xnvpWe81wn9te1jYx8b+9jYx8Y+8WrxkiXv
NZe8ly55r7PkvWzJe7l4hXileJV4tXjJo9bf2D7r/LztY2MfG/vC+9/aPjb2
sbGPjX1s7Au+ecljsbGPjX1s7LNOvrN9oe3/Y+Rs7GNjHxv7gn/B9rHxueXY
2MfGPjb2LXsvW/Zebp18b/vY2MfGPjb2sfFc8V5zxXvpivc6K97LVryXi1eI
V4pXiVeLl6zKvlXvpave66x6L7POw77w6z/YPjb2sbGPjX1sPM96r2mdm5ey
sY+NfWw82dgnXileFb6/tn1sPNuxR59vsLG37d9vWee1/fcN27jY+P2wR94W
G78/8bri5eJti1eI1xOvDPsvwuuzcR/2yBuwca/gXYQ3ZONzj8fG/ayTH+1+
bNyPjfuxcT827ifelniZeF3xcvG2xSvE64W+ZPdj435s3I+N+7FxP/GG4iVr
3musea+55r2WdW5eysb92LgfG/dj437idcXLxdsWrxCvJ14pXl+8SryBeLV4
Q/GSJ7zXsE4u2/3YuB8bf/+E9y/b/di4Hxv3C+//ZPdjj7wuG++xcT827ide
T7xSvL54Vdhn3oCN+4XPX4E3ZOO5Hhv3Y+N+bNxv3Xvpuvfa4nXE2xIvE68r
Xi7etniFeD3xSvH64lXiDcSrxRuGvmr3ezI27medX7X7sXE/Nu7Hxv3YuJ94
W+Jl4ft/tvux8Tk27sfG/di4n3ileH3xKvEG4tXiDcVLnrLfj3kNNu7Hxv3Y
uJ918ovdj437sXE/Nu7Hxv3Ey8XbFq8QrydeKV5fvEq8gXi1eEPxkg3vNTa8
19zwXmvDe+mG99ridcTbEi8TryteLt62eIV4Pes83I+N+7FxPzbux8b9xBuK
l2x6r7Hpveam91qb3ks3vdcWryPelniZeF3xcuvkmt2PjfuxcT827sfG/cSr
xBuIV4s3FC95OvZ/JHv+kA==
       "]], {}, {}}, 
     {GrayLevel[0], Thickness[Large], LineBox[CompressedData["
1:eJxl2WdYVFfbBWDsDSsWsGOh96G3WTPDFBVLbAlqbHnFHgsaNUYl9h5bVNQY
K9hFULALooKKAmIBQUVQuhV7/U5Zk/nxcSXm2nHmPotnzt77OXusR07qO6qG
mZlZNeHft8If1c3+/8+WKPHnlDJOXzRhxtRBSnl8VZlh3mjP8iXDlZ4K8Seb
48n8+1yl6sDMutXmTFfKSoHy7EPdPLsuM/j6Iv79IuXocPGnmP5yvr9MuT92
3qArSauUN9LFn0plQ9vpw9oPXkvvpXLpYM1dbfX1fP0rZd74T0Ner9pEv0r5
ckR3uwa6rXz/G2VovVHJYxZs4/XeKaHzPLG37w56H5h/B72PvN5Oep+V2571
6lVjzU56X5Q9VPmt41x20fumvF8nod6mX3bRM8OV6QfW5t7ZzdebxrJf7b+x
/P7qGBC4MPJ8/T28Xg3UWNO058T9e+jVxPqBFQF9H+6hVxNzLz1K2dAnml4t
NFpxKm7Womh6tSHXO4ZeHYzzuN3j3sUYenWx7MIS+51O++jVxXTnP44Vbd9P
rx6ybm/srso/QK/+f2PZawC5vgfpmUO4WKuXvx+kZxrLXkNIvNUheo3+G8te
Y8ifzyF6TZCfERzb86Tx9U0gfrqtOh2m3wQ/1hQ/oSNK6e2KptBMrXY0Meso
r9cUY6UPLJZeMxwTb6d2sfSa4cPI1CCFbyy9ZlgqVMNyYizzWCAmoX/9wrux
9CzwJPPM5ekHjtFrDqfjdkGll47Ra451XboJ/8TRaw75foij1wLHjn2Z9Dwu
jp5pLHstgZl3h2aXxNFrCfn+jqfXEpad2l128Imn1wreRzN3vdkRT68VnlYf
Omm38jg9SzgVXytuMeg4PUveP8fpWULiLE7Qs8I4M49d+51P0LOCPD9P0GsN
y/4Xfv0p/QS91hjuI17hBD3TWPbawOfx1NBO3gn02vB+TaDXFldiQgPqjE+g
15b3bwK9thj4q41D5b8J9NrB2XLiGs0Lo9cO0z7nChVOpNcePfZ2/LVhWCK9
9rzfE+mZxrLXAZ8+HPY/+z6RXgdkCdW00J+k1xGpuc+feJqd4v3VEdsXePVY
2fsU/Y6cL6f4/o7YcNr1r8N1T/N6HSGvZ6fpWeOTQ58nZStP07OG1ckaF+Pf
naZnGsueNefPGXrWqGXzodu7MWfpdeL8OEuvEzrHH7RNunWWnmkse6ax7HWC
Vfne8Y9XnKPX+b+xXJ/OeLm+Mss37xy9zogUp0+T8/Q6w+VIv1XpR87T64ye
wqe50fICvS7Y0H5aYV3FBXpdOB+T6HWBvP4m0euCMyPcf/Q+mkSvC+dfEr2u
uKypW3oQyfS64uPszc2uzU+m15XzM5leV9QQp0Pzi/S6Yu6sCdrMyRfp2eDj
hrElw29cpGfD+XeRng2cbnxsOq9xCj0bTIsNX/bKPoWeDXoMOvzCMCuFni3X
8xR6tmgY1qpe6MsUeqax7Nlyvb9EzxaqtTGKcR6X6NlxPl+iZxrLnh3n9yV6
dtwvjJ4d7vv9FH/pg9Gzx9yDjV58rXWZnj0+XmmwdvXIy/TsOd8v07PH0zau
If7LL9OzR839hdY131ym54BO3hu/3/j5Cj0Hzucr9Exj2XPg/L5CzwH//LB+
59DTV+g5cj6n0nOENN1bptJz5H6WSs8R+xTijE6l54i4FqqUbg9S6Tnhac+s
Z6M7pNEzjWXPiftfGj0nnH3fSljh0ug5IfT8K/We3Wn0nOFj0eJd7+tGzxl5
C6+7L8sxes5odG7wkJjWV+mZxrLnzPXiKj0X7Btlnl/t8VV6LpCWzxbX6Lkg
9fWFU9e7X6PngoGnovbFzrtGzzSWPVeopQteo+fK9cTouXK/vk7PFZ233O9r
v/Q6PVfux+n03Lgfp8uvt3LjepPO9cYN22/uu9rH9Yb8/lA3bKi1u+HU0hu8
nvD60saLnlS/KXuRbvhtbVJN5dWbvL7w99Ueh83umSF78W4Yn3baMHx+BvO4
YfkAcQPIkL1iNwTcSassr5fJfO5YcNLrfz93yWQ+dzxJLH/5cFgm87ljWHbJ
uklnM5nPHXXF7bhZFvO549rxCGFGZzGfO75V1hA+0izmc0dMRtdHM61vMZ87
hIu5Jfe+xXzu2PT38UGP1t5iPuH6ZSu3mL+9xXwe0JWpbFe7ZTOfB9yDRwlT
Mpv5PBBT+i6+8YRs5vPgepLNfB5YF9R69Jn12czngUNhI/+4dpxelAfGCatX
syJ68R6Q2tWmt5nPA9eF1WFD+9vM54FJP6X/fcPxNvMpsHRa84P5obeZT4Hy
iKs+Q5fe5v2jgLgaZ+6iF6pAOykAvXAFXgi7o1UWvUgFhMWjhd1relEK9JEK
ckf24hVoNLX0QaH/HeZTYEHb3xNP9rrDfApc/17s4jj2DvN54h/fi+mpk+4w
nycsivpF/7OAnsITTt+3njm0h16oJ4Tm5e/5J+mFe6Jc+jjoRXpi9bc+BpcC
elGeXM+M+TwhbO5RvzW6y3yekNqjFneZzxPJ3mJDc5f5vNjP3GU+L653d5nP
C4F9HzZ/MJdeqBc+Psof1fUwvXAviKvVplR6kV54KpWTXpQXEifmJUzMoxfv
xf7HmM8L38Vf560xnxcyl3VO/+OLMZ+3vL02ucd83lxP7zGfNzyW5fz0zece
83mzf7rHfN7w+aSxPhV5j/m8UU/R4cKAJfSivPFmiVrouOnFe0PsDrafoJfu
DfFpqkkmvWJvrs/0zHwg7s7rGuQwnw/X5xzm8+H6nMN8PnCWJlAO8/ng+1ir
GjOQw3w+GD725l8fZtOL8sFdC/H/0Iv3wT7x49lIL90Hvy9qubfOP/SKfbi+
0zPzxQ+uPzcYVmnM5wtpu26ey3y+SPx3zvCtk3OZz5frey7z+aLmmwE70rJz
mc8Xv28vmbW9JJf5fDGqqr5z98b3mc+X6/995vNFQaO6GffH32c+X0iXn3Wf
+fxg93qarufi+8znh+3bancU1nTm8+N+QC/UNJbz+cH5F+kKzOcHvdRw0ovy
4/5hzOeHCmF17fPVmM8PoXKDyHx+qD9XXLHymM8fqWJ78Xce8/kjKmSCMGXz
mM8fj21zd09JyGM+fzSXPkB64f6QljPPfObzxzn1ilsLeuUznz9GHFcJv1E+
8/nj5e9tvu5ck898/nhbsfjykNx85hO8mS9c9819wHwBkLbnqAfMF8D96wHz
BXD/esh8AZA+vlkPmS8AUvu14SHzBUCaHu8fMl8AOojtb4dHzBcAqf3e9oj5
AjDgVZPqnxwKmC8A17buyssILmC+QMwWf50hBcwXiJRv4g1fwHyB0Eo3YAHz
BWKVuNydoBceCHfzFDfzFHqRgdiyTzxQoRcViGBpe6EXHwi5PPTSA7Hoa7ZH
7efGfIGwn7T8V+VnY74gfI6RGhjmC4L3HBehpXzMfEFocemwdUWnx8wXhD7i
6ur0mPmCIGpJ3o+ZLwjip/FzEL2oIAQ8j0r+sz+9+CAYvgQJLQm99CAMEJ4O
1kynVxyEkZaLR1gupmcWDPm8xpgvGLWWBwotpzFfMPZ/fp2zfIcxXzBme978
zTbGmC+Y/YAxXzAaSL+wMV8wIqQGwJgvGGJ3v77SmC8Y4tNbm6/GfMEYVnly
dO06hcynxATpQKOQ+ZRoMsHCJbVLIfMpeX5QyHxKlIjb+bRC5lPCRWrg6UUq
cf7Cjk/TU+hFKTG75789zr+iF6/E6F0XhTuoiPmUkNq/wUXMp8Ri19/yFQuK
mA+QpvMZvt4ccG22ucA2t4h5gUdrX0eXvuP7hcen8zlTMswbPWF/AxwQt2Ov
J0py+NY+emHc8Cf8fYAH4m4444nshQH9miQuPrTiCX8/4N2fEy8+3UwvAuxH
6EUCs/x322jO0VsJ9if0ogCH01+FT5BetGks90uAT9rOGSsq6CWB5yFPWR9g
c+rAmg1tn8peLtA6cuWYcT2esl6mseRVAWsc2qsx7Cnrp+LzFD1zFXqdbLt+
6Sp6Viq8ts++mbyFno0Ko2//b9+mI/QUKjTQtREeaelBBWk5uUAvVMXzGHph
KvSzF0+M6IWr0HXkL0LLQS9Cxf6HXqQK0nSrVsz6qSDOnhGWxayfCsLD4p2j
bYpZPxX7n2LWT4WpCQF+DVHM+qlweEVNmw/d6KWr2B/RyzWN5fqpID2+DKJX
pcI4cTufSc9MjRm2MdXSltIzVyNOPC5bR89KzfMhejZqXBB2R//d9BRqSN3O
fnpQo/bzyJeHztELVePAMGnHZf3U7L/ohauxUWzvX9OLMI3l+qkhTacaJayf
mv1WCeunhnQ8Z1HC+qnxXuj2LVxKWD81Jg7dqS1TlbB+ajTN/PHPTr3ppavR
7uHnBgeG0ctVI7m3eKJEr1gN8WaaF0GvSo0dG90n11lIz0yDqdKBNj1zDQ7v
ufNp9QZ6VhrMexC72XErPRsNpMebuBKuP6axXD8NCqT2lV6ohv0cvTANBi55
/21+Ob1wDeyE3a7DK3oRGqwdklQx8Q29SA1q1+krHumwfhqIs7+mTSnrp8Hr
weKOXcr6adj/lXI902DjDUfxBJb10/D8jl66BkfLxAcaerkalJ8PTOg0hl6x
hs/79KpMY7l+IXifXoADM+mZh0ApPP22XU/PKoT9Iz2bEIi7R7U0eooQyI87
9BCCw+eihSdKeqEhKBWeTpuU0QszjeX6hWBoULWNxV/oRYRAPN3uUL+M9QvB
jLBuB9+2K2P9QvBM3K7cy1i/EKydLj5wl7F+ITy/LGP9QjBZuJrdQHpJprFc
vxCopAaKXm4IOgaOF0pKrzgEQvPqP2UhvaoQZInHb2vpmWnhLx4/baBnroU+
/MfekXvpWWlh9a/Hs7aH6NloUXGv4YpTcfQUWqzudunK6wv0oGX/TC9UixPi
4/sremFaOIrLb61y1k/L/rqc9dNC+nqgQznrp0XLCPEV5ayfFp3/rCdseeWs
nxbV05ZGJ/SnF61FtJ+y8MUIevFaCOGFDYdekhZe4vKxkV66lv04vVwt+296
xVrMKVpk0B+jV6XFYIdaU8an0TPTsT+nZ67DGF+xY6FnpYPUrRbSs9GxX6en
0EF8mp/WvIL102HrZD+bpm0qWD8d2ksNXQXrp4Ov1FBWsH46iKcR/aZVsH46
SMep6+hF6jB+jl5oWemt1GFh1F+PDqTQi9JBfrygF63DnC8DhSWNXrwOQ8Sv
NywqWT8hv/QFUyXrp4NCKnAl66dDRvKWrldiKlk/HbTi48SZStZPh9MtxQ6E
npkebtKCSc9cj8cQN+RnrJ8eSeLjpeUz1k8P8fRauCVZPz2slzx0PtLvGeun
h7l0YPWM9dNDWg6W0gvT83mCXrgeI240K+oXTS9Cj21iex9LL1LP83V6K/Wo
H+tZov9CL0qPM+LXCa2fs356SO2z+3PWTw/x24xWAc9ZPz26vxsjtLzPWT89
7INKLzUNf8766fn8Qq9Yj9yz4gMVvSo9hMVEuCPomRlgveNode12euYGbOou
fuFJz8oAsxIXx7En6NkY8MhZ/EKAnsKAc9PEB2J6MED89mLbM3qhBlybn1Xb
7w29MANmVxdP3F+wfqaxXD8DpOXD7wXrZ4A0fbu/YP0M6HtoquKHES9YPwOG
STcEvWgDJG4evXgDpHZrEb0kA9oaWjS23kEv3YB1YnsbTy/XgCni9LlOr9gA
8fSsfw69KqFepyLv5ZXSM+sG+b8vlf8He9CMFA==
       "]], {}, {}}}}, {{}, {}, 
    {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
     LineBox[CompressedData["
1:eJwVz3k41AkYwPGZLqod11YaOSKqsZVREyG9r/uXUCY9ksi6ZijlaqPV1hRy
NkrnunOWp5lctUIisdmEoVXIlTQy/FI0S8ts+8f3+fz91fY+wfZbQKFQHL/3
vzr8udxMzZJd9n7i9iejB3Y9lGdoBXH5sNhKLbifzoK6CEHeRm4WsLJuppfR
raGRGcJZwhWCQ0tXaQbdBf5MEhHTnFpw9ZXWXKH7wnPTC5USTiu8NbholUwP
h+bLPSFiTj9kr9wbm0CPBvsaOacRDgk8+bIN8fSr0EIzWrrIg4IH3XKEnybz
wJJv86RwrzzSZLzDdppC8DOYpRnSlFDPeUL8NLEcHBl+k6vsVuCplyZwc6oS
SjvPnHy+YzWqliv3Uam1YKaiL1x0Vh0rhqxetO6sB863Kxn5B9diXWDGGjdJ
A5xo/LBN6KiD0+vNFe8FNUHCoSV6c8d0ceFMsdIavWbwafrV35C7Ho1lXg/2
C15AnRzd+ajbRnwZzXrZqN8Khsrnro+G66NWytjMnYk28Ppivsnp2CaUSPv7
XjFFkJP5TF2avAXzP1Y1K1zqgLJLpj0iNhMVNArJ4eFOCH9kvi/DwRATAir8
s3X/htrm/M/x7ltxGouHuWe7IMDOpCbg4DYM3dpQvurpa0gvMqw4GsjCXkFD
Yrt2N1z+UsMLPrUdpYGdaYzTPTBy9+Qv3FAj3GAhN+9f1QsNtldunj9vjFa3
tTklqn1A3ds9xD+3A0M1jugMHu4HisUDanakCTIkB5Z3OQ5AnKrUUXTRFBUV
P8k3zA5A8CGfeukFM6TUpgnXpQ/CII/lC9d2IodV9WbpniFYkXqrOz7HHAt3
e2c//joEBUr6kU1pu5AcU1Mauf4O6kK1bDYUAwr32y28aj0MmWuz1c1dECOI
mKzykWGoiZqlcNsQ17y1f50b8x6098j9u87VArcbR1+lbx2B8lZG4ptOC3TV
bJ2hdoxAUuM8c62HJU42Jw8F8z5AathooFevJaYu8gxn64ohaqWmoo6bFSr1
Vdxe0CCGO4zFzeEDVkg9w3MxCRmFJVNUep2nNc4XeQqHVD5CIbPkt8wP1hj8
uzBZpf4jMLzvOs0F2eCjn+LklY+PQc/uytIDYzaoYB+66byCBES5pzdDmC12
b27riKyWwD9lzjt1PtuiIBN0hz3HQfZHaEXscTt0Fxopa8yPwx6mrU3UtB2e
jcnh9d6dgCYPg4CjYQTeE2ukKTiQoOLDrco4SWBcRoxXnxMJntwcWtspAn3Z
43oCZxK+hv5YyooiUL26+r6jKwm6cdLZuWgCE/jujUneJJwrrU1KuU4gx+jW
5LJIEkzl9t2vqCRQO3oFIVdAQuwP8QvEVQTO74iidRWR0K5c76L2mMA34+9E
BcUkcNVZM7/VE5jiWuZhW0LCDcPVlsRfBMr02WEx1SRMuQ90dPcS2NvOz1zY
QQL+TF9P6yewMlbq0/GKhER/dgQMEphqdoSR+5oEnZAG9bz3BNrnbym37CPB
ObbIL2iCwEcRLc95oySkJw4+zPpE4LXN2/nOEhLEKWrLRJ8JDBlKd9Emv/+k
JQmMpAQyHI71P5ki4UX2M0rADIGLqZ15KVISVAvm2WnfCByoMAv0miXBu9g4
v2WOwKrAXAPmHAmC+8FSmYzAG1rLp2UyEv4D9blOIA==
      "]]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{
    FormBox["\"kbp\"", TraditionalForm], 
    FormBox["\"cdf\"", TraditionalForm]},
  AxesOrigin->{0, 0},
  Method->{"MessagesHead" -> DiscretePlot},
  PlotRange->{{0., 50.}, {0, 1.}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.02]}}]], "Output",
 CellChangeTimes->{3.5857641282828693`*^9, 3.585764867653159*^9, 
  3.5857649224022903`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"nsq", "\[Equal]", "10"}], "&&", 
    RowBox[{"nbp", "==", "500000"}]}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"dist1", "=", 
     RowBox[{"EmpiricalDistribution", "[", 
      RowBox[{"Select", "[", 
       RowBox[{
        RowBox[{"Rest", "[", 
         RowBox[{"truetreeloc", "/", "1000"}], "]"}], ",", 
        RowBox[{
         RowBox[{"#", "\[LessEqual]", "50"}], "&"}]}], "]"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"dist2", "=", 
     RowBox[{"EmpiricalDistribution", "[", 
      RowBox[{"Select", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"Flatten", "[", 
            RowBox[{"rescold", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "4", ",", "All", ",", "1"}], "]"}], "]"}], 
            "]"}], ",", "1"}], "]"}], "/", "1000"}], ",", 
        RowBox[{
         RowBox[{"#", "\[LessEqual]", "50"}], "&"}]}], "]"}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"gcpcdf50", "=", 
     RowBox[{"Show", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"DiscretePlot", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"CDF", "[", 
            RowBox[{"dist1", ",", "x"}], "]"}], ",", 
           RowBox[{"CDF", "[", 
            RowBox[{"dist2", ",", "x"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", "0", ",", "50", ",", "0.1"}], "}"}], ",", 
         RowBox[{"Filling", "\[Rule]", "None"}], ",", 
         RowBox[{"Joined", "\[Rule]", "True"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Black", ",", 
              RowBox[{"Thickness", "[", "linethick", "]"}]}], "}"}], ",", 
            "linestyle"}], "}"}]}]}], "]"}], ",", 
       RowBox[{"Plot", "[", 
        RowBox[{
         RowBox[{"x", "/", 
          RowBox[{"(", "50", ")"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", "0", ",", "50"}], "}"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Gray", ",", 
            RowBox[{"Thickness", "[", "linethick", "]"}], ",", "Dashed"}], 
           "}"}]}]}], "]"}], ",", 
       RowBox[{"AxesLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<kbp\>\"", ",", "\"\<cdf\>\""}], "}"}]}]}], "]"}]}]}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.556095029833451*^9, 3.5560951501003294`*^9}, {
  3.55609518752247*^9, 3.5560951971950235`*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
  "******)"}]], "Input",
 CellChangeTimes->{{3.4940977943255997`*^9, 3.494097801075859*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
  "******)"}]], "Input",
 CellChangeTimes->{{3.4940977943255997`*^9, 3.494097801075859*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"restbl", "=", 
   RowBox[{"rescold", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "4", ",", "All", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "3"}], "}"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pos", "=", 
   RowBox[{"ysnp", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tblsnp", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"getsnptbl", "[", 
      RowBox[{"#", ",", "pos"}], "]"}], "&"}], "/@", "restbl"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lev", "=", 
   RowBox[{"{", 
    RowBox[{"0.025", ",", "0.5", ",", "0.975"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"qtbl", "=", 
   RowBox[{"Quantile", "[", 
    RowBox[{"tblsnp", ",", "lev"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"priq", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"FindRoot", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"cdff", "[", 
           RowBox[{"nsq", ",", "x"}], "]"}], "\[Equal]", "#"}], ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", "2"}], "}"}]}], "]"}], "&"}], "/@", "lev"}], 
     ")"}], "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "1", ",", "2"}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"If", "[", 
    RowBox[{"withdata", ",", "\[IndentingNewLine]", 
     RowBox[{"truetbl", "=", 
      RowBox[{"getsnptbl", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{"truetreeloc", ",", "truetreetbl"}], "}"}], "]"}], ",", 
        "pos"}], "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"truetbl", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"mf", "[", "nsq", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"Length", "[", "pos", "]"}], "}"}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ls", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{"truetbl", ",", 
      RowBox[{"qtbl", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "2"}], "]"}], "]"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"errls", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"pos", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "/", "1000"}], ",", 
         RowBox[{"qtbl", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"ErrorBar", "[", 
        RowBox[{
         RowBox[{"qtbl", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", 
            RowBox[{"{", 
             RowBox[{"1", ",", "3"}], "}"}]}], "]"}], "]"}], "-", 
         RowBox[{"qtbl", "[", 
          RowBox[{"[", 
           RowBox[{"i", ",", "2"}], "]"}], "]"}]}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       RowBox[{"Length", "[", "qtbl", "]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"g", "=", 
   RowBox[{"ErrorListPlot", "[", 
    RowBox[{"errls", ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<x(kbp)\>\"", ",", "\"\<L\>\""}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "linegray"}], ",", 
     RowBox[{"PlotMarkers", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Automatic", ",", "0"}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"g", "=", 
   RowBox[{"Show", "[", 
    RowBox[{"g", ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"errls", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "1"}], "]"}], "]"}], ",", 
       RowBox[{"PlotMarkers", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Automatic", ",", "6"}], "}"}]}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", "Black"}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{"withdata", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ls", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Append", "[", 
             RowBox[{"truetreeloc", ",", 
              RowBox[{"nbp", "+", "1"}]}], "]"}], "-", "1"}], " ", ")"}], "/",
           "1000."}], ",", 
         RowBox[{"Prepend", "[", 
          RowBox[{"truetreetbl", ",", 
           RowBox[{"First", "[", "truetreetbl", "]"}]}], "]"}]}], "}"}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"ls", "=", 
      RowBox[{"DeleteDuplicates", "[", "ls", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"truetblf", "=", 
      RowBox[{"Interpolation", "[", 
       RowBox[{"ls", ",", 
        RowBox[{"InterpolationOrder", "\[Rule]", "0"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"g2", "=", 
      RowBox[{"Plot", "[", 
       RowBox[{
        RowBox[{"truetblf", "[", "x", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", "0", ",", 
          RowBox[{"nbp", "/", "1000"}]}], "}"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Black", ",", 
           RowBox[{"Thickness", "[", "linethick", "]"}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}]}]}], 
   "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"g3", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{"priq", ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{
        RowBox[{"nbp", "/", "1000"}], "+", "0.5"}]}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"Gray", ",", 
         RowBox[{"Thickness", "[", "linethick", "]"}], ",", "Dashed"}], "}"}],
        "}"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gtbl", "=", 
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{"withdata", ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "g2", ",", "g3"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "g3"}], "}"}]}], "]"}], ",", 
     RowBox[{"AxesOrigin", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "0"}], "}"}]}], ",", 
     RowBox[{"PlotRangePadding", "\[Rule]", "None"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gtbl2", "=", 
   RowBox[{"Show", "[", 
    RowBox[{"g2", ",", "\[IndentingNewLine]", 
     RowBox[{"Plot", "[", 
      RowBox[{
       RowBox[{"priq", "[", 
        RowBox[{"[", "2", "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "0", ",", 
         RowBox[{
          RowBox[{"nbp", "/", "1000"}], "+", "0.5"}]}], "}"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"Gray", ",", 
           RowBox[{"Thickness", "[", "linethick", "]"}], ",", "Dashed"}], 
          "}"}], "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"ListLinePlot", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"pos", "/", "1000"}], ",", 
          RowBox[{"qtbl", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "2"}], "]"}], "]"}]}], "}"}], "]"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", "linestyle"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "All"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "All"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"AxesOrigin", "\[Rule]", "0"}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<x(kbp)\>\"", ",", "\"\<L\>\""}], "}"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"nsq", "\[Equal]", "10"}], "&&", 
    RowBox[{"nbp", "==", "500000"}]}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"gtbl50", "=", 
     RowBox[{"Show", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Plot", "[", 
        RowBox[{
         RowBox[{"truetblf", "[", "x", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", "0", ",", "50"}], "}"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Black", ",", 
            RowBox[{"Thickness", "[", "linethick", "]"}]}], "}"}]}], ",", 
         RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Plot", "[", 
        RowBox[{
         RowBox[{"priq", "[", 
          RowBox[{"[", "2", "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", "0", ",", "50"}], "}"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"Gray", ",", 
             RowBox[{"Thickness", "[", "linethick", "]"}], ",", "Dashed"}], 
            "}"}], "}"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"ListLinePlot", "[", 
        RowBox[{
         RowBox[{"Select", "[", 
          RowBox[{
           RowBox[{"Transpose", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"pos", "/", "1000"}], ",", 
              RowBox[{"qtbl", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "2"}], "]"}], "]"}]}], "}"}], "]"}], ",", 
           RowBox[{
            RowBox[{
             RowBox[{"First", "[", "#", "]"}], "\[LessEqual]", "50"}], 
            "&"}]}], "]"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", "linestyle"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "All"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "All"}], "}"}]}], "}"}]}], ",", 
       RowBox[{"AxesOrigin", "\[Rule]", "0"}], ",", 
       RowBox[{"AxesLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<x(kbp)\>\"", ",", "\"\<L\>\""}], "}"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"GraphicsRow", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"gtbl", ",", "gtbl2", ",", "gtbl50"}], "}"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "1000"}]}], "]"}]}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"GraphicsRow", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"gtbl", ",", "gtbl2"}], "}"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "700"}]}], "]"}]}], 
  "\[IndentingNewLine]", "]"}]}], "Input",
 CellChangeTimes->{{3.5560870631035233`*^9, 3.5560870833536816`*^9}, 
   3.556087191046841*^9, {3.556087290518531*^9, 3.5560873440025897`*^9}, {
   3.556087397422645*^9, 3.5560874059551334`*^9}, {3.5560876231025534`*^9, 
   3.556087632101068*^9}, {3.5560877909621544`*^9, 3.5560878036968827`*^9}, {
   3.556087840168969*^9, 3.556087890209831*^9}, {3.556087922618685*^9, 
   3.5560879646690903`*^9}, {3.556088030466853*^9, 3.556088069462084*^9}, {
   3.556088107696271*^9, 3.5560881390460634`*^9}, {3.5560893764598007`*^9, 
   3.556089391714673*^9}, 3.5560895020099816`*^9, {3.556090233222228*^9, 
   3.5560902343022294`*^9}, {3.5560903030223255`*^9, 3.55609030643233*^9}, {
   3.55609143485283*^9, 3.5560914366539326`*^9}, 3.556102489595239*^9, {
   3.556103305818925*^9, 3.5561033083490696`*^9}, {3.5561816706520047`*^9, 
   3.5561817060000267`*^9}, {3.5562679188406277`*^9, 
   3.5562679244878373`*^9}, {3.5567081730783052`*^9, 3.556708196065755*^9}, {
   3.5567087999662924`*^9, 3.5567088108596125`*^9}, 3.571881838376129*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{{{{}, GraphicsComplexBox[CompressedData["
1:eJztlvlTU1cUx8PShEbQRBYTwIXFEovKJoiEJAdZEgQUcMFStAXRaoqKFJQC
RbEDETfGyuJSRIu4dCyjgpRB0OpkFKkrdKDooDKUoS4UAYFaCvbd+5x3nP4N
eb9kPnNz7jv3e7/nvOOQsDl6rTGPxzM14vHI75yLpX2nb/Sorruk7zuW/iH8
EFwzOPbba1XryqyrITcEQJfDhjiOrp2W+yLKAiaZjNpqu/nwV5bKe3WdCJ4n
v93rJhbAlPa7I0vXiMFdHf77HncBsPsjm52zj02UW3Lcfd/x0Ztxey7eizyD
DhAWqd8+1sKHJ0v2lWz6zhGyTH+U22v5sDhBtHJB9UwwGy1KSHHgg+mKiXMu
TnXhuFLdmWG1yRVydz7e9WmGAK6U2bp1/OEKGv7PQZeyBfC9fsb5FNlciK7Q
nV7cIIRF5sauumF3cK5+8FPPBRFsnvztL01GHhzTfA56gPGlK7+6JdnAzbD5
+QFPPaA3YiDrnJ0tm9+ABzz9Wq+43C9l13meHE8kAgg8uf8z4tVOm4l85gYJ
QNbZEAExnjls49ZsXP/3bH9zxE7ktvJkhbAE+VrTieCaKuRZcQXXh/5EVgiZ
iDHk4sA9ST12Xtz7NvaMnu33RI5kjjc5EPklk35uGPKd28wTjtxVcVQ/IxKZ
6hmP7NbhzM9JQ2Zuq1J9zQvmhR5tf9UqhQO9jKEeIzs9epOt9Z8HDwtydKVf
SEFDAnTI5PpL782D3WlqzQGdBFyJgFO8wbd2a3GDTMLqt9obfN5x2kGJ6YpK
by7+JCNfm4kPF39oE5OwEJlRZ/SsGJn6wRJ54eeMg+2QSTWEhvtAX1DqooYa
Keu/RGR+ThGjODLVKxnZihi4EHk9EaQI+Z9sbX1qCzKtv4fIpHrTZ83n9KX5
zEZm3CCL24xMqqnRxpdjWq/rfKHfc8uOck8J69/TyLR83/pyelK9tAs4DiKC
5SMT+a+UIdN6q0G+N7K0q+IyMtsvkI3Jhc71g9l9q59EeUtgWMYYerkfp3ei
nFQgMm1Ph5BpPVUh14UyCdz0A/8N1RtlyVIg5SGzl0NudF7oungp0OtxQab5
hCC/ZuR99h5Tv8XIuf3ofWTI4Zv6HeHaGCnQ9Pbj/6k+t+RgYhbRG8/0E7bf
IocQlPjD3gvq+vENNnDkMPN8gtwSwTTAw/5Qans/87iNDZt/PTLVtxV5nEn3
I7EChl/GjgQMW7N+jlJw6y4epCMjf0UM9xlyJjUkxtP1MgVcXeOoH+2yBhp+
EpnW27gCjn/ptLU0xRoGmpmEJUqOqX9UyNQf7/F00iCzlbA89eP2qYnWQNt9
oxJinD07PrC2Zvv/MhVofLYldHdbwfkUJqE4ZPp9yUSm99OmgjwrpYtTvJjV
wwg4pv2wAcAyLqbTfNCC3V+PTNphsyIAgiyOKFfpLNjzKZFpPS0JgPXP84oW
pluw+z8IhFdN9kaPUwVAys88Ogjqru9fL4gVsvWfFQyDLwrS6v4Wsu9zDoFT
nU3H7JQTWH88C4GSpKo1Z0omwTLaINTQpC9oNnsiend+NUQmJ20JKhSz+u5S
w3bTnFUTdotZvWqRHahAauicclemNRZDfgBpWBoo3xZ1R3RbBEx3PhFcrIGR
Wy+GOtaK2O/nuAZyCvNPrbITg2E+MMwHhvnAMB8Y5gPDfGCYDwzzwf/ng/8A
2HH7Pw==
          "], {
           {GrayLevel[0.65], {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 131], {
              LineBox[{{0.743, 9.880899300780758}, {0.743, 
               1.2705931396171564`}}], 
              LineBox[{
               Offset[{1.5, 0}, {0.743, 9.880899300780758}], 
                Offset[{-1.5, 0}, {0.743, 9.880899300780758}]}], 
              LineBox[{
               Offset[{1.5, 0}, {0.743, 1.2705931396171564`}], 
                Offset[{-1.5, 0}, {0.743, 1.2705931396171564`}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 132], {
              LineBox[{{1.302, 9.880899300780758}, {1.302, 
               1.2413019883167435`}}], 
              LineBox[{
               Offset[{1.5, 0}, {1.302, 9.880899300780758}], 
                Offset[{-1.5, 0}, {1.302, 9.880899300780758}]}], 
              LineBox[{
               Offset[{1.5, 0}, {1.302, 1.2413019883167435`}], 
                Offset[{-1.5, 0}, {1.302, 1.2413019883167435`}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 133], {
              LineBox[{{1.331, 9.880899300780758}, {1.331, 
               1.2413019883167435`}}], 
              LineBox[{
               Offset[{1.5, 0}, {1.331, 9.880899300780758}], 
                Offset[{-1.5, 0}, {1.331, 9.880899300780758}]}], 
              LineBox[{
               Offset[{1.5, 0}, {1.331, 1.2413019883167435`}], 
                Offset[{-1.5, 0}, {1.331, 1.2413019883167435`}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 134], {
              LineBox[{{3.665, 6.426750597338426}, {3.665, 
               1.2413019883167435`}}], 
              LineBox[{
               Offset[{1.5, 0}, {3.665, 6.426750597338426}], 
                Offset[{-1.5, 0}, {3.665, 6.426750597338426}]}], 
              LineBox[{
               Offset[{1.5, 0}, {3.665, 1.2413019883167435`}], 
                Offset[{-1.5, 0}, {3.665, 1.2413019883167435`}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 135], {
              LineBox[{{4.182, 6.426750597338426}, {4.182, 
               1.2413019883167435`}}], 
              LineBox[{
               Offset[{1.5, 0}, {4.182, 6.426750597338426}], 
                Offset[{-1.5, 0}, {4.182, 6.426750597338426}]}], 
              LineBox[{
               Offset[{1.5, 0}, {4.182, 1.2413019883167435`}], 
                Offset[{-1.5, 0}, {4.182, 1.2413019883167435`}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 136], {
              LineBox[{{4.347, 6.426750597338426}, {4.347, 
               1.2413019883167435`}}], 
              LineBox[{
               Offset[{1.5, 0}, {4.347, 6.426750597338426}], 
                Offset[{-1.5, 0}, {4.347, 6.426750597338426}]}], 
              LineBox[{
               Offset[{1.5, 0}, {4.347, 1.2413019883167435`}], 
                Offset[{-1.5, 0}, {4.347, 1.2413019883167435`}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 137], {
              LineBox[{{4.444, 6.426750597338426}, {4.444, 
               1.2413019883167435`}}], 
              LineBox[{
               Offset[{1.5, 0}, {4.444, 6.426750597338426}], 
                Offset[{-1.5, 0}, {4.444, 6.426750597338426}]}], 
              LineBox[{
               Offset[{1.5, 0}, {4.444, 1.2413019883167435`}], 
                Offset[{-1.5, 0}, {4.444, 1.2413019883167435`}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 138], {
              LineBox[{{4.808, 6.426750597338426}, {4.808, 
               1.2413019883167435`}}], 
              LineBox[{
               Offset[{1.5, 0}, {4.808, 6.426750597338426}], 
                Offset[{-1.5, 0}, {4.808, 6.426750597338426}]}], 
              LineBox[{
               Offset[{1.5, 0}, {4.808, 1.2413019883167435`}], 
                Offset[{-1.5, 0}, {4.808, 1.2413019883167435`}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 139], {
              LineBox[{{7.249, 6.426750597338425}, {7.249, 
               1.0947203887883095`}}], 
              LineBox[{
               Offset[{1.5, 0}, {7.249, 6.426750597338425}], 
                Offset[{-1.5, 0}, {7.249, 6.426750597338425}]}], 
              LineBox[{
               Offset[{1.5, 0}, {7.249, 1.0947203887883095`}], 
                Offset[{-1.5, 0}, {7.249, 1.0947203887883095`}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 140], {
              LineBox[{{8.975, 6.1465077448975745`}, {8.975, 
               1.0947203887883095`}}], 
              LineBox[{
               Offset[{1.5, 0}, {8.975, 6.1465077448975745`}], 
                Offset[{-1.5, 0}, {8.975, 6.1465077448975745`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {8.975, 1.0947203887883095`}], 
                Offset[{-1.5, 0}, {8.975, 1.0947203887883095`}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 141], {
              LineBox[{{9.286, 6.1465077448975745`}, {9.286, 
               1.0947203887883095`}}], 
              LineBox[{
               Offset[{1.5, 0}, {9.286, 6.1465077448975745`}], 
                Offset[{-1.5, 0}, {9.286, 6.1465077448975745`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {9.286, 1.0947203887883095`}], 
                Offset[{-1.5, 0}, {9.286, 1.0947203887883095`}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 142], {
              LineBox[{{10.852, 9.348788653909546}, {10.852, 
               1.0528331373431263`}}], 
              LineBox[{
               Offset[{1.5, 0}, {10.852, 9.348788653909546}], 
                Offset[{-1.5, 0}, {10.852, 9.348788653909546}]}], 
              LineBox[{
               Offset[{1.5, 0}, {10.852, 1.0528331373431263`}], 
                Offset[{-1.5, 0}, {10.852, 1.0528331373431263`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 143], {
              LineBox[{{11.558, 9.55711731363326}, {11.558, 
               1.0947203887883095`}}], 
              LineBox[{
               Offset[{1.5, 0}, {11.558, 9.55711731363326}], 
                Offset[{-1.5, 0}, {11.558, 9.55711731363326}]}], 
              LineBox[{
               Offset[{1.5, 0}, {11.558, 1.0947203887883095`}], 
                Offset[{-1.5, 0}, {11.558, 1.0947203887883095`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 144], {
              LineBox[{{13.715, 11.421825578908159`}, {13.715, 
               1.0947203887883095`}}], 
              LineBox[{
               Offset[{1.5, 0}, {13.715, 11.421825578908159`}], 
                Offset[{-1.5, 0}, {13.715, 11.421825578908159`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {13.715, 1.0947203887883095`}], 
                Offset[{-1.5, 0}, {13.715, 1.0947203887883095`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 145], {
              LineBox[{{13.947, 11.558660124896633`}, {13.947, 
               1.0947203887883095`}}], 
              LineBox[{
               Offset[{1.5, 0}, {13.947, 11.558660124896633`}], 
                Offset[{-1.5, 0}, {13.947, 11.558660124896633`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {13.947, 1.0947203887883095`}], 
                Offset[{-1.5, 0}, {13.947, 1.0947203887883095`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 146], {
              LineBox[{{15.079, 11.558660124896633`}, {15.079, 
               1.1759068869287206`}}], 
              LineBox[{
               Offset[{1.5, 0}, {15.079, 11.558660124896633`}], 
                Offset[{-1.5, 0}, {15.079, 11.558660124896633`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {15.079, 1.1759068869287206`}], 
                Offset[{-1.5, 0}, {15.079, 1.1759068869287206`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 147], {
              LineBox[{{16.963, 12.731143725881255`}, {16.963, 
               1.280423753160517}}], 
              LineBox[{
               Offset[{1.5, 0}, {16.963, 12.731143725881255`}], 
                Offset[{-1.5, 0}, {16.963, 12.731143725881255`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {16.963, 1.280423753160517}], 
                Offset[{-1.5, 0}, {16.963, 1.280423753160517}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 148], {
              LineBox[{{17.007, 12.731143725881255`}, {17.007, 
               1.280423753160517}}], 
              LineBox[{
               Offset[{1.5, 0}, {17.007, 12.731143725881255`}], 
                Offset[{-1.5, 0}, {17.007, 12.731143725881255`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {17.007, 1.280423753160517}], 
                Offset[{-1.5, 0}, {17.007, 1.280423753160517}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 149], {
              LineBox[{{17.575, 12.831237711501643`}, {17.575, 
               1.280423753160517}}], 
              LineBox[{
               Offset[{1.5, 0}, {17.575, 12.831237711501643`}], 
                Offset[{-1.5, 0}, {17.575, 12.831237711501643`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {17.575, 1.280423753160517}], 
                Offset[{-1.5, 0}, {17.575, 1.280423753160517}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 150], {
              LineBox[{{17.876, 12.831237711501643`}, {17.876, 
               2.182104774020174}}], 
              LineBox[{
               Offset[{1.5, 0}, {17.876, 12.831237711501643`}], 
                Offset[{-1.5, 0}, {17.876, 12.831237711501643`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {17.876, 2.182104774020174}], 
                Offset[{-1.5, 0}, {17.876, 2.182104774020174}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 151], {
              LineBox[{{17.947, 12.831237711501643`}, {17.947, 
               2.182104774020173}}], 
              LineBox[{
               Offset[{1.5, 0}, {17.947, 12.831237711501643`}], 
                Offset[{-1.5, 0}, {17.947, 12.831237711501643`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {17.947, 2.182104774020173}], 
                Offset[{-1.5, 0}, {17.947, 2.182104774020173}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 152], {
              LineBox[{{18.001, 12.831237711501643`}, {18.001, 
               2.182104774020173}}], 
              LineBox[{
               Offset[{1.5, 0}, {18.001, 12.831237711501643`}], 
                Offset[{-1.5, 0}, {18.001, 12.831237711501643`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {18.001, 2.182104774020173}], 
                Offset[{-1.5, 0}, {18.001, 2.182104774020173}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 153], {
              LineBox[{{18.031, 12.831237711501643`}, {18.031, 
               2.182104774020174}}], 
              LineBox[{
               Offset[{1.5, 0}, {18.031, 12.831237711501643`}], 
                Offset[{-1.5, 0}, {18.031, 12.831237711501643`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {18.031, 2.182104774020174}], 
                Offset[{-1.5, 0}, {18.031, 2.182104774020174}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 154], {
              LineBox[{{18.145, 13.49337739468438}, {18.145, 
               2.182104774020174}}], 
              LineBox[{
               Offset[{1.5, 0}, {18.145, 13.49337739468438}], 
                Offset[{-1.5, 0}, {18.145, 13.49337739468438}]}], 
              LineBox[{
               Offset[{1.5, 0}, {18.145, 2.182104774020174}], 
                Offset[{-1.5, 0}, {18.145, 2.182104774020174}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 155], {
              LineBox[{{18.256, 13.49337739468438}, {18.256, 
               2.182104774020174}}], 
              LineBox[{
               Offset[{1.5, 0}, {18.256, 13.49337739468438}], 
                Offset[{-1.5, 0}, {18.256, 13.49337739468438}]}], 
              LineBox[{
               Offset[{1.5, 0}, {18.256, 2.182104774020174}], 
                Offset[{-1.5, 0}, {18.256, 2.182104774020174}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 156], {
              LineBox[{{18.328, 13.49337739468438}, {18.328, 
               2.182104774020173}}], 
              LineBox[{
               Offset[{1.5, 0}, {18.328, 13.49337739468438}], 
                Offset[{-1.5, 0}, {18.328, 13.49337739468438}]}], 
              LineBox[{
               Offset[{1.5, 0}, {18.328, 2.182104774020173}], 
                Offset[{-1.5, 0}, {18.328, 2.182104774020173}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 157], {
              LineBox[{{18.494, 13.49337739468438}, {18.494, 
               2.182104774020174}}], 
              LineBox[{
               Offset[{1.5, 0}, {18.494, 13.49337739468438}], 
                Offset[{-1.5, 0}, {18.494, 13.49337739468438}]}], 
              LineBox[{
               Offset[{1.5, 0}, {18.494, 2.182104774020174}], 
                Offset[{-1.5, 0}, {18.494, 2.182104774020174}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 158], {
              LineBox[{{18.509, 13.49337739468438}, {18.509, 
               2.182104774020174}}], 
              LineBox[{
               Offset[{1.5, 0}, {18.509, 13.49337739468438}], 
                Offset[{-1.5, 0}, {18.509, 13.49337739468438}]}], 
              LineBox[{
               Offset[{1.5, 0}, {18.509, 2.182104774020174}], 
                Offset[{-1.5, 0}, {18.509, 2.182104774020174}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 159], {
              LineBox[{{18.59, 13.49337739468438}, {18.59, 
               2.1439556734903116`}}], 
              LineBox[{
               Offset[{1.5, 0}, {18.59, 13.49337739468438}], 
                Offset[{-1.5, 0}, {18.59, 13.49337739468438}]}], 
              LineBox[{
               Offset[{1.5, 0}, {18.59, 2.1439556734903116`}], 
                Offset[{-1.5, 0}, {18.59, 2.1439556734903116`}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 160], {
              LineBox[{{18.702, 13.49337739468438}, {18.702, 
               2.1439556734903116`}}], 
              LineBox[{
               Offset[{1.5, 0}, {18.702, 13.49337739468438}], 
                Offset[{-1.5, 0}, {18.702, 13.49337739468438}]}], 
              LineBox[{
               Offset[{1.5, 0}, {18.702, 2.1439556734903116`}], 
                Offset[{-1.5, 0}, {18.702, 2.1439556734903116`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 161], {
              LineBox[{{18.91, 13.49337739468438}, {18.91, 
               2.1439556734903116`}}], 
              LineBox[{
               Offset[{1.5, 0}, {18.91, 13.49337739468438}], 
                Offset[{-1.5, 0}, {18.91, 13.49337739468438}]}], 
              LineBox[{
               Offset[{1.5, 0}, {18.91, 2.1439556734903116`}], 
                Offset[{-1.5, 0}, {18.91, 2.1439556734903116`}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 162], {
              LineBox[{{18.99, 13.49337739468438}, {18.99, 
               2.1439556734903116`}}], 
              LineBox[{
               Offset[{1.5, 0}, {18.99, 13.49337739468438}], 
                Offset[{-1.5, 0}, {18.99, 13.49337739468438}]}], 
              LineBox[{
               Offset[{1.5, 0}, {18.99, 2.1439556734903116`}], 
                Offset[{-1.5, 0}, {18.99, 2.1439556734903116`}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 163], {
              LineBox[{{19.109, 13.49337739468438}, {19.109, 
               2.1439556734903107`}}], 
              LineBox[{
               Offset[{1.5, 0}, {19.109, 13.49337739468438}], 
                Offset[{-1.5, 0}, {19.109, 13.49337739468438}]}], 
              LineBox[{
               Offset[{1.5, 0}, {19.109, 2.1439556734903107`}], 
                Offset[{-1.5, 0}, {19.109, 2.1439556734903107`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 164], {
              LineBox[{{19.199, 13.49337739468438}, {19.199, 
               2.1439556734903107`}}], 
              LineBox[{
               Offset[{1.5, 0}, {19.199, 13.49337739468438}], 
                Offset[{-1.5, 0}, {19.199, 13.49337739468438}]}], 
              LineBox[{
               Offset[{1.5, 0}, {19.199, 2.1439556734903107`}], 
                Offset[{-1.5, 0}, {19.199, 2.1439556734903107`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 165], {
              LineBox[{{19.262, 13.49337739468438}, {19.262, 
               2.1439556734903107`}}], 
              LineBox[{
               Offset[{1.5, 0}, {19.262, 13.49337739468438}], 
                Offset[{-1.5, 0}, {19.262, 13.49337739468438}]}], 
              LineBox[{
               Offset[{1.5, 0}, {19.262, 2.1439556734903107`}], 
                Offset[{-1.5, 0}, {19.262, 2.1439556734903107`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 166], {
              LineBox[{{19.295, 13.49337739468438}, {19.295, 
               2.1439556734903107`}}], 
              LineBox[{
               Offset[{1.5, 0}, {19.295, 13.49337739468438}], 
                Offset[{-1.5, 0}, {19.295, 13.49337739468438}]}], 
              LineBox[{
               Offset[{1.5, 0}, {19.295, 2.1439556734903107`}], 
                Offset[{-1.5, 0}, {19.295, 2.1439556734903107`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 167], {
              LineBox[{{19.3, 13.49337739468438}, {19.3, 
               2.1439556734903107`}}], 
              LineBox[{
               Offset[{1.5, 0}, {19.3, 13.49337739468438}], 
                Offset[{-1.5, 0}, {19.3, 13.49337739468438}]}], 
              LineBox[{
               Offset[{1.5, 0}, {19.3, 2.1439556734903107`}], 
                Offset[{-1.5, 0}, {19.3, 2.1439556734903107`}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 168], {
              LineBox[{{19.313, 13.49337739468438}, {19.313, 
               2.1439556734903107`}}], 
              LineBox[{
               Offset[{1.5, 0}, {19.313, 13.49337739468438}], 
                Offset[{-1.5, 0}, {19.313, 13.49337739468438}]}], 
              LineBox[{
               Offset[{1.5, 0}, {19.313, 2.1439556734903107`}], 
                Offset[{-1.5, 0}, {19.313, 2.1439556734903107`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 169], {
              LineBox[{{19.382, 13.49337739468438}, {19.382, 
               2.1439556734903107`}}], 
              LineBox[{
               Offset[{1.5, 0}, {19.382, 13.49337739468438}], 
                Offset[{-1.5, 0}, {19.382, 13.49337739468438}]}], 
              LineBox[{
               Offset[{1.5, 0}, {19.382, 2.1439556734903107`}], 
                Offset[{-1.5, 0}, {19.382, 2.1439556734903107`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 170], {
              LineBox[{{19.459, 13.49337739468438}, {19.459, 
               2.1439556734903107`}}], 
              LineBox[{
               Offset[{1.5, 0}, {19.459, 13.49337739468438}], 
                Offset[{-1.5, 0}, {19.459, 13.49337739468438}]}], 
              LineBox[{
               Offset[{1.5, 0}, {19.459, 2.1439556734903107`}], 
                Offset[{-1.5, 0}, {19.459, 2.1439556734903107`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 171], {
              LineBox[{{19.755, 13.49337739468438}, {19.755, 
               2.1439556734903107`}}], 
              LineBox[{
               Offset[{1.5, 0}, {19.755, 13.49337739468438}], 
                Offset[{-1.5, 0}, {19.755, 13.49337739468438}]}], 
              LineBox[{
               Offset[{1.5, 0}, {19.755, 2.1439556734903107`}], 
                Offset[{-1.5, 0}, {19.755, 2.1439556734903107`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 172], {
              LineBox[{{19.868, 13.49337739468438}, {19.868, 
               2.1439556734903107`}}], 
              LineBox[{
               Offset[{1.5, 0}, {19.868, 13.49337739468438}], 
                Offset[{-1.5, 0}, {19.868, 13.49337739468438}]}], 
              LineBox[{
               Offset[{1.5, 0}, {19.868, 2.1439556734903107`}], 
                Offset[{-1.5, 0}, {19.868, 2.1439556734903107`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 173], {
              LineBox[{{20.236, 13.49337739468438}, {20.236, 
               2.1439556734903107`}}], 
              LineBox[{
               Offset[{1.5, 0}, {20.236, 13.49337739468438}], 
                Offset[{-1.5, 0}, {20.236, 13.49337739468438}]}], 
              LineBox[{
               Offset[{1.5, 0}, {20.236, 2.1439556734903107`}], 
                Offset[{-1.5, 0}, {20.236, 2.1439556734903107`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 174], {
              LineBox[{{20.53, 13.49337739468438}, {20.53, 
               2.1439556734903107`}}], 
              LineBox[{
               Offset[{1.5, 0}, {20.53, 13.49337739468438}], 
                Offset[{-1.5, 0}, {20.53, 13.49337739468438}]}], 
              LineBox[{
               Offset[{1.5, 0}, {20.53, 2.1439556734903107`}], 
                Offset[{-1.5, 0}, {20.53, 2.1439556734903107`}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 175], {
              LineBox[{{20.811, 13.49337739468438}, {20.811, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {20.811, 13.49337739468438}], 
                Offset[{-1.5, 0}, {20.811, 13.49337739468438}]}], 
              LineBox[{
               Offset[{1.5, 0}, {20.811, 2.131498096857408}], 
                Offset[{-1.5, 0}, {20.811, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 176], {
              LineBox[{{21.093, 13.49337739468438}, {21.093, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {21.093, 13.49337739468438}], 
                Offset[{-1.5, 0}, {21.093, 13.49337739468438}]}], 
              LineBox[{
               Offset[{1.5, 0}, {21.093, 2.131498096857408}], 
                Offset[{-1.5, 0}, {21.093, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 177], {
              LineBox[{{21.369, 15.803387118844666`}, {21.369, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {21.369, 15.803387118844666`}], 
                Offset[{-1.5, 0}, {21.369, 15.803387118844666`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {21.369, 2.131498096857408}], 
                Offset[{-1.5, 0}, {21.369, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 178], {
              LineBox[{{21.681, 15.803387118844666`}, {21.681, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {21.681, 15.803387118844666`}], 
                Offset[{-1.5, 0}, {21.681, 15.803387118844666`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {21.681, 2.131498096857408}], 
                Offset[{-1.5, 0}, {21.681, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 179], {
              LineBox[{{22.015, 15.803387118844666`}, {22.015, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {22.015, 15.803387118844666`}], 
                Offset[{-1.5, 0}, {22.015, 15.803387118844666`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {22.015, 2.131498096857408}], 
                Offset[{-1.5, 0}, {22.015, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 180], {
              LineBox[{{22.042, 15.803387118844666`}, {22.042, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {22.042, 15.803387118844666`}], 
                Offset[{-1.5, 0}, {22.042, 15.803387118844666`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {22.042, 2.131498096857408}], 
                Offset[{-1.5, 0}, {22.042, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 181], {
              LineBox[{{22.069, 15.803387118844666`}, {22.069, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {22.069, 15.803387118844666`}], 
                Offset[{-1.5, 0}, {22.069, 15.803387118844666`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {22.069, 2.131498096857408}], 
                Offset[{-1.5, 0}, {22.069, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 182], {
              LineBox[{{22.075, 15.803387118844666`}, {22.075, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {22.075, 15.803387118844666`}], 
                Offset[{-1.5, 0}, {22.075, 15.803387118844666`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {22.075, 2.131498096857408}], 
                Offset[{-1.5, 0}, {22.075, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 183], {
              LineBox[{{22.106, 15.803387118844666`}, {22.106, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {22.106, 15.803387118844666`}], 
                Offset[{-1.5, 0}, {22.106, 15.803387118844666`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {22.106, 2.131498096857408}], 
                Offset[{-1.5, 0}, {22.106, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 184], {
              LineBox[{{22.298, 15.803387118844668`}, {22.298, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {22.298, 15.803387118844668`}], 
                Offset[{-1.5, 0}, {22.298, 15.803387118844668`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {22.298, 2.131498096857408}], 
                Offset[{-1.5, 0}, {22.298, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 185], {
              LineBox[{{22.394, 15.803387118844668`}, {22.394, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {22.394, 15.803387118844668`}], 
                Offset[{-1.5, 0}, {22.394, 15.803387118844668`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {22.394, 2.131498096857408}], 
                Offset[{-1.5, 0}, {22.394, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 186], {
              LineBox[{{22.424, 15.803387118844668`}, {22.424, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {22.424, 15.803387118844668`}], 
                Offset[{-1.5, 0}, {22.424, 15.803387118844668`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {22.424, 2.131498096857408}], 
                Offset[{-1.5, 0}, {22.424, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 187], {
              LineBox[{{22.438, 15.803387118844668`}, {22.438, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {22.438, 15.803387118844668`}], 
                Offset[{-1.5, 0}, {22.438, 15.803387118844668`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {22.438, 2.131498096857408}], 
                Offset[{-1.5, 0}, {22.438, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 188], {
              LineBox[{{22.58, 15.803387118844668`}, {22.58, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {22.58, 15.803387118844668`}], 
                Offset[{-1.5, 0}, {22.58, 15.803387118844668`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {22.58, 2.131498096857408}], 
                Offset[{-1.5, 0}, {22.58, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 189], {
              LineBox[{{22.583, 15.803387118844668`}, {22.583, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {22.583, 15.803387118844668`}], 
                Offset[{-1.5, 0}, {22.583, 15.803387118844668`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {22.583, 2.131498096857408}], 
                Offset[{-1.5, 0}, {22.583, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 190], {
              LineBox[{{22.826, 15.803387118844668`}, {22.826, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {22.826, 15.803387118844668`}], 
                Offset[{-1.5, 0}, {22.826, 15.803387118844668`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {22.826, 2.131498096857408}], 
                Offset[{-1.5, 0}, {22.826, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 191], {
              LineBox[{{22.853, 15.803387118844668`}, {22.853, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {22.853, 15.803387118844668`}], 
                Offset[{-1.5, 0}, {22.853, 15.803387118844668`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {22.853, 2.131498096857408}], 
                Offset[{-1.5, 0}, {22.853, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 192], {
              LineBox[{{23.162, 15.560009649225263`}, {23.162, 
               2.0557998473197294`}}], 
              LineBox[{
               Offset[{1.5, 0}, {23.162, 15.560009649225263`}], 
                Offset[{-1.5, 0}, {23.162, 15.560009649225263`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {23.162, 2.0557998473197294`}], 
                Offset[{-1.5, 0}, {23.162, 2.0557998473197294`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 193], {
              LineBox[{{23.173, 15.560009649225263`}, {23.173, 
               2.0557998473197294`}}], 
              LineBox[{
               Offset[{1.5, 0}, {23.173, 15.560009649225263`}], 
                Offset[{-1.5, 0}, {23.173, 15.560009649225263`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {23.173, 2.0557998473197294`}], 
                Offset[{-1.5, 0}, {23.173, 2.0557998473197294`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 194], {
              LineBox[{{23.435, 15.73547338959265}, {23.435, 
               2.0557998473197294`}}], 
              LineBox[{
               Offset[{1.5, 0}, {23.435, 15.73547338959265}], 
                Offset[{-1.5, 0}, {23.435, 15.73547338959265}]}], 
              LineBox[{
               Offset[{1.5, 0}, {23.435, 2.0557998473197294`}], 
                Offset[{-1.5, 0}, {23.435, 2.0557998473197294`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 195], {
              LineBox[{{24.089, 15.73547338959265}, {24.089, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {24.089, 15.73547338959265}], 
                Offset[{-1.5, 0}, {24.089, 15.73547338959265}]}], 
              LineBox[{
               Offset[{1.5, 0}, {24.089, 2.131498096857408}], 
                Offset[{-1.5, 0}, {24.089, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 196], {
              LineBox[{{24.401, 15.735473389592649`}, {24.401, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {24.401, 15.735473389592649`}], 
                Offset[{-1.5, 0}, {24.401, 15.735473389592649`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {24.401, 2.131498096857408}], 
                Offset[{-1.5, 0}, {24.401, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 197], {
              LineBox[{{24.656, 15.735473389592649`}, {24.656, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {24.656, 15.735473389592649`}], 
                Offset[{-1.5, 0}, {24.656, 15.735473389592649`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {24.656, 2.131498096857408}], 
                Offset[{-1.5, 0}, {24.656, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 198], {
              LineBox[{{24.997, 15.73547338959265}, {24.997, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {24.997, 15.73547338959265}], 
                Offset[{-1.5, 0}, {24.997, 15.73547338959265}]}], 
              LineBox[{
               Offset[{1.5, 0}, {24.997, 2.131498096857408}], 
                Offset[{-1.5, 0}, {24.997, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 199], {
              LineBox[{{25.417, 15.73547338959265}, {25.417, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {25.417, 15.73547338959265}], 
                Offset[{-1.5, 0}, {25.417, 15.73547338959265}]}], 
              LineBox[{
               Offset[{1.5, 0}, {25.417, 2.131498096857408}], 
                Offset[{-1.5, 0}, {25.417, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 200], {
              LineBox[{{25.539, 15.73547338959265}, {25.539, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {25.539, 15.73547338959265}], 
                Offset[{-1.5, 0}, {25.539, 15.73547338959265}]}], 
              LineBox[{
               Offset[{1.5, 0}, {25.539, 2.131498096857408}], 
                Offset[{-1.5, 0}, {25.539, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 201], {
              LineBox[{{25.624, 15.73547338959265}, {25.624, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {25.624, 15.73547338959265}], 
                Offset[{-1.5, 0}, {25.624, 15.73547338959265}]}], 
              LineBox[{
               Offset[{1.5, 0}, {25.624, 2.131498096857408}], 
                Offset[{-1.5, 0}, {25.624, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 202], {
              LineBox[{{25.713, 15.73547338959265}, {25.713, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {25.713, 15.73547338959265}], 
                Offset[{-1.5, 0}, {25.713, 15.73547338959265}]}], 
              LineBox[{
               Offset[{1.5, 0}, {25.713, 2.131498096857408}], 
                Offset[{-1.5, 0}, {25.713, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 203], {
              LineBox[{{25.733, 15.73547338959265}, {25.733, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {25.733, 15.73547338959265}], 
                Offset[{-1.5, 0}, {25.733, 15.73547338959265}]}], 
              LineBox[{
               Offset[{1.5, 0}, {25.733, 2.131498096857408}], 
                Offset[{-1.5, 0}, {25.733, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 204], {
              LineBox[{{25.776, 15.73547338959265}, {25.776, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {25.776, 15.73547338959265}], 
                Offset[{-1.5, 0}, {25.776, 15.73547338959265}]}], 
              LineBox[{
               Offset[{1.5, 0}, {25.776, 2.131498096857408}], 
                Offset[{-1.5, 0}, {25.776, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 205], {
              LineBox[{{26.183, 15.73547338959265}, {26.183, 
               2.131498096857408}}], 
              LineBox[{
               Offset[{1.5, 0}, {26.183, 15.73547338959265}], 
                Offset[{-1.5, 0}, {26.183, 15.73547338959265}]}], 
              LineBox[{
               Offset[{1.5, 0}, {26.183, 2.131498096857408}], 
                Offset[{-1.5, 0}, {26.183, 2.131498096857408}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 206], {
              LineBox[{{26.335, 15.803387118844666`}, {26.335, 
               2.143955673490311}}], 
              LineBox[{
               Offset[{1.5, 0}, {26.335, 15.803387118844666`}], 
                Offset[{-1.5, 0}, {26.335, 15.803387118844666`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {26.335, 2.143955673490311}], 
                Offset[{-1.5, 0}, {26.335, 2.143955673490311}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 207], {
              LineBox[{{26.592, 15.803387118844666`}, {26.592, 
               2.143955673490311}}], 
              LineBox[{
               Offset[{1.5, 0}, {26.592, 15.803387118844666`}], 
                Offset[{-1.5, 0}, {26.592, 15.803387118844666`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {26.592, 2.143955673490311}], 
                Offset[{-1.5, 0}, {26.592, 2.143955673490311}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 208], {
              LineBox[{{26.595, 15.803387118844666`}, {26.595, 
               2.143955673490311}}], 
              LineBox[{
               Offset[{1.5, 0}, {26.595, 15.803387118844666`}], 
                Offset[{-1.5, 0}, {26.595, 15.803387118844666`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {26.595, 2.143955673490311}], 
                Offset[{-1.5, 0}, {26.595, 2.143955673490311}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 209], {
              LineBox[{{26.703, 15.803387118844666`}, {26.703, 
               2.143955673490311}}], 
              LineBox[{
               Offset[{1.5, 0}, {26.703, 15.803387118844666`}], 
                Offset[{-1.5, 0}, {26.703, 15.803387118844666`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {26.703, 2.143955673490311}], 
                Offset[{-1.5, 0}, {26.703, 2.143955673490311}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 210], {
              LineBox[{{26.778, 15.803387118844666`}, {26.778, 
               2.1439556734903107`}}], 
              LineBox[{
               Offset[{1.5, 0}, {26.778, 15.803387118844666`}], 
                Offset[{-1.5, 0}, {26.778, 15.803387118844666`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {26.778, 2.1439556734903107`}], 
                Offset[{-1.5, 0}, {26.778, 2.1439556734903107`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 211], {
              LineBox[{{27.11, 16.039867058033586`}, {27.11, 
               2.3386400580802933`}}], 
              LineBox[{
               Offset[{1.5, 0}, {27.11, 16.039867058033586`}], 
                Offset[{-1.5, 0}, {27.11, 16.039867058033586`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {27.11, 2.3386400580802933`}], 
                Offset[{-1.5, 0}, {27.11, 2.3386400580802933`}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 212], {
              LineBox[{{27.154, 16.039867058033586`}, {27.154, 
               2.3386400580802933`}}], 
              LineBox[{
               Offset[{1.5, 0}, {27.154, 16.039867058033586`}], 
                Offset[{-1.5, 0}, {27.154, 16.039867058033586`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {27.154, 2.3386400580802933`}], 
                Offset[{-1.5, 0}, {27.154, 2.3386400580802933`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 213], {
              LineBox[{{27.276, 16.039867058033586`}, {27.276, 
               2.4972493252177714`}}], 
              LineBox[{
               Offset[{1.5, 0}, {27.276, 16.039867058033586`}], 
                Offset[{-1.5, 0}, {27.276, 16.039867058033586`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {27.276, 2.4972493252177714`}], 
                Offset[{-1.5, 0}, {27.276, 2.4972493252177714`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 214], {
              LineBox[{{27.277, 16.039867058033586`}, {27.277, 
               2.4972493252177714`}}], 
              LineBox[{
               Offset[{1.5, 0}, {27.277, 16.039867058033586`}], 
                Offset[{-1.5, 0}, {27.277, 16.039867058033586`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {27.277, 2.4972493252177714`}], 
                Offset[{-1.5, 0}, {27.277, 2.4972493252177714`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 215], {
              LineBox[{{27.343, 16.039867058033586`}, {27.343, 
               2.4972493252177714`}}], 
              LineBox[{
               Offset[{1.5, 0}, {27.343, 16.039867058033586`}], 
                Offset[{-1.5, 0}, {27.343, 16.039867058033586`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {27.343, 2.4972493252177714`}], 
                Offset[{-1.5, 0}, {27.343, 2.4972493252177714`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 216], {
              LineBox[{{27.478, 16.039867058033586`}, {27.478, 
               2.4972493252177714`}}], 
              LineBox[{
               Offset[{1.5, 0}, {27.478, 16.039867058033586`}], 
                Offset[{-1.5, 0}, {27.478, 16.039867058033586`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {27.478, 2.4972493252177714`}], 
                Offset[{-1.5, 0}, {27.478, 2.4972493252177714`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 217], {
              LineBox[{{27.557, 16.039867058033586`}, {27.557, 
               2.4972493252177714`}}], 
              LineBox[{
               Offset[{1.5, 0}, {27.557, 16.039867058033586`}], 
                Offset[{-1.5, 0}, {27.557, 16.039867058033586`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {27.557, 2.4972493252177714`}], 
                Offset[{-1.5, 0}, {27.557, 2.4972493252177714`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 218], {
              LineBox[{{27.789, 14.867088338069141`}, {27.789, 
               2.698683656174475}}], 
              LineBox[{
               Offset[{1.5, 0}, {27.789, 14.867088338069141`}], 
                Offset[{-1.5, 0}, {27.789, 14.867088338069141`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {27.789, 2.698683656174475}], 
                Offset[{-1.5, 0}, {27.789, 2.698683656174475}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 219], {
              LineBox[{{27.832, 14.867088338069141`}, {27.832, 
               2.698683656174475}}], 
              LineBox[{
               Offset[{1.5, 0}, {27.832, 14.867088338069141`}], 
                Offset[{-1.5, 0}, {27.832, 14.867088338069141`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {27.832, 2.698683656174475}], 
                Offset[{-1.5, 0}, {27.832, 2.698683656174475}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 220], {
              LineBox[{{28.097, 13.91451339484205}, {28.097, 
               2.698683656174475}}], 
              LineBox[{
               Offset[{1.5, 0}, {28.097, 13.91451339484205}], 
                Offset[{-1.5, 0}, {28.097, 13.91451339484205}]}], 
              LineBox[{
               Offset[{1.5, 0}, {28.097, 2.698683656174475}], 
                Offset[{-1.5, 0}, {28.097, 2.698683656174475}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 221], {
              LineBox[{{28.35, 12.326095762132013`}, {28.35, 
               2.698683656174475}}], 
              LineBox[{
               Offset[{1.5, 0}, {28.35, 12.326095762132013`}], 
                Offset[{-1.5, 0}, {28.35, 12.326095762132013`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {28.35, 2.698683656174475}], 
                Offset[{-1.5, 0}, {28.35, 2.698683656174475}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 222], {
              LineBox[{{28.599, 12.326095762132013`}, {28.599, 
               2.698683656174475}}], 
              LineBox[{
               Offset[{1.5, 0}, {28.599, 12.326095762132013`}], 
                Offset[{-1.5, 0}, {28.599, 12.326095762132013`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {28.599, 2.698683656174475}], 
                Offset[{-1.5, 0}, {28.599, 2.698683656174475}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 223], {
              LineBox[{{28.735, 12.326095762132013`}, {28.735, 
               2.698683656174475}}], 
              LineBox[{
               Offset[{1.5, 0}, {28.735, 12.326095762132013`}], 
                Offset[{-1.5, 0}, {28.735, 12.326095762132013`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {28.735, 2.698683656174475}], 
                Offset[{-1.5, 0}, {28.735, 2.698683656174475}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 224], {
              LineBox[{{28.838, 12.321746398834286`}, {28.838, 
               2.698683656174475}}], 
              LineBox[{
               Offset[{1.5, 0}, {28.838, 12.321746398834286`}], 
                Offset[{-1.5, 0}, {28.838, 12.321746398834286`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {28.838, 2.698683656174475}], 
                Offset[{-1.5, 0}, {28.838, 2.698683656174475}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 225], {
              LineBox[{{29.067, 12.321746398834286`}, {29.067, 
               2.698683656174475}}], 
              LineBox[{
               Offset[{1.5, 0}, {29.067, 12.321746398834286`}], 
                Offset[{-1.5, 0}, {29.067, 12.321746398834286`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {29.067, 2.698683656174475}], 
                Offset[{-1.5, 0}, {29.067, 2.698683656174475}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 226], {
              LineBox[{{29.319, 12.473955941640604`}, {29.319, 
               2.698683656174475}}], 
              LineBox[{
               Offset[{1.5, 0}, {29.319, 12.473955941640604`}], 
                Offset[{-1.5, 0}, {29.319, 12.473955941640604`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {29.319, 2.698683656174475}], 
                Offset[{-1.5, 0}, {29.319, 2.698683656174475}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 227], {
              LineBox[{{29.352, 12.473955941640604`}, {29.352, 
               2.698683656174475}}], 
              LineBox[{
               Offset[{1.5, 0}, {29.352, 12.473955941640604`}], 
                Offset[{-1.5, 0}, {29.352, 12.473955941640604`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {29.352, 2.698683656174475}], 
                Offset[{-1.5, 0}, {29.352, 2.698683656174475}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 228], {
              LineBox[{{29.373, 12.473955941640604`}, {29.373, 
               2.698683656174475}}], 
              LineBox[{
               Offset[{1.5, 0}, {29.373, 12.473955941640604`}], 
                Offset[{-1.5, 0}, {29.373, 12.473955941640604`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {29.373, 2.698683656174475}], 
                Offset[{-1.5, 0}, {29.373, 2.698683656174475}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 229], {
              LineBox[{{29.48, 12.473955941640604`}, {29.48, 
               2.698683656174475}}], 
              LineBox[{
               Offset[{1.5, 0}, {29.48, 12.473955941640604`}], 
                Offset[{-1.5, 0}, {29.48, 12.473955941640604`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {29.48, 2.698683656174475}], 
                Offset[{-1.5, 0}, {29.48, 2.698683656174475}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 230], {
              LineBox[{{29.623, 12.473955941640604`}, {29.623, 
               2.698683656174475}}], 
              LineBox[{
               Offset[{1.5, 0}, {29.623, 12.473955941640604`}], 
                Offset[{-1.5, 0}, {29.623, 12.473955941640604`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {29.623, 2.698683656174475}], 
                Offset[{-1.5, 0}, {29.623, 2.698683656174475}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 231], {
              LineBox[{{29.642, 12.473955941640604`}, {29.642, 
               2.698683656174475}}], 
              LineBox[{
               Offset[{1.5, 0}, {29.642, 12.473955941640604`}], 
                Offset[{-1.5, 0}, {29.642, 12.473955941640604`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {29.642, 2.698683656174475}], 
                Offset[{-1.5, 0}, {29.642, 2.698683656174475}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 232], {
              LineBox[{{29.994, 12.473955941640604`}, {29.994, 
               2.698683656174475}}], 
              LineBox[{
               Offset[{1.5, 0}, {29.994, 12.473955941640604`}], 
                Offset[{-1.5, 0}, {29.994, 12.473955941640604`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {29.994, 2.698683656174475}], 
                Offset[{-1.5, 0}, {29.994, 2.698683656174475}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 233], {
              LineBox[{{30.094, 12.321746398834286`}, {30.094, 
               2.698683656174475}}], 
              LineBox[{
               Offset[{1.5, 0}, {30.094, 12.321746398834286`}], 
                Offset[{-1.5, 0}, {30.094, 12.321746398834286`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {30.094, 2.698683656174475}], 
                Offset[{-1.5, 0}, {30.094, 2.698683656174475}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 234], {
              LineBox[{{30.247, 12.321746398834286`}, {30.247, 
               2.698683656174475}}], 
              LineBox[{
               Offset[{1.5, 0}, {30.247, 12.321746398834286`}], 
                Offset[{-1.5, 0}, {30.247, 12.321746398834286`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {30.247, 2.698683656174475}], 
                Offset[{-1.5, 0}, {30.247, 2.698683656174475}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 235], {
              LineBox[{{30.249, 12.321746398834286`}, {30.249, 
               2.698683656174475}}], 
              LineBox[{
               Offset[{1.5, 0}, {30.249, 12.321746398834286`}], 
                Offset[{-1.5, 0}, {30.249, 12.321746398834286`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {30.249, 2.698683656174475}], 
                Offset[{-1.5, 0}, {30.249, 2.698683656174475}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 236], {
              LineBox[{{30.495, 12.321746398834286`}, {30.495, 
               2.698683656174475}}], 
              LineBox[{
               Offset[{1.5, 0}, {30.495, 12.321746398834286`}], 
                Offset[{-1.5, 0}, {30.495, 12.321746398834286`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {30.495, 2.698683656174475}], 
                Offset[{-1.5, 0}, {30.495, 2.698683656174475}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 237], {
              LineBox[{{30.784, 12.321746398834286`}, {30.784, 
               2.698683656174475}}], 
              LineBox[{
               Offset[{1.5, 0}, {30.784, 12.321746398834286`}], 
                Offset[{-1.5, 0}, {30.784, 12.321746398834286`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {30.784, 2.698683656174475}], 
                Offset[{-1.5, 0}, {30.784, 2.698683656174475}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 238], {
              LineBox[{{31.329, 12.321746398834286`}, {31.329, 
               2.6588406238259745`}}], 
              LineBox[{
               Offset[{1.5, 0}, {31.329, 12.321746398834286`}], 
                Offset[{-1.5, 0}, {31.329, 12.321746398834286`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {31.329, 2.6588406238259745`}], 
                Offset[{-1.5, 0}, {31.329, 2.6588406238259745`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 239], {
              LineBox[{{31.363, 12.321746398834286`}, {31.363, 
               2.6588406238259745`}}], 
              LineBox[{
               Offset[{1.5, 0}, {31.363, 12.321746398834286`}], 
                Offset[{-1.5, 0}, {31.363, 12.321746398834286`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {31.363, 2.6588406238259745`}], 
                Offset[{-1.5, 0}, {31.363, 2.6588406238259745`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 240], {
              LineBox[{{31.482, 12.321746398834286`}, {31.482, 
               1.6016961044634535`}}], 
              LineBox[{
               Offset[{1.5, 0}, {31.482, 12.321746398834286`}], 
                Offset[{-1.5, 0}, {31.482, 12.321746398834286`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {31.482, 1.6016961044634535`}], 
                Offset[{-1.5, 0}, {31.482, 1.6016961044634535`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 241], {
              LineBox[{{31.843, 11.605250004565127`}, {31.843, 
               1.3732778136327446`}}], 
              LineBox[{
               Offset[{1.5, 0}, {31.843, 11.605250004565127`}], 
                Offset[{-1.5, 0}, {31.843, 11.605250004565127`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {31.843, 1.3732778136327446`}], 
                Offset[{-1.5, 0}, {31.843, 1.3732778136327446`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 242], {
              LineBox[{{32.009, 11.479389690623226`}, {32.009, 
               1.3732778136327446`}}], 
              LineBox[{
               Offset[{1.5, 0}, {32.009, 11.479389690623226`}], 
                Offset[{-1.5, 0}, {32.009, 11.479389690623226`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {32.009, 1.3732778136327446`}], 
                Offset[{-1.5, 0}, {32.009, 1.3732778136327446`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 243], {
              LineBox[{{33.48, 8.890651729926178}, {33.48, 
               1.1034861520768264`}}], 
              LineBox[{
               Offset[{1.5, 0}, {33.48, 8.890651729926178}], 
                Offset[{-1.5, 0}, {33.48, 8.890651729926178}]}], 
              LineBox[{
               Offset[{1.5, 0}, {33.48, 1.1034861520768264`}], 
                Offset[{-1.5, 0}, {33.48, 1.1034861520768264`}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 244], {
              LineBox[{{33.533, 8.890651729926178}, {33.533, 
               1.1034861520768264`}}], 
              LineBox[{
               Offset[{1.5, 0}, {33.533, 8.890651729926178}], 
                Offset[{-1.5, 0}, {33.533, 8.890651729926178}]}], 
              LineBox[{
               Offset[{1.5, 0}, {33.533, 1.1034861520768264`}], 
                Offset[{-1.5, 0}, {33.533, 1.1034861520768264`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 245], {
              LineBox[{{34.483, 8.890651729926178}, {34.483, 
               1.0754855450416807`}}], 
              LineBox[{
               Offset[{1.5, 0}, {34.483, 8.890651729926178}], 
                Offset[{-1.5, 0}, {34.483, 8.890651729926178}]}], 
              LineBox[{
               Offset[{1.5, 0}, {34.483, 1.0754855450416807`}], 
                Offset[{-1.5, 0}, {34.483, 1.0754855450416807`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 246], {
              LineBox[{{34.488, 8.890651729926178}, {34.488, 
               1.0754855450416807`}}], 
              LineBox[{
               Offset[{1.5, 0}, {34.488, 8.890651729926178}], 
                Offset[{-1.5, 0}, {34.488, 8.890651729926178}]}], 
              LineBox[{
               Offset[{1.5, 0}, {34.488, 1.0754855450416807`}], 
                Offset[{-1.5, 0}, {34.488, 1.0754855450416807`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 247], {
              LineBox[{{34.62, 7.953982742084829}, {34.62, 
               1.0754855450416807`}}], 
              LineBox[{
               Offset[{1.5, 0}, {34.62, 7.953982742084829}], 
                Offset[{-1.5, 0}, {34.62, 7.953982742084829}]}], 
              LineBox[{
               Offset[{1.5, 0}, {34.62, 1.0754855450416807`}], 
                Offset[{-1.5, 0}, {34.62, 1.0754855450416807`}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 248], {
              LineBox[{{39.634, 8.251917320812652}, {39.634, 
               1.0940578650298862`}}], 
              LineBox[{
               Offset[{1.5, 0}, {39.634, 8.251917320812652}], 
                Offset[{-1.5, 0}, {39.634, 8.251917320812652}]}], 
              LineBox[{
               Offset[{1.5, 0}, {39.634, 1.0940578650298862`}], 
                Offset[{-1.5, 0}, {39.634, 1.0940578650298862`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 249], {
              LineBox[{{40.641, 8.141752207470867}, {40.641, 
               1.0940578650298862`}}], 
              LineBox[{
               Offset[{1.5, 0}, {40.641, 8.141752207470867}], 
                Offset[{-1.5, 0}, {40.641, 8.141752207470867}]}], 
              LineBox[{
               Offset[{1.5, 0}, {40.641, 1.0940578650298862`}], 
                Offset[{-1.5, 0}, {40.641, 1.0940578650298862`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 250], {
              LineBox[{{42.973, 8.277633615714565}, {42.973, 
               1.0940578650298862`}}], 
              LineBox[{
               Offset[{1.5, 0}, {42.973, 8.277633615714565}], 
                Offset[{-1.5, 0}, {42.973, 8.277633615714565}]}], 
              LineBox[{
               Offset[{1.5, 0}, {42.973, 1.0940578650298862`}], 
                Offset[{-1.5, 0}, {42.973, 1.0940578650298862`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 251], {
              LineBox[{{44.283, 11.806473530277493`}, {44.283, 
               1.2362306579711335`}}], 
              LineBox[{
               Offset[{1.5, 0}, {44.283, 11.806473530277493`}], 
                Offset[{-1.5, 0}, {44.283, 11.806473530277493`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {44.283, 1.2362306579711335`}], 
                Offset[{-1.5, 0}, {44.283, 1.2362306579711335`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 252], {
              LineBox[{{45.828, 8.364676655025551}, {45.828, 
               1.6135481402583909`}}], 
              LineBox[{
               Offset[{1.5, 0}, {45.828, 8.364676655025551}], 
                Offset[{-1.5, 0}, {45.828, 8.364676655025551}]}], 
              LineBox[{
               Offset[{1.5, 0}, {45.828, 1.6135481402583909`}], 
                Offset[{-1.5, 0}, {45.828, 1.6135481402583909`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 253], {
              LineBox[{{46.256, 8.157641236046551}, {46.256, 
               1.6927894211139813`}}], 
              LineBox[{
               Offset[{1.5, 0}, {46.256, 8.157641236046551}], 
                Offset[{-1.5, 0}, {46.256, 8.157641236046551}]}], 
              LineBox[{
               Offset[{1.5, 0}, {46.256, 1.6927894211139813`}], 
                Offset[{-1.5, 0}, {46.256, 1.6927894211139813`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 254], {
              LineBox[{{46.658, 10.040666090178572`}, {46.658, 
               1.6927894211139813`}}], 
              LineBox[{
               Offset[{1.5, 0}, {46.658, 10.040666090178572`}], 
                Offset[{-1.5, 0}, {46.658, 10.040666090178572`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {46.658, 1.6927894211139813`}], 
                Offset[{-1.5, 0}, {46.658, 1.6927894211139813`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 255], {
              LineBox[{{47.063, 9.746942997663497}, {47.063, 
               1.6927894211139813`}}], 
              LineBox[{
               Offset[{1.5, 0}, {47.063, 9.746942997663497}], 
                Offset[{-1.5, 0}, {47.063, 9.746942997663497}]}], 
              LineBox[{
               Offset[{1.5, 0}, {47.063, 1.6927894211139813`}], 
                Offset[{-1.5, 0}, {47.063, 1.6927894211139813`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 256], {
              LineBox[{{47.443, 10.415100678555948`}, {47.443, 
               1.6927894211139813`}}], 
              LineBox[{
               Offset[{1.5, 0}, {47.443, 10.415100678555948`}], 
                Offset[{-1.5, 0}, {47.443, 10.415100678555948`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {47.443, 1.6927894211139813`}], 
                Offset[{-1.5, 0}, {47.443, 1.6927894211139813`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 257], {
              LineBox[{{47.856, 8.702863472381466}, {47.856, 
               1.6927894211139813`}}], 
              LineBox[{
               Offset[{1.5, 0}, {47.856, 8.702863472381466}], 
                Offset[{-1.5, 0}, {47.856, 8.702863472381466}]}], 
              LineBox[{
               Offset[{1.5, 0}, {47.856, 1.6927894211139813`}], 
                Offset[{-1.5, 0}, {47.856, 1.6927894211139813`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 258], {
              LineBox[{{48.272, 8.702863472381466}, {48.272, 
               1.6927894211139813`}}], 
              LineBox[{
               Offset[{1.5, 0}, {48.272, 8.702863472381466}], 
                Offset[{-1.5, 0}, {48.272, 8.702863472381466}]}], 
              LineBox[{
               Offset[{1.5, 0}, {48.272, 1.6927894211139813`}], 
                Offset[{-1.5, 0}, {48.272, 1.6927894211139813`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 259], {
              LineBox[{{49.174, 10.279565801221775`}, {49.174, 
               1.7881765610841414`}}], 
              LineBox[{
               Offset[{1.5, 0}, {49.174, 10.279565801221775`}], 
                Offset[{-1.5, 0}, {49.174, 10.279565801221775`}]}], 
              LineBox[{
               Offset[{1.5, 0}, {49.174, 1.7881765610841414`}], 
                Offset[{-1.5, 0}, {49.174, 1.7881765610841414`}]}]}}, {
             InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 260], {
              LineBox[{{49.985, 8.801571361486912}, {49.985, 
               1.7958751621666122`}}], 
              LineBox[{
               Offset[{1.5, 0}, {49.985, 8.801571361486912}], 
                Offset[{-1.5, 0}, {49.985, 8.801571361486912}]}], 
              LineBox[{
               Offset[{1.5, 0}, {49.985, 1.7958751621666122`}], 
                Offset[{-1.5, 0}, {49.985, 
                 1.7958751621666122`}]}]}}}, {}}], {}}, {{}, 
         GraphicsComplexBox[CompressedData["
1:eJztlvlTU1cUx8PShEbQRBYTwIXFEovKJoiEJAdZEgQUcMFStAXRaoqKFJQC
RbEDETfGyuJSRIu4dCyjgpRB0OpkFKkrdKDooDKUoS4UAYFaCvbd+5x3nP4N
eb9kPnNz7jv3e7/nvOOQsDl6rTGPxzM14vHI75yLpX2nb/Sorruk7zuW/iH8
EFwzOPbba1XryqyrITcEQJfDhjiOrp2W+yLKAiaZjNpqu/nwV5bKe3WdCJ4n
v93rJhbAlPa7I0vXiMFdHf77HncBsPsjm52zj02UW3Lcfd/x0Ztxey7eizyD
DhAWqd8+1sKHJ0v2lWz6zhGyTH+U22v5sDhBtHJB9UwwGy1KSHHgg+mKiXMu
TnXhuFLdmWG1yRVydz7e9WmGAK6U2bp1/OEKGv7PQZeyBfC9fsb5FNlciK7Q
nV7cIIRF5sauumF3cK5+8FPPBRFsnvztL01GHhzTfA56gPGlK7+6JdnAzbD5
+QFPPaA3YiDrnJ0tm9+ABzz9Wq+43C9l13meHE8kAgg8uf8z4tVOm4l85gYJ
QNbZEAExnjls49ZsXP/3bH9zxE7ktvJkhbAE+VrTieCaKuRZcQXXh/5EVgiZ
iDHk4sA9ST12Xtz7NvaMnu33RI5kjjc5EPklk35uGPKd28wTjtxVcVQ/IxKZ
6hmP7NbhzM9JQ2Zuq1J9zQvmhR5tf9UqhQO9jKEeIzs9epOt9Z8HDwtydKVf
SEFDAnTI5PpL782D3WlqzQGdBFyJgFO8wbd2a3GDTMLqt9obfN5x2kGJ6YpK
by7+JCNfm4kPF39oE5OwEJlRZ/SsGJn6wRJ54eeMg+2QSTWEhvtAX1DqooYa
Keu/RGR+ThGjODLVKxnZihi4EHk9EaQI+Z9sbX1qCzKtv4fIpHrTZ83n9KX5
zEZm3CCL24xMqqnRxpdjWq/rfKHfc8uOck8J69/TyLR83/pyelK9tAs4DiKC
5SMT+a+UIdN6q0G+N7K0q+IyMtsvkI3Jhc71g9l9q59EeUtgWMYYerkfp3ei
nFQgMm1Ph5BpPVUh14UyCdz0A/8N1RtlyVIg5SGzl0NudF7oungp0OtxQab5
hCC/ZuR99h5Tv8XIuf3ofWTI4Zv6HeHaGCnQ9Pbj/6k+t+RgYhbRG8/0E7bf
IocQlPjD3gvq+vENNnDkMPN8gtwSwTTAw/5Qans/87iNDZt/PTLVtxV5nEn3
I7EChl/GjgQMW7N+jlJw6y4epCMjf0UM9xlyJjUkxtP1MgVcXeOoH+2yBhp+
EpnW27gCjn/ptLU0xRoGmpmEJUqOqX9UyNQf7/F00iCzlbA89eP2qYnWQNt9
oxJinD07PrC2Zvv/MhVofLYldHdbwfkUJqE4ZPp9yUSm99OmgjwrpYtTvJjV
wwg4pv2wAcAyLqbTfNCC3V+PTNphsyIAgiyOKFfpLNjzKZFpPS0JgPXP84oW
pluw+z8IhFdN9kaPUwVAys88Ogjqru9fL4gVsvWfFQyDLwrS6v4Wsu9zDoFT
nU3H7JQTWH88C4GSpKo1Z0omwTLaINTQpC9oNnsiend+NUQmJ20JKhSz+u5S
w3bTnFUTdotZvWqRHahAauicclemNRZDfgBpWBoo3xZ1R3RbBEx3PhFcrIGR
Wy+GOtaK2O/nuAZyCvNPrbITg2E+MMwHhvnAMB8Y5gPDfGCYDwzzwf/ng/8A
2HH7Pw==
          "], {
           {GrayLevel[0], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 131], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 132], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 133], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 134], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 135], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 136], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 137], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 138], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 139], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 140], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 141], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 142], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 143], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 144], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 145], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 146], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 147], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 148], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 149], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 150], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 151], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 152], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 153], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 154], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 155], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 156], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 157], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 158], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 159], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 160], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 161], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 162], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 163], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 164], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 165], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 166], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 167], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 168], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 169], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 170], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 171], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 172], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 173], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 174], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 175], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 176], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 177], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 178], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 179], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 180], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 181], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 182], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 183], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 184], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 185], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 186], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 187], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 188], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 189], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 190], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 191], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 192], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 193], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 194], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 195], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 196], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 197], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 198], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 199], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 200], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 201], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 202], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 203], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 204], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 205], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 206], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 207], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 208], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 209], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 210], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 211], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 212], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 213], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 214], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 215], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 216], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 217], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 218], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 219], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 220], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 221], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 222], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 223], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 224], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 225], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 226], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 227], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 228], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 229], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 230], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 231], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 232], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 233], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 234], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 235], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 236], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 237], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 238], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 239], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 240], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 241], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 242], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 243], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 244], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 245], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 246], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 247], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 248], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 249], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 250], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 251], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 252], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 253], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 254], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 255], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 256], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 257], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 258], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 259], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 260]}, {}}], {}}}, {{}, {}, 
        {GrayLevel[0], Thickness[0.003], LineBox[CompressedData["
1:eJxNzX0803sfx/G5nW4UEe3YEZsYuZuRpfAjm7kJUaESkXsh92m1TjpFN+4r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          "]]}}, {{}, {}, 
        {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
         LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ/SZ+oWqR10Y7nfqmH6wFjA5y577M9ttx3x7Gz+pc
VuSz4z2cXx8w9dXzNgYHGN9u8j+/J70ccD47z5mpHmYCcP6rOY8VGapF4Hzp
H5aVp8sk4PzjitHvvh+XgfNtzU751zUpwPn7HNj6umqU4PyaTerR7gtV4PzE
zhe8fQvV4PxTBVvvHZiuAecX7k+3W7JDC+He4p3Nglt14HzPvg/h+nf04PzX
dySXzqkxgPPdVLknPqswhPMdFPOPdHQZwflnzy969b7TGM7/aegZsX6eCZyf
PufrlZR1pnB+xs5Cl/urzeB8jq6E3xv3mcP51rzySz33W8D5G2Y8jr2+yxLO
P3JdKm7vaSs4P+ekYmDGKWs4f1Pe7O7sezZwvpWM9NWUt7ZwflhNlqDyKzs4
X3CCzlTLP/Zwvr72/VauOgc4v1xotUfxbwS/L9hAv6PZEc5/nyvbX8/kBOcr
PDospNyD4M/Sv8S/kscZzjdtTBZZ1YXgL9BZZxMu7ALnh2xMuPdsEoJ/o//M
YiVZVzi/tmh3wc0lCH62ntD2ImU3OF/TRUlxxxoE38B4FssDHXc4P0Jt6vum
VQh+QLHnv4tGHnD+pJmpbcybEHwHgwf7GH8i+G+PRX3/b+8J5wMAwypLiA==

          "]]}, 
        {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
         LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ/SZ+oWqR10Y7qavBc55cEHGQO/dltt+O+/Ywflbn
siKfHe/h/PqAqa+etzE4wPh2k//5PenlgPPZec5M9TATgPNfzXmsyFAtAudL
/7CsPF0mAecfV4x+9/24DJxva3bKv65JAc7f58DW11WjBOfXbFKPdl+oAucn
dr7g7VuoBuefKth678B0DTi/cH+63ZIdWgj3Fu9sFtyqA+d79n0I17+jB+e/
viO5dE6NAZzvpso98VmFIZzvoJh/pKPLCM4/e37Rq/edxnD+T0PPiPXzTOD8
9Dlfr6SsM4XzM3YWutxfbQbnc3Ql/N64zxzOt+aVX+q53wLO3zDjcez1XZZw
/pHrUnF7T1vB+TknFQMzTlnD+ZvyZndn37OB861kpK+mvLWF88NqsgSVX9nB
+YITdKZa/rGH8/W177dy1TnA+eVCqz2KfyP4fcEG+h3NjnD++1zZ/nomJzhf
4dFhIeUeBH+W/iX+lTzOcL5pY7LIqi4Ef4HOOptwYRc4P2Rjwr1nkxD8G/1n
FivJusL5tUW7C24uQfCz9YS2Fym7wfmaLkqKO9Yg+AbGs1ge6LjD+RFqU983
rULwA4o9/1008oDzJ81MbWPehOA7GDzYx/gTwX97LOr7f3tPOB8A9ZuBxA==

          "]]}, 
        {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
         LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ/SZ+oWqR10a72RukOB7UqzvInfsy22/HfXsYP6tz
WZHPjvdwfn3A1FfP2xgcYHy7yf/8nvRywPnsPGemepgJwPmv5jxWZKgWgfOl
f1hWni6TgPOPK0a/+35cBs63NTvlX9ekAOfvc2Dr66pRgvNrNqlHuy9UgfMT
O1/w9i1Ug/NPFWy9d2C6BpxfuD/dbskOLYR7i3c2C27VgfM9+z6E69/Rg/Nf
35FcOqfGAM53U+We+KzCEM53UMw/0tFlBOefPb/o1ftOYzj/p6FnxPp5JnB+
+pyvV1LWmcL5GTsLXe6vNoPzOboSfm/cZw7nW/PKL/XcbwHnb5jxOPb6Lks4
/8h1qbi9p63g/JyTioEZp6zh/E15s7uz79nA+VYy0ldT3trC+WE1WYLKr+zg
fMEJOlMt/9jD+fra91u56hzg/HKh1R7FvxH8vmAD/Y5mRzj/fa5sfz2TE5yv
8OiwkHIPgj9L/xL/Sh5nON+0MVlkVReCv0BnnU24sAucH7Ix4d6zSQj+jf4z
i5VkXeH82qLdBTeXIPjZekLbi5Td4HxNFyXFHWsQfAPjWSwPdNzh/Ai1qe+b
ViH4AcWe/y4aecD5k2amtjFvQvAdDB7sY/yJ4L89FvX9v70nnA8Ak+1daA==

          "]]}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      Axes->True,
      AxesLabel->{
        FormBox["\"x(kbp)\"", TraditionalForm], 
        FormBox["\"L\"", TraditionalForm]},
      AxesOrigin->{-1, 0},
      Method->{},
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->None], {192., -116.80842387373012`}, 
     ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[{{{}, {}, 
        {GrayLevel[0], Thickness[0.003], LineBox[CompressedData["
1:eJxNzX0803sfx/G5nW4UEe3YEZsYuZuRpfAjm7kJUaESkXsh92m1TjpFN+4r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          "]]}}, {{}, {}, 
        {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
         LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ/SZ+oWqR10Y7qavBc55cEHGQO/dltt+O+/Ywflbn
siKfHe/h/PqAqa+etzE4wPh2k//5PenlgPPZec5M9TATgPNfzXmsyFAtAudL
/7CsPF0mAecfV4x+9/24DJxva3bKv65JAc7f58DW11WjBOfXbFKPdl+oAucn
dr7g7VuoBuefKth678B0DTi/cH+63ZIdWgj3Fu9sFtyqA+d79n0I17+jB+e/
viO5dE6NAZzvpso98VmFIZzvoJh/pKPLCM4/e37Rq/edxnD+T0PPiPXzTOD8
9Dlfr6SsM4XzM3YWutxfbQbnc3Ql/N64zxzOt+aVX+q53wLO3zDjcez1XZZw
/pHrUnF7T1vB+TknFQMzTlnD+ZvyZndn37OB861kpK+mvLWF88NqsgSVX9nB
+YITdKZa/rGH8/W177dy1TnA+eVCqz2KfyP4fcEG+h3NjnD++1zZ/nomJzhf
4dFhIeUeBH+W/iX+lTzOcL5pY7LIqi4Ef4HOOptwYRc4P2Rjwr1nkxD8G/1n
FivJusL5tUW7C24uQfCz9YS2Fym7wfmaLkqKO9Yg+AbGs1ge6LjD+RFqU983
rULwA4o9/1008oDzJ81MbWPehOA7GDzYx/gTwX97LOr7f3tPOB8A9ZuBxA==

          "]]}}, {{}, {{}, {}, 
         {GrayLevel[0], Thickness[Large], LineBox[CompressedData["
1:eJxNlQ0wlHkcx73drhO1W2gXdSmd7VReQrJ296ewKxR60TnckTrtCTnkyind
aNOb6Qq9nNSV5KYzvTojdJkdyfXKDVcNMs64khPCdS7d//9/mufXM7Oz85n/
8/s/v+f7//6+j31ccvgGIwMDg13kR/8XXC4eKGvoVdU7Zh44mfkh/OhfOfzm
91eq1nVZNwIahMCWg0Z4Dq+amdsXZgFTjMdttD0C+DtL5RFTLYLnKW/3O4uF
MP3RvbFV68Xgog7+Y5+LELj9kU0v2EXGy6fx3PNg9pPXE3Z8/SJ6DdtDUKh+
x5sWAXSuPFCU9P1syDL5SW6nFcCKONG6JVfngul4QVyqvQBM1k5ecHmGI88V
6q5tlklOkLurY89n24RQV2Lj3P6nE2gEv/hdyxbCD/pZF1NlCyG8VFe2otYM
lpsbOelGXcDh6sOfey+JIHnqd782GbryzPo57ApG1+p+c060hltBi/N8n7pC
f8hQ1gVbG66/IVd4+o1ecX1Qyq0buPE8mQogdOPvJ+JVzZyLfL6BFiDrrKmA
WE9etjEjG9f/Kx9sDtmF3HYmRWFWhHyz6bR/5RXkeVH59SN/ISvMSMUb5MJl
+xJ7bRfxz9vcO14+6IYcSl5v6jLkF6T93CDku3fIFYzcXXpCPysUmekZi+zc
7iDISUcmp1WhvrkI3ANPPHrZKoVD/cRQHchznrzO1vq4w+P8HF3xl1LQ0AId
Mj3+4vvusDddrTmkk4ATFXC6B3hVZRTWyiScfjEe4PmO0w9LTNZWePD1Z4l8
bcaefP3RJNKwGTJRZ7xcjMz8MA156RfEwbbIdBoCgz1hwC9teW2llPNfPLIg
p4Aojsz0SkG2pAY+gpxABSlA/jdbW5PWgszm7zEynd7MeYt5fVk/85GJG2RR
ych0mhqtvXhm87rRCwbdtuw84ybh/FuGzMb3rRevJ9NLu4RnPypYHjKVv64E
mc1bJfL9sVXdpdeRubxANqIHutAb5g/EdIZ5SGBURgy9xpvXO15OJxCZxdNR
ZDZPV5CrA0kDt7zBZ9PVzbIUKdDxkNnJITd8d+DGWCmw43FEZv0EIL8i8j57
j5nfIuT8fuw8tsnh25qdwdoIKbD2DuL9TJ/bcjA2DemPJXnC5S1yAEWJD+y/
pK6Z2GQNx4+R61PklhASgMd8oNjmwfZT1tZc/zXITN9W5AnS7sdiBYy+iBzz
HbXi/Bym4NcdXWkiI39NDfc58nZmSKxn6yUKuLF+tn682wpY+VlkNm8TCjj1
1ZyM4lQrGGomDUuUPDP/qJCZP97jj2hAZithTdonj2bEWwGL+0YlRDi4tX9g
ZcXl/2oVaDy3xvX0WMLFVNJQFDL7vmxHZufTpoLdlkrHObFiTg9D4JnlYS3A
tKiILvNhC25/PTKNw2aFL/hZHFdG6yy491Mis3la6QsJz3cXLM204PZ/uAxe
NtkZdqQJgY6febgfVNcfTBBGmnHzn+UPw3356dX/mHHPcwiAc11NJ22Vkzh/
PAuAosQr688XTYHVLCDU0KTPbzbtFL17fzWEpiRu8Tsi5vTdo4YdJjnRk/aK
Ob2qkO2ZQGromn5PpjUSQ54vDSwNnNkadld0RwQknU/7F2pg7HbfSPsGEff9
nNBAzpG8c9G2Yvgfckx+9g==
           "]]}}, {}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      Axes->True,
      AxesLabel->{
        FormBox["\"x(kbp)\"", TraditionalForm], 
        FormBox["\"L\"", TraditionalForm]},
      AxesOrigin->0,
      Method->{},
      PlotRange->{{0, All}, {0, All}},
      PlotRangeClipping->True,
      PlotRangePadding->{Automatic, Automatic}], {576., -116.80842387373012`},
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}]}, {}},
  ContentSelectable->True,
  ImageSize->700,
  PlotRangePadding->{6, 5}]], "Output",
 CellChangeTimes->{3.5857641309960246`*^9, 3.585764868524209*^9, 
  3.585764922935321*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"gtbl", ",", "\[IndentingNewLine]", 
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"pos", "/", "1000"}], ",", 
          RowBox[{"Mean", "[", "tblsnp", "]"}]}], "}"}], "]"}], ",", 
       RowBox[{"PlotMarkers", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"AxesLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<kbp\>\"", ",", "\"\<E[tbl]\>\""}], "}"}]}]}], "]"}], 
     ",", 
     RowBox[{"Plot", "[", 
      RowBox[{
       RowBox[{"mf", "[", "nsq", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "0", ",", 
         RowBox[{"nbp", "/", "1000"}]}], "}"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Thick", ",", "Red"}], "}"}]}]}], "]"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"pos", "/", "1000"}], ",", 
          RowBox[{"Variance", "[", "tblsnp", "]"}]}], "}"}], "]"}], ",", 
       RowBox[{"PlotMarkers", "\[Rule]", "Automatic"}], ",", 
       RowBox[{"AxesLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<kbp\>\"", ",", "\"\<V[tbl]\>\""}], "}"}]}]}], "]"}], 
     ",", 
     RowBox[{"Plot", "[", 
      RowBox[{
       RowBox[{"vf", "[", "nsq", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "0", ",", 
         RowBox[{"nbp", "/", "1000"}]}], "}"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Thick", ",", "Red"}], "}"}]}]}], "]"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.5221932253050995`*^9, 3.5221932762140117`*^9}, {
   3.5221936067339163`*^9, 3.52219366501425*^9}, {3.522196861660087*^9, 
   3.522196881616229*^9}, {3.5226102186865935`*^9, 3.522610220476596*^9}, {
   3.5230394575847144`*^9, 3.5230395424510183`*^9}, {3.5239338178278093`*^9, 
   3.523933820157813*^9}, {3.5239398466563034`*^9, 3.5239398491363416`*^9}, {
   3.5241014421617374`*^9, 3.5241014887278194`*^9}, 3.524101869914489*^9, 
   3.5241731383909836`*^9, {3.529342897647563*^9, 3.529342900252768*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{{{}, GraphicsComplexBox[CompressedData["
1:eJztlvlTU1cUx8PShEbQRBYTwIXFEovKJoiEJAdZEgQUcMFStAXRaoqKFJQC
RbEDETfGyuJSRIu4dCyjgpRB0OpkFKkrdKDooDKUoS4UAYFaCvbd+5x3nP4N
eb9kPnNz7jv3e7/nvOOQsDl6rTGPxzM14vHI75yLpX2nb/Sorruk7zuW/iH8
EFwzOPbba1XryqyrITcEQJfDhjiOrp2W+yLKAiaZjNpqu/nwV5bKe3WdCJ4n
v93rJhbAlPa7I0vXiMFdHf77HncBsPsjm52zj02UW3Lcfd/x0Ztxey7eizyD
DhAWqd8+1sKHJ0v2lWz6zhGyTH+U22v5sDhBtHJB9UwwGy1KSHHgg+mKiXMu
TnXhuFLdmWG1yRVydz7e9WmGAK6U2bp1/OEKGv7PQZeyBfC9fsb5FNlciK7Q
nV7cIIRF5sauumF3cK5+8FPPBRFsnvztL01GHhzTfA56gPGlK7+6JdnAzbD5
+QFPPaA3YiDrnJ0tm9+ABzz9Wq+43C9l13meHE8kAgg8uf8z4tVOm4l85gYJ
QNbZEAExnjls49ZsXP/3bH9zxE7ktvJkhbAE+VrTieCaKuRZcQXXh/5EVgiZ
iDHk4sA9ST12Xtz7NvaMnu33RI5kjjc5EPklk35uGPKd28wTjtxVcVQ/IxKZ
6hmP7NbhzM9JQ2Zuq1J9zQvmhR5tf9UqhQO9jKEeIzs9epOt9Z8HDwtydKVf
SEFDAnTI5PpL782D3WlqzQGdBFyJgFO8wbd2a3GDTMLqt9obfN5x2kGJ6YpK
by7+JCNfm4kPF39oE5OwEJlRZ/SsGJn6wRJ54eeMg+2QSTWEhvtAX1DqooYa
Keu/RGR+ThGjODLVKxnZihi4EHk9EaQI+Z9sbX1qCzKtv4fIpHrTZ83n9KX5
zEZm3CCL24xMqqnRxpdjWq/rfKHfc8uOck8J69/TyLR83/pyelK9tAs4DiKC
5SMT+a+UIdN6q0G+N7K0q+IyMtsvkI3Jhc71g9l9q59EeUtgWMYYerkfp3ei
nFQgMm1Ph5BpPVUh14UyCdz0A/8N1RtlyVIg5SGzl0NudF7oungp0OtxQab5
hCC/ZuR99h5Tv8XIuf3ofWTI4Zv6HeHaGCnQ9Pbj/6k+t+RgYhbRG8/0E7bf
IocQlPjD3gvq+vENNnDkMPN8gtwSwTTAw/5Qans/87iNDZt/PTLVtxV5nEn3
I7EChl/GjgQMW7N+jlJw6y4epCMjf0UM9xlyJjUkxtP1MgVcXeOoH+2yBhp+
EpnW27gCjn/ptLU0xRoGmpmEJUqOqX9UyNQf7/F00iCzlbA89eP2qYnWQNt9
oxJinD07PrC2Zvv/MhVofLYldHdbwfkUJqE4ZPp9yUSm99OmgjwrpYtTvJjV
wwg4pv2wAcAyLqbTfNCC3V+PTNphsyIAgiyOKFfpLNjzKZFpPS0JgPXP84oW
pluw+z8IhFdN9kaPUwVAys88Ogjqru9fL4gVsvWfFQyDLwrS6v4Wsu9zDoFT
nU3H7JQTWH88C4GSpKo1Z0omwTLaINTQpC9oNnsiend+NUQmJ20JKhSz+u5S
w3bTnFUTdotZvWqRHahAauicclemNRZDfgBpWBoo3xZ1R3RbBEx3PhFcrIGR
Wy+GOtaK2O/nuAZyCvNPrbITg2E+MMwHhvnAMB8Y5gPDfGCYDwzzwf/ng/8A
2HH7Pw==
        "], {
         {GrayLevel[0.65], {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 131], {
            LineBox[{{0.743, 9.880899300780758}, {0.743, 
             1.2705931396171564`}}], 
            LineBox[{
             Offset[{1.5, 0}, {0.743, 9.880899300780758}], 
              Offset[{-1.5, 0}, {0.743, 9.880899300780758}]}], 
            LineBox[{
             Offset[{1.5, 0}, {0.743, 1.2705931396171564`}], 
              Offset[{-1.5, 0}, {0.743, 1.2705931396171564`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 132], {
            LineBox[{{1.302, 9.880899300780758}, {1.302, 
             1.2413019883167435`}}], 
            LineBox[{
             Offset[{1.5, 0}, {1.302, 9.880899300780758}], 
              Offset[{-1.5, 0}, {1.302, 9.880899300780758}]}], 
            LineBox[{
             Offset[{1.5, 0}, {1.302, 1.2413019883167435`}], 
              Offset[{-1.5, 0}, {1.302, 1.2413019883167435`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 133], {
            LineBox[{{1.331, 9.880899300780758}, {1.331, 
             1.2413019883167435`}}], 
            LineBox[{
             Offset[{1.5, 0}, {1.331, 9.880899300780758}], 
              Offset[{-1.5, 0}, {1.331, 9.880899300780758}]}], 
            LineBox[{
             Offset[{1.5, 0}, {1.331, 1.2413019883167435`}], 
              Offset[{-1.5, 0}, {1.331, 1.2413019883167435`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 134], {
            LineBox[{{3.665, 6.426750597338426}, {3.665, 
             1.2413019883167435`}}], 
            LineBox[{
             Offset[{1.5, 0}, {3.665, 6.426750597338426}], 
              Offset[{-1.5, 0}, {3.665, 6.426750597338426}]}], 
            LineBox[{
             Offset[{1.5, 0}, {3.665, 1.2413019883167435`}], 
              Offset[{-1.5, 0}, {3.665, 1.2413019883167435`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 135], {
            LineBox[{{4.182, 6.426750597338426}, {4.182, 
             1.2413019883167435`}}], 
            LineBox[{
             Offset[{1.5, 0}, {4.182, 6.426750597338426}], 
              Offset[{-1.5, 0}, {4.182, 6.426750597338426}]}], 
            LineBox[{
             Offset[{1.5, 0}, {4.182, 1.2413019883167435`}], 
              Offset[{-1.5, 0}, {4.182, 1.2413019883167435`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 136], {
            LineBox[{{4.347, 6.426750597338426}, {4.347, 
             1.2413019883167435`}}], 
            LineBox[{
             Offset[{1.5, 0}, {4.347, 6.426750597338426}], 
              Offset[{-1.5, 0}, {4.347, 6.426750597338426}]}], 
            LineBox[{
             Offset[{1.5, 0}, {4.347, 1.2413019883167435`}], 
              Offset[{-1.5, 0}, {4.347, 1.2413019883167435`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 137], {
            LineBox[{{4.444, 6.426750597338426}, {4.444, 
             1.2413019883167435`}}], 
            LineBox[{
             Offset[{1.5, 0}, {4.444, 6.426750597338426}], 
              Offset[{-1.5, 0}, {4.444, 6.426750597338426}]}], 
            LineBox[{
             Offset[{1.5, 0}, {4.444, 1.2413019883167435`}], 
              Offset[{-1.5, 0}, {4.444, 1.2413019883167435`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 138], {
            LineBox[{{4.808, 6.426750597338426}, {4.808, 
             1.2413019883167435`}}], 
            LineBox[{
             Offset[{1.5, 0}, {4.808, 6.426750597338426}], 
              Offset[{-1.5, 0}, {4.808, 6.426750597338426}]}], 
            LineBox[{
             Offset[{1.5, 0}, {4.808, 1.2413019883167435`}], 
              Offset[{-1.5, 0}, {4.808, 1.2413019883167435`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 139], {
            LineBox[{{7.249, 6.426750597338425}, {7.249, 
             1.0947203887883095`}}], 
            LineBox[{
             Offset[{1.5, 0}, {7.249, 6.426750597338425}], 
              Offset[{-1.5, 0}, {7.249, 6.426750597338425}]}], 
            LineBox[{
             Offset[{1.5, 0}, {7.249, 1.0947203887883095`}], 
              Offset[{-1.5, 0}, {7.249, 1.0947203887883095`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 140], {
            LineBox[{{8.975, 6.1465077448975745`}, {8.975, 
             1.0947203887883095`}}], 
            LineBox[{
             Offset[{1.5, 0}, {8.975, 6.1465077448975745`}], 
              Offset[{-1.5, 0}, {8.975, 6.1465077448975745`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {8.975, 1.0947203887883095`}], 
              Offset[{-1.5, 0}, {8.975, 1.0947203887883095`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 141], {
            LineBox[{{9.286, 6.1465077448975745`}, {9.286, 
             1.0947203887883095`}}], 
            LineBox[{
             Offset[{1.5, 0}, {9.286, 6.1465077448975745`}], 
              Offset[{-1.5, 0}, {9.286, 6.1465077448975745`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {9.286, 1.0947203887883095`}], 
              Offset[{-1.5, 0}, {9.286, 1.0947203887883095`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 142], {
            LineBox[{{10.852, 9.348788653909546}, {10.852, 
             1.0528331373431263`}}], 
            LineBox[{
             Offset[{1.5, 0}, {10.852, 9.348788653909546}], 
              Offset[{-1.5, 0}, {10.852, 9.348788653909546}]}], 
            LineBox[{
             Offset[{1.5, 0}, {10.852, 1.0528331373431263`}], 
              Offset[{-1.5, 0}, {10.852, 1.0528331373431263`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 143], {
            LineBox[{{11.558, 9.55711731363326}, {11.558, 
             1.0947203887883095`}}], 
            LineBox[{
             Offset[{1.5, 0}, {11.558, 9.55711731363326}], 
              Offset[{-1.5, 0}, {11.558, 9.55711731363326}]}], 
            LineBox[{
             Offset[{1.5, 0}, {11.558, 1.0947203887883095`}], 
              Offset[{-1.5, 0}, {11.558, 1.0947203887883095`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 144], {
            LineBox[{{13.715, 11.421825578908159`}, {13.715, 
             1.0947203887883095`}}], 
            LineBox[{
             Offset[{1.5, 0}, {13.715, 11.421825578908159`}], 
              Offset[{-1.5, 0}, {13.715, 11.421825578908159`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {13.715, 1.0947203887883095`}], 
              Offset[{-1.5, 0}, {13.715, 1.0947203887883095`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 145], {
            LineBox[{{13.947, 11.558660124896633`}, {13.947, 
             1.0947203887883095`}}], 
            LineBox[{
             Offset[{1.5, 0}, {13.947, 11.558660124896633`}], 
              Offset[{-1.5, 0}, {13.947, 11.558660124896633`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {13.947, 1.0947203887883095`}], 
              Offset[{-1.5, 0}, {13.947, 1.0947203887883095`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 146], {
            LineBox[{{15.079, 11.558660124896633`}, {15.079, 
             1.1759068869287206`}}], 
            LineBox[{
             Offset[{1.5, 0}, {15.079, 11.558660124896633`}], 
              Offset[{-1.5, 0}, {15.079, 11.558660124896633`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {15.079, 1.1759068869287206`}], 
              Offset[{-1.5, 0}, {15.079, 1.1759068869287206`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 147], {
            LineBox[{{16.963, 12.731143725881255`}, {16.963, 
             1.280423753160517}}], 
            LineBox[{
             Offset[{1.5, 0}, {16.963, 12.731143725881255`}], 
              Offset[{-1.5, 0}, {16.963, 12.731143725881255`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {16.963, 1.280423753160517}], 
              Offset[{-1.5, 0}, {16.963, 1.280423753160517}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 148], {
            LineBox[{{17.007, 12.731143725881255`}, {17.007, 
             1.280423753160517}}], 
            LineBox[{
             Offset[{1.5, 0}, {17.007, 12.731143725881255`}], 
              Offset[{-1.5, 0}, {17.007, 12.731143725881255`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {17.007, 1.280423753160517}], 
              Offset[{-1.5, 0}, {17.007, 1.280423753160517}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 149], {
            LineBox[{{17.575, 12.831237711501643`}, {17.575, 
             1.280423753160517}}], 
            LineBox[{
             Offset[{1.5, 0}, {17.575, 12.831237711501643`}], 
              Offset[{-1.5, 0}, {17.575, 12.831237711501643`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {17.575, 1.280423753160517}], 
              Offset[{-1.5, 0}, {17.575, 1.280423753160517}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 150], {
            LineBox[{{17.876, 12.831237711501643`}, {17.876, 
             2.182104774020174}}], 
            LineBox[{
             Offset[{1.5, 0}, {17.876, 12.831237711501643`}], 
              Offset[{-1.5, 0}, {17.876, 12.831237711501643`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {17.876, 2.182104774020174}], 
              Offset[{-1.5, 0}, {17.876, 2.182104774020174}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 151], {
            LineBox[{{17.947, 12.831237711501643`}, {17.947, 
             2.182104774020173}}], 
            LineBox[{
             Offset[{1.5, 0}, {17.947, 12.831237711501643`}], 
              Offset[{-1.5, 0}, {17.947, 12.831237711501643`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {17.947, 2.182104774020173}], 
              Offset[{-1.5, 0}, {17.947, 2.182104774020173}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 152], {
            LineBox[{{18.001, 12.831237711501643`}, {18.001, 
             2.182104774020173}}], 
            LineBox[{
             Offset[{1.5, 0}, {18.001, 12.831237711501643`}], 
              Offset[{-1.5, 0}, {18.001, 12.831237711501643`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {18.001, 2.182104774020173}], 
              Offset[{-1.5, 0}, {18.001, 2.182104774020173}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 153], {
            LineBox[{{18.031, 12.831237711501643`}, {18.031, 
             2.182104774020174}}], 
            LineBox[{
             Offset[{1.5, 0}, {18.031, 12.831237711501643`}], 
              Offset[{-1.5, 0}, {18.031, 12.831237711501643`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {18.031, 2.182104774020174}], 
              Offset[{-1.5, 0}, {18.031, 2.182104774020174}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 154], {
            LineBox[{{18.145, 13.49337739468438}, {18.145, 
             2.182104774020174}}], 
            LineBox[{
             Offset[{1.5, 0}, {18.145, 13.49337739468438}], 
              Offset[{-1.5, 0}, {18.145, 13.49337739468438}]}], 
            LineBox[{
             Offset[{1.5, 0}, {18.145, 2.182104774020174}], 
              Offset[{-1.5, 0}, {18.145, 2.182104774020174}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 155], {
            LineBox[{{18.256, 13.49337739468438}, {18.256, 
             2.182104774020174}}], 
            LineBox[{
             Offset[{1.5, 0}, {18.256, 13.49337739468438}], 
              Offset[{-1.5, 0}, {18.256, 13.49337739468438}]}], 
            LineBox[{
             Offset[{1.5, 0}, {18.256, 2.182104774020174}], 
              Offset[{-1.5, 0}, {18.256, 2.182104774020174}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 156], {
            LineBox[{{18.328, 13.49337739468438}, {18.328, 
             2.182104774020173}}], 
            LineBox[{
             Offset[{1.5, 0}, {18.328, 13.49337739468438}], 
              Offset[{-1.5, 0}, {18.328, 13.49337739468438}]}], 
            LineBox[{
             Offset[{1.5, 0}, {18.328, 2.182104774020173}], 
              Offset[{-1.5, 0}, {18.328, 2.182104774020173}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 157], {
            LineBox[{{18.494, 13.49337739468438}, {18.494, 
             2.182104774020174}}], 
            LineBox[{
             Offset[{1.5, 0}, {18.494, 13.49337739468438}], 
              Offset[{-1.5, 0}, {18.494, 13.49337739468438}]}], 
            LineBox[{
             Offset[{1.5, 0}, {18.494, 2.182104774020174}], 
              Offset[{-1.5, 0}, {18.494, 2.182104774020174}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 158], {
            LineBox[{{18.509, 13.49337739468438}, {18.509, 
             2.182104774020174}}], 
            LineBox[{
             Offset[{1.5, 0}, {18.509, 13.49337739468438}], 
              Offset[{-1.5, 0}, {18.509, 13.49337739468438}]}], 
            LineBox[{
             Offset[{1.5, 0}, {18.509, 2.182104774020174}], 
              Offset[{-1.5, 0}, {18.509, 2.182104774020174}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 159], {
            LineBox[{{18.59, 13.49337739468438}, {18.59, 
             2.1439556734903116`}}], 
            LineBox[{
             Offset[{1.5, 0}, {18.59, 13.49337739468438}], 
              Offset[{-1.5, 0}, {18.59, 13.49337739468438}]}], 
            LineBox[{
             Offset[{1.5, 0}, {18.59, 2.1439556734903116`}], 
              Offset[{-1.5, 0}, {18.59, 2.1439556734903116`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 160], {
            LineBox[{{18.702, 13.49337739468438}, {18.702, 
             2.1439556734903116`}}], 
            LineBox[{
             Offset[{1.5, 0}, {18.702, 13.49337739468438}], 
              Offset[{-1.5, 0}, {18.702, 13.49337739468438}]}], 
            LineBox[{
             Offset[{1.5, 0}, {18.702, 2.1439556734903116`}], 
              Offset[{-1.5, 0}, {18.702, 2.1439556734903116`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 161], {
            LineBox[{{18.91, 13.49337739468438}, {18.91, 
             2.1439556734903116`}}], 
            LineBox[{
             Offset[{1.5, 0}, {18.91, 13.49337739468438}], 
              Offset[{-1.5, 0}, {18.91, 13.49337739468438}]}], 
            LineBox[{
             Offset[{1.5, 0}, {18.91, 2.1439556734903116`}], 
              Offset[{-1.5, 0}, {18.91, 2.1439556734903116`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 162], {
            LineBox[{{18.99, 13.49337739468438}, {18.99, 
             2.1439556734903116`}}], 
            LineBox[{
             Offset[{1.5, 0}, {18.99, 13.49337739468438}], 
              Offset[{-1.5, 0}, {18.99, 13.49337739468438}]}], 
            LineBox[{
             Offset[{1.5, 0}, {18.99, 2.1439556734903116`}], 
              Offset[{-1.5, 0}, {18.99, 2.1439556734903116`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 163], {
            LineBox[{{19.109, 13.49337739468438}, {19.109, 
             2.1439556734903107`}}], 
            LineBox[{
             Offset[{1.5, 0}, {19.109, 13.49337739468438}], 
              Offset[{-1.5, 0}, {19.109, 13.49337739468438}]}], 
            LineBox[{
             Offset[{1.5, 0}, {19.109, 2.1439556734903107`}], 
              Offset[{-1.5, 0}, {19.109, 2.1439556734903107`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 164], {
            LineBox[{{19.199, 13.49337739468438}, {19.199, 
             2.1439556734903107`}}], 
            LineBox[{
             Offset[{1.5, 0}, {19.199, 13.49337739468438}], 
              Offset[{-1.5, 0}, {19.199, 13.49337739468438}]}], 
            LineBox[{
             Offset[{1.5, 0}, {19.199, 2.1439556734903107`}], 
              Offset[{-1.5, 0}, {19.199, 2.1439556734903107`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 165], {
            LineBox[{{19.262, 13.49337739468438}, {19.262, 
             2.1439556734903107`}}], 
            LineBox[{
             Offset[{1.5, 0}, {19.262, 13.49337739468438}], 
              Offset[{-1.5, 0}, {19.262, 13.49337739468438}]}], 
            LineBox[{
             Offset[{1.5, 0}, {19.262, 2.1439556734903107`}], 
              Offset[{-1.5, 0}, {19.262, 2.1439556734903107`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 166], {
            LineBox[{{19.295, 13.49337739468438}, {19.295, 
             2.1439556734903107`}}], 
            LineBox[{
             Offset[{1.5, 0}, {19.295, 13.49337739468438}], 
              Offset[{-1.5, 0}, {19.295, 13.49337739468438}]}], 
            LineBox[{
             Offset[{1.5, 0}, {19.295, 2.1439556734903107`}], 
              Offset[{-1.5, 0}, {19.295, 2.1439556734903107`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 167], {
            LineBox[{{19.3, 13.49337739468438}, {19.3, 2.1439556734903107`}}],
             LineBox[{
             Offset[{1.5, 0}, {19.3, 13.49337739468438}], 
              Offset[{-1.5, 0}, {19.3, 13.49337739468438}]}], 
            LineBox[{
             Offset[{1.5, 0}, {19.3, 2.1439556734903107`}], 
              Offset[{-1.5, 0}, {19.3, 2.1439556734903107`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 168], {
            LineBox[{{19.313, 13.49337739468438}, {19.313, 
             2.1439556734903107`}}], 
            LineBox[{
             Offset[{1.5, 0}, {19.313, 13.49337739468438}], 
              Offset[{-1.5, 0}, {19.313, 13.49337739468438}]}], 
            LineBox[{
             Offset[{1.5, 0}, {19.313, 2.1439556734903107`}], 
              Offset[{-1.5, 0}, {19.313, 2.1439556734903107`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 169], {
            LineBox[{{19.382, 13.49337739468438}, {19.382, 
             2.1439556734903107`}}], 
            LineBox[{
             Offset[{1.5, 0}, {19.382, 13.49337739468438}], 
              Offset[{-1.5, 0}, {19.382, 13.49337739468438}]}], 
            LineBox[{
             Offset[{1.5, 0}, {19.382, 2.1439556734903107`}], 
              Offset[{-1.5, 0}, {19.382, 2.1439556734903107`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 170], {
            LineBox[{{19.459, 13.49337739468438}, {19.459, 
             2.1439556734903107`}}], 
            LineBox[{
             Offset[{1.5, 0}, {19.459, 13.49337739468438}], 
              Offset[{-1.5, 0}, {19.459, 13.49337739468438}]}], 
            LineBox[{
             Offset[{1.5, 0}, {19.459, 2.1439556734903107`}], 
              Offset[{-1.5, 0}, {19.459, 2.1439556734903107`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 171], {
            LineBox[{{19.755, 13.49337739468438}, {19.755, 
             2.1439556734903107`}}], 
            LineBox[{
             Offset[{1.5, 0}, {19.755, 13.49337739468438}], 
              Offset[{-1.5, 0}, {19.755, 13.49337739468438}]}], 
            LineBox[{
             Offset[{1.5, 0}, {19.755, 2.1439556734903107`}], 
              Offset[{-1.5, 0}, {19.755, 2.1439556734903107`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 172], {
            LineBox[{{19.868, 13.49337739468438}, {19.868, 
             2.1439556734903107`}}], 
            LineBox[{
             Offset[{1.5, 0}, {19.868, 13.49337739468438}], 
              Offset[{-1.5, 0}, {19.868, 13.49337739468438}]}], 
            LineBox[{
             Offset[{1.5, 0}, {19.868, 2.1439556734903107`}], 
              Offset[{-1.5, 0}, {19.868, 2.1439556734903107`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 173], {
            LineBox[{{20.236, 13.49337739468438}, {20.236, 
             2.1439556734903107`}}], 
            LineBox[{
             Offset[{1.5, 0}, {20.236, 13.49337739468438}], 
              Offset[{-1.5, 0}, {20.236, 13.49337739468438}]}], 
            LineBox[{
             Offset[{1.5, 0}, {20.236, 2.1439556734903107`}], 
              Offset[{-1.5, 0}, {20.236, 2.1439556734903107`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 174], {
            LineBox[{{20.53, 13.49337739468438}, {20.53, 
             2.1439556734903107`}}], 
            LineBox[{
             Offset[{1.5, 0}, {20.53, 13.49337739468438}], 
              Offset[{-1.5, 0}, {20.53, 13.49337739468438}]}], 
            LineBox[{
             Offset[{1.5, 0}, {20.53, 2.1439556734903107`}], 
              Offset[{-1.5, 0}, {20.53, 2.1439556734903107`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 175], {
            LineBox[{{20.811, 13.49337739468438}, {20.811, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {20.811, 13.49337739468438}], 
              Offset[{-1.5, 0}, {20.811, 13.49337739468438}]}], 
            LineBox[{
             Offset[{1.5, 0}, {20.811, 2.131498096857408}], 
              Offset[{-1.5, 0}, {20.811, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 176], {
            LineBox[{{21.093, 13.49337739468438}, {21.093, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {21.093, 13.49337739468438}], 
              Offset[{-1.5, 0}, {21.093, 13.49337739468438}]}], 
            LineBox[{
             Offset[{1.5, 0}, {21.093, 2.131498096857408}], 
              Offset[{-1.5, 0}, {21.093, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 177], {
            LineBox[{{21.369, 15.803387118844666`}, {21.369, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {21.369, 15.803387118844666`}], 
              Offset[{-1.5, 0}, {21.369, 15.803387118844666`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {21.369, 2.131498096857408}], 
              Offset[{-1.5, 0}, {21.369, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 178], {
            LineBox[{{21.681, 15.803387118844666`}, {21.681, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {21.681, 15.803387118844666`}], 
              Offset[{-1.5, 0}, {21.681, 15.803387118844666`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {21.681, 2.131498096857408}], 
              Offset[{-1.5, 0}, {21.681, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 179], {
            LineBox[{{22.015, 15.803387118844666`}, {22.015, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {22.015, 15.803387118844666`}], 
              Offset[{-1.5, 0}, {22.015, 15.803387118844666`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {22.015, 2.131498096857408}], 
              Offset[{-1.5, 0}, {22.015, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 180], {
            LineBox[{{22.042, 15.803387118844666`}, {22.042, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {22.042, 15.803387118844666`}], 
              Offset[{-1.5, 0}, {22.042, 15.803387118844666`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {22.042, 2.131498096857408}], 
              Offset[{-1.5, 0}, {22.042, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 181], {
            LineBox[{{22.069, 15.803387118844666`}, {22.069, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {22.069, 15.803387118844666`}], 
              Offset[{-1.5, 0}, {22.069, 15.803387118844666`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {22.069, 2.131498096857408}], 
              Offset[{-1.5, 0}, {22.069, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 182], {
            LineBox[{{22.075, 15.803387118844666`}, {22.075, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {22.075, 15.803387118844666`}], 
              Offset[{-1.5, 0}, {22.075, 15.803387118844666`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {22.075, 2.131498096857408}], 
              Offset[{-1.5, 0}, {22.075, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 183], {
            LineBox[{{22.106, 15.803387118844666`}, {22.106, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {22.106, 15.803387118844666`}], 
              Offset[{-1.5, 0}, {22.106, 15.803387118844666`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {22.106, 2.131498096857408}], 
              Offset[{-1.5, 0}, {22.106, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 184], {
            LineBox[{{22.298, 15.803387118844668`}, {22.298, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {22.298, 15.803387118844668`}], 
              Offset[{-1.5, 0}, {22.298, 15.803387118844668`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {22.298, 2.131498096857408}], 
              Offset[{-1.5, 0}, {22.298, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 185], {
            LineBox[{{22.394, 15.803387118844668`}, {22.394, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {22.394, 15.803387118844668`}], 
              Offset[{-1.5, 0}, {22.394, 15.803387118844668`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {22.394, 2.131498096857408}], 
              Offset[{-1.5, 0}, {22.394, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 186], {
            LineBox[{{22.424, 15.803387118844668`}, {22.424, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {22.424, 15.803387118844668`}], 
              Offset[{-1.5, 0}, {22.424, 15.803387118844668`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {22.424, 2.131498096857408}], 
              Offset[{-1.5, 0}, {22.424, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 187], {
            LineBox[{{22.438, 15.803387118844668`}, {22.438, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {22.438, 15.803387118844668`}], 
              Offset[{-1.5, 0}, {22.438, 15.803387118844668`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {22.438, 2.131498096857408}], 
              Offset[{-1.5, 0}, {22.438, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 188], {
            LineBox[{{22.58, 15.803387118844668`}, {22.58, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {22.58, 15.803387118844668`}], 
              Offset[{-1.5, 0}, {22.58, 15.803387118844668`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {22.58, 2.131498096857408}], 
              Offset[{-1.5, 0}, {22.58, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 189], {
            LineBox[{{22.583, 15.803387118844668`}, {22.583, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {22.583, 15.803387118844668`}], 
              Offset[{-1.5, 0}, {22.583, 15.803387118844668`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {22.583, 2.131498096857408}], 
              Offset[{-1.5, 0}, {22.583, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 190], {
            LineBox[{{22.826, 15.803387118844668`}, {22.826, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {22.826, 15.803387118844668`}], 
              Offset[{-1.5, 0}, {22.826, 15.803387118844668`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {22.826, 2.131498096857408}], 
              Offset[{-1.5, 0}, {22.826, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 191], {
            LineBox[{{22.853, 15.803387118844668`}, {22.853, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {22.853, 15.803387118844668`}], 
              Offset[{-1.5, 0}, {22.853, 15.803387118844668`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {22.853, 2.131498096857408}], 
              Offset[{-1.5, 0}, {22.853, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 192], {
            LineBox[{{23.162, 15.560009649225263`}, {23.162, 
             2.0557998473197294`}}], 
            LineBox[{
             Offset[{1.5, 0}, {23.162, 15.560009649225263`}], 
              Offset[{-1.5, 0}, {23.162, 15.560009649225263`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {23.162, 2.0557998473197294`}], 
              Offset[{-1.5, 0}, {23.162, 2.0557998473197294`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 193], {
            LineBox[{{23.173, 15.560009649225263`}, {23.173, 
             2.0557998473197294`}}], 
            LineBox[{
             Offset[{1.5, 0}, {23.173, 15.560009649225263`}], 
              Offset[{-1.5, 0}, {23.173, 15.560009649225263`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {23.173, 2.0557998473197294`}], 
              Offset[{-1.5, 0}, {23.173, 2.0557998473197294`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 194], {
            LineBox[{{23.435, 15.73547338959265}, {23.435, 
             2.0557998473197294`}}], 
            LineBox[{
             Offset[{1.5, 0}, {23.435, 15.73547338959265}], 
              Offset[{-1.5, 0}, {23.435, 15.73547338959265}]}], 
            LineBox[{
             Offset[{1.5, 0}, {23.435, 2.0557998473197294`}], 
              Offset[{-1.5, 0}, {23.435, 2.0557998473197294`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 195], {
            LineBox[{{24.089, 15.73547338959265}, {24.089, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {24.089, 15.73547338959265}], 
              Offset[{-1.5, 0}, {24.089, 15.73547338959265}]}], 
            LineBox[{
             Offset[{1.5, 0}, {24.089, 2.131498096857408}], 
              Offset[{-1.5, 0}, {24.089, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 196], {
            LineBox[{{24.401, 15.735473389592649`}, {24.401, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {24.401, 15.735473389592649`}], 
              Offset[{-1.5, 0}, {24.401, 15.735473389592649`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {24.401, 2.131498096857408}], 
              Offset[{-1.5, 0}, {24.401, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 197], {
            LineBox[{{24.656, 15.735473389592649`}, {24.656, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {24.656, 15.735473389592649`}], 
              Offset[{-1.5, 0}, {24.656, 15.735473389592649`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {24.656, 2.131498096857408}], 
              Offset[{-1.5, 0}, {24.656, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 198], {
            LineBox[{{24.997, 15.73547338959265}, {24.997, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {24.997, 15.73547338959265}], 
              Offset[{-1.5, 0}, {24.997, 15.73547338959265}]}], 
            LineBox[{
             Offset[{1.5, 0}, {24.997, 2.131498096857408}], 
              Offset[{-1.5, 0}, {24.997, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 199], {
            LineBox[{{25.417, 15.73547338959265}, {25.417, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {25.417, 15.73547338959265}], 
              Offset[{-1.5, 0}, {25.417, 15.73547338959265}]}], 
            LineBox[{
             Offset[{1.5, 0}, {25.417, 2.131498096857408}], 
              Offset[{-1.5, 0}, {25.417, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 200], {
            LineBox[{{25.539, 15.73547338959265}, {25.539, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {25.539, 15.73547338959265}], 
              Offset[{-1.5, 0}, {25.539, 15.73547338959265}]}], 
            LineBox[{
             Offset[{1.5, 0}, {25.539, 2.131498096857408}], 
              Offset[{-1.5, 0}, {25.539, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 201], {
            LineBox[{{25.624, 15.73547338959265}, {25.624, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {25.624, 15.73547338959265}], 
              Offset[{-1.5, 0}, {25.624, 15.73547338959265}]}], 
            LineBox[{
             Offset[{1.5, 0}, {25.624, 2.131498096857408}], 
              Offset[{-1.5, 0}, {25.624, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 202], {
            LineBox[{{25.713, 15.73547338959265}, {25.713, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {25.713, 15.73547338959265}], 
              Offset[{-1.5, 0}, {25.713, 15.73547338959265}]}], 
            LineBox[{
             Offset[{1.5, 0}, {25.713, 2.131498096857408}], 
              Offset[{-1.5, 0}, {25.713, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 203], {
            LineBox[{{25.733, 15.73547338959265}, {25.733, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {25.733, 15.73547338959265}], 
              Offset[{-1.5, 0}, {25.733, 15.73547338959265}]}], 
            LineBox[{
             Offset[{1.5, 0}, {25.733, 2.131498096857408}], 
              Offset[{-1.5, 0}, {25.733, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 204], {
            LineBox[{{25.776, 15.73547338959265}, {25.776, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {25.776, 15.73547338959265}], 
              Offset[{-1.5, 0}, {25.776, 15.73547338959265}]}], 
            LineBox[{
             Offset[{1.5, 0}, {25.776, 2.131498096857408}], 
              Offset[{-1.5, 0}, {25.776, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 205], {
            LineBox[{{26.183, 15.73547338959265}, {26.183, 
             2.131498096857408}}], 
            LineBox[{
             Offset[{1.5, 0}, {26.183, 15.73547338959265}], 
              Offset[{-1.5, 0}, {26.183, 15.73547338959265}]}], 
            LineBox[{
             Offset[{1.5, 0}, {26.183, 2.131498096857408}], 
              Offset[{-1.5, 0}, {26.183, 2.131498096857408}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 206], {
            LineBox[{{26.335, 15.803387118844666`}, {26.335, 
             2.143955673490311}}], 
            LineBox[{
             Offset[{1.5, 0}, {26.335, 15.803387118844666`}], 
              Offset[{-1.5, 0}, {26.335, 15.803387118844666`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {26.335, 2.143955673490311}], 
              Offset[{-1.5, 0}, {26.335, 2.143955673490311}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 207], {
            LineBox[{{26.592, 15.803387118844666`}, {26.592, 
             2.143955673490311}}], 
            LineBox[{
             Offset[{1.5, 0}, {26.592, 15.803387118844666`}], 
              Offset[{-1.5, 0}, {26.592, 15.803387118844666`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {26.592, 2.143955673490311}], 
              Offset[{-1.5, 0}, {26.592, 2.143955673490311}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 208], {
            LineBox[{{26.595, 15.803387118844666`}, {26.595, 
             2.143955673490311}}], 
            LineBox[{
             Offset[{1.5, 0}, {26.595, 15.803387118844666`}], 
              Offset[{-1.5, 0}, {26.595, 15.803387118844666`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {26.595, 2.143955673490311}], 
              Offset[{-1.5, 0}, {26.595, 2.143955673490311}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 209], {
            LineBox[{{26.703, 15.803387118844666`}, {26.703, 
             2.143955673490311}}], 
            LineBox[{
             Offset[{1.5, 0}, {26.703, 15.803387118844666`}], 
              Offset[{-1.5, 0}, {26.703, 15.803387118844666`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {26.703, 2.143955673490311}], 
              Offset[{-1.5, 0}, {26.703, 2.143955673490311}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 210], {
            LineBox[{{26.778, 15.803387118844666`}, {26.778, 
             2.1439556734903107`}}], 
            LineBox[{
             Offset[{1.5, 0}, {26.778, 15.803387118844666`}], 
              Offset[{-1.5, 0}, {26.778, 15.803387118844666`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {26.778, 2.1439556734903107`}], 
              Offset[{-1.5, 0}, {26.778, 2.1439556734903107`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 211], {
            LineBox[{{27.11, 16.039867058033586`}, {27.11, 
             2.3386400580802933`}}], 
            LineBox[{
             Offset[{1.5, 0}, {27.11, 16.039867058033586`}], 
              Offset[{-1.5, 0}, {27.11, 16.039867058033586`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {27.11, 2.3386400580802933`}], 
              Offset[{-1.5, 0}, {27.11, 2.3386400580802933`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 212], {
            LineBox[{{27.154, 16.039867058033586`}, {27.154, 
             2.3386400580802933`}}], 
            LineBox[{
             Offset[{1.5, 0}, {27.154, 16.039867058033586`}], 
              Offset[{-1.5, 0}, {27.154, 16.039867058033586`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {27.154, 2.3386400580802933`}], 
              Offset[{-1.5, 0}, {27.154, 2.3386400580802933`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 213], {
            LineBox[{{27.276, 16.039867058033586`}, {27.276, 
             2.4972493252177714`}}], 
            LineBox[{
             Offset[{1.5, 0}, {27.276, 16.039867058033586`}], 
              Offset[{-1.5, 0}, {27.276, 16.039867058033586`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {27.276, 2.4972493252177714`}], 
              Offset[{-1.5, 0}, {27.276, 2.4972493252177714`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 214], {
            LineBox[{{27.277, 16.039867058033586`}, {27.277, 
             2.4972493252177714`}}], 
            LineBox[{
             Offset[{1.5, 0}, {27.277, 16.039867058033586`}], 
              Offset[{-1.5, 0}, {27.277, 16.039867058033586`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {27.277, 2.4972493252177714`}], 
              Offset[{-1.5, 0}, {27.277, 2.4972493252177714`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 215], {
            LineBox[{{27.343, 16.039867058033586`}, {27.343, 
             2.4972493252177714`}}], 
            LineBox[{
             Offset[{1.5, 0}, {27.343, 16.039867058033586`}], 
              Offset[{-1.5, 0}, {27.343, 16.039867058033586`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {27.343, 2.4972493252177714`}], 
              Offset[{-1.5, 0}, {27.343, 2.4972493252177714`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 216], {
            LineBox[{{27.478, 16.039867058033586`}, {27.478, 
             2.4972493252177714`}}], 
            LineBox[{
             Offset[{1.5, 0}, {27.478, 16.039867058033586`}], 
              Offset[{-1.5, 0}, {27.478, 16.039867058033586`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {27.478, 2.4972493252177714`}], 
              Offset[{-1.5, 0}, {27.478, 2.4972493252177714`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 217], {
            LineBox[{{27.557, 16.039867058033586`}, {27.557, 
             2.4972493252177714`}}], 
            LineBox[{
             Offset[{1.5, 0}, {27.557, 16.039867058033586`}], 
              Offset[{-1.5, 0}, {27.557, 16.039867058033586`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {27.557, 2.4972493252177714`}], 
              Offset[{-1.5, 0}, {27.557, 2.4972493252177714`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 218], {
            LineBox[{{27.789, 14.867088338069141`}, {27.789, 
             2.698683656174475}}], 
            LineBox[{
             Offset[{1.5, 0}, {27.789, 14.867088338069141`}], 
              Offset[{-1.5, 0}, {27.789, 14.867088338069141`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {27.789, 2.698683656174475}], 
              Offset[{-1.5, 0}, {27.789, 2.698683656174475}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 219], {
            LineBox[{{27.832, 14.867088338069141`}, {27.832, 
             2.698683656174475}}], 
            LineBox[{
             Offset[{1.5, 0}, {27.832, 14.867088338069141`}], 
              Offset[{-1.5, 0}, {27.832, 14.867088338069141`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {27.832, 2.698683656174475}], 
              Offset[{-1.5, 0}, {27.832, 2.698683656174475}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 220], {
            LineBox[{{28.097, 13.91451339484205}, {28.097, 
             2.698683656174475}}], 
            LineBox[{
             Offset[{1.5, 0}, {28.097, 13.91451339484205}], 
              Offset[{-1.5, 0}, {28.097, 13.91451339484205}]}], 
            LineBox[{
             Offset[{1.5, 0}, {28.097, 2.698683656174475}], 
              Offset[{-1.5, 0}, {28.097, 2.698683656174475}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 221], {
            LineBox[{{28.35, 12.326095762132013`}, {28.35, 
             2.698683656174475}}], 
            LineBox[{
             Offset[{1.5, 0}, {28.35, 12.326095762132013`}], 
              Offset[{-1.5, 0}, {28.35, 12.326095762132013`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {28.35, 2.698683656174475}], 
              Offset[{-1.5, 0}, {28.35, 2.698683656174475}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 222], {
            LineBox[{{28.599, 12.326095762132013`}, {28.599, 
             2.698683656174475}}], 
            LineBox[{
             Offset[{1.5, 0}, {28.599, 12.326095762132013`}], 
              Offset[{-1.5, 0}, {28.599, 12.326095762132013`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {28.599, 2.698683656174475}], 
              Offset[{-1.5, 0}, {28.599, 2.698683656174475}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 223], {
            LineBox[{{28.735, 12.326095762132013`}, {28.735, 
             2.698683656174475}}], 
            LineBox[{
             Offset[{1.5, 0}, {28.735, 12.326095762132013`}], 
              Offset[{-1.5, 0}, {28.735, 12.326095762132013`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {28.735, 2.698683656174475}], 
              Offset[{-1.5, 0}, {28.735, 2.698683656174475}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 224], {
            LineBox[{{28.838, 12.321746398834286`}, {28.838, 
             2.698683656174475}}], 
            LineBox[{
             Offset[{1.5, 0}, {28.838, 12.321746398834286`}], 
              Offset[{-1.5, 0}, {28.838, 12.321746398834286`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {28.838, 2.698683656174475}], 
              Offset[{-1.5, 0}, {28.838, 2.698683656174475}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 225], {
            LineBox[{{29.067, 12.321746398834286`}, {29.067, 
             2.698683656174475}}], 
            LineBox[{
             Offset[{1.5, 0}, {29.067, 12.321746398834286`}], 
              Offset[{-1.5, 0}, {29.067, 12.321746398834286`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {29.067, 2.698683656174475}], 
              Offset[{-1.5, 0}, {29.067, 2.698683656174475}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 226], {
            LineBox[{{29.319, 12.473955941640604`}, {29.319, 
             2.698683656174475}}], 
            LineBox[{
             Offset[{1.5, 0}, {29.319, 12.473955941640604`}], 
              Offset[{-1.5, 0}, {29.319, 12.473955941640604`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {29.319, 2.698683656174475}], 
              Offset[{-1.5, 0}, {29.319, 2.698683656174475}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 227], {
            LineBox[{{29.352, 12.473955941640604`}, {29.352, 
             2.698683656174475}}], 
            LineBox[{
             Offset[{1.5, 0}, {29.352, 12.473955941640604`}], 
              Offset[{-1.5, 0}, {29.352, 12.473955941640604`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {29.352, 2.698683656174475}], 
              Offset[{-1.5, 0}, {29.352, 2.698683656174475}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 228], {
            LineBox[{{29.373, 12.473955941640604`}, {29.373, 
             2.698683656174475}}], 
            LineBox[{
             Offset[{1.5, 0}, {29.373, 12.473955941640604`}], 
              Offset[{-1.5, 0}, {29.373, 12.473955941640604`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {29.373, 2.698683656174475}], 
              Offset[{-1.5, 0}, {29.373, 2.698683656174475}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 229], {
            LineBox[{{29.48, 12.473955941640604`}, {29.48, 
             2.698683656174475}}], 
            LineBox[{
             Offset[{1.5, 0}, {29.48, 12.473955941640604`}], 
              Offset[{-1.5, 0}, {29.48, 12.473955941640604`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {29.48, 2.698683656174475}], 
              Offset[{-1.5, 0}, {29.48, 2.698683656174475}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 230], {
            LineBox[{{29.623, 12.473955941640604`}, {29.623, 
             2.698683656174475}}], 
            LineBox[{
             Offset[{1.5, 0}, {29.623, 12.473955941640604`}], 
              Offset[{-1.5, 0}, {29.623, 12.473955941640604`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {29.623, 2.698683656174475}], 
              Offset[{-1.5, 0}, {29.623, 2.698683656174475}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 231], {
            LineBox[{{29.642, 12.473955941640604`}, {29.642, 
             2.698683656174475}}], 
            LineBox[{
             Offset[{1.5, 0}, {29.642, 12.473955941640604`}], 
              Offset[{-1.5, 0}, {29.642, 12.473955941640604`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {29.642, 2.698683656174475}], 
              Offset[{-1.5, 0}, {29.642, 2.698683656174475}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 232], {
            LineBox[{{29.994, 12.473955941640604`}, {29.994, 
             2.698683656174475}}], 
            LineBox[{
             Offset[{1.5, 0}, {29.994, 12.473955941640604`}], 
              Offset[{-1.5, 0}, {29.994, 12.473955941640604`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {29.994, 2.698683656174475}], 
              Offset[{-1.5, 0}, {29.994, 2.698683656174475}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 233], {
            LineBox[{{30.094, 12.321746398834286`}, {30.094, 
             2.698683656174475}}], 
            LineBox[{
             Offset[{1.5, 0}, {30.094, 12.321746398834286`}], 
              Offset[{-1.5, 0}, {30.094, 12.321746398834286`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {30.094, 2.698683656174475}], 
              Offset[{-1.5, 0}, {30.094, 2.698683656174475}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 234], {
            LineBox[{{30.247, 12.321746398834286`}, {30.247, 
             2.698683656174475}}], 
            LineBox[{
             Offset[{1.5, 0}, {30.247, 12.321746398834286`}], 
              Offset[{-1.5, 0}, {30.247, 12.321746398834286`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {30.247, 2.698683656174475}], 
              Offset[{-1.5, 0}, {30.247, 2.698683656174475}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 235], {
            LineBox[{{30.249, 12.321746398834286`}, {30.249, 
             2.698683656174475}}], 
            LineBox[{
             Offset[{1.5, 0}, {30.249, 12.321746398834286`}], 
              Offset[{-1.5, 0}, {30.249, 12.321746398834286`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {30.249, 2.698683656174475}], 
              Offset[{-1.5, 0}, {30.249, 2.698683656174475}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 236], {
            LineBox[{{30.495, 12.321746398834286`}, {30.495, 
             2.698683656174475}}], 
            LineBox[{
             Offset[{1.5, 0}, {30.495, 12.321746398834286`}], 
              Offset[{-1.5, 0}, {30.495, 12.321746398834286`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {30.495, 2.698683656174475}], 
              Offset[{-1.5, 0}, {30.495, 2.698683656174475}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 237], {
            LineBox[{{30.784, 12.321746398834286`}, {30.784, 
             2.698683656174475}}], 
            LineBox[{
             Offset[{1.5, 0}, {30.784, 12.321746398834286`}], 
              Offset[{-1.5, 0}, {30.784, 12.321746398834286`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {30.784, 2.698683656174475}], 
              Offset[{-1.5, 0}, {30.784, 2.698683656174475}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 238], {
            LineBox[{{31.329, 12.321746398834286`}, {31.329, 
             2.6588406238259745`}}], 
            LineBox[{
             Offset[{1.5, 0}, {31.329, 12.321746398834286`}], 
              Offset[{-1.5, 0}, {31.329, 12.321746398834286`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {31.329, 2.6588406238259745`}], 
              Offset[{-1.5, 0}, {31.329, 2.6588406238259745`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 239], {
            LineBox[{{31.363, 12.321746398834286`}, {31.363, 
             2.6588406238259745`}}], 
            LineBox[{
             Offset[{1.5, 0}, {31.363, 12.321746398834286`}], 
              Offset[{-1.5, 0}, {31.363, 12.321746398834286`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {31.363, 2.6588406238259745`}], 
              Offset[{-1.5, 0}, {31.363, 2.6588406238259745`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 240], {
            LineBox[{{31.482, 12.321746398834286`}, {31.482, 
             1.6016961044634535`}}], 
            LineBox[{
             Offset[{1.5, 0}, {31.482, 12.321746398834286`}], 
              Offset[{-1.5, 0}, {31.482, 12.321746398834286`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {31.482, 1.6016961044634535`}], 
              Offset[{-1.5, 0}, {31.482, 1.6016961044634535`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 241], {
            LineBox[{{31.843, 11.605250004565127`}, {31.843, 
             1.3732778136327446`}}], 
            LineBox[{
             Offset[{1.5, 0}, {31.843, 11.605250004565127`}], 
              Offset[{-1.5, 0}, {31.843, 11.605250004565127`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {31.843, 1.3732778136327446`}], 
              Offset[{-1.5, 0}, {31.843, 1.3732778136327446`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 242], {
            LineBox[{{32.009, 11.479389690623226`}, {32.009, 
             1.3732778136327446`}}], 
            LineBox[{
             Offset[{1.5, 0}, {32.009, 11.479389690623226`}], 
              Offset[{-1.5, 0}, {32.009, 11.479389690623226`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {32.009, 1.3732778136327446`}], 
              Offset[{-1.5, 0}, {32.009, 1.3732778136327446`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 243], {
            LineBox[{{33.48, 8.890651729926178}, {33.48, 
             1.1034861520768264`}}], 
            LineBox[{
             Offset[{1.5, 0}, {33.48, 8.890651729926178}], 
              Offset[{-1.5, 0}, {33.48, 8.890651729926178}]}], 
            LineBox[{
             Offset[{1.5, 0}, {33.48, 1.1034861520768264`}], 
              Offset[{-1.5, 0}, {33.48, 1.1034861520768264`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 244], {
            LineBox[{{33.533, 8.890651729926178}, {33.533, 
             1.1034861520768264`}}], 
            LineBox[{
             Offset[{1.5, 0}, {33.533, 8.890651729926178}], 
              Offset[{-1.5, 0}, {33.533, 8.890651729926178}]}], 
            LineBox[{
             Offset[{1.5, 0}, {33.533, 1.1034861520768264`}], 
              Offset[{-1.5, 0}, {33.533, 1.1034861520768264`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 245], {
            LineBox[{{34.483, 8.890651729926178}, {34.483, 
             1.0754855450416807`}}], 
            LineBox[{
             Offset[{1.5, 0}, {34.483, 8.890651729926178}], 
              Offset[{-1.5, 0}, {34.483, 8.890651729926178}]}], 
            LineBox[{
             Offset[{1.5, 0}, {34.483, 1.0754855450416807`}], 
              Offset[{-1.5, 0}, {34.483, 1.0754855450416807`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 246], {
            LineBox[{{34.488, 8.890651729926178}, {34.488, 
             1.0754855450416807`}}], 
            LineBox[{
             Offset[{1.5, 0}, {34.488, 8.890651729926178}], 
              Offset[{-1.5, 0}, {34.488, 8.890651729926178}]}], 
            LineBox[{
             Offset[{1.5, 0}, {34.488, 1.0754855450416807`}], 
              Offset[{-1.5, 0}, {34.488, 1.0754855450416807`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 247], {
            LineBox[{{34.62, 7.953982742084829}, {34.62, 
             1.0754855450416807`}}], 
            LineBox[{
             Offset[{1.5, 0}, {34.62, 7.953982742084829}], 
              Offset[{-1.5, 0}, {34.62, 7.953982742084829}]}], 
            LineBox[{
             Offset[{1.5, 0}, {34.62, 1.0754855450416807`}], 
              Offset[{-1.5, 0}, {34.62, 1.0754855450416807`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 248], {
            LineBox[{{39.634, 8.251917320812652}, {39.634, 
             1.0940578650298862`}}], 
            LineBox[{
             Offset[{1.5, 0}, {39.634, 8.251917320812652}], 
              Offset[{-1.5, 0}, {39.634, 8.251917320812652}]}], 
            LineBox[{
             Offset[{1.5, 0}, {39.634, 1.0940578650298862`}], 
              Offset[{-1.5, 0}, {39.634, 1.0940578650298862`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 249], {
            LineBox[{{40.641, 8.141752207470867}, {40.641, 
             1.0940578650298862`}}], 
            LineBox[{
             Offset[{1.5, 0}, {40.641, 8.141752207470867}], 
              Offset[{-1.5, 0}, {40.641, 8.141752207470867}]}], 
            LineBox[{
             Offset[{1.5, 0}, {40.641, 1.0940578650298862`}], 
              Offset[{-1.5, 0}, {40.641, 1.0940578650298862`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 250], {
            LineBox[{{42.973, 8.277633615714565}, {42.973, 
             1.0940578650298862`}}], 
            LineBox[{
             Offset[{1.5, 0}, {42.973, 8.277633615714565}], 
              Offset[{-1.5, 0}, {42.973, 8.277633615714565}]}], 
            LineBox[{
             Offset[{1.5, 0}, {42.973, 1.0940578650298862`}], 
              Offset[{-1.5, 0}, {42.973, 1.0940578650298862`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 251], {
            LineBox[{{44.283, 11.806473530277493`}, {44.283, 
             1.2362306579711335`}}], 
            LineBox[{
             Offset[{1.5, 0}, {44.283, 11.806473530277493`}], 
              Offset[{-1.5, 0}, {44.283, 11.806473530277493`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {44.283, 1.2362306579711335`}], 
              Offset[{-1.5, 0}, {44.283, 1.2362306579711335`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 252], {
            LineBox[{{45.828, 8.364676655025551}, {45.828, 
             1.6135481402583909`}}], 
            LineBox[{
             Offset[{1.5, 0}, {45.828, 8.364676655025551}], 
              Offset[{-1.5, 0}, {45.828, 8.364676655025551}]}], 
            LineBox[{
             Offset[{1.5, 0}, {45.828, 1.6135481402583909`}], 
              Offset[{-1.5, 0}, {45.828, 1.6135481402583909`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 253], {
            LineBox[{{46.256, 8.157641236046551}, {46.256, 
             1.6927894211139813`}}], 
            LineBox[{
             Offset[{1.5, 0}, {46.256, 8.157641236046551}], 
              Offset[{-1.5, 0}, {46.256, 8.157641236046551}]}], 
            LineBox[{
             Offset[{1.5, 0}, {46.256, 1.6927894211139813`}], 
              Offset[{-1.5, 0}, {46.256, 1.6927894211139813`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 254], {
            LineBox[{{46.658, 10.040666090178572`}, {46.658, 
             1.6927894211139813`}}], 
            LineBox[{
             Offset[{1.5, 0}, {46.658, 10.040666090178572`}], 
              Offset[{-1.5, 0}, {46.658, 10.040666090178572`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {46.658, 1.6927894211139813`}], 
              Offset[{-1.5, 0}, {46.658, 1.6927894211139813`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 255], {
            LineBox[{{47.063, 9.746942997663497}, {47.063, 
             1.6927894211139813`}}], 
            LineBox[{
             Offset[{1.5, 0}, {47.063, 9.746942997663497}], 
              Offset[{-1.5, 0}, {47.063, 9.746942997663497}]}], 
            LineBox[{
             Offset[{1.5, 0}, {47.063, 1.6927894211139813`}], 
              Offset[{-1.5, 0}, {47.063, 1.6927894211139813`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 256], {
            LineBox[{{47.443, 10.415100678555948`}, {47.443, 
             1.6927894211139813`}}], 
            LineBox[{
             Offset[{1.5, 0}, {47.443, 10.415100678555948`}], 
              Offset[{-1.5, 0}, {47.443, 10.415100678555948`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {47.443, 1.6927894211139813`}], 
              Offset[{-1.5, 0}, {47.443, 1.6927894211139813`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 257], {
            LineBox[{{47.856, 8.702863472381466}, {47.856, 
             1.6927894211139813`}}], 
            LineBox[{
             Offset[{1.5, 0}, {47.856, 8.702863472381466}], 
              Offset[{-1.5, 0}, {47.856, 8.702863472381466}]}], 
            LineBox[{
             Offset[{1.5, 0}, {47.856, 1.6927894211139813`}], 
              Offset[{-1.5, 0}, {47.856, 1.6927894211139813`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 258], {
            LineBox[{{48.272, 8.702863472381466}, {48.272, 
             1.6927894211139813`}}], 
            LineBox[{
             Offset[{1.5, 0}, {48.272, 8.702863472381466}], 
              Offset[{-1.5, 0}, {48.272, 8.702863472381466}]}], 
            LineBox[{
             Offset[{1.5, 0}, {48.272, 1.6927894211139813`}], 
              Offset[{-1.5, 0}, {48.272, 1.6927894211139813`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 259], {
            LineBox[{{49.174, 10.279565801221775`}, {49.174, 
             1.7881765610841414`}}], 
            LineBox[{
             Offset[{1.5, 0}, {49.174, 10.279565801221775`}], 
              Offset[{-1.5, 0}, {49.174, 10.279565801221775`}]}], 
            LineBox[{
             Offset[{1.5, 0}, {49.174, 1.7881765610841414`}], 
              Offset[{-1.5, 0}, {49.174, 1.7881765610841414`}]}]}}, {InsetBox[
            StyleBox["\<\"\[FilledCircle]\"\>",
             StripOnInput->False,
             FontSize->0], 260], {
            LineBox[{{49.985, 8.801571361486912}, {49.985, 
             1.7958751621666122`}}], 
            LineBox[{
             Offset[{1.5, 0}, {49.985, 8.801571361486912}], 
              Offset[{-1.5, 0}, {49.985, 8.801571361486912}]}], 
            LineBox[{
             Offset[{1.5, 0}, {49.985, 1.7958751621666122`}], 
              Offset[{-1.5, 0}, {49.985, 
               1.7958751621666122`}]}]}}}, {}}], {}}, {{}, 
       GraphicsComplexBox[CompressedData["
1:eJztlvlTU1cUx8PShEbQRBYTwIXFEovKJoiEJAdZEgQUcMFStAXRaoqKFJQC
RbEDETfGyuJSRIu4dCyjgpRB0OpkFKkrdKDooDKUoS4UAYFaCvbd+5x3nP4N
eb9kPnNz7jv3e7/nvOOQsDl6rTGPxzM14vHI75yLpX2nb/Sorruk7zuW/iH8
EFwzOPbba1XryqyrITcEQJfDhjiOrp2W+yLKAiaZjNpqu/nwV5bKe3WdCJ4n
v93rJhbAlPa7I0vXiMFdHf77HncBsPsjm52zj02UW3Lcfd/x0Ztxey7eizyD
DhAWqd8+1sKHJ0v2lWz6zhGyTH+U22v5sDhBtHJB9UwwGy1KSHHgg+mKiXMu
TnXhuFLdmWG1yRVydz7e9WmGAK6U2bp1/OEKGv7PQZeyBfC9fsb5FNlciK7Q
nV7cIIRF5sauumF3cK5+8FPPBRFsnvztL01GHhzTfA56gPGlK7+6JdnAzbD5
+QFPPaA3YiDrnJ0tm9+ABzz9Wq+43C9l13meHE8kAgg8uf8z4tVOm4l85gYJ
QNbZEAExnjls49ZsXP/3bH9zxE7ktvJkhbAE+VrTieCaKuRZcQXXh/5EVgiZ
iDHk4sA9ST12Xtz7NvaMnu33RI5kjjc5EPklk35uGPKd28wTjtxVcVQ/IxKZ
6hmP7NbhzM9JQ2Zuq1J9zQvmhR5tf9UqhQO9jKEeIzs9epOt9Z8HDwtydKVf
SEFDAnTI5PpL782D3WlqzQGdBFyJgFO8wbd2a3GDTMLqt9obfN5x2kGJ6YpK
by7+JCNfm4kPF39oE5OwEJlRZ/SsGJn6wRJ54eeMg+2QSTWEhvtAX1DqooYa
Keu/RGR+ThGjODLVKxnZihi4EHk9EaQI+Z9sbX1qCzKtv4fIpHrTZ83n9KX5
zEZm3CCL24xMqqnRxpdjWq/rfKHfc8uOck8J69/TyLR83/pyelK9tAs4DiKC
5SMT+a+UIdN6q0G+N7K0q+IyMtsvkI3Jhc71g9l9q59EeUtgWMYYerkfp3ei
nFQgMm1Ph5BpPVUh14UyCdz0A/8N1RtlyVIg5SGzl0NudF7oungp0OtxQab5
hCC/ZuR99h5Tv8XIuf3ofWTI4Zv6HeHaGCnQ9Pbj/6k+t+RgYhbRG8/0E7bf
IocQlPjD3gvq+vENNnDkMPN8gtwSwTTAw/5Qans/87iNDZt/PTLVtxV5nEn3
I7EChl/GjgQMW7N+jlJw6y4epCMjf0UM9xlyJjUkxtP1MgVcXeOoH+2yBhp+
EpnW27gCjn/ptLU0xRoGmpmEJUqOqX9UyNQf7/F00iCzlbA89eP2qYnWQNt9
oxJinD07PrC2Zvv/MhVofLYldHdbwfkUJqE4ZPp9yUSm99OmgjwrpYtTvJjV
wwg4pv2wAcAyLqbTfNCC3V+PTNphsyIAgiyOKFfpLNjzKZFpPS0JgPXP84oW
pluw+z8IhFdN9kaPUwVAys88Ogjqru9fL4gVsvWfFQyDLwrS6v4Wsu9zDoFT
nU3H7JQTWH88C4GSpKo1Z0omwTLaINTQpC9oNnsiend+NUQmJ20JKhSz+u5S
w3bTnFUTdotZvWqRHahAauicclemNRZDfgBpWBoo3xZ1R3RbBEx3PhFcrIGR
Wy+GOtaK2O/nuAZyCvNPrbITg2E+MMwHhvnAMB8Y5gPDfGCYDwzzwf/ng/8A
2HH7Pw==
        "], {
         {GrayLevel[0], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 131], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 132], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 133], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 134], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 135], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 136], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 137], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 138], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 139], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 140], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 141], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 142], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 143], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 144], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 145], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 146], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 147], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 148], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 149], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 150], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 151], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 152], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 153], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 154], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 155], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 156], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 157], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 158], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 159], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 160], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 161], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 162], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 163], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 164], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 165], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 166], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 167], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 168], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 169], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 170], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 171], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 172], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 173], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 174], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 175], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 176], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 177], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 178], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 179], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 180], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 181], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 182], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 183], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 184], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 185], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 186], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 187], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 188], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 189], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 190], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 191], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 192], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 193], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 194], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 195], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 196], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 197], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 198], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 199], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 200], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 201], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 202], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 203], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 204], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 205], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 206], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 207], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 208], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 209], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 210], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 211], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 212], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 213], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 214], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 215], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 216], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 217], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 218], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 219], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 220], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 221], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 222], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 223], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 224], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 225], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 226], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 227], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 228], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 229], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 230], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 231], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 232], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 233], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 234], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 235], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 236], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 237], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 238], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 239], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 240], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 241], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 242], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 243], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 244], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 245], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 246], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 247], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 248], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 249], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 250], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 251], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 252], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 253], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 254], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 255], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 256], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 257], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 258], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 259], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->6], 260]}, {}}], {}}}, {{}, {}, 
      {GrayLevel[0], Thickness[0.003], LineBox[CompressedData["
1:eJxNzX0803sfx/G5nW4UEe3YEZsYuZuRpfAjm7kJUaESkXsh92m1TjpFN+4r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        "]]}}, {{}, {}, 
      {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
       LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ/SZ+oWqR10Y7nfqmH6wFjA5y577M9ttx3x7Gz+pc
VuSz4z2cXx8w9dXzNgYHGN9u8j+/J70ccD47z5mpHmYCcP6rOY8VGapF4Hzp
H5aVp8sk4PzjitHvvh+XgfNtzU751zUpwPn7HNj6umqU4PyaTerR7gtV4PzE
zhe8fQvV4PxTBVvvHZiuAecX7k+3W7JDC+He4p3Nglt14HzPvg/h+nf04PzX
dySXzqkxgPPdVLknPqswhPMdFPOPdHQZwflnzy969b7TGM7/aegZsX6eCZyf
PufrlZR1pnB+xs5Cl/urzeB8jq6E3xv3mcP51rzySz33W8D5G2Y8jr2+yxLO
P3JdKm7vaSs4P+ekYmDGKWs4f1Pe7O7sezZwvpWM9NWUt7ZwflhNlqDyKzs4
X3CCzlTLP/Zwvr72/VauOgc4v1xotUfxbwS/L9hAv6PZEc5/nyvbX8/kBOcr
PDospNyD4M/Sv8S/kscZzjdtTBZZ1YXgL9BZZxMu7ALnh2xMuPdsEoJ/o//M
YiVZVzi/tmh3wc0lCH62ntD2ImU3OF/TRUlxxxoE38B4FssDHXc4P0Jt6vum
VQh+QLHnv4tGHnD+pJmpbcybEHwHgwf7GH8i+G+PRX3/b+8J5wMAwypLiA==

        "]]}, 
      {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
       LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ/SZ+oWqR10Y7qavBc55cEHGQO/dltt+O+/Ywflbn
siKfHe/h/PqAqa+etzE4wPh2k//5PenlgPPZec5M9TATgPNfzXmsyFAtAudL
/7CsPF0mAecfV4x+9/24DJxva3bKv65JAc7f58DW11WjBOfXbFKPdl+oAucn
dr7g7VuoBuefKth678B0DTi/cH+63ZIdWgj3Fu9sFtyqA+d79n0I17+jB+e/
viO5dE6NAZzvpso98VmFIZzvoJh/pKPLCM4/e37Rq/edxnD+T0PPiPXzTOD8
9Dlfr6SsM4XzM3YWutxfbQbnc3Ql/N64zxzOt+aVX+q53wLO3zDjcez1XZZw
/pHrUnF7T1vB+TknFQMzTlnD+ZvyZndn37OB861kpK+mvLWF88NqsgSVX9nB
+YITdKZa/rGH8/W177dy1TnA+eVCqz2KfyP4fcEG+h3NjnD++1zZ/nomJzhf
4dFhIeUeBH+W/iX+lTzOcL5pY7LIqi4Ef4HOOptwYRc4P2Rjwr1nkxD8G/1n
FivJusL5tUW7C24uQfCz9YS2Fym7wfmaLkqKO9Yg+AbGs1ge6LjD+RFqU983
rULwA4o9/1008oDzJ81MbWPehOA7GDzYx/gTwX97LOr7f3tPOB8A9ZuBxA==

        "]]}, 
      {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
       LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ/SZ+oWqR10a72RukOB7UqzvInfsy22/HfXsYP6tz
WZHPjvdwfn3A1FfP2xgcYHy7yf/8nvRywPnsPGemepgJwPmv5jxWZKgWgfOl
f1hWni6TgPOPK0a/+35cBs63NTvlX9ekAOfvc2Dr66pRgvNrNqlHuy9UgfMT
O1/w9i1Ug/NPFWy9d2C6BpxfuD/dbskOLYR7i3c2C27VgfM9+z6E69/Rg/Nf
35FcOqfGAM53U+We+KzCEM53UMw/0tFlBOefPb/o1ftOYzj/p6FnxPp5JnB+
+pyvV1LWmcL5GTsLXe6vNoPzOboSfm/cZw7nW/PKL/XcbwHnb5jxOPb6Lks4
/8h1qbi9p63g/JyTioEZp6zh/E15s7uz79nA+VYy0ldT3trC+WE1WYLKr+zg
fMEJOlMt/9jD+fra91u56hzg/HKh1R7FvxH8vmAD/Y5mRzj/fa5sfz2TE5yv
8OiwkHIPgj9L/xL/Sh5nON+0MVlkVReCv0BnnU24sAucH7Ix4d6zSQj+jf4z
i5VkXeH82qLdBTeXIPjZekLbi5Td4HxNFyXFHWsQfAPjWSwPdNzh/Ai1qe+b
ViH4AcWe/y4aecD5k2amtjFvQvAdDB7sY/yJ4L89FvX9v70nnA8Ak+1daA==

        "]]}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{
      FormBox["\"x(kbp)\"", TraditionalForm], 
      FormBox["\"L\"", TraditionalForm]},
    AxesOrigin->{-1, 0},
    Method->{},
    PlotRange->{All, All},
    PlotRangeClipping->True,
    PlotRangePadding->None], ",", 
   GraphicsBox[{{{}, GraphicsComplexBox[CompressedData["
1:eJztlvs7VHkcxyXL5D5TGM6ZKLcpISPjMsa8JYatyKVa5VHK2k1JN10opC1d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       "], {
        {RGBColor[0.24720000000000014`, 0.24, 0.6], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 131], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 132], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 133], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 134], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 135], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 136], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 137], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 138], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 139], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 140], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 141], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 142], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 143], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 144], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 145], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 146], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 147], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 148], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 149], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 150], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 151], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 152], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 153], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 154], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 155], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 156], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 157], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 158], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 159], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 160], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 161], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 162], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 163], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 164], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 165], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 166], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 167], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 168], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 169], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 170], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 171], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 172], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 173], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 174], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 175], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 176], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 177], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 178], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 179], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 180], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 181], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 182], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 183], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 184], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 185], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 186], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 187], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 188], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 189], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 190], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 191], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 192], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 193], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 194], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 195], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 196], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 197], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 198], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 199], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 200], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 201], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 202], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 203], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 204], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 205], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 206], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 207], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 208], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 209], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 210], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 211], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 212], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 213], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 214], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 215], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 216], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 217], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 218], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 219], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 220], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 221], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 222], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 223], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 224], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 225], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 226], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 227], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 228], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 229], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 230], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 231], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 232], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 233], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 234], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 235], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 236], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 237], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 238], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 239], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 240], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 241], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 242], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 243], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 244], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 245], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 246], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 247], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 248], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 249], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 250], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 251], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 252], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 253], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 254], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 255], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 256], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 257], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 258], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 259], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 260]}, {}}], {}}, {{}, {}, 
      {RGBColor[1, 0, 0], Thickness[Large], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQrdT/d/E8uY12MrsWSu9aKOZwauLtwhfp9+1hfK+9
7H7P0t/D+Wd5zThZYhkcYHynftcDy/054PxU/V+8hrwCcL6vZupHMXcROH/T
ldrSkxYScL61kNZ6lnoZOD/996S5SyMU4Pz8Y8+N1/sqwfldUWyqf3NU4Pzk
49VphhlqcP5BdsnA7EgNON9QsGHayxItOD/hs62OX44OnL9w3lGZ7716cP7m
Pqvbl4IM4PySXbYBc30M4fz9p5Z+6ow2gvMz3S33ZkYYw/lzVhhuzc4ygfMn
ft7bWFBuCuc/W1VallFkBucfcZs0o6nJHM5n9L/1qL/BAs5ncNzGuKDSEs7v
EP/ue6ndCs4viEo+9L3ZGs5/2GiSYj/VBs4XmTzzVudCWzh/mYBW5fHZdojw
KpJ3VV9tD+fPU1ggYxviAOfvrfnFkHEBwVf0Zv+jHO4I5285r9l98wqC33Ps
n4FCrBOcP7n4ZVbCHQS/RlSOXynSGc5fqcl6quQBgs/2hVHyYJwLnL/cYGPd
vOcIvmbSKr+/ua5w/m3PnZtCXyP4lxZX6doXu8H5PzYH2ih9QvD/7yja2pbn
Dud7G7i51nxF8I/H6mdmF3vA+VbsARu27kTw120o+P7/P4IPAJ12XKk=
        "]]}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{
      FormBox["\"kbp\"", TraditionalForm], 
      FormBox["\"E[tbl]\"", TraditionalForm]},
    AxesOrigin->{0, 3.053482693418886},
    Method->{},
    PlotRange->All,
    PlotRangeClipping->True,
    PlotRangePadding->{{0.9997, 0.9997}, {0.08528334590407137, 
     0.08528334590407137}}], ",", 
   GraphicsBox[{{{}, GraphicsComplexBox[CompressedData["
1:eJztlvs3lHkcx9FFKdcU5TJjZjzRoMzUYC7mLRmmkFuKVW2lOd0WJZ2KHYt0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       "], {
        {RGBColor[0.24720000000000014`, 0.24, 0.6], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 131], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 132], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 133], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 134], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 135], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 136], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 137], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 138], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 139], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 140], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 141], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 142], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 143], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 144], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 145], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 146], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 147], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 148], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 149], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 150], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 151], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 152], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 153], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 154], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 155], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 156], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 157], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 158], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 159], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 160], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 161], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 162], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 163], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 164], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 165], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 166], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 167], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 168], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 169], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 170], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 171], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 172], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 173], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 174], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 175], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 176], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 177], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 178], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 179], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 180], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 181], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 182], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 183], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 184], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 185], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 186], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 187], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 188], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 189], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 190], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 191], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 192], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 193], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 194], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 195], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 196], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 197], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 198], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 199], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 200], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 201], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 202], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 203], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 204], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 205], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 206], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 207], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 208], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 209], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 210], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 211], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 212], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 213], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 214], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 215], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 216], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 217], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 218], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 219], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 220], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 221], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 222], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 223], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 224], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 225], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 226], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 227], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 228], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 229], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 230], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 231], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 232], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 233], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 234], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 235], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 236], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 237], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 238], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 239], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 240], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 241], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 242], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 243], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 244], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 245], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 246], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 247], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 248], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 249], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 250], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 251], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 252], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 253], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 254], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 255], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 256], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 257], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 258], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 259], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->8.96], 260]}, {}}], {}}, {{}, {}, 
      {RGBColor[1, 0, 0], Thickness[Large], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQrdT/d/E8uY12Mvt4ah8vknA4NfF24Yv0+/Ywvtde
dr9n6e/h/LO8ZpwssQwOML5Tv+uB5f4ccH6q/i9eQ14BON9XM/WjmLsInL/p
Sm3pSQsJON9aSGs9S70MnJ/+e9LcpREKcH7+sefG632V4PyuKDbVvzkqcH7y
8eo0www1OP8gu2RgdqQGnG8o2DDtZYkWnJ/w2VbHL0cHzl8476jM9149OH9z
n9XtS0EGcH7JLtuAuT6GcP7+U0s/dUYbwfmZ7pZ7MyOM4fw5Kwy3ZmeZwPkT
P+9tLCg3hfOfrSotyygyg/OPuE2a0dRkDucz+t961N9gAeczOG5jXFBpCed3
iH/3vdRuBecXRCUf+t5sDec/bDRJsZ9qA+eLTJ55q3OhLZy/TECr8vhsO0R4
Fcm7qq+2h/PnKSyQsQ1xgPP31vxiyLiA4Ct6s/9RDneE87ec1+y+eQXB7zn2
z0Ah1gnOn1z8MivhDoJfIyrHrxTpDOev1GQ9VfIAwWf7wih5MM4Fzl9usLFu
3nMEXzNpld/fXFc4/7bnzk2hrxH8S4urdO2L3eD8H5sDbZQ+Ifj/dxRtbctz
h/O9Ddxca74i+Mdj9TOziz3gfCv2gA1bdyL46zYUfP//H8EHAHsjXA0=
        "]]}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{
      FormBox["\"kbp\"", TraditionalForm], 
      FormBox["\"V[tbl]\"", TraditionalForm]},
    AxesOrigin->{0, 0},
    Method->{},
    PlotRange->All,
    PlotRangeClipping->True,
    PlotRangePadding->{{0.9997, 0.9997}, {0.27477915815531306`, 
     0.27477915815531306`}}]}], "}"}]], "Output",
 CellChangeTimes->{3.585764131741067*^9, 3.5857648689932356`*^9, 
  3.585764923336344*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"!", "withdata"}], ",", "\[IndentingNewLine]", 
   RowBox[{"gtbl2", "=", 
    RowBox[{"ListPlot", "[", 
     RowBox[{
      RowBox[{"100", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Mean", "[", "tblsnp", "]"}], "-", 
            RowBox[{"mf", "[", "nsq", "]"}]}], ")"}], "/", 
          RowBox[{"mf", "[", "nsq", "]"}]}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Variance", "[", "tblsnp", "]"}], "-", 
            RowBox[{"vf", "[", "nsq", "]"}]}], ")"}], "/", 
          RowBox[{"vf", "[", "nsq", "]"}]}]}], "}"}]}], ",", 
      RowBox[{"PlotStyle", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"Brown", ",", "Blue"}], "}"}]}], ",", 
      RowBox[{"PlotMarkers", "\[Rule]", "Automatic"}], ",", 
      RowBox[{"Joined", "\[Rule]", "True"}], ",", 
      RowBox[{"AxesLabel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\"\<Site\>\"", ",", "\"\<100 (est-pri)/pri\>\""}], " ", 
        "}"}]}], ",", 
      RowBox[{"AxesOrigin", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}]}], ",", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{
            RowBox[{
             RowBox[{"Dimensions", "[", "tblsnp", "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], "+", "1"}]}], "}"}], ",", 
         "All"}], "}"}]}]}], "]"}]}]}], "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.5152775405564384`*^9, 3.5152775600564723`*^9}, {
   3.5152775922393293`*^9, 3.5152776757774754`*^9}, {3.5152786292737894`*^9, 
   3.5152786296481905`*^9}, {3.515373092662649*^9, 3.515373103395468*^9}, {
   3.515373168790783*^9, 3.5153732997374134`*^9}, {3.5153755574291797`*^9, 
   3.515375561656787*^9}, {3.5153755951500463`*^9, 3.51537559755245*^9}, {
   3.515521346198599*^9, 3.515521381088648*^9}, {3.516675090734133*^9, 
   3.516675095254139*^9}, 3.5166816235051117`*^9, {3.5206817900906467`*^9, 
   3.520681801525467*^9}, {3.5206818535359583`*^9, 3.52068190024244*^9}, {
   3.520681944094117*^9, 3.5206819445621185`*^9}, {3.5206821674563093`*^9, 
   3.520682177955128*^9}, {3.5206822094203835`*^9, 3.5206822359404297`*^9}, {
   3.52068237281507*^9, 3.5206824058559284`*^9}, {3.5206824753072505`*^9, 
   3.5206825042453012`*^9}, {3.520682550639783*^9, 3.5206825783766317`*^9}, {
   3.5206826344587297`*^9, 3.5206826545983653`*^9}, {3.5206961035608845`*^9, 
   3.5206961122501*^9}, {3.52934298705132*^9, 3.5293429955221353`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"pos", "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"ysnp", "[", 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pos", "=", 
   RowBox[{"Insert", "[", 
    RowBox[{"pos", ",", 
     RowBox[{"Floor", "[", 
      RowBox[{"Mean", "[", "pos", "]"}], "]"}], ",", "2"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"tbl2", "=", 
    RowBox[{
     RowBox[{
      RowBox[{"getsnptbl", "[", 
       RowBox[{"#", ",", "pos"}], "]"}], "&"}], "/@", "restbl"}]}], ";"}], "//",
   "Timing"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"truetbl", "=", 
   RowBox[{"getsnptbl", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"truetreeloc", ",", "truetreetbl"}], "}"}], "]"}], ",", 
     "pos"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"truetbl", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"mf", "[", "nsq", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"Length", "[", "pos", "]"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tbllab", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"\"\<L\>\"", "<>", 
      RowBox[{"ToString", "[", "#", "]"}]}], "&"}], "/@", "pos"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pritbl", "=", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"f", "[", 
      RowBox[{"nsq", ",", "x"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{"Max", "[", "tbl2", "]"}]}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Red", ",", "Thick"}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"g1tbl", "=", 
  RowBox[{"listmcplot", "[", 
   RowBox[{"tbl2", ",", "truetbl", ",", "tbllab", ",", "withdata", ",", 
    RowBox[{"LabelStyle", "\[Rule]", "Medium"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"g2tbl", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"ListLinePlot", "[", 
       RowBox[{
        RowBox[{"acf", "[", 
         RowBox[{
          RowBox[{"N", "[", 
           RowBox[{"tbl2", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "i"}], "]"}], "]"}], "]"}], ",", "100"}], 
         "]"}], ",", 
        RowBox[{"AxesOrigin", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}]}], ",", 
        RowBox[{"AxesLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"\"\<\[Times]\>\"", "<>", 
            RowBox[{"ToString", "[", "thin", "]"}], "<>", "\"\< lag\>\""}], 
           ",", 
           RowBox[{"\"\<acf of \>\"", "<>", 
            RowBox[{"tbllab", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}]}], "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"Length", "[", "tbllab", "]"}]}], "}"}]}], "]"}]}], ";"}], "//",
   "Timing"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"g3tbl", "=", 
   RowBox[{"listhisplot", "[", 
    RowBox[{"tbl2", ",", "truetbl", ",", "tbllab", ",", "withdata", ",", 
     RowBox[{"Table", "[", 
      RowBox[{"Automatic", ",", 
       RowBox[{"{", "3", "}"}]}], "]"}], ",", 
     RowBox[{"LabelStyle", "\[Rule]", "Medium"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"g3tbl", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Show", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"#", ",", "pritbl"}], "}"}], ",", 
      RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], "&"}], "/@", 
   "g3tbl"}]}]}], "Input",
 CellChangeTimes->{{3.5151770731963854`*^9, 3.515177211521828*^9}, {
   3.5151772844061565`*^9, 3.5151772932669716`*^9}, {3.515177346525465*^9, 
   3.5151773472274666`*^9}, {3.515177649555998*^9, 3.515177680537652*^9}, {
   3.5151777930450497`*^9, 3.5151777936066504`*^9}, {3.515177830297915*^9, 
   3.515177840656333*^9}, 3.515178589314708*^9, {3.515258145953899*^9, 
   3.5152581468275003`*^9}, {3.5152779247851133`*^9, 3.515277946905952*^9}, {
   3.515424002035801*^9, 3.5154240060918083`*^9}, {3.5154240717835236`*^9, 
   3.5154240728287253`*^9}, {3.515424124371216*^9, 3.5154241271324205`*^9}, 
   3.515424999440153*^9, {3.520702809130418*^9, 3.52070281098042*^9}, {
   3.5207028442504663`*^9, 3.5207028641904945`*^9}, {3.520785859885447*^9, 
   3.520785860883849*^9}, {3.5221937626548347`*^9, 3.5221937742624984`*^9}, {
   3.522194248325613*^9, 3.5221942736100593`*^9}, {3.5221943389757977`*^9, 
   3.5221943461462083`*^9}, {3.522196472838848*^9, 3.522196493381023*^9}, 
   3.522202798074163*^9, {3.524324464750002*^9, 3.5243244716123943`*^9}, {
   3.5243247241338377`*^9, 3.5243247257549305`*^9}, 3.5366948072247143`*^9, {
   3.5366950862180166`*^9, 3.536695100890361*^9}, {3.5366951428917046`*^9, 
   3.5366951433135934`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.01560010000000000042474912476109238924`4.21372729556415", ",", "Null"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.5857641319350786`*^9, 3.5857648691142426`*^9, 
  3.58576492344335*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{{}, 
      {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJw9lAtU03UUx9cMJCBAQANEmFDyTAFJcCL78nCAgI5tsA1K0VwkaATydBRD
yycg8uhoInA08Cj2UMMMSP6oGPhAIwOPBxVQ6KSQeCbHIaDV4f7aOTs7331+
997fffzu/PWpUjWfx+N98u/3v9/pz6jooXCoffF9W9AfMDvYfa9PYE3aCHU9
XTkq+TPRtLaAx5a71nt0FsStcUVzR5978CVxGzRkqY+0JTFtjwfu1j7iQWM6
L4CsM1N9bsdc0k7I2iPZl3R7lM6/jaemed1p152JL4BbXbv3+XV2pF2hct1q
eanAirQ7Jj31vN1hBqQ9kV5lLfY6z+IthP/1jILilHHy74XuM7aFXROMe2Nh
vmDRk0Y9cR+Yrvvca6Mji7cYFsKGlshEPmlfmFeoDa52vEH6PXQYfG376KdJ
sl+CbmVei/jyTOJ+WHroO/9rx1g8f9xTKHvG85heitTEt5Jb2wxJC/HZXwFu
jrOmyN8yOHQaWXx44jXiAXi/RrF5r9UE8eUoG90pmjjFzgeiIPSoa0w/Oy/C
nqfKtf4zWX7AiOHMIkGo+TTXApola9pbU1j8IJw/fGdgqcqEeBBGv6nX14zP
Jh4MoUn2jnPNrxMPRvO7j/J/nTQlHoJNcrfaG9EziIdAEbZm7zJTNi+hMJ8x
YZc8SPG0oWhwnsVfq2R8BSRm37s3NZkRX4GfnQZCnzqyfMRw7JRGFN1zIi5G
4xcZvupSI+JhKPFQhLbpqb7aMOS3yByaxGyewlHyMm3unG+Z/3A0qwbfzHIW
EI9AX/fg9mvVdB9tBKqvnn0ydYTN60pwGTJdPuYQXwn73ZPdf6fOIh6JY+6+
I38M03xqI6HTnAqcmmL9icJHfI5LT+ATj0K2QJSlKaP78KIxZ+jP5R1HLIlH
oziktNHlOct/FUwPSNsjFMz/KnTWB4cN1Twn/6sRXd5zfFsJ9Uu7Ghdccoqq
cti8SnDlke7xmB/5hwT+gUbvuBe9mrbXSrBhrKvczYHmg5Ng+9gPN/JMeGQf
g3lc3aFAIeWLGChrf+wfGWP1ioFBScbpdeHzyT4GVcalhR3ZrL9S7M+9kLxp
PcWDFL0fqIuqfOzJXooTNtds/MqoXpwUPUkpSf3xOspPht5ig2RLH8oXMrS6
8ZV3d7F+ynDcOKQyX0n14mQQaB5XBA6z+ZWjMvP2WPpDmlfIsVGYqWvS0/7Q
ynFws+1WDzuaT06O3PIDCwobqB68WIzKv+RO7qXziMWMJ5U7b+bakH0svC+/
kBb1UH25WAzJTY426Nh8xqE8JCrcPJveB+JQeOtZ2mMvFj8OHlaJIpiz+8fB
py39zEAAvTeeAqWaferJGOoHFAju6W1rFVB/tQrMS9wkTUimfDkFDC5ueLnm
K7bPldBZBX0qzaP3DSWqXW5WJGVQP7VKaA7zhb8sJ3+cEnYD0Wd5tZQPT4XZ
D6b4VQ+pHlDB6eNdXl25bmSvwiTnefqkM5/sVRAVtPy2KPsF9S8ez+6H71rk
TfsR8Sh+flNT70v308bDNafGQT9G+5qLx+7EguE+AatfAkwDtogvCuk9IgG3
1sa+2v//PkpApORS/tTvhvgHyXDYKg==
        "]]}, {}}, {{}, 
      GraphicsComplexBox[{{0., 5.657936507936508}, {0., 5.657936507936508}, {
       0., 5.657936507936508}, {0., 5.657936507936508}}, {
        {RGBColor[1, 0, 0], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->15], 3], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->15], 4]}, {}}], {}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{
      FormBox["\"\[Times]1 t\"", TraditionalForm], 
      FormBox["\"L1\"", TraditionalForm]},
    AxesOrigin->{1., 1.0528331373431263`},
    LabelStyle->Medium,
    Method->{},
    PlotRangeClipping->True], ",", 
   GraphicsBox[{{{}, 
      {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJw1lQlMVFcYhQcriBUYlgEBZZPNDgyMClQ2OaIsMmyzMAuggkJUiliqEmxR
Hpqg0UrBYq1VhCC2LGpdQoosdUiQRSoo1bamHSGNSGuVAcZSQI1t439fMnn5
5tzlv/ece5/bll2y7Hk8Hi/vv9//77fPRESxs6jhas8y0B8oqeupu1ZtT2wK
M8vo7U+sFhFbIuaWhUp/2JZYgAwupOZCtxWxPQKuG0x3nGW8FFc+lGhaa+2I
XeEXMtLmUPQm4i0vw8vTZYd6hoxJ90C2Cs2DHtbEXrjXlFeoLniPeDkWXNdF
St6w9kJk87nhbPslxL4webDT1KaDze+HL8UXi+/a2RCL0eF54lOP+a9o/hXo
rcm5GSdcTPpK1PB6Fc5CNv4q9EdWjRjdX0ocgACzuxLjGgfiQERtdltjKzAl
DsKW0/umxufcid/H4rDKW70ObLzVaHr088nSeDZeMNLuXFYr+K7EIYA2y6M5
cyFxKEb2dYW3TbL5whA94VLLmVkQhyOopeCLjuXMrzUYKAsKnLzkQhyB7s9N
g2aCBcRAUrkpRI+oXg6oOfGNxmYrW/9aiNMjvk/gU/3cWgg0WZGyai/SI5H7
4nS0tJL85yIxEuB+dfoQq38dDtTnVixrdyN9Hd5pl5qfFHmSvh4ys+IK/T3K
A7ce4c9q105PMj0K3n35R3CQ9Y/ChRlJcIaOjR8NNxtfL9k4qy8azk7PTMrd
2X7G4IAtP0z1lPznYmAXutVmLtqb9Fh8/TevXLDHjPRYWNgYWr9qYPoGqK8O
9ApbnEnfAOmMpQx65mccnB3k2/J2iEmPg4uPW3PWGlafBBPKpdqOel/SJXie
MFV0cYkj6fE4O2qiMewxIj0ePYb6SdEU8ycBjzeaibs6yQ8uAe67xSWz6Szf
idA1Lhz9Yxf5zyUiyaEqQ9G/gPQkHN0bE1txmPLAJUF/7ozOqUFIejI0Gzc1
ilOpHiTj1KrlM7ldltQ+GYLp/Wm6G3T+tMmY3fuucfELPvWXYq74Es/QJqL+
UtxfcfTbgiKqn5NCNf5RWcoZf+ovxeZzHxzmW7H9kSH9jGOZayAxZMjk+fu3
5xNzMvj8JnpgLyD/tDI06rlZHz92/8jxsn5/wY+jNB/kkFd8/Ko0h/ktR+yN
281xleSvVo5KXaHRlVPMXwVS9ggfOmVRfqFAfpB3zvkfKN+cAida7lwc+JVY
q0DUfNlWPdtvXgpWy7e55RyjvCIFo50//fNZIa2XS8G1F0Wi8ETStSkoUl6u
rqpg948S24JzW2PaWf1KeDs93l3PdE6J55/0OXqCzrtWCafMCLuxbJYPFcKs
r3Qe9ac8QgXldSvzzEGWFxV+91nfP2Wg+1KrgmXJ2OWmXHZ/qrGo7uZuUTfN
BzUmV+Zz51eyvKjhq980LA0k1qqR+d3O0CEvyitPg5nWwYfd2+l8QgN3nUE4
/prWy2kg+LN/ONGc2ms1cPW5NXz8CbuPUuFa/drY9TarPxWvhiSqymNs/1Mx
9Mvg8U4vyqM2FbetrO1yS9n3Iw3hg0/HGmopn0iDX3nAX0ea51H/NMw09TW7
FBjjX9zqwAc=
        "]]}, {}}, {{}, 
      GraphicsComplexBox[{{0., 5.657936507936508}, {0., 5.657936507936508}, {
       0., 5.657936507936508}, {0., 5.657936507936508}}, {
        {RGBColor[1, 0, 0], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->15], 3], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->15], 4]}, {}}], {}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{
      FormBox["\"\[Times]1 t\"", TraditionalForm], 
      FormBox["\"L24993\"", TraditionalForm]},
    AxesOrigin->{1., 1.7510114184427572`},
    LabelStyle->Medium,
    Method->{},
    PlotRangeClipping->True], ",", 
   GraphicsBox[{{{}, 
      {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJw1lAlMk2cYx4EV7ESUmyK4URACcquIlAl/7paj0EJbKOC8gKgoxwxCXLbP
Y7phEB3KncBwG8yJTBkIVWcBGYIalYUtimSizsURFJmIyDUXnrdJ0/z6/573
/T/H9wi3ZMnT9HR0dHa/+/7/u/AZCwz5xDHJY0gA+gN5FhWWiY0mxHw8mlPJ
m1oXExuDvzF4do+vEbE5Hj4obRvKEBILYBLtbDsgX0Jsi5+XFJe93fg+sR0M
/DqrW8ZnAhfYHjdCzcr/vsR4JcKmYlK6z7D7ncCPMAjnyz4kdkZroKm1XMgj
XoVmgx6f+BtmxG7wO9AZM8Zn8R7QiF/07zvKnveCSHzK4ONqdp83Bkt41xpS
3iN9Nbr9wft6mulrIBaa53+22ZD0tUgT+fccamLsA3dJhJ5co0O8DmWZzVsb
ypYR+0K3NKaQN83yX48x8W+PuXDGfuAb7+SvbDMnFuFwdpH3+UZdYn88z/Xw
9BkwJf4Idvcl2/c46BNvwFPHqzXPvmH5BoDnWTvi7cnqH4jpbevTG1JYvwDB
t83nl43pLTAHSNdJ9p7JtiI9CCGbBz1i11O9uCDsNsgbddOw+gejyuSeIMCS
/HLBOLupSGPlaEx6CE7vld0yvknMhSBuqvpp3l02X6FwN2nI7aijfLhQlKzI
uybQXU56GNaIIhLso6ifXBhCBxeN717O6hmOiochr4dT6TwuHPMBz3fNRlmS
HoHxl68m9ZV80iNQkG/35QMvlr8YE3qyrn07qH+cGJfLa60LXdn5Erwc7f8j
0oWe5yQ4mFnTm5nB5j8S2XUnNw3X2JEeCeF3lT8c62T1j4L1C0n+aJ8t6VFQ
bMpwkziw/kWjt+l6a4M9Oz8aet2LzWaHLEiPweT8waW/e1M+XAwez7TnXNy1
gnQp2o+NO/sYs/5J4ZAlvil4y+YlFuVPJH4iKcsvFpO9IxNDaaw/cXhSG1S5
9g35QRyU8Xc6qtJfLcw7F4df/9K/59JH86WNg+4jYV+KNZt3GercowZyuqj/
kMGIt+WATxGrtwzH/zHtMOoj/1oZuKeCcsUJVj851KLp8RYz6i/kSD18tmCJ
LquHHJeFwxcKk8ifVg6+9INPh6oWUXw87ouzXHd0UL0QjwShRn1LyeYxHlf9
1+7d1kH5auPxOW9/qmEh608Cboauq2wZo32FBPCNqidfy0nnElDr9Fxzbiux
9p2uU9o395rtFwWSR3x/0ZiRXyhgVZ+QZ29BfjgF9p/86vtUGxavQEuYYurN
CM2LjhJr5q4UZ1Sy+5Vo13RZ3HjC5kmJiImCE353llK8Eqqjxysm5li8Ck7n
rriXfcHuVyEnN2uDnsaR4lVovFvfs/0i+dGq8MKrs2DGjs1XIn6s7V+e2Uz+
kIjctFVFp9XMfyKGLHP+9LQhf9pE9GQ3b74tZfsqCYECm2d+B9n8JOHf6P4j
O0X0/nJJGLhULFWdMqD4JGTO59soEpl/NdKHTcqP6FJ+UKOp3uT+vuvsfVZj
9KfSHZM+dJ5WjdWDbi4Xbs/SPk6GYZarcUoN7SMkI7zEYkIbQPuLS0adfpvv
uK0h/gP5rcA0
        "]]}, {}}, {{}, 
      GraphicsComplexBox[{{0., 5.657936507936508}, {0., 5.657936507936508}, {
       0., 5.657936507936508}, {0., 5.657936507936508}}, {
        {RGBColor[1, 0, 0], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->15], 3], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->15], 4]}, {}}], {}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{
      FormBox["\"\[Times]1 t\"", TraditionalForm], 
      FormBox["\"L49985\"", TraditionalForm]},
    AxesOrigin->{1., 1.275050885281606},
    LabelStyle->Medium,
    Method->{},
    PlotRangeClipping->True]}], "}"}]], "Output",
 CellChangeTimes->{3.5857641319350786`*^9, 3.5857648691142426`*^9, 
  3.5857649234953527`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.15600100000000000077804429565730970353`5.21372729556415", ",", "Null"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.5857641319350786`*^9, 3.5857648691142426`*^9, 
  3.585764923643361*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{
      {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
       EdgeForm[Opacity[0.6579999999999999]], {}, 
       {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
        EdgeForm[Opacity[0.6579999999999999]], 
        TagBox[
         TooltipBox[
          TagBox[
           DynamicBox[{
             FEPrivate`If[
              CurrentValue["MouseOver"], 
              EdgeForm[{
                GrayLevel[0.5], 
                AbsoluteThickness[1.5], 
                Opacity[0.66]}], {}, {}], 
             RectangleBox[{0., 0}, 
              NCache[{2., 
                Rational[1, 11]}, {2., 0.09090909090909091}], 
              "RoundingRadius" -> 0]},
            
            ImageSizeCache->{{23.5, 40.49641500276842}, {10.714290774515877`, 
             40.31655449248589}}],
           StatusArea[#, 0.09090909090909091]& ,
           TagBoxNote->"0.09090909090909091"],
          StyleBox["0.09090909090909091`", {
            GrayLevel[0]}, StripOnInput -> False]],
         Annotation[#, 
          Style[0.09090909090909091, {
            GrayLevel[0]}], "Tooltip"]& ], 
        TagBox[
         TooltipBox[
          TagBox[
           DynamicBox[{
             FEPrivate`If[
              CurrentValue["MouseOver"], 
              EdgeForm[{
                GrayLevel[0.5], 
                AbsoluteThickness[1.5], 
                Opacity[0.66]}], {}, {}], 
             RectangleBox[{2., 0}, 
              NCache[{4., 
                Rational[13, 55]}, {4., 0.23636363636363636`}], 
              "RoundingRadius" -> 0]},
            
            ImageSizeCache->{{39.49641500276842, 
             56.492830005536845`}, {-35.049331174236144`, 40.31655449248589}}],
           StatusArea[#, 0.23636363636363636`]& ,
           TagBoxNote->"0.23636363636363636"],
          StyleBox["0.23636363636363636`", {
            GrayLevel[0]}, StripOnInput -> False]],
         Annotation[#, 
          Style[0.23636363636363636`, {
            GrayLevel[0]}], "Tooltip"]& ], 
        TagBox[
         TooltipBox[
          TagBox[
           DynamicBox[{
             FEPrivate`If[
              CurrentValue["MouseOver"], 
              EdgeForm[{
                GrayLevel[0.5], 
                AbsoluteThickness[1.5], 
                Opacity[0.66]}], {}, {}], 
             RectangleBox[{4., 0}, 
              NCache[{6., 
                Rational[6, 55]}, {6., 0.10909090909090909`}], 
              "RoundingRadius" -> 0]},
            
            ImageSizeCache->{{55.492830005536845`, 72.48924500830526}, {
             4.993838030921879, 40.31655449248589}}],
           StatusArea[#, 0.10909090909090909`]& ,
           TagBoxNote->"0.10909090909090909"],
          StyleBox["0.10909090909090909`", {
            GrayLevel[0]}, StripOnInput -> False]],
         Annotation[#, 
          Style[0.10909090909090909`, {
            GrayLevel[0]}], "Tooltip"]& ], 
        TagBox[
         TooltipBox[
          TagBox[
           DynamicBox[{
             FEPrivate`If[
              CurrentValue["MouseOver"], 
              EdgeForm[{
                GrayLevel[0.5], 
                AbsoluteThickness[1.5], 
                Opacity[0.66]}], {}, {}], 
             RectangleBox[{6., 0}, 
              NCache[{8., 
                Rational[2, 55]}, {8., 0.03636363636363636}], 
              "RoundingRadius" -> 0]},
            
            ImageSizeCache->{{71.48924500830526, 88.48566001107369}, {
             27.875649005297888`, 40.31655449248589}}],
           StatusArea[#, 0.03636363636363636]& ,
           TagBoxNote->"0.03636363636363636"],
          StyleBox["0.03636363636363636`", {
            GrayLevel[0]}, StripOnInput -> False]],
         Annotation[#, 
          Style[0.03636363636363636, {
            GrayLevel[0]}], "Tooltip"]& ], 
        TagBox[
         TooltipBox[
          TagBox[
           DynamicBox[{
             FEPrivate`If[
              CurrentValue["MouseOver"], 
              EdgeForm[{
                GrayLevel[0.5], 
                AbsoluteThickness[1.5], 
                Opacity[0.66]}], {}, {}], 
             RectangleBox[{8., 0}, 
              NCache[{10., 
                Rational[1, 44]}, {10., 0.022727272727272728`}], 
              "RoundingRadius" -> 0]},
            
            ImageSizeCache->{{87.48566001107369, 104.4820750138421}, {
             32.16598856299339, 40.31655449248589}}],
           StatusArea[#, 0.022727272727272728`]& ,
           TagBoxNote->"0.022727272727272728"],
          StyleBox["0.022727272727272728`", {
            GrayLevel[0]}, StripOnInput -> False]],
         Annotation[#, 
          Style[0.022727272727272728`, {
            GrayLevel[0]}], "Tooltip"]& ], 
        TagBox[
         TooltipBox[
          TagBox[
           DynamicBox[{
             FEPrivate`If[
              CurrentValue["MouseOver"], 
              EdgeForm[{
                GrayLevel[0.5], 
                AbsoluteThickness[1.5], 
                Opacity[0.66]}], {}, {}], 
             RectangleBox[{12., 0}, 
              NCache[{14., 
                Rational[1, 220]}, {14., 0.004545454545454545}], 
              "RoundingRadius" -> 0]},
            
            ImageSizeCache->{{119.47849001661052`, 136.47490501937895`}, {
             37.88644130658739, 40.31655449248589}}],
           StatusArea[#, 0.004545454545454545]& ,
           TagBoxNote->"0.004545454545454545"],
          StyleBox["0.004545454545454545`", {
            GrayLevel[0]}, StripOnInput -> False]],
         Annotation[#, 
          Style[0.004545454545454545, {
            GrayLevel[0]}], "Tooltip"]& ]}, {}, {}}, {{}, 
       GraphicsComplexBox[{{5.657936507936508, 0.}, {5.657936507936508, 0.}, {
        5.657936507936508, 0.}, {5.657936507936508, 0.}}, {
         {RGBColor[1, 0, 0], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->25], 3], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->25], 4]}, {}}], {}}}, {{}, {}, 
      {RGBColor[1, 0, 0], Thickness[Large], LineBox[CompressedData["
1:eJwVl3c81f8Xx6lkc+81S2Rnd0nZn/O2S5G4ZpS9CqWigawyklFCyqhUojK/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        "]]}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{
      FormBox["\"L1\"", TraditionalForm], 
      FormBox["\"pdf\"", TraditionalForm]},
    AxesOrigin->{0., 0},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    LabelStyle->Medium,
    PlotRange->All,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.02], 
       Scaled[0.1]}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[{{
      {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
       EdgeForm[Opacity[0.637]], {}, 
       {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
        EdgeForm[Opacity[0.637]], 
        TagBox[
         TooltipBox[
          TagBox[
           DynamicBox[{
             FEPrivate`If[
              CurrentValue["MouseOver"], 
              EdgeForm[{
                GrayLevel[0.5], 
                AbsoluteThickness[1.5], 
                Opacity[0.66]}], {}, {}], 
             RectangleBox[{0., 0}, 
              NCache[{2., 
                Rational[1, 110]}, {2., 0.00909090909090909}], 
              "RoundingRadius" -> 0]},
            
            ImageSizeCache->{{23.500000000000004`, 36.472789115646265`}, {
             29.635873917679724`, 33.48373876248842}}],
           StatusArea[#, 0.00909090909090909]& ,
           TagBoxNote->"0.00909090909090909"],
          StyleBox["0.00909090909090909`", {
            GrayLevel[0]}, StripOnInput -> False]],
         Annotation[#, 
          Style[0.00909090909090909, {
            GrayLevel[0]}], "Tooltip"]& ], 
        TagBox[
         TooltipBox[
          TagBox[
           DynamicBox[{
             FEPrivate`If[
              CurrentValue["MouseOver"], 
              EdgeForm[{
                GrayLevel[0.5], 
                AbsoluteThickness[1.5], 
                Opacity[0.66]}], {}, {}], 
             RectangleBox[{2., 0}, 
              NCache[{4., 
                Rational[21, 220]}, {4., 0.09545454545454546}], 
              "RoundingRadius" -> 0]},
            
            ImageSizeCache->{{35.472789115646265`, 48.44557823129252}, {
             2.58115789199708, 33.48373876248842}}],
           StatusArea[#, 0.09545454545454546]& ,
           TagBoxNote->"0.09545454545454546"],
          StyleBox["0.09545454545454546`", {
            GrayLevel[0]}, StripOnInput -> False]],
         Annotation[#, 
          Style[0.09545454545454546, {
            GrayLevel[0]}], "Tooltip"]& ], 
        TagBox[
         TooltipBox[
          TagBox[
           DynamicBox[{
             FEPrivate`If[
              CurrentValue["MouseOver"], 
              EdgeForm[{
                GrayLevel[0.5], 
                AbsoluteThickness[1.5], 
                Opacity[0.66]}], {}, {}], 
             RectangleBox[{4., 0}, 
              NCache[{6., 
                Rational[31, 220]}, {6., 0.1409090909090909}], 
              "RoundingRadius" -> 0]},
            
            ImageSizeCache->{{47.44557823129252, 
             60.41836734693878}, {-11.658166332046413`, 33.48373876248842}}],
           StatusArea[#, 0.1409090909090909]& ,
           TagBoxNote->"0.1409090909090909"],
          StyleBox["0.1409090909090909`", {
            GrayLevel[0]}, StripOnInput -> False]],
         Annotation[#, 
          Style[0.1409090909090909, {
            GrayLevel[0]}], "Tooltip"]& ], 
        TagBox[
         TooltipBox[
          TagBox[
           DynamicBox[{
             FEPrivate`If[
              CurrentValue["MouseOver"], 
              EdgeForm[{
                GrayLevel[0.5], 
                AbsoluteThickness[1.5], 
                Opacity[0.66]}], {}, {}], 
             RectangleBox[{6., 0}, 
              NCache[{8., 
                Rational[9, 110]}, {8., 0.08181818181818182}], 
              "RoundingRadius" -> 0]},
            
            ImageSizeCache->{{59.41836734693878, 72.39115646258504}, {
             6.852955159210129, 33.48373876248842}}],
           StatusArea[#, 0.08181818181818182]& ,
           TagBoxNote->"0.08181818181818182"],
          StyleBox["0.08181818181818182`", {
            GrayLevel[0]}, StripOnInput -> False]],
         Annotation[#, 
          Style[0.08181818181818182, {
            GrayLevel[0]}], "Tooltip"]& ], 
        TagBox[
         TooltipBox[
          TagBox[
           DynamicBox[{
             FEPrivate`If[
              CurrentValue["MouseOver"], 
              EdgeForm[{
                GrayLevel[0.5], 
                AbsoluteThickness[1.5], 
                Opacity[0.66]}], {}, {}], 
             RectangleBox[{8., 0}, 
              NCache[{10., 
                Rational[17, 220]}, {10., 0.07727272727272727}], 
              "RoundingRadius" -> 0]},
            
            ImageSizeCache->{{71.39115646258504, 84.3639455782313}, {
             8.276887581614478, 33.48373876248842}}],
           StatusArea[#, 0.07727272727272727]& ,
           TagBoxNote->"0.07727272727272727"],
          StyleBox["0.07727272727272727`", {
            GrayLevel[0]}, StripOnInput -> False]],
         Annotation[#, 
          Style[0.07727272727272727, {
            GrayLevel[0]}], "Tooltip"]& ], 
        TagBox[
         TooltipBox[
          TagBox[
           DynamicBox[{
             FEPrivate`If[
              CurrentValue["MouseOver"], 
              EdgeForm[{
                GrayLevel[0.5], 
                AbsoluteThickness[1.5], 
                Opacity[0.66]}], {}, {}], 
             RectangleBox[{10., 0}, 
              NCache[{12., 
                Rational[3, 55]}, {12., 0.05454545454545454}], 
              "RoundingRadius" -> 0]},
            
            ImageSizeCache->{{83.3639455782313, 96.33673469387756}, {
             15.396549693636228`, 33.48373876248842}}],
           StatusArea[#, 0.05454545454545454]& ,
           TagBoxNote->"0.05454545454545454"],
          StyleBox["0.05454545454545454`", {
            GrayLevel[0]}, StripOnInput -> False]],
         Annotation[#, 
          Style[0.05454545454545454, {
            GrayLevel[0]}], "Tooltip"]& ], 
        TagBox[
         TooltipBox[
          TagBox[
           DynamicBox[{
             FEPrivate`If[
              CurrentValue["MouseOver"], 
              EdgeForm[{
                GrayLevel[0.5], 
                AbsoluteThickness[1.5], 
                Opacity[0.66]}], {}, {}], 
             RectangleBox[{12., 0}, 
              NCache[{14., 
                Rational[1, 55]}, {14., 0.01818181818181818}], 
              "RoundingRadius" -> 0]},
            
            ImageSizeCache->{{95.33673469387756, 108.30952380952381`}, {
             26.788009072871024`, 33.48373876248842}}],
           StatusArea[#, 0.01818181818181818]& ,
           TagBoxNote->"0.01818181818181818"],
          StyleBox["0.01818181818181818`", {
            GrayLevel[0]}, StripOnInput -> False]],
         Annotation[#, 
          Style[0.01818181818181818, {
            GrayLevel[0]}], "Tooltip"]& ], 
        TagBox[
         TooltipBox[
          TagBox[
           DynamicBox[{
             FEPrivate`If[
              CurrentValue["MouseOver"], 
              EdgeForm[{
                GrayLevel[0.5], 
                AbsoluteThickness[1.5], 
                Opacity[0.66]}], {}, {}], 
             RectangleBox[{14., 0}, 
              NCache[{16., 
                Rational[1, 55]}, {16., 0.01818181818181818}], 
              "RoundingRadius" -> 0]},
            
            ImageSizeCache->{{107.30952380952381`, 120.28231292517007`}, {
             26.788009072871024`, 33.48373876248842}}],
           StatusArea[#, 0.01818181818181818]& ,
           TagBoxNote->"0.01818181818181818"],
          StyleBox["0.01818181818181818`", {
            GrayLevel[0]}, StripOnInput -> False]],
         Annotation[#, 
          Style[0.01818181818181818, {
            GrayLevel[0]}], "Tooltip"]& ], 
        TagBox[
         TooltipBox[
          TagBox[
           DynamicBox[{
             FEPrivate`If[
              CurrentValue["MouseOver"], 
              EdgeForm[{
                GrayLevel[0.5], 
                AbsoluteThickness[1.5], 
                Opacity[0.66]}], {}, {}], 
             RectangleBox[{16., 0}, 
              NCache[{18., 
                Rational[1, 220]}, {18., 0.004545454545454545}], 
              "RoundingRadius" -> 0]},
            
            ImageSizeCache->{{119.28231292517007`, 132.25510204081635`}, {
             31.059806340084073`, 33.48373876248842}}],
           StatusArea[#, 0.004545454545454545]& ,
           TagBoxNote->"0.004545454545454545"],
          StyleBox["0.004545454545454545`", {
            GrayLevel[0]}, StripOnInput -> False]],
         Annotation[#, 
          Style[0.004545454545454545, {
            GrayLevel[0]}], "Tooltip"]& ]}, {}, {}}, {{}, 
       GraphicsComplexBox[{{5.657936507936508, 0.}, {5.657936507936508, 0.}, {
        5.657936507936508, 0.}, {5.657936507936508, 0.}}, {
         {RGBColor[1, 0, 0], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->25], 3], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->25], 4]}, {}}], {}}}, {{}, {}, 
      {RGBColor[1, 0, 0], Thickness[Large], LineBox[CompressedData["
1:eJwVl3c81f8Xx6lkc+81S2Rnd0nZn/O2S5G4ZpS9CqWigawyklFCyqhUojK/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        "]]}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{
      FormBox["\"L24993\"", TraditionalForm], 
      FormBox["\"pdf\"", TraditionalForm]},
    AxesOrigin->{0., 0},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    LabelStyle->Medium,
    PlotRange->All,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.02], 
       Scaled[0.1]}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[{{
      {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
       EdgeForm[Opacity[0.637]], {}, 
       {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
        EdgeForm[Opacity[0.637]], 
        TagBox[
         TooltipBox[
          TagBox[
           DynamicBox[{
             FEPrivate`If[
              CurrentValue["MouseOver"], 
              EdgeForm[{
                GrayLevel[0.5], 
                AbsoluteThickness[1.5], 
                Opacity[0.66]}], {}, {}], 
             RectangleBox[{1., 0}, 
              NCache[{2., 
                Rational[3, 55]}, {2., 0.05454545454545454}], 
              "RoundingRadius" -> 0]},
            
            ImageSizeCache->{{23.500000000000004`, 31.482462773707134`}, {
             21.814801893568927`, 35.79913663643974}}],
           StatusArea[#, 0.05454545454545454]& ,
           TagBoxNote->"0.05454545454545454"],
          StyleBox["0.05454545454545454`", {
            GrayLevel[0]}, StripOnInput -> False]],
         Annotation[#, 
          Style[0.05454545454545454, {
            GrayLevel[0]}], "Tooltip"]& ], 
        TagBox[
         TooltipBox[
          TagBox[
           DynamicBox[{
             FEPrivate`If[
              CurrentValue["MouseOver"], 
              EdgeForm[{
                GrayLevel[0.5], 
                AbsoluteThickness[1.5], 
                Opacity[0.66]}], {}, {}], 
             RectangleBox[{2., 0}, 
              NCache[{3., 
                Rational[13, 110]}, {3., 0.11818181818181818`}], 
              "RoundingRadius" -> 0]},
            
            ImageSizeCache->{{30.482462773707134`, 38.46492554741426}, {
             6.666411360219641, 35.79913663643974}}],
           StatusArea[#, 0.11818181818181818`]& ,
           TagBoxNote->"0.11818181818181818"],
          StyleBox["0.11818181818181818`", {
            GrayLevel[0]}, StripOnInput -> False]],
         Annotation[#, 
          Style[0.11818181818181818`, {
            GrayLevel[0]}], "Tooltip"]& ], 
        TagBox[
         TooltipBox[
          TagBox[
           DynamicBox[{
             FEPrivate`If[
              CurrentValue["MouseOver"], 
              EdgeForm[{
                GrayLevel[0.5], 
                AbsoluteThickness[1.5], 
                Opacity[0.66]}], {}, {}], 
             RectangleBox[{3., 0}, 
              NCache[{4., 
                Rational[3, 11]}, {4., 0.2727272727272727}], "RoundingRadius" -> 
              0]},
            
            ImageSizeCache->{{37.46492554741426, 
             45.447388321121394`}, {-30.12253707791433, 35.79913663643974}}],
           StatusArea[#, 0.2727272727272727]& ,
           TagBoxNote->"0.2727272727272727"],
          StyleBox["0.2727272727272727`", {
            GrayLevel[0]}, StripOnInput -> False]],
         Annotation[#, 
          Style[0.2727272727272727, {
            GrayLevel[0]}], "Tooltip"]& ], 
        TagBox[
         TooltipBox[
          TagBox[
           DynamicBox[{
             FEPrivate`If[
              CurrentValue["MouseOver"], 
              EdgeForm[{
                GrayLevel[0.5], 
                AbsoluteThickness[1.5], 
                Opacity[0.66]}], {}, {}], 
             RectangleBox[{4., 0}, 
              NCache[{5., 
                Rational[12, 55]}, {5., 0.21818181818181817`}], 
              "RoundingRadius" -> 0]},
            
            ImageSizeCache->{{44.447388321121394`, 
             52.42985109482852}, {-17.138202335043523`, 35.79913663643974}}],
           StatusArea[#, 0.21818181818181817`]& ,
           TagBoxNote->"0.21818181818181817"],
          StyleBox["0.21818181818181817`", {
            GrayLevel[0]}, StripOnInput -> False]],
         Annotation[#, 
          Style[0.21818181818181817`, {
            GrayLevel[0]}], "Tooltip"]& ], 
        TagBox[
         TooltipBox[
          TagBox[
           DynamicBox[{
             FEPrivate`If[
              CurrentValue["MouseOver"], 
              EdgeForm[{
                GrayLevel[0.5], 
                AbsoluteThickness[1.5], 
                Opacity[0.66]}], {}, {}], 
             RectangleBox[{5., 0}, 
              NCache[{6., 
                Rational[3, 22]}, {6., 0.13636363636363635`}], 
              "RoundingRadius" -> 0]},
            
            ImageSizeCache->{{51.42985109482852, 59.41231386853565}, {
             2.338299779262705, 35.79913663643974}}],
           StatusArea[#, 0.13636363636363635`]& ,
           TagBoxNote->"0.13636363636363635"],
          StyleBox["0.13636363636363635`", {
            GrayLevel[0]}, StripOnInput -> False]],
         Annotation[#, 
          Style[0.13636363636363635`, {
            GrayLevel[0]}], "Tooltip"]& ], 
        TagBox[
         TooltipBox[
          TagBox[
           DynamicBox[{
             FEPrivate`If[
              CurrentValue["MouseOver"], 
              EdgeForm[{
                GrayLevel[0.5], 
                AbsoluteThickness[1.5], 
                Opacity[0.66]}], {}, {}], 
             RectangleBox[{6., 0}, 
              NCache[{7., 
                Rational[7, 110]}, {7., 0.06363636363636363}], 
              "RoundingRadius" -> 0]},
            
            ImageSizeCache->{{58.41231386853565, 66.39477664224279}, {
             19.650746103090455`, 35.79913663643974}}],
           StatusArea[#, 0.06363636363636363]& ,
           TagBoxNote->"0.06363636363636363"],
          StyleBox["0.06363636363636363`", {
            GrayLevel[0]}, StripOnInput -> False]],
         Annotation[#, 
          Style[0.06363636363636363, {
            GrayLevel[0]}], "Tooltip"]& ], 
        TagBox[
         TooltipBox[
          TagBox[
           DynamicBox[{
             FEPrivate`If[
              CurrentValue["MouseOver"], 
              EdgeForm[{
                GrayLevel[0.5], 
                AbsoluteThickness[1.5], 
                Opacity[0.66]}], {}, {}], 
             RectangleBox[{7., 0}, 
              NCache[{8., 
                Rational[1, 22]}, {8., 0.045454545454545456`}], 
              "RoundingRadius" -> 0]},
            
            ImageSizeCache->{{65.39477664224279, 73.3772394159499}, {
             23.978857684047394`, 35.79913663643974}}],
           StatusArea[#, 0.045454545454545456`]& ,
           TagBoxNote->"0.045454545454545456"],
          StyleBox["0.045454545454545456`", {
            GrayLevel[0]}, StripOnInput -> False]],
         Annotation[#, 
          Style[0.045454545454545456`, {
            GrayLevel[0]}], "Tooltip"]& ], 
        TagBox[
         TooltipBox[
          TagBox[
           DynamicBox[{
             FEPrivate`If[
              CurrentValue["MouseOver"], 
              EdgeForm[{
                GrayLevel[0.5], 
                AbsoluteThickness[1.5], 
                Opacity[0.66]}], {}, {}], 
             RectangleBox[{8., 0}, 
              NCache[{9., 
                Rational[9, 110]}, {9., 0.08181818181818182}], 
              "RoundingRadius" -> 0]},
            
            ImageSizeCache->{{72.3772394159499, 80.35970218965704}, {
             15.322634522133516`, 35.79913663643974}}],
           StatusArea[#, 0.08181818181818182]& ,
           TagBoxNote->"0.08181818181818182"],
          StyleBox["0.08181818181818182`", {
            GrayLevel[0]}, StripOnInput -> False]],
         Annotation[#, 
          Style[0.08181818181818182, {
            GrayLevel[0]}], "Tooltip"]& ], 
        TagBox[
         TooltipBox[
          TagBox[
           DynamicBox[{
             FEPrivate`If[
              CurrentValue["MouseOver"], 
              EdgeForm[{
                GrayLevel[0.5], 
                AbsoluteThickness[1.5], 
                Opacity[0.66]}], {}, {}], 
             RectangleBox[{10., 0}, 
              NCache[{11., 
                Rational[1, 110]}, {11., 0.00909090909090909}], 
              "RoundingRadius" -> 0]},
            
            ImageSizeCache->{{86.34216496336417, 94.3246277370713}, {
             32.63508084596127, 35.79913663643974}}],
           StatusArea[#, 0.00909090909090909]& ,
           TagBoxNote->"0.00909090909090909"],
          StyleBox["0.00909090909090909`", {
            GrayLevel[0]}, StripOnInput -> False]],
         Annotation[#, 
          Style[0.00909090909090909, {
            GrayLevel[0]}], "Tooltip"]& ]}, {}, {}}, {{}, 
       GraphicsComplexBox[{{5.657936507936508, 0.}, {5.657936507936508, 0.}, {
        5.657936507936508, 0.}, {5.657936507936508, 0.}}, {
         {RGBColor[1, 0, 0], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->25], 3], InsetBox[
           StyleBox["\<\"\[FilledCircle]\"\>",
            StripOnInput->False,
            FontSize->25], 4]}, {}}], {}}}, {{}, {}, 
      {RGBColor[1, 0, 0], Thickness[Large], LineBox[CompressedData["
1:eJwVl3c81f8Xx6lkc+81S2Rnd0nZn/O2S5G4ZpS9CqWigawyklFCyqhUojK/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        "]]}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesLabel->{
      FormBox["\"L49985\"", TraditionalForm], 
      FormBox["\"pdf\"", TraditionalForm]},
    AxesOrigin->{1., 0},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    LabelStyle->Medium,
    PlotRange->All,
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.02], 
       Scaled[0.1]}},
    Ticks->{Automatic, Automatic}]}], "}"}]], "Output",
 CellChangeTimes->{3.5857641319350786`*^9, 3.5857648691142426`*^9, 
  3.5857649237333665`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
  "******)"}]], "Input",
 CellChangeTimes->{{3.4940977943255997`*^9, 3.494097801075859*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"i", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ls", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Count", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"SameCoalescentTreeQ", "@@", "#"}], "&"}], "/@", 
        RowBox[{"Partition", "[", 
         RowBox[{
          RowBox[{"rescold", "[", 
           RowBox[{"[", 
            RowBox[{"k", ",", "4", ",", "All", ",", "2"}], "]"}], "]"}], ",", 
          "2", ",", "1"}], "]"}]}], ",", "False"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", 
       RowBox[{"Length", "[", "rescold", "]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ls", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{"ls", ",", 
      RowBox[{"reshyper", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "i"}], "]"}], "]"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gcorcp", "=", 
   RowBox[{"Show", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{"ls", ",", 
       RowBox[{"AxesOrigin", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0"}], "}"}]}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
       RowBox[{"PlotLabel", "\[Rule]", 
        RowBox[{"Style", "[", 
         RowBox[{
          RowBox[{"\"\<Corr=\>\"", "<>", 
           RowBox[{"ToString", "[", 
            RowBox[{"Round", "[", 
             RowBox[{
              RowBox[{"Correlation", "[", 
               RowBox[{
                RowBox[{"ls", "[", 
                 RowBox[{"[", 
                  RowBox[{"All", ",", "1"}], "]"}], "]"}], ",", 
                RowBox[{"ls", "[", 
                 RowBox[{"[", 
                  RowBox[{"All", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
              "0.01"}], "]"}], "]"}]}], ",", "20"}], "]"}]}], ",", 
       RowBox[{"AxesLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"\"\<#VisRE\>\"", ",", 
          RowBox[{"hyperlab", "[", 
           RowBox[{"[", "i", "]"}], "]"}]}], "}"}]}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ContourPlot", "[", 
      RowBox[{
       RowBox[{"Evaluate", "@", 
        RowBox[{"PDF", "[", 
         RowBox[{
          RowBox[{"SmoothKernelDistribution", "[", "ls", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", "y"}], "}"}]}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "0", ",", 
         RowBox[{"Max", "[", 
          RowBox[{"ls", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "1"}], "]"}], "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y", ",", "0", ",", 
         RowBox[{"Max", "[", 
          RowBox[{"ls", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}]}], "}"}], ",", 
       RowBox[{"ContourShading", "\[Rule]", "None"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
       RowBox[{"ContourStyle", "\[Rule]", 
        RowBox[{"Directive", "[", "Green", "]"}]}]}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{"withdata", ",", 
    RowBox[{"gcorcp", "=", 
     RowBox[{"Show", "[", 
      RowBox[{"gcorcp", ",", 
       RowBox[{"ListPlot", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Count", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"SameCoalescentTreeQ", "@@", "#"}], "&"}], "/@", 
               RowBox[{"Partition", "[", 
                RowBox[{"truetreels", ",", "2", ",", "1"}], "]"}]}], ",", 
              "False"}], "]"}], ",", 
            RowBox[{"truehyper", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}], "}"}], "}"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", "Red"}], ",", 
         RowBox[{"PlotMarkers", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Automatic", ",", "20"}], "}"}]}]}], "]"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}], 
  ";"}], "\[IndentingNewLine]", "gcorcp"}], "Input",
 CellChangeTimes->{{3.5221927592314415`*^9, 3.5221927595614605`*^9}, {
   3.5221928783392544`*^9, 3.522192893694133*^9}, {3.522196018177843*^9, 
   3.5221960255952673`*^9}, 3.5221961776729655`*^9, {3.52219630118003*^9, 
   3.5221963118516397`*^9}, {3.5222538241430807`*^9, 3.522253824469099*^9}, {
   3.5226102104849815`*^9, 3.5226102129049854`*^9}, {3.529158143957693*^9, 
   3.5291581691673374`*^9}, {3.529158248197076*^9, 3.52915825598149*^9}, {
   3.529158680363696*^9, 3.5291586934365187`*^9}, {3.5291613099457207`*^9, 
   3.529161310398122*^9}, {3.529161723285822*^9, 3.529161724767824*^9}, {
   3.529163948961093*^9, 3.5291640601580887`*^9}, {3.52916548401433*^9, 
   3.5291654880843353`*^9}, {3.529165941620894*^9, 3.5291659474865046`*^9}, {
   3.529187984483182*^9, 3.529187989677991*^9}, {3.5291880243880515`*^9, 
   3.529188039395278*^9}, {3.529194883974588*^9, 3.529194940821088*^9}, {
   3.529195029210843*^9, 3.529195051862083*^9}, {3.5292004750329885`*^9, 
   3.5292005698655553`*^9}, {3.5292006242940507`*^9, 3.529200642156082*^9}, {
   3.5293373461517057`*^9, 3.5293373469161067`*^9}, {3.5293374594557047`*^9, 
   3.5293374618581085`*^9}, {3.529338092957217*^9, 3.529338098963228*^9}, {
   3.5293381606925364`*^9, 3.5293381653881445`*^9}, {3.529338677050477*^9, 
   3.5293386781736784`*^9}, {3.529339188283327*^9, 3.529339279574687*^9}, {
   3.5293418312946997`*^9, 3.529341855100341*^9}, {3.529341969869743*^9, 
   3.5293419969825907`*^9}, {3.5293424188865724`*^9, 3.5293424259616814`*^9}, 
   3.5293428840287395`*^9, {3.529343065488258*^9, 3.52934306643986*^9}, {
   3.529343143629795*^9, 3.529343146796601*^9}, {3.5293434313411007`*^9, 
   3.529343463586357*^9}}],

Cell[BoxData[
 GraphicsBox[{{{{}, 
     {RGBColor[0.24720000000000014`, 0.24, 0.6], PointBox[CompressedData["
1:eJx1VHswnHcUXYwgE0FeSJtGQgwa6r1o195pJlhBkqZKqe4kHhV5kGqkEzak
ZRu0Em1lPBalYWS63rTpIusT2bVI94UOod3FhqHTnYiJNsS0nXy/a/pHvpmd
b86c37333HN+3+47lfpOoiGDwTj/7++/94vHB+bF8RXN4kH2C+wN66y54R2d
AzR2A7tjBwzKSpQ09oNM2dr5y2sKNqkvj6LkGfmE9wBlrHdRHGIvqB/Ke6/1
E9LfH3QmKRWND0n9QaihCpJsTWg+Jxg6UlRr0oIZnP/tMmP6Uvg9Gr8JuqAE
ZaW9hsZM+KL3Lmur5j6NgyC0xc2mY+JXGrtAUWzDo3JTMi8AVhwUAUmrUzR2
gtCRM6qc7b+g/sn8rproEHLeEajKnIpF/hDyvDZ+2UKYCvszPV4rdu7RID4R
Yza1FNGEfj2Xerc/eWOcxp7QXKGKlh9V4v6FodbXGPo+1JPg9UqUeakY8/j7
K4FRRjXR5w6tZ+x3H7u64e+10M8mhV8S3gHE5XvivU7dQb22fbrh5Bgl6nu8
yfZprkiN89kNZqcXHIfxfFyp7KIp1YXz3++39Cyc7sc8TvCKDyY0DeL5Cx+3
G26TSGi8H4S6xaVs7kZ93mSIsnm3FOfP7ktp4JmoX8LbwJ77E2lcTR2NX4V6
SKvqbKVwnsPy9RFRbh/m4xHk9KxE2IvzuywPlCTakPNMoKIyA9M/uIf+xfcF
m5m7Er0BUDDw594srQz9GNW7ZPjUEuwLt2/VpllNy7CfxU7XanX2GPKcBN+Q
H1ekyIduiYH95mrUtzpufrihToJ43Ui7YHJUgn6mrq4Hp54m9zcMzEsVNW4c
Dep5uDQity8n/vvAHeHvy2x3kqc/JAbaTzDbyX0F2MpmrHCfjuJ9yOKsqnex
SL0n8CPqPu2+QOY5wTNjTbMotg/zSHrXKurKVfL9s8Dgu2zLy6JRPJ+f81Z3
5B8U6olOHqmbd3iAeQ0u9foadLRiHqkx1nOf72zDev3xgWiVE8nrbcg6O8Xy
SlChPxwP7x9OPhlCvZFFfkfknVoa24HAwH9+XLfBXy+IZE4dGsd8/49dYHPh
A/6NpnbknePTMwp7KPQ/iH+p35ErQ16Y+1xrTPXiPupFrt509if080bg3E15
uBj3y6vaEcdVbuzXtXm2f8yT8B4gjVDs2mYpwf4r+d8c4vgQP9mgYh8XVivJ
/oHQXdshjrEbw/zPZes3VQVN4j6ePFHWFokUeW+/dJnV6zLkj3w9NpOiakM+
szZcHmfciPMMa2J5xrYTL8Fe8L1rS1ucVov7f/jXOYGFQoH7tzSUX1zn/Ez/
XwMYHF6/lfiREvNx7jET/CaWYj7FKveT0jzyPTDBqFFXcCVMhv3qRYLkzsrb
6F/OzJRP9Nm7qJ+5LKgo6yD+scDGOlHw+JEC5zH2WgT6DVOol+B/ADGb7cQ=

       "]]}, {}}, GraphicsComplexBox[CompressedData["
1:eJx0/XVcVM/7Po5joyIiwoLksuzSLMsGS8+ICKjY3d2K2K1rN3aLiYqBiYiI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     "], {{{}, {}, {}, {}, {}, {}}, {{}, 
       TagBox[
        TooltipBox[
         {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl0bsrxWEcx/FHDDgYsKBImJgVZVQumxTl7hy3hUEyIgb3y5kNKOocl4nB
baJM6JTdYJL/AHW8ToZ379/n+/08zzn9ftWjM13TWSGEWbxEQljCK3KLQojn
hXBUEMIeH/IBSgtDKMGXWTbnYNl8JYPZtjyWH8IWj/MOj/I6x3iVo7zGm9jA
k3NRvxlDv+cL7uO03gCPuHsYcbnBrh675gu8iEF0u6dHpxffej+YQ0JO4hR1
evvOnXk+xyMe0IRm5OlXuiefq/hKt9GZSy6XK3Csd4Jinc9MtrvM3MUpHsQQ
buzT9rd8jXsE7/SO53WT/Gt/ygtYxLvcYtfpfAfaUWveZl7DZf7LhP2H3CpP
yZN4M0twyuw58v8d/wDp1UAb
           "]]},
         "0.25`"],
        Annotation[#, 0.25, "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl07lPlFEUhvGrECOyqGBjkEJBiEEhxsQFqCwsLGTVBMSoJCpYMIU4IwiR
RVAroXRhmRHFyqVRI4mNCPwBYilGS6Wx1Jj4u6F48pz7nnPP981MZndHoql7
QwhhAWs5IaRyQ7ibF8I9ZKnHZElObglhhG9jFOU4gi/5IbzVW+F3XC2rin33
K7ARZ+QJ2T71R3OzzgN8mjN8jac5jRl8Rg+uxx5SSKLF3E3uxw30oReXveMj
foyHmMIkEuYPee60505ha0EI3bIHcdZ5Egf177tfyEXYqV/PDTgs32HmGH+S
p/DS+RVe46iZGb299pVjD8pQihH5d/M/MK/+xo3mm9CMVtTIf8vruNa+Ftkq
vqJE/ovX8BNt+q1ox1mcQ1qeie+AWWzy+Z7wfr1KvLCj1+4a2ZB6GG3Iijs4
O+7kQe87hFtod+5054L6Is7jhGyXHcU46VzhvOzum/i98BIW8Q+XYmZmEQtY
xhKeujOHv+pnfNxcmv84Z/gUrqob4vO5nru4w9x7no/fr/1lKEWf/vP4+/M2
n/uA7IN6O/fEjItQiDpztdis7tQbV1/hfPfGZHcwIeuSFchG89b/C/8Bc0hj
4A==
           "]]},
         "0.2`"],
        Annotation[#, 0.2, "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl01tMjnEcwPGnjQv1ZrPpMIfpxcZsNjdcINLrGHPh5s1hKGc2pkRXFRe4
ZDPjwmyumCJkNhdUjPVWNi7kFNUmS81KziM+/7n47vs7/p/neZ/njZceWLc/
LYqiXuTEouh4RhRd44tjomi8eG5mFM3Da3En3qBP7y5/5Ht8nT+l2+Nu/sC9
XM9Z+je4T75VvAVN8jM80XUmYBYq1d67Tp25WszUn4FFWIlVuK0+YqaBi+Tz
eQF61Dbb/+ycYQzhK74gpd7JLfyWk/zbTrqdDAyoPVfr5w7+yb/wDT/wHXvV
R49l1xzF+/g8numd41JUOavYuQfVyjBHLSlvVb/CLXyZU7zWeQkUmFuMOrVa
5Omv5w1IokBezNvM7jC3Hd3owlL1ZUhgBZbjkrmUXmt4XsTDmeE5nXNS77Ta
qfBM4kz1EvfYr3dHPlv8SPwYw+E9ynvQFd6B2Xxki2/Zv4kT4kqzueIX/BKD
9prVh/gBD/BZbsT98N6RZX6E/+IPiuylqa3hiFdzk2s1oxEX5IXmEpiGqZiO
OCqcf8hOOY7gcECtgmPeU6HdTc7YE94h8uzs5l3YiSX6G/Wf2nkibseUcL/y
QXFOeC55Lr/iyXYmYaE4Hw/VO1Btvt05NXxM/yhK1NvU6rlKXo2a8FuFbyXc
N78L37p4nPgqN4RvHGUoR3bs/3/yH8tch48=
           "]]},
         "0.15`"],
        Annotation[#, 0.15, "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl1FdsjlEcgPG3dpe6MSJWJVZtQUtsNaNEl5EYcWeUWzEuUASJUdpSK+KC
IIQaLeXCik0IYlzha2mi1HZB/E5cPH3Of53T7/3O+6UuWJa9NC6Kos7+/E6M
okkJUfSLJ/ITPMbu5Cgq4D1JUVSGveigp6/cdLV+nM0v4qPoPG8Rn+XNfI4P
8zM8xRRzgziNd3BHe6WiEwaL6+TT+RPnmI3xV+4vV21dgznIddZfuTz+IK7F
ewyQ+8xDuNJcBmdwO07noRiCq+aK9V3jUr6OG/gibqoej2b4JG7MddyEG+np
zsn268Zp6IFD6n24L3qiN3pho3yt3kc+32XrIvNXeKTaKAyXH4HRct/0ZfKY
EKNQfEpPKrcxVyJXjMXiUvkE6+Xy9/g+KsxuFefho3o+z8QMjFd7pyeGt6hB
NS7Kj1O/Zc/byJKbglrzlWoPrB9iu54GzaNoGzfkWWpx/FM8wdxiPUtQgNZy
WeE5hO+bp2EqTqK92iaz1daL1OPD5xHvlz+AMuzDXoySz0IPfd1RbKYERdiF
nVioPl9tfXjW2IA54kKex2t5Lq/jkXqHOW+d+Li4K0/iLtzWeSvUj/MJHMNL
8Wf9+fxdPFbfN87kH9yBv4T7iXrMDWejXv6O+C5uh2eL2aiyz3u1GqwJ3wfH
wr22jszFoUrfpfCsw91TS3J+MhKRguZoK9+Em6IxVmIFVmMVLpiPhXeRK1GB
N+LTXI4z4R0UNwjvC2eYSUcr+7aQS8ER+Wf8HE/D/VEfhwmYrDaRB2FgwP/a
0myi+3BEfBQHzdzU98r6NXKRg2y5P3pzOF+ch03icnv0Sfj/G/QPeJSaQw==

           "]]},
         "0.1`"],
        Annotation[#, 0.1, "Tooltip"]& ], 
       TagBox[
        TooltipBox[
         {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl1WdsVlUYwPFTFZC2FNwSVyQxUeOixRUUHCgYZNVojJqozA92gZqIpXwg
QbEstUWGgialZSQEKBFQKRWMI1JpoUUKlCVNRAVxMC2Ivyd++Pf/rHPu+957
3tsbRxbnF2WklKr9Odw1pdezUmpCl5yUpsgvzkzp2m4pXYfPslP6Ap/jQ716
/hIbsBF1uNRcsmayPcowCefNNnCjehO2y38318xTcY3aPnlf8d/ifnxAfoO4
QnxYXCIuskch9qit4Blq17vmIr6ZP+ZKnDJfwaPNzeHT8g+4P54W9+Nn+EX9
PZxrbR4O2XOw/Fb9dvF4vku9N+6W90GlNc1m5vBi9SpMMLcb5Wo5eme4Ur0C
7+N03Me4p8iJPc105968WO8ScRX34DZchLnyKeZ/M1MvrhA/jxcwTP5YXF+v
GlVYghrcZu1wvp2HuvYwDMcg83fG81K/gzfxIrW9ce+xVJxn3eXiXL4snpNr
ZfM2bkFXZ6KZM3mh+TK9E2Yn86S4B/FZeSfvQityzGehh/gfa7pzR3xnnsW5
ejP5Z3mBtVvFP/l8jVytV8M/4Ih+A58yM5APynuJXxX3NzdbfFLtXT4TzxzP
6Z21Vxt38F7ej2Pm9vFraDG3Em/oT0SZ2uNxbrkkzgCWYgnGYhw6mf/LHp15
vrnBavN4rbxb3DM8IU+cgWnqtebf5r7yUr3zrnWQ/+UDvEp9JcbE709eww+a
34zj1j7AD8V14vvJ58cZwWrxVF7Fb8U9iGeCAfZ9FA+rP4J54rmYYe+B9pke
Z99cZjxXPCu/ytzVuBIX6vWM3436BeI/xRncyWxnHFcvt9/02BMn5bN5Fmbi
hDzbmj7W7JdvkY/kUXhZfIXeSzyGx2I0hpgdx3l8S5wLXhfnhNfzjngXWP8r
fonfnXxAPCNu1//E3Hfim+L9JC7QK4l7wAvk9WY+4g28EXXxXol3kZlj2Ixa
+SZeE59Xf1ScW+vPogP3qT+JLfb5CkdxBMVq483mi0v4KZ7AI+K9xcV4BYVx
zuO+xLnB9/qtXOSaxSgUH+UibjTXhK3Yjm1YbX4NzolrucXs1/FO4h+xAwXy
3bwTrfH7l+/i9+KdGfcVQzAUPdVL7TNN/Kl4Le6P84FyvIPlrrUM9+itxzL7
reMRyA/LD+EPM+28AMvRFs+Su9j/3njXyFfEmce39j3HpfwmJsY9ln/DDebr
sv7/f/QfYWb47w==
           "]]},
         "0.05`"],
        Annotation[#, 0.05, "Tooltip"]& ], {}, {}}}]}, {{}, 
    GraphicsComplexBox[{{19., 0.4}, {19., 0.4}, {19., 0.4}, {19., 0.4}}, {
      {RGBColor[1, 0, 0], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->20], 3], InsetBox[
        StyleBox["\<\"\[FilledCircle]\"\>",
         StripOnInput->False,
         FontSize->20], 4]}, {}}], {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{
    FormBox["\"#VisRE\"", TraditionalForm], 
    FormBox["\"r\"", TraditionalForm]},
  AxesOrigin->{0, 0},
  Method->{},
  PlotLabel->FormBox[
    StyleBox["\"Corr=0.62\"", 20, StripOnInput -> False], TraditionalForm],
  PlotRangeClipping->True]], "Output",
 CellChangeTimes->{3.585764133204151*^9, 3.5857648700962987`*^9, 
  3.5857649239763803`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"hyperlab", "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ijls", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"gcorhyper", "=", 
  RowBox[{"Table", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"i", ",", "j"}], "}"}], "=", "ij"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ls", "=", 
      RowBox[{"reshyper", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "j"}], "}"}]}], "]"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"gg", "=", 
      RowBox[{"Show", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ListPlot", "[", 
         RowBox[{"ls", ",", 
          RowBox[{"AxesOrigin", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0"}], "}"}]}], ",", 
          RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
          RowBox[{"PlotLabel", "\[Rule]", 
           RowBox[{"Style", "[", 
            RowBox[{
             RowBox[{"\"\<Corr=\>\"", "<>", 
              RowBox[{"ToString", "[", 
               RowBox[{"Round", "[", 
                RowBox[{
                 RowBox[{"Correlation", "[", 
                  RowBox[{
                   RowBox[{"ls", "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "1"}], "]"}], "]"}], ",", 
                   RowBox[{"ls", "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
                 "0.01"}], "]"}], "]"}]}], ",", "20"}], "]"}]}], ",", 
          RowBox[{"AxesLabel", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"hyperlab", "[", 
              RowBox[{"[", "i", "]"}], "]"}], ",", 
             RowBox[{"hyperlab", "[", 
              RowBox[{"[", "j", "]"}], "]"}]}], "}"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"ContourPlot", "[", 
         RowBox[{
          RowBox[{"Evaluate", "@", 
           RowBox[{"PDF", "[", 
            RowBox[{
             RowBox[{"SmoothKernelDistribution", "[", "ls", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"x", ",", "y"}], "}"}]}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", "0", ",", 
            RowBox[{"Max", "[", 
             RowBox[{"ls", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "1"}], "]"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"y", ",", "0", ",", 
            RowBox[{"Max", "[", 
             RowBox[{"ls", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"ContourShading", "\[Rule]", "None"}], ",", 
          RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
          RowBox[{"ContourStyle", "\[Rule]", 
           RowBox[{"Directive", "[", "Green", "]"}]}]}], "]"}]}], 
       "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{"withdata", ",", 
       RowBox[{"gg", "=", 
        RowBox[{"Show", "[", 
         RowBox[{"gg", ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"truehyper", "[", 
              RowBox[{"[", 
               RowBox[{"{", 
                RowBox[{"i", ",", "j"}], "}"}], "]"}], "]"}], "}"}], ",", 
            RowBox[{"PlotStyle", "\[Rule]", "Red"}], ",", 
            RowBox[{"PlotMarkers", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"Automatic", ",", "20"}], "}"}]}]}], "]"}]}], "]"}]}]}],
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", "gg"}], ",", 
    RowBox[{"{", 
     RowBox[{"ij", ",", "ijls"}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.529337373670154*^9, 3.5293374359620633`*^9}, {
   3.5293374845717487`*^9, 3.5293374937913647`*^9}, {3.5293376027419567`*^9, 
   3.5293376820056953`*^9}, {3.529337804918311*^9, 3.529337807975917*^9}, {
   3.529338072957982*^9, 3.529338074720785*^9}, {3.5293381768853645`*^9, 
   3.5293381864637814`*^9}, {3.529339294800314*^9, 3.529339299792323*^9}, {
   3.5293393636588345`*^9, 3.5293393652656374`*^9}, {3.5293430894967003`*^9, 
   3.5293431275461674`*^9}, {3.5293431965138884`*^9, 3.5293431966854887`*^9}, 
   3.5293434796543856`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"\[Theta]\"\>", ",", "\<\"\[CurlyEpsilon]\"\>", 
   ",", "\<\"r\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.5857641332211523`*^9, 3.5857648701213*^9, 
  3.5857649240083823`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{{{}, 
       {RGBColor[0.24720000000000014`, 0.24, 0.6], PointBox[CompressedData["
1:eJw9yXk8FHgDx/E5TBqV5FhRbTnWdpCSq934/nq8EqK2Uu5UjIqKjdLmrEVF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         "]]}, {}}, GraphicsComplexBox[CompressedData["
1:eJx0vXd8j9f7x5+EiBViU6s21VbNKtVz+xjValW1NatKqy2t2kpRLaW0Vs0a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       "], {{{}, {}, {}, {}, {}, {}, {}, {}, {}, {}}, {{}, 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], 
            LineBox[{4390, 5831, 5832, 4202, 4608, 4609, 4606, 6169, 6170, 
             6167, 4607, 6168, 5623, 5624, 5281, 5283, 5282, 4163, 5285, 5286,
              5284, 4302, 4666, 6255, 4169, 4942, 4561, 6141, 4563, 6140, 
             4562, 5138, 5137, 5136, 4360, 5356, 4687, 5925, 5926, 5786, 5787,
              6162, 4598, 5827, 5828, 5829, 4905, 4972, 4903, 4904, 4597, 
             6160, 4596, 6161, 4120, 5302, 4121, 5102, 5101, 4307, 4714, 4099,
              4846, 4745, 4746, 4390}]},
           "2.25`"],
          Annotation[#, 2.25, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl0Tss3VEcB/CfpQvSoi4JiyAhJe1ibeI1eExmizJ71XPxiOu1tI1IEBMm
dmYWUq/EazKyXSqSNkHS1Oemwyffe87vd37n5H9LvvS0dWdExDhXORGbiYgt
mt9FvMmLqCmMOCuIOGfKfpJqtc9qs37PMM2l+gV7+RGZ8lZPtsxi0owJTvQd
U+WeRvuFckx/r1y07pF/rbNyI0r1l1PGJ/tN6h9ls6wye1XPizc885Rmb9nZ
Dv0rcol2d628j9hXW5IHMmG/0px8WSHX5QZrfLPeNv9E7ym/zf3DB+fO1QcZ
YoARhrlR65df6eOH899JOLfn/l0azEqZXSs79V97e5est67jXs8vHkhxRy3X
b307vSlazGxNfzN3FFPEqBl3avckzf/pzkOO2LH36PyM+bNMM8+C7zMnb9Nv
51/B///9Fc6rURI=
             "]]},
           "2"],
          Annotation[#, 2, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl0rtPE1AUx/GjKAlWojxq0UjBAIKDSPkHHIjKDIqR6MLAUgIT6CwOosLE
wO5ggeogDi4+oiNhkkQSo0SCCSXykMUAkvBpHL753t+55557+7jQN9Q1eCQi
JtFeEXGnOiKdjFg6E/HgdESd9X2+pd6Nc/JZZPQ+rIzIqo3bn7Se4Ec1EaPW
Deq35Xq9Pfxd7QdGMIw1VJhx0n45dvXXywnrAi/yOm/zPO/wBn/j3/yHG839
wDPyG57lj9zH73maX1ZF5PidfNSdu1zCe9ysfsO9nciaNaE+wKvyL0xhBT+x
cyriYvEMmnAJLXiuP+GOu87ew195gS8XZ6ciWrmTU3zFnDZksKynV2+t7+u4
9Xku5TQf45t8nbv4GnfzF28oWL/GHF6Z+dTv9AxtZnV4R6b4OeRxLLn3K4b0
PpazZozxZ+9+wq16rzpzgH/YR97MT/bf2ss79wI5lKlXe/cmtpCQaziFJE7I
G9yvtzb5/790CNwGU7c=
             "]]},
           "1.75`"],
          Annotation[#, 1.75, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl0ktsjGEUxvFjgYSgnWmnSCoRNmb0IpFakhBxnV4itCJpZyzEho00KRIJ
sWHVBTYS6rYQsaGT6KYrFFOXlmnasNCuWJKqaEJ/Xyz+ed7zvOf2vfnWF093
nFoUEcNYkYo4VBNxGEfwT7yzNmJvdUSneB/dJS5VRazLwH2GX0/rxYvTEWvF
a5DGR/l/6yKm1cy6n8MvjMor4+eqiA/yxvA+ycc4hvS/Qp/Rq8lcNTNyR8w5
uDoijwNoQyvumzNizis8x0u8QLgbVjOrtuh8WV7O3CzO6F3Rt4//0PmH836k
5PfyLvIK8i7RZvEWNKLKfRM9ye9034V5fTO8P/QWfarPIErYbP8HvAaaw71k
X9zFHQwgo65d3912HrPrV+dptPILavJ0jze8yesRd+MYWvhZ/gn+jHiJeCld
huXIir8lc2mdvH47f0/eEHlMoIJ3Zn7BY9/yCMflF+UXaIkO0Cf0Nh2kG/SZ
t+uoeEr8ln6mr+kELdNxWsEnvNF7Cju8x3a0qE3J2UbTSQ87TKJL34323co7
SiflnuddcHeOdtutByvFm7xbDlmcdXed3sA1/FY7h0b1DSib3Zz8e7x+9e20
Db3qOmr+//cLQ4ZwKA==
             "]]},
           "1.5`"],
          Annotation[#, 1.5, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl00tIVGEYxvHPknQR5NRMIQQSZVRU00UhGgsMMrtYNgVG5WgaQYssimiR
uoiKFs6M0aZFl02Nq1YF7VqkXUncBF0wkgKrTZtWdrPfR4s/z3t93jPnMIu6
TmZ7ykIIo8jOC+FzIoSDdIpm54bwek4Ix+Rv6D66H5N6DckQZs4PoRwJc5vl
m1Ce0lsQQgYb0aT21MxWWmsvqf+oKoS8vIgCUvJ6vkl6wuw38ZC5EmrkO+hO
bMdRnt145uYy8+f1f5gf4TOMU+qN8i14KX6BavE9mjY/Lf6LUV6v0OKZ+u3d
1nuu3idu49lLx/Dd7y6YKyKPqxjELns36S3cwAPPdB8ldy7iEprNXKGXcZb/
bn57MOhOg520Oxk6pf8bf9Bhp8ZMu/phTCOYO6N3GnvtfjBznI7TVppDO8rM
zUBRXMAFDLhbwaMSs+L7tNPoOQ+on+OXki91bzlWYFytV79TPWe+Ex3x/au/
pe+ij7k78ZvyaHGjiT7WH45+8Tvik1om/k48UR9BrVoivmP+/TgSvye6sZDf
JN8vmI2SfAgD9vKo8Dxf1VfZW4lmXtfVt9G75ir1JvARD9UW86y3cyi+SyyR
52gdXY8+M+/trRN3qa+la1An/olquxvc+SXuQatbE7hmr0hXJ///X/4B6HRt
VA==
             "]]},
           "1.25`"],
          Annotation[#, 1.25, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl00dI12EYwPFXs0NBmaPyFCo5oGEUCQbx1/JcEbYoL7bUtgZBh5Iy7BIF
DZBoWB3Mhh7CMDAwMhtQNmyQG6TUBl0al+jzo8OX7/M+7zPe3x/NKNuzendc
COEvYtNDKE4KoS4lhOModC6dGUIR56SFkItsvJuhJjmEU9P08Uk+mhpCLTr1
deGSnsvoFW9TH68miOMQjxP2JPAELHZXzPkcZ0ZAq/vn+n/K/8JZe85hMjai
PzGEbnSqeYSHeIwu3NL7lJ/hCd76hh7kmP/A7Gw+6E0d4h9mjzi/F3/ANr0v
ze/GHbTru49Gc5pwHfVqmrkFN3E72ok/3vPGvN/8ml+h3ezD+muwzM7laJFv
xj77Rp2ror3Yihr138z6jq+4574NpfLVfvv1clW8gavVl3jLOvEO8yuxVrwC
5eIKrBSvQoN9X7jArHHO5Z36d+GCu0W8z9yFvMmuuWrmYQ7yMB+H5De734Lz
ejLl8s3J4Bt+q175Ppxxl+Bd/eIGPfXuJonHMFG+xzlNzUw0iafKT8E4Fnhz
HuYj0bnR/AHzh7Db+wb5ihmn+Srfjb6dl0Z/c1zJF3kJd5h9j9vQikr5vdFv
E72Nu/kYv+A+rlE/Fu1yPsLDnKIvGbnekoMsDMqPuk+N9kX7sR0V0WxcM6fM
d8fUFmLINwxjMPqtEPMdhUgXZ6stNz+LD3CM96NEf5b7NbxXbYY5A86ZXCf3
2Z7ZzklIRrl8P1dwKqcgXTwLH73zk/oR1NpR5FwgjiX9/5//B6b6k+c=
             "]]},
           "1"],
          Annotation[#, 1, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl1FtMj3Ecx/EfLpxGoeKCJjZucJVDDi0bNeZGKVTYTKzpwNAFOSSnymkm
OaScmouunJacZjF0Yc6bjTlt0my2VrhheD1z8f5/vofP8/19/8/z/P9JK0sz
S3qFEBJ9FAwLIW5oCLEJIcTTQTQGg6McD2NCqODZgflxIcxDcWwI3+kPdCN2
SAg9NM3141wzm46n79QHjAjhPe1L+6MfyvX7x+vhvrn30IbL5haorcYV+VW8
d34T/wc6x8xrasX6Rdg9PIRq83bRSvlW59SLyyNVz+JfhD1629R20e10L63h
K6H76QEUqpfKW8y/jnr5Cucux1r5KfkUepC3lq9S3ig+Ks5zRi667Hib/w4K
sAqvcc332sy3BTfNSOfNwAu9l6jDGZ5L9BxN58tALe8x1KGv3m+1X6iXH+Gb
Ip6KyZHaZ4ZnMB0pGClPsV+I+vJ1+OLMTpSKG8xoRBlfBc8OnJNnyTPFC2ku
zabn1S+gCTnyPPUlNNs9XhzdN+cspetom702mX+UbqS1tIw20YX6mXhjh7fY
rhbje00wZyKKomeCYrzTG0UTcYj3MJLV/mAn71+6Hs1YJu9w7+/Z4TPNl28U
b8AoO5e49is9KW+2e6Ezn9A78t5264NUcybxjOEdi7tqHWpdat34Yo9OnNE7
i1l6aeozaaO8AR36n9GuNtoOSXiq/gzPkc//ir6Mnj0G2mMMTzL95LpW+9Sp
H8cJzI3eleh9VP+o30Ib+H/avUccI74lbsUNXMdF9Zt0Jf8+WiE/LW5AjpnZ
+OYe1UTvPqpRhQfRb5x3gV0e6/9Ra6dV6nuQKp+FVJ5pUUwr1ZfaIQ+5eMTf
Ec2iE5yzRX+4eQnimfw/xGvi/v/n/APaFqct
             "]]},
           "0.75`"],
          Annotation[#, 0.75, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl1XlM13Ucx/EPpluUB2ri2eFflrM1NyekaYo5ITHFA0wKUyssBWetBgmS
lAdZK7GsaLUy88iDw1aWV5lT0Yb2R8c/Vl61DhPQVAi1x2f98fT1fb3Pz+/z
+/6w/+wFkwsTQgh1/undLYTVmN4rhEraiOFdQzhPL6AZTViWFMLs7iEspc/x
i/AoPwcVYsX8es+5PUN4CNMxAw+ir9mz1OxNDmEPRondi3x7ltAXUI65arLN
yEGzXGd9TTRRPEnsejpP/5PYpX4nasU23BTCRvys5hfcILaDv5E+bsZnnk+I
f0w3YY6zbqZbcFL8FDqp/YHvSOfLv27v53QHksW+oDvxhngB7Sy2R30Xmm/H
bs+nzdlGt6KyRwjVtAZnxH9FV7Xb+SQ6hF9jViF9k6bQVNxldp3eWqyJqr4O
v8nN97m76d0UvzOfvUBfsZpCWiNWjQw16fF+1JfKlWCXngb+GL5FlbrEeE/x
Tj2PNz8TE9BPrEzPVc/XMBQpSMXN9iTIXYd26Mu3ifehV+gps17DefsvYEm8
C7vLaSlfgrN8D2cfoG60e7vNvv5I5+ehvfyn8uvM/whTMA1TsVduqpopKIj3
x6/yPMfcdnq+5BeZeVzuJ3TgB9Mn5OciH68666D47qpr60LFqjzvV1safwPO
WkI38E1yG+kzZj+Le/gRGInTZpyJvxvkYIT8yPhOxrtHnr7ddCZNky92jiIs
4HNpIT0q34BE+VvtnEbfodnxHVBTi03qcswd5tzZ9G56RM9h1ONF+eO0kSbr
W0HT9WXggNrR/DnxUXQh7SRWq74OWWL3mTmJVvM18TtDOQaK/SN3By3jn8cx
/igWe+5o/gyzFvK5dJjYcPzoTlvEWnEJh+Qu0np6mR6k98fvxj23R5HPu96O
Rr3f8d+jhS9y1qfi3xq1T9Mj4t+gpxnJOCfWwTtxi3mHxP/mD9LDqMcD/ES9
E+gWszfHd8SuBKQgX26i3DbxrfHs9mWJZ4pd44MdbfQqrqDV5/pAbC3ex3J7
P6STaZZzVMR32Yyhcb76VKzlq+x5G29hktpMtevsGMTfiffUvIsGXLQjT9/D
GGNOGpbp+cues/gdf+IPrFT/Fd0X33vsx9fxdxPvV994jEMG0nFA/Unzx5pd
qW4V5qvdxz/mPH34ZtqLNtHeNEH+dhroADowvg/4RP6yvu20hZ4wd7n4CizD
S6jAeH2z4n3Z38/+IXRw3O9zj3UPj8jNxCt8Hn2ZrsQ4ff+qb8UwdWn8UvEx
8R0Su4QyfnH8G9f9///D/gPUKP6M
             "]]},
           "0.5`"],
          Annotation[#, 0.5, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwlkLkOQVEURbdeYoohxvgDQ2FqUaDyA4aYCjxP+ByJRKtXilbU/oHCEEFC
JJYoVtY9+5x73s2LNo3q0CKpAh+7lIG0Uxr4pBznqUvK4hRZnyzBeUKWxA6v
dMR2fMANZurw8khvqEEdnjZp45AuzF2hDV3owJJ7C+7M2bln7uaWTsyuyLb0
1szMqA32jCD4eyOzIXzGMeZM8jFEyMZkYTzCJsTp53l3EQoQoGeQ+/GQXgkq
1GXI/3ZTP/AO33Gbb7dgD2VqK+45///qCzuAK/I=
             "]], LineBox[CompressedData["
1:eJwl1WlQl1UUgPGXVNxBQNPEUpaa1GkDLSqzRiunmdDSbM/MxrYPLSqBWNoy
lYmWuAKCtrqWmsu4YWpK07jjhCJo2ohCyqQlLZNZ/e704fG5595zzr3v6/++
pIx6aeiLMVEUnffP4s5RVJAQRZ/zIizEgsQoOoAL8VH0dJco6m08WU6TtQr+
lXfweT7ESXymQxQlciN35O+4GbdAczTotU+feh6hZ4667klRdAVul/u3eLL5
i7wVP6vZwme5Ss1atZXc99Io6oP1WIfH1MaH/hzH9Tyb5+Bd/d7BK/oMUp9j
/LL1sfbsK54mvpHLrZ+Qv5nreBN3svZneDb+gzvyQLkf8p280Vyp/ctwk56D
9MziK/kqvGV9pNyzzrxc/g36ZqAbzstL5qbwjuS9Le8S7m2uTr+TKDb3rPVT
xs/wOHGKnMPGW/Wr5mN4Pszzj0jFC+LjvKWjMQqMT+gxhYus/WKur3364HV9
JqLMWq61Up5gj0ZnflKcb3wXpnieu3lApyi6g5P1S1bXlbtyhtzfubO4C78m
/7Iwxjw9x9tzAh4MPfkhrrBHL+u90Qbt0BZJ6ltxa7RAS8Rih/xMZ46z/zk9
4nmI+D5kI1M8mIfZr4X+h8XNuYZjuZr7c7r+t/Jt6Bfy9N2OjWoL5WzgGZzp
GTLQUr+Z4l7q0sTpuMb4WoxWH2t9uvV16tZjPCYgP5zJektuhbGeYRxycEhN
HufiVRwUt5YzSs90/ks8y/xszMGFcD8wH4vsvxhLsDOc27uoMb+Ba3kTj1dT
zkfFbfQ7wg+bewTzze8Rl/FHWIDO4jP6NWIpluGI3ntR7kyZ6jIw03z38P8T
3gt6qNuPiZ5zHzfJr+RJ4gNchVj7f89r7bMGDeryrW8yN1W8T1zk/T1nLslc
V3EyxpjbzF9jC74RV/r91dljutz9xqXqd6mZx7v5pJz3rNVxtvVJ5t/AVvUV
XGjtJ/XfGmd4jqniTF4of49z7sVO7MYuNLP+Ax/DUayRd5xzOVXPq9UWyOnJ
q8zVWlvNR3gFf4Uy6yvDvTVXgxjMddbT3mcRDxSnh7vFqRzn3GkczyXhXjpr
cfi98LbwW+Ms68PkD8cDeNP8cOepN9/Wfg1c70ynMNJa+/AdMteOz4XecuPw
hHGu+hGcxyvl3iInVV1W+K7wzVziLPNwWM1o547kXW8cw7Vcg6nh74Oc33CP
up7h98aPhnuDWc5dEe4Sz8FsrBBvU9tBTQKSkIihau8P345wv7mEi8PdCu+U
V2F5OG94z/jX/+lSXoYl+BJfIE/+XC7CYH2G4IzcXc5zmrPF9+JTfIIB4Rsq
Nw3dkYIeuCi3JtwvHHTeKhQab5d/Oa8O99hcP33744PwfeGh4R4bJ8uZyd34
kLxq/KNnSbiD8j7GWmct1GdGuGdoL+dxc2PsPy58P8Iz6/cZTzH/lJxRuE7e
+wn//x3/D++BI28=
             "]]},
           "0.25`"],
          Annotation[#, 0.25, "Tooltip"]& ], {}, {}}}]}, {{}, 
      GraphicsComplexBox[{{1., 0.4}, {1., 0.4}, {1., 0.4}, {1., 0.4}}, {
        {RGBColor[1, 0, 0], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->20], 3], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->20], 4]}, {}}], {}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{
      FormBox["\"\[Theta]\"", TraditionalForm], 
      FormBox["\"r\"", TraditionalForm]},
    AxesOrigin->{0, 0},
    Method->{},
    PlotLabel->FormBox[
      StyleBox["\"Corr=0.28\"", 20, StripOnInput -> False], TraditionalForm],
    PlotRangeClipping->True], ",", 
   GraphicsBox[{{{{}, 
       {RGBColor[0.24720000000000014`, 0.24, 0.6], PointBox[CompressedData["
1:eJxlk3k41PsCxmcxadAkFIpkuYqEVDht7zduXZ2Up1LZEmnGDaHFUolbZ6Tb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         "]]}, {}}, GraphicsComplexBox[CompressedData["
1:eJxsXXVYVE+4JgVEQMTGwBYLCwvlOxYGdosNdneLgS1id2AHxs/u7k5UsOhm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       "], {{{}, {}, {}, {}, {}, {}}, {{}, 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl0j1IVXEYx/HnNngp7TongYpLqZUgCS5OSoKbL5Q6BJUQlLeppVxzEBGN
MF8IWnxZUryRTg4K4r06p0ZRizU41Y3ARe1zcPjy/T0v///hcE71g2ed2VRE
jGCvNGLnUkQzf8hEnF6MyMnDegVs6+X5s14Df0p2+M3liGOMyRt67+WnfFtd
aXdXruJD9St5GE+SHVzRWzOr4Kx6EL/kRjs/+cisiVfV5fKBXC9/4b9lERNc
5H3+zXv8hzN2h/glXuC1/jQ2nZ3i4Ld85nkX5BTa1Y+du8Pv1MtmA+oZeUm+
6p5/8kO9G+qbqMMjdT3Pctp8xvkSnuWP2JJzPGc+jxqs63XoHcrfOa/+wQv4
6jmL/C2xe9vkE3utfMpnqDW7jlG5BwXn09zH/biLXtzDNefum00m7568N5rU
t9zdgBb3dHDR917R78K4nW6e4M7k+9h5Xnb+j/wHU+RRWA==
             "]]},
           "0.5`"],
          Annotation[#, 0.5, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl09tPz3Ecx/EPnftVqNzIpoMbKhc2Q6HCH5AcRswhp03DasUF48LhBtko
ZqtGN04XspXTuGVzY3Hbj/hxiUoz4sLjMxfPPd/v1+f9+Xy/n9+3ylqONh2Z
EUL4iuOJEJ7hKVJI5oZwsyCEVvXL/BBeoVG2IC+EUqQhHeUowxVz7XHWnifm
UrJ36jbZEvWkeiwnhOf6Uf6GWnkNWnEonmPfC+uP4nPMl6EUVfpxeTUP6X9x
o75LvYEvcx4Xesd8LuJdshJepO9Qz1PXow5Jz07nDKQhC5mYaXaT2c3xXGxE
E5Z6Xo71XGQjD4m41/wW6/PVlepO9WKe4LWydWhAleyY7LFz9vI+7EYL9mC5
fMxMhdmFKMca/SAeICeuyz7iA1L4hGb5Kr/banx3p/cYMP+J11t/KG8zM8jt
/EM2hXFMYiLeQ37bnjs4oz4nOx/fQZ3m3Sq4h5utd/N2znReBrJRghVmLsX7
o1JfzVm8lUfs2ca9ZkZkffyWhz1jKN7X2mEzA+pbmK3fry9WD5v7qe6I313d
yX/kf/Eb3fppnhXvaK4h/lZYJjtl/jSm9f36PvTG76ffYfaqPWe5Pt6b67jY
/H0z93AXLbIb8Zuqr1vbaU83X0MP3qBAlrR+gkf5JOfak0A2+uPfDhc66wAX
8UGew3PxOt6Va8x9UdfyFH9GChc94wKSKNavtN6V+P//+g81/3Xv
             "]]},
           "0.4`"],
          Annotation[#, 0.4, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl01toj3Ecx/FntakdcWGbw5QLG2W7mdqIEinCFhfmYnMhOc5cTGw2hx2I
2toicqpZM7Nlc7pw3FCalUgohTAWxnJaiCGvJ6v33t/P5/f7Pc/T8///J6zY
uKQoIvDnX0RsEJTGBcGh+CA4jE9yibwFmxHIHWjHQHQQ7ORtKEcXFsc4x2vt
vcOd8m/zIA/xVy5KCILUcL/rX0daOOtyrI3mM5zEHZzMc/gsxpjP8VjO5xTX
G4/dzn/xLL1oMr/mua6bGa5hFzrla+H9zJXOdnEF9+ni+YX8Es/Ri7fu0Y93
mG99HD+09xEeoEDXho/6Vo7kKPy1dkD+wwc5UdfOo/g053m+pVgjJ3OTfSfQ
jHy5HnWY4hnSEYdYZOgScdG5GeE7Nc/kS3JS+BnYkynfMN8MMUfrYpAtt9nX
570MIksuk8uxDinyeo7hAt6PfZjkmZZzrP4zN8hFrteDAfMHvEeVnMpv7Jnl
vmnmXGcyeSqSrSchR1djTy1q9LWYHL5D/SY061twEsVyK5fxKd7Kja5xHA2Y
7uw0lOizuJSzebXr5Vo/jwsolhfxQizAKvm7fT/wLXyG8Pvk7FX3mG1u0T3h
9PA7Fn7O6LX+Cs/0Gfqn/Mt77NH95Fx75rl2t76fI/XxuihO4CM4im75NoZh
uDwSI5Dq3H3nJvIGLkS1+Rav5GPc6EyRuZqrwvtimXzPWj3f5Treq9+DxyiU
r+h38GXezpX6CgwhT24I3334u47//9v/B6xUjtU=
             "]]},
           "0.3`"],
          Annotation[#, 0.3, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl1FdsjmEUwPFHglitlUhIrNgkqmLvVtUqQZAYNWpeqRt7BCHWBeWCICIu
JKKEiD0jQVApidKaiVWrZhU1f09c/Ps/5zznnPd9v+/t1zQre9ScCiGEZH+m
VQthe/UQtmFzjRDGyjfxFhxNDCGHn3Ij9aGcgSEYjmHIV2/FrTE6IYQxqKh2
zL7dOGv+HM5ghfor56/xAsV4iR36epnvje/6yvEDt/Q3dt4k7o33xpXUcvVX
5rWczROcTUQm9qhVURsnHo807MQApGONs8t8FVfQN+ZmFrr2IixAJ/liLnVW
KL7NzfW2wH15UXwutQf8EJ2xBiVVQ3jEUzAVDdDKTGtsFLc1U1/cjvvbn4ZU
lMu/OP+M9uJPvNWzbkEOfqil6GvMi+SLMRhD8NE1n+CtvTecv+E8fsfn+aZd
F3i4/CI3s6c49phN4pEYgeDsD1fgIj2/xaNQJu8j7xvfATMNkYFS13yB5fbP
RUu9l/Tmi0/xpVhXy8Y3eT/zf8VZOIHjeI4L+pbatwQ99XzU+4H3yVPEp8X1
9awXl6ht4PfciW+YX8fXeC1fj98/d9SfZy6ZE9X6qJ2ST5KvkBfzM7VktY6Y
Yd9M1FU76awOT5dPw0HkIl3tbPwMnOegjVomr7RvFRKQJO+AA/pe+2zS9bzi
MhSo3UG/+M5hOybbeVFttni+3nlYpvaYU+2px015tfPD4iMI8TvCLPWdZmfy
Lt7PXbjEfGd+z135HXfnHuiGD/K/7ueeuBB3scG+9biLAtyLz6OeiBqohZrx
/91s3fgbEN8vroPa2Cv/becg8WAMjO+P2jf3VIYkcSl/xS/xAOc/OZ3z1K7h
Ogrid+vad+I7wD09b1F8t1EYYxxSf2suS09Bwv/fr3+YnrKM
             "]]},
           "0.2`"],
          Annotation[#, 0.2, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl1GtMlmUcx/FbfOHCY5mneVhaWOkLxVOetzJFKMXA8rQlnoVUBJunpqi1
oZLoRtp0KlORSrKWZ+VFGrg8gSgtCzxvIp7WWp623PJzrRdfvtf/9/9f1/08
9/1wd56amTKvQRRFn/nTtVkUjWkaRR/g2QtR9FvjKPqXE5tEURJWIxf98Y/Z
ATzUbAUmxEbRz7JZslbqG9ZtZR2ckW59wLojH+ROPJ//MpfH+bweG7BDvcAZ
2cjCl+pz/CH/yHN5PB/HCZThF2x0nU34W3+Zc5YjBxdky1xvOS6pM/RTOBWr
ZWvwufUXeEWvtbNWWa/ECgyzP9dMnHWx3idmdvO3uCL/hq9ya3mC2Urrkfwu
RqBCPZxr3MckPq9+jxMxClXq97mN/det9zjvGpfwdxjiuoNRa3+cvMzca1zO
1fZdxDBz7+BtnJTXc4w9DdAZg8z0CudwS70x9idjiHoVj9MbjyN6jewfxx9h
L77HTWzDdiSgOuT2PQm/EeunPNr+Ubhof3e9ar7m/KuYJJ8YfiPopvcmZuiv
5TzkhmeB12UPzOdZr8UaPApzsliuVS/l8zyJK8PzRRUKfI5TfBZncBofyyaj
SZh1RppscshxXbZNthW/q2erd5otQo3PtItruUV43iizLuZFqDG/kB/53nXI
ccZ/6o3yTfgaT2Xxspecs8LelcjBQPkB7EeM/g+yCl6MaWb/wAPZnzzVOVPw
ot5lWY1sC6aoN3Ma38U+vQ5835nt+Sf1HV6COnOlfIuPcZfwGzI3Qz0d/cJ3
Ud9BPZLNtJW1QxssMJ+NN/QyOSv87yLG3nJZkvn95vahi7ph+D/VT+e3wvnI
xzrEh+8S3g96GdbpWIxF6Ch7rPcED3Ev3F+ucuZYTg33BZXymTwrPDO0sn5Z
1pxboLf5BPlI3PVsitSHsDM8U+zAXHURzwnfKfwPWc/jr1CAQnUGlzmjHCfx
anjP8AkcD59df7u5Qtcutd6DEtxWZ+rPRxbuyT4N9xHZqNfvY19aeI64pV+H
m/Ie8hvck2/77H30+6JXuNeyeO6JsWaKsCu8y8JvQC81vBdQgqOucwyliHP2
ET6MQ/g19v/3/HMvt9mU
             "]]},
           "0.1`"],
          Annotation[#, 0.1, "Tooltip"]& ], {}, {}}}]}, {{}, 
      GraphicsComplexBox[{{1., 1.}, {1., 1.}, {1., 1.}, {1., 1.}}, {
        {RGBColor[1, 0, 0], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->20], 3], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->20], 4]}, {}}], {}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{
      FormBox["\"\[CurlyEpsilon]\"", TraditionalForm], 
      FormBox["\"\[Theta]\"", TraditionalForm]},
    AxesOrigin->{0, 0},
    Method->{},
    PlotLabel->FormBox[
      StyleBox["\"Corr=0.\"", 20, StripOnInput -> False], TraditionalForm],
    PlotRangeClipping->True], ",", 
   GraphicsBox[{{{{}, 
       {RGBColor[0.24720000000000014`, 0.24, 0.6], PointBox[CompressedData["
1:eJw903k4FAgfB3DHI+Qo1jpqRcimwx229+Vr9WYdxZYVkSRHJTnyog2pFoW2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         "]]}, {}}, GraphicsComplexBox[CompressedData["
1:eJx0nXmcz9UX/2lVKu0iVGixV/KttNwIqbSQNkqbQiVrtEihlCXJMmWpbI1E
TGYMss1mxmDG7GMMYzaMfcyMYRj59ZvPPM/7cc7795t/PF7u+/N+3+Xs99xz
b3t7UI93L6hRo0a7W2vU+L//2r8lB7Zljngx2GkcLnjT0Z231YuIMO2xgqfn
bfw+7dA283yS4LD3UyrjJqaa32cI/rXv5pW335pl3pct+Ls+a/qPW5Vj3p8r
uP2yF38YfHu++V6BYHnu5mtuuPn7GMd4NQ4XzHh1e6xgxqufTxLMePXvMwQz
Xv2+bMGMV78/VzDj1d8rEKzHm2bGm2bGm2bGm2bGm2bGm2bGm2bGm2bGm2bG
m2bGm2bGm2bGm2bGm2bGmybjzfxj1m9/pObIeDUOF8x4dXusYMarn08SzHj1
7zMEM179vmzBjFe/P1cw49XfKxCs17fQrG+hWd9Cs76FZn0LzfoWmvUtNOtb
aNa30KxvoVnfQrO+hWZ9C836Fpr1LZTx1nr7xV1vhRyU8WocLpjx6vZYwYxX
P58kmPHq32cIZrz6fdmCGa9+f65gxqu/VyCY8WZUrfcxGa/G4YIZr26PFcx4
9fNJghmv/n2GYMar35ctmPHq9+cKZrz6ewWCGW/KqY9Wjjx7Qsarcbhgxqvb
YwUzXv18kmDGq3+fIZjx6vdlC2a8+v25ghmv/l6BYMb7YBV9l8l4NQ4XzHh1
e6xgxqufTxLMePXvMwQzXv2+bMGMV78/VzDj1d8rEMx45z0aOnJjo1MyXo3D
BTNe3R4rmPHq55MEM179+wzBjFe/L1sw49XvzxXMePX3CgQz3kur+LlCxqtx
uGDGq9tjBTNe/XySYMarf58hmPHq92ULZrz6/bmCGa/+XoFgxvvRN6cevrhj
pYxX43DBjFe3xwpmvPr5JMGMV/8+QzDj1e/LFsx49ftzBTNe/b0CwYw3vUp+
/Svj1ThcMOPV7bGCGa9+Pkkw49W/zxDMePX7sgUzXv3+XMGMV3+vQDDjbbS/
Yc3glTUeY7wahwtmvLo9VjDj1c8nCWa8+vcZghmvfl+2YMar358rmPHq7xUI
ZrypVfK6poxX43DBjFe3xwpmvPr5JMGMV/8+QzDj1e/LFsx49ftzBTNe/b0C
wTOq3reu2t4Kq17/aMGB78cLDnwvUXDg/SmCWzd77v1bitMEB8YTVG2/JlbT
X4hgvg/me+CbmnS89Ytvdgm+at5DZ1s8v0cw7w/YT1nyfjDvBzM+MN8DMx4w
3wfzfXBlt592xgzNEzyy9vVdGuzMF0z/AvOdJ/0D0x8w3wczn+CmwV07J/6T
KXjslPofDLwyVzD9AdMf+/75VfrqgLwPzPvA9G9Qlfw7Ir8H0z8w7wPTHzDv
C/Bbscw/GPoCM/9g5h/M++3vx18W8c6TnUqlP2B+D2a8YN4HZv7A9PdIy7dj
j6SflO+BmQ8w3wfzfTDvB0MvPZ+/qNnUfqfl/WDmA0x/wbwPzPv+GRY8qW3F
GaE/MOsBZnxgvg9m/cGMD0z/wIwXzHyD6a/tX+Ofuh7LmHhO+BdMf8H0D0z/
wKwHmP6C6S+Y/oKZXzDz2en1j+965Cr0S4hg+gumv2DmF0z/wfQfTP/B9B9M
/8HML5j+g+n/6Y9is656uab0H0x/wXwPzPfAfA/M98B8D33A98A6nuG18/86
nmF/HyP0oeODEfK81m8xQj88z3qAdTzE6r8YoTf9vSSffkQ/sZ48z3qCoX+t
fwuM/gz26Tsbz7P6VcfLon361sb7aNf6P83EwxLNfKQJf9EOvVhs9amNT1p9
aeNduj3cp+9tfE8/HyuY9bHY6ltrD9h4H+16/DkmPpRl5iPHxIuyRB7q8eT6
2m180NofNv7JeLQ9myfrr+2RCMGsr25PMvZKqs+eIF7H+tKOPAVrezXPaXs1
z2l7Nc9pe9Xrv7VPwPQfzPqCGQ+Y9QOzvrad+Bzjs/YT7YxXfz9HMOtlMb9H
Huj+BIn9BL1bjP3D/Oj2CMG0W/vL2mc6vpdo2lN99iDvY/6sfWjtN9qhbzDt
fJ92fs/86P4UCKZd9yfI4FjB2h8tdtof9exJHd9L8dmXej6zzPuzffYsv9f+
qjc/Nr5IO/Nh443WHrbxRzt/Ov4ZJP1h/a29C2a+wMwXmPUGQw92vmy8kXbm
R9vXOT773cYjrT3P75kfPb4Cn32v46NB8nvmQ9vnsb527G3mh3bmj3boR/8+
1bw/w+c/aH8gR9pZbzte/f4Cn79h45W8H/kARn5ofyLW558QD2T99fMZglk/
68/we9bPPm/jk7TzvI1XWv9I+zsFPn+J3zN+7Y9ECGb81n+y8UvrT1l/Rccb
UwQzf/p7GeZ9WT7/y8Y7rT9GO/Np4536e0E+f0fHD0N88U39fKzPX7PxTtqZ
Hxv/tPNl46HW37PxUev/2Xip9Qdt/JR26Mv6h/hT0I8ef7Dxt8KNvxhh2mN9
/qKNl1r/UftvST5/UvtzqT7/UvtnGT5/k3bmi3bmR38vx4wv1+ePMh7mS48/
2OcvEp9EPtEOf1r/1cZj7fM2Pmv9XR1vjTc4S55n/cGMX/fH84cZr/5ega9d
9y/I+L/B/5/4a4zIL+v/an8xw+ePWf/O+kM230G35/j8K+0/ZPn8C23Pxhr7
PdXY71nGXrfxyALBjNvaw9iPrL/dH+d5xm/tWZ6HH+x+t7Vf7X63tUftfjf2
GN/DHkNe2/1ibU/F+uwl7Bf6Y/dfrb2i90PjBUMfdv+T38P/1h6x+lbvP8b7
9t+sPLX7UVY/6P2dRLOfkyJY+xvefo+Vx/Af4wHzvJV/8I/O50kUfaX5IcPn
/+r8lmifv2jzRaAfxq/t+Wizfx/vs6dtvNnuv2v7JsnEe3NMe66xD4JlfWjX
OETmX8frvf0+LS/nVc9XcvX4QgUH6Hur4LcuvrTy04E7Bb80tkbmXQ9kC+Z9
g6vmb7e8DzxnVHlo/e15ggP8iT9X4J4+X/F35gU5gj/87srbti1Ir6bvImkH
07/AeE5If8A8D+b79vk3p/V/eGVRqbt146ddot/LFXzjQ8NuG3pPgWC+F7vq
8t9e/Kxc3g/meTDvb521rGZF7Qr5Ppjnwbx/RuWzfef+crZaniQJZv7BvB9M
f+zvK285Eeva/CvzDWZ+bfvf8+NnDHmzxmO8D8z8gAP0v7aavxa5CVX0u1Fw
gJ+jBNMfcEA/LK3mv3ihFzDt0FdAPsYJDvDD+Gp9lCn0B6YdeuN9tNN/cEB+
xQjme2DWBxyQt8ny/uzocQOSU7KknfWx/bmlih9z5fdg5t+2W36gfX+XiVMa
18oUDH2AYzeMuKVN/72CWT9wn4YPnPuoXp5g6NO+H35jPddXyaNDggPy56g7
ET81dNgjadJOf8G08zzvp53+gOkPmPUJ6JNiWR/4OSDvEnz8z/NJj33R6atf
dks7eNlXdSfl/lYi2MoD2plP2ukv7fQXTP+uXbT26Lh7Tgr9gGlHXjAftNMf
MN9DXuzMDns/dnS++yyu9/N3Rp8SeQKmnedZL+QD85V76NzKrT3PCH+Caed5
6Jt26BtMO8/Tf9pZDzDtPM/80s78gxkPmPEgv+gvGP7petW8Gz7aXymYduab
dvgHTDvPMz7aGT+Y8YCRR8vv6fjJNZ+cF/kGRh4hTxkP7WDaoRfaGS+Y9QMz
XjDyBQw/guFX28736e+k5kMH7roIfypUMP0Fs55g1hOMvsBO1vtjiyT+gfzk
e3o/ban4U8yPzn+PF32h9ycyxf5H3mF/g+kXWMefC2R9kI/MF1jH34pMfM7D
yDfoDXsUfjlWZU/uE4z/hTzgfdj/vI/nwdAn9qz2p0/I75FfyCsrz5B/2Ltg
3o9/BMY+Zv11PDrOxFvjRH7hbyIf8edo5/1g6A15x/iQF7TjHyGvaef9/B7/
FPmEP2LloY0HWvlAO/0F83sbH+T90JeNz1l5Rzv8rv05z94Dw9/Qp5WHNn7H
8/Tfyisdj/PyJ+AHMPQI/+MvQz+sv/WPWX/sJ+QD8kDLi3DB2HfwMfRMO/MH
pj0gXzYKxh7led6HvrXfs/Ys8gZ5hzwCW/uTdjDyjO/zfj2eNNFf1v60+Qa0
oy+wX8HW/tP2smffws/8Hkz8Cv6y53l4P/QBxp+19i/yj/Eh75g/7Enmy9qL
tp14EPRIO5h2vo/9yPwgL8HWPuR53kc788Pvwchj7Bt+z/zRDr3RDj3wftYb
jHwGM79g3gdmfrA3oRcw7fAjGPnLeHie99v38TzzYzHyF4y85v20g2mHPpCn
zIfdb0He03/kNfIHTDvyEYw8hP94nvUA087vwdZe0/aih2lHniNfwdhrdn+F
3zN/FtMfsLVHwYwXeQ/W8jtJ2sG0Iz94H+sDxj5+L7R+l8eXEH8fLxj5CWZ9
eD/9oZ34Ge3QH+06PzrGxPO9fCotb/cI1vnSORIPBOv8aO/8oM1P1ucREyU+
qb9fKPFksM5XKxR9bs/TEb/k/Vqe5ZnzYNG+81fYY6wX/E5/dDwzyHdehng0
+lufjwnynU+x+ae08z0w/be/1/udoULfrJe2j/LMfmWQxEd1fo6X7wnW+VWe
/WL3t3Q+Yapg+Bd7Af0Hxq7Q+0fjxR7A3kLf6nz9HJOvnyP2mvZ3okS/wj9g
nX9YKP3D39H7V4Wi72hnfmlHn/F++BFMu/59suh35IfV/2C+D+b36H/m28aX
0PfMH/xAu9W/YPgJf4bx2vwVzR/jRb/xe9rRF7Szfva8nN3foZ3+8nvox+ZH
wH/IT/Qf+gjM+up8jKWiP+AP+I/v08739X7PeF+8GPmP/Qamnef1+YMaj7Ee
Or6RJ+18D/mPf8N+B/4W7dgHYNrRF9AXmPHyPP0B6/Mf3v659VfwLxgvmPkA
a33jtVv7n+/o+McioW/r7/A+nreY9+vzOfHCT3wPftPx/hRf/EbHX9b6sM5v
Xiv6Fnll5R/yjPHY/Sp9XilBMOvL82Bd/2CeTz4ib5kfi3W+cJL0D/sMzPzx
e+YLzPNg5J/FfA/5TDv2g90PsPsTYNp5H+02f5rn4QeL0TfwB+1gnT8dJfKe
+QLrfMYC0Z9g5g95r8/j5Ym9z/h1vnuh6EPasX/BOt+xwMSrCmQ8Nv5Hf6AX
MOMDs75gnV9YJP4J8T3kC8+DbbwPrM/befUZbD4y+g95gn4E23xkntf5+weF
v2jX50eLnY4Hefsv2n/dIxj7wPrr+Ms6f+iEtPM9+JH3IQ8s1vm+CdKOPLP+
vfX/7e91fYJE+T3Yxgf0ftUeXzsY+8juX/N92sHQJ8+D6Z8+H+TFE8DMD/E4
xmexzvdNknb4j3b4i3ZtL3r5xLTzvN3vsvtt/J736fhgrGD40+6X2fgF7dAP
GHkL5ns23mHj0TxPvAVM/4nv8n0w37fxX+wr+JF2sN3foh3+s/tb2Htg7EXG
q/cH98jvoT/asQN0/sk8eR57TPtjS30Yf4zx0874LMb+w9+08XCdXxpn4iPx
vv0tfs98gJHPFvN71t/u92G/kq8Dpl2fV1xq8k9DffYy7chnux9o4zP6vGKc
eX+0PA/GfoX/aWc+tT2+Vd6n5SfnHZN98SDbDkYf8jz0B2Y9wNgnYPjR7k9i
r4N1fut4sc91fomXz8rvmW8w/GjjUbZdn/ePlnZ9Hqum7IfY+BVY5y95/ojN
Z+V55Dl8yfxi7zK/Fuv900yfPY09x3pbjH2LvqOd/oMZn7U/sadYXzDzj32j
z0MUCf9hHyFfwfAP9gTrBUY+gqFPsD4PXCzyn3Yw8QPkI+3oGzDjQ9/SH6v/
0X/El2z+CPqG9bP5I1Y/0c78gFkP9BPy0caLkafoN+QhWOcj7DHyeI+0Mz82
P8P60/Az9gT0zfcs1v7+eJ8/DNbnixeZ/bMY0Qc8r88De/uLdn8P/tH5bza/
O17sfzD0z/PIS3veFf7S+//efqLeP4sw8bxUwdAfmPiS9X/AOh+jUL4Hf/E9
jT1/h/dpfyjXxOvyfPxr889pJ56g88nHC3/RH/wZXQ+nWPoPP4N1vbV48W+g
H96HfQnW54cPCv/Szvh1PNKrP4d80Pl0+eZ7Qea84HiRH7qegef/2POWNn4J
1udXPP/G1luz+5n2/CPt8AsY+ke+0W73G+1+v46HbpV2+IV2sI2HIi+hHzDf
BzM+3sfzYPqHvcx8ghkfGHlg603Z/UR7HsvuF9JOPId4K/JD29cZgqE/MOOz
8pz3I29phz75HvRJO+utvx/s2y8kHqv9Za++lD5/kyLyG2zrT+n91l3Sf+SZ
jh9nmf1Vr94W80M786Pz47x6XIxf5+Pl+/Yvtf4JFqzz6714sN3fpB15pH8f
Yd4f69v/5PfYf2C9XxMm9AKGnoj/6noL3vkKMOup868zBPM+rc9y5fe6/mqi
0KPNh8E+ZLw6vhkj+pHfgxm/zWdBf9E/HW/M9cX7eJ732fgj9ifv1/aiZ+/B
X7Y+J/YX39PnfULM+d1gcx54nu+8gM7vTTHPJ5nzukkmPjHPxBNCBdM/MONB
PrBe2HO063y1eb76dNh3/N7Wl6Od+C78os+bePmk1h+DvnX81+IYE++ON/v9
YQbHiL1r90d0PD9K4tHY4zZ+THvg+/HV4/X0M/Eu+oc+Qv/b/BVbH4r9O+xr
nme+bXwGecb38M/pr/XPkT+06/yNcN/+FfOl69lsNPvXG438WGTyITz72+4H
WXtbnxfJlPXT+yfxZv8jXuwtnf+G/bdL5J3db9H78d7+CvOt5U2E2T/w9jP0
/lSem/LNd3VijpCvlS/8q/1hD6PfwPp8YJH4w/b8BvYa2OaHWPuQ32NP6fMc
5OecEAx9Ey+w9T50vNw7r8V4rL1Juz7P69Ufhn/0/lKpOV/mxZ+tvcjvsQds
fBn5yfrDb9Av7dCLzUcG03/4F31j85Gt/Wnjw7Y+q67vlmKe92Od/+bFf7F/
9PMeRn5oeRJr8uXSfOcnwPCLju+G+uKd9ry+1g/bTHw1ycRfMwQ/PKPplM8/
/U+efvlbn5fv987P23gt8gx+1fIt1hd/sOfTadf5w1kmfzfLyKs8adf+eKLP
X7f2ipYHub74GP408iSgTzy8pYq+9wv98Xtdr6NI5K+ut7NW5IOuP+HFz/T+
oZdvC/3we50/4tXr0f5ulvAv9KTPK+zynVfg+YC83+KuHHdpYcngU6J/wegH
7DHkD/RJ/238y/oLOt/ew6y3ppcEkz+S7KvXAOb9Nj7G++69ptGA5p12uzY/
Ftdp9pWXn4Z+ZDw2fgR9MH/6/HOWYPQl8r/7HVtfuam9Rz+tVh04VK9LnmD0
P88HxrvBBVXJj8Oy/tAT64O+CPR3h2D4CXuW9TtQO2R97xtOi/zV9UOSRL8j
/8HYTzo/ep7YW/zexhts/hD6nvmz/orOZ4gWjL1s8+dsO/qIdjDyX8cfogVD
zza/y57fs/lWdj8JeaX3dwtMPS1PHiHPsN+hH/gF/mc+7X4Q/iH9B3et2yJ0
+/KManmYJPRl8/X4HvwCvqzTxV/c3IP4xRHpL/mu2LNg5OOrQ8Lvve2ucpHH
rL/O1/f8Fdrhx6hucxeWtaop52F0PCjNp3+Rg3p/xuZXxYh9b+nZ1ktDnvG8
pWfkS2D+N4u9W/xis/s+mu7Zn6wP9FOj3XuZO2J3ij69fM2HlbdWpsv66HyB
ApOvlefevz54/ubTebIeyHPr/yC/6Q/roetDH5Tndfw02OS/zDP6J8jgYGOf
zjP5J0EmPyRX/EWNY0Tesj7499AXmPVhP5L1Yb71fQGJ4v8yn3p/McG3Pwh9
ot/hb/SLtp9CTL2YcFMfZq0vHm/rJer8o/GyHvAr6wmGXtFHNv9G748m+uwz
3sfvkec6/uPdj6TXI8KnD+19Qfr8fpDEh7Q/6tUX1/fzxJvng83+RojMF/YB
7do/PWjyLY6K/6T9sVTB6G8w8gX/Dv4BQx+2Xg7rwfzY+16Qv8gz2vmePb9k
6x/a+1X0fkGqrC/yjOf5Hhj9bu930fyW5KsXbu8f0eeVwsXegF51vb0Y3/kH
az/Y+0L0+QgvvoO/puP9m13TqvXeI/JI2xOhJr4wz9jvoT5s9S8Y/Q5GPgfs
12PSP+jhUOtXv2/1Wo57t4ofT7h9KY3rNOxTIBj61vUeU0S+I9/AzC/rw/zp
878pvvoqYOgT/5rnwein2Q1rftSqj3dejHZ+j3+LPNb1OaJEH2J/6XoTiRL/
oH/wB/rc5veBkd/QH5jxYT/QDqad5xlPoD3GPdOmxy3ng884HR+NMfV8M8V+
1PVUIkw+R6LYB+gDnW+71ZynjxP6pL/6PoU40Sf8XufHxgn9Mj4bf0deov9p
R/5o/bPUyMtQXzv0r/Ozik18wvN/bf6k9ncSfPLZ1kvBPtHnpYsF23xRLf/n
mf3cqUJ/2p/08luhN/jDnhe19ZFs/VubP2rr2/I+9L/F1n8BM16eB9POeG0+
jK63lWDqsyb7+EXXh11r9kMiBGNvWIz9y/uQ37zPxtvBtCNf+J6N59n7H2gH
4y/wfVuvxd6vqM9vxQm/aH1UJPoIjP7X9vR4U896qdnfCjH0GeLjF1sf0OZ7
6/tLkuV5xgvW9T+9/C3r/0CvYEuPtt6yrY9j69nZ+KL177X9FS/0C9bxZq++
F/1n/Vf3mH82JWeX8DPxDvwf5HtAXqa7HrPv2dmwMFXiK2D0N/4o+nnQ4N23
ZJTvdu7h6EbLnikRvD1j/R/725dJ/L7tmT61J24vF8z3idfQHuh/pKvZYWFS
0vGzEr8ZHrykS9AFnv7hefpXUbU+eRIfwh/E/gEH/Ptkt6Jqv+p4tb+e7IsX
MV8B/z5J8LIdszPGLNkj48Ve4X1g3tdlYXTbuIsK5Hldzz5T6Neen9T176LN
eaI03/6PPv+RYvKXvP1l9J2u157gqxfP88Qz7PlffV4j2rd/YvPhbT1Jmy9o
5Rv0C312ruJ/b37s+Rfmg/gh9Er/secZr7bXE03+/XaJ5+p6Eafl+zq/P87Q
p5fvz/rq+ntbqu2XSKF3+A/7EMz4sd+hT9r5PfYk9oWubxoh/Ax/0I5+0e0J
4i8yP/Y8LPoaeQqG3pl/+o+8wP6DX5hv+AV+5HldD+CEiZ+dcHdOqdsp66q9
8vy7R9PPfB251+dP8DzzV/rM9UlfBJUKPyOv8EeC33h3zHN7y4SeaGc82v7f
Ipj2O9ecOdXv6bMif8Csb3b800senFEp46U9YM+nSDvzxfqDkQ/1quyXfwy9
JwveXtgldtBvHj9Ar/U2f3Dq+hLqfWyT+Df0Ab9Bvzr/MkLi8+g/rb+nyvd0
PWfP/7fnrfT9vPFCb8xvfpV88OwH7f+P8K237AdVxxcZH/FY1pf1gX/B+Ds6
nzZR7AvWA/2g9Ys33/Aj8gX9GznjlZkxa0+b/fjTQp+0Y8/B33yf/oGhH32e
MF36x34d8Qnmi/iinT99Pi7N1N9LFPpAXrOe0CP8jf2v13OnyB/WB/nTrer9
G90FVfr/sNjnen9ms+hT3s/7El5Z3vnjJ9NlPXV+zkHH/i30hP1p47v6Ppal
4h+Dbb4V6xug7+WiP3ge/gHb85Y6Xhkh8gp+tPKQfBcdn4wResNe4H2sF/ym
873n+fxZHZ8NNzjWd15V16OLkfnW+21evV0d3w029so8333Ztn+0Qw+sJ/IN
jD3C7/k+9gtYvy/dxPPDjX8cIvIHeQu9ox9pZ39I/z7X7HcHm/tWws39LCHm
vuYo8T+gH3t/tI1f4y8wPu2/ZBgcbu4fCRX6B+v9hnWC+R6Y+dD506mC4V8w
8QMw+gL+Yvw23ol8Qt/YfBfkga53nyz0E5jvVFNfIUf4B3mv6yd498fjDzMe
ne8QbOzlhaIfmC97fzvyh/Wy8RS732HrS+t68t594rRjj+vxZIm8CfR/p/iT
+j5S735T7BX8r6kVx6fEB6WJvtLnxfLcNyMODvjkrUxp5/36vHqy6CtdP+6A
/J526EHHv2JEn/B+2nk/+lrfL3lU7I0vi67stWbcSdHXYB0/PC32HPoX+Yr/
wvto5/e0o0+1/vbomf5ae4T8BOyFVT3Kxix44Jw5f+bdv6LzTdeafMO1sv7I
G13fIFHoQedv58n3WX/0G/6YPh+ZZ+oXev46v4ffoA/4Gczz2J/IX+iB/X0w
/GL3G7W+mSr0AoY+9PlPTx/jr7Dett6/Pt+3w+df8Tzza+MT6H/4X+uLIF+8
1vpPOn8y07d/YOPB2FPoK7t/jX6AnvGfoDdd7zpJ/Atdf7zU5M97+ZP4V+xn
8D5d36lU6EHflxVlzi/GCb9q+8Tz360+sfyM/a33D07L+GlHHtIfXe/8tMgr
ntfnUU8LvdOOPw9mPMgH/GWwvu9lo9CbtffgN+xfLZ/jhP70/U6efQS9It/R
X8yf1vdRYv8ij8H6vjWvHry1B5hPXf/mgNj38Df7cWDindjL9F/Xy42X+cP/
BSPfeJ75pB36BsNvyK/AfoYXj9TnaQ/I+iIPiKfijyIf0M+sN/YL8gLM87Y/
6APkCf1Bv2gcZe6vpN7FQekf8oH8KzDt8C8Ye4PnaYce4U/oD/8O/rLxYfhb
n7cNk/UM9H+trCcY/kJ/sX6MH3sZrOvfHnBR6YtvbXr9Tlk/yVeqxuQvanm9
WcaDPGU+eJ71xh7leeQV+/fwD/Eg5o925o925gvMfPE880U79EM79GbjT2Dm
D/pi/sC8T5/fTTT19naY+MA2X7wD+xt6xP7W9cZyRN/qer+RIv/4PZj55nnW
i3ad33bA5McdFP7Cv4S/wOgDfT43RdqZf+Qn8Sjmg/mBX5g/fZ/DdqEX4hvw
Bxh5TH6O3v+PEfkB/WBfsh46fhLvkzfEG6AP4tm8j/WiP3p/fpdgff6mUNbv
+qrx7pP1A+t61oUyHtqJv7N+2Lf2/Arro+/LLJL5ZX3A6Ed9H59Xn0rnP6WK
Pcb6W3oHw09g9I+lB77HekAfrIfOX0qUduib/TLoH8z8o2+YbxvPhj95n7VP
wNjf1n5CP6H/wfo+qDyRt9gnyFuwrrdXKPY4+gp5D4aewKyXzu9NkfVl/cDw
Oxh7lPX+Y1jfV4YszRd6IZ7KerA/gbxnfwJMf63/Y+sv0A794l/peoeFJj/S
Oy+GvaHvsy2S9aNdn1fz/CPsKeYDemT/hHYw8Qny6WhHPyG/6A8Y+kQegZEn
8D/yWtenyRP7EHrBPgSz/uh31h95wfqD4T/Wl/xvMPwIv6Av2P/T9Wg9/qA/
vF/ff7Fd5CnzhT0Dxt6H/nmfzl/Nr+a/1aJ/9HmGg/J92pEf9ryd9S91PGqb
yBv6b+UP8wN9gWm3+6k6/yxN9k/B2OfoX+wP+k88A/sHftD3XxdIu41nwH/4
S4H1KRBs8yd1fne4OV8Yava7Vst86vNzR4TfkP/4M3b/jPgHz+v7ybeK/IU+
8XcD/Y93IQe/Gd/hyCkZb4Af4sSe0/V/ksR/A8Ov/J52XU8gT/SHzv/fbPar
owXr8yylsn9JvIH8GfiF/FIdj4gUewV9BqYd+UL/iLexf8X6IE/BtNt6j9hX
YOwv1tfmVyKvia/oepkLffRgzxdAD8SnWH9+jz/C+/V99FN99Pn/zlf28n1t
/j4Yesb+It9L5/OPN/Hw8abe/FSzvztCsD7/XCrf1/lQa337IWBdL7bUxBNL
RN/iz+r65TFmPyte9JHN/0cfIb/AzD/j1fWdCuX7zB/vAxMP0ftlsTI/6D99
3nqhyZ/27EnOv2B/sB+lcYRvf8Xmp9v9cvxD+gdGP4D5vX4+3Jx3CzP56p49
h/xB/5b9/cbK0T9my3h5P/qH8dv4JO3Qjz6fHW7qe4aJvcx40F+8X98nkiTt
2G/oL+wL8tuQJ8QnkFfYY8TbkAfoN+Qv9KHzC7KkPzqf+bT4Xzz/WWl+pztb
7vLFX5CPWl6FiX7HHtH1ydaKPgis53ZTbyVR5IWuhxAs+pT5QL/xPq3vvHwG
7AH8STDyh/njefbXwIyX+QZr+ZvkywdE32APgWm39QNsO/IIe5J25A/yGPml
z5vEmPjoZomXwX9g5BHPo+/seuvzJGuFPpCnYOxNfo/8sljfNxAp7WBdnybW
5x9aeUE7+pV4FfYfz6NvwcRPdL6KF//W9bW8+8ORl/gTyBtdj+CY5LMjP+k/
9hD+je5flPiH+APINzD6su6KXfNGZmdUz58Xn0B+gJEvgfzb7a7Prqatxw73
8oF4P/my0D/jARO/1fe5ePnC0BvnMxkv++nQF/vpYH0/jtfO++A/nke/8bzW
d5vFPw2sz2b3XJW8OiTygv0n+E3vb/nzI3g+EJ9NcvkLOkSe2eLth7G+9MfG
V228FP0N/dn4j+UP9B3yhPUCQw+BfMRkoQf0CfNDvAV7AP6GXllPMP1DH7Ke
6HfoS/ubCb54H/4D+gR/Ccx8sH5g+s/8BOIjO1yDEUGFnbcel+9Zf1Lb25E+
/xL+AMMfgf24OOEPfV7YO9+APOD3Nn8Se5z3BfzPoyLPbf1WLS8iTD7YHLFf
2N8F6/oP3vk5vX/pYeSh3n9IEn8QegKzPsgr/Fstr5PF/iNeAn3wPTD9AQfk
yfZqe2C9qY/p7c8w/2DsgQA/b6rmz3wZj41X4P/Av+tbHJr1zsBSke+aPrz7
aZC3tGt57J3n0fXRI33yHIx8RV/pfJNKGb/dT0f+gO39prQH1mur+O/afy4R
+Ym8Q16B6Q/rDX8z//grmh7H++hV+2tBgrEP6C/2BPqE9aWd+dX2UoTYQ5oe
vPw4fR4iTPQ766HvK4iU8WPPYV9BT8h3XR8hzeQ/JUt/7P6Pjl94+VLgH7Ln
9qq9x9uPtfeNEa+CfpsPfvSSnzeVVscvPf1G+/MHZrZqc7NXz4D9VOS5rf/B
eMF6f3a7zDf90/dnRwj/aXopFf4OCps2dPs1ZaJ/7Xld4nXQD/Y09rqthwXG
/oI/9X51vNC/rr+3QfQL/jaY9dT1KCN85+d1PsI2oQ8w88f6YV/jjxH/IX4H
v+l64edEnhK/hP7A0Df+Ev4k/Ii8sflQyCPGa+UV/hH8YfMTdLwmVuwz6LFZ
lXw7LPra0qO975Pxor8Znz6fVWnyc8/JfPM8WNejTRT5RTwQe4H1ZXzaPykS
+g7ow6Lq+YsUzHqxnqwX60l/sId0Pa5I4Y+AvIqQ+UI/kR9k9RMY+wh9Av/o
/Pwwsc+Rt8w/WN+PvVqeh3/s/jDtrB8Y+Yl8gN50fNXiSKNfPH3P/AfkT4GJ
15fK/CKfwPb8L/TC93Q+ZKTvvCv6n/iAjdcgH3S+a7LwJxj7TvvrHoYekR/Q
B+OBPpD3zDfj0/5SqawP+hN9yPdYX/QBzxO/Aut6/l5+KZj1Zf50/dFIWS/2
FxgP6wcmnqXlW5SP/xkP84l8xZ62+TK6/sNmEz8JlfiqzhcqNPrWu+8UfY78
tvVLsIeIt+p4eoTPv6T/0A+Y8zd6POHm/MhGX70PXU88TPxDxsN8BOKh29wF
FftzavQtk/fp+hbLZT85cN4t0fWs1fX+iOxi2c9mPZCv0BMY/0Gfx0wXetD5
VFtMvvZK336KPZ+MvuF7YOQfv8deob+cX8IfgB8tPTIeMPItkG+wxTVqvavk
40dPy/oyXuwr5Bv9Rz4jT+An+q/v8/XiL/zenmdhP4jz6fh/+rxGvtCvzf/T
+6OePiNecu2Rj/e+sMG7D4r4A1jb017+kr5fmvP1eb74gpan0WJ/gWknXoV+
xB+FX9GXyMcrWqZ9fkdwlsgfvT5FrrjOntLB/fOr7e2j4j/2rlpfb7/UnrfQ
+/eRvvw7+B171NZr5ff6/I63P4w/oO+v9PLl9X5giMnfCPHVM7H1oWy+PfYd
WMu7ELF/9H3L3vksfo++ZPzY5/ib2Cv6PGas8KPe7/XqMen6uClGv6UJxp7Q
559SjP5P8dXnsOeh9P3TSb76Hjo+nmbuk1jri4/r+23X+erl2PpOyAvmm/iK
rgfv1XOiHXmp6wWt9MlTnZ+UIv479Kf3R5ea/PoUkY/oC+aTduQj/gwYfwv5
CIYfyOey+e30D/kLJv6CPsW/QV/if/K+gLyNcTdeedfBwi/OmHy+nSIfkG/E
77A/wfhPvB/9SjwMHFifJSY+HWbyq5YYebhE1gf9SzuY+CfvA2PPMT/Yvzb+
Bab/Vl/aehfML+sL5jwb32P+8afA0Av6Wte/TJb10vl3Xv0b1o/34U/hn8Ev
PI9+Q36jH+Evxsv37f6F3V+y+XB2PLbeCvYC8gL9Tj5N4+cmV15y/mT1eNB3
6e7tTz/6/Mu6u93c9E6jXk+BvmPlefzp3VX++RG35/7DRRmj9rha9WcV/di0
xMjbfBPvPSDyzepfnX+Z6cu3se3WvtH1X6Jdkmux6IlvK6rzlZNc8cykyGca
nxV7E3sJ/oOf6A/vg75Zb+zPkCr63Cv8pvMllgv/EV/CvwbrfI0wc75hpdgz
+Jsrq+zHXLFPbf4Gvyefwvaf8fF+7BvkP/2FX1kv6Evv98VKfE/HN46Ivsbf
Z/7ZH4F/oXfiL9jHur6fly+j9WukL16L/mQ9bbwUfmD+4XfyLXkf9hLyBXlm
62ehb4l38H7Gx/vJ96Ad+wJ/HPs2QO8ppp7fQfHvdP2qhbJfg7y29XLgL+w9
/AvsHzDvt+ePdDzKizfTjr4EI//0eTHvPC70if1gzxvZ+oL2PCz0xf6a1t8J
Yn9gb9rzp/a8KRh6IB7L8/QPe35ylb+XJ/Ot81eXi35m/Pwe+mf/k/7Z/A3W
j/HY8drznuTzoS/BfC9Qf/mE+JusJ/2DnrFniLewPxh++QNTU5Z58VB73of5
R37g7zM+m0/P71lva39hT9I/vR8Y4SYObf3Gn1NPSzzndPjYbTn5p0UesT8a
yF/fIfJyYOXweUndsmQ/gOfZ/0RfdPr9nvpXzvbOA+p6K955Pejdnr+z56Xh
h5pLEl5KH7xb9COYeAf++9Tpuf0f6l5u6k2slfMGfJ/5tOehwIwfeRuwf7fK
/MFf2Jdge57Ing8C8372T/B/oR/s20e//vLqUVkVMr9/bkkdFdLijHzPno/R
52FW++INyEPkrT3PYs+fMH7slcrM+9IHLfTOj9j9GdaL+db57pt88XX4k/MT
0Av95/f0H/kQkN/TXeuq+wpOuFH9noppmbFH7K2A/+HFc3T9i3yzn37ANf6k
1SWxD3nxA+iJ/Wvok/ULnHdIcEXRpVsnTSgW+oAema++ZzPuv65dhfALOJDf
nOxG37316e/qePsb+rxLvIwX+8PGy9gP1vV+vHxsm1+t4+nrquuve/n9+HfI
O+gRfanz3ceLPmV90Pe6PpkXDyA/EHk0pkqf75P5Ij7FeO35NuQZ/MJ4/+zd
9uVR57NkPnR9zQNCD8gr1pP4EvurNl6I/QNG3tNf5A38yvfRR9Af84P9C33r
fPpN8nxg/yBZ5oP3B+ghVewd6iWxfuhH6Bd6Zn4SqvRXodi7yHvkIfNDu81v
4X3ID/qv63ecMvv9+e6TLz/ffNvYDKF/4pOLFt827JYPKmV92E9kvMh75Is+
jxTpRvQ52jN2hJe/NfiRh55uF17m3u9VkhfVJMld9Uazw5cvLXVzi19ve+uI
dPFn4Df4VZ+/LxJ6Zf71ef0iWU/kFfQBvZKv9XX3US/WS/L8Rbu/T74Z+Re6
XkWwYPpr/Qv8JfhT52cE++IDYH1/hucv2HwNXX8qwux/zPPV19X108NN/C9U
2rFPwMhn+I14ld5PDvPpB52fFyb+BO8HIx+RZ2Drf+h8zlTfeT34F3qx+8Fg
4n1g4lHoR/x3/BedH5wq80m8l/GhD/T9jkWy/tAH86/r44aJP8P3dL7gTsHE
g/g9/peub5dq6jmn+ugFe5l2nc+XbvIpUiVexPPYF6wn8Xn4SdvXXn1z9mPw
F5HH7I8gH4lnwO/s/8Lfdj8LfUr8ymId748X/uX3xA+Ip+r89hDJb8Ufwl8h
3gCmHXuA8cPPjJ94AO32PhIdL5gu9gztvJ94Ee8nf4Hf8zzygHgTmPkm/4H+
ES9Af7BezL+NH+t88EhfvWviQ5wnsvOl6duLt8C/PA+29aOgfzDvQ193PHq0
9p7bj4s+QL7o+rFevQ34AQw/jD/0/MEvameLfavPI1eKfrH2I/m62KPYr/iz
PE/8WPNztO+8LvIKetb2/Rbxf/T51Bw5v8f42C8E833kI+sHxr6z+VTIb86z
2PrS5C/gf7M/QDvnjbB36D/0putDrpP1Qn5CL8g3fV+7F49HfsE/gfq4qeJP
kc+J/4c9gP2AfYS9pOOLFWL/4b8zXjDnB8D6vHuliU+eEvuT+AzzgT9JfAH9
w/zYfB7yw6AH5k+fZz4o/gvzRf/5PfKY9WR+WE/8KTD6jPMJYPQrzz9VNf7d
Jh5bIeOz5+u1PeX5b9gfWj6ulngg64N9Cj8gDwtvGvRc/Ql5sv7oV1sPzOaf
6foNKT7/TNcjW+Lbn7LnQ8HIf+JdYPQF+snaZ/Y+KptvQv/A+nzsSuF32tGH
8Jut5wE9om/Qr8TzdH3iIF+9VeYf+kbeYV+A0S/2fLG+f2qOOb85T/xh+J/5
x74B0478YL9Ux182STwDfkXf6vtLi6XdxjORt+hb7Fni8zq+vk3id2B7Xhx7
DMx+N/60Pd+PvIUf4D/4GQz96vNJYaZ+ZqjwB/xi7xuS+H3XxOaD8/PEX+2R
+8VNN9fx+6/6PPU6oV/kOZjxQs/83sZfOX/C+vB7/C9+D9b5mKnyPPakve/A
5nuib5E/xB+hb7C+HyVf5DH0S3+tv6nPI28z/BXrqyeCvAeznvA38hT+t/6q
vu9jidA38239DzDtrD/0rs+XpfnO18JvYPgf+cv3iedqezlV/Fu+T/wLjH1L
PqGutztC2llfm/+g8z2DTT3dhcK/2FPQB9jeb0M79gv0in8KJt5i69lr/zNW
sK6nWyD0hTykno/Op/DyK2jX+ecjzH0oS2S9oCebX8H6g1kv9BOYdlvPAXpi
/vke9ANGH6M/0cdg2pEvYJ3v6t0ng/5C3/B9e54P/Um87P0GEzosOlku8bAH
3km45PBN3v4F+wfjLhh7aOjq1Or7D716J9grPE8+KPt1YOQj/jC/1/awlx+I
fGO+oD8w9Ml68Tz6Q+fjePeJWP8D+5B6aug7MP4U94HYejXMJ/3BHiY/O+PN
PX/tfOKUyDN9fixW5hf7FYx8wx5Dn2PfIm+gFzDrwX4P+p/+QQ/sP+Bvoq9Y
L+aH/uJ/E//En8B/5nvEQ4i/ggPx3xSJh+KP0h/80QF9O7cdPsa7n8nWI4Xf
sb/tfUfoA/r7cdV6e/VBkI9g4pHBa0N+/igjV+K/yCPGj/3B+hA/wj+Cnm19
G12v1at/A7+wH8j78UfYfwGjr1lv/HPsK/YrwdjX2n5caOTZPJ980/lUIUK/
yE/0Odjmt9n9QmsfoR+xN7AHwNgPur7TQZkPMOPV+ewLzX16c0Qeg/V9I/NM
fsZm8S/hb94HvSF/+L7Nv9PxrHATPwsz9vVSI79DTD39YF98XPsPS008fLk5
j7hSMPyG/gDzPfqn6x+Hif6Hnm28G3tCn5fy6j3YeLc+f7xA7Gn8CegbbOPB
zAf6C/mCvAKjH8k/Aev76jbIedDkqvVeL/EL2qFH2skHh55svqS9zxH5grxl
P4z8ceiB/CfoCWzjq+y3Qh96f2ShqUe00JyXTfLFS+35TZs/bfczdX5xlK8e
CPoW+WvjRzY/S+e/pPji7dgLyH8w/gT8i/8Bph37AP7FvoB/WT+wrucYLfIP
fiH+iT7X9brjZP8V/5f4KfKF5/FfeR75D8Y+AEPv/1aNL0fex3xgT4N1vY1c
GT/yD362+Xi2Xiz95bwF/SGeauuno6/gd/afsC8XV8mjQolPgvke/QNj/2BP
ke9Kf8DII30fqFeflPXEfgnQX5Rg7BfoFX6359V0PCnel59p623Ar6wv+VDM
N/SJ/WXrQ9J/4r30l/uO2B8n/gTW5x29+oVg2vV9gCtF3iL/9Xn+cF+7vt9y
pYkHhpr7BFb79oeQd8g37FEw8W7Gi/ylHXsVzPozX6wn9hb8DH0yv9An9h30
CUZe2XiMjm8n+Owj5gt9oOdnoTlvtkDGw/xqfz3Ut3+N/QO29fesPWaxrc+n
88Onev519Z+Ot7wn+cfoS3seBMz3dD331aKPaAdjL9p2fX9wlKmPFSH5Huhj
+g/W55nmmf3uYEPfi2T/jP7qeuKrffXnwPALzwfk8SqJV5Jvgr+DfmF+wDbe
bOvJoW/xB9hfgN/xh9FHtPN+2nX9oAqxV/An0D/Id96PfoOekS/obx2f3iL+
K/YBmPFhT7D+YE2/nn0JRj7QXznfVe1vEg+B3olnXFVlnx5wje/N27zl6jTB
tSZ233DTF7lu95gfVg+odVLOGyCf8MfJPwPb+w5pD/DXLKEn5B8Y/cb+K/l9
9B/M/hv2Gu2MF3ub/WTkHZj4PPJLnwecJf4yGP4G63pRq8XeRH7YfH1tv60W
ewR6w/4A6/PwK6Wd39MOPdh4tr7/YY2cl4E+9f5PrPA/9ticKn7wMPMBf2Of
YO8gT7DXdLzBw/CL3d/FP+B8N/zOfaL2flH8PfSLPQ+u641ky/Psd+h6Ah4m
fgv9MH70H+MBE7+GHhkP+c9gez8EGHonf4/1gR65/0OfN/XuR2M8rF/g/Ion
T8n31OczPEy82NYDhX7BOl/Nq//J98j/I5+e9cO/A+PPWf2n6+uHC0Zf6Pis
l09Lf8D0h+fZv7b5Ysh72m39fn0+JErykbCfH6uan3yJN9r723j+jR9/GzU8
Ok2eJ9+H58E83/OqWS83mZIpzxNfxB8D4w9gr5O/ijzEnwPzPPIPf4H+0g69
4I+THwLG38EfZ36IL4CJhzJfxCOIv9rz/TyPfuF5+m/rgfE88p73MT7yRbFv
mF/4S9evDPZh5DPyRd8fsETeh34DY3+xfuSH31dFn95+uo5HTpf1wz5jvXle
358xXdYP/W/vO8Wexn/D38DfYr3xByz98HvmU9vjXrydfEf8H/LbwNC33s/J
F3lCvQzkDfUabL0x7Fv4m/w3sK6f5NWHRd7Y+ufYz+RjY1+Ddf0t734z6Jl4
NfNr613Y80K0g208HH3A+tj6q2BdL/KA+CP2/gnWF30MvaC/wMh31gd9CSZ/
jnwW/EX0Nxj7Fn8RexZ9B3+CiT8Sv+A8DvON/6Xnv0jiFeSPY18TP8O+Jp+V
eBmYeAL5jWDsTfxl7HnkLflQxN/BxDMC8sHLP9bnZZNEnuDvEF+FXsF3/xJ+
sOnsnXL+gPuusP/A2H8PlMzfMfB5zz6nv5wn1PrDO/+Avcx68Ly+r6dS1ofn
kdf2vgiex1/iecZv77/ieeaDeCLzAYb/wegH7BvsSfJH8O/gTzD8hr+F/Ua8
k/wP6EHXO44359EiRR+AWV/on/gW9Es79Es768P7NL3lynrxPPaPPa8P/xFv
w19BntOO/0Q7+ZRg4ju8H8zvA/I6RZ5n/4/1wB+392HB7/jn8DvzzfNgnocf
eZ75oZ4fmHgD80V8gXg0GPmGfY09gz+EvQPGv8K/wf9Bvsp+cbV8gh+wx/V9
Kgdl/MTzWB+dL+dh1hP/GP7B/gJjn8FPvD/we++8Ghh7vMvBOsNj2nj5k+gP
4nvoD84roj/AzDfxReLt5L+AqR+MvOS8FPsdyAfoC/mBf6DrM6wVDH1ajH/D
+9hvgt7B5JNiX4ElXy6k0SObV3n5b9CDjeej79gPwn5CPuh80QgfZv2wJ1lf
sL5P1lt/8tGJr4P1fbdefi+/53w59KPPEybJ+Q1+D/9gLzIf5LeAsa/AyDvs
YepT4F/jb4A5X0d8hueJb1G/ivgW8sfWRwYzHuQZGHkGvyDPGC/6BP8f+gYT
H0T/IK+Rd3Z/Dv8Afxt60/slp0Xeob/QT2D6T71w7Eew5BtVvW+LjI/5gv/Y
H4G+OU/H+QLkBfnVtIN1/akokdesN/Ka8xDId/xV6BHM7/GvkK/4b/p+gQXC
v/hDYH5v9xOwX8kP0PU5w8SeJl5GvJL4P/aozm8vFfsf/wP5wPzxPP4Q8Vnk
uT5vk2zq/6aa+ixpst6063q+Wab+7E7BgfFlSjwZfUn/iM+DsYfYv7D3UbI+
8Cf8BYa/8OeQRwH5WyD7XQF/ysM8z3zxPPoQjP/I7/V+RZrJ58wx99UsEXua
fBNdLzJU+Jt4FJh2+BX7EvmEfiGeF7BPwoQ+4X/0C/rPnm+BXv+95Omf454o
EHrBn4X/oA/oGX5E3mLf2HoE9n4+6B/6op39On7P/LGeEW89Nr/R+2kSP4Af
GQ/2pj7fv0v4k3oFYO535PfcDwKmHfogfmDzgcHQvz0fZuvf6vvTo8Qewv7Q
9RhDRV5BH2CeJ94IRv7pfM9KmU+djxUi8g57B35DvtAOP4Nph77Yz2G/hniZ
zocO8uXP6nyZqaZ+/HhpJz5AfIj9JPyBgP+4W/gTDP8+WmvylWOaePW65u1s
eW+LrV59Ep6Hn8HE8/k98Wd+r+PRcWJfgMnfwj8gXow+Jp6MPQHGf+R5MPYw
+oD4Cvoa+sa/Zb7Qz+A+mYfXDzmWL+PX901mmXzKncb/2Gn4OVPsAZsvAj2w
/8B+KPRk7/ODfsHEX6FPq9/xV/V9wqfkfA7xMTDylHgi7egfvod+0vW815l6
NxvE36A/2K/IA+wx7HfkJf47GPsb+578Bvw79BH8i7/H/OK/kX/M/a7QMxh6
pv4K9Ls2ttbnO7/LkXzc68dsemvQa3m+847an4oS/wtMfJH4JfoJeQfeXUX/
a4V/8SfA2H/Y99A79eeQJ/p8yXT5PZjfsx72fk6dP/qezB/6EP8W/5J4Dhj7
Ev6x96lBD/An8hX+hF/gTzD1X+g/9BLI382Q95HPq+31A/J+9td5PzjoxTuu
3DVjr+h76Bn9C73r+5DWCb2BmR/2D7HH2D8EE/8lngvGnsNe0echs3zt/J52
MPWu2P8F429hjxNvYL/b1m/V96lGiLyE/nQ+Qbg5/xgj8w992PNXYNp1veDV
Ml7eD9b38R3y6pFUjx9/jvVhvPq85HKz3xEi8gF6ob4J/AhmvxX9TP1X9LO+
L7lE5lOflwsVjL1KPR7ogXgz/Ik+Jd8Dfx1+wN9EfqIfiHfoengRom/0efBd
gvFX+J7m3wjB9Ffbt5vEf8VeRb6H5zw4KuG+TCP/vfvDwMT32A8jPk/8C/sX
exd5QX0O+Id8buw1/BUw7fr+qyjZD8V+QR9iv9DOfgeYeLzdfwUzHuQl51PA
jIf9VOwJ4vHYA6yXjpdmiX1AO/4E8RH8YfY/WE/2Y5F/5DuSf4M+Rp9oe3mJ
735f+I3v4Y+wP6nz63NNPNWrBwrGnuN+O9rR99Ab8t/uT9r7GjSO8uU7E39i
f4b1x35jPbHv7HkA7B3sW73fHy/vI57G75FfYOJZPI//SzvxbTD2qPV/+D3x
RJ6HvsDMH78H83vmk+fRp2Dyb6AnMPMRuO/AO8+H/w3GPoHeqEeMPcb8E++C
v/AXwcQX2L/CXoE/wdhn7G/C79AD66Xr6UUIvyFftT+wqVqeZcn8wW+B+l65
ok/B7CeiH/k+9jTxefqDvQm29YWwL6EnMPPH+5gfu3+IvMH+Rp8zv+hv/CEw
7ehz5pP4FvKT8wTITzDj0fl63v4e6wVGXqIf0NfYO8hbMPIWTP+JTzE/9jwE
8hgMfwTqlcS6exs9ctHQaR5/Qp+sh6VX4sdg6kGzHgH7IlroFcx8on/pD/MH
Jn5I/1ZXxcP2SDyI9dHxmQLB7Lcw35yXQF6CscfYb8Ofwf4kvqvzO7125ht/
hXxZe14djPxg/4X9J/xB1hf7j/0oMPILex1/Bcx62PPp+IusD/4i6wNm/olX
gG19XVvfHfmJf46+BiM/Sx85fe+nBzz7adrAl6/a8dhOwehve78h64M+Jt+U
+SJeyv42+gp+wr5C34KJB+IfgVmPqe7hHbGR+bK+EYsn590808MBfbRX4oFg
5vuV8n4vtc73/PHy2+Pu+fqhvYKxj8kXQP7q8y6bRJ4gv2mHvtA/0K+m7zhf
vR/kBxh/BP6knfmEXpEHyBfiXWDabb1l+gu9I2/ByGfWE/8W+gejj/k9mN/D
XzyPfgZjT+CP01/OBxHvJH6PPc/+nrbvvftaaYcfoQfsE+IvYBuPt/c52vr7
0D/2D/KH94Gx9+z9HdAj9h78jv+KvQi9YI9AH8T7wMwP9EI78gX7gf1I5AHz
A73Tf+gDDL0zftrxR7GnoR/4HfqBv1lPMO3Y/8SjbTwJ/wH7g/WlfwH9s1n4
Q9ebTBKMvOY8ARj/l3wU5CP2ks4XjhGMvAVTfwd/AIx/T/0d8h+pzwNGP6Lf
sVewF+gf/h30g3xhv5T5DdDPYomvkJ9KvAJs65nSTjxB25PhvvNUtl6JPo80
QviF/Qfd/p7wC/qE+WB/h/1Y7GPoD31o7+dC/3IfhM539+ph7Lyt5tLoJV69
BM7LgJl/4iFg6AVMfAv6h1/BOj/dayf/gPXGP8MeB2OPYw9if+OvWXtc55uu
Fvvu9vohMal9syUey/PIH/gB+Ye+BpPPz34J7cgb/DddXyNN+o89xvjAxPux
F3W9+CjRh9iL+HPwi72PNfD8VskX53yo5I9U01cg/zLJ7Xz4fFjxmNLq9U9y
8+unj854pVTqoQu/ks9TrV/xr2z8Xp8nifbdNwemnfWCnpGHOp/2lDwP/fE+
MO3IO/gHf5T4MfyNP8x+VYAePEy+SUA/JEm8BHkAv+j6wzG+fFPiMegj+BN/
CUy7jo97+aDod/wzxg//PDlp2r0pr+wSeRiID8a5jvF1rjv5xlnRl8hHMPPN
8wF/9Wj1eQ4PE7+Cf8C6Hney7/54MP4l9EO+FPqI+DryJrA+26v9rw1if6Jv
wMRH7qqyRzZVx5fzhZ+tf4r/w3wTTwOjz1k/2tE/xKPRh9R3ZP3BtENvyBvq
r+Pv2ftErbxHfhNfRB6BdbwuwpxfChd7B/2Af078XN8XGybn7YiH0o6/qes7
rHFdYwua/NrL04+0I3/hFzDPg4nP8z57Xwr57WD8e+xF/H/2E4g/c34LTP6J
zsf0zguxHwT/we/8How/hj7leb7HePge8oH4LvEB8o3gv5gn68xrttHTT2Dk
EecLoT/OE0JfYOiJ/RN7/gT9hDzX959skHi39nezZD+ceAfxZ/wfsL1/kv0P
sM7PWi72N/2Bv9lf4Huc9+J7YP29OTJe9nNt/RPsU/hZ3x8cLRj6svdN2fsf
4Bf0Ic+jz6Bn5gd5CMZ/w78g3gRmvvC32K8mPo49AcbeIL8D+wh5zPuQ18w/
GH8H+wX7FXsF+wRs6yuxH4o/y36c3p9MF34GIy+5P4/nyR9EH3P/BfkLuj6k
h/EfuR9c32fhYewV5o92MO2sB/yvzw/tEgy9a/ttl2DaeT/yAyz3T1evH/Ed
fZ5op2DyZaBn+AMM/8D/xE+ID5GfBrb5i7Qzv2BdP2C3+Pc6HzPB1AffKfFQ
5C3ykPVCfrE+yDcw8o/8O/iR/Dr4D3qEfqFH/C3yK3k/+SvW/sO+ArPfiz1N
Pjr0wfkq4gtg9lMZP/uljB+Mva7zJT1MO/YM+gP5QPwRjP7CXyK+QjwB/wWs
4ymZ0l/0Cf0BW/8CexB7A4y/hD+O/uV92H/U62G9kcfQB5j9RfwTnifegH3L
/iX6DH1P/oWux5Vh6o2nSz4k6wfGv9L1bxbK+4lH2HpfOj8o2NzfsEj2s4gv
Qd/oS5v/a+9LgH/Ip8GewB9CfhCPYP3A+j7qqXKeCHpAPqG/GD/ygvEz3/AX
mP4R76B/fB/7Cazvc54q9jDxGvQN8wnG3rL5IsQjOC+l+WOXuQ8i25efquvp
bpD3k98Exh7AfoU+Ob+p6xPuEnmp9UmyOW8z1dzfG2Xip+kyfuwnMPaSzpdJ
891nwfqx34d/Cma96R8Y/479Id4HRh6Sf8R4+X5gfJ69Tf1W2jnfQf84D8b3
wdAn9qqtP6Pr/a0TjDwgH0bbw158jngL+g99yXqyXmD8SehZ1+Mab/KnvhL9
o+sjV4i+JP6r6yV753vQV9hP5BvQTjwVzP4r9gL2JJj4FPaZvh9yr/QfDH9D
j/weTH/Qd3wffmV/D38BjP5FfzM+MPF9Wx8cec7+DPKbeKSurxEi9gzyF/uF
57GfiW9iP4Oxn9FXyC/sO/xBsPZ/t8h8od+Yb7C+D9vzl9Bf2HvoZ+xBMP4S
8gT61vGy03Jehv4hL8HIS/QP68n3wHwPfUo7mHbkBfMJZj7Jj0P+E88DE89D
HrLfy/fAfA97R9eb8c4DU08B+QIW/7/OntLB/b39V+I52p5dLfqU+AbxOV0P
LV/kERh5xHk37Dm937tD6F3XM1or9AeGfsi/QT9o/k7z3b9q7+PFf8bfYX7B
0B/7A5xHwz5Enml8UDD7KfgrxDtpR97Sznkj4u/Yf8TvsBfBuj5TosTT9Hnn
tTJ+MPtNzB/Po9/JXwjQa4TE49F/YFt/WN93tFXi2WB7nyLxPviffFHif3q+
ImQ+WQ/awbSzX088A/olXge/Yg/B/7Zela5nFezjB11vdLXspxB/oB1/gXb8
CeQ160/+GfND/AN5RvwTe4n8BOwf2smvpZ34BONF/xE/x/7BfsD+wX7g+7p+
cZToX+iLduiHdvgNewL7Q9fjnyP2BfF42uX+m2qM/NL2o61fEyX8A/3o+2W9
+jDQH/Eg6Il4O/EL4l/oNzD6nHgP+TD6/L9njzK/+FPMP1jfX3pO/GMw/G7z
f+39X+h3/CfibdAD9EL/yUcEo6+wD1lf9i/ZvybeiL3PfnuAnrJlfMR3oH8w
8pD4GfTCerA/wnqA0ff6vgMvHxF5QHxP1zv1MPktmt5ixX7Evtza6NPZ4bFn
JT8Ze4F4BPIObOUd8hIMPWBPIl+Qp8Q3mA/a4R/iC2D8X+YXfka+YO8zHvbj
wNhLrDfro+sv7xR+B7O/h70Dhn6IV/E97BMw9IK8AENvxBPYv8Ke1feHrZTz
hAF6+1v247A/8M+xb1lfMPKW/Cjizfhf+HPYX8hT4oH2PAH6GftRx+P9GHoB
a38oXdZHy7cCkcfYV2B7n6euX+edd0Bf6PpUI4Q/8O/AAXk9SewV5Bn8w3lX
7LsAvXjn7TgvSn4G8g77gXgX64e9gT7CfuH98JO9z5D8JeS99ocTZDzET+kf
8VP6hz8L/cAv6G/yD3V7uqm3tVvit+zPI9/YX7HnS8AB/o2o3o/NF/3EeqO/
wDzP/jHnM3R+xV5T38Q7PwH9wJ/6fqh8kZf4a9g7gfy/c4LZr8D+OTK80Zr1
b3n7FdA740c/g9HPOj/aq28OPyJfbP4h/gT6k/1V9Cf5Zvgz6Bf4BfnMeWr0
M++DXngf9EK8A/+B/VHij8hr/H3qLcj9XdX5sdjbPE++FPrA5n8iH8jPA+NP
4B9I/Koaww/6fPd2GQ/+lr4vMs5Xvxn5y3rDv7yPfAHGY8/j8D78Nx2/8TD5
PuT38H38NzD0AkaeYo/ZeoDE38HIZ+x77D2wzg/INPX+Msz9UbuFHsD0D3mg
/Z8kiW+C8SeYL10PKkj0AfY0/Ep8GYw8RX6y3wMm/xh6xP6FHonXQc/4QzwP
1vd9rfHVF8feh17Q72DkEfF57B9d37ZA4jnYg9y3i/1D/Effn7xR/AXokXgl
80l8iPgS/IG/iHwBI494nvgh+pL3oy/xD8DMH/YW8VWwvu86Q+Id6Bt7/p7+
gVkP7CHWE/8c+Qm29byIb+h87oMST7fnpfT9AB6GnogH4k+BkffwO5jx6nrr
Xj0g+In11PVeR5h6ruNN/Y5Jst9I/Id2MPyN/sWe0PUrlwsOxMvCRB8F+rda
+Bl+1Pf7evUo8d9pR7+C0a88j36F37AvoH/4FX8ZeiP+Bz3gPyJP8B+1vZHk
q3fN+sO/nA/A3yTeRvyB89NgXT8mQ/wH5Cn+KvwPJn6Kvia+ivwA63pwyZKP
gTzC/4R+9Pn4jT77gPdhH2D/Ih91fbo8oR/2dzR95Rn7NVfkPfYa+gCs78Pa
JP6gvu+iQPwV+BmMvMI/If6s9/O9fHbWX+cfefYn8hJ+sfXcGR/6FX8D/4n1
x98CI/+hH+wt5AX8CD8F6M+zf6kvpu8LCReMPtfnz3bL98D0h/g8+ZHwA/YH
9I/8QX4jH/R9B2Eiv+B/6A/7mvW02J6vJx6K/4M8ZL7hRzC/h3+wTxgv48Ge
0PelzzHyweM38it1PtAaXz0W9D38B9b5XRtlfsFaXkZKfBJ6g39YL/gFfU++
DRj6svYA88X3kb/Iu1fWDm16IvScyFfmG3uf+QPr+d0u+gB/IkAPi0w8frk5
Dxom/YPeWX97HwHzD7bn6fX9uR6Gf7FvwXp/b6fYN8gTPb87RH8zPjD8SzxN
3//n6Rcw8w39Y7/Y8402n5r1gx80TpL51PogTPrDfgn2JOvJeoOJd7FexM/A
rHeAXv+W/rJerCf8C3/b/SL6Q/+QF8gbxs/70McSb1fne2JdVM+6G57NjXVd
Z23YNOXJMNFXnTZU1MlZEibxipTCbl8u7LVN8NRpyz54YHy2OQ8U7H6JO/JV
QkfvfpHmT33foHObQ+6T2xbsGheWLvbn11H/DgrtmS34SPO74lb3TDX54//p
/a590ictOe7+GTwhaEPaPNl/Hnvor37vXxUuOPp4u1ubBG8SfOnlo6/J/DZJ
MPL+gi8mPHlmWZlr/8nQ1Mn1w8VffSLjkrInv40QnLt23uyb1iYJlvPGD6V8
8tV2b7/2f4vKNtVbWCb5zDdNHXN18/Vl0v+yZwZdEB3ufX/ujg83/vHwKdGH
qW0uif/xzVOuzbzp+zasjZB8Hom3XxXV9fku3vezBrTpODfE+32vQxGfh670
7kOZ9daff0yJ8n5/7YNbsh+fUukWTW/06aAeq9zkZnelHb2h0A1sMSNszEer
XGHLRw836nLQzdvW+5vFr6a6vQPqX/144gmXc3Hr2LCibDctuXWPcRUn3Ncn
3u0YNCbHHSufMXPFthNuQ5PsuIdHr3L/Wznhkp97l7lmIa//c/V/33vyxusr
IyaXuaD/Db+2ZFGS69D25p2Nhpe5qz+YXjC/bJXbNTUnb2StU670vejuvT+O
cP+0OdWyd2W5q2j195ap65LchBvHrZ9W/5SbN3no+X9eSHXtpwfd+nqdSlfv
vpCGDQ+sc6NDP+ldvizLpc6as+PmknVuwUUvdF+xJMuNnvLQ6Nc7R7uNbaPj
Xn4o341/868LBwdluh+2JK1Z9tYB99XS3DHTDqe5mztMqfvuU0dcu5COYSPn
JLqktvUi528sdmff/iztopfi3YWdLp7dZMNJN/mXl6e+MSLRFWTdVLx3zUnX
ZXira1rNT3OPPv7ozCe+P+my2u6dcnzJZqnPS75F67uvnlD/8lw3+x43YvfB
P4Q/W8ZnfHZ+4Dr38G1PTawVledufKBoymc/rHN5F9WJDy/b71a/t/mHT6+J
dwXRIU0eveaAe275z/O6NIx39Vcm7nn7tgNu4MmLnnltX6J7//bLHl9dst/d
Xvury94MSXNNEyZdefWMA2Ivb3xhw6gV7xxwsz9Y0vbr3bvckroT9s4Yvd/9
vevkxjrfzXQnP9xf2bf5EXfdmbrHlxbNcJcN+GTXmQ+OuEsmTpr98tK/XaMh
3T+KTz/sgo+s6vnEyL/dM3eNaDf2u2J3vvzJNoPbxrsehaePdbr7iKtx/Ps/
ll2S6I6WvXVVk/mH3fCln8/LOpfo9ja/uuHH5w+7Q//Mm96wXop7e9aXzc5t
KHZXfPv7zkXFye7qoU99FnZdqVv/9LmZA77IdOu3Tt9+52fFEh/eU/ZSw731
Slyt5iUdun85zcW1uHHo5lGlrl6f+mdaBnv74asPPdprZGSaW/bJrOW96pW6
8M8ejmn4UIa08775b/Vb83uXMqmHfMWf9a7MHFDq4l6dHlrRJd/UU4x1j//S
4I0nLy93ZVu/aLlsf6zY1zk5Pet9NyXTXRvS8Y9npp52Nd+Ykdb3qfWueczJ
x2d0Py36bfiEv85v2lvhOsW3Wzzk53XuncU3DbjzirPCjyPPXRZUo8FZN6vo
jsnbgtPcyZnPXvTPqjPy+5BVmXufvzvG3R18dOKgFxJl/472xya0fODx3/e6
8LvnvPbRq7FibyAfKmsf+u2r6d59FH9mfjPjTNsj7mTRqI4Hz68Qect4Hxzb
/8DVXx1x2W3PLfts82bxT+hvYau6z77Z6b/1jhh2aP2BbdLe+aIOL9141rsv
m3hAw+tnfFKn5JjEM4NWv9mvcocXT2p6/peaO6ZVin7/d+y7A+o2O+t+6JYR
vrRJtiuLDet+cMAJ177OSz8MeSHZLf9rZr9uR3Ldym8WurKUSJfa4vV36nc+
7JolxI2ef2maq73h82GPvXbYrd7yZPJXg5Ndv48OJ40r8u4fG/vFSz8sPprr
Xs6b9sY95ZHu1j9zj142vchdvbhWbMYLUe70oJ5dOk4rknhcyRE3+ro7SwR/
WzH//scf8eIXsz4qXftWulePsvUTu+8MebXc3dz57fxm+7eIv3b3lPYvHZsb
I/4l/u9V734SFLow1W1Mf6Vdhzv+o+dd80+9lJsr8/F4643tJv033lZbJq35
e+ZOd/TXvx6f3LDIXdTn1mWJTye7p65e267uvcXuumHTrkq9t8AlXu9+D61d
7PZHNxrfqV2B+7FdcmTnG4pdnYc/rjj5fK4bmvfbs30vO+m63zj4cGL7OFf3
wf63Tlxa6eY1+V/vna9vcV/8c0Ps+3Mq3chLpv342XVJ7vutE2eeP+ytz5Qb
ho06Vl4p+Twfd2x5afs9OdLe6stWfTt+5/mvGZ+99uy4B4/JfvCc2k1yt548
4b5pXNGvcYF3/wPzV9Iz6slFcyrcW6fj5q84Gelivmw8+cCs3S4za26XOV2j
3NGKpWM2jN3t2k8c1qpny83u7/bfjXCf58r7KzqPLC+vv88Vfp1z9YeHU9yY
gydaLEk/5M59WXHhIxEpLuOyJnM7JXj3sVceiNpXd7S3HzBrXJcpd3U75d57
s0/PUR/vEn1PPPHFn0Z+uf5i73zmsumvJA+ZVOG+7ZfXPWR8nHsxpE+7zR+e
cfPf67lg+rat7prBNb+edN8Zt6HjyRU9X9jq1u97+Vj4I2dcnROR//zeMMFN
P1weua1JhLu574LhM47Hue7rm8+9rmWEa/7rvgbPXxvlHuiY9eCksxnucEHF
xLY9o1yfVn3HrtiS4fYdDH1xTW6MG3e8T/HrfXa7hFsm3PDqVzvcqd4ld797
QYbrMSRn1OTSGDe152erNqfsc7e/O75iyNeb3eLHPwnq32e/y08MvzE6K8b1
aby516uR+9z9L72dtrjvOrHfWN/Uj5+ZOeGHg+6rr4N+vCJylXf+f80Nw7/8
wLs/gfl7vsexE8dTD7p6+R9ufb6HFw9pl1z5+ntHUtymNrW6NTl13PVr8/OO
WzZvdQ2zmx09nHfcdRp8S98dbZLc1rKTo9ru8fJpr+/56dU35he7O3Y8dVfN
p/e6hZUjphcNOeEOfXys7u+D97pzb+0/ntnnhBtx5cF3+3QtcM/1dzfvbXnC
NZ576cyDpTvcD781+zQuw5Pn7+a3Gn/5rHL39u2zR+c+ESv8OT1927StBZGu
/69Dn2zVvMJ1fyI9c3ZKjOvb5qJuff897crm37Ax5+LN7vXgyG9P1axwz09+
+9bov+LcLbkDVp6+uMJllqQ89Exxgqvz0OTVq/vvcVu++ua1z0N3ukHT+k4a
Fu3FQ75tf8P+TnOLXMteLfqPrPeP+/ubI99PPnfU7Ru/7/zO0hT3kNt/4baX
j7oF3+1eWufaOHfJX8tTxh0tcZ1OnZwXOmOvC2qz6Nrva510YS+snhoZtNW1
yb++Ub1tp1yvkXO7/nDVJhff671Wv2bnevVXj1//0zUXFrpZF9+6OPHQRrf8
qUuLhhzb5/ZklNfJTJlq6htHuPC8HgOTnzjsvv+uSWLD/C2yvvDLhPVNtzQu
Oug29Pr21wf/G//W9V1Wrrz4sJu7aeimLxK9+w3u35nxV4OEPWK/s58a9PKY
Lh2OnXDDD//Q/cx//Ht388P9tw4+I+uz6NKfOuwZ8R//7Lynx+UuyeWXPHZ7
dqdkab/7/K8/3F6w222pdXBYg6fSXepzb99//fx899Oh5UO/OZruHht5LDjq
n3zx/x+Mq1lrx8P57rf8L799IyzDzS+aMLDxn/luctDq9/P+yXI1du9o3Trr
lIxvZ++apQenrnfpi7f+tuXjjW7o0W43n7qjwHU+8erf5Z+scVNfGNew67JD
sj/WYPSs37NnFrt9S4afyjuVZOLxsW7mr5uXnbumQuyxM1327OnfoMK9+erT
t309KEPyBX/5310V306L9OV39Vx4YeNTfSvdM6Mz57+zK0HOK06o9+/tjZ/K
knjLsfQr/up1wxaxX9BP60Zdd9+epqXuym9LHjx7jVcfPu3Zn/o/v2aDm924
5dzxCYdd8wnTk+9c9J/++jjpr4Lzp9zIV4Pn/9t1s+t8WcqhyhElrkV5h55D
Hkhyi3uu6bz+0H/+0LqMD+9Yn+d2P//E8he3lbrf1kw8vTbDuy+g/U/X/rlu
ZrZ8T/I/L8yc+b9ril101s6/6+asE3pZ8XCbxmtqpIi8RV/XurpH07+Tyt37
+/duWP1kuis7ETw49YIzLsaNaLkxfL77NeG33+r1OOr6/fT9XUdmTfPqM3b9
amSj4TNlPXr3f2DYZR+EyPuxz/ttCz3fsdMpN2Zkh8+6/5Iu/hb5Fq2ij7Ye
/2eFO717yKnf16xwPcJ++6pk1X435r7PIue2mObWn+790+2L9rui1JNXNrsw
yXcfQKPWl8YveSzNq68559v1pUcyvf2mvGFH28TscWd+Pj/q0kvDxD/4rfOA
Pz4tXGbOq4S4s/feuHf/oAKh15+W1Mi+fHKBO93q8tXftVkk9t+Gu+vUW3V8
hblPOMTVeW5x0OTGB8WeGzZ+54Za0w64ITm/dHtx0jaf/XhNrwUV19502G1f
8WTWa12985B9f4t9sO9D3n0CxGdLBua+efrf4zK+IQtXf/XmLu883dCJNaLq
P1PspkfXHrynQ5rIhwczasxJrevdHwD/7ErZc9lH60rc7UsfSqxfsVnid/Qv
aNSjU7/oXeq2N3hlVsnsVKH/8LZNh65emCz+PvTUbdIvFy+/0MOjmrX64UD9
kyKf2qc17b/nszIXuuO9SXkxS8TeD+/1Zq/FA5MEd+j5wOLYL9aI/QJ9v/bA
tojOMyvc6HYfxrcJjhF6wt5LfT34m69XV7iv/v183N21vPstoZe2tT+/f+by
CremT2nM6y+nyvvJz/9kzNsf73i30nWu3NynUa+V7kyj8Ecarsl3j5cv7tp9
8HzX7scLu1/iilzo8XeDc35d6T7r33bDxWcPuGkP3vTbvV9nux23Fibv//eI
Gzg8eM0Vh/LcrAXHhtapOOpq3dU5afml+e7bd/Zvfv30Uff7p1eFT78hx/14
16ov2h864bbNviBs8n1/ux83pr/xZbNS9+CeiQVD71rvBg68pXxT3Em3vPOb
zzU+s8MtOf7JH098UO4ubdAto+c3O9ycqL5nbt1U7pY8/GFKqxO73KRJSWcv
erDcXdnyi22t52xwwwd1qX/JttMut3lB6/WzNrqVIS8dfO3a//jtgwUz15xO
d0+P/XDJ5b0r3A2dB587cV2GaxR57fWPd61wU7pln92xaKN75q+rjg+bf9a1
6PDvTc8cinTN+h54s9PQE658Y9QTvVplu5tnh3zw9EXF7uTuUV/W+zvD3fNS
3uH450rcophth2ffl+DSm/849qJvy935NRcfbvhUgmv1n2E5eWS5Gzs68uML
bkxzf+xt/MLlL5W7fn+seSK2a4L77Im31/1Yq8INeqJ8Q+8VsXJeH3lbdMHt
Z65KiRB+/1/DWvfceHa3+73hmTqzlie4dx7rV/nIjGz3/BWDrggLT3C7H3g7
/bqBu1zte9vU/+2tNe7OP0Z1PNfLO5+8pMG09jc0y3evPJrTaFGNLW7G5rAD
S2buc3V7rot4edpW1/LTou03bd3nsnfMja61fqs7WiMru2Gt/S7y3fY14hfE
uXffvWjOn18UuVqby8d9fEmC67025v2+S4uE3sa9taDJI7MPuP6Dug2tVXe5
u/mZyt3u00NuVvLhxqNrhLp+Sz78bPraQ+6h7meTvl+yxI3YPeTuyy856n6O
m3vdmBZL3JCHlzZv8kax65W7peeyfWHul9DXH8sdddxdcXHj+x5uleC6dmky
9NV6h4VfV9629IrHLjrmGpRNzg59Ps391TZt9RUVx93R+xMnn30zzf3d5+oV
ESNPuO53dyhLXTnP/ds6vl/4FcVuQOFLfx1ul+xu2719dX6/ErdpyJT7d51P
cfuav/XB0JgS91xJ4aufX+Ht5/38WsbZ8Gjv/onlLTK+6PPlJ//5+eMKF7xY
4va9+uewuePGuWenv/3RgrAS9/vXjV74qHaaO37J/zpnDSlxzRZHpbRpnubW
vrbm4w/PlLoXF3WbFto+zQ3YU/Fs8/2lrv7Cl24s6LbQzWz65qUf7S9zg94o
uaD9g8nu0P2f5k+tLHMh754oODsoTeQF6zmoVU3Xpkm5W7l54v+671nj5rYY
P7B53zPu4dMNzw+8YJPb9FzH0zc9fkb0/5TNpX8NOu/ZR7de0uLbPlMLXO72
FjvvLN0s+n/om1dnfnDdeyKPkfe7In95bEDREXfzPW1Khw0MMfkIIe6X+FZv
jLin2AWnb7x+zYQQ0cfIq5PPDhg3PPewxMN/6P1NyGM/HHMPPHT6tek107z6
fQ2WrWzaPVnkd+fv82/p8UaK6F/k7ei/HwtLXF/ihr1/T48ObVNkfTqvbLCu
Z/gPIr/xr1atD77251GHRd+9dvTaktQNpa55yz/fbPVqvOxHSr70oRnrOp48
47bMveOyvZdkuyY/Nf+rRm6xW53d6frxl8S42nULnsgYnO5CDtbr3H5Rqst+
pfE9te467GovvKNH5y2pbvD26KzRbx9zl7545N2953e7bh0nPnX/42XuvenH
en1+bLeb/HLT1UEdy1yvWm2aLO0Z5w716zwg4ni5G9Fz38ZrB21xu8f93KBL
Qrmb1WJI0uB+W1zdu78vf35HudtTc367oSO3uF+frbm1NK7c/Xyw+VX7Pkhy
nz+eM/a2Gidc006Nn1nZ+z974czi6UvPFLvUm6c1WfdkgTs7tsOwsm+KXYdP
b35ha0W+e/mfzv2GPVgi/lavfdu7PvB1pvstfHDhR8WJkp87Jn34yK2Z3n2y
8PuKBhV1nn7piHsqrvhcw2PbZf2wZ6Oi2/1x5QXH3eN/Bbfs3ixR6KX9S4mf
fFzXO3/I/nWvmN1fdkr07nu8ftD7+yIf9/LBjta4+965qypk/WbfsvyKsv2n
3f/uXph/rJ53n2BI4th3Qi+OcaMW9HhiYodc1+Li5AlNX8hzK67f88Jjb/z3
/j87jOvfIM89uGrbklVbvO9/GZ8wJKN3mXvmtgUvHmngv6+i5oUf3nRrz9NC
TyFHmj/Vc8tpt2Lh98XvXBvtur01463WHTLc/2ocjGu/a4e74bVzd15+Ubrr
cHnZ2JI2ke7DV+fMeeftfLfmhwsWRfWIcC89eT5vx+uH3QWvv/tz0aD1Mr/s
39wzYG7z2Ue9fKLuZ5ZsWjL3sEu75b2fWoVslHyjRu8MCq4Ykiby6pPve6Zu
3pnvLm2ybvIDycfc7Do9Tl3UJNFt2n/Lio97HXcv9hixq0dIgttQWSuuccvj
LumOFU/W/nS7a/XTmFn3Dyl2Y6+4tCSkaLs7Gh265rJxxa5908NvJ3ROdnUr
rr+6bsoJ90tUctjWszmuw4LMBv/8dMJNOdn/5aufKXAz0zKjPt1X7J6/8bKF
xVP3uO0vn9wzpnuZWzpx9OC0Z/NcrXf+eSGjeZlr+97TV8XdHuPax37wzbjH
zrrLtxePGN0txq2P+qHTqE5n3WulP9fes2Kz235bbt8Pup916xe+tenio1Gu
9oP/TJ89sdKVP3dbYr2/otxXMZ/vHPRVpfuwc9ikt48nuY1jF6wNb3rWPfpW
96CQUf/Z+08uz2saVOmueDnl3jOVCW7CN6XtF8zc4xoe/bR34z8T5Pzi+QfG
Tvk9d637ud53A+p+fsw1WtXu/Tv+TXJpT376f8h667Coui9sGFQEQUKRkBQF
EVAxKEFYqICogKKAICWICopg0CWYoKRICkqHhHR3dwxd0l1DDTOA+s17ve/s
+a7n9+e+zpyZM2fvvdZ9r7X2upesjZZg5KGffeLldhCriBriJV6Po15+1h84
Cj1tqmvxjEvgVZYgyjxVA7Tu/lfMxlZhv0TeLycfPyAErbzhuLoEPo9900NH
/eCfQjfNGv0Sms+WSNG7gWFY2KrzOpB3nnwe3DpgYGJ5qhf2ydPozZ/Dw6Gn
e4OoP/UCfk/932uqeKRPsd+0WaV4axEWdu8XEfKthxVm91+WvXjgHIbTFE6t
aP2S9mt01gecBhcevKL6h1OYWqEwzZTg5kfu9/l15XFwu9o2TLRZ8eIqq1C9
F8l/hJ6NKdy12A2LN+PuyT1pg5GKnMelRdMQG8G5rmjcBjZzy/wTBdMoXyU6
9VeVI5/I17X4C8a6fqN6M1J+PHHpLhWPCdFefb/S//bSOLLvpPr2LpPxlqd6
W+Btmduihu/8j35cPvCs2k92zGOh8ffpirS0AlCfKqM5a7IMMrtlk5rcB6Dd
QvJRo8kcSA68jLzI2gfclhFcdaILEEJtmEKj3gXtqg1J4dsE6N9/6JHr33RU
L/z46VbKdEMicNOI8TVpT4KAkNU17l1J8Nglkp/63Azw9EhwG8cWoudt/vzl
U6VSGUwO6J+wn8NCl5Shb+KbDEj54v3vsd4kys/pdt58PCE5BSmYsQKb67ko
X08Iznvz90oVpJnnjaxRzaL5ULvJcH7r5izoL9lND6g2wGObmaSy0BnI7fyU
KLArFvnn05m87ze+RPwn/hIBttJ1VnOBS5C/O35Lkrg+nzK8BgqrOVi+FYw/
ld4AVnwmPVHGi2DSx07Z5N4FYWy3alMLFtHz3vkW2MZHxGNJZ9cvR1lno/VJ
8vf8WrzRFdUrMPfiXRS1ywgIULHtZbyAhflsGf87ISP/0aeMgxuPGkJf3ViD
QRu293+44pB/dhKfbReiz0NjzKsRTYHTaf/pZ5AGx5me/QsrWIf8qetd5v7l
IBm4HMYwvgrxTz9/GRsuQJ+nXYsXuYpphRNup4N5mTbI9Yzy/RzzTGuQzpvZ
NO5J1ssQk995IfIvH/F5Wg9nfX/GDjBc5Er2MtmAoqJoOwexDlSfwOHG/nHx
7gA4D4U6lKptgMZUmLTV5xI4mB1q6JC/CTnLPx42f8bA+avXmfwZtsCHdiIj
xzgD5VtI/RWquu7flsINARfP92s066XwCruRwP14CI5zMo/Sny2DOp2DeMVr
QyB34TbW/9oA2BWoNrldnYHURy0/C1O7kL3n2PwsSenXBXc7g83TlFYg31R4
a+RtF+wvmFJze7UCS8YJLeH4EtDkDzK/3LeGzv/o5NygP/NpHY3v3u8K22tN
QPbpfFE97emWXrDMGizzwxWDWcbjvhSKPjgc4vxRIgQDezW8mB4fH4XKV7On
r9zEAH/p4KHv/0aAvmXPVwr9HuCaN7OLDxqDvcXsucV17XCZh6f3bv00qMpO
amBb2iFEEF9oUDeN6u0K8yqPMN6ZBk+fArbO4z2QMn31jMzdaah7jlH5cq0K
3AqitSsTyPjxXHaw1M+MBaC0Cs7/k9cOr+8JSF+qXIBTDT+tOpXrYEXp4L+B
lxvgZ8Nv9SK/Dkzo+0ur7m+A9buCgO07dVBc/1AmBcjndz2cVhLO8GwjfKmd
q50a834Lgv9ilEc0Mcj+zLn8MjNmyoOHXOf3rF0dQPaova9MQrGxH7SWeIri
7FJRfSHpfP5WhO3fzHujQMntpPl1tBh+3DVVOHFoFMZ1mLSfHisG3/mSctvL
o8D8KCh234ky2LiHo9Yn8vGTV/8ljYoWg/g3cQOHp1NQ2/ZqPytNO0j2010+
ND4NnfXSnou23XBut/QrEYNp2JZTFO6Y74auF+dUe29PQzH+i8On0WBkL4wp
lj55CvqDdlG/u9SpRbg8SdfxzqcYPOIYzu6xxMLP7kQ/heIu8Cm/oF8+vwzO
Lz3zswu6QN9yhQH4saDXWWAZ0+pLPr/Qkuq6fMwPrtop/8q8h4Xz6rW+9Ow9
IJh2LyTr4QqcbePyiaOJBHcui1PuQasgfnxXddi9dsiv5qi0xayhelGJ7S7d
0N1rYHQQ96uAoQzxndFLu9N5H1eA9Ic1Tu9gHLKPa1Qj1tuCePCIsKSr/1KJ
7LfKBK1qjlYF8n8k//X2t9Zue3Vyv+QVHfM1Llk8LM73pEsXYtDvkeIjEMXt
Kpa0Abd0y7QZVHogPnCDhSkOD2fn6iVVKWrh5HH1b7tuboMWtUduvHwr3PcO
6As7NwK/6l11yspqUfyN9HunWbXmaXGjkBKhLP6GuhYM6B5FUU4vwEXlQ1+m
NioAW7h5WO7BJlzCcLj1fasAwuHXUvu214GFufVJ0uEB9HykeriNl9ruvr4b
KL7YGlS0UuEyDX2CPS2UJ7tAZHfvxprnNPyZWmbc+7QLTtpesTZ6Pw1bQp+t
LU92w2hIwBv5J9PA7cmk49TRBSovMP/u2U0je7AptbBxiYinBN3U8EkB9cCc
8x2nKLoNqzMncM/5GkBoIddWRnAb4YtVZtf+GPFtyNgqkVA/2gpNL8w6Lots
g+zorU8d0a1wpIeda5N4/5b0jkXFhzZw2v08HHdqG+QpCs7aqLSB0XjgTbHz
2yCxO8gY87sNfKUtF8/Mj8BksLmKrWoH0K9vs0R8GoXMKSuhOwIdwJZQ/1z/
2Sjav8V3y7vpd21BQqz2+VinJnCOf82XdWALeP7k5yWdbYGwqpl02kUC5Kzd
5F6ZbIb0W2WXrm8Q4K1Kyr3Hnu0gMmvwuGN0BGSHKXSF92IgVkxHQ2xhBLoX
6TQHTAbh5VPDwG3tdehkCMqIYyTrE5LqGaUF9WwSzNaB7WZvjsTBOlTf1nu3
9GOGWz2UvuO55klVBAf5vKnTfRpB1E4io0SsCGwSIqz4DpSBf2jMxH2LXrBu
DG+x2FsGwuWcHpZWvUR7Em3GvNUDTCpM7KL+0xDM6+a5ydsLZiBb8SBlGrIp
vSuOGVcD357m3xzn8XAzS9lXjbkKjvExxIbH74DUxQBl18Ya+KN/XJ03bQcm
HVrmVR3qIGB535cjoTtovvfZyODL3u3A5WIh9p6yemhj1zy1/pk4Lq97XjdT
D1a4HG8eIv6WuXGvwiioCXboSx/SBu1AaMEnd0YHIp7OTDth9GsS/FIOXvon
0wof+JJeFEQsA/w9ytSx1QDxG1tanuF4MG07aK7zuhJcXvmcZrw7CFeMea8+
qSbrb1g/iQ+bwleA28oDe7OTIyhe0bFP85gZdgSErb9EMpeRzw+T/IFVm4ri
RM80KFlmfjDcbINj54ZT7P3nIJ1dne4fcV4FHlyPfXZrGZSsuJ0+1TWBzMGT
PEJCeMi1WCSUt/Wj/F1b/VTM2w+NMLY4JRB9fAt2e9QpFIm2QMcFqrysiApw
nInO0NxqBi8205t1HBWg+nLI7nA8Wd+CZG+65teiWpYmQFb3s0HV7XKw8wjU
O3BoErq1VJ/5x5TD5doZ5l+7J+HXP7qlJd5K6GjXGTJfngDVX68KVDmI/s6s
I2NAfRLFw+1Zq0t/P5oG4fBAu136eUD3rEmyjn4GbiYuP/us0ATKxWMLHG5L
oBb5/pVCXhPc9o3qbGpeACHZ6xwWUh3w1pK75/cjLPg/t2yREe8A/flE1Q09
LPyWV1ku98CAZ7fmpYEHy2g/lQxsmVobrMPKywHRcvYWKJxYcN9WWAfWt9fX
Nfua4Zgci+0/1XXYI8rqirMm6008d5DZVcZUCXOu+B8X7Qig+fneyFBpBbyX
T13WMCNAwfvdnGGrldAuNll0fpDMpxfN737hPLsNojv7wi0P9MK9IAzTVOgY
rJqe2r7G2guyfDNhC9/GYKlJkUVvoxeOVxLKP22MoXrJj7e0TGXmx6HU9v0p
6o9F4BQTafjOdBb2DrU4LRH92wbGp0dNaBZsV4JxK79Kodc9s7uufwbcn14N
GTLHwJfohrYH1ItwlucSo9zFdnDM4nMwiFtA/kmL31jUW3EJCNdLNejCx0BW
dG1HzmQJZm85svrQD8N5d4dU3t/rECVg9+E+4zB8Ceqm7SCOS1PwpWGEYUhX
UeZYPLgBdxTY3J7s/K8+hEm3XaNdygg8ija1eyufB+8SwlgeDo0hfJFqK+Tb
c2AS1WdaxQbs1ePFIn3Jmayu9lTaVQijoztaxF8H9h/WHDokyPUQllGpfyJY
8YBfP3/eW5Cs9zBcsv51WrkLatpZ1CYjxmBMjfrSFdpuyD4TYjeeP4b84faH
Z+Ja36Yh6vHVAt+XGAh49ncmNXkarnyT8PL0wkBEc30rLn4a/kr4ae1c7wB3
n9Wo41+nIf/zu13A3gE7DDozNcQxz1sLjeUbY+CuJBn7kX0JdF//3a/I3QDO
Hy8FW7gSgMGCPbtavB1GFf/K9nbgYSs9+kSizf/qNzjR270ZtsDDVypKC9eE
bmBZasqyTRqDCQq6z/3h/6vX8F28OvPF+hoMtYlkXpSoQ/XepPNBF3MKC1Yn
i4GGYrzRIKQVGh0tDroLkvU0SvOnd5+yX0H9lJ5Jj9n67CNA2ZHdH2Xhf/UV
NoeY7HAMBMCOXPxevqcTZFwfND0324Yw5qwZPfNO1N+JFM/tzV60jRIhn0fK
1Rd80LXYi+Jh7HdfGw6HjsMuTZ2m31mNKF5Lst+WF/u/yUaOonpwNqw39rPV
OFAaKa3+OJwFFkOiPuckyPqJ8syqz/tCifx8lH855FAuWHF5RqZ8wCL8q9vh
3WIwsQBJK+tfC4XI+gvSdaET0u2+cJZmk/KwzTKc8HtxTYE4pmwS2k3nsAyD
21074de+IH6i91p/T6AlWY/hqsH67Q9mrbAZunix9XAtPFCvvI9zboNRveyV
Gx824dVdS8F1bCXIyF7gddIZA7xtuKjAiyqoeKetefP5GHRJcjWm/x2FqyG8
H4I+r4FwX41gAhFXLUCnSsiXNTA+SR2gFVoOgyXGKUZYAliGGm91nigH8eHz
ibvryf270jYkGZWMtkDbs4TTQbIYnS846MCepC3dDpkbHveeKOFgYkyv7K0G
BvkHpcWoD5lOUeDiohOtkrAAltMUYo67Y8j9QG83X/95IQp+c2GqmX9j0fvm
ecdoPdg5A5bRbVFzL3JRvTSJD7ZFu7IxEPEZab+b+fDN0VVOQ1l6r9mlHx/A
eY43oOXpDOy+hnW353ZA+dje33o+J06+gvl5JZr3snNwG5fh3yj2HIZ1aIyn
3OYg4J/UhFEnWc++fOi0pviNAmhK6X7mcmodXitOf/xnWQDPkuOKwm+vovxj
S+bJCa7YVRDehwkW7yn8j75kBaSncx6nukXcT+63LNM5ytH1+5MNy/4yZfD0
yD2D51KrUNPN0NJMWYP6f5pSy5uli4aj5/9xZ7Tk/N0yOPF9tPaR9STKd3FU
0NQfkZyEPrf1BOq+MnS+jIR3J27SuK/dXwLu8z8Zkn/HwDLF0ozwmxW4l3d4
6XbQCDT75woL9K5D8LbJSyu/EXA59KMgeWAdTiYovHjV+L96C5fKKZvfBZPr
m4+pv9w+xrMFocOt25Uz1TDYFnj+adYOwiM+rfuYJYhj80u1ZrJqjeDwtg3H
RMRH+kYHBCx5G+HQPclnfe47aP6PWromYK4Mwh2nMs957RwUf2zXu6F5NzAL
lIM1Hl2QGgKx08P8iiZt8IA/TqT7/BKo62Zl7Hk1AI3x6R/Vqsn57+hUhZF2
z3Xo8zCW9OHPhyn+czY6jjgQjJu1qb6bDXsraXdlZOFgSVSdnUWyEea9R3xS
9QlA2yk7cEW6ETSujFqIE8ekertiFzcqsWsEYKWqdlDc047sGTqfz8/5Le73
NrRZVNhGtJD1GBJUBG4pcVRCAq2HesH9eahcX7LwHIz+n34hOZVvXx1vmwY2
AVos81uy/jzJ/tGrdwoKEPHtlBdtG4NzJyi2/FNrJo6TRkqcp/jqYOD06OkD
2vPQPOwwp2tbB78azzx893Ueff8BLevX46eJ7+cFV/WQXRvqv+CpUenRadAG
qcJPhc/6rAE/3wMmboMKxKdEdrjTVoRr0PkUkv2+VJrTkVi3AQeFoGzv3Srw
bhl/HbQPD3YGTKOhNbkwpHBsMOYg0b/SKZTcYylE/JOwzax97Wcp3P6ae+CS
KB75d3XKbpPPmmQ9iJ8iXpxJd8h6XESKwfuMiMeNE+8YXFEh6z2c9nuY+GBv
K+p/Qjr/n6Dzm+MDxzg6X7Ok0mNOYNmAtE8atXQU9ej+H6mMOcP1HeDvuOI2
8GUajjgHZ7v87QDz+ZrAb1+mUbzVv5b1/n6if04q1As5hh1A+TcSv9mqYYli
YV4F+sHYLU2XevS+ftNJXVD7Ug0MXXyUal/bkH1tUjq7q2tfF+i1Kiv6MpLy
ix2oP7wj2002LgJZD6LmQ8T4X+J+IuWjHvruKHu9WYa+vf727z/+r96DdrVL
07wPHg7wB0q/ZSmHbxR7miWGByGT56mskEg7TPIf1a4dn4avqq07to/aYTnF
T7ehbxpYDtEzWn2tgyYdzFFjuiWIe/zCQbek7n/6OYxwNtAa8a1DroRFwtDF
FnR+MfSldF5PXRPCD6TzduNCdN/nJUsQfnYaXfRyDCiD5JTOA9ULzeg8WffD
g4pH3Gsg5cHzf/5XiTgi9F6E+81+cL2XdPgxdgIutQbF9Ka2wjWV29xs+cvA
Kz1gut3UCrbbEr/yS5dB6MtE8IF2cj9gdna57p5nRD86f2waTi2CvlXnvt6H
Y+j/oH4llb2H9L9PwqrkNf73CiFA+bocr9i2At5nKbqpCUEoPi/9biXcPbkd
Vn7PlKrhNyErqSqRWqQfYu9nyc5ZbgLL+cdthx72QfFy/VDALjzEY8vvvsrG
wJ0XaT5KbQQwc0/xdRduAp/gYxvZf4tgoLZh7r19E0yWUDC2NhSDcBVnVp57
KYjw3wzlGh+Dg398VxT0SkFe2OhbyMIYNKbfTHEl7t8SQ8WPz63nwDVJuPud
8P/qTXB3zdDsTcWi87s75QWNMZNkva9HolsGYj3kfuUSlCuTNQ/WIFb7g2fM
0Vp0/pL7gJRTmmIDmJ5ZbnUb2QQd1xqMNH8DTAkHXAqb2QSfpcV0xgdV8KlW
28DgIlm/gka+udbmwSrg3ZZw0vPtwJ9vF6OmsQmPBWT+EQba4SBm16DX6034
rriPDaPUBHqltDLWUhPg/NT/PKh8g6oLS4e8Ls/Bt+qmo05eoWD7S9ma4DQH
TNuH+KOT89D+I+EB138Oq7NMq8ifUFoxP/7CPArTuaz+zPdzEZ8g2UNu3oz4
MzYbcD5BO8eUsh3Fr5/rsQnrXmsDF/imJF+1DmPW1qeozrVB5uNH/UJ5a2h/
1U+UK2A+ryN88l1abFu5kXxe74K0Fcvq1xm4c9AhIM6iDG5RD796kzEDU3Uc
237GZVDbdmRjJnsGrh5I7AvaKIMJ37n6+uAZGC2l1Nt1qRyKDLtGdQJm4Fk3
o/rL+lwonvr6hfUjWW+jDhPZfHB8AroMfUbSGupR/RoJ77JRmEkb506iz/OI
SVq3GZL1nXYrxmy9/jCH4mUZ7BKL9TnL6PwCrkVOX/nFCgQKFH16VXAbrf+U
H8ZhQXe7/kdvJApHs0vbbhVSRzfYWU3L0HlE1F/MzOEx3c91OFPwcu/+SAyK
D5HwhW1YU9PO9XU4Eiw8SziTi/xFFU6e/cXtIoRHSPH3XQyymYvs5DF/bjEL
s9gW6Dh+nHn4vgPdv2R65tPH5UwQ6lqmfN++BuwbPBIORP/+w6GLmZaID5R2
1fk1CZXB3nV+Z2ZOHHSOqnn3XyiGLp4bJsntOHj00rT5rlQKRLVucRr+G4Gx
gfLXD7+PQdXJYMuD/atAVTWYe+RxM3AdcD5pRkmA9w7L2p0yLUA4q5i200Hm
76t6t7qfDnZB9OWfjJ+/VKLz7i5DMlsJXA0wsj5zlIu4XlttalX2iBRAENMp
u5+HV8BYcNnj8DMi/+P6VRvDOA+W/vXcbyhbIFa+L6v7+zx0Pi7+tjcrAgZ8
XkZHMGIh/Mew9vUb48geMD33bZJxrIBTTq67/2hvgMNRvvP9jysg03DB3iB3
A17PHvjcoVsBP95W1N00wsGA996wIa0KqF0rvPNzYQMkNI593wyvA9qu5qNJ
Ing4yDKJreGsh/o1X1sDNnL/viMf+p93VuAhlc76Q2dyGeIzJHvUpxppEZgz
BLOeWY43fuejfByp34Fc4PCl7OvLiD9+qHp1LfLcAspPPY7d+kuTOQZW1XLK
4U/aET8k8U+lnLYfitzb8PSpQ3Z8dDkE3vTi9CTuv6iLn4Sp9apBblQ3ro7o
P3ujmSRXJaqh9NqkfWsWWU/K4kGGuMXdQTSmzT8lkSI5gvheRnT0V9W0OWBj
3tVu4DiK/Ed4RHoFe10lwt/PM0+F7D7Wj/Yj6fyqXWuQtX/EBKgNpGcyRPbB
1/ZcuaEf4/A2eurdiuYYaAenn+HjI+tBtO04tz2T2YGf5uKdLeGVaL+R8INv
zDmNCdFVuHVdXtt/owvpoZHsnzhMsdXEjUNGp8aG/5VchDdJ9kAMn3wkX3QM
smzCT/iXF6B4PMme/mE6vznrPobyM98NaCQvNk9A7ferCu950/+DX9NA52A4
Y8rFKbC9Lfo481M6ivcdecCyhpGqRe8Dxfv5ZLd3xCfB++ZnW9r5OvL36Voe
D9NK/R/9l97WtO3pCSI+NlqcYrKMJ5+P3ZNzyGkpHfHFPzPhOYolTWiM9NOy
JAaX9qwiPCfouZEYVbQKJ2m7GJR2dSF+ZvKvoztxsPs/+hE9sL1rgHvrIzm+
YWdlqmHzeRUEjNI4hoU6UDzFUp3jm+AFcv+5x7wrT15nYhC/JNm7WmXxxzZ7
1kDRbtEiJr4TXSc9r7AMHscxRq63okmlmKUoX4cbQrWqdhcx6PulipXKbzBh
kP/quvrqIVdJB/m87v/LPxwTjvE11cbBaTvVjQivdoTvSd+fn6QR2vpnA3x8
hHidizpQvhf5V3WJN/cT8MC0qyjHxCcH2eODkdj00TcliA89lPnnYsddgMak
9bqe5iGxFEvmj5tOdwKTHuIRXn8r++shKzceDl1zK3sk1ofib6aiWeMh/OnQ
RJvbfPn5AoyGVmfhTDGw7q2hqlm8Au1bp7KePcCAgEOQ9mHfFfjwe/A3TiML
duKuxOm/WAV+y60Hvb+SoIHqH7vj8hp8YeGxVHbBAIGnYmxf4BroBC9QZTli
oCyJ7bl6yBq8e/f06+3hUmivWrCiXFyHOZr3z4bnSyG1xNB11m4D1PnFTJ2I
92uvOLEPCeKgX6BIodwZA5/3v3U9IISDC+sG8gp0A3AoXIXu4r8NOLq6ctTz
bjEMBLVLHczDg+vzxEdmvEWwoHUUrsUQoG3Bxmu5tQfqb6ekUjriwVv6SulR
80rQwTieNFhcgaYGpsT2vAo4ryo+lpC7ArcbxMwYsrqB/qIqpkt5FZ6xnZAM
iO8APrdvDd/i14HTVSwvvaAKpmdepxo+24IP3Ja5LkZVcGH3AM7w4RaKX3De
ii3uT+qDW+oGuvM9NVDVMyXFxDIBwH/aJeJuDZywUN9VzjUNA+VqDu8E++Db
PnBpj5oF1psJ6lGH4kG8O0NQb3AWcr12Y3pXs8FQ8mpN7KEF2LcwcOiIbwLU
5yfaGN1aAq8HHQk2hQkQcxSvzcq+BPXX6d/y8/8Et7lm9+8/F8B8ySBehDMN
hr86zdR8XILawV28LvppwKSusEs8bxEKdN9bHeVIg4HVpHt7jizDo5Pxxs9c
0kBXNMn4yt9lON/d8o1iIAta32/16lgsAwdudFpLJRfc2mZakytWIPTk+T/C
MY1g1jvl8XhlFo5QxD47GdYClrTF9Jm1s+B668OUtn8EJBflM68PLUHK0j36
GuV2uEhtasR1dBWC+Ow/RGpj4KSsfuwX4VVwlmMI9LqAgTbjDVcDr1V0Hl01
ebeh7NYKWMglt2ovd4C69rfjFxXXQePlF2rLrx3AGu94TkR1DWgX/7j2G9aj
/RfmOcJW+rEc7ReS/TcuxOaP7yEgvnUn6cH5U2l4qAxW/kUX1IL8a06vc+e+
lA7Ibhi8pSC3CaKfu7MEi8tgkf/q66J08v12xjsLo4Lb0KLFPhWjFoDq6Ujx
79vF/m0BEtsQ9ktNinC4CtXPLenH0Giu1aF+bKT+SpzP2nrKpNfR/Zm19zBc
XhtgpNZBmUJXj/J70T2/sg9Z1IOiozl9HWEDhF20aYpf1cMPZ2efJEocvBWA
ur75AditUqL+kfj+JqbZS2U9aiCsZ//F0sUN6BuUE2QVrAHHdErFDPMFCObJ
Z2uxGIJRMbGheLZVGDQDtmy/IchLSuUzOEC27yoVycoxnmPgta82UkChC/Wz
QPHbxFQ52/xpeOoAYSOL7SjeQsLHGwMNH2vUyPoPKVNBmxbE73NmEGehu1SJ
3j/p+h8ZHuFGV/J5ZI/XLVUMs/OgUJU7H1pTCb90k4IGvhJAqFjqrCBXFeTL
zDQzRhLgfGTm0OfZNhBOshNWENgGkTDsa9GZRoDFR/Haj8jnHQZVxwcf9kzB
12M+uRZ7ilH/C9L79/SxZVnkXYAZl5ssY251aP5y2PznBU7mAMFxPBpObMLi
fs3FkCctIE/7/sQH/WG42eE3qSbSR9Zjdg3mzbuSBpwF2ewnbGdB/TP3WbbK
FrjCtiuFT7cKTD7LC3i2t6B6fFL+IMUqpYqLpRZSs04fOXopG6gSvnzScBqF
hywO2J/O6RD4snGQ/c0w/Mx4RSvvWQbL3zR0sG9GYJBK/sgp1jK4l7TnQMjP
Efjx5qXc0Zo6kJ8qX7tlPwxa7VmRlbtrIew7o+0h3VFIn9O1zn1RC8YPSnQk
8kZhO2MXu2t3NGwJD4ZT/5qH4IHvukvnYiCr60P1os08eB3FuFBqZ4OugeYt
vp9TsHY2f45FtAoeebfVlP2dAZHhWINrmY1AFSSR2a8+Db/qDTvMZhshosVj
950rC3D6W/JSXVsKil+X+UjeqKhogz86IfoNdFj4Z8RR02yGQXjBIyvI7GtG
+n/qqzNhdYbq5jkifyT50+svdfrqotfghbHgpgFlBfAJrrGnn19D801hkhdt
7rEBv+vt9e98LUT+PRIC+ar82mDiaePr60kb0P+7ipJwuRsoFD88UiTeL7os
/ilTsgsybjtIacqugt5G9Pwd5i74dzD3kePrVfD5VConcjEP2Z/mXS3Np8wx
gG99PnKuZR1C0h152E2r/x8ebIfbt2n4xi9Xg0LmbH2dPwaMndS9jp+rBgGe
DfvqBgziXzoypZeeb83A98DpL0w3S1B/sm+vNr8CzQDCcyS+GRFKGBHcnIYJ
QYzo2KdIVP+s3Pnmwmf+RDQm6XkEJX3qK/VdRHhmibvvljzRn0icWTCh12pD
eJwU/6aOCuGynsSC+qVPOfEmPYgPkX6/6WkdJ9+HFfj1cEV8l9YA4rejgaff
cnXUo3gW6feOmjjQv8evg9zKLv8rQm2o3xHtxbzd2ucbEf4m8e9r79XsEy5s
IXz1Ghu77TE1gvBflSTWbpfcKHAqyGUz/sH8T3+1JCfPnLDIMYjlNX9Tz9bz
H/tVAS9NfqqlXSP3083eb3ukYy8BjSXrRCLObm2Crne5qjNVM8JTJPzNLHjp
2fmnW+j/ibpa+7jNk/X9Tqy+P889swOFzXOfi3pbUX6C9Pn9Ft0jih0j4G8m
bLZnTxsUXeKx2qwcgTSakIdmEfHwnNW+MOTqGAjhjmNb2H/BV73OUY9/5P5o
hDOCpZvzI6DHxnp4b0MbfL8qHf60axo9X6z55o0bRL7LutFa3DZdi9YDKV7l
ljfQtjW7iP7v8copv4gji9D1jrIieqIJ5eNI1/UWGvm1ROeh9914vsm/ZmQf
RfykFVczIlC91jGLy0zfhtog/5jP4LTMCryKjTXNGGmHY7RMgX2qxPm/kG6R
K1qE9s9BFbvhMI8K0FM8UB6PxYF3t7QOl2UtGPn+FDmcuQFONAF+GlAL109/
+/WxaAO23ZIPNgVWofkgxct+s5k8baMg42WOIDuaor+b6H2o/jl+7jIVWU/N
cGlrbrQED34KW3nC7D3IH3m84pVpdCtC+WBSvfxLhqBrqtnkfuYBp2PLBFs2
of5rE/uCUSl6noDfuoGOj8sg/djNL5q+xO+/NcWlZ14G/FFW32T98cBp+S+A
g7UcHn7W3Ho0gYe4mZqpvrPlsCykVsexRPw/WiKO8o9rYG5HhSHozjZQHLeR
HDjdB7sfldpKCo0T8ceVsus+lfCK1XfPofJNcNZYG7WKrwBn/6mJhbr/o5/N
GR91rRn1d3bTGXtgbDMINmVeyja8q3CGf8xj+dEgnF4/cM+GcxUWT7VmqgcN
QlQBy0yg/DqM3TB3KaCshz2XKpq0zHFoPybu3OM9O1uAzivYxDior/+ZhpAj
Hg6npXqR/ye976lT6QsvY3bQ+rnha8B5I2EH3m6yZZtXtQCtzSRzw/tlOPdA
yjfvawNoCS46VWSQ6+luvPnHEft5EI1ZA7i5BGXJ9TgVTmGP4yPmkD0wjEoX
CWifAxOhNxd4drfCoZCgmkf712HzpNp10XOtwKT0yOoT5Trc/qOi/tKxH2T4
tQZcWTZh3r137vxYFTy8lGNcn0OAf8Jsoa9DKon4ifsSldoWWl+2pgkH7rZO
giTbFQ3fokKQaNlryf5tFgxqDlBo7WDQ+ifpG82bnOfNuYslPx9Wv9Gwaxmk
ct+LPA/GoHwDyf9LC0YuH/65DGynr1nRXa+Bzkml2MDXOPT/nRosDVXlCNBE
d0CVLrgC2UvS9ZtC29MrB7bgiT57XPVEOZp/0nxFb7ec/Jo2Bq/wr4bfHO9F
9vCGopxzwFwJjKytnPRem0HPG6M2csFScRHV00eBbtEzyg0IdMeURDANI/ud
nD7QFHm5EPjMCfx5MAE7hq6l17ID4KQ/jlPx/gpUc6yoDuKGoPbB9LEX2BV4
t7rscI66Dryrfhm4SeGRv3l7mptlLWMMnt5JL+88OwbM/kX10ZRLkH06t+7n
7zowWT4lEblSBMzxqnJJYXUgnTj0T96uGNlTdpOlrgXNOdhX6Hquj64N9Ues
zeQxanNphmbWM1pnwrGQM3bEQG29GT7w0g9sJGHBKyDFS/JzA3RetDex+7QO
ih9uuseJNULJzOta58/rcIqFS+D1tRowdfwb4HCAADEVNo0HH9SAl98AVuYg
AQYuzw9VU9TCXt3Ao3qMBJCiVvuiaNUOXjv0HG3TO2BsavrM4UojJAW/u2gT
MAarTVcJOKNGUI149Eq7Zgyy3mWPDX2uh+D3y1vbQhOIH3D3yW5mb27C/nZW
jZOHGlB/8eQTt7ViNdtQfJYUH24UoPfsS9xE69XiJVXQ5v/pr3fvBdfIchWa
b9L5Do+Y5aLCwjVonw3qMlsdRfyEZqX8kft4Ibj478zNMWKB1kLR8ed+DBw8
+DJ0lXoT6St+NI7s/3BxBViV6mcOM/kifELiXxm8mVE87atQNMp417iyGtJl
Lqtv5TeBG+e73It91XAk1b4+wr4RrqaWWqj8KgM6lrf3CPKTYKMQbuTFWAPp
3b48Jlk70LRooC80nfUfPb0sMGHlSPnjgkP1WZYOOcm42k24ttKxINXXh95P
jGNU3FRXHyxz+3v/qd4EO7qA0NqWWrh/TrbI2o6Mh1porXTGWtfAdnW1REOg
Den72M22WJhpt6H3Q+pHLjVel6idtga+p67gjxP9FwlfXm6Os0lXqIGb97qV
vr/EQX7ih99mojXwdP36UtQFHPK/5wirPK/P4eHRmIJ5gncBSHNNTndbbMIp
67feHiEFsG9LKsDHehMu/32oZD6cC/y8DKJ13HgY8rIavb8XA7XCt9n76nfA
R7Pi45NRIv/isixsx+yA0pi9iX9JFRzXFhqeP9sJ5imdNy5KVEOueyWlG+UC
ZJ3TpPnkVg0qGx4xT48toPhvOMVvTbupaUgT5z3R8qcPBNz97/2VnUD56rDQ
W7fC1LaRfef8kVuXb7oInPbUfuXOtaj/MOnzQ82v7jyfXkB6Nw3314y7uJcg
45HXncT7HdCYLyLYIo+H3wcPiLW/6QDJ7Uh9x4ZNyE7+nVtR1o7mj5RvK/T5
HuUST9YjuZaoGVBTSeSTCu9dlgy7oZCrqjqUhQAndUVCpFfLYXfw1K4AnR3w
svkZwDhWCy9l+hounFtD9pIqyUQzhohfd0SDlBi8KxB+nXnr3ciwUAZTDfTd
cZ9XIaOhkwv7owsWJjVEy1MIKH5pRPU5MYS4PknPs7gmTuPbNAM6tHODBzTK
UP9CrAS/HgtvITSL9DFtFa5Dwe5NuQLbQvA6tKC1j20Dbm39HUy8X4HWd+/y
BWHq5+3QXHxoOAW3Bdv7h9vkFerhwrcVH5Ze4n7V8NHMEa+BpkGVh06pq4BX
aG/6gIsBmnTTU7tbptB5mEu/ss1zTaeAibBfHsedgOLJVYZXCvhwDTAi24wt
UJ5F+TiIu/4H4zkL2ZhpvjfGsRB185TDzfI52LL0efv1XByyp7iCMzfL7jfB
PVv7O+mec/DYoyf3ISYd8TcSX3uY9PRHg+oqWJ6Po40yL0XXUb5YeLCW49gq
XLTHUBeJx8GbBL+M5atrsFjw0XvLPgwc9OgPJ50j64sO8pbEWH8i9yO8B/Nx
wj2rMJE4JBiklY3iz4OpYgm9gjnQLm4ZHBK0Dv1fJS5PuRejeOy7khPp43od
8NO3Su8a9QZwVMTuOuzUgfwZtV/VFd2gMsjwtxB0PrsJh/5mvqnSboRY2j7/
tdebwOomvVDl0oj0Poq4//l4SLVBYJBAAX8oBjJ1M2UvHfj+n34YEdAYlB9w
9sAEvKY/tizHEIni678j1X5Q2P1E49N6nZck1yNAjcrGyuvVDKQLMypbBWSB
ThOzpzvVEuzT4DU95ZAFvTLvKt8+XEL2n/GIzXKA2BK4Bu0j/DjR+5/+9b2Q
X3E8e0WAeH1l8jfDiwHwlLqd57W2CE3VA9gc7QEwembTVxK0BC+b+KhPmHYg
vh4r73Hf9WEHmFyuztKzX4GosAUb+SOlMI81kpUn4in3tGDTvDelwJZ0iXNK
f52IQ3Ui6ag7wMFt5/MY8zrIH6KNOnu/C8XTSf5+9c7waZaz68A1cCI9hbMD
xe/kNnwIe2g64O1xpwoGKXJ+UmlJiz4iZhtu6HdKDAx2kvUQbZ76DRZ2wh8D
uqlQow3Amp/z4/aqA+pLNeZ9F7fhnRa7YsRGHVTlNKX2SG6j/WsvE7rC4NkK
HhgIK3xSB5rDs/2PosYgzlZoQZKtDqh2hmjcbo1BU2QgjYlwJ5xNYWb05BmD
uqkQA6f1DpTvIfXTNtrjF9OGHQWu2I99ZSfq0H5LXih1TPeugy/urweqdKfg
u5jcmVdd/cD7OfIIi9kUNHLDpY0/yej8zEUJ3KN32Rlo3ODT14yPTgZc0WpX
w7F5+GQuLLR3PR3Sio8xjnyYB++HJz9zLCYTcVlNrc6FFRC9039iUKsT4dHn
f87dN9PvBMvq2bpYESw4640LOj/vhGuu8Wa/3mKBrzyUrsezC833bV6Vv8pm
nWhcqSQWy3HeD9Uvak0UHxG45Qcu1FEGBaZYmJX5mjBJ9QWi8fQqsz+wIKNi
PhOZ0YN+/6qO3kW95B4IdQqncuck66HxrZwOH6tag+CrzPLDnMEoH1OWO8em
/bMOfmACIpwc1mAMf1a3tpHI/w/cS3j6dgMGa9QnORraQcM6Tc3n/QYR30Wd
eFWQD8yhj0fsZ/CgmiDpnMdJxMdZecrJf7bgyCnL2QjqCpTvJOGTI4xJlQV9
W6D7OGZcq/Q+MLCsHOiVmIfGZwelWgQbQd9svScheR7ZR6q5K/3G+fPwXKrl
lodfO6gzFjLs+0bW6014TmVul7sEQSqVzm85MEBbti1XNb0EArMEz5KICmR/
SP3H2f7diLO/Re7Pdn5t9eXH5hlwfnJdiD6/AmweR02cubYOVxei/8aVVKD9
Q/LXhqXKBEfCDvS+uMtWJtwOSiN/7urjdtDzFpgVsFC0FYKmHUvSr60G4JnM
VJuzKgTquE8VKbkN0NI9a9fPVwibmRz9XB1twKVvoLi4uQNGx9w+9u9pB4tU
tb0GxO+nN+waZvFuAaoVynaeX0R7cT1C2JC3HpTLFHQtNbagulZunrW6FswO
SXJx///Ozxf7vL9jSLzefY8i/opqHTqfSMI/3rv38tP/+Y367/1lrpjt37cO
ppm6FN2XW2CXu66sifcmUBQeU2+zbvmPPmM/RP22b80m4qX4LdOLrnn9sDGA
N1RKxMF2cJebRXw/Oi9AwiP3+Q7fHX25BRl3zj9xvFILRwqhkf35FlCNuZRT
S9Yi/TnLAzgpq9V8+Bk3acN/YA7iSgdaE4Syof+q7oWNxgU4G3HowI+92cCi
wr2/DrsAqRdwHL6PO8BrfTgkTmIF8I4C0+uY/9Pv4b1Gt/Q6ikeMb53o7pvF
w8XbU1WjYdXA/FUiX34fAfbT1Zh8a+qG3xhp8XNdeOj50f79+b9uoCox66sq
xyP9ismnv5NPBZDn9/iTL349npuwWOYwVI8pgtrOLtFdv8YhR2QocvN8Earf
6uS19+R7WQbztourQ5rz4D/LUKGsVQd5rYaat/hm0Xwkmj6/+lR8FnKWzn4K
yq6HUUZ3o1+WZH1fA/fTR6682gLuhueUTxlqYNAkvtzBegvMlDDHd6ar4TSf
uUqE1RaYl3mHzv+ogX7Vp0b7bbcA/t7JulVaA4WOe2Nv2GwB1/jR70eJ+HmX
kT7OmKEN3r5MwU1cbkPx0vi0wMilsBroVjahuUU9hPgQ62nVtcJWPHRKFc2f
/f/pxZHiM3rns2ayXMdRfNjA7llMvMkcHPNNknFSyUf4xX2jsm08IA8s9tuI
WWGwsI9w6znlWi6Kb5L0X9Q8vmQlxxPt5w3T6KHr1dDxguqouS1J/2QUtpnv
WeVMrsHRfUVP/riMgsbl5yui/9bge6Jn55+PA/CxbSIf27kAJjV8J1oUMSC4
X2iEOxgHc/Mw+0EQg9bnjz9h+5z2RaN8Eolf4d+s1VFNzcPOBwOJXtokqGbc
uufCsABRRSPaC60/oWpPo8WZDiz4G0x+YY+IQvWo194wVnzu+wotKVo64pdW
oHPoI4Mq11d4kS8gHChA5GslnC399BnIf5LqAzTPiSa/FMaB1nE5dRmqNEjf
WgsuX8OBCpfUhh/zL5AbmrXJK8dBsqyPqP7bdMi85d0gE7gJgQW8ybm4TLAP
eeH1+NY03GI3rrHqykP1HCR7/1j+g5XwwCQY7Kqk8LEMRP5RXP7rhnbxB4R/
ki6LF7g25SN/sKnT9D2kpRBeTUcbeumvwJQeLaPdt2KE1w9GMNoKc1XAmUW9
NC/lNZgoqnL7xUrWz3TPpjwa/i8UXock11uzTsKQrcKp4LJACBLkkQ2tnwSu
Z1ZrCi4dQH0Ge0OaaR7Fb3ZuclNzLc/Bm6tZZy9v9cDVRkVtS+VlyNWdWJun
LoXUunj3NzMr8CFG65v/l0b44X95s0cCCx2X6Aa9oQn5y7CQti0CbyPyh6T9
G0ifndrCioVO3PmbtJOdQOcdoqQuuAEMdUkuv8S6gJrmuOi5pnV4Ujq3wLe/
De49zmo/84uA4kXLT+yUhuvJfGROpENpMnwQWP61bJ/YWw2UTw7V+D8ZhKER
T/YA+2pwJizyDXkNwtWbic4XifuXS+/SQc7qQbA72dXEPlYNzfo/fN7nDIJv
b2qd1kQUBO+muTIUNg0q1zPiVTOzUPyYxL8l28rm9A4vQuhy3nUBhwF0/f/q
6YzCVBbfqVz8IpRdL95j2z8KQrXpV0y2FkFnTxW1DCsRV4ldr1DYXIRID69l
wZYixH8oG3AXjh3LR2PNjOjw/ZOtaMzckujjb9EKEzYP1x1acUCL+SeSDh1A
lx8Qk5CMhwds7kqLUh3w7KPGUFwZHtIUdqT0FZvR/SpGUgF6hU1QwJnNe7Uf
B3e6affvputE130PLBRsNHXAxnvfnd5RHORkHtv3oL8DrpyS3R9YiUP2xfN2
jtsZvhFoqR19d/pwAVTdW21qyxuGdMLZAfrQBrS+KSj8+uq4G+HWqZKU0C9T
0KSq7/DcvRatdxCNLzF5VgMTX/6YVopNw8lgR9lvWzVQL1l5NrR1GirX13wE
XVOB8ZvJrXfKc3BihupO//cEtJ6mCjmaAy8kwrrGoyKDB1gwYd0pE3vUARI1
nanHWxZh4ocEQ398B8rv2BSzcI0IdqD5Iq13jtt1WKavixDhnjCt49YJc7uo
khir51E9jeft21mSHvPw5r5fnJNmJ4r/X0qk2xS70gm/Y4f3nsStQG3XLfxE
UTuISQ2/f25B1sOYbLU6r6qABW1rGn3nuHa0P7YjHGkDDnYg/uaX5m2tuEUe
78x9f2Ik1gE3BXea8NdXgVbblLrqXAfUKV3dP662CuJix8VPJXVAcOBvHofj
a6Chsohrx3TAiLbYW+GxVcSHdf9+ije9uQF40+H6RJdYZP8UB34ODEtHwsFI
XQ3pb+twg0sh0GSoGTLsZy5NseLAYXJpz1/lFpSvINXjebcUBHbuwqH4dhiD
vkjiKxxwivnQtlQ3o/p1MfmGl+U0pSC971xSRdo2eB+52OAlUAYYThfe3Amy
fjz3d5URgYM70KFqRPNIvQzpTXgwFitQCNUAzDE+O/9sHCIePNijmlyD/Dtp
/+t+3E3rzjgO+Aw4qc1Zj+Jxub/zPLameoFuUO5kTdsMqheyyU+e6Pw0C05D
KwwihF6Ub1Tk3NKlLO9F65OkB1R1p7zv9osZEPHcKPmokwA8uIdB968vwwI1
heQ5ywS4aPfJtCZiGQ4Lziq6OKfB3KHwnbPmxP3v9/umY2Aa8LZcoWpjw8LM
tUHeO/vT0fyT1teTEOzuxp/LcHflm/TvM51kPcHOwZcNWhh4+S/nfqwQuT+X
xG39oIfNWODSds78cgOD/J/N53AHiXIMvAm9YC8pugZrhoxGq6cxMExrcjgi
YRXxtcQQnwMlAUvkeJxQKadnMw7UmYL3XBioBb+/nVJWAzgYoZ6TPEFfDqI2
vju+PDswN5ryJ/tqOZiyXsgXP70DIW/eru+naQW/aSp93W4CWLXGDbRztsLj
k/rX33UQIFVXuR0f2wEiddGyz+pHIXoXFe7wQAcoDt++NzI3iuz5m4YB+31E
PJIxefNv52ALvEgyYS2uwoKn4RFpcdFWaOAy6RlswsIhb51B3apWEGoerXvR
j4UKR5yCaHErxH8ixJb3YVH+ezgHjMTDR+HnlYtMUb1FKD9KWr9VPTKvSp0W
IdyUz+eyYhPcWYjm+ipOgFYZ5/Rq8WbEx0nnD34p/2mUEySg94VxzHzNYrwF
dvlrXzT2jsJO//6VVbN1EEzhWeMeH0F85f/qe4xApVQ01u7tOuRieXX8L46i
/DBFolTWrqtNiB+Rfs9R/U1m/CIOPN1ynR4NNKN4IOn5rxwJS7P8tQl79zWA
wOEmqF0c/kEvtonw/vezvPe6SggwtMJEkelcAxij+4MTFQRYkhG/PzNRAwK1
NPuCyghg3K6nvj+1FuaFxpzkcwhAESDLY89fC1FnToY9LSYQ7eGg8rJKOsJn
msOtd7oaSoG5Wvdco9087LN+KuqTVwKDI4U/xMPm4ecLBwnDF53wXGxATllw
BW42eOA9X3WCUtTxvmcTWHhc7ot/8qUSLjzkk17fXAHN+5I1zXHNoO5IM6xz
YhnVv8j0jqQzlWNBvT7aLYOnDtULkt6/vbX9HqVkAlAveB1n3a6D3wZseRo/
CID3mZLPs6uDJwPPA8WTyPlQgdgsV6Mr29Dk6H1cOr8SalzHzfZJbEPB15Tr
cQoYcNZ693MlbQfxSymrE44WT5bA+8J80H3ldvCMeTl0xXkJxX9fvVHr9PWf
gWQ2JukRuTpkPwJOHFjg+z/9w/9f/IKE3/21HN6IesyBd+tH+sCgeoTHGzLn
pb0o6+F6mZuAR9MsUMpqaIqN2cB+bQb2uBurEDk3pCm8x+w//VZtoPrwfLnP
1VXI0Hj0yLd5BHCRhWrjsevIHr41N+vkJM5f9965/lSKaljdvGdEkUcA3m3D
6Er3ahi6vJWoW0SAcwL6NYee1YNbx2dO4SE8sMq9Vvva2gqMRkqbiwp4tD9B
RfFjniUewgrf27czt6F8b8aI92LU7lZIpFjewQTgYdyqKPDag2oQPfEnZtdL
cv5w1qu02t9yC+qPbN0KSMpH9oqUX3WuXvFIaNtEeDzQIuDg3nfzcGOtsW2i
IAn52ydrLNaXPkfCp97koavfsCi+eDL+7UQDJxaKwxWmL+yJRPaVf0bznKdw
OuLPtk+m1W98TIPOY79KWkU2YdJl2/5bXALsIbSnLQnOQnwWzfwdfAKouxoS
WnfNovryfTUydrYnVpB9cXHqeH7eeAXmsHQFOXU54JTVLrtGO4X408mqVb29
CZOw7HyuuuBUNQweV7ubbjsLCRaczH/Vq9B6Qf9fgTmPp2sGZFTiKZYLGtD1
dwQlgbshERAd/5O7pGEJ/K+e+v6DPhLhGRkQ4A7/VI3qr0jzf0VZqpqleBYM
myrvNG01ofVIsi8PFi+E8hTNgY9fyqmpPQ2gpce7b+faMnoeJtPDFGkZy8D6
pY/ORaaBrCe6terjWJcNxxfSG5JOYwH7rm9fu04Oet8kfBxxymK8yH0ZQuSj
Cv18kyGl0uRCm+cqqvduUnTp+XhgDQZid/J9NVIQ3klSetg34pyE+A9pPTz8
E0x7E7cGl9Rpv155lgb3XkTfFopYhx2LNMaPwekwfu/p/oJ/68DLGPsombYd
wuVCtl5PrAK7gZPteZF29P2k/c3xK6n/Ts0qLHT9wo+FZEJQq9nZV5gNyBaj
olyIyER4x0TPARf1pwXZZ9J+kNsb+2KzA4fwY+HedU9d8Q3QP7Qc5dpfDNr8
JwyPqG+ieFu6qDZz7tom0I8yf1Qwj4S1V9RKLzMWYUXOSfEyD3FsyuwaeHgJ
xn0EXuibdcH3o1r2P2qIfI8qT2mYiJ9I7+OIunwMa20tSCkWKZYrkvU36wpO
7XGTI+uh8/xz+OTBu4XiA10sMze2JEZB2Y9X52R7/H/0TZMgc9/4bRrHVXjl
l+U7H9wM+ik/+yavLoI6nd/qvdFmiFqie7mXiGfefny/GV7ShfC3hxbL/YmM
LljKLJe4trIE72096FnTuqAjCzKexGEBdyAqN6HVF84ymF0+yoiFxnB+qXWl
SDQfPdX58ybj0dCcXQhKO6uQrbd7V4R3NLzJ4a+LXiHr8zn1dCWLiKyB2LKR
7LvtNnS+rPeo8Xx6QjtoYlJ9Z6zXYLj+VcFOczviv6T45I1uC7ZFJXI9PIVY
5YkPucT1F1b7x8KvHeU3ac0PuekmlSP7Rnq/1K+UaD5u46HphcMW92gdMOwc
4iIs4eGa/AQFTVgdvP0THuWFw4NF7CM8tgYD2DwOlSM1G2g+Bs9OXrYXxEEe
ZL75u45B9a3/RGi/jRTXgroqHIkh8sZenrq/0taNMNLv9ZaeyA9J9e4uB5dn
A5SWYFaJ6qxOXSPa/4WdUcX7pxsQnyHxa+5rGLMvdYvwL7c49thqPYhfWe37
Vr+A9vfhg3zPGfjnoT94j/s9lkZkX0nXq1eXhcflFkF80j2zj60B1UOR8AWh
1+bnHmU82CvTnLloVgslNRpuNJfx4HGLQV7sbi1YXHPlF72CB8r396hqvjTC
/hd8Cd+kipB9+rpawsp0AQ/uK++K/XfXQLmiv/T4JTwUUFzY/w9XDZofah0w
8njI2p9kePhYNdDrX5puPYkH0Z5Dg72+xM//2dMvq4KHgXiDe+GNNWASwjia
ewMPrcZB75IJteBjraW3Yfgbwm5IbPAS+cPhbIfRlwMj8Oz54u+oPzUID5Ke
5+pdrTKN+BEQPDDEd8e7HuWPSP67rSzuTPvhZUjt16AQ42gFsV1Rrj2GG1Bj
saTy1bUV8SmSfXj068Oq18UNZG/5CK8lZ8XxSG94MLHOLM+ArNenH839q5Fx
EpTj6VYkp8rh4oXsY3c3J9D9C9k2RdjUJTQeuXD0U3jJAiSfPfq2F98IVpud
rXNqCyCbWkd7RaUJRHIKbGo8F1C8/czj6lPbFgSIelcYXixfCU/tPIXkXAmg
emLzjFtZJei9eabmhMEDgdnfdzG1HoKdnZtPTUyjeLb+nUOKMgLT0JKf+jrO
vx7VO1kxiOsx8DQgvkR6X/Oxa4bFDDMQfbutjOZCO0RILIiri2ChOw7s472r
4VKr7hB3xAjCewWam1tcRYvo/o/Oen/+uRNAI/xW4EHFBiiYv+Pf5kjOhzFd
D//rzjoOZ7+5FM9cLkV6pnOcIsbh9Y0QYz3U12c8DjRBD4758jYhvphbK35D
ViodrPlojTuHVyCZn2n5yM9s4rrCHbJ3WYHGuMNtz3/loPjaPvaLyywNWf/p
n5kFfz4anGnVX4GrBgUCLj8zwC+UP1duCovyvwnz/eXah1dA5BILfePxTIR3
BoaKAqDdF/nTHYzbqUGMLxQTTrO0dy0B9fwp4QiivWxtNPfUpseCoLRSjDxd
CbztTYq9zD8Fd/FStKEUJXBzNP/KYcEp2LZepuLCf4EfP6zjRIn42tAx8/lI
2hcw3bhFLdWKhb//aMR24euhc/Dw7tEGPKQNiCoNDbdAZ3lftvQ5sn/i9RaU
750kgL2zkZRBSxl4WS6GrhL5gF1R/LiwUDm0nrg1JIchgNfhT+fMB4nr8exy
VjhxfZL4vzlFeDaXyyRM5zhN0TE2o/inMcYh+enxeIDtty0W42R/g1mEBIYD
KyB313YzODoJvZ/Z1M1mu4ZIFI/uSngntSgaBUuMl59+JvK90atDjTzdOfCA
rTatPGoG4S2On+lHCm7MQLnB0vzq/ky0PqVfPj7rvZAP5bUHNRqcpsHxKF4z
laoQxQdI+G78eKMBk+I0dIX4BA7z5qP7XY82xOYJvUR43T+a8t2mxlMw4hb9
YZJP1hcOUuXI/Ji4BoJFj661fStB/qQ41tD7t0UBSOq3l3HIr4Pv96H/r6vv
jsv5/95PRhQZkQYNGREiyQgXDZUKoaFSyEzKSBOFikKlpZKktFFpT+097hbt
cbe097q76Xd/P289PR6/P5+P1/2q1zjPc67rOud1jstF+XiszGqvub50FAM3
rk2/aElGQFRwzRH/ETi6BxaKzqaQ+DZ3fW749olTfQQDQfbBs06ZkEpo0w1n
xK899OH4K9d98YZTUWC3ajeZ7+r8xW5ZwZoego/lgnOdcl7/wrbStQkWDh8I
vpzTh/LDZP2/ZQyDents2j8rkNi/2CUHzsAvnxCnc//NM7Nh8ryrpeteBprV
k/3wo0PwqRNLIxRuWn/8fDoOmx6Yut4+3oCGO0eDp+/FwuFpX/TtpAZI8gm0
ZM4vhz3HzOXxzWNQuJx6fplsOcE3c/iMxXJs+fM1Y1guweX7pzQRY7HqBrYT
EyS+7dY6+cb2wjSo116yLE4vQhTrgOHDE9PkfO47ml8wPgU1tqtXld1K0M49
OGJFnYSKEG/qro48/Fl4u/PEDRqMy+jML0/mQ9L94qZFejQSb2u/rDpdGpEC
R0X5Fibvor/9RFJQcEN9M076Izw1nan1QxvBB/tj5J/sedULha5VbltW5eOu
vEC/pHIvdhlYSHxVS8YlATmuQx2ThD+MJt77unvrFBpP8gX1piQTvCH9/bN2
6rs0wvfvHfhoSA1g8Gu1buu9ef/mrfirdh40S6Nj0fbQrRzCFVjV96D5bCqd
6DuCBeHDz126YKvvfqb2UyVeenaP7nDtwturBd/3CVUh+JSNbTPjONOhTZwp
d1ogfID1XejwGPI++lLty76Df2J7gWx0B2zelE97KHwneu7cfNbFG6TeM5d2
YKllSMvNw+l48j880wFX65sBi43e4lrk6/SVXsMk//GzsMum0XgYuyZWS576
4oGdb4aWb7UeJvNVBQtxWHhbKo6mKP5xSyvH2hu5X+m1dOxns/zFZFn+F3/Q
/+afyrEiVSwroZmOr4GzajLUcsLvVjL/TNw2Uo5wlq2p2ccm0VpRNeRnV0zq
Uebip5iRw93DX9uhEb5MQjfDC++3WT5zYOxnk4o/fJEr3pH9fm71yjDZ/gQ8
OkyniLCM4KBV3MoktSTyfbqQhO/pxNw4PHbX4crsbCH746hfrkm2awsqBL9R
/akUvN78ZURRZZzYZxDrrRa2deOYcfCrvhP+Da4Kz8rar4xjpxyvr92GRNSY
FjkUmP/T27dTBpNWmU2gaAenZvznBKKven7cUmd+PwHXhErCAn+P420h731/
M8Y64zaP57wJ/D76YXbz0lwcKOr68nO0G9FR8uxnMnOg2K3hcqWkG0F2AxdE
dWP+9YuXx6To41zUCuyNUhHtIf1Uur63N+pw9cAi/Y+xMANPzc3bruey5kri
LibPK2Rm3UKdFU1Ibzm9PtR6DJyyXs/ddjQRPey/+cFNoOZdcdfwGYNG1J1P
lOg4Un90vO4Dd7ZXPbpKojt7O8dg56c73uBfT46rDQc/q6Wkk/dt+XBKR3pX
LjJHap9ZZUxDTimoXDk9B4uS5L+Np06Da7/tfk/2SjKvaY6v7f+29vOhrXQI
zrvQxDlZhEE3zXR3RzrO1jMNG6jUEzyzirtS8YdaPRQ/u+su9PuFsBil6Kw7
9Xh3+en1vfLdUL49j/2gPgXWF5lyP+wdwIYFvzdfi6LgftICFuUTA+CRNvm2
z6UGxl6sDcal/WSe80b5gqUs9cOE3ySxG1g0XhiDa0x9q04PheiDyfMMgn5k
VCPKQuSa9MIx8L7uqY+1iiX5U6H3kdelsmNxLS3+ynD/BI7uWy71mUZB3WfT
BsnIiX/9e2TcpLdxTMJplRL/024KOd9RriHKPIBC6qnn6qmgVZ754tk0wY8i
bO4v1m+lQtcx68mf1Vko3jjS8GgPFc7Tg44FHlXwtWfNK7lARUSR37qN36rw
fN+Ykv1tBh4zPscR21oFxcJdNA1bKpnXvUB+6OO6t1ScG47If3PtJ2Ia1ux6
7EFF79lz2h2RP/FIgC024DWV6Hfj/LeDlwb1QlHc4QmHRDYGHvxqvvqpl/C7
ac5zZ6zy+jDaWHGTp57B77IVPlQW9jH8uDqddWMFzn/0XdDQxjhuwhy+rKOK
6Jlz12/TV8Fl0diL4JlFgoPC/+Ztv7L+o+EnUI8r+5cVtAsNweHV/bNUjno4
vzBPlHkzRJ7PC/PDkloCM8gftGjP2ZKF+cziyzI2z8Aj2o/zIQNv7x3W5jyw
9V//ucM6hybOCc5gy50C9ikNBv5150rIE5qByExTBMfFUsx8v/yba+MMuT9O
v+6FSrk0WNTrfG6bLoey6Bn+2SAagmq1Nki3lmON57oDpkk01D2QE5aZ/oSD
vs/vio5RSXy/73+M3y6QittrPAK4bwWReui3q3QPm98Mg6LnMv1y/1byvZTq
re3b+gZaif9OPeJK9a/vhaDxw4+9Yx6EL9bpDto/SnUl/HBaI6JjhaIbKnxK
PqmH/Zu3YK7J0hJwZQhWvEURCbKp8Lc7srD28hDhS+Khp5csE+iDnc3XlJRd
ZbCJYa+cZe8DOGVWBrBVEDw49zwob1f+vm4+BNaUd7FCfD8JPjdYVMO9bPtP
SHDx7WGWGMb6BdJHV574ifR5281UBodwPHOpKXspFTqZ1cW6r0fIvFMbk5kc
YYsRLJbBfr1BKvHv5rd6piafU0Bzlnb9eXkUVWfYqp2/URCfEOVdvW+UzDfv
/eEsLaA+ip9mXeUBTD/g86Vti7rLKJTKtCy1fleDoz5L/MPbUYRZCvffuUnF
Vk4l6UXrR0l98OkngfPe7Rsl9tTazF9Kez/F4DNsXI9/Z6LiZIHnm5Ap7Gsb
Uj64Ph3967ZvUrw4hc3HSikmwunke53/9m86Tr3MPdvkNAXHLqM1Zt2lKKW3
OtuV/uv/ZHGkaLltAR2Jf1pX7hI+S97njeyZmfW+uXBmqX3sGtCHHj85/1hG
PGj4X7+rPvhkTh9cw1xP8Do738EfXovqsWJenrXx1mHEPP7u95mlHutPNvaY
7h4m/EJd5fE1dulezNfgcxzIZqwFl14qlekl8ZhNijnu5XIa/Hp7+5/HFYM7
ue8SDzuNPI/s1MT2sbe/sKGZXex1cCZGfL8xw+0X4pJ+ZJu25CHQY63KUvdx
os+vMvKRWPxhHC/ZxKn5dnmIY93vXPF5HJdy/0xbsBai4pacltCJZCz/9nDF
I/VCHDvFlM88Pxlj7OfWSTnN9b+l4MOul8eqHHLAfUv3WnoTBem05p6yBzlw
3rzMLiKknPjLJ4E3RHV6WyA5qtvEK0/B9DHzNSsYa2OZG866fhTcq5oNWNzf
ggXPJxek21LgI5Sz4Qvj+H/19C3gvcwT7MM7jk+09lyWUy3IGZP6SGcdJ/7P
aHLPyVPhdHA7PWE2ssxGhNGTFWmRdJTwbDvlFp6NYG+HvsxoOnmeeePH71i/
pSP4+m/n20HFiLE8yKvqSQc/9bB4jUgJOJjPXR/6RCf+iDOz0qIygY4mzvF3
1ukleOJ82+D7NzpWfJ1MTrUrwa3iIwtUv9DJ/fbLir4RH6Fjcfrx7mBNCkwO
/1nuMkxHQvb8S4IRFIS03xBgm6DjvYnzTlVjCt5Ghcf2MH7fRf/2oudeEdh4
v8V4Pp36Gw+L8GzT186DllOQU3sUKmZZgKfot23UaSH6g1y2zqovy1sQ+eXN
CQu+AtKvbc6+nknpzUyrtmB+p8oh67gMHJzpeums1ALavqO+et0ZKFcJYbeS
bSH2FEX/lfRhawsuXVqq+y4+E9bvrnRu2t6CoJ4WjhQVhr1xsbvOSrSQ5387
XPaT0/EWWNJnypWeZIPdh78rnPH3RToTTh4LykaK95P2vWdaCL7bqHHbKcm7
B+N8FZEdR8vRbA71W+97wNpn3cGuWI7yhaapzYz1nD/btnhpXldQD+4GKazf
9rEcbI5X2csDevCLb3Gu7/tyuFss0AxmrNN/7spz3VaJXdRv9k59PURfLN2T
MsuT3oOLq01WbnlXgR+L7Uemsxl49lF7SYlKAWoOiO2YDBwg/OkyfdWGL9tp
uNVxJdqivxA2F7R9DcVoRH95JThx+JwcDZYBXTpyE4z34fx4voXMv/6eBQN5
YaUqDVj60Utl0fFscHZ+EixmrJMHl086ceXBhtfz/juDRnhfHPmT6F0HbV/L
8R9fO8h8Xtu686JrzDqg21EtcFi/jugFc3z3T/V2xZmubmgqh00M5ZZgfnlj
2lrpbmKvX3Q26zne70YF7eisv1g54auZHW3Ri0XKwX+lQ+z/+MecvbY+Yk//
NDKI0NZYnxUnKGgr0CwI7RrEjtiuHu7jrdCXHBqmiY1hyQ2njCPSrfBqvMke
uJeBN0+mmP++nYtnQZ7KxzImsGG59WCJVi7oP8WrjQImkNXgsM35XjZ2v6dc
tR+dInpiKvXYWhmVGWgli5TpeuTgfOv7ND7GWm6njHHKZDas1fhjfp2cwSH3
ooxo6wrST7DWXqnCxKoCEQpn6fWMdTX9fbIPWxLRe+fet/eQcJz6yn40MN3d
mOpXweChVPvBjf1ItGRKvRJVgZXhEt1fd/STer2zJfkH5FgGMB7Dxt8T3orA
dU+kzswbwOpetfsDqa1QudcrsmamHyp99aqiN5IIX5p7HzferVsc86QdK4R2
5H1iz4CChKOkxbFe6IlO55/ZmMHAHx8jLzPWrN0la6+tzcCogrFS+85//b2W
7uzJjF0zDMedOixqjukkftizJRzUGkpD5ErJT+sCh9B2/u6ypmPfSbyf+16i
9Y/IgogfQ/AU+h1Wx1oOHn5Vl2Deob/5dQr8JkVdHVcP4afNoaGa7Qx/SxXx
0+4rQXrfYNyXPZS/9belMDCjl40y3t+J/+GVBuh+U7/8lKkMQwbF5rVl/Vh8
7alsHGcZGv37F5ZV9+MhS/dFIf8y7NVjTuqd7seBBXZS8lNlCPO9H2C0fIDM
p0/+eHaaf7IfK+WszJUvZ+L5L64pMwY+vrm0MDzFPxOUV95RbtupSPrQncSy
rY7wF75bu0ObuepwfJb5VeTTSeQ3R7D/YarDoy6hxXfeTZJ+w5ZB9zqiJyfR
ND37eNy/FnpfvL+rdE+Cq2TkYcL9Apge9PLyXpsCg4pcLyfVAqJXzNl/M7Oy
EP/dHmyomqzcdp6Cjg0f6GW3e9C069VacXYKbPdHntuv1oOlb40nrYNz8CFo
r0Tpkmn07dyjcqw6h9RDsCYY0AXoOfhq4nGNsmwa5ukI3f+tEDkURfGTFa3g
sztdWU8pJN8HzPmbuyolR4/ZUZFLl5I4w1KLnxYGn2KN+uDRmil5vakGIqPv
MmsY9qx1r+Ssi1UhRG4bBrDFT5F8hBnPhDdT3BQi13HEXdIv+6vf5YEzaHDd
r9tlyPkh+K10Tx7Cxn2CHn0pg+ObcWP5qHyYb+FrDhShoLvldtGr6UncFj16
xko3BxkcvsdKGqng3DH84vxQNqicQos4/ahwU7SPtmfgYM138vy/qaPQYn4y
IOXbCrvd111fdI7CjfdssM27VqJXtXMZneKxbwWXx2yPxOQ//NaR1sbKtY8G
m4DlVhueZ6LtuVL9zy00OAof+Pr8WiY2DklWvhCgYfXq/V+it2TDrHylVbEO
7a9+kwVz2WiVe2o00CrvmsakhRG+stvjhteWbf4Eb0+du+g+1fARRi9aYye2
9CNZcfW+0GkXrHgaHnlWoR/pD7xKPp8PI/uJ+c6+TRNt/tDIin3DyjWMqvU3
Phr+/gyxpfS075oTOLL9K/8F3Riij87pe1eZt2NpXSdS5b2Tr0oloP1SpGan
EcOfD2xMEFz2HPySD1mZLvzCnY+He/L6X4H1gNPVn1ZdBP8LK1UGjq4YBVe4
zTIjvlTIDCrx2f0eweaDm335vBLRb6JFayweJb9/Y/pmUbnPMJanmSRkGqWi
wbZl7M/HYWx+sGLRehYKev5IuTY+qMKavVfu79hCIf1P3553O967MgP7RO/N
nIn9CcZe+ypEzSDz9ubwgsTVWaX9Rj9RXSr8XLw+FYeZdznksjahi1LIbsuU
Qur1565HspU/MuNIE+53vKZ6m30n9fI11IufRw/UQnavx1CkcC9Eyo3vtS1p
Q9sz+x1SVwf/6g1tUH6xPmLX4iGsNCp2OcTeRvR/qy/h7zUE2nDra7TFbP0w
jgdk7clb0IZOfV5dHaERcv6xB/xNNu+GEaDPto59ZxuJd3P9auqzdqSeWjOO
RcpTDZkbqolectL29peC4yEYefvsS4LPOJKFufte7o2B+xthrcj2KfI92XTf
+d5E72mc2yvnsvVzDNnvT0au3uzZEU34xVx+g3n69I3UV1OonX+veGCwAgXG
238PqdNx3aPjc1NiDHwMT9a23O1HALukdUpUDclPztXTUdY3PRZS60efTU5i
zKE2rJ+435x3axiz4e7X6yjVZH/952+qUfmt0EnOaxQF7d/GjuWXgaZ43+u7
fhc6rPX3eewvI/Y6xydllVys+vZ1ET67T32s31tjCLYTSTOjd11J/PnvflwR
rq+c82HJMJZa3XV9Wt0MCfOol1g7TPr/vp4t/xPQMYTmUW/vut5mcv6MynBI
gUUz4Z9X+6tpNhnN2JTE9Pzo5mGE3L+icTecCrF5Qjvf5o1Avz1X22HsCcl/
NwWqatkw4sPc/R5rjmiLissk+k+h/4ebhyMzISl/y9VReAw+ykPDL4IycVzp
6rUns6Ng3pEmqGQaB7H5w9peIdOY2vY0OvRzApmnNJy8anctazyqtb808NZN
49VVnfNb3OJxhRrpaMFGQ0i50Z+1fWVEX517fjkftzYdqqPDcb+M/JmdIUQf
rPQJecCdEUn8Dy2r+OlUUhLK1zy+sGT23/zw94JBIhwmfXicx20mWZNEfr+F
ahbgI5lE7GEOX5jSmJj0dvejp1xqW9DaKmzytCw9yD0IjbFjY/s2VuFg5eJd
HxUGUdrW0620pILkRzY57fpW1vASDbuLLnrwjv7FG85YdPcHfTeDj/9n33b4
Mfp4e3L5CKbGFbf1Frwg55vuqYn2XFwPmVBFEc7aIRjdaeD/MdGAnHXz2NcI
jGD5Y+3cU9sbQTXy22K6bgT9Ia9t3vA2Yt3OCTuZ9SPQ9RmnLClogFTZLb/n
jP06n8PHwLCoAeOPayxuMNZzf8/knFrifqkx/MwplU6VaoTvih1dUnJjuN3N
e8HArwGDLUJsbw+Pkfy6V8ebz7LNEyjvNk3IM8nDieVpKj96J7Dzg4Fwk1E+
0e88K9dec0rIx9barH2tPhOQfaylor4lBdsj31xtuNBH4r+i+qf31/4MwUL+
4G6VbRSM25VNyfQMYZB+s3pBVSk2uxoHUtV+4pT21KPbm0r/7vcaYg8Ba3Y/
FhL7gd9BdbLrF1IQFetarKLSB1OJS2fX7yxBVm+TzuzIAKKOXwxcLlWMLYtP
cLNJTGOefsP4N9EkRJyg6ycn0VDRMWKvyeDdc9+jzb3/a09/Lpxf/G/+4E7p
ZvrP+zSUmV4pye9MJHqXiEW+yMuULASu1LdlOdQCrfK4SVftGhzMVr0zX2MK
mdXBAhtX1+CPveXliJtT2CmzYy/HhlTckEn9yqw2Q+xzyUr+0gW8M3jfcDKf
eTKFzGOsDNHuEH+TRvqvz/n/VO89N6N1ZvBEVUXvhkcW7t6636Gv3oCduZ/O
Nolngz8zWbycwX/m4ou1s+rpHRpURPhEeTtMpuMhz72pegMqHDv0Qw9QMjDY
U3yhVYGKPo1hX5ECRrxaM02fOkElePfgyeeRvYb/+vNsOqr+/WHHL1zhH61k
elJC8neeB+7toNZSyf6cix/ijw2aPc8OEr4UG3z0w8mTg3gevOoITbYcQQJN
Hy0qhsl8E56K7Uofz41Bo4g7upbaCEH6teIwozF4W02d5C5vRNrV9Hefb4yB
b/O8FfpvmnCgqrj4zNcxyJ+qCx5/0ASK1I2LVZ/GEB7QfybqYis2Kimo+XOP
wci7cOmodC7suGN7Tc7OEHyk5Lhgi+wLOiQGH/t+08/ED8eDB7SN6XC4IJ/P
2pgI2z+Bt4XtBtAvvOu0T9X/1f9E1s+eG8AJ6eeJjcPJWHRIhGVDXRMyDdT8
M6PeEH7UtnGNrf4PZ3zpOmq8tnwAejeb+lNUXUBj1T5rldgPcembw+tdMoi/
nntfmpLa1oNKw/iYqy8+vukyLl44dW9lHSO+bnxQe+mMNg5JnR0+kzVM+iW8
Tvc+oidWBB7fn4GLhCh/8XYxqXfMd/8s/uFyA9l/ty+onNa824d1ieq/g30p
EJLvqHW26kMjbYIp3IaCw+U3nNjN+8C50PADBy8Fq1IW1ghp9eHLcrWIPacp
UHWXN3C49W8/77sQVTuY3IXnZ0U+zuenQPPDQp8C/y7MCrW8ci1PIvjC6a5J
Tl5CMgS4GvwTmYdwXfyuqJBiMrSe1/o4ZAzCvkY6JsmzntQHagiyJtPs6lEZ
3GB951gPWPTX6lS61SN/U+j71IBeJFUeOJHJWEctyfP0fttL6unzOMTe32Hu
g5j41WeiErVETwzv9lV8uLeW5IdSDanzb+2oxdqjpptL87uxffuFRhHxWhTe
yY4cEu2B1CK28HgGnpKe3Oy+sbCH8bxa6TOMv2fZ+ftP+eMecI11RKUEfiHf
q/yXf/+KtbL7nb9/mUCMN7rsTL/Bzpliac48heJXvhLjC6IZ97OCM09+rr/O
N3jLLzGyrJjEK84BlVGnFAydprGxPRqG6llp5voPKRBaZXfd12oYoX9utbll
xJJ+efbd1aGiBTk49eVlSOj7Tuy8+N2Bk8H3FyqcKZqx6CT5MjF+D+uDPF0Q
0uotLJ7IJvlTmx0VT4Q548F/gvlzvUovwV92mSbnHqb1YlP3wg2rbOPI82ui
fLy0tSievJ+5/CJT4eQtiXm90E71rRByjoDLI3//9c7DyDVx412wJ4rgP++j
sd9dH/2A+4qrJQXZI6Sfu6Jttf6CcyOovyu45JlCDMknbuEN2nfrIQPv39fa
9V1qAmfENywRaIkByzNzq2CTCZjyL6AG6NeTeqe5fNbper0f9KExCB+tbjNZ
kUb4bbPpt2fqzhl4KpbskM4yhcm9by6NnkiHZPiD2EgHGtEHuO10lHZ9pcFA
bRm7YGg68fd0P8Mj5+59J3hmzj9m7/5ZMnz/39pS+Nqht9qNEN7qdlbrWTpM
2PUDljHidG9Zc5DQ5SpwrdJWoh+hMng9PZHDsAphvx4H6x2nEv1N3DPjQk9e
FwKWNykPp2YjoP/HpoKiXpRpcn8ae1mOqPsvizkS+nDrhRqLoVw1UjqvfN3a
00fwt+KKIr8jZ/vQy88rai1bTfCO18GgiHGLaoJ3SjS+yj5QqIaxg/n3h0N9
eLTTbAvtYCaEHBOV1s2fwcIfWx88fZcJWWW9U2vWzOBX5/2Q5Mg8HNjg6ZJz
/F//EZm8AYXTjLXs0YUOyv4lkDwuJfGbj+FfXS6WXYosQeCMD/NG/hmEvr+v
dWxzKYbcKRnKG2YQxfKZ6S5HBaTrNqoaedDgGiJzMhgV4BwYLek2oCFz5gUc
H5ajfWMFn9gQDQ8abzVGhZbDMdCQYl9LQ31O5YWZxRREbnyuZNtDB5dm8OzF
Hoa/vp9RZ6Zfh55Vv8Q5mpL/1iPXkvi+wDK6XW9XHXRt8tYlZyT8tec6/Nr6
QdhkJpzU49Gu6ayYXJaGfqti86klrbhgHOrFfTmd5Kvm8htb9p7Y2P2eSuKz
X5r/yWrdTrzxPDSp/zsVWv+z505Isz+TiJD0xPDUjyiB3b04+K6wZ+HptwhS
OWVZaN1L8P+lczw0nT996Noi7xaxNg0qtcuV0m2GENrr43PyVAtqSlsPWz4f
wiylYuzznhbCp+f0e66dJgt5wobI/I3Q6T/amheHsJZr0fNYxnquPvrXdbh3
vaIS/JklE3WVeigTPKycObnaUxiKto24UJSHcn73R5oLpvE6jfXeC+V80MJs
PY//niL6/luWX9FqPDPQ/bH9BdeuYnxrTGtcyT2DkZ3xTFXni+Em1yenxjWD
aUen++aLSvD1w1ADLwPvaJnsGXncWYzEOOP1BYzzm58aitkqFBB9YU7/Pf3C
b1gv8t86nGXnKrUdM/g6UmRtoFaA4MQQLiOxGaQXueU3iRdCybbG+PTmGaL3
6Hc6maoIzED4fOqrLN8irPLS7xBbN4MZSXXVKdsiZFrdPMO0fgaertVr1tYX
QtR59bg74/efHS8d5morxKyNaaYaYz2HP91WZX9R2jmDc2I3L/HOluJC9I+m
l1sZx+s8CpM7y3Dy7Jcxgz0zJD7Kf9yQ271rBmOURdfMGPGW0y9Ix2T7DApk
ku6qbKYg8wvXK2vxGVIPcPqc2sk9Jq1IyjL+sfRqJcwFdopZ+bSiIYDj5/up
eihIpIcVejHwzL7ujZHrizGz+aoZnZtG8NW8GDlhvpFpCDAJPikzK0Wak8DT
kM5piB9c6xSsUoJDS/P9u+bRsPmF55DYviy8jK8+Zx7zC7MvLhkJbM7C6w0q
OzQj/tVP2kl8XHrdI5n4t0dU7Q/Gd2qgt4avqp8vneDzyfVq8SFLv2NFnFtu
enwNGuKWKT9f34LJDzzZcpQhVEzzS+/kbUF726iiONc4Cg/wJ93b0QK35E0v
DvOMk3jV+6nJVFJhChManqyu77Lwx+Dn+9F3dHI9fc8NSwVe0rGaad8KZ6EC
aJxO1Q12oSP5+dnNzVcLUSVt+O2LLR3zRAuu6l0rxSxPhMWiTMZx345rF1VL
se930bhxOh36TQd84teUwior8tLkjU6Sj+wfSPMxq+/E0dKAinDhUhJvJUv7
L4S+LSHxc+55mxo3XlQ93wmn2KO8ga/ysF7RsrSwuZH4Ryammu3snE04+a73
5yFKHv78Dx82kfthK6U5JGa0YHGDqF4JZwZ+T+brN15uwYm1yVayvBngW7jR
fgNjzd1wyyrkUhYcpSy0V4u3wPjaE9Vtj8px1mLPLYUfXXi5i2Ik10yBi8Je
1h2OPRAt2sgeTiuH+5S1xcOwHmzaOC9WaLIcjaVKx5gY66Pr/HvKFSowfanO
HXE9UM8UlHHSroCPmKudZFIPeR6ZTHlC8p7jaEL8w7CaUlIv/u2EwE3OsSKc
D3tdpqw3hZD9iWr7tYpx5+YW3ZWM9yfi+3h4vn8R3iZfD+LcSIPkls/+RwQL
EPdL+a4CI35G1B06351YgBdN5oKqCv/sd/XaswP9OzNh5XBJvVivFIVJ2isP
C2cRPiq6zWFoSqfxL37IxWv7pVqnVjVi+/7m6jt1uVjP9rI5TaIRbi7m+5vq
c3Ha9nx0x75Ggve1PRwkImrbMbS5vGXlhSyoa35tuM/SgYQ1DTeSzDLBz5nG
/p1x/Nw26/YXdplYvO6wh0hNOwJ8qg4uYeDqiTcDLx5bDeDtJpn54RKVxJ/O
5UNONj3VTVcbxBuOPNtxpQpYbkh+qrduEM7zn1U7na3AeeO3RaJCg5iJnRmd
TaZg75LfCaasQ7BcpzToZk7B7pSHq2qmBwm+j1vw63xz2SDKNQ5F186WYZ2J
R7ts4T8+ldNxYHGH/Bjuu+WHyziU4AfV5t5H1TGIPfvU8+JTLpaqXj9+gTaB
5aLH/d7b5uKR4KxlFHUCQ4cE+hVTcmE9oT5dOzMBB509J7hk8gj//K8+Jg8v
zjqLbDkxQ/jsiaqqm2bvqNh2ZOnRjuyfOLRgc9/J1//i3xnxaOkUiW6Sf9y9
mJ7C94GBV3r3Rzn0UfC7YtMaimsfBraMUwcZaykni3ndjHXGxvX7+86UI4J1
RKEivI/oVbbJblxuZgMIOf3HaLyaiviXiptSiwbgEX5Rsi2ZijN3ru8UfDsA
tcOvDv2wo6KVdcOGPqUBbHFcK1PL3owNBpK9vk1jGBIdNTCnNCHbzvSqde4Y
4nUFBeSXpKOKa4VB9dcWUk9opRNwcGdxC5mHtrjKtPddXCvwVprDyrQS1/6n
d7aivZrphWFMIlrzHz07V94Oh8pF56GQh9FFuQcVUnuQZCP/YepdHsHLc88z
/pz3q6rSHmLPunqjEdyve4CoE4UCInk49T+82YNlHTwG2zYUIP/PegsFzqm/
+ZcCuDm+nTjM8q/fqtZ44ud+Rlw/VHXOhqk2G9/+Z48txB5Z265Kvwrrws5G
tq1HRSrwoeSLx4OELjztNPXWya7Ayl/XEyt8u0j8URfadcrUrQuVHqs7lt+t
BO/vtl0Vrl1Yp5xzxXewAkp+lwva3v7TNwcVqtm7e/rRInhhJlCsDE71Ppps
jf14vf/HgI1WAaRfL6xc4T4NQcMom7BXBRhyviTI6zyNJ4fbEl8+KEfX+tdK
fPpTaBwWOc0iV076v4ZN+t/vMitDi6aJq97Q6F89swymx5nPyLb+m/eZcMaY
JWx1D7hXN8qZT5bCxWZzH0d/NxxfXcqu5yrDXaP9py5OdxO88nBksLH+0Riq
OT8ejmAuAR/X3kvGN8cwr0Ho4eEfxShgjd7KdH8Ma3g0IkaX5YFqunhjEPs0
eX9r3TftXs86jWuNhTHbuBj+v/ZcYqljDVTW/Lm9TamQ4EerInZ5r6AySLdy
i+0zbwH/Zvrog+EyMr9p7n7c1V30ml63kPuxHCs6+Fu5BW+bVHyrnpaR93lz
gifw43QUwXtz/DE6XfhpWfoQ2DkDjp7fXIG3NJOajPa5fn8VODfeEHSU1odc
SbtEFZ56ojfY9ZzufsRWD/toTbFtB4ZJ/bhvz5Do8ZmOv/19CsEvOE8xLGsK
n51ybMMcKIRPLbJ+YREdRYHB58NDv0UmYeLQY+jyngInG/evO1QmSX5+dqsY
O+91KoInDJm867NwtChh6okqlfRb6ppXFGgoR8X0rV+vfb4yjv+v3olK+lfI
qYRKZTiPYuLwipqq1VRsFNBY1286yohbH/O872bhg+M9lb2M+MEjE5zUyJoF
1m7753cO01DDVlZVTU1H9B1NF1ocDQkVcu4Zpf54+EFL7fjtPpzNsyys13uP
pXGLRX7vG8EJpiA1d4r3//c92jssXZ5d/XD1CKlfH+G5JjX2cgRS7yWZfO/7
kvqsxUa6Tas7Yoke1qisV7B0lxVaBgR1Nyt3k+9lNa0TfyrRu4kefPv3DUlh
s19I8BnUWRjyhJyvuVXIMHxjGiRZF5u9uzqKbbFy+26ap+G66IYTYS9GkdOt
t9XdOpPU98/xV/sOztKz91qw+9LXncMM/z6nd8zFS0OHLce4T/ybn9Vx4jq7
LNvQ3/qxFpgdK3J9WDeG2xqCTM+iWiA0Gqphmj0Gl49xVBapDNAOade61k6i
eL7ro/j5GbhUy0Jj/TQJ85Pjxo5N6VC7q6Qz8XgSC4STXU2EMkj9+H/xIANj
1MQNvomT0NZT0+0sq4DLUG5CZcg0OC46sg9MVJD6zzn8LiZhOvvIno61Wy7W
cjUWIX/hdr5fr+nYU/Qk/UxgIVRSq9a6MfCemBLH5oB7xaR+Ya6e277PVTDM
mY7D2zxtv6jFQezlUz4h6Qas5e5ee62XwQ/29vPVvBrDlonlTV5Pi1F6wzgu
yXoMCyg23eZtFGyTiGmz2z4NRS6PXSdWUsCl38VU9XkayzmNvLzlKRCrCb39
0W0aVepNlo5fK0FbqNj8PG2G1L8vFdl//PXzf3pj8MzRnBtnepGbzU6ptszE
zbWhRtHyvTiw6+Ey/SeZ+DBdLEVjrK/vKLtapJEFp4zT4u+NehFS5rdm40gZ
3h1J23L4eCHpT9Qw8aQ2SaON8I0oYXWvh3YMf7mFw5X5MQUpIj1eerdHccdc
9tFuMSp4fEvYMrVGUbfbsOX3j+/g21k38uDIFGIU3V7YWWXBfKfqletec/XJ
WahWTeOzeUPHL5dT3rGL8oieMGdPZd2XN11lxOvHuRV8IlJZ8G098UDL5V8/
NTkVOTONtEm8GnY3bTqZBZnA3TzLvCeRrK/3iHNpFvEnc/+vxD61YdGLSdIf
dP++MrFAl1940D9gVinagLqwiEWi7CMwWhFkI3umBQ1PnOJvLh7HSyNbTbZX
LURvWuygksr1iGHP7qunNbvHcKqlxEPxcynqYsoGXlkP/q3/LoXhaavVqwwH
EekEyxbxIjjc26kb5vxv3pk7JyXviBINEzb+xXrseXj/3T5C/uQ/fJRRXT9m
uqkfBSalz6PZ8kBxCRKN6+5DqE3iniDJPOg90beQXNKPfcd5P5V7eWGlkl2N
du3cvD8vpJjeyW8vGsbAEgfN7b7l5PuL0e2jisnm5VA5cX5my6UpKJm93xXy
phw7tq0YyNs9hbQJV+Vj9CLIGgv+OJGZQvBL0J0bxWw9VHB59V8+HkIBxxXL
d/7WPbBhv/zmHWsplBfNu84RMUTun1X48PG9CUMIzVW9c708G7JJVtKlWiOo
01Pdukg+ByY6/edyTUbgknH+t4pHNvF3/9UrZ2N0ZZ5lFWMd3ht46vHpYoTv
2BN65Hg70Qdti9+8t6waRom00fLDwbEkPv6pc3JUj6YQPtG+Lrm4cOgbWV8R
9bBMjonGp3VJGq7N4+A0ecLbtDQGAcZRYuKsE4iWeGNQGpyMSq92jsGj41jj
2KXvkx1Pzj8mcEh8R2Y8FAbMZRc9HUd6/ct4HaZ4aD79yryHdRz+tnVsbONx
yA9cr7NwwTgubX/0JvRKPFKuHFmmKsvgo6E8Cw9IxxN98T+8Fg93xYXLs9nH
Qb0uLlSwLgGnNF+6Xv4+juyHtpNXOXPh48JCO5qfj6qWh04PoqqR0bGANzxh
AA2lFu0yDJzpcLXZs65uEDSNfROGIfWQ6TDbpN05TL5HCFV5WmrIsI9DOkty
Ta0p2H5qXkTVg2mCr505blODxWtJ/fqalzx98dpd0PVTttRhioRYdIWdkWYL
qSd/npPSvJKB5/SWi3s9OP8WjxYt10yrHUXQr6uFisxuJH5Yn7a98kUyFwKu
+gPS6ybANJyj+3EsF4uvr34wWjxO/h/nzhsByz5MIdwuS0D8Ryk2uWyoPt3S
jLtuJVs11hfg7e2I54Mu//pXrHJX73XobyH+0HWRSrsXw7/tTXRS+HS6AJ43
ri+5e2QCiRx5TwUNGfb3slctqrMKdbzWBhkLctDHrisupV+JFJrQyB25NsK3
5vCznfOKLdxf/83/3PNYotjHm07yKe7PL7juz2gg/leYKVk3RLsB34Oqyp+O
5OP+ieZNR84PkONB+3ymTa79IPjFjk93R4FuB+ETKzWuDvs5DmOpcihzxck2
kn+PMF18cWC6hNRjzF3fgk1xOsd6R7AmsHo7VbMA1ztDbqTx9cD3+jX5tJhG
NPIYvCpdOPJXj83BqtDvmwzv0rCpO2PrmyMUUv87p9dyr9hVSfOjknoEFdUR
X08GD/rv+sqQFXQo5VtlP9HXo4vNEpPCqHhd1iW6cEk55kV5yW69Now7YtGr
WW/Woi18neary22w7QgZkJXLx5Vwfp5G1VG0++5xuGCZhzOsDjtkl4+CPij3
cPBJCvaMzX7/epjBd9+dKR3/P/34b3/7t9bx2SOTfnDcJ8WyUHOIEV+3XuaJ
/QmP4v6i34uH0KfYqX3pSBrWuoXuDc8ehhPHMu3K6DBoaBs6fZsex0fxiXu5
dvUkvvQbG7DmSqYg651pyMtf4wy87X7e3S8F5WXPqbanJ3DrFpvz+XspJF8Q
vuRwXtvOPJwLvsW03iETSSt32b4LLiH6rs96jiUOqZmIMjtp1MqI7yfWuH4d
0qoC+5XLubThcWySu2buwNWKT2nptrqUAVKPefGFld564wEMVmyYEetJwajk
6jc8HH0wYHJ2zo1Og+mDtYllPv/qxzc/VuJqNR3CwOc/UYt3mxJ/OVdv8mbl
7IMz/xdvVxtoHOjOhr2Zka0bI5448RyJUB6rQqqgh0OABiPePN34c8wrB2em
8988S+iGqDp9lOJaQZ73g+u3t/ExR+MMT+KpLtUmwvdurFmia8+4j7n94DKu
/IPp0vhf/p6PeNq4kqHUv35X6StvVt81oxJ7iV2QY6hzrgvCS8UfvhKsx0pH
qhFfxjixvwOi/n9u2ncR+3OtDOVIvNdF8heGCkvoX1tacH/L5eW/dzTAbpth
2zezMaIfrPtp4rn3UxdEeGx6+s2pKPQKTlhzbADXvnNOHM6Nw2wJc9J2szY0
xfnwqNATcONjXDSLYAcUDY3FdxcmwmKib2OMAhXOxa/vX9DIx76GyOvYnwY1
/eTYI+pVEH2s+GxwxQzK85R2tWSngzLdoN29twPh8UVuWQkUPDN+HxlE6YJX
lF5JSTAFeueOq+/lHYakSPoeF5dSnBPYuqxy2xhW2XM7r/1cDJPLabdwIw3S
OsdWvHhVAsed6qVK6zMIf8vdZvFuT+og4UtxFQpiPzsnSX7g9qOKmqSYXwT/
XhVX5Vru8e974cJm+1ixR+P4s/FE+h/beMjntgn5ao7DQ9B0z3uecpJfnPOn
1WuWOig/nMASG60YMe4CfP+aXNtjN/7XXsvxcsR56+JdQ9hU+0jd064cVZt/
79lzcgiF43W6ZRrlsLD6oKO+b4jkQ+7zLinLfNYMTX/fBfZVycg89/Pt9l9N
ODOT7kdfkIyWF5wdNPlm4p8Mq9X8ROxaMNBqyJJ0s5L4P+UlYxdv6TD8u3fp
JrP6IUxejFjnyVgbDNy+t7thCNu9iwbDpgoREpvBOhw4iR3W0kLNXwsJP/iv
H0EhPnnfHRWJnESfJMdGTp9UBO5TapK43gal/+ldaYh2SjJfJdOGtackCjLm
R8H05SvNy5cm4WTsyV6fUAGzZh9OU1M6Hia4iNuOVSJalf24WewA4l3bL9Y9
K4OAqaiWk3AfjFaXTdfGF+P0/RCNm8kDGIoXVPXxT8cSrvjjaTZUXHQakYvU
T4fvx6sZ0j5UCK1ZzaL8NhNNVZMBl2ynIFFa728SkArDXb17BXaPIuyDfQ6N
gWfm62RELTo7DRnRa1VbZCiIs13aKb94AjzLXw/sl6nBZoWF91OeD8DDmBbx
9FE1Tl6WMSnWH8PTsRcyC9q/E7wxZy9KTsuG869SkRv2WuvW1hhwfPiUozPd
jePZzzaE+H7Ag12smfGq7bjS59fFzVFP4uPpuBBbWf9Mgod/JsUIK52ux0uD
JspqpkFwr571y3+bBpbi/VqKf37h/wFed4VN
       "], {{{}, {}, {}, {}, {}, {}, {}, {}}, {{}, 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl00tIlFEYxvFTzUSLwjZe8jpCl00WNZsgtYsF3VbRolWQl1G7aNSmNkVa
SbVokVYKbsplQRLVLoMItNHamAUamalobXSgRaTZ76PFn+ec933e55zz6ZRW
Nx9tWhZC+IqavBCerAvhMYryQ9iG7TinfrMkhNu4haTa6dwQLlpfwlKh4aIQ
OrNDOGK2i6bNlPFtRldOCM3FIVSa6ecdQBXfw6hufgfvGdqEs+jW65ERlxlD
NU7it9qgvLS5XHlXC0JowXv7WXMfaB6GMGM/SP+Y+45JTGAaU5iTdTyq82yS
NeAO7xDccad9BcqR0M9yZgn9LDPGM+X+kzjGe4fnp15KVj0asEq9jtaiBlt4
ylDHVyGrEoXeWIA+97juDWNyv+AGHjinE/fQZn+f5psdN/fLvsr6oPXe6J1I
62fktOp9ss5RK9fPpiP2LVGG/T7nPVI7YN1D99u/sb5Lk+78ly6hg78XJ2Ru
pXUyUliPjdiA5/wZb3pJ5+kLmuJdmeCno3LGMKFewv+NJui0zOLoe6Kdr5Qm
ordYn9e/gDnfNoNrvPN0xveZRRpDGESr+yfld9Mi54/QQ7714ehv7KxhOWvU
nvHslh13rz30qdoCTy9djP4nnNEo7xRSaEA92tCo1yHnsrl2eoUuylvAavMf
8UN9mK7g30WX0zhiGDffR1/jFdZ6SxbKnduv99Zsbd7/390/8UGLQA==
             "]], 
            LineBox[{7674, 5807, 7673, 5805, 7006, 5806, 7007, 5548, 7672, 
             5804, 7671, 7925, 7923, 7924, 6072, 7504, 7505, 5607, 6631, 5608,
              6691, 6692, 6212, 8118, 5514, 6475, 5515, 8119, 6213, 6584, 
             6583, 7436, 7435, 7434, 6025, 5953, 8179, 5954, 6471, 8209, 6470,
              5482, 6457, 6472, 6473, 6231, 8125, 5549, 6607, 5550, 7674}]},
           "3.5`"],
          Annotation[#, 3.5, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl1Edsj3Ecx/FfK3QbrdHS1ggSF5e2VzUSLkaMokatGDWDIKkWh5arBLFb
Eh3iQtKWaoJ/y4GLIGaNNBExWweCIvV64vD+f57v/v5+z5P/6NXb5m2NCyFM
8NOcG0JiTghJuDgkhP0jQ2ig9zNDOI7TSB0VwinazX+CprBP0mnDQ5iK9mEh
dGWFcBAFYodoG1+P3jH6Ql0n33M6w5ybal6iAylDQ1gsrxhFWISFGC+/Q/4t
OTEMGmGO2oF0A7sU1dkhTJRXoUc7/1CzYnQIbaPf6Bt5r/EKvfJq+Vvtfpkm
iP/kv+J5tplzUG9GA35FO7qLSWrixBewi5Clth51KGRn0gw6Uq8yu/z23INh
/HPVF9vxiX7P8QxPUS/+Nrpnek9Nnjvbon4M+5a6WHS3aEcbpvOXiDfLveC5
FpvZFXrsQxnKsRd35awUa6XT1bbQFexEexymfWkC+uGG8ybRZMShD+KxRt53
dQ/oOLNu63MHD9kDzHhEB9Isd5Mgnogq8WTnqIzuJrp77y6HnYts3JWzEqsw
X6xMzm7sQU70TvXKpqV0Kp2GQkzBZGxS89S+zzDIjhlIx2i7HLXrMRwxuwEz
5K5As/hVrMV6rMNS+V/068JHfMYnHJD/wbupMX8Z+xwt0DMfu5GG/qiOvlfx
JSjGfnXv9f2APHYBMpw3nw6mjeLpdKz4fbNLzdiIv/y79Ctyj1+cqQsz+Weh
U6yb/RVbnScp+j7oO/kn9XhMl7Mr1ZbQKvowuj/5j+hBs1toPPsaHac+0/zL
at/z/RT/hR/4jZ5oZ7FeGuT9oTXyqlFul5LoG0KhWTvEJ9Gd9BLfH/EU81OR
jP5IQ7p+8+kC1Mg9h/M4g7NoNaNb7DptRJr8JppKt+tb5ztpyv3///QPZj6y
qw==
             "]]},
           "3"],
          Annotation[#, 3, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl1ElsDVAUgOGLlTFBlddWEaGomVQbbCyImls1dCDESlBDIlREiRhTFK2h
hlIWZkpCSkKENBJzpMrCXFMlpoVZfC8Wf/97z7nnnHtf816nmfkZ8xqEEFL9
2REbQnIkhB7Y2SaEntwLu8QnxotxFi+T69shhH7onxDCQAzAl7bi3A+98dW+
D/fRo8zZonYhbLHfxMUcw1M4lidxG57Mh9uHcAjdO4bQSmyc2vHIlMtAf31r
3WNBXAgLMdx9WpvR2/kYzpOvVDdDPB3TnZnAR9Rm6zMVucjBFDzQa1ZiCB95
ptpS6xncTb9var4jS99q70+0vih3Tc8Md3yvb5VcPV8XeyO3QrwQKxHEWqhr
wA3xTj7JzLfR/vxB3SX1O8zciU/u8AWfcVndPv7EtWqHmD1IzU+1a/Vehxq1
u+3XiE/35i5iXXFF3xy5xnik72PEqK9wtlxsP+bYL9F/Kc7rfwE31A0Vvyt2
DxFMM78d53FQl+xzGWW93HqvucXmblezlUu4SO639XA+58wI/mPfyrolvlvn
6PeDV8ulWKchFcPMz8Z8d8nHVUTMi0ccnshVesM77znLL/V7gafir7gO58Tf
y39APfbJVeizlw/yAZSZu8W817yZ67ibs5nqz3pDJWY718sdN4kVYYHPdT4i
3hyHfOv7PC/6mTt/2vkqfebq9wxPcVLdKZxxp4gz8YhDmbssEt/D5er246/z
f3DJzG28HXfES/imOb+cLbX+ybfFb2GrfTEWm9uFk9AVJc501j/TmyYgAw/F
JnINP5Or5Wp9T7hbjZnX7evkj9u/4jd4jSP2bd35GMfyUU50vpH/R3uOdY8E
XiW3kFfwShTim54pZqRap2GjfhswVo88d8iNfq7OjJEbi9FoHv3O8yln0rmp
/UhuwunR76/zg6O/QeaXixV4+1p3WI8C8ULvb6bvc/+XUrnM+P+/bf8Azli7
zg==
             "]]},
           "2.5`"],
          Annotation[#, 2.5, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl1F1MlmUcx/ELm03AZZsBJigILV5KbYiKgOGBNNGhSQVBuJpubemGTHDG
QMp0Td5qq9ZoUQoHlXSisGAVtCitDZhz8yjnUk9CTlJw4kpFP/c8+D6///V/
v+7nee4Vu/eX18aEEHb4qF4eQsPTIbQtDaEkJYSXMMXuXhZCTnIIzYkhTLCz
2eXYiavOmWqy0IF2NMnLpl1i19V/J+9bHGd/iEbxLOd1dI+89fTfJSFU0G1m
LmTPyDuh/iTq5Lxst7ikEPrVxdMB2iN2S96D1BDO88XSN/newoya2YQQxsXH
cAmpaSH8RdNoXLSjWTloNu8TtU10g3iZXsfNa0Wm3GdxW/wp59XsMbWL2YlI
wOPO9WY24Ff9RvG22RvVvIgi3NezkM7RhWbE4yP5ndjqLp/psYV+Sktpuv2v
22cK9XxH5R/DAX23idfTNHNWIBUZSMcT+g+KD6FM/nYUyX1Bv2LaK2cn34j4
MFr0Pi12BiNmHZZTyW6hk3L/wTPuPCgvxl2H6Hqajzysw1qMyL9H7+Muztlj
jhbTOrqJjuk1jgncds71PGbpGnqWVnkW1XgDN+wwredKO67Cc3jP7OfpKbqL
Ztirmz0Z/c5QyVeB9/na3bEDnbjgfIz/KD52PuKcy95Eb7pza3Qn50IUoMQ5
3/zNdDZ6/mr66Cl8wL+Ff47dxf8FYvjmYT7fIjs9iZ/dcQTD2B19Z9jgngXI
xz33jVMbi2T9OuzfY/YM+wSdpifpLdpLi/TfiCEzBvE1e5/YfrE61OKx6Hvg
22vmGjnv0Fz6udw887KcL9NMmmKHZIzaq01tO1qj/yj67fSLPi3RM0cTDkf/
/+j5yu9T/z2+dP4K3dgh/29zttMFtAqvY0L+Mrk/mptCf6JT0W8bU2IFtBB/
4Fyk9v0TZ9m/466a//EftvIftHMp/U1sFO/yH0KWvnvc/6Jdauw/ICcxej/J
v4Yr+EF+jf2aaI9zMy2Ruzl6J6h/VZ/F6u44f+P7aBRP4X+Nv4qvGov4XqHl
WMmflPTovfkQi3HDgg==
             "]]},
           "2"],
          Annotation[#, 2, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl1GtsjmcYwPG7Wbw0ceriUKYnWhJmWquVytpaiAqJQ0Ik4riN1qHGWkSc
l8WQ1RKjTiVFUbI57cMk5pBgH6xlVYa1utmQsEU2TEKC35N9+Pf/3Nd9He77
ed+3aTPmjyuJCyEs9edBYgjZnUKIdQ1hl+fdKLXu8VYIZZzOg3hhlxAG8iP7
izkxOYQuKEwKYQQaO4aQJaeJu6eoRxrudg7hhfhzrJC3HMsi67PJfhXX61Ml
713xbAzAzWge5+A9NMi5igb51/g6csUH40czb8m/yIOsX7nLYGd8ybl8EKfM
qraf6T5Z6Ie6biHUokh8oX6fYgHKUIoOzpRi3mG1BXLuqBkv9jtP4D+iPrzR
7EwuNy+LfxGvVrdSfBX+9fwPPtfjOb/ABmd6xus5R84rz8k8Ss4UfSajp171
emXwU/6YH/NH/IQ7yu+EmNo/5d9Fd/3acxpvcLcvohm8jgeK56DMc7k7fYWN
uK1fEjdzMjfxHDUD5M2yzubeqSGcFjtifYaLuQhjzWnlLGM4nj/EDJS7xwnv
cI1ex/kz/o5X8SVnbulzimG19THxDDN+5Wrr98XzUKdHhdzLXGCdjyY5jTjh
Hsdw1twF5pU40zxUya+V/4O9U2jAVcTJ+5nrcQV7o8/f+YP4Ps8p6lLxhnNs
MacCSfaaxdbKG4IPsEn8a2zGA3sPEacmz+wC5GO8+fni4/gbe9Oj35f1tOh3
w2dxBl/aL5O/CKUolNsr+tyR7j0UiWWKdXa+Cs9bsQ07sB2r9ahxpp1y9vBe
tPE5tcV+zwdwEPui7z72RzPMnKT/MJ6Mo2qX6LMYk5zvglkXcR630YSh6qZg
KlLlT+NWnKBPZfQeON66UHw4atQcxi0zD/Fpe8f1X6N/f27vbt+LJ/BJvo5r
WG8vXc52PbehpbqhetzT/z5K7M9HO3Wjrccgzx0yxP6W+60eRzBTPCbnL7GH
6KPnPb6PePFKzlU3Ec2eX5rxG9dGv2kO3t8d/sT+HP3mYpS9Rh7Ja33/asx8
aj+m9pJYC/6JZ4sXR5+9dZ28y+jtLn3wNm7Y68fvoC8q1VyJ/rdFZ+Nzzpop
noX+eFOfBJw3K9G5MrzfttitrjXv4jY8V995mG39n3MW80rvYUXX///HvwbC
qN/t
             "]]},
           "1.5`"],
          Annotation[#, 1.5, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl1VlsV0UUgPERURL3rQut7FVZigEJGFmMUEtBQKAtLmxWEqxSRNFu0OLG
EqItFDBEoWhxRcAigolW4oOAZZEaECm0mrQiGlmUpAgl8cHfxIev3z0zZ86c
ufd/b3vMei573hUhhKP+7OkWwvqkEI4kh3Bz1xBuwcguIYzC0YQQBomvTQ3h
OlyDG3A9rkwM4Vk5jSkhtMr5FSfRggzj3xg/4Pogvo81bg9hp7EvUNA5hD5y
euMuVNv/kJw6PfTVz3nxa8YXYwk6WnMV/jbeT52/OJ1fl79OfoXrSoxEBkbh
LTn71NyPvajHdyh0pgNqHsR+lDrHUOPtfB9f4mHqduxunDfrdaJad9v/SfEs
1IgPyx3K83gYZ8ubjNv00yi+lY9zAh/jZG7iRD7BSbxWL+V6zVazjHN4EQ/n
Edghp0hOruv51rSLX+DnUYjL4he5WM4kviiezMMxAtvF+eZqXa/Av+KV8Vnr
8zB2mJvoWU7CeDyMCUgzNwuZzjYaD2IMsjDc/fncfctwPQod4lmMLTW2DHux
BzudY657lu4+FnBQd4S8Zj2sEb+JV+1fZZ+zcs/gNB5X74LztqGLuXxrZtin
l/Hp3JNfMr7M2jb5F7DPfvX40nWRuv3tWcid7Pm18Tpc7XqBsYWYa+0KdU/F
+8Fz0NV8d3SLv23170euvG36GGLNYGTLSzGfimJxCWaqkSZnBvfiUpx33Uef
zfJGx371ncmL+IQem3Acr4hfxofqZql1yNoGtIin2n+j/beaL7N2C5fzp1zK
m3khb+IF/Ak/YE2jusdQLv6Jy2JefIZyqnkD3sZ6rEOVPT6IPeB9fIyPUCT/
PS7hGi7mjfGZ26Ncr2Vocr6M+Lzibzre39hbfIdwEcuND5CXL6feunHOlmb8
F+fL8UxyMQUXxOfk/sM/o0KtZq7kXdYedY4fcQQlsResNr9e7WpsQAe1M9R4
ylw+ZuMZPI1VcmvNb0VnfUwQd+J11nXk8eLerrPMb8Ek9yTP+Nho1Nn3KwyM
6+UlI0/dJzATNfZ9Fz/otwFr5b0T329rzsXvoLFp8ro6y37XXeK3iW+yRz2n
iB+Rl8q/i//AKUwVj1FnLDKRhdHxexffe3tUciEvts9SLEGbmnc6zxn1zqLB
/T2EoeaG4bKaq42vQhUeE/9mr0f5XvPtPJgv8ZAYO38/vf+pZl8+zel8R7z/
6ubEb0v8/ss9iQXyR+qhlFvErfHbbL4C2TFXXKHnlfwGT+NUnsozMB35+pqN
Kfa4UW+D+SHxOIyP/wtiz9bcY3yTvQbFd1mcy608kPONV8f3W7xazSpew/PN
9VCzJxJ8J5KQiF367aPHbc70GWoxQO52TrffHHP9uYDnGc9Tb7f631rXaK/d
Cf//L/0P3ZYYpw==
             "]]},
           "1"],
          Annotation[#, 1, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwV1necyHUcx/GfFS1bOIqjEonqob14NMlqOZWGu0vDOFREj4Z9SuNEWo+G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             "]]},
           "0.5`"],
          Annotation[#, 0.5, "Tooltip"]& ], {}, {}}}]}, {{}, 
      GraphicsComplexBox[{{0.4, 1.}, {0.4, 1.}, {0.4, 1.}, {0.4, 1.}}, {
        {RGBColor[1, 0, 0], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->20], 3], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->20], 4]}, {}}], {}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{
      FormBox["\"r\"", TraditionalForm], 
      FormBox["\"\[CurlyEpsilon]\"", TraditionalForm]},
    AxesOrigin->{0, 0},
    Method->{},
    PlotLabel->FormBox[
      StyleBox["\"Corr=0.08\"", 20, StripOnInput -> False], TraditionalForm],
    PlotRangeClipping->True]}], "}"}]], "Output",
 CellChangeTimes->{3.5857641332211523`*^9, 3.5857648701213*^9, 
  3.58576492466842*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"truemtbl", "=", 
   RowBox[{"Mean", "[", 
    RowBox[{"getsnptbl", "[", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"truetreeloc", ",", "truetreetbl"}], "}"}], "]"}], ",", 
      RowBox[{"ysnp", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "1"}], "]"}], "]"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mtbl", "=", 
   RowBox[{"Mean", "[", 
    RowBox[{"Transpose", "[", "tblsnp", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"gcortbl", "=", 
  RowBox[{"Table", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ls", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"mtbl", ",", 
         RowBox[{"reshyper", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "i"}], "]"}], "]"}]}], "}"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"gg", "=", 
      RowBox[{"Show", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"ListPlot", "[", 
         RowBox[{"ls", ",", 
          RowBox[{"AxesOrigin", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0"}], "}"}]}], ",", 
          RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
          RowBox[{"PlotLabel", "\[Rule]", 
           RowBox[{"Style", "[", 
            RowBox[{
             RowBox[{"\"\<Corr=\>\"", "<>", 
              RowBox[{"ToString", "[", 
               RowBox[{"Round", "[", 
                RowBox[{
                 RowBox[{"Correlation", "[", 
                  RowBox[{
                   RowBox[{"ls", "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "1"}], "]"}], "]"}], ",", 
                   RowBox[{"ls", "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "2"}], "]"}], "]"}]}], "]"}], ",", 
                 "0.01"}], "]"}], "]"}]}], ",", "20"}], "]"}]}], ",", 
          RowBox[{"AxesLabel", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"\"\<<tbl>\>\"", ",", 
             RowBox[{"hyperlab", "[", 
              RowBox[{"[", "i", "]"}], "]"}]}], "}"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"ContourPlot", "[", 
         RowBox[{
          RowBox[{"Evaluate", "@", 
           RowBox[{"PDF", "[", 
            RowBox[{
             RowBox[{"SmoothKernelDistribution", "[", "ls", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"x", ",", "y"}], "}"}]}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"x", ",", "0", ",", 
            RowBox[{"Max", "[", 
             RowBox[{"ls", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "1"}], "]"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"y", ",", "0", ",", 
            RowBox[{"Max", "[", 
             RowBox[{"ls", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"ContourShading", "\[Rule]", "None"}], ",", 
          RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
          RowBox[{"ContourStyle", "\[Rule]", 
           RowBox[{"Directive", "[", "Green", "]"}]}]}], "]"}]}], 
       "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{"withdata", ",", 
       RowBox[{"gg", "=", 
        RowBox[{"Show", "[", 
         RowBox[{"gg", ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{"truemtbl", ",", 
               RowBox[{"truehyper", "[", 
                RowBox[{"[", "i", "]"}], "]"}]}], "}"}], "}"}], ",", 
            RowBox[{"PlotStyle", "\[Rule]", "Red"}], ",", 
            RowBox[{"PlotMarkers", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"Automatic", ",", "20"}], "}"}]}]}], "]"}]}], "]"}]}]}],
       "]"}], ";", "\[IndentingNewLine]", "gg"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "3"}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.529337849269189*^9, 3.529338022008293*^9}, {
   3.529338193312194*^9, 3.5293381938581944`*^9}, {3.5293383905433397`*^9, 
   3.5293383909801407`*^9}, {3.5293393065471344`*^9, 
   3.5293393111803427`*^9}, {3.529343341812544*^9, 3.529343402075449*^9}, 
   3.5293434853015957`*^9, 3.5293435184360533`*^9, 3.550264557134804*^9, 
   3.550271601944089*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{{{}, 
       {RGBColor[0.24720000000000014`, 0.24, 0.6], PointBox[CompressedData["
1:eJw9k3s0FHgfxudKc2kaM8OMawbNRqOJRUh+X1qtimPz2iS6GUayoaXoQr01
YsutoiWliO2y6k3MVnKN3hVCukjWJWIwNte5NOOy3n/eP57znOefzznPOc/D
DY7yDcVhMJjIJf3P3QdxQsUqY7iYS5CcOaVAKa0Ldiu26MHTomur80WLyGMj
jxirzYTY+6IM+TfakDkhlTWZsMA+SPcbz31YsGn9lXXyGA02RMazM0RkWOX5
WPpiKxVOz44xfw7Sht8qBjAxnSz42LtnnkzCA7/U7aWWMwVupmp0egdJ4HI7
Fy9hUkHXRxyxE8+A4YFmDC5DD7xzd3nLfptDxJzT3ofxq6Baw+0MTZxElTGj
yLqcDusnaTyrpmXQPFNR3PYHB9ri5oRWlUq0+IE88PmRLsy8ZPR8G7qAsgca
7klTqTBw6baXSy4RtuGzl1DLIPCioJyxiQoVFFbjj2IG3Lhc5FfDxMLqvhDJ
EbUWTKsmqzuEhpBZ96Wr9QADHErtPU8O4CG82aH6mYQF20dGDePpGLDcGJY5
eZ0CPT1l4YoVdEho6veMGtYHmbGpMT1UjSZyHnACM6ggn3Q3erePBqKs+Oxa
Lz34dUFTJA/VIKddGp2HbEOoJh4iEBVq1JzFKzzmQgUzkYRln0qBZKMralkK
G04d8yqzmcTCJw/jW6fKqOBH2/vvvp1UmDv3XNCN1YP86PJZrU8L6Jcn6Q7f
N7AgkNPWdctxHlkaWjnzRAyI83ctf16Pg7zAlrzBL8tB8FqFOdGgD9rdrV//
krGAaNZz5GChBuE56az1wSagiTqRS3mrQCcudifcu2MKEdff5pFzZtCpq7EK
wTgD8MmVtU8r5pE9f0IYHGwAkjSaB8N8EYXs7LwW7mwEdQ8/Xm20UCAWxXuh
rNUY9AOefd20ZQpdIp9tslEzYeFz+1pJPQaEazKy5U4mwN6RmRjAlqOSjLfh
E9P6cMrt9rsXsIjyh0LYafcNYKRUJq5tVaJ0s6Jzg4uGENcVJBSXKVHfh8Nd
/E4OyHKx2UqVBmlcI4bUG+gwtTiVpS9gwkjCcrfheAs4fm7NuJftLApIjI90
i6BC+8n+vCkBDpJUrn1/DFvAlKbNxKFnCt1scyBxFzngm6/Z1xKlREqvXEXz
NS4Y3cP3BBBUiOeo2Ld1PQ86C1aEvRH/jRJecELyk0xhPyZitZ9MjqheT7qk
eeZQfGxs0lY9gWrbSY5u/bpQefyOi4XjHNq2PfI/YfYEGJxoYbzPpoHGv799
3F8PEndej5DEL6DQqFLV671G8FPzBevEexhwVjTKg8+zwZPfrlr/8xza1fHd
2BsqA17kx3GvinGQFWTr/LsZCQg1TY0lIjpMuxtSMVf0IKnk9VWjJDVKFyuc
nJ24UPU18uGzDxMoznu80yaVA0YG6WcbhWr0ZE1hr4pOh8cOffwtXBJUCBIK
K3P0oJlXe4EnVSOfBwl8cgcdmGKy/pgPGfxVZZ++6zAH6yxW8KvYSbQt0y9W
8CcbZkKqtkX/NIeyLT3XduvyYdeDMNmblkHkIfzrQNVZQ9gfUPjSz02OzMTT
unc+M0G5iXx+6iQWLDyi7UZMDYBiYI0fqp1FXkcL3FJ9GTDv7Rc6hBaR9peV
PbGPqKAoaLU9gyFCm+mZvLXndSBZO81SNxgHp0Vx6+xu0MC6hWR+8R0ObAuw
Nl4zyyBr03D6CTM84JQsQkmKOfTFkkKtMmaR03YLDKHDAPKdysJIN7HQ0Woo
lFSZwu3ppCpCwjQKabwfI6s3hbqOmIN/Tkyjj7ek63RG6cC/9mMxbV4LDNzJ
X4PzV8K/MrjlG75Mo5tavpbcLCvoGC1IjCn5jCq//YVOTOOCj+fgnu11SkQ4
WjRRWsOGy0HTWff/iwO9K67hbnE6sFt6KcQrCQNlA6VWoj1MaAsVfe92RBui
KTU2j/bogL/gFX9lIQ6cBFYN7kt9e4nz6U4SLJQ70rKldBNwUTXZpUhnkeqy
vkXfiC6MbrTsshXPo4OiuzsM7FaBQ6qH64LrDJqxlspb6y3+ny/sPy6SqHTA
d/55YPERAvQr6+yseHpgZUHsxqYs/fe9+Rt+LRvKZCvX3cmRox98fH7Yu7TX
HHJCdTaLCZt/nzw+lGECcbttd5DWKpFvMZ9nftcUzpk32KWtnkXvp3YPDXwk
gtKucI3dYzpoNbocZphy4O6r0SZXAzXaGhOIi7tsAu85JV1P56fQ0SY9edqM
OeB6nc0258+i8JobR2lTy6F6PCo6TYiHC7nVf1/vZ4JiWhPb7YGFSumYziKB
CTy6vtQPYeHQodx6bxUFRpKTG5WjRIjNlPctrqDA7N3NB0ijePgH47sdUQ==

         "]]}, {}}, GraphicsComplexBox[CompressedData["
1:eJxtXHlcTVvYPuc0z/M8nUYhY5RcrDekSJEyRxd1aTAmIVFSkqGQIZHKTFJk
JkMyhMI1D4XSrDTP9fVd3rW/vc/nn/t77tprr/Ws9c77PRkvXD7NR8Dj8WZI
8Hj/+1/uP/mz4iRU/hdhYx4gVu2JKrypKg3scWWKY1/n7jqspM55XpvifX2d
Bn7S0OfMF1LsSn6UyiuaUBz33/vMKH7le9LGSsWCYvX/3m9J8Yz4xVHO6v04
61lRjP/sYjxNI1yKCPJlYx4gRr7scWWKkS/7eW2KkS97vpBi5IsY+SJGvoiR
L2Lky17PimI231oO31oO31oO31oO31oO31oO31oO31oO31oO31oO31oO31oO
31oO31oO31rK99ziyDkm61soXzbmAWLkyx5Xphj5sp/Xphj5sucLKUa+iJEv
YuSLGPkiRr7s9awoZt9vD+d+ezj328O53x7O/fZw7reHc789nPvt4dxvD+d+
ezj328O53x7O/fZw7reHc789lK/3W53mlXFigHzZmAeIkS97XJli5Mt+Xpti
5MueL6QY+SJGvoiRL2Lkixj5stezopgtz1LAlmcpYMuzFLDlWQrY8iwFbHmW
ArY8SwFbnqWALc9SwJZnKWDLsxSw5VkK2PIsBWx5lgK2PEtRvvWtv7JfLZKj
fNmYB4iRL3tcmWLky35em2Lky54vpBj5Ika+iJEvYuSLGPmy17OimK2/SsDW
XyVg668SsPVXCdj6qwRs/VUCtv4qAVt/lYCtv0rA1l8lYOuvErD1VwnY+qsE
bP1VArb+KlG+dxVKchISVShfNuYBYuTLHlemGPmyn9emGPmy5wspRr6IkS9i
5IsY+SJGvuz1rChm2ys1jr1S49grNY69UuPYKzWOvVLj2Cs1jr1S49grNY69
UuPYKzWOvVLj2Cs1jr1S49grNcpX+ugUy0mRGpQvG/MAMfJljytTjHzZz2tT
jHzZ84UUI1/EyBcx8kWMfBEjX/Z6VhQj37T/7JcW5cvGPECMfNnjyhQjX/bz
2hQjX/Z8IcXIFzHyRYx8ESNfxMiXvZ4Vxch36uCbO9qX6VC+bMwDxMiXPa5M
MfJlP69NMfJlzxdSjHwRI1/EyBcx8kWMfNnrWVHM9kd6HH+kx/FHehx/pMfx
R3ocf6TH8Ud6HH+kx/FHehx/pMfxR3ocf6TH8Ud6HH+kx/FHuN7XP/6ngBNf
FpDmwplz1DT6A2K2fS8gOD9F/e2Jf3x16fkhxvlczF0f5+E4Yhzn7h/f93v8
xZ/93yETxKeOD96H+71DcDwvatHFw6W6gOOI2XyZ+ez1X4isj/NxHJ9nn88d
+v+56+P7Xvx3f5p/4qEy4vHffelS/Dbb8q2fliHF5xsbVR0UjCmu3fbmxmtF
U4qHGF1Z6K1sTvHv/cj/sdcNf+J1VYpxfcS4PmJcHzGujxjXR4zrIw7M2i/b
qNKH4t/6IP6HfwfdH2LcH2LcH2LcH2LcH2LcH2LcH2LcH2Lcz2//zQfcD2Lc
D2LcD2LcD2LcD2J8/2//IUHfhxjfhxjfhxjnu/5nn2To/hDj+xDj+xDj/P33
LOrOzlKg8xHjfO74sr5Pzg5IUebkC2X0Prj5P1d+ufUArjxz6wNc+ebWC3Ac
5Ykr7/g8jnPrGSh/yI+b73P1g5v/c/WFWw/g6g+Os/WXqQ9w9YlbL8BxdnzW
wNFvpp7BlWduvs/VN27+z9U/HGffN1MP4Oojtz7A1U9uvQDH2f6sg7Djf0Z/
2PmyPEc/1EX0lZvfc/WXm+9z9ZldLxAXya+563P1m5tvc/Wdm79z9ZWb37LH
1UX0n53/ilP9xflc/ebml/g8O5/n+g/mPHD+yv/0TevP+lWk8T//rUdxsIzO
2aHaRhR36/zsPL3TmOLf8qH453yaSM1/9lqNYnw/YpyPePP49MmP48wp/n2+
kn/4dtH3I8b3I8b9Isb9Isb3qdZ3f5bYLwCcjxj3hxjfx31+ToSf/ZVNkvR5
xDie/F88Iwu43/IT9rJa7opwaWLwxQg1HXpeNqtHCI5pGlDsWdBp+W2HkOKv
bbfX8uLMKB78n73Q+CPfdfQ8EeM4nh+uh+PIBzGO4/O4HxzH+0GM+0FsEpsk
jNttQfFvfZP9I89tf+yhCsW4P8S4HmK8L8R4HohxfcS43m955wFi7n3hOK6P
GM+PO47z8XxwHDGO4/5xHPleuTFMqTBGnK6PGN+PGN+HGOWz0zk5cNdqafo+
xDifOz7+i9z7MfPlKX+Hq38ltZgqc/KTKsKOd+o49r+KygP6W3Z8VkXY8VEd
xz8w8ozz2fFcFSeeq6Lyw8Xc7xUon8gf/SfbHjPyjuP4PPpXdnzWRPeH8oTy
zo0P8H7Z9q+Dyh87XlSk94n7R3lh6y/j3/B55MO1R/g8W5/5wD4PMeqPcD7e
F2KUL5QPtLd4/ojxfpEPng/KM2K2P2bkiWtv8LwRc88bMe4Pz5vtL9sI21+2
0fUQ4/vZ84Wc/UrTcXwfYuTHjTe49gLvC9fn7pd7/1x7gPqL78dxzG+48TbK
I8ofnic7X2TiW5RP3C/6P3b9lZFXlA92PU+Cygv6N3a8LQXsfE8Okry/vFix
y0QkXkB5wHFuPID3g/LNxbh/nI/jcOH58RGxphQjH6495mKuPuD5oz6z/bch
3T873mX8NY6jfUOM+8Pn2fFxFSd/ZTD7fSr0vNj5IuNf2fmIKn2enU+2EXY+
2UbY+WkTxVz/zI0PuPkQez3mfvF8uBjn43nhOGLu/eI4+n8uZudrslReELPr
CSoi8SR3nGvf2fmSvEj8yZ3Pzo9U6fOIUR7xPLnxK76PHR92cPxzD70vNl9d
kffj83hf3HiYnS/JiugD6j/un60/mvR5dnzJ2Becj+fDxWhv0J/hODueZfIx
tJ/sfIKZj/YJ94fvQz44H/eH+o774WLMz9j12SoqH+gv0H+y4x9FKu8oL4jx
vBCjP2THK5Kc+1OkGPkjxvdx83PUJ7Q/XH+L+8f3I8b3s+MLSXq+bD5SwI7/
Zag/wfNmf79povrNtQcoP+z6EVP/wPtEzLXXWM9m4yKqT7/5FFP/hJi9XgEH
F1H7hc+z48ViwvbfBRxcRP0XPo/8EbPrXwUcXMSxd8U0XkPMrleUceo/tdQ+
oX/B+0OM/NA+/L6/VoL3wf6+i/GrgNobxOx4opWgfrK/H0rQ59F+IMb7xfko
TzifXS8RUPlCjPKA87FegvPZ9VIBzZ8QY77O7rcoo/kENx/H82XXt5n4gFu/
ZPs7Feq/2PFnAxlRdi8if4rZn/NppPEr3g+7PsTj1Ie6aHzMjv+Y+0X5Zfsn
Aac/RkD1+zcfZRii8mVYmECSng/e12//JAPm2QPCHtQx94HxIc4PTnVKGFwt
Q+3l/19vLuDgImrfUN6xPoz+kW2fO6h+oL1j9w/waT6H58eOZyQ436clqH9D
eUV7ifKH8QHi38/L0fNA+UD5w/NDjPfPlkdVkfofYlwf8zm0J9z8De8PMb6f
bX8aOPX4FpqPc/NllA+0p6jv7PqfBLDzR+Z7BsoD6g/qK9teKVH/y9ZH8T/r
qQL7e48KPX8cZ3//UaH2gH2ePHqeKK94nsifGw/j/f/GCvD6g+riWS1SlA+e
L+6fez/c+ADPo/zekwS/AlOq77/lU4nqG/pftn2Tphj1D/UL5yPG+QcSZ1xd
ZKhC7wcx+m+UF/RfbHtvQjHaD9Qf3A+eP65XsWnliwJtVaoPeF7seFKVyjdi
3B/OZ/vTHupP2f5Hld43nj/OR31eoF99rGzSD2oP5nwUlvoEFdN4yfB0Vuuz
v4ppvORR6l2jefs7rT+sC7jkmKTxi+L2g0qflss3kJsyN/YmnlMTycelMuJO
3JjHfF9ryv/160dILXkVdG79OgMm/vNSGKVvX8rEf30OTf8ar858H8Lz2WzW
HqoY0kq63m+u9Aph4kHcDx9si1+9a6XrP98doNLt1E6sM/zexw3T48RTQnA9
fSt5cHkLObsmoPnrKiOR/s8c8/ZEq9ut1P8ECKc/FrNm/E3sI6uA1hl8GD1f
qU+pqWj95NyTD/MKP/YQX7+FdXIhWiLfaz5leTaJ+fLAWbnTId+N+V6z+tbz
hM1dUiLfa3YcktmpPoSpr2x7wqtIdBen8pehbxX684oU1Et3d76tZL6nxBVs
bbBwVGL65954at6z1oNtDvxnmz5VEV+9U1FTeUKor/R4FFVTQw4cqnEqeqAI
TovOqwUObCbTD/YsOuqmBsviDC/GSTWTaj13wd0yNVBadCVpoVULyQwy9Tq4
RgssIy982z+xmUjMNmjNMzeCr8N1ffOPNhH9jHFij/kmcCzNocRhUguJOFtn
deCuOZz//nHFE9JMqhJfp3yY3ZuPDblzevvR3vwy2WrFu79698tfV/ghqJu8
nmAgbeSvBfkxEqv3S3aTyo9+BUYn9SBX7kxNfGA3+Xzjwc7TL4xg9mQbk9V3
u0n21nVJ23LVYOXwrL3DnMTg2wP1AS8LtcDzxej5L+aJgXtPE9mvqwVmY7/O
XJnUG0d92/I2brUejNcIkrFoEIDzpmx+ea+eDpfLC1RYKgVDptfKS85Xgxvx
BnvrnklC3Pnz9x8pKUHk+GPV4d9lIdt8+98ZPmrQOajtkl62LBzYolZ+57YS
nJhzrFvSWAkufbk//KmYLugII4aH3ygjE5RvDXi1wgA8gzNqyK8SYnrQtan+
iyH803f363OBJWTn2ntzR3oaQJTNwNLZHpVEJuD+wLik3vvxGTnfV7eELAot
nCoMN4aaK4eu/VVfTLZenTz7xE0hSPFHfWhsriApbx+cvNdrH1Yf5KeW7ykm
xHmQx/hTJmCheznZOLWShDqbTu3wMYdxvltmeRWWEDve8ANX01XAdvvr1k1v
60lthqtQzE4DtOdKj39dWUemNHukBLRpwJGlU78aLWwgmyWDhio4aUJRMdxZ
bN5AXukd21KUowMtCxqj9zXUk1kya/PeHdYFH70f8fpR9cRI6+r8QGcDyPRo
rzgsqCdzkk/yH9wyhKnT9pfVutQTh747bjuVm4H5to1zO3vn++oe2fbqjAU0
hfx0GtVeR/ZUHNBv9ZeFURLf54c8aCNeuo41RgdUwD04IuZzSDtZX1qY+dVZ
AzQXvBDwi9uI7sZXFrNkdCFd7sfrNa4dZMn3A53vqnXgWPTT07kZHeSI5PqK
jpsGoD6gj+aGzHayUd6k7dJhIVzpJ7svK62N6OntzZx0VghaXxbtq/nRSQQ7
Nvf9ctUELNO/Je5WbieX2o+4RH8WwLxP4dWfJfhwa4DitKWeslAYM6du9gMe
uIi7Rqhclof392+OaHHhw4UxuWu2xKvCPdm0/Wu0+RDmUnJTOU8Dfg56LW3f
az/e6+8WbNHQgMrmcS+sTvIg42v8znQxLRj82TND+wIPxmbt2iOM1QH+7knN
N3T4YOJZN/3oVQNINq4JHzCGD8pCuYPNAQI4rugwapmbJIDaycaPPFXw73nz
0X+tBCQZ+5huslaFdzLfJuX+LQHSwWdkp63UgL+lDk/0qRCH2S5fnfOOCeDh
ugM79tyWhhtvm8aP7CcAZacYhzNzZUH2x+KBl7eqgNE4xaXNVb12UNuLb60u
gAFFxuu1pirC6P3n5c+f741Xcvfz09vlwXJDYMCc53LwcPWqv8Nime8xcXsS
Pl69X0HzBe3GD06Kh6spTlp4sqvMiqmnb4s8MTXMqIrorjhU0d9ZVyReDn0Y
vkmvrJri+MjV3nXJv6h9H5Htc3RMbgWN3/6Z+sCpLrmG+rvRu3TfvDpbSfPd
ueNNWuz2/qL2/1CHi9+0V5U0H5V33tT0+HQNOVHRJBd9zUIkv5G5F+u4YSFT
r5T712xNxZpW5nuOg8Lyh8OaSMcns9DyTCbfQf89SCpxxp5Ypn55SHnF9pgr
jD/d+kXb0uRuAyl2M49PD2D6OQqt58QsDBL93rN3UpPMt+5mijfbJC4MG9xG
vrYkW2Z+Eq1nyvXx1rqt1kJGuP3IX3uO+R6E51PuP8Jl4XGmXtk423Rw2LdW
el7qt6MWlN9ppPmIpIHV6JTBTUR+VMcK342i/R/SVx5+/LiZ6f+I51uktHV0
EL/buhvdL4r2gxTXHK2UGsgDx6U++i7nlOh4fv6Yhi3FciL1yuR/FKUWafeQ
62PEVCSfMvXKomfzDQq7ReuVj5xHJutZMP0irv30ZFSFPKgoeL9Jbh9TnwzQ
P/Lz00PReuSx9zPXLj/dTZTMLj11DmW+l+H5LpvQ8dOxlAeTTmk7lJ1k+rvu
LLefkhbI1COvyW+/uzNWhmJYumtysYMsLO5Wz5E/9r/fS3XfPnsnB0eOXjq+
4xjTv/FcX+3ubFMBjQfXNGta7UllcOJhh7in9Ux8IpUftHSzvACSSzZWt+kx
39uKagxHTcxh+k1WPOH7vlok+r3NMWaAo7kNg3W+Xh0BK5jvQw9jrmYlRwug
YP/damlHA069VRdSTadY/bzem29n5+2VuiwQiXdGD7vi7PL3/8m3h6fFucj3
xvG3j2gmxon2q+ys0Jn5fZY05F53I6EjmfrotAfrBhYfEa2Ptri1fiGfJSG4
RGHY02vc/hV1qI6vLhPkygAsmpBwaqpovwrZNqesJFIeVs6bMG/4bnFYpiz9
Pj6cyVfrxqzcYt+oCBlv/uk/eqaKSP9K2NOk1F9blWn8dnfCfNMSMRXQkZvk
N+SKBM3P7pbcM9tYJyvS37Ly0+cNB5LKyN3zF47qyDH9LgmwTs4qS8D5fYU4
7Kk+qDpjljI07ePd2SujBR+dHRrMx1URS2/714uEWrDr47aT4f2rSOGZ1476
Brrw8ZHgY+ThMrJgzo2La77rgnJFlfzYvtXk0t0H3mlXeuX5WXjowrIKEin+
MactwggKA0otFt2pIN4P5IJzHAxh77TKh1cP1hAtL5vRr5cbQ1pw2HaNkEri
sOCSzT+99uVjlZ7q815sPjytLO2oKhhpL78VktZI3EODJl84owlaY632V15v
JPHj5daF/9ICnl9swbB/G8i6sxeqPgRpwro3CjNzLjeTQvFLjifdjeG2/LLR
3amNJGPA61t7FstDrOahyVsudZCBwgFr078pAIk9PWycWRfJGBFderfXH068
Myvb83wHEdqsPKtVpgorJzgnWcp1kWuWN1Mcv+iCwCTz69uqTvKu4s3MU6cM
e+N0BZM+oZ0k025Yt1iLBLRI+50ev00AOQPXv55UIwHv8lfwpE8JoOzizzdO
P1XBpjUtyTVIAK90u9NW2qlBn/QdssG9fnprUs6GgtWa8KIwaXluJx9kYix/
dDX04i/LNcZcEoBlWF7irlm6sGb5VxOrQj74+rkOabysCY/8tQ90mUuC9p7L
3/pu1IYLTYP9bQwqSGhT2lrb/Tpwc0n1/QsLfhKNfiXVG77qw4wcwyUH4iqJ
ZpDvdvdaAwh4KbvFMLOGPA84nJ+nJYSrPWnv3ZtqyKOx1dN/egoh2LV/xaWf
FaRxWr9rr6PM4P7IzRle56qITT/Vz9sfmkFHgN1TL4Wf5PmnvJG3bNVhSu7E
QOnKWrLxWZV0UoQ6eC74cX1Aej1ZbLB3QZ2cNpzSNC7lLaklKktGL9u9WAtO
C6sMD4ytJyHPY169O9BrLwJcViw9/4uMPz069ckOdfCK3DiwI7KZEJmsjTcP
qoPptxj/H4mNpPz7xmIB0YAlD4KEI742kdRjYbPFSjXAvzXqeYN5C6m7PKrs
vYY2jJyT6nF6di0pn9vXI69MG1aVJnq6TagjiZdWzfJeqANLQlrW3eXXkZZQ
ObJUSh86bWX4zyNryeixKUGdQXqw00N+9tFZ9SSuvHKdWKguBI9v+8AP/EX0
eZvcryvrQPvb4MibMU3kgYGne4ylNoSEhvi232gg7UMSVe10dKBh6uRtAXFN
5KXqql3vhfq98WLfzgVra0mO0pxJ/r/0QWj56rxZaR1ZVvRh9P7dxvCwYJ6b
0446sn5rT9be/caw+ELq9oXZdUR7+5e/wyONYWcxTycvpI5ougavu5hlAYVF
H0ZtV60jvosrJvu5KkN3zpRT19pbyJOUAdI+3cpwv2GNQotbG7lvlJ+cvlYF
1vjF2Kw70kosFp/+O26bOpgZtnzrWdxKLmaWpD6IUoeGhkLw7Y2f45q1204W
6ENe7F/+USWtZFSt4jTJBCPIlJsSlhXYi58aVkR/NwL+oKiXKW3tZIiTo5d0
gyGcsDcyD7VoI7EPXVM9jIRwsVCyX2pOC8mz3hmrtkgIk2fpdMmrtpPEpNDJ
e93NQLEtSmpsRCsRi99ocU6h1/+PcBt1f0sLMYsqdegfKQ1ph5aaGtzuIfm1
OrEmAXIwO1K/VKqhhyg++flqgLUMlKw42ZtHiYHeuQbV/DkysCd4qPzevwQg
p6e8P3+5GoSC8dO7PTyIrxsaFSDQgPRHdR3P0nv9bczXb2uztKAkaY5LGuFD
ZY33ulQNLdh7YEvOg+M86N9R8nn5bE2QUT/qsKY3Xx9Sp2U447U66KeMW3Hg
hQDczKPvfwxQhw65k6XRzXywWe0xsemNBvxTpeFzcYYYzFhn7zXATAPenktd
5nZGAO7ReY6LC7XBZ9j5qgVLeVB9aNeUA39pQxfkSw870kOeT9gkpdupDRuG
Whp+ShPAQDGL7AXztUFc1Vfv7x98WN6zbsg23d74IjvzQ+FhAYTMDjoUukUf
Ygc6pJ9U5cFhs1yY1OsHoknStVhjccjNVhAbvkUFos+4KX/VFIeEHxr+gZPU
4PunJS8FueLgqH2ceHuoQsX45X5yb8TAY/D9C5q9/nPrjg9ptxXEoTJqdfTh
am1oOU3CfnqLQ0DsNsULj3Sg75qsPMtPYpBZ/XCcXo8ULB6xfFVWhBQUeW0f
ta9HHayna3zq6y0NpOlC+LDL6pCWx5+84TlT7929cuS+nVMaiNXDkeHuSUz/
Xrr9FDnnPKa/cuQcz0XWQub32Pi912W/w9LxEjUUJ0se1EizqqPx1hbBneMH
TzL5QI3vTOH83Hoa/z+cbZEWXltDGncR8wxv5vfdWM9Md8+Kv11aQ+Mz47hL
5ooSTD4wZm/bXFu7SlIYdVNvxg4LqD0a/j5hB9OvZTtrSLi0VDWN753+Ouki
I2ghgmcD1cgzpv/z/aaBg+490xDpzxJ8nJ1bOriR4vw7Oz0a1OtpvF/0I3jp
2fdMf9fwc1ZLwm2Z+evmPZ6tLNZMsdrT51ufFjDxv8X8mdIm5k0k8ryGc+Ax
DZF69l49F9lftu3EZp5/H4tbov1grnl2q24WM/1gI/Zbm56w5YPsuNXxRsYa
Iv1hF+vz3Z59YfoHvr0/bC2vwofki835XuJK8P3ohsRpWkz9KkPBTbdloBiU
pkVdPj1RQ6S/K6PS2ujzVQbPSOruW3eaqXdaplSVDlotQePZaN8IiRkjxSBt
nk1IuYWWSD+ZYtmOb50nmX4mv8aIoPspTH9Z47vHCVd8mPV+fDTT97jE9K9d
LzrrWn+fiXcn7t+nqjZEAGPsoqQdHTVE+s8eZX71nSUQQNtD8SPXTJn+yWn5
mjMLFS2gZL1PqP6OMiLtaznlk645NDdbLS3sqCEFo8aQCybmsO972sKRn2tJ
tU2piU6oIsj6pTibvWojuhPvlMcXKcHLZea8D/07iO1zGaNHu+XhUeqme531
LSShT/i0wslqEPQ80q6jrI2saly1fU6jGnR4+TufHthBJAv6R7gbqcK7KOed
rxNbSA5v8azJF1VhdvWT8o03mPppToPx55xndeSb6pQyTx/Rfrei6WJTL6nW
E3u+006jOl0Iys9v9H3aRCbF3+i7pVe/qza7Fha9aCfzpScnLD2pC99vyL/u
e6CVeP27PjS5wRi2KQVr3elsJ69bI79GTTGGiIjynQkbWslRa0e9NQ2S8EI3
1jtSiQ+mCQuX2a8Rh1s3deccyWS+h4fs8A8a3dNOpNKl9DI7mX49Oa8zW0Jr
RfvnnocsKF8k1kGUXee66SSoifTTFVhWH1JxbicLdJ9aW+9j+utajx7xfrFe
D846PXriI86H86rw9H0vn5Fpxe/PD2f67T79M/5jv9vtxFNQdDLYT0qk3y7P
WizCvpvptzsZ7S92/RCTj5X94y8uxeODmLhJZoMu059rXUZWPkhg+vFOZdxM
3ZOtBdvE4/xtrCUgPmXd64rjmuA1QVphq1AclB6uci36wPQDHrk8ecOoFKYf
N/KOxXSZwN74d+6q1KTPTH//XJuHpVfKxMFJS924MEG0P0/Ro8KYiFcRnvj1
+7ZXjKg9G+YduCB6tRFoHO4za8jLRtJm2N1ucccQ9B6NTmwd2kz7AfYcaTZP
yGD698qVLe4uesX0Uz7K7ufyTaaTBMxtNwuRZH4ftcl3Q3mIO9Pfh/fvkhFi
f+U+H3jmY/cc3sv83uncQIcAzwolJn+d675UkCgPawfJeG79zIcBzWPlCquU
4My5SEFCJh9WWiwY4lEuD643Bu540VcMFMHix89sSZo/ruh7v8nwhhzFlzpT
jMtlpCB1fPDpAEmmP1Bn4ZMbt59JQKpMs/gZfTnO7+flYed56fNOqXIgWfRc
xmKtCYzdZ8kru1xJLNrW+8X3N4EvOQ2ydZItpOvNwxHDs01gTtPPg8mkmexy
uzfkeG/8PMoq9uD7R61kzQvnhswvmuAvN/uHvEwbmSmxMnGJnzakfNcteHGt
nXzU1f3ebqcNwgg7G6+MDnJo6FWXQ1U6kOY+/YBZdze5Fa01OsNaBwIK04wC
DnSRuXcXhT1yNIFvC44YJm9uJ82tx45tPGEKc2LbPbS028iHZLnh9ptNYbjQ
dp/PqDYy/txJ25Q6JWhUKn3nG82HUY+VZl7crQCW7zrGtHnxIPPU8CvFvspg
Z3u89R2/V/697Tx1W1RgPsx3dljf0xv/RiwaK68CarapZoIDAtg1OtFomKIK
OA2f2l3Tax8NMhKLXYWSwIvcmLkhQhw6uvdZnx4kCTMKW5bdTOjNs+3n2sIk
GdiWGltd9ZTpf3GZfsfeSbmeSOWFKVuVCuHdv/+QCeQXSQ+LkgoLNIX3fteP
bt9eSZQcbY49PmsKgd43Yx7vqCQGZ/aO2OYr2p/ofqxkaqt9PZky5vCabCum
P3FC+W3P3DBlcD/4o40ENhKB0aujtUtV4KTEletv7JtJ6/LcKpNq5vcA/OYa
BZ90ZU6/jwr09155uaOsmWKjAfyJMmPaiMOvgHgPTdF+xnEDH3ll32wjp+zJ
sN2jmf5G0yUrs+5laYj0N9ZPuNCzeX0T2RAy9GCiC9PveNv4VtOmxToi/Y+T
ro0cOnJQB2m4rj3v5VGmH9JP63r7kWYD0DL/tN5yZAuNn05NzBtlGdVK66mN
wT6pQdYtpDNwzObAe0KQGlS9ff60ZjL5glPMm7FM/yP2hxCY+hQeNhNrnfvH
HPWZfshtZc/F+txm+pftHvn7JG01hTE2D2pTFjeR487Jm0IOm8KoA287d7k1
EfmwiOGGD5h+SOwXCox4ayLR3UBOyZhnVs2UBtXAtd3OpzpIeKpXvZ6PLLSm
+2iEnOoi3XkeZoJ2OfCd7J48Z2gPjV/aR3RHJvRpJ/Vvb0uq7FaGRunVG33/
6STzo9USp9ipQNEytVO707uIZdl6F2dJVTD2qnZYOKaH2C4NvlDxWJ5T/1OE
XQpv/haQdopj6kyOj2/tJEpvdjaZaKiI9FPesdYZYB/YQYJaHbwGfZPm1Bt7
5X5p8VdVmW5a7xSLXDvhu0In2e2zoHzSRQXa32Lr0eKacp3pDy0pznW87cH8
PhX90eMxWiWPe+NBxGv9tNLiLnaSp/lHW75vYf7eDu4vVlfzlpN0N5XP+YsG
pKn/7CD+J1+mj7zO9H8GGNVk3fNQEekHndGY4dtxrzce6+4OefSL6VfO+Gdt
1prj+lDftvtl27pOoi2u9Nk9xgCSiisq3UZ2036YOXY5YyICO4lkrt16I0cD
kf5RnvP1Bx/TO8j7VfKKXb7M3wPCeC/K5sTNqs9dFD8a/n5TLuFBoL/cNsXL
TH+pS5DP+RA3HZF+05cCiZCtp3r9v3+LpJs+03967a1s6V/FzN8bwv3cfJvN
z6rupvF3hby6vo1tF+GX9Rl6lS/an3o/8/HKpHkCyFht2ydMRxb0hbFjPKLF
4fzi4fueuTP9qIMmDvf/u5j5fc34mXJBj04wv+fF85LdkSO9wpEP/U1WvS0J
VgDz635fqodIwv7vAo9cR0VoiFEeb7JEEsr2eUu5XlEG4yU6IaX9JKHS0dB+
6XemXxXv//lY0iUtLgkzSf+37tPVIfd8c7jjEwmorRyiPvqVBqh3L7a8P4rp
DxmQphxt108C0l5flOzboCLSz+o8qL/94Qymn7X6XOq/cU7SMAm6pb/OYPpZ
d+vFmHw7ogx+p7MKHnTKwOO+I1aG6TH9qri/tX3u7NQIk4Gtl88pBGxj+lcL
b8xSFsyVofVs2r/53dLeZrM4BF2e3FNrzPSz6uiILUqYp8D5XqIIq2Iav46o
bCZdV5bIatmpivS7Dv1g21k+r5npl/6WMmydfSuVX11t69gv+kw/7DRn3xlH
dzP9sG7fQ7+PkW4ldzcte7nsLfN7WJSPVZ2LBriKd9P9+ImnDNtR20MOyZeP
HfmR+b0rnu/HI/EEShj9cV/2uPZjNNMve25lsXlLb7weMcQkqPithEj/q4+V
ja2fqzgsDvw10ylcQaR/dmmNwfv9H5j+2Q3T7NtepTL5V9mv1N0+r8XgXkbj
7Zh7qiL9tA1Drr2ss5SCnafFvI/5Mf2z2D9kamEZXDiwjebne5oj88cFd9J4
8GGjYbn+Vlm4mCv/dHBf0f7Y1dHDUvM7ikn8xEPfzx3Qhw23twhvbvpBFIwF
u8KcjWDQPadT8bNK6PvNPhcW+3sXk+5+R85nhQhBWUdQtkyzhOyuUBGMOmQM
wwTRq3fUM/2vp5tsbuo/+04Wuu3V0dplAlO+ZVcO2FtMos4W1/keNYWoRymX
9VWLSZ+UtPPbNpmCnfnlvRqaTP/r0Hb4q/xDMalzM0qp3GEG8oG7L3itLSYZ
r/s8Td5jBhN423Y3hjD9rt7uBxMDHOvJS/+tL2UWqMG4xJwC+45fpGZIpdiQ
MjWoWDJrWqJ9A5mqcGRZSr0qOI6IzzzoXUfyv0vuqNkshGY7s+ufh3QROZnr
Q5YPFFB7ka5V7u7/ng8fPM+etcoQwO6E6lfqP/iwaeHPNLnNAlCS99VZ182n
9iDS6+CZXfl8WPfCeWC5vzjEhQrOvnjHB5nxSY5TT4jDGako67xeO6UXt3/z
ovuS0N7qxFvoKaD6umdXSc6ZNAGEKihn2/SRhqJ5g03CzAQQP/+03uzVstDl
X6UU/YhPv5/4Jdtnb7rDh39Lj/xVZysPi0akWvybxYcXOrOr7m6Th+TLbUt/
6grAcllw6PzZilBX+TBTcrsGZBjZrrcZ+5Ps2ep/3ieJ+XuAaG+sfT/8O3VO
DREbN2OnYRvTzzoMeq5Pncn0s2L8Mi7l8PhTl2qJsO+hzBk1SjR+4f2a2+ri
osL5fqoCkjsP7nv+jel3nVG8NneYfSOZEDehz7iJZvBCPH3njJWNJEF/z1of
LzNI44VFKbg2kveepi15aczvgVP7pV78NUdMpP9195k7zmJBXSRrctm9I9qi
/bA/ZOeHrdncRea9aLbr7C/aH1v0Y6jPysndJGTT3JS4pUy/bI5n+WHjkcbg
vH2gz7+qnWRaz/2AXWl8qv9G1ctWF9oow9oumcwFMyQhXOLgz3kJzO+FDS7b
B67aKQ066tlDzaxl4FnFl4Kby6XBepbwTFmKNMhdkxDs7ZUX9t8vE8DBnol9
R2fL0n5Z4Z1B0mt69fWF2c/G/Vl6wJvikn2p+wcxO9m8tVjFHHrcwjtbN7WQ
s5pftt7PNgQxqbr1jRN54PPKLu+dlS4YX5BIWnhaDNxnpYoZ7VSF1tx9c+8U
yUGr1fxYnc8KMGX1fJdwDWWoKwufcnCpPDzvq2uXuEuO2h+lAelRLV5N5MSE
cb7Nky3g5zqz6+nrGsmNqcG2J1P0ofj6/FM1pkw/6JaMg/5NiyVhbk72JOfh
vfn/F1O/G3tlwCfy1/vJj5XhYGCZ4LWSIgyslZdfJikGyr+ul77MV4KIxw9m
dtxVoOeB70v9t3z7kZlyMHxZX02DSlPwULqmItbQSJT7H5j+660SnM0aFLrZ
SxK2bF17OFpbhto/tbLmnPIr0jBwgfwJ6TsyoHeuK+H2A2mI3tG/LUFVFiJW
xSi8LZGEyzPDMx5XKsP/AF8SSeQ=
       "], {{{}, {}, {}, {}, {}, {}, {}}, {{}, 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], 
            LineBox[{870, 1194, 869, 1148, 1214, 1213, 812, 994, 1100, 995, 
             1056, 814, 1049, 871, 998, 1267, 1268, 768, 1118, 1139, 1120, 
             1138, 739, 1136, 1137, 852, 1170, 802, 981, 1092, 1076, 868, 
             1207, 934, 1211, 870}]},
           "0.12`"],
          Annotation[#, 0.12, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], 
            LineBox[{851, 961, 850, 1042, 980, 738, 1093, 1075, 1206, 1205, 
             933, 1210, 1212, 1193, 1209, 1208, 1147, 745, 1145, 1123, 1125, 
             1121, 1149, 1150, 883, 1233, 939, 940, 882, 1000, 1055, 1054, 
             813, 1048, 815, 1060, 997, 1103, 747, 1004, 1220, 1221, 1141, 
             1224, 804, 1119, 803, 1174, 1175, 1084, 1262, 733, 1261, 1082, 
             1172, 1171, 1173, 970, 968, 1039, 762, 929, 851}]},
           "0.1`"],
          Annotation[#, 0.1, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl0DEvA3EYwOFXW4uJMKFDB5GykUjEztSmlbQJtkYEA0tjMPoEbDqxsdBv
ILpUJGaDrYlEogZtLHTguRh+ed5775+7y+Vqh+sHQxFR1UQm4j4dMcY7jvA7
FfGiD/OSznSqnPu3bOpai8MRC/p1tqO+3bHmnatxWzvJ8/SjaX0613O/r7q+
VLB/t0+bs+Y3ziY7zjGvG/MMj/iqormkrrnNveR53OcDr9jiLle4qjU9u26w
wnNWucWB929yQ1m7k+R7+aRlc5tTSpknOcoyH1XSpS40nvn/p3+V4C2L
             "]]},
           "0.08`"],
          Annotation[#, 0.08, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl0bsrxXEYwOHvcZwJo1umkwgTOSKbS0qUkmJ1LDI4DMJksPsHXAbJxoJN
KZeEXCLXFAqFUhIpi+dkePq870u/c4snU52DkRDCOM3REFaJZYaQyYH5NiOE
Hd2lkW2Cv21pndaybi7klwKy3XLYMLeTZf7xnDd9pYYO9zOmzKfapA1U0Wtf
0gVd0T5d1KTeUUGRPaUP3PNkf+aEIXu/DuuAntMWC+FCO3XCvV4v7ddcUe0W
14R+0mX+8J6/zGXmMX1hnOX0Z3WLabGO6DujlNordU/3aeWLR8+KuCe8bg0b
6e+QTUrcczUv/X7Ml+nP4/9vdMZtlml67HM6r/narUccckwLk+7lnl/Gmj1q
//as6ej/7/sHbaNCTw==
             "]]},
           "0.06`"],
          Annotation[#, 0.06, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl0j1IlVEAgOGj1zSXggyChqAGl1JbgqBMMsRINNOEjKYWiUx3FzXMRIxW
lco/pNTAUqkohGitDLMhtURrqEExhNDh+vMcHB7e8/fde+6nR2/WV9SlhBCe
cj4RwhjbbPGB+dQQ3ukk50hyiH1pIbzVWftZe0IoNc7RJ/rQXpm26wM6mDZf
dLbQ+CTPGWEgfqdOMMhLXrBg/a/zJcYF1Jl/0SEdZt14g0aaqOEWGfZWPbeh
a7ptLd+9ztJq7apWUUmzvdvUUmx+mXIynUvVBEv2fvOL09Z/6l2t0k222Gt+
xtkmnTNv1h96Sr9qg1ZokmV3SjM/ZrwS78oJ4+OMGs/oNy5SGc84/8/6R+NP
vGeKzzyzfjj+Bv3OJeN5zabHuDr+zXQ1vk+fk6Q7vkvquUFv/C5379Mret0z
uZrHgLV+jli7r23k8Yfc+Jz1N7ymNb5DvactXOOg+R0t0sc8IsP8gL7iAt10
kW59v45TwCb/3bczsft/uQPfZ11h
             "]]},
           "0.04`"],
          Annotation[#, 0.04, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl0jlPlFEUh/ELMgoDggoObgiICLgkSoGIIIMLibgkWEABAqEG7NDEpVEj
uOCuX8DEFku+BYUCiSIWRrQhGg0EEgi/G4snz/mfc98z730z5f3XrgxlhBDG
0bQhhP2JEA6gEhPyTGYI29RF2IqU3iE+jNGsENrkg+ol537JP1GLC/qPuIzf
cy+/4x4+6vya83/k30ijT/+Yfg2neAeKcQK7sBs7UWu+h+/wXq7jEj7OpdyM
UyjHPpTFHWYV/JIv8yt+iKfokMf4GU7iCVr1/nm/3HgHXJIfcwNGcU7+a55U
P8BFeYRXsIw597nHn/k+f+Nx/sp3uZ070IlFeQm3cdaeBXs3qm+iTb4VvwsG
cEb+YZ6prot3xnZUyRlcj0F1U9yLYVTLV/kGgvl1nrfji/5snOG0/pzeKrrk
83J3/J6YjBk5nsvGdzyXj/ALTsd34HzeggJM25PHm5FEoXkuT+nnxP+RvCme
52z+FO/M+XJWfI4T/FG/hdPy23hHv5nHH9CIN3iNqsT//+46tvpGug==
             "]]},
           "0.02`"],
          Annotation[#, 0.02, "Tooltip"]& ], {}, {}}}]}, {{}, 
      GraphicsComplexBox[{{11.686041877050696`, 1.}, {11.686041877050696`, 
       1.}, {11.686041877050696`, 1.}, {11.686041877050696`, 1.}}, {
        {RGBColor[1, 0, 0], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->20], 3], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->20], 4]}, {}}], {}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{
      FormBox["\"<tbl>\"", TraditionalForm], 
      FormBox["\"\[Theta]\"", TraditionalForm]},
    AxesOrigin->{0, 0},
    Method->{},
    PlotLabel->FormBox[
      StyleBox["\"Corr=-0.74\"", 20, StripOnInput -> False], TraditionalForm],
    PlotRangeClipping->True], ",", 
   GraphicsBox[{{{{}, 
       {RGBColor[0.24720000000000014`, 0.24, 0.6], PointBox[CompressedData["
1:eJw9k3k81IkfxhlXzJAZY2aQc2SX5IhcW30+bPqpyKaVoqXQtCpXcnTIbtEh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         "]]}, {}}, GraphicsComplexBox[CompressedData["
1:eJxkfXdcj9/7f6W9994pJLPscY6VjGwVmVHRFBIysiUj2UJmlAgR2YqQFQ3S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       "], {{{}, {}, {}, {}, {}, {}, {}, {}, {}}, {{}, 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl0DtOQkEYhuHfgnPUWm2suBgLTdRVKNCRuAEaCwGDeI0SjUuwIe6Bkkrx
7h7UxAUYjFDT+RCLN+833/wzc3Ky1b1KYyoitvGTRqRoz0YkPEwizuQRn6Kl
K/PLdMQJH/AhjvCGV6zoK+byCOtj6xt5n9d5DQ/6R9RQx5K9Zy5w03tP8i7u
0Z/c6cwqmvY7k+/K2DfXsy5hx0yRL/hKvyHPyYv4NXvLdxjr32ciPvCJL3ct
6+rcQFeeN7eAb+eudSPecmcRmyijhJbZhNuc4XPOmb+UszxI///nH7+3LOI=

             "]]},
           "0.2`"],
          Annotation[#, 0.2, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl0jtLW2EcB+A3VRsrCEKn6qQtEkRph3pZLERFVEQw0VKUdigohXqBNnGp
iaKDQ6c6dlBXv4Crl4+g4GArqC0qpYOTQpqoz6HDw+/9X857ciD172dTM7EQ
wlfyD0P49SiE37xwjleF8FzmKs0o6pf4xzDd5j38dD6mxe7feAjN8of6iC7z
JBm9dtnBS9po5cz+mb1TTqhQ9+rPe9+Uc1d0l0zKj7Igx83GeMMfdcJzm3LL
vFquqr/xxD111HJld4JJ6u2c222Qh/Y+6H3mE016F2aXFJ0Ho++VQ/KpHNV/
zWNGSNPp/lf02Rmgn3O7GZmlz727co9tdljUW47e6bml6P2yMfpGsymeufeG
a0r6a1HfzrqcZoOrihBqzN7qvyOnt0CeW/0ROUqKO3VaHrDPiv2sXsF5TsbU
D7hVB3kny+UXszL53e9IOA/H//9P7gH2jkqi
             "]]},
           "0.175`"],
          Annotation[#, 0.175, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl0s9L03Ecx/HPgsq8GORR5yJNKPMSdNBAl8cQRfCwVQbrVIe8iLbCg9XB
Q4LmD/wb8pyK3tw/oDfx0EqCOdqKQVu7BD4+eHjyfH3e7/fnve++283c9MTr
RAhhBX9aQijhy5UQalxF19UQ8tdCSPFbrus94hEMIY3hmFsZj+UBbpgb5H9c
cHdU/YBf2fkSZfmhflO/Kd9DP9pxV/8O3ssZ/WPOct78B7lPr3E5hI9yiHv1
FtQKnHAu8S2zy7huZpK70YP/5j7xErrkVU7xOn/GvPk97NhR5V3e51N+avcz
vDOf4xnz/erf5CJeYFHtq1qSt3nD3XVsYhVr8T2qz9mRNf8El2LNOY83CM7P
OWnup3xk5hBTajW1B3Kb+g/c9zkVtTG18fh8ZjrjM+l1xGeOvyN/dy7iL+rx
+8W+u1t6J/H9yp08a0eS57is18u3kbHnzLlHviG3ooJfSJv/3XLx/zkH6r5O
8g==
             "]]},
           "0.15`"],
          Annotation[#, 0.15, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl0r1Pk1EUB+ALRUtbDWAMshDRrVYUBYMuhIAfYWHoIBIJaHHBgcJmrAO4
6eACqBAdCOqm/gO2geCii4sMjMSkSHAAJTiQKM8bhie/e8499/3KeyqXz45W
hBBmyFWHkGeU9OEQxuQ4w9yjSW8oEUJVPIRBeZc7xNST8jETFPlEnfntQyGU
rOfpco1G/rJL1v4/+Z89PptZ5pj+H+cWrHv0TxOzruS2vRpZy9lkCBm+6T2R
X/SOW3+VR+l17i1vqFYniJMiyZLZ6/IG13hEIbqHaw2w6L2K0YwsyYK8av+h
/OX5avQ61N3qHetx+UA9Jsv2j+jVu04DZc/wTv1Tdso1OSdT8qkzP8wn1B+c
zfGRV+pV+Tr6HuZ2+M20+SnWnTkjM6Rpjr4Jm+bPyxbO8ZwZNsxflK1c4BJt
bJm/LK/QzkteMMcsJ9zzvhzhvdlbsp++6Lt5twrP+Ex+V5+0vyJvJg7+p31O
H0l2
             "]]},
           "0.125`"],
          Annotation[#, 0.125, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl0ksopmEYxvFHOc2Qw2ehhlFy2JGdsyQySY1mxc6pyIJiq2mERtY2UjRT
opxjgcZCYTEibCzETMnWgi3l92bx739f13O/p68vv3vo22BcCGES/5NDuMEd
bjGQFEIGp6PfvJgYQj1nfwwhxRzTZ2JY1yw/cAMa8Uk/ym36Q26KdpCnf0oI
4Yd5DKfOW/gvn/ARUj+EcCaX2T3nKd1PrOpXsKTv1H/lLl7mNf06pu3F+FKf
xlecxa36TL6Q8+2XoBST+gT9sf5FPuFE+Ys+no/kXH0BCvFd/wd7+kfe5wN+
4Gu+51rXPXMVP/GM36vGPIIOc669ds7hV2zY+SxPOC+Wx7mIu6LvxI650vlv
e7vmX7zNK9jCglzHtdHzUS338TzXRBm3qJJ7eS56t+ie2Iws9/AsV3A5/iW/
/x/eAFgMRJY=
             "]]},
           "0.1`"],
          Annotation[#, 0.1, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl0j9I1GEcx/HH4urOskUsM0ga9M62iihouMlIgkxbGhTtTMEhXQoMghDs
NC78BwZiUVPpDS7R0GSLKP7rD9LQWNfi5NAQKdrroeHN+/l8n8/vud+fO5Pr
b+0rCyG8wnAyhEtYw1B5CAcPhbBuvYERXJQv8yd8xld8wZvDIRzRH7P/TR7n
HrNuPEuFUMBR85/4gUn7Jf6FChxDKRFCNb/QfeSsGT4pNzjjrtyNHM7KXTzv
jDuclp/oZngfe6jBLj5gUOc+X9F5wCXXPeQBLOAx0n6nHnVYtp9xzaL+Lett
Tsv1qJR/u8971kvWbVhzfTvneQPr8ZnxR++C886j1hmncdN8Ezn9Ap8yq0F1
fM/xedGqX8QcTsQ9NOvewA46dKvMjuNc7HERK/Ya5AyuWzdhCbf1/5p95Ne8
wC+5hRu5maf5HU/xNc7yVZ7gtzzKs7zFWWe+R1bu5VT8pp41KVd6L1P83ex5
/D7xftEZ34mciP8j9/oUB+RVOZ/8/7/7B0p6Ufo=
             "]]},
           "0.075`"],
          Annotation[#, 0.075, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl0stLlFEcxvEzXXQUEgxFhMKsNgllkokgtMldSGZmVKBRXmqj1SL/gMyQ
mskuUFRQahe72MVWJbWrNIQuGqUGrWsXJDhu6nNo8eX7e55zzvu+M5zSQ10N
nYkQwiucToZQhbc4lavICuGdeSA7hJ1yPVpzQmhHG85Y/2I9zVOc4mketv8+
ViBLzkYSD+TzzqXR6Fl5MXNKvuXsqDzELbqDKEQBtute2PMSY/i1PIST9nZj
JTp1+dzFr7nEmTFnFryz19xo/m1tD2+Qy3BbvoO79jTr63kXCs3D+nsol6fk
AnMHr+c5rnB+ltfJF8xrucnedt0jnuFS3WZr5WiT/8itPM8Z37/Vvk3WNmJN
/D/kw9Yf8mp5FYrlp/wElfpvctrvS+G5bhSP9Uf1u/kIj/Az/Wd7vsonzEXm
47zXu5rQJ39CkfU6XkQGk/IH/ogJjOOYc4OeOYQd8S7gJjK4jhuoxTVcxTwu
4TK24SL68RPn4h1BTVzzrrN8hWfiWf4e7593jqBabuYluh/+r4Sc49tzMa57
jwls0Q/aV8n7eKluGfabD6BXn4j3IN5X/PWsN3JP8v99/wf+z2Oa
             "]]},
           "0.05`"],
          Annotation[#, 0.05, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl08lvjVEAhvEj0emqMdEYNuo/UFNImxBTIrdNVLgWbCy0it5uDLEwN9Hb
hTaEBS2h2EhUVVuJrSkVFrQklHZhHkobao7ficWT57zvmb47fIUb0+XVo0II
T7E9EcL+7BBm5YTwNyuEQc7FSezV5/Ema56ZO2XchASSujKUoln+jNM4gxac
wwH7h3k25mAIX3Aeq+wbwxV5IeRzJR+2/qJxv7s2m2+U52FBbgiPUasbLefz
W+vfoRNj5Sz9OD7K73XzuYvLddnGq/mSs8fzBHw0V6z/wCX8iVs4bc1SvoJd
1rXGc+OZnqlKbjNOYtD6Uj7uuW7wDHMzUYi18i3zt3EHX+0d4mF04x4KrBnR
fzMewX3U2PuAf+A7iuRp1v20rjr+BsY1OOIZO8y3uzstp7iar/I1fRtvk1t5
a/ws3K6/zFvkNVzF/djt3Bc8Hb/ck5YHjBvd0YA/ui7rr8ez0YkO/Nb3mO/F
1PhfsW8KP0Sf/fXyc+5FgW6PPJm78UiXkXv4Lm7qLsTv07lJrERK38xn9St4
OZagTH+Cm/SLeRFKsCx+L9ygf+nZEnKxvBAZ1GFAn6Of6O5JeKI7Jm9w/3pk
jHfq63muXMeV8XPYt04+JO+Qa7lIPsgVcp/5VHxvjF+7/018hvj7mX/F+7L/
v2f/AEPkfUM=
             "]]},
           "0.025`"],
          Annotation[#, 0.025, "Tooltip"]& ], {}, {}}}]}, {{}, 
      GraphicsComplexBox[{{11.686041877050696`, 1.}, {11.686041877050696`, 
       1.}, {11.686041877050696`, 1.}, {11.686041877050696`, 1.}}, {
        {RGBColor[1, 0, 0], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->20], 3], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->20], 4]}, {}}], {}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{
      FormBox["\"<tbl>\"", TraditionalForm], 
      FormBox["\"\[CurlyEpsilon]\"", TraditionalForm]},
    AxesOrigin->{0, 0},
    Method->{},
    PlotLabel->FormBox[
      StyleBox["\"Corr=0.05\"", 20, StripOnInput -> False], TraditionalForm],
    PlotRangeClipping->True], ",", 
   GraphicsBox[{{{{}, 
       {RGBColor[0.24720000000000014`, 0.24, 0.6], PointBox[CompressedData["
1:eJxF0ms4FIgaB/Bxvw0GYwyikcsTkcj9xPtql1xT7bYsKyeG0BYO0ZaJ3bAu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         "]]}, {}}, GraphicsComplexBox[CompressedData["
1:eJxsnXdcl9X7/wEVEBAFmU5wb7PSXHVuc5Yjt5ZZrrLMbc5yz8yRmpSmpube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       "], {{{}, {}, {}, {}, {}, {}, {}, {}}, {{}, 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl0TkvhUEUh/EjEaLB5RIaopKoNZbKB0AkJEpqsVwNn0BEobOF1l4JNyQU
lkRsodFR2ZfCUlp/onjyzDnznzPz5q3o7GnpzoiILgznRXwURnzhE4fJiAO0
6Y8XRExiAi+5ERuJiFdeU6exLLeEftlt9Q5qcI+S4ohj2QfrBfv1XIdaDKl3
uZVrzZzjC3Pm+ZKfnFvVf+TRooiO/Ih1nuJT/Ry5H7kt/uZNXpUtlDmzLuAi
JFGu3nOmjCu9aciMQd85gBFnsvXuvKUXKWSp+7hU/oZvcYVZ9TXvc6az7X85
60X3p/iN3/GCtPqV181PyK24swrn3nHMDXon3I1nb5zGDBrRjCaMmZFnv1o2
l4+S///qF5MSRzY=
             "]]},
           "0.7`"],
          Annotation[#, 0.7, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl0jtIlXEYx/HHhmNp1DknzSiki2ReoKnbJLSEtxbHDDRdDDUhDCmbgk7R
UIMdrMmKhqiWPAWdReW456UhLw1F0AW0Wrps9jk0fPn9n9/zPL/3z/u++3uG
Oi6URMRTnE9GDKUiBnENDchvi1jfEVGbjhjeHnHQeY3+1ZtynsYDM58qIwr2
b6tnaU5/Eo0VctBuv5t/Rv8FnVFn5Byjx3ECBfWi3oGdEWXOy/bLaY36LX8T
RnlXUCZzCzbjFP+q55c6JzCPOWzlN/Nb0YJBWS89J4c0zqon6BfaJ/MzvU9P
umOd3RpaT+/xxrHP7F4853/nL/IWcMh5ha7iPb6pn5lZoo9oho7Qavm99nuQ
cp8kyvnX3fUmbiCDbv1z2GW+IK+KdvK7eGP0LrJ4qK7EB3xEG36g2vv66pv8
dH5lt5W2oBmP1QmZE/q38Me5z/2OyDuKNd5r3jqdMz+PN8jamza3W/Y7vSdm
lugedQc/qT/DSxX/Ed5l3sXi+8NvXh39RfOyLhVr2s5Lm52Sc7r4L9EGfj0O
29+Qd4fXRPsxkPr/j/4D82FfBg==
             "]]},
           "0.6`"],
          Annotation[#, 0.6, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl00tsjFEUwPFrgwTtoCpefU5tLEjqGa+IhcaoxKNUU20VrTa0I62SeCea
UAuh3Viw0SHpxo4FDRLaYkHUSh9oYmGhiAWJtPX7YvHP/95zzzn3zM18udWN
OxsmhRBGsHF2CLmxEDZwDnfMCqE4PYR23s7z54TQz/P4HS/ghajICKESVRhQ
d0f9IHfyI36MzMwQ+tJCGNXrJc+1/2a9Aq16PeF8efv1i3MFXxcf5m77aXpP
R7/azpkhpFAkftb5Fj7HKXSi3NkreWn8Xo8D6qpxEFnOFyFPfLcZSrALze5v
QjDzBCfkFoo/kzduX2s9xjvwVGyd3kmxtZyPOCrNkcfXonfkrUhgQnwcRdaF
apfwZPsGnsLL5Y9Zb8J350neG+WJ/+FV5v3NK/mD2ADSzNGlttV6Km/mZXxY
zlKuMtsxsZPWR/lUdB+3cJKPoxE/8QPd3uuFnj14jsvu6+V671CHXH1zMIQe
8/Xiql5datv4NI/qcTH6DVzCe/AZn9Ch3za1xUhghpq2qAdqrW+I1XA7P1A/
4u6HXMBxJNWvkbsaQ/Yp+0H+iGF8lXvf2WKzFiCOcv3+4oqz23hrxjc45G3u
ive56x5fEuuybuEz9k18As3IcE86x1Dmnn0oxWvxC2I35Z+P3i/6ZvBFPJvz
ov8ARuyzuM6d9TiCX+a8ZZ4aLnNvlh7r5WTH/n+D/wAtlX0H
             "]]},
           "0.5`"],
          Annotation[#, 0.5, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl1Hloz3Ecx/HPbJMcmzn212ZmsY0ZOUYZJkY5c9awEWb+cPzjTlLIH0wz
d0nNv5QjylGT3OfcIykzf2iGUvyxTXl88sdzr/f5+n6+3+/vu+wVG+atTwgh
9PNnZ58QCtNCyO0VQnLvEDpjvngBFuJtaghD9YtoPR1Dk/uaQyIeyJPogZQQ
btm9K76D5J4hjJQn0VL5LrtprtUTk/jOVS+J/vYm603BD15ttB0dqLBfjmni
AzzK7eynFfSi2gXk88tDLg7qVaMs7vCu4/eBFslHYzn+ul5WegiPeTzCax6D
6LHoR79iIF7JH9CHuI/HfM/GHXqOPqE1/KfRbvKptCvtQZ+qlznPYqSLL6vl
IR+5+KTW1blOOUt/1xmgloPuzpeCHsg3s9bMOozXm4Di6K33DKvsVcb3gplm
q2gyMvWa5C3iXxgnL0YGn2+0FTXqh+Ks85bxzKDLPJNretdxFcfUrug18zpi
9p34PRpxXu+wWi0uuYdM3kfjfai/pUvNLEEJn+dqx+lJnEBj9MJP9SX0Rvw9
ufZ3+V/PqwPtaJUnqTfoN4oHiTPEt+3slX+hLTSNNjlDNe/PdLa5OZgV37Fz
veT1ArV2nzvTi/gM0YBn2Ge/2V6p2Y/8Vputwhp81MuxVymu4PdGnGVnlXxL
fDdqw9W2y4fRRfLE+A2IE8zdo53i9xBz9dsxp+Pjby568xiAbKzX66A3abBT
T8v5tauNoG20O7phM7a55lZsEg9BQYTnKHt19Ez8NpCHuvh8MDF+Z65fQjdh
I7qgUG0YBmMoCjADtXam0yLPJZX/GLrH/G78Uf+NEeqj1e+IVzrn6fi9OP9d
+UxzO+K904CbGJv6/3/OP/+BmLw=
             "]]},
           "0.4`"],
          Annotation[#, 0.4, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl1ElsjVEYxvFTJShaVLswhFIbQ2KooEKpagwJYqxZzVRMJTETCdqGComp
lajW0A0LQmkthBqDIFiQCIKNIMTUSsTvi8W/z3ne9znv+c69323KvJUTVsSE
EHr7065lCH1aWSMXJfEh7MT5xBA+8i8SZKzH0H78V2zlD9i3tHUIy5CH9eqr
24SwCkv4/fpb5H7TOHrf/pnqszAbHeWT1C4khbBX5jwtpg2SQ4hFDN7y7eTa
4hVO8qfQXK/UM/6y/omj9i6ng509BPV61fJ/6FA+A6UyJUhQn+B5JiLDczTS
eyK3QT3GjAyZYRiKen43LUAnuRS8lz0n+4F24TujSL8QOWZmm1nmXi/oRFog
O4n2px9pqky5XgWScR/x7lNp3gPr1+a8wR65XPVxnmE7Pz66n/4k9cmYiimo
1FtG87AEZ/h10Xdj3ZOWOvciLeCLUIju/AK5HjSTT7NeTNfyC2k+Pa22yLrK
mSs9x2W6FduQyCehDWo99z33ipNvjmZI5JvY2xSNcTfy6k1xxedVg2o8tDfQ
HHNyZLrRFngV3Y+mq23XH0R3OPeXel/aiw40Kx0DcJ2/EX2u5uW7b538MVpP
R0TfCRZH90FvdxvLZ9IhZv21rpAdxo+3zqLj6HC6LnpnZDZiE+rk/uKafnH0
jqnVoGv0+3FWNu1DD6odQguURDOj95UupE/N/WzuM3pMbQ0t5ytwHCdQhovm
33T3W6jFHdzGN72veG5fqnnxznvk3Ctqw5GFTMTqb1bfgtHW/WVH0afmTqfp
/Ayag7MyHcxuj2n8LvuP0Cr6MNqvPgoj8Vj9k3oT557iT6McJ1GBC+bP1c/F
HMzHPLyT7x6tnXvYjEvWNe5/Fd+d8QNf0E39M/0U/ebtSaNV0fdO5+OlWkMa
i32t/v//+gct3aac
             "]]},
           "0.3`"],
          Annotation[#, 0.3, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl1V1M11UYwPED1oxNhQTcMqW8CFqFGuaFitZFimba4sZKlIZ4USDky7CS
NIQyGgHWZjU1aFlqOYWVWoivrBftbYa01Bptga2wNHUormWfMy++fM/znOc8
z/nx4/9nTFF5fllCCKHOj8mpIYxICWESp/O89BBG3xzCV+IvcdPwEPKS1fLd
vMPeXZzBC7EAe9TtxifIdP4OdKtp4VbsRJ3eu7iBK9U9MSKEajUdaSHU8GW+
gn58Jl6m9gG1S/l+HpBvk5/OM5CH78TD7CejSfwumnGrfI0z0+IMrnfHf4e5
s3iJuND8jPg84gVqm61TkYb3xF36/YgfcAKdqNXjdz226b8dW1GutsdeL+4R
Z2Msdqu9l8djHIrMbFSTIl9g9mLxfJ5gb6/cIvEezhGvV1csnuJuxe6zGJ/b
q5U7E++AdCSavUGPQZyv9oS6R7mLO/G2fKd+7e48VH2J83PkJ8lNxjK5iWZd
VJepzyXO4kIu0acU29TP5q18Sp80505yKg9HFzapL1DzoPV/9m633it3zXqf
Gc+Y28t9nMr98mfMvcy5zkzBW+I38Yg5c9GHP7HOfRpxJc6Oz65HE7+DXOtP
zRljXuAD+qzhdl7N+3mHczvj7x4l4lIswTfOZ6np5ju5XK4MvepGyWXK/WY9
Q++eOBPNSBK/oecWdLvXr6hxzypnpzrzUnwHcs97llVIkE/E9+pX6rvW3iY1
m7ERjztTzbkcOAGJ+BDbMTP+jZibx/fxLM7hbHsXrA/rW6HvodjfvGdRgelq
nuPz+i61v1FcFWfzF/InrX/CKnebqKaSX4joW4kj+mU518GX1F1Ehbpdav7h
HD0u8AReyFuc+QDvo82Zp+Od7B3GQXTgCAbLn4v3wsN6zcGQ+K7kh/Jccb4e
xeYtwhD55WpXYEB8FV/r/5T8Prl2tOEA9uO4/Vo9XsVtyECP+ia9T1mfxsr4
GRX/zefQh79wFlfjd5D5AziGOnVH+TVuQLb3X8/H9bxB7aD4HYRvkeR3W2ov
RU2r/SrxVOu1vBovIle8hl+x3+8Z1vF5LjejDCv0WR4/m5gvfoznxffizEee
72f9z6r/hUd51of4RnWz+HX+WO5lPRut18d7owH1aLXXgj+cH8m3ING6CDOd
H89PohDH7B1FUvw+NLva+lry9f8V/wM/7OhO
             "]]},
           "0.2`"],
          Annotation[#, 0.2, "Tooltip"]& ], 
         TagBox[
          TooltipBox[
           {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl1nmQz3Ucx/GvDorJ2l320h9pNFMz7NIUK5NrqZRjD0dRM1HJUbb+qNCU
W3KUZdexspXGsfZwhkqiiRQqkrVyrmvpxCK5enymP57z+r7v9/f7+x6/JgNz
s4fXiqLo7puiaF9MFMXFR1FDxCMtNoom1I+iXo2iqDdy0LBBFPWh3/LPbxhF
Q9QU0sH0vNg5rIqLohfZyTQFjTGOvZGWqaurby95CeoSkYQSvgNijRxPlfeI
/Cm0C/2AbwFO2+kMVsjby15Oq9mnMC3UoZ/86bQ/LVJ/Cd0Souiw3Mb8h2gK
TUaRnLbOJbLLdj124ILjGryK2uIb7FWHrkFLfVbTM2p70vE0k06gl+VPDecs
5yczFjrOwn3s7FCDXDkd5XZCBgr1/tX81fz76Rp6gM6Se5huZN8hrz6WyO3O
Xkxj2KPFe7B7Oo6Rn0mHsgv4ZyOdXWOPafInOa9drsNudEIGOqNQ3R558+lc
9LfrHNpVzTKayi6hF/SZztdA/wf5YumT7L44pncVjiLb3CyMCtdK/72oQCX2
oY5YlXnHcBQncBxvyl9L12Mdis17KuxAY8wrMy8euepfwUsYjpexRc55vWtw
DmfxAN7Ss7Wd0pHEPklL5PbTd5NeVWo302Xs4vA7iN1pVg7fFbVX8Vy4LvZ5
ns6jTemgcG+jAWKxWF0Buusxhw7S42b++81riWtqvhfbjr/1/o5uwz381+xw
HVfDPajuBj0k5wi6hHuWJslNxlHHS/UrxiIswWLcEn578SycDfcD7YGtdmnH
fhgfsXvbv1e41uxic9qpG8duT6vDs4VTWMX+0v5j6Qr6Al1OB9GVdJSZperL
8LT8Z9BE7BL7rnCv0IuoQaVZ/9Ir+Af72Zfp1PCc6XURmail7mt9xtCv6GZs
wnm5M+XOQh4KkI+P9VmIuq7RbOfZxfmtY7dnr6dr8Tk6sD+jncRX6N2CvZIO
RKm55eF9hHw9FqGU/6S5ZeGckSa/nF4Wy3T8u9wSDOCbI+9ZOpu2MWNwOEe7
LTArnT2M3ZYOoQ/RoXSS2ESckHcciXrFiS3AbfrPMOcTHBA7iDHio0N/c4aL
j2Vvww6+KXw35OyUv5r9Rvi9wu+Hlcjjn6zvp45HhPcXHUkT7ZGEBOwK10S/
NGxAKvqiT9hLbLNdc9RlIwuj9IvjO6f3kfD70Na0FQ6HdytuFy+j5fjTfn/h
C3n55qWhBVLxR3hH0L3iFdiDXzDC7JF4zPk+jq5Yov4Js9Mdd6On1b5tzujw
/kEVrvJfw8967A7PSXjW9F8a7v9wz4TfBh+iKMzSs0h8gOOBaO64Gar1ztEv
O3yjMI5vPMZiIiaEb6GefdHGPn3C86pXnvOdifcwA++H7wu2hHe+vK30G5xR
/xtO4XSYh4Pqa+RewOtoZofXaHO6j1aiInwD2QV65GOn3WbRH5Gh/w/0VvFh
aMYeSsv1rSfvpFgiTUAKf2fcKycjfK/EWjlOCe+a8F63T2I4dk3mqR+PR8Xr
oU64N+xRm76LRDlzxbfShPAuCt8XPZuGZz/M51uOyfwd2ZNoB/pOeO74q+1T
wY51fJ02iv//P8h/y5xJYQ==
             "]]},
           "0.1`"],
          Annotation[#, 0.1, "Tooltip"]& ], {}, {}}}]}, {{}, 
      GraphicsComplexBox[{{11.686041877050696`, 0.4}, {11.686041877050696`, 
       0.4}, {11.686041877050696`, 0.4}, {11.686041877050696`, 0.4}}, {
        {RGBColor[1, 0, 0], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->20], 3], InsetBox[
          StyleBox["\<\"\[FilledCircle]\"\>",
           StripOnInput->False,
           FontSize->20], 4]}, {}}], {}}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{
      FormBox["\"<tbl>\"", TraditionalForm], 
      FormBox["\"r\"", TraditionalForm]},
    AxesOrigin->{0, 0},
    Method->{},
    PlotLabel->FormBox[
      StyleBox["\"Corr=-0.4\"", 20, StripOnInput -> False], TraditionalForm],
    PlotRangeClipping->True]}], "}"}]], "Output",
 CellChangeTimes->{3.585764134599231*^9, 3.5857648721084137`*^9, 
  3.585764925240453*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
  "******)"}]], "Input",
 CellChangeTimes->{{3.4940977943255997`*^9, 3.494097801075859*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
  "******)"}]], "Input",
 CellChangeTimes->{{3.4940977943255997`*^9, 3.494097801075859*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Print", "[", 
  RowBox[{"\"\<true visible #RE=\>\"", ",", 
   RowBox[{"Count", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"SameCoalescentTreeQ", "@@", "#"}], "&"}], "/@", 
      RowBox[{"Partition", "[", 
       RowBox[{"truetreels", ",", "2", ",", "1"}], "]"}]}], ",", "False"}], 
    "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ind", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Boole", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"SameCoalescentTreeQ", "@@", "#"}], "&"}], "/@", 
       RowBox[{"Partition", "[", 
        RowBox[{
         RowBox[{"rescold", "[", 
          RowBox[{"[", 
           RowBox[{"k", ",", "4", ",", "All", ",", "2"}], "]"}], "]"}], ",", 
         "2", ",", "1"}], "]"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"k", ",", 
       RowBox[{"Length", "[", "rescold", "]"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ntot", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", "#", "]"}], "&"}], "/@", "ind"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ninv", "=", 
   RowBox[{"Total", "[", 
    RowBox[{"ind", ",", 
     RowBox[{"{", "2", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nvis", "=", 
   RowBox[{"ntot", "-", "ninv"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"ListLinePlot", "[", 
    RowBox[{"ninv", ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], ",", 
   RowBox[{"ListLinePlot", "[", 
    RowBox[{"nvis", ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}], ",", 
   RowBox[{"ListLinePlot", "[", 
    RowBox[{"ntot", ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], 
  "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Quantile", "[", 
    RowBox[{
     RowBox[{"Select", "[", 
      RowBox[{"#", ",", "NumberQ"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.025", ",", "0.5", ",", "0.975"}], "}"}]}], "]"}], "&"}], "/@", 
  RowBox[{"{", 
   RowBox[{"ninv", ",", "nvis", ",", "ntot", ",", 
    RowBox[{"N", "[", 
     RowBox[{"ninv", "/", "ntot"}], "]"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"gnRE", "=", 
  RowBox[{"MapThread", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"PosteriorPDFPlot", "[", 
      RowBox[{"#1", ",", "1", ",", 
       RowBox[{"PlotStyle", "\[Rule]", "linestyle"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
       RowBox[{"AxesLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"#2", ",", "\"\<Freq\>\""}], "}"}]}]}], "]"}], "&"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"ninv", ",", "nvis", ",", "ntot", ",", 
        RowBox[{"ninv", "/", "ntot"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
       "\"\<inv\>\"", ",", "\"\<vis\>\"", ",", "\"\<tot\>\"", ",", 
        "\"\<inv/tot\>\""}], "}"}]}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{3.5567101622525024`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"true visible #RE=\"\>", "\[InvisibleSpace]", "19"}],
  SequenceForm["true visible #RE=", 19],
  Editable->False]], "Print",
 CellChangeTimes->{3.5857641346862354`*^9, 3.58576487221542*^9, 
  3.5857649252824554`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{}, {{}, {}, 
      {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJx1lMlKRDEQRYMrly5cuHChDxEREedZO9rO7dTtrDvBrf5CfVo+yU9Qefcg
uWCguZzUlKrk9eTb5+B9KKX08fP71XZ9dVodydrINQ8b+/6odOwfHTf/Cdtv
zD5l9mmrO2N5ZnPdx5yda97sC5Z/0eosWb1lKWvF/FexS9es3rrl27DzbRpv
GW9Lmc+O5ds13rPzdKT0m2t7wNzXfl0vYO7loM4XMP12Lb5b+6dDqfoLmPpH
nK9dAdPfsdWHmc+JxcPEn1p9mHmdWX6Y/OdSvbuAyd8ze8/sFzUHTP1Lqd5R
wNS/kmreATO/a2mjeJj6N1L1l2Huy7jAvMd+zblf+4fZC0x/g/r8Gdb7Cpj6
MN/7rcXDjeKNi/mnO4uHOb9xMU73dT8Z1vwD1ryL2dODVP1mWP2FcYHVT3qU
Mn+Y9wqrvwIz/6c6fzYOmPuDiX+Wqr8MUx9mfuafXmr/DGsFTDzM/F6lzA/m
/+yPvwGwToCI
        "]]}}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{None, None},
    AxesOrigin->{1., 0.},
    Method->{},
    PlotRange->{All, All},
    PlotRangeClipping->True,
    PlotRangePadding->{Automatic, Automatic}], ",", 
   GraphicsBox[{{}, {{}, {}, 
      {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJx1lLlKZUEQQC9GhgYGBgb6EBlExH2ZcWmf+74vo5lg6vxCfVp/0nyCyjsn
6AIFOZxXt29Vd1Xfybd/t+9DXdd9fP1/c/D3f2fAlcIPcBkOwzk4AtfhaGnX
j8EFOA6X4ATcgD04C6cGjCN8OuX/Bf/AGbiW3nOY1vncPPyd6vS9i+l367aO
5RR3375/9Ye61hPN4zlYt3XlfZp3M+1jK9W5DTnHbifVW9r6Qjf/bvt86Obv
Q841+u3z3R7sEdddv5/y76f4AWSOQneO7Kv16fbHuTG/bh+OIecXuud+AjmP
0O3rafu+OE3xsxTXre+89dCd04v2udDtzyVk7kJ3jq4gfQ3debiGzF/RmbfQ
6UfVnbOb9vmiW49Ov6reg7dpvd5nvc75VN37cgf5jpS7Nh46/a269/G+jRfd
eU7xqjt/D5DzLHqP9Tr7q7r34zHl17mnoXOPq27/n9r9lKc2HileU7x7bvOV
5KHzPam6+/8L3T/udySM05+q278XyP0out993fPTrf8VMo9FJ1/o4+UTez2G
Nw==
        "]]}}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{None, None},
    AxesOrigin->{1., 6.},
    Method->{},
    PlotRange->{All, All},
    PlotRangeClipping->True,
    PlotRangePadding->{Automatic, Automatic}], ",", 
   GraphicsBox[{{}, {{}, {}, 
      {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJxdlMlKQ0EQRR+uXLpw4cKFBhEREecpajpxNs7zsBPc6i/0p/Un+QkqOSfQ
JcjldL28qrpVr6c/vu8+R5qm+fr7/9fB309noNuJA3QLHUVX0TG0jY4HnkA3
0Ul0A51CE9pCl9EZtI/OhvxzA81deD7Uu0D8FF6sz5sl4uY3r/WuoOshr3Ws
obvhOfPYp/k2w/Nb4VzfzbMT6mqH532PdeyF+D6KT00n5LVv6h364Pu6NQ99
9r09lD6zrG8Hdf4s28dh/XyW7fsIZY+yrP/HdT9Z1u8TtEVcNr97wdyGe6Kv
ZyEuO6dztEdctv5+iMvux0XNWXbel5zfo5chfoXqv+ycrznH1wwP/bmp+0my
9cjsU5Hdg9u6niQ7D5n5F9n53aF8t0lmTlmm3iLrL7443yQzX32zvyLb/0Oo
X3YfZb7HInsvPaL0l2T9k7lniuz3+VT3k2C/k2wcLrK/f67rTbL7KuufTD3N
S50vBc6w8yxyC32t359k901m3kX2XnxDuU+SjL9Zxs8iez+9h/rfw+/lVvoF
m9GMEg==
        "]]}}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{None, None},
    AxesOrigin->{1., 6.},
    Method->{},
    PlotRange->{All, All},
    PlotRangeClipping->True,
    PlotRangePadding->{Automatic, Automatic}]}], "}"}]], "Output",
 CellChangeTimes->{3.5857641347482395`*^9, 3.5857648722914248`*^9, 
  3.585764925329458*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "4", ",", "13"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "16", ",", "44"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9", ",", "21", ",", "49"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.`", ",", "0.21052631578947367`", ",", "0.4`"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.5857641347482395`*^9, 3.5857648722914248`*^9, 
  3.585764925332458*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{}, {}, 
     {GrayLevel[0], Thickness[Large], LineBox[CompressedData["
1:eJxF1Xk0ld/XAHCZp8qYyHQvFTIl7lXR3qkkGSOpTKEyZSiKkplEGYqQEskU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       "]]}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{
      FormBox["\"inv\"", TraditionalForm], 
      FormBox["\"Freq\"", TraditionalForm]},
    AxesOrigin->{0, 0},
    Method->{},
    PlotRange->{All, All},
    PlotRangeClipping->True,
    PlotRangePadding->{Automatic, Automatic}], ",", 
   GraphicsBox[{{}, {}, 
     {GrayLevel[0], Thickness[Large], LineBox[CompressedData["
1:eJxF13k8VP/XAHCJrEmWQsoWhlCKsczkHJMlY8ZS9uykEiJEtqzDTIulbGWn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       "]]}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{
      FormBox["\"vis\"", TraditionalForm], 
      FormBox["\"Freq\"", TraditionalForm]},
    AxesOrigin->{10., 0},
    Method->{},
    PlotRange->{All, All},
    PlotRangeClipping->True,
    PlotRangePadding->{Automatic, Automatic}], ",", 
   GraphicsBox[{{}, {}, 
     {GrayLevel[0], Thickness[Large], LineBox[CompressedData["
1:eJwVl3k41O33x2WNoqxRnsiSfcsSYs4ZMmIwY0ZFVCgRka0spXyJ7ESWkDC2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       "]]}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{
      FormBox["\"tot\"", TraditionalForm], 
      FormBox["\"Freq\"", TraditionalForm]},
    AxesOrigin->{0, 0},
    Method->{},
    PlotRange->{All, All},
    PlotRangeClipping->True,
    PlotRangePadding->{Automatic, Automatic}], ",", 
   GraphicsBox[{{}, {}, 
     {GrayLevel[0], Thickness[Large], LineBox[CompressedData["
1:eJxF13k8VP/3B3BkLWSphBRpsZYSKvK6thaFPtIiKslSREpJiWxpI0LZU1HZ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       "]]}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->True,
    AxesLabel->{
      FormBox["\"inv/tot\"", TraditionalForm], 
      FormBox["\"Freq\"", TraditionalForm]},
    AxesOrigin->{0, 0},
    Method->{},
    PlotRange->{All, All},
    PlotRangeClipping->True,
    PlotRangePadding->{Automatic, Automatic}]}], "}"}]], "Output",
 CellChangeTimes->{3.5857641347482395`*^9, 3.5857648722914248`*^9, 
  3.5857649253954616`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
  "******)"}]], "Input",
 CellChangeTimes->{{3.4940977943255997`*^9, 3.494097801075859*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"out", "=", 
  RowBox[{"GraphicsGrid", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "gh1", ",", "acfgh1", ",", "gh3", ",", "g1tbl", ",", "g2tbl", ",", 
      "g3tbl", ",", 
      RowBox[{"{", 
       RowBox[{"gcp", ",", "gtbl", ",", "gcorcp", ",", 
        RowBox[{"gcorhyper", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", "gnRE"}], "}"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "900"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.574736409890443*^9, 3.574736410171243*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {{InsetBox[
      GraphicsBox[{{{}, 
         {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJxdVHswlXkYPoXqsCPrMiJtuYwkl5JbJR7kFsJxcA5qiw67aTGl0ZVv2yNN
uaxiFpWNZVWjnRpMY0OfLrsS6aZWDXZTi067HXKr09HuTu/vn/1mznzznOd9
f+/z/t73+cwT0kSy2QKBIPXf33/vj4/Sq6hMs/FQ9qQX/YGm6lM2FUkfCM9D
xoWkwomlc/ER68El3mhp4JZZhA2xNnWPcWGSNuEF4MZfGuyMZ/FmeNK/Wa0t
1CC8BGfyVJ/2DwoJW8AoTJ4i0dAnbIXQsthQxY/vqb41WlXmj2VZSsI2cFPq
Wtt2zKN4W3Rnvk+0bZ4i3g5vbun3rZLNEHbAs+O1IR5lWhS/AnFFjg36vp8Q
XonvT1SLrxqwfpwwNq1svZ+4kPAquF5yCTzwjOl3RsTwyMI9egLCLujrq/9y
cr4eYVcoFi1ZpCd7R/XdMKH0MevZoku8O76bUVVPyFTEr0ar1leaWpMsfg0s
khoNXfJ0KH4tsveG1K9UMn0eEOt+/vWAhOlfh4r0hvE5f7B+PRG3oLv3B3c1
YS9kxng2XLs+m+IBx3vTgv03TD5iDtCy6Nu9vYrp8YYqbX+ZzkPaB84bKacf
ntQufUO8DzRym/mmn+l8zgeN+bp++pZsX3zRdvFJebsVy/eFifTKW9+gUeLX
Y+b5XYfG63R/3HoYR3+bJTWeIN4P2d61PTdB53F+GL6kkPN32Hz9kdkbnyiv
J8z5Q1E2q2RqmukPwOiH0WITRwM6PwD7Di9/FeI0Tnwg7h74/eSoI90HF4hR
Vfdnrn1MXxBEFaotnWns/CCYndfok2pOE78BjyvnJz+Q/0X8BmwVpNiIFUx/
MGr2vlQ6vXtNfDCa9531sHJn+xyCwded+o9KaB+4EGRJTqc07mHzC8WO28fs
s86z+wlFoN3dabedLH8jblZkmpfLmf6N0Lza0V6XxPYvDDl198rNcmifuDC0
vE29eOU30iMIh5lpwTfticQjHJddB+yCzMmPXDhuW/PHrIeI58NhINc2eRnG
/B0B+2LDhK4M8iMi8GZbS3D6DtLHRSD2p2TFg85Byo/AVmnVLbE3ux8Rpny1
j44eoH2GCDqm9hoveJoPJ4I6VCx74UXz50WYrLzjdEjA/BuJ3Ln5y4wSqH9E
wr5TaFnUw+4jEsW+fxbstyC/8pEYyBDKbAvZ/MWoWF2fLDzD6otRO5bTonlw
jOqL0XZ/1/ZfXxPmxbA7FVWjq55D9aMQWWjesPZv4hGF+yOVWbvqnlN+FMIC
BzdHtNH+8FE4ET9WfOEX0ieIxqah49tCcmi+iEa3LCnAezd9L7loxDh22S2u
ong+Gv1a6oLVjcz/MfCY7nA+MkT9IAYj65b1OsmZH2PgmufnOeNJfuX/hwUS
iNTX4mp2a1J9CWyttJ7OOsL8JkG9YvGKs6U0L16CUu2DrSWG5CeBFJmbnKKF
DtQfpDhsecM534bNT4op56rlzpdpH3kpznWNdHiasu9bLB4tqOttUpPfEIvZ
/Wss/CtYfixaX6Wl5yey+cVickyV8dSP9R8Haz2TIbEXm18chnNz26dGaD+4
OIyf8/9COKKBfwBYsvsI
           "]]}, {}}, {{}, 
         GraphicsComplexBox[{{0., 1.}, {0., 1.}, {0., 1.}, {0., 1.}}, {
           {RGBColor[1, 0, 0], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->15], 3], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->15], 4]}, {}}], {}}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"\[Times]1 t\"", TraditionalForm], 
         FormBox["\"\[Theta]\"", TraditionalForm]},
       AxesOrigin->{1., 0.6187533948663699},
       LabelStyle->Directive[FontSize -> 14, FontFamily -> "Times"],
       Method->{},
       PlotRangeClipping->True], {194.4, -121.13466179497938`}, 
      ImageScaled[{0.5, 0.5}], {360.00000000000006`, 222.49223594996212`}], 
     InsetBox[
      GraphicsBox[{{{}, 
         {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJxdlHlQk2cQxkMcBRqglTKAVQSBoqCFAAoUi3kIh+GQIyEhJFYBC44Hp0Pw
QIhW1KKttmoPEC1FGdSqCFqx1jHQUlEQS8UDyxRRUU5BNBINmLbDvv80M5nM
L7v77bPXNys5Q5zC5XA46f9+//ud+AwLShxy76cufSqgP9BSFi6ssG0lNsGS
+pHWcyV64ndwv6p0fcdgG7EVioJ/PdHJe05si5OHurKKq5n/DGy6vqH8YPY1
YgfofJ1vHWkZJnaE01mnrXdm9RA749PTQ5fSO5ndBcMDXHve30+I5yD75U83
jvSNELuh4OjKzBLlGPE8cK9c2yIM7SN2x+vuTGODmPnzwZf6uj5++IbYE3+8
fW12l/tLYi+cd79X+Z0Xq8cbtfJ0T+frOuL5mOJWrG8Z7SJegFe6kkXlXky/
D5rGZLsLfZ4R+6J0W6Z2bAPT44dSYbGViQ3T8yHkxz/gOQ2/IPZHZemttdtU
rP6FkJv1VRyuZfaPkGI6U7W+ZoA4AHUzbEWrvmV6F8EoT/rAO2iIWIBLTQv2
9d9ldiDz1Y4q+2ODE6wGrjp9Yr4/n+kNRJrnWwcHk0ivOhAjuX6nHH2YXiHe
b/eKWzqsJbsQa4LKj+Uo2P4EIY2T1ffL3gdkD0Jynzc3K4TVE4yDZqbZCZMo
nzoY/tooO8OefrKHQPnF+CFBEdMXAoUs+s91saz/oTh3qMJozc+UTx2KimoX
raSD/DmLISy02anwe0T2xXgjGExtLmDxItRFuqy2+ZrlF8Hqdk+3diPVwwnD
2YIDdgWrSa86DEs3m98VtLP9CEfYSp7znhTSqw5HfMuR283mr8geAYO5Pufk
Q/b8COSqIvJ3L2T5IzHdsEzs5kr9VEfi6oXo+XnWLP8SLFNZjzR0Uz71Ehw+
JXJUeFM9nCgMbfcszZhH+6COgqlHb/Fci1GyR6Niu/XmWUqmPxobLf2ML65j
+mIwlmFj0ax9OMGIgetxj792cpl/DPwmy2xfuNJ+a2KwdrDQ7tFVpj8WU7mC
VdtMiRGLQP+m1706Vk8sbo6mV+fqjTARH4sUafvqyvVsf8Q4b/R8Jj+S9hNi
1D3NtGz0JVaLcXu2vnrZOapHI0aywKNhXi3bTwlcptakmuyg+UOC/YKLK/PB
5i1BY2doK38T9VMjQVSV7olIxPobB0v9l9W6aJY/DvFJWyt+s+qm+Di0HW0w
dILFx6E+7MLy9w6ze5LinlZ/4nQhzR9S2Bln7S23ZvOW4kDPnXuTBqhejRQ3
y6wuS358TPEydAjs6x870nwhQ06b764pHixehqEIqaPDOLFGBoF9PH/Xdna/
8UgodipqTyQ74rFWz+NW/UD9UscjfPI0Xo4bvY80/2OOHGbC5mepqXQvkOOr
stMBZ+bQPNVy5GmSLi5XMf1ytAqLZvDD2PwTECC6ktGxvJfiE/BuYH+7j4HF
J+BM2gmLuezeNAlI/Pz7SsstrH4FLq9Y8fG+b5h+BWojvKdqLFj9CtQ0NqnO
W5G/RoH9ez+TjNez950SZTnTunTjpA9KdN6omZ5Yx+5BCff036McfF4K/gFH
vhsB
           "]]}, {}}, {{}, 
         GraphicsComplexBox[{{0., 1.}, {0., 1.}, {0., 1.}, {0., 1.}}, {
           {RGBColor[1, 0, 0], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->15], 3], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->15], 4]}, {}}], {}}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"\[Times]1 t\"", TraditionalForm], 
         FormBox["\"\[CurlyEpsilon]\"", TraditionalForm]},
       AxesOrigin->{1., 0.2066226766797675},
       LabelStyle->Directive[FontSize -> 14, FontFamily -> "Times"],
       Method->{},
       PlotRangeClipping->True], {583.2, -121.13466179497938`}, 
      ImageScaled[{0.5, 0.5}], {360.00000000000006`, 222.49223594996212`}], 
     InsetBox[
      GraphicsBox[{{{}, 
         {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJxdkwtMk1cYhgsGASMKzgu4OVHQgFMnd3RCX0UKLbdyKS1lrFHAKV7QOXER
kN8NUGBD3ebCpcJgQjArN4HNFbWtQy6KKy3oAsIGKmpwGROJbIJkW/zOlvAn
zZ+n73n/857vfN+KHckRiaY8Hm//P79/36+eP/iPNfHFtZobfPoD0z6POhc2
tRNbwF68yqTwrIHYGqkdU/uPTnURL0SRVKdPyWG6LQyx7vlx//EbqLyZFV3/
Ifu+PYbNk4qr7zL/SpTpcnfamTPdEY1Jxqm23PvEq/HlOO/ekZAfiZ0wLEgw
nHMYJF6DE9qrPvMGrxOvhahuvW1j38/E65EfW/WwyILttwETjl2bdk4OELtA
1LPHyL32E7Er+nOay2SBbL0bdOe44ifZN4ndkX4xu3Ak2EjsAS+XN884X2F5
PBEptxwYC60h9sLLNveGZ2/3Enujttgo04ex+mxEnmjJSd7oNeJNSHB7XWpV
oCF+B399ppyVUsrybUb9Hoel4uPM74OToo/7VZ8y3ReaomXxbjsuEfNhd224
c5ecrQeezrZ7nqnufsUcwK+y3D2yupP0LYgr6DhsoWsmfQtiWqxd8+61kL4V
keln1ibU0H1xW3HwgwbTBa2tpPtBNfxkLEPB/H7I6g801C5tI30bHqxIqko3
Z/tvm6H7Y9n1vgOKwQrS/VGJAyVN9TrSBXAcP9WjzqR6cQK4CJxenFVpSQ9A
s/Wqs4m2tJ4LgE6a6nvoXdY/gYi/FmBptY7ycoHIbf99edpQB+lC3B5dk+JR
TswJceF8+QGbe0wXYf6idaXdGXdIF0GY4Bn43QTLHwTRXDlWWrHzBWGy18q/
qoLVJxjTs4ZGzMPY/sFInpwOSN7N+jcEVgVdZeuF1E9cCO6O9egdilj9Q3FJ
9es4fwPdJxeKRF+HPq8G1q9hmMfnTSie3yY9DGnCye7FPswvRnZoxUeXD9J+
EOOF2WCtOpbVU4ydUTbSY8dp/rVimHydYX1UTd/jhSOH23xZ8hvVF+GQ7eqp
eOx4i/zhuDGm9TRprCd/OJLlSx59sugi+SMwGt4uMzrRfSECaXsHfNwSaJ64
CAhd3L/d/ozmTRsBSb53kL5piPyRUJpsfNw7TDoicSpX4jXgR/PFzWBtJObk
3co+XdNA/ig4xx9KybvC8kdBkH2kZbWC3XcUVJkvh8x0lE8bhe4nilGLB9+T
X4LTvo++0ofQfEKCrJKFcQoDnY+ToHnOg5Y7rqRrJWgL7Vq8wJrdfzQmcr7w
E3pQPRENIz9cVWpg54/G5fJGjdye+ksbjX0Zo7NLBP3kl8I1XZ02t5X6DVK4
ex/qsHmL5Zci6PM795OMlEcrRWp5iD7OrJr8MpiWxaab2fWRfwZzMnyzru5i
3BDVWyvDe3/uU87vYv0Vg7qqosPTwh/IHwMT/+nzie+zfoyB8xVL5S8ayqeN
wRnjhu1tWTQPPDlmVQ/nHgumvJCjUq3c1XTuAvnl4O4PeMj2XiW/HF7jyuLC
Rla/WNguSVQ+fUh5EAve8vm+3p1s3v/nvwGyNBBw
           "]]}, {}}, {{}, 
         GraphicsComplexBox[{{0., 0.4}, {0., 0.4}, {0., 0.4}, {0., 0.4}}, {
           {RGBColor[1, 0, 0], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->15], 3], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->15], 4]}, {}}], {}}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"\[Times]1 t\"", TraditionalForm], 
         FormBox["\"r\"", TraditionalForm]},
       AxesOrigin->{1., 0.04272745373362794},
       LabelStyle->Directive[FontSize -> 14, FontFamily -> "Times"],
       Method->{},
       PlotRangeClipping->True], {972., -121.13466179497938`}, 
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], 
     TagBox[
      InsetBox["", {1360.8000000000002`, -121.13466179497938`}, {
       Center, Center}, {359.9999999999998, 222.49223594996212`}],
      "InsetString"]}, {InsetBox[
      GraphicsBox[{{}, {{}, {}, 
         {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwBmIQDQEf7FFpBgf+6A/n7mhUQfkcDhvqJe2t1s2D8gUc
VO/xRq3fdwTKF3H49X4Jq1NpKJQv4fDuaoEg87ZVUL6Mw6oHZ1sOcK6F8hUc
GKVVUmJED+yH8JUc1nxim2s/ZwqUr+JQyyTaLW1zDKpezSF4kc6jFbeOQ/ka
DoHH+XYKWx+C8rUc7rWuNpbua4DydRy+FKluEenfAeXrObzbLdZslHQFyjdw
uC85adGNgy1QvqFDe9iGINtvu6B8IwcD+Y99h12OQt1j7CB5mY0nJWgdlG/i
IGMj6BSgDFNv6sDUzljyoW81VN7MgZN7cfyOo3ugfHOHZa8fLP5vCJO3cNB1
qX7Sv30NVL+lw+QNx2odT6yH8q0czh7paqrRng5Vb+3w4tvZYB2pQ1C+jUNl
z6ErExiLoOptHdz36SpdfrUbyrdzcDrD3dvc1w7l2zsoXLfnmcIIs8/BITpf
pGm34EmIeQ0ODkbhE/fJ7pkENd/RYdb21JxfB8oh6hscHZ7beHk3T1kBlXdy
yM/SLZS0gcZng5ODRdpMd5GMi1B5Zwfxrn82Bs0roPLODio+87q50zZC7Xdx
0N+y8BmnEDT+G1wcZr0s+1DvUAGVd3VQNWxqefZ/G1S/q4OGlaqQ18o1UPPd
HLZq/LZ3lT4JlXdzmPZrYy+b3FSovLuDyt2mWad1Yf5zd7Ari+y/XrAYar6H
g/709U829m6Byns4mGUdj2ufuROq39OhP3XqSsnUBKj5ng7x9rqPi3KO7QcA
SfThoA==
           "]]}}, {}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"\[Times]1 lag\"", TraditionalForm], 
         FormBox["\"acf of \[Theta]\"", TraditionalForm]},
       AxesOrigin->{0, 0},
       Method->{},
       PlotRange->{All, All},
       PlotRangeClipping->True,
       PlotRangePadding->{Automatic, Automatic}], {194.4, -363.40398538493815`},
       ImageScaled[{0.5, 0.5}], {360.00000000000006`, 222.49223594996215`}], 
     InsetBox[
      GraphicsBox[{{}, {{}, {}, 
         {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJw1kmtIk1EcxodNCy2mXaQwLDM1xiaaWulme+buiJRl1Bcvk8IZ2EL2wcqR
NcsNZNgqDYRw2WW2ZunYbJqJzRkJKQwLyyzKVlINyw8yQrHL/u+Bw8vv/J6H
c877vkmV2kMnIlgsVtbf+e8ZHj9FK//HvIgWcFnTr3tp8Q2FcQ18sSrN/cVW
8rFYamqJV557TLwR686vHJ21OSm/GTx3tvPDKTvxVpR8TBAmjHUTb0ewvLH8
nttO/R3wBwNP2+pl5Hei2Wx6grI+4lT0L2sWfepHlN+FVM5gtTfnAXkuklxX
/XyDlTwP7ZPjmaxN3cTpsPcFuHrhFcpnoCrO/O2L+hlxJm77jiyXBuspvxtd
aWmfdB43+SwEE7V1GSZm/2wUpaWnrJ/wEOdAIC6dGpA2UX4P2N7vfMO0hfxe
5Dr4PE5NL/l92DahbTMYbeRz8SbgYvuLmP3yELfCcr5e7SIWwNMR2MJ3MO9P
CCvHlNie0kv9fJydu3XMMm0hvx8VtV8l8irmfiJ4uNEDs9eZ8wO26tDMDfXz
MDcAF4aMx8t0VsqLoTAnL+TbX4S5QYxXvx6yjTFO6heg2I/kd9xr1C9ApIAT
v+rgXepLUHig2mYIFVNfAttSxWR2Qyf1pYjSR8SeXPBSX4qOwYuFU5oe6ssQ
ap6PdJtd5GXwn4nuEqztob4chuFR4fjvOvJyjOUFWkfeDpJX4FJJ91x7403y
CugrHZ9jZMz/qERx6mHBTKSXzqfEyOzpxtFC5vur8J7DT67pGSavQu2PO+Ko
DS2iP1Yt9U0=
           "]]}}, {}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"\[Times]1 lag\"", TraditionalForm], 
         FormBox["\"acf of \[CurlyEpsilon]\"", TraditionalForm]},
       AxesOrigin->{0, 0},
       Method->{},
       PlotRange->{All, All},
       PlotRangeClipping->True,
       PlotRangePadding->{Automatic, Automatic}], {583.2, -363.40398538493815`},
       ImageScaled[{0.5, 0.5}], {360.00000000000006`, 222.49223594996215`}], 
     InsetBox[
      GraphicsBox[{{}, {{}, {}, 
         {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJw10m1IU1Ecx/GpFT6UU1MLU8myEAmdOjVzuZ+b27xIYBOERmQZC1RGbKFZ
RM1Vw8jEmS8WORNdmGs6mTQ1IyvJFBIXYcOEpvYkzmXZsheWlvj3wOHyvZ/L
4R7OiSk+K5V7s1islP9z7bk+vvNXVtfGAp9e4K6J/Skgv5/aF67xIvPiymvq
IOwbz2P8Fi0D6x0KN/tBBttkJN+JO5bhcs+36+SR0Euybpa4DOS7MaJzRgVf
1ZDvQYi5YsfSi1byWPx4N8HI5huo92Ome2ukvrOXvo+DSleuYp4/IY/HzOgZ
y6Sij/wA1LE1F0YLu8kTcML4sixQayPnYFOEMoObYiNPQpvSUfn5aAt5Mirf
TtpPKVTUKbgmOuddIh2k5uKVJXGiasRKnYq/7QNRT/1vU6fB39PqCTFYaf10
RC9GaO5duUR+EB9/WsXQDpJnQLnXZ5U7Ukd+CNxHg/LN5h7qTNhPFzgCm+9T
85BYPK9IyxyiPoww8ZdbyzEbnYWq6uP1PcaL1HwYxv58GDOYqYH80COFx1qo
1YCrd3lcWvGGPBtKT6M1bI72q86GPMoRvz2oi1yAeTfPa1u7bv3/1QKEF+0q
ZmQN5EI4S23hSyfpfNRC1H/1vTHb9Yz2m4PkqUYJW24iz8Fl80JBUmkfuQhD
fhz9e6aaXARRk5e20bVxXmIEx/OcqbN0H9RilMl+cboSB8glYB4n/OZEd5JL
0CGcPp/Ht5PnwhHwUDM9PEyeC256TduUu4OcwZxpLE7W1E/OYEutoNZHUsf/
Bzfw+V8=
           "]]}}, {}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"\[Times]1 lag\"", TraditionalForm], 
         FormBox["\"acf of r\"", TraditionalForm]},
       AxesOrigin->{0, 0},
       Method->{},
       PlotRange->{All, All},
       PlotRangeClipping->True,
       PlotRangePadding->{Automatic, Automatic}], {972., -363.40398538493815`},
       ImageScaled[{0.5, 0.5}], {360., 222.49223594996215`}], 
     TagBox[
      InsetBox["", {1360.8000000000002`, -363.40398538493815`}, {
       Center, Center}, {359.9999999999998, 222.49223594996215`}],
      "InsetString"]}, {InsetBox[
      GraphicsBox[{{{}, {}, 
         {GrayLevel[0], Thickness[Large], LineBox[CompressedData["
1:eJwVVHk8FN4XRQgzlhnNZGaE7CKksoTuk62UkqTQQknIlqxJpE3ZR5bwLZF9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           "]]}}, {{}, {}, 
         {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
          LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQXXwqXW/awSa7WTNBYKf9zqA8VweTjfYw/uX3IZL2
Jgfh/E22ra2Vby/C+aG+ZpfnLboF56/4mM/EOu0hnO9vkywTYf4Mzn+8+uCD
CZ2v4HyF2XZq6Rbv4fyjz27rbXjxEc4vEDo3fz7vFzj/Q63/xbsJ3+D859Vs
N/p6fsD5JbN3hweu/QXnX/31f3rSnz9w/to3lWufKf+H83X6Dx68s4fBAcY/
a+H60u8RI5y/cnVy9a/PTHB+wb6TuWdlWOD8olmnTt00ZIXz48SEO3jj2OB8
0cW3GE+1sMP5HD9tnu2fzgHnP333TOvuQU44/+9a7VvGN7jg/Ae1712FX3LD
+Wvf/hKUEuSF87epLfSIUuVDuPd/3/2DAfxw/pYvtZKR1gJwvsG5xh+5RxD8
heUr28UiBeH8Da1yZ24/RvBVZC7nPc0WgvP7mlYfbPqP4E/1vXjSplMYzp/4
QqqpS04Eztd+sfH9l5VI/IKO3YuNROF8hRNN5s+OIfibWk5luAaKwflWgmZe
Fs8RfHW1h535VeII9fNv1h1mloDzjV5+VV49A8H3nx5ft15ZEs6/dJbD/Mdq
BN/rytX5V+yl4PwE+w97z55E8OeZHbC8ICYN59/WnbD1UjKCDwCQ37QC
           "]]}}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"\[Theta]\"", TraditionalForm], 
         FormBox["\"pdf\"", TraditionalForm]},
       AxesOrigin->{0, 0},
       Method->{},
       PlotRange->All,
       PlotRangeClipping->True,
       PlotRangePadding->None], {194.4, -605.6733089748969}, 
      ImageScaled[{0.5, 0.5}], {360.00000000000006`, 222.4922359499622}], 
     InsetBox[
      GraphicsBox[{{{}, {}, 
         {GrayLevel[0], Thickness[Large], LineBox[CompressedData["
1:eJxF13k4VO/7B/AxFCUR0iKJohV9IhXxPgltkiwlIiJLRQiVtUTZS0UUyhJC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           "]]}}, {{}, {}, 
         {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
          LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQLZV37tzhBRl21SLr3B9Wtdh3XXpjyTV9mj2MP3fq
g/Uc05fB+bumJt6279oO5xskMpyfX3MQzr91vDQ3S/w4nH9urx7LRe2zcH5A
kP1dnZyLcH4cb6eJff0VOH/6htRX35qvw/n2Z3g37A+5Bef3rL9eGJZ0F85f
0rpN8b/sAzh/xvJTO5c2P0SYv/a9/2b2x3B+TP6v3JOFT+B8HVGxLrdfT+F8
If3q0GnVz+F8fdZjK949egHny+9X/LU24xWc72aafLn0yms436F/66olcW/h
fP/YQMNlD9/B+aeKX8pHqH6A86+vMlom8BLB/78/r+Ds/I9wvlG//6TPQZ/g
fL8LFsa+op/h/Lb3IhKrTyH4yxt+Vtv0f4HzL59uMjcP+ArnS3/9Z2bG8g3O
95nQvDXjOII/k/N3+fza73D+RxvxSfYGPxDueWStLfwJwe9PDeZ4vewnnH81
qjjlW9YvON9Mr42FTek3nL9ot+2fuqsI/o9df4u0Z/yB8zNnbNC94/sXzj/8
PDv9gNA/OF/j4+kfvFcQ/JU35M7Fd/yH8zklbSd+UmVwgPHPmKTEmjci+FPW
xl7dcAvBD4y/zXPEmhHOl2kISouchuDXLfbpfHECwb9/zG1N+W8EHwAgepBe

           "]]}}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"\[CurlyEpsilon]\"", TraditionalForm], 
         FormBox["\"pdf\"", TraditionalForm]},
       AxesOrigin->{0, 0},
       Method->{},
       PlotRange->All,
       PlotRangeClipping->True,
       PlotRangePadding->None], {583.2, -605.6733089748969}, 
      ImageScaled[{0.5, 0.5}], {360.00000000000006`, 222.4922359499622}], 
     InsetBox[
      GraphicsBox[{{{}, {}, 
         {GrayLevel[0], Thickness[Large], LineBox[CompressedData["
1:eJwVlHc01f8fxyXkXrkkZZWREiEpZeb5qa+WNGiYZYQSUbKzSmSVRFpGZioa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           "]]}}, {{}, {}, 
         {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
          LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQXZv17O+yw152s2aCwE5796udrGt6Kuxh/MxU/8hV
PR1wvtiXiRG/psyE8w9/v5TznmExnP9BM+CtnsRKOD/bvvbGtM3r4fzvM+TN
+d9vgvMfNEeYp7ttg/OZObuvq/bthPNX/WH3LZm7B87/8fDO92vv9sP5T6T+
7X7SfBDOfzWRy2cix2GE+xgPf3NfdwTOv7dCoeeY+TE4/6yHlo3/o+Nw/s2t
BjbcrSfhfPWoO2r93KfhfI/vxjqym8/A+atPG8gU252D8x/NuKl2+dV5OH/2
zP0Om49fgPPTmFIfP+i+iJBPT5g8OeESnF+Ysc5CS/0ynH/1/K/WWy8R/MXG
cx/w770C5wsZTzLQbLoK57/Wu9t7PPwanB80UW1yveZ1OD+q/1Cv9FsE/0zn
lqk2B2/A+fflf05ybL8J5zfK2FgkeN6C83tEr75ilrkN51usOjCp+wGC72fN
5DFj6x04nzVj2qeOmrtwvvdvDdfJ9vfg/F9dgkuVhO/D+V7bfH5NvYHgM7/P
03MPfwDna2zbZhxwAMGXPb3c2FvpIZzvfs95V0cPgu9k32m94z2C33L57IQv
AY/g/N+pe3OKdyH4Tm5hzk9kHsP5cx7vlrkWjOB/bVD8drwLwQcAMrXDHQ==

           "]]}}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"r\"", TraditionalForm], 
         FormBox["\"pdf\"", TraditionalForm]},
       AxesOrigin->{0, 0},
       Method->{},
       PlotRange->All,
       PlotRangeClipping->True,
       PlotRangePadding->None], {972., -605.6733089748969}, 
      ImageScaled[{0.5, 0.5}], {360., 222.4922359499622}], 
     TagBox[
      InsetBox["", {1360.8000000000002`, -605.6733089748969}, {
       Center, Center}, {359.9999999999998, 222.4922359499622}],
      "InsetString"]}, {InsetBox[
      GraphicsBox[{{{}, 
         {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJw9lAtU03UUx9cMJCBAQANEmFDyTAFJcCL78nCAgI5tsA1K0VwkaATydBRD
yycg8uhoInA08Cj2UMMMSP6oGPhAIwOPBxVQ6KSQeCbHIaDV4f7aOTs7331+
997fffzu/PWpUjWfx+N98u/3v9/pz6jooXCoffF9W9AfMDvYfa9PYE3aCHU9
XTkq+TPRtLaAx5a71nt0FsStcUVzR5978CVxGzRkqY+0JTFtjwfu1j7iQWM6
L4CsM1N9bsdc0k7I2iPZl3R7lM6/jaemed1p152JL4BbXbv3+XV2pF2hct1q
eanAirQ7Jj31vN1hBqQ9kV5lLfY6z+IthP/1jILilHHy74XuM7aFXROMe2Nh
vmDRk0Y9cR+Yrvvca6Mji7cYFsKGlshEPmlfmFeoDa52vEH6PXQYfG376KdJ
sl+CbmVei/jyTOJ+WHroO/9rx1g8f9xTKHvG85heitTEt5Jb2wxJC/HZXwFu
jrOmyN8yOHQaWXx44jXiAXi/RrF5r9UE8eUoG90pmjjFzgeiIPSoa0w/Oy/C
nqfKtf4zWX7AiOHMIkGo+TTXApola9pbU1j8IJw/fGdgqcqEeBBGv6nX14zP
Jh4MoUn2jnPNrxMPRvO7j/J/nTQlHoJNcrfaG9EziIdAEbZm7zJTNi+hMJ8x
YZc8SPG0oWhwnsVfq2R8BSRm37s3NZkRX4GfnQZCnzqyfMRw7JRGFN1zIi5G
4xcZvupSI+JhKPFQhLbpqb7aMOS3yByaxGyewlHyMm3unG+Z/3A0qwbfzHIW
EI9AX/fg9mvVdB9tBKqvnn0ydYTN60pwGTJdPuYQXwn73ZPdf6fOIh6JY+6+
I38M03xqI6HTnAqcmmL9icJHfI5LT+ATj0K2QJSlKaP78KIxZ+jP5R1HLIlH
oziktNHlOct/FUwPSNsjFMz/KnTWB4cN1Twn/6sRXd5zfFsJ9Uu7Ghdccoqq
cti8SnDlke7xmB/5hwT+gUbvuBe9mrbXSrBhrKvczYHmg5Ng+9gPN/JMeGQf
g3lc3aFAIeWLGChrf+wfGWP1ioFBScbpdeHzyT4GVcalhR3ZrL9S7M+9kLxp
PcWDFL0fqIuqfOzJXooTNtds/MqoXpwUPUkpSf3xOspPht5ig2RLH8oXMrS6
8ZV3d7F+ynDcOKQyX0n14mQQaB5XBA6z+ZWjMvP2WPpDmlfIsVGYqWvS0/7Q
ynFws+1WDzuaT06O3PIDCwobqB68WIzKv+RO7qXziMWMJ5U7b+bakH0svC+/
kBb1UH25WAzJTY426Nh8xqE8JCrcPJveB+JQeOtZ2mMvFj8OHlaJIpiz+8fB
py39zEAAvTeeAqWaferJGOoHFAju6W1rFVB/tQrMS9wkTUimfDkFDC5ueLnm
K7bPldBZBX0qzaP3DSWqXW5WJGVQP7VKaA7zhb8sJ3+cEnYD0Wd5tZQPT4XZ
D6b4VQ+pHlDB6eNdXl25bmSvwiTnefqkM5/sVRAVtPy2KPsF9S8ez+6H71rk
TfsR8Sh+flNT70v308bDNafGQT9G+5qLx+7EguE+AatfAkwDtogvCuk9IgG3
1sa+2v//PkpApORS/tTvhvgHyXDYKg==
           "]]}, {}}, {{}, 
         GraphicsComplexBox[{{0., 5.657936507936508}, {0., 
          5.657936507936508}, {0., 5.657936507936508}, {0., 
          5.657936507936508}}, {
           {RGBColor[1, 0, 0], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->15], 3], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->15], 4]}, {}}], {}}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"\[Times]1 t\"", TraditionalForm], 
         FormBox["\"L1\"", TraditionalForm]},
       AxesOrigin->{1., 1.0528331373431263`},
       LabelStyle->Medium,
       Method->{},
       PlotRangeClipping->True], {194.4, -847.9426325648557}, 
      ImageScaled[{0.5, 0.5}], {360.00000000000006`, 222.49223594996215`}], 
     InsetBox[
      GraphicsBox[{{{}, 
         {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJw1lQlMVFcYhQcriBUYlgEBZZPNDgyMClQ2OaIsMmyzMAuggkJUiliqEmxR
Hpqg0UrBYq1VhCC2LGpdQoosdUiQRSoo1bamHSGNSGuVAcZSQI1t439fMnn5
5tzlv/ece5/bll2y7Hk8Hi/vv9//77fPRESxs6jhas8y0B8oqeupu1ZtT2wK
M8vo7U+sFhFbIuaWhUp/2JZYgAwupOZCtxWxPQKuG0x3nGW8FFc+lGhaa+2I
XeEXMtLmUPQm4i0vw8vTZYd6hoxJ90C2Cs2DHtbEXrjXlFeoLniPeDkWXNdF
St6w9kJk87nhbPslxL4webDT1KaDze+HL8UXi+/a2RCL0eF54lOP+a9o/hXo
rcm5GSdcTPpK1PB6Fc5CNv4q9EdWjRjdX0ocgACzuxLjGgfiQERtdltjKzAl
DsKW0/umxufcid/H4rDKW70ObLzVaHr088nSeDZeMNLuXFYr+K7EIYA2y6M5
cyFxKEb2dYW3TbL5whA94VLLmVkQhyOopeCLjuXMrzUYKAsKnLzkQhyB7s9N
g2aCBcRAUrkpRI+oXg6oOfGNxmYrW/9aiNMjvk/gU/3cWgg0WZGyai/SI5H7
4nS0tJL85yIxEuB+dfoQq38dDtTnVixrdyN9Hd5pl5qfFHmSvh4ys+IK/T3K
A7ce4c9q105PMj0K3n35R3CQ9Y/ChRlJcIaOjR8NNxtfL9k4qy8azk7PTMrd
2X7G4IAtP0z1lPznYmAXutVmLtqb9Fh8/TevXLDHjPRYWNgYWr9qYPoGqK8O
9ApbnEnfAOmMpQx65mccnB3k2/J2iEmPg4uPW3PWGlafBBPKpdqOel/SJXie
MFV0cYkj6fE4O2qiMewxIj0ePYb6SdEU8ycBjzeaibs6yQ8uAe67xSWz6Szf
idA1Lhz9Yxf5zyUiyaEqQ9G/gPQkHN0bE1txmPLAJUF/7ozOqUFIejI0Gzc1
ilOpHiTj1KrlM7ldltQ+GYLp/Wm6G3T+tMmY3fuucfELPvWXYq74Es/QJqL+
UtxfcfTbgiKqn5NCNf5RWcoZf+ovxeZzHxzmW7H9kSH9jGOZayAxZMjk+fu3
5xNzMvj8JnpgLyD/tDI06rlZHz92/8jxsn5/wY+jNB/kkFd8/Ko0h/ktR+yN
281xleSvVo5KXaHRlVPMXwVS9ggfOmVRfqFAfpB3zvkfKN+cAida7lwc+JVY
q0DUfNlWPdtvXgpWy7e55RyjvCIFo50//fNZIa2XS8G1F0Wi8ETStSkoUl6u
rqpg948S24JzW2PaWf1KeDs93l3PdE6J55/0OXqCzrtWCafMCLuxbJYPFcKs
r3Qe9ac8QgXldSvzzEGWFxV+91nfP2Wg+1KrgmXJ2OWmXHZ/qrGo7uZuUTfN
BzUmV+Zz51eyvKjhq980LA0k1qqR+d3O0CEvyitPg5nWwYfd2+l8QgN3nUE4
/prWy2kg+LN/ONGc2ms1cPW5NXz8CbuPUuFa/drY9TarPxWvhiSqymNs/1Mx
9Mvg8U4vyqM2FbetrO1yS9n3Iw3hg0/HGmopn0iDX3nAX0ea51H/NMw09TW7
FBjjX9zqwAc=
           "]]}, {}}, {{}, 
         GraphicsComplexBox[{{0., 5.657936507936508}, {0., 
          5.657936507936508}, {0., 5.657936507936508}, {0., 
          5.657936507936508}}, {
           {RGBColor[1, 0, 0], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->15], 3], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->15], 4]}, {}}], {}}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"\[Times]1 t\"", TraditionalForm], 
         FormBox["\"L24993\"", TraditionalForm]},
       AxesOrigin->{1., 1.7510114184427572`},
       LabelStyle->Medium,
       Method->{},
       PlotRangeClipping->True], {583.2, -847.9426325648557}, 
      ImageScaled[{0.5, 0.5}], {360.00000000000006`, 222.49223594996215`}], 
     InsetBox[
      GraphicsBox[{{{}, 
         {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJw1lAlMk2cYx4EV7ESUmyK4URACcquIlAl/7paj0EJbKOC8gKgoxwxCXLbP
Y7phEB3KncBwG8yJTBkIVWcBGYIalYUtimSizsURFJmIyDUXnrdJ0/z6/573
/T/H9wi3ZMnT9HR0dHa/+/7/u/AZCwz5xDHJY0gA+gN5FhWWiY0mxHw8mlPJ
m1oXExuDvzF4do+vEbE5Hj4obRvKEBILYBLtbDsgX0Jsi5+XFJe93fg+sR0M
/DqrW8ZnAhfYHjdCzcr/vsR4JcKmYlK6z7D7ncCPMAjnyz4kdkZroKm1XMgj
XoVmgx6f+BtmxG7wO9AZM8Zn8R7QiF/07zvKnveCSHzK4ONqdp83Bkt41xpS
3iN9Nbr9wft6mulrIBaa53+22ZD0tUgT+fccamLsA3dJhJ5co0O8DmWZzVsb
ypYR+0K3NKaQN83yX48x8W+PuXDGfuAb7+SvbDMnFuFwdpH3+UZdYn88z/Xw
9BkwJf4Idvcl2/c46BNvwFPHqzXPvmH5BoDnWTvi7cnqH4jpbevTG1JYvwDB
t83nl43pLTAHSNdJ9p7JtiI9CCGbBz1i11O9uCDsNsgbddOw+gejyuSeIMCS
/HLBOLupSGPlaEx6CE7vld0yvknMhSBuqvpp3l02X6FwN2nI7aijfLhQlKzI
uybQXU56GNaIIhLso6ifXBhCBxeN717O6hmOiochr4dT6TwuHPMBz3fNRlmS
HoHxl68m9ZV80iNQkG/35QMvlr8YE3qyrn07qH+cGJfLa60LXdn5Erwc7f8j
0oWe5yQ4mFnTm5nB5j8S2XUnNw3X2JEeCeF3lT8c62T1j4L1C0n+aJ8t6VFQ
bMpwkziw/kWjt+l6a4M9Oz8aet2LzWaHLEiPweT8waW/e1M+XAwez7TnXNy1
gnQp2o+NO/sYs/5J4ZAlvil4y+YlFuVPJH4iKcsvFpO9IxNDaaw/cXhSG1S5
9g35QRyU8Xc6qtJfLcw7F4df/9K/59JH86WNg+4jYV+KNZt3GercowZyuqj/
kMGIt+WATxGrtwzH/zHtMOoj/1oZuKeCcsUJVj851KLp8RYz6i/kSD18tmCJ
LquHHJeFwxcKk8ifVg6+9INPh6oWUXw87ouzXHd0UL0QjwShRn1LyeYxHlf9
1+7d1kH5auPxOW9/qmEh608Cboauq2wZo32FBPCNqidfy0nnElDr9Fxzbiux
9p2uU9o395rtFwWSR3x/0ZiRXyhgVZ+QZ29BfjgF9p/86vtUGxavQEuYYurN
CM2LjhJr5q4UZ1Sy+5Vo13RZ3HjC5kmJiImCE353llK8Eqqjxysm5li8Ck7n
rriXfcHuVyEnN2uDnsaR4lVovFvfs/0i+dGq8MKrs2DGjs1XIn6s7V+e2Uz+
kIjctFVFp9XMfyKGLHP+9LQhf9pE9GQ3b74tZfsqCYECm2d+B9n8JOHf6P4j
O0X0/nJJGLhULFWdMqD4JGTO59soEpl/NdKHTcqP6FJ+UKOp3uT+vuvsfVZj
9KfSHZM+dJ5WjdWDbi4Xbs/SPk6GYZarcUoN7SMkI7zEYkIbQPuLS0adfpvv
uK0h/gP5rcA0
           "]]}, {}}, {{}, 
         GraphicsComplexBox[{{0., 5.657936507936508}, {0., 
          5.657936507936508}, {0., 5.657936507936508}, {0., 
          5.657936507936508}}, {
           {RGBColor[1, 0, 0], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->15], 3], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->15], 4]}, {}}], {}}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"\[Times]1 t\"", TraditionalForm], 
         FormBox["\"L49985\"", TraditionalForm]},
       AxesOrigin->{1., 1.275050885281606},
       LabelStyle->Medium,
       Method->{},
       PlotRangeClipping->True], {972., -847.9426325648557}, 
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996215`}], 
     TagBox[
      InsetBox["", {1360.8000000000002`, -847.9426325648557}, {
       Center, Center}, {359.9999999999998, 222.49223594996215`}],
      "InsetString"]}, {InsetBox[
      GraphicsBox[{{}, {{}, {}, 
         {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJxVlHtQVGUYxhcsBwmytMIcSBYIQrlIAQrL5WG5rrCw7LLAMtBMC+skCmsi
GsNQKzdFIcCRuBWCyEUiQLlohOwKJKQgCpIXCgFlQTCQ4mZqVLPv/tGZOXPm
md/3vM97vvN+hymW8iWaDAZD8u/931N1PXX9/5OBkpcuUuanpXKV1MKtu6PX
4ns7iL8Bffk7qVu4jaTfwupT6/eOp1WQ3gTG8sdmcOwgvz66kl8JK5BWEzfE
pP2k0tG0mbQRNJ80xmq0nKD1Jpgbq7ndXaXON4W5j47x4dP1tP4DLHMqWUFa
TcS34lyCbsEAu4i0BU7vsUq3GSkkbQX5RpctY9wa0tvh7dRfsuhQQvVs8NcB
jb9FB3NJf4jpNU2RwgV1/kdIjFsRtW3vIW2LlsIWg67xBtJ26BK9upypVHN7
fNfTO9HfVU96B/Z2D97fHKWuvxNRHvbOfhrNxB3wQDPad7enOs8RqWLL7+OT
2kiz4PdwoKjW9gj5ncBYmVvHXu0k7gw78zeNxX7FpF0QOx+THZiRQ9oV1l6d
hmxjdX/AvNmZ4hQDhaqeDNCVnYrIsP+RuBush2Y55fwslZa54Xy8VPS6uyHl
s5EfNNFc6lJLfjbmivWRuJpD3B1pVcmyFx40HzJ3XNgHZvl4OnEPHHJ6NPNJ
WStxD7jfK/JVeqnnxRPRmt3adn8kEfdEgplOjKvmeeJeeOyfuswyOk79eeFr
wZElJwP1fntDMT+WJ78nJ+6NgHFH77G6NMr3QQCLOxkZXUX1faBlwxu0kNB+
MDjojxzlOdZTnoyDqeXr4Rd7fyG+C+t+muEfvJFNfBde81s6+rtkgLgvBOsX
Ws9yqR+ZL06IivRG57uJ+yHu0KmGqZ3txP3glb40lLm7mvrnotYjy3Rw5CL1
x4Uy7ea8UFRO3B/Tlln5w6wLxP1R+FysPfWwk+oHQIfZsEfKuko8ABnPTS8V
zjYQ52EhheG24f63Kg0e8iYsHfbduUL98JDKrK4XF3WptIIH4x1GX4YL8ik/
EMypOydL19J5QyCiMvoMHZoukz8Qjc+GKh31bqnqKwKR0PpV9SaDXvLzkcuq
1//8wRny89HOuW5o6F1Jfj5u/pmik5tO86zgo067zt54+Sr5BaiaLjYfzqH5
gQA+/WYRfQvZ9L4CvL91MtjN5xjlC8Dh9cjZ9XnkD0LRs7li02oF5QfB9sU3
kreP3aX8IEhKj767OFZL+UH4Ik5vG2NbH/mF0OWezLRX3qZ8IW4UGDzpqKD5
lwmxdn9oeNjeNsoXYqVuQ5lzKe0vIxg/t64f1ZLS90IwEhcrXg4rrlF+MMou
zR6IDushfzCsLieZtOcM0fcLAeesu9KkZoT8IfhtsGeIbTtO/hDw/GMHBI3U
nyIEGkaPDGIi1OcnFN6Px4RrZgfo/UPhIjncuzFtlPyhCN+fXCn9dZj8obAQ
u5/z0FD/j0Qw4VZcGd9M8wsRPpOX/jCTNOP6D7sh820=
           "]]}}, {}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"\[Times]1 lag\"", TraditionalForm], 
         FormBox["\"acf of L1\"", TraditionalForm]},
       AxesOrigin->{0, 0},
       Method->{},
       PlotRange->{All, All},
       PlotRangeClipping->True,
       PlotRangePadding->{Automatic, Automatic}], {194.4, -1090.2119561548143`},
       ImageScaled[{0.5, 0.5}], {360.00000000000006`, 222.49223594996215`}], 
     InsetBox[
      GraphicsBox[{{}, {{}, {}, 
         {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJw1lAswXGcUx5e0ITWUSuJRqchDGo9a6xFJg7/3m7Vrrc1UUkUSqUckjdZo
Y4NEjEzsjCEis8SrUqKWEQZb1np1vVU9KqGIxijRJDptmYw2HWfvzJ07//s7
/3O+e77zXZPPEjjRqgwGI/rN/f9z+3rhvIOe9AL1Kpa8YyUtpNWRscX6dCyq
k7Q2dPV6WYLDSr4bAZqr6tlrD9u3tT56ViMWHK9XETeC02Do64mN74jvB+tS
upNObCPpAzhbFmhcZP4N6UP4xHqf3Emrg/ymSDa8vJmZotQfosnugpbaT72k
zXAhatKgUyAmvwUUu2ovG7g3E/8Ip4dUd3K2HpBmgpkrFtwqLaV4a7QcmJu/
utlHnAWetuKeT24NcRvUtrYXBy2LiNsiYDqh4L0pOWk7ZN6cT/klT0rx9jiy
J1Jufl9C+hgOlvXnGM3dpHgH5KxGz2tldxA/jpKVxZaIyArSJ6At0py+Majk
HyOuYUXsaDtI+iT02k2udakVUT5H6OT1KCqeNRN3whXDEqt/fm8i7QxPu27O
0/3KfgAZVYtDi5KGbS4ExNd8ZhfSu4m7IL2Y29hZKNvWQhccT645WJxYS/lc
4WlaF5+flkp+V7RFRpie7lMQd8Mr3erZ3nYZcTfsbRHl8+OqiLuDZeeT2p81
StwdmtMDJTzzMuIekExIssV7aH+FHmhiLuv3sc8R90QMb02qskH7JfREwpOJ
r9sd6ol74f5b12MVqdQ/oReM6pLMHOrK6fu8MTe3mXZ0Q7k+b7y4+sX6hlst
cR9YXDunaf+4hLgPnjJ1TsmWuMR9MZDbXanxeoTq+4LvZ1CwfkZC3A/uGeNq
llLKJ/TD9HDEB5l1j2h9/th6thm63tBD+f2RE+619Juii3gA3h2MYUwutpI/
AK273UXDBcPEA5F4cUj/j9Fi4oFY75fpXbl7g+oHIUgnq/zRqx8ofxB+TQ3e
eOhoT342eAV9R+LZndsabBzWyeoyseileDaej7rKTXi0nzI2xMb8QsPmavIH
4yJTfvdxOMUjGPVn9JsCFDRvwmBU/6nxl6W0m/zBUH/pbXPnqJTWx4FTo3Tv
CacC8nOQ7BmcJvqS4oUcWK/zKp2XaD5lb+IH2wa07inPExcOsb2fRz2/Q34u
lm8HiaayRsjPxQjTuZRbOkZ+Lv423opz3tVG/hDk1WXulAe2kD8Etm1l/lmn
lPMQgoWktpN2cpo/WQhWWDMR9l7EGTysdZRLXiZ0bXPw8H6gtOhtQ+U88mDI
9NihKqd5lPEw86C55tYY1WOEYkDbZTw9WVk/FO8wMlXC45XzGgqBmVWhrV8r
+UNh9WSsN0pvgPrHx5C6UBwzQ/0BHx1TwvxNwwqqz4fG+Nl/K3V/pvXz4bDv
x1g3hwXyh8Fm6/vZxAHqB8Jw/lBS24S+L9UPQ8jW4KiLG51HWRh6Uthul5aV
/yMBvtIt73DNFtP3C/Bt7fnwNcGk83/CV/oX
           "]]}}, {}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"\[Times]1 lag\"", TraditionalForm], 
         FormBox["\"acf of L24993\"", TraditionalForm]},
       AxesOrigin->{0, 0},
       Method->{},
       PlotRange->{All, All},
       PlotRangeClipping->True,
       PlotRangePadding->{Automatic, Automatic}], {583.2, -1090.2119561548143`},
       ImageScaled[{0.5, 0.5}], {360.00000000000006`, 222.49223594996215`}], 
     InsetBox[
      GraphicsBox[{{}, {{}, {}, 
         {RGBColor[0.24720000000000014`, 0.24, 0.6], LineBox[CompressedData["
1:eJw1lHtUk3Uch9fM4EiAAsfIyFARKVBghMT9A+PiYFw22LiIQSAdCo3gSCCa
vKJAoojUAVfh4RgYcomAQC6euQFjCgkyAzcuoolxS8TIP+AIXfnuPWdn59nz
Pu/7e9/3+25bfIowkc1isRL//fz3vbY98/z7/23Bk35AkIttX4HZFWJdeE/3
XtUVDhJvRMJc2BvtfVJiE+zJepxQW91FbAo7MWe9JVtFbIbfY1slJ1KUxOZg
7x2rqBNfJt6OGraUs6VR6y1gszMvM7z6KrElSiRxsk/nfia2wo6X43e4ptcT
v4NNMcpCi50/EdsgnzHq55e2Eu+BuXr6muK374jtcKre9aS9TguxPcbyBbas
m8myNebArvntz8d5Wu+AfslnsY0Z3xO/C15RbuHusDza3xELk/NRp5JaiPeC
sbXttmgtJnbC+yWOLY9cpMTvgZuTz3q6WkvsDGvDmKHTDs3ELjDtvithjdQQ
u0IjV5SYGHURu+HpmH3uIeYOsTvc9dQHS9gMrc8DzlGKQ8dGS8l7wivN0Hrd
RDYxsEH8RcMr+nQ+Bigvdi8r17tB3gsaqzqNoZ/WeyE+T3XMxKCNju+NmD/Y
w1O5N9aY8UaiJlsnabmCei4wvFVtM/sN9VwokpouO2d1kvdBf0llhm3HAPU+
8Be7xn84dJ28Lz5ab20QVKAg7wt1g/pM6VdN5P1gsUlmejxSQsf3w5n6QQun
VDmtzx/7xxsmRha+pt4fp+1fv+k50kh+H3wTrHtqzmmPvw93StIPW8ZUkOdh
f9G6LseUPvI8SJNFnlKO9voCcN+8u7LqKM0bE4CcE0mz10O6qQ8Ez3FFEiul
eWYCYd3m0akqu02ej9ly+0XT4F5aPx8LF3xuGc83kQ/Cs1Edl4Pcs+SDYHwr
4qyI30k+GFXKk2584w7ywViMq0v+UyWn9YVgqTjnzVzRbfIhEDrdv5jn3UY+
FJJHQXF/hbavMUIRM6Zod+jupv1DcSn2E9GAr3KN5aFIC+ea9UL7/ASYrXx+
pWlXH/UC2B2tfrLkp6BeAB/1+EZVUA/1AmREp21PHVRRL4R+bt3zphkN9UL0
ZBaOPzB7SL0QWXwnN/3yQeqFePjxKmqnh6gPg5l6+UC+AV0fwrBFqtuU2Ufv
BxOGLsVb3ivDY9SHoTr/2iWDB9r5Coey/MXmI/wR6sOBIr3zvtHD1IeDfW6u
2WD0HvXhOC5xf2nVXXv9IhyZmizeEEj3EyJs1Ygcs3eRZ0RgfIftdgseUy9C
/48Frz45X0e9GPwXM8oQKxn1YggGdcYvzFTRvIjBSZVOfHnvF+rFyDAynuQt
0/NmReCAn25PwJj2/kWg41eVB3uF5ouJwMVvo92K++n/Sx6BAY1p5Gtld6mP
xGSqzGypgd4HRKIyYKluMUs7j5FI4abHxHLofsoj8YFx6uFYp1GavyhsdhPP
K6fUdP4oDP1gWM8ES2X/ACVx+TU=
           "]]}}, {}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"\[Times]1 lag\"", TraditionalForm], 
         FormBox["\"acf of L49985\"", TraditionalForm]},
       AxesOrigin->{0, 0},
       Method->{},
       PlotRange->{All, All},
       PlotRangeClipping->True,
       PlotRangePadding->{Automatic, Automatic}], {972., -1090.2119561548143`},
       ImageScaled[{0.5, 0.5}], {360., 222.49223594996215`}], 
     TagBox[
      InsetBox["", {1360.8000000000002`, -1090.2119561548143`}, {
       Center, Center}, {359.9999999999998, 222.49223594996215`}],
      "InsetString"]}, {InsetBox[
      GraphicsBox[{{
         {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
          EdgeForm[Opacity[0.6579999999999999]], {}, 
          {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
           EdgeForm[Opacity[0.6579999999999999]], 
           TagBox[
            TooltipBox[
             TagBox[
              DynamicBox[{
                FEPrivate`If[
                 CurrentValue["MouseOver"], 
                 EdgeForm[{
                   GrayLevel[0.5], 
                   AbsoluteThickness[1.5], 
                   Opacity[0.66]}], {}, {}], 
                RectangleBox[{0., 0}, 
                 NCache[{2., 
                   Rational[1, 11]}, {2., 0.09090909090909091}], 
                 "RoundingRadius" -> 0]},
               
               ImageSizeCache->{{32.86067977499803, 
                51.445627404910525`}, {-50.90192981379158, \
-18.45930285703895}}],
              StatusArea[#, 0.09090909090909091]& ,
              TagBoxNote->"0.09090909090909091"],
             StyleBox["0.09090909090909091`", {
               GrayLevel[0]}, StripOnInput -> False]],
            Annotation[#, 
             Style[0.09090909090909091, {
               GrayLevel[0]}], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             TagBox[
              DynamicBox[{
                FEPrivate`If[
                 CurrentValue["MouseOver"], 
                 EdgeForm[{
                   GrayLevel[0.5], 
                   AbsoluteThickness[1.5], 
                   Opacity[0.66]}], {}, {}], 
                RectangleBox[{2., 0}, 
                 NCache[{4., 
                   Rational[13, 55]}, {4., 0.23636363636363636`}], 
                 "RoundingRadius" -> 0]},
               
               ImageSizeCache->{{50.445627404910525`, 
                69.03057503482302}, {-101.21013294459581`, \
-18.45930285703895}}],
              StatusArea[#, 0.23636363636363636`]& ,
              TagBoxNote->"0.23636363636363636"],
             StyleBox["0.23636363636363636`", {
               GrayLevel[0]}, StripOnInput -> False]],
            Annotation[#, 
             Style[0.23636363636363636`, {
               GrayLevel[0]}], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             TagBox[
              DynamicBox[{
                FEPrivate`If[
                 CurrentValue["MouseOver"], 
                 EdgeForm[{
                   GrayLevel[0.5], 
                   AbsoluteThickness[1.5], 
                   Opacity[0.66]}], {}, {}], 
                RectangleBox[{4., 0}, 
                 NCache[{6., 
                   Rational[6, 55]}, {6., 0.10909090909090909`}], 
                 "RoundingRadius" -> 0]},
               
               ImageSizeCache->{{68.03057503482302, 
                86.6155226647355}, {-57.19045520514209, -18.45930285703895}}],
              StatusArea[#, 0.10909090909090909`]& ,
              TagBoxNote->"0.10909090909090909"],
             StyleBox["0.10909090909090909`", {
               GrayLevel[0]}, StripOnInput -> False]],
            Annotation[#, 
             Style[0.10909090909090909`, {
               GrayLevel[0]}], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             TagBox[
              DynamicBox[{
                FEPrivate`If[
                 CurrentValue["MouseOver"], 
                 EdgeForm[{
                   GrayLevel[0.5], 
                   AbsoluteThickness[1.5], 
                   Opacity[0.66]}], {}, {}], 
                RectangleBox[{6., 0}, 
                 NCache[{8., 
                   Rational[2, 55]}, {8., 0.03636363636363636}], 
                 "RoundingRadius" -> 0]},
               
               ImageSizeCache->{{85.6155226647355, 
                104.20047029464799`}, {-32.036353639740014`, \
-18.45930285703895}}],
              StatusArea[#, 0.03636363636363636]& ,
              TagBoxNote->"0.03636363636363636"],
             StyleBox["0.03636363636363636`", {
               GrayLevel[0]}, StripOnInput -> False]],
            Annotation[#, 
             Style[0.03636363636363636, {
               GrayLevel[0]}], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             TagBox[
              DynamicBox[{
                FEPrivate`If[
                 CurrentValue["MouseOver"], 
                 EdgeForm[{
                   GrayLevel[0.5], 
                   AbsoluteThickness[1.5], 
                   Opacity[0.66]}], {}, {}], 
                RectangleBox[{8., 0}, 
                 NCache[{10., 
                   Rational[1, 44]}, {10., 0.022727272727272728`}], 
                 "RoundingRadius" -> 0]},
               
               ImageSizeCache->{{103.20047029464799`, 
                121.78541792456048`}, {-27.319959596227136`, \
-18.45930285703895}}],
              StatusArea[#, 0.022727272727272728`]& ,
              TagBoxNote->"0.022727272727272728"],
             StyleBox["0.022727272727272728`", {
               GrayLevel[0]}, StripOnInput -> False]],
            Annotation[#, 
             Style[0.022727272727272728`, {
               GrayLevel[0]}], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             TagBox[
              DynamicBox[{
                FEPrivate`If[
                 CurrentValue["MouseOver"], 
                 EdgeForm[{
                   GrayLevel[0.5], 
                   AbsoluteThickness[1.5], 
                   Opacity[0.66]}], {}, {}], 
                RectangleBox[{12., 0}, 
                 NCache[{14., 
                   Rational[1, 220]}, {14., 0.004545454545454545}], 
                 "RoundingRadius" -> 0]},
               
               ImageSizeCache->{{138.37036555447295`, 
                156.95531318438543`}, {-21.031434204876575`, \
-18.45930285703895}}],
              StatusArea[#, 0.004545454545454545]& ,
              TagBoxNote->"0.004545454545454545"],
             StyleBox["0.004545454545454545`", {
               GrayLevel[0]}, StripOnInput -> False]],
            Annotation[#, 
             Style[0.004545454545454545, {
               GrayLevel[0]}], "Tooltip"]& ]}, {}, {}}, {{}, 
          GraphicsComplexBox[{{5.657936507936508, 0.}, {5.657936507936508, 
           0.}, {5.657936507936508, 0.}, {5.657936507936508, 0.}}, {
            {RGBColor[1, 0, 0], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->25], 3], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->25], 4]}, {}}], {}}}, {{}, {}, 
         {RGBColor[1, 0, 0], Thickness[Large], LineBox[CompressedData["
1:eJwVl3c81f8Xx6lkc+81S2Rnd0nZn/O2S5G4ZpS9CqWigawyklFCyqhUojK/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           "]]}}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->{True, True},
       AxesLabel->{
         FormBox["\"L1\"", TraditionalForm], 
         FormBox["\"pdf\"", TraditionalForm]},
       AxesOrigin->{0., 0},
       FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
       GridLines->{None, None},
       LabelStyle->Medium,
       PlotRange->All,
       PlotRangePadding->{{
          Scaled[0.02], 
          Scaled[0.02]}, {
          Scaled[0.02], 
          Scaled[0.1]}},
       Ticks->{Automatic, Automatic}], {194.4, -1332.4812797447732`}, 
      ImageScaled[{0.5, 0.5}], {360.00000000000006`, 222.49223594996192`}], 
     InsetBox[
      GraphicsBox[{{
         {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
          EdgeForm[Opacity[0.637]], {}, 
          {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
           EdgeForm[Opacity[0.637]], 
           TagBox[
            TooltipBox[
             TagBox[
              DynamicBox[{
                FEPrivate`If[
                 CurrentValue["MouseOver"], 
                 EdgeForm[{
                   GrayLevel[0.5], 
                   AbsoluteThickness[1.5], 
                   Opacity[0.66]}], {}, {}], 
                RectangleBox[{0., 0}, 
                 NCache[{2., 
                   Rational[1, 110]}, {2., 0.00909090909090909}], 
                 "RoundingRadius" -> 0]},
               
               ImageSizeCache->{{23.5, 
                39.958862790399195`}, {-24.767559807933083`, \
-20.09049246328516}}],
              StatusArea[#, 0.00909090909090909]& ,
              TagBoxNote->"0.00909090909090909"],
             StyleBox["0.00909090909090909`", {
               GrayLevel[0]}, StripOnInput -> False]],
            Annotation[#, 
             Style[0.00909090909090909, {
               GrayLevel[0]}], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             TagBox[
              DynamicBox[{
                FEPrivate`If[
                 CurrentValue["MouseOver"], 
                 EdgeForm[{
                   GrayLevel[0.5], 
                   AbsoluteThickness[1.5], 
                   Opacity[0.66]}], {}, {}], 
                RectangleBox[{2., 0}, 
                 NCache[{4., 
                   Rational[21, 220]}, {4., 0.09545454545454546}], 
                 "RoundingRadius" -> 0]},
               
               ImageSizeCache->{{38.958862790399195`, 
                55.41772558079836}, {-59.699699582088556`, \
-20.09049246328516}}],
              StatusArea[#, 0.09545454545454546]& ,
              TagBoxNote->"0.09545454545454546"],
             StyleBox["0.09545454545454546`", {
               GrayLevel[0]}, StripOnInput -> False]],
            Annotation[#, 
             Style[0.09545454545454546, {
               GrayLevel[0]}], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             TagBox[
              DynamicBox[{
                FEPrivate`If[
                 CurrentValue["MouseOver"], 
                 EdgeForm[{
                   GrayLevel[0.5], 
                   AbsoluteThickness[1.5], 
                   Opacity[0.66]}], {}, {}], 
                RectangleBox[{4., 0}, 
                 NCache[{6., 
                   Rational[31, 220]}, {6., 0.1409090909090909}], 
                 "RoundingRadius" -> 0]},
               
               ImageSizeCache->{{54.41772558079836, 
                70.87658837119756}, {-78.08503630532823, -20.09049246328516}}],
              StatusArea[#, 0.1409090909090909]& ,
              TagBoxNote->"0.1409090909090909"],
             StyleBox["0.1409090909090909`", {
               GrayLevel[0]}, StripOnInput -> False]],
            Annotation[#, 
             Style[0.1409090909090909, {
               GrayLevel[0]}], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             TagBox[
              DynamicBox[{
                FEPrivate`If[
                 CurrentValue["MouseOver"], 
                 EdgeForm[{
                   GrayLevel[0.5], 
                   AbsoluteThickness[1.5], 
                   Opacity[0.66]}], {}, {}], 
                RectangleBox[{6., 0}, 
                 NCache[{8., 
                   Rational[9, 110]}, {8., 0.08181818181818182}], 
                 "RoundingRadius" -> 0]},
               
               ImageSizeCache->{{69.87658837119756, 
                86.33545116159675}, {-54.18409856511664, -20.09049246328516}}],
              StatusArea[#, 0.08181818181818182]& ,
              TagBoxNote->"0.08181818181818182"],
             StyleBox["0.08181818181818182`", {
               GrayLevel[0]}, StripOnInput -> False]],
            Annotation[#, 
             Style[0.08181818181818182, {
               GrayLevel[0]}], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             TagBox[
              DynamicBox[{
                FEPrivate`If[
                 CurrentValue["MouseOver"], 
                 EdgeForm[{
                   GrayLevel[0.5], 
                   AbsoluteThickness[1.5], 
                   Opacity[0.66]}], {}, {}], 
                RectangleBox[{8., 0}, 
                 NCache[{10., 
                   Rational[17, 220]}, {10., 0.07727272727272727}], 
                 "RoundingRadius" -> 0]},
               
               ImageSizeCache->{{85.33545116159675, 
                101.79431395199595`}, {-52.34556489279265, \
-20.09049246328516}}],
              StatusArea[#, 0.07727272727272727]& ,
              TagBoxNote->"0.07727272727272727"],
             StyleBox["0.07727272727272727`", {
               GrayLevel[0]}, StripOnInput -> False]],
            Annotation[#, 
             Style[0.07727272727272727, {
               GrayLevel[0]}], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             TagBox[
              DynamicBox[{
                FEPrivate`If[
                 CurrentValue["MouseOver"], 
                 EdgeForm[{
                   GrayLevel[0.5], 
                   AbsoluteThickness[1.5], 
                   Opacity[0.66]}], {}, {}], 
                RectangleBox[{10., 0}, 
                 NCache[{12., 
                   Rational[3, 55]}, {12., 0.05454545454545454}], 
                 "RoundingRadius" -> 0]},
               
               ImageSizeCache->{{100.79431395199595`, 
                117.25317674239511`}, {-43.152896531172814`, \
-20.09049246328516}}],
              StatusArea[#, 0.05454545454545454]& ,
              TagBoxNote->"0.05454545454545454"],
             StyleBox["0.05454545454545454`", {
               GrayLevel[0]}, StripOnInput -> False]],
            Annotation[#, 
             Style[0.05454545454545454, {
               GrayLevel[0]}], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             TagBox[
              DynamicBox[{
                FEPrivate`If[
                 CurrentValue["MouseOver"], 
                 EdgeForm[{
                   GrayLevel[0.5], 
                   AbsoluteThickness[1.5], 
                   Opacity[0.66]}], {}, {}], 
                RectangleBox[{12., 0}, 
                 NCache[{14., 
                   Rational[1, 55]}, {14., 0.01818181818181818}], 
                 "RoundingRadius" -> 0]},
               
               ImageSizeCache->{{116.25317674239511`, 
                132.71203953279434`}, {-28.444627152581063`, \
-20.09049246328516}}],
              StatusArea[#, 0.01818181818181818]& ,
              TagBoxNote->"0.01818181818181818"],
             StyleBox["0.01818181818181818`", {
               GrayLevel[0]}, StripOnInput -> False]],
            Annotation[#, 
             Style[0.01818181818181818, {
               GrayLevel[0]}], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             TagBox[
              DynamicBox[{
                FEPrivate`If[
                 CurrentValue["MouseOver"], 
                 EdgeForm[{
                   GrayLevel[0.5], 
                   AbsoluteThickness[1.5], 
                   Opacity[0.66]}], {}, {}], 
                RectangleBox[{14., 0}, 
                 NCache[{16., 
                   Rational[1, 55]}, {16., 0.01818181818181818}], 
                 "RoundingRadius" -> 0]},
               
               ImageSizeCache->{{131.71203953279434`, 
                148.1709023231935}, {-28.444627152581063`, \
-20.09049246328516}}],
              StatusArea[#, 0.01818181818181818]& ,
              TagBoxNote->"0.01818181818181818"],
             StyleBox["0.01818181818181818`", {
               GrayLevel[0]}, StripOnInput -> False]],
            Annotation[#, 
             Style[0.01818181818181818, {
               GrayLevel[0]}], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             TagBox[
              DynamicBox[{
                FEPrivate`If[
                 CurrentValue["MouseOver"], 
                 EdgeForm[{
                   GrayLevel[0.5], 
                   AbsoluteThickness[1.5], 
                   Opacity[0.66]}], {}, {}], 
                RectangleBox[{16., 0}, 
                 NCache[{18., 
                   Rational[1, 220]}, {18., 0.004545454545454545}], 
                 "RoundingRadius" -> 0]},
               
               ImageSizeCache->{{147.1709023231935, 
                163.62976511359267`}, {-22.92902613560915, \
-20.09049246328516}}],
              StatusArea[#, 0.004545454545454545]& ,
              TagBoxNote->"0.004545454545454545"],
             StyleBox["0.004545454545454545`", {
               GrayLevel[0]}, StripOnInput -> False]],
            Annotation[#, 
             Style[0.004545454545454545, {
               GrayLevel[0]}], "Tooltip"]& ]}, {}, {}}, {{}, 
          GraphicsComplexBox[{{5.657936507936508, 0.}, {5.657936507936508, 
           0.}, {5.657936507936508, 0.}, {5.657936507936508, 0.}}, {
            {RGBColor[1, 0, 0], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->25], 3], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->25], 4]}, {}}], {}}}, {{}, {}, 
         {RGBColor[1, 0, 0], Thickness[Large], LineBox[CompressedData["
1:eJwVl3c81f8Xx6lkc+81S2Rnd0nZn/O2S5G4ZpS9CqWigawyklFCyqhUojK/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           "]]}}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->{True, True},
       AxesLabel->{
         FormBox["\"L24993\"", TraditionalForm], 
         FormBox["\"pdf\"", TraditionalForm]},
       AxesOrigin->{0., 0},
       FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
       GridLines->{None, None},
       LabelStyle->Medium,
       PlotRange->All,
       PlotRangePadding->{{
          Scaled[0.02], 
          Scaled[0.02]}, {
          Scaled[0.02], 
          Scaled[0.1]}},
       Ticks->{Automatic, Automatic}], {583.2, -1332.4812797447732`}, 
      ImageScaled[{0.5, 0.5}], {360.00000000000006`, 222.49223594996192`}], 
     InsetBox[
      GraphicsBox[{{
         {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
          EdgeForm[Opacity[0.637]], {}, 
          {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
           EdgeForm[Opacity[0.637]], 
           TagBox[
            TooltipBox[
             TagBox[
              DynamicBox[{
                FEPrivate`If[
                 CurrentValue["MouseOver"], 
                 EdgeForm[{
                   GrayLevel[0.5], 
                   AbsoluteThickness[1.5], 
                   Opacity[0.66]}], {}, {}], 
                RectangleBox[{1., 0}, 
                 NCache[{2., 
                   Rational[3, 55]}, {2., 0.05454545454545454}], 
                 "RoundingRadius" -> 0]},
               
               ImageSizeCache->{{25.256915299739262`, 
                35.04938929413379}, {-35.809468874550305`, \
-18.45930285703895}}],
              StatusArea[#, 0.05454545454545454]& ,
              TagBoxNote->"0.05454545454545454"],
             StyleBox["0.05454545454545454`", {
               GrayLevel[0]}, StripOnInput -> False]],
            Annotation[#, 
             Style[0.05454545454545454, {
               GrayLevel[0]}], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             TagBox[
              DynamicBox[{
                FEPrivate`If[
                 CurrentValue["MouseOver"], 
                 EdgeForm[{
                   GrayLevel[0.5], 
                   AbsoluteThickness[1.5], 
                   Opacity[0.66]}], {}, {}], 
                RectangleBox[{2., 0}, 
                 NCache[{3., 
                   Rational[13, 110]}, {3., 0.11818181818181818`}], 
                 "RoundingRadius" -> 0]},
               
               ImageSizeCache->{{34.04938929413379, 
                43.84186328852826}, {-54.884662561646905`, \
-18.45930285703895}}],
              StatusArea[#, 0.11818181818181818`]& ,
              TagBoxNote->"0.11818181818181818"],
             StyleBox["0.11818181818181818`", {
               GrayLevel[0]}, StripOnInput -> False]],
            Annotation[#, 
             Style[0.11818181818181818`, {
               GrayLevel[0]}], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             TagBox[
              DynamicBox[{
                FEPrivate`If[
                 CurrentValue["MouseOver"], 
                 EdgeForm[{
                   GrayLevel[0.5], 
                   AbsoluteThickness[1.5], 
                   Opacity[0.66]}], {}, {}], 
                RectangleBox[{3., 0}, 
                 NCache[{4., 
                   Rational[3, 11]}, {4., 0.2727272727272727}], 
                 "RoundingRadius" -> 0]},
               
               ImageSizeCache->{{42.84186328852826, 
                52.63433728292273}, {-101.21013294459581`, \
-18.45930285703895}}],
              StatusArea[#, 0.2727272727272727]& ,
              TagBoxNote->"0.2727272727272727"],
             StyleBox["0.2727272727272727`", {
               GrayLevel[0]}, StripOnInput -> False]],
            Annotation[#, 
             Style[0.2727272727272727, {
               GrayLevel[0]}], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             TagBox[
              DynamicBox[{
                FEPrivate`If[
                 CurrentValue["MouseOver"], 
                 EdgeForm[{
                   GrayLevel[0.5], 
                   AbsoluteThickness[1.5], 
                   Opacity[0.66]}], {}, {}], 
                RectangleBox[{4., 0}, 
                 NCache[{5., 
                   Rational[12, 55]}, {5., 0.21818181818181817`}], 
                 "RoundingRadius" -> 0]},
               
               ImageSizeCache->{{51.63433728292273, 
                61.426811277317256`}, {-84.85996692708443, \
-18.45930285703895}}],
              StatusArea[#, 0.21818181818181817`]& ,
              TagBoxNote->"0.21818181818181817"],
             StyleBox["0.21818181818181817`", {
               GrayLevel[0]}, StripOnInput -> False]],
            Annotation[#, 
             Style[0.21818181818181817`, {
               GrayLevel[0]}], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             TagBox[
              DynamicBox[{
                FEPrivate`If[
                 CurrentValue["MouseOver"], 
                 EdgeForm[{
                   GrayLevel[0.5], 
                   AbsoluteThickness[1.5], 
                   Opacity[0.66]}], {}, {}], 
                RectangleBox[{5., 0}, 
                 NCache[{6., 
                   Rational[3, 22]}, {6., 0.13636363636363635`}], 
                 "RoundingRadius" -> 0]},
               
               ImageSizeCache->{{60.426811277317256`, 
                70.21928527171173}, {-60.334717900817395`, \
-18.45930285703895}}],
              StatusArea[#, 0.13636363636363635`]& ,
              TagBoxNote->"0.13636363636363635"],
             StyleBox["0.13636363636363635`", {
               GrayLevel[0]}, StripOnInput -> False]],
            Annotation[#, 
             Style[0.13636363636363635`, {
               GrayLevel[0]}], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             TagBox[
              DynamicBox[{
                FEPrivate`If[
                 CurrentValue["MouseOver"], 
                 EdgeForm[{
                   GrayLevel[0.5], 
                   AbsoluteThickness[1.5], 
                   Opacity[0.66]}], {}, {}], 
                RectangleBox[{6., 0}, 
                 NCache[{7., 
                   Rational[7, 110]}, {7., 0.06363636363636363}], 
                 "RoundingRadius" -> 0]},
               
               ImageSizeCache->{{69.21928527171173, 
                79.01175926610625}, {-38.53449654413555, -18.45930285703895}}],
              StatusArea[#, 0.06363636363636363]& ,
              TagBoxNote->"0.06363636363636363"],
             StyleBox["0.06363636363636363`", {
               GrayLevel[0]}, StripOnInput -> False]],
            Annotation[#, 
             Style[0.06363636363636363, {
               GrayLevel[0]}], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             TagBox[
              DynamicBox[{
                FEPrivate`If[
                 CurrentValue["MouseOver"], 
                 EdgeForm[{
                   GrayLevel[0.5], 
                   AbsoluteThickness[1.5], 
                   Opacity[0.66]}], {}, {}], 
                RectangleBox[{7., 0}, 
                 NCache[{8., 
                   Rational[1, 22]}, {8., 0.045454545454545456`}], 
                 "RoundingRadius" -> 0]},
               
               ImageSizeCache->{{78.01175926610625, 
                87.80423326050072}, {-33.08444120496512, -18.45930285703895}}],
              StatusArea[#, 0.045454545454545456`]& ,
              TagBoxNote->"0.045454545454545456"],
             StyleBox["0.045454545454545456`", {
               GrayLevel[0]}, StripOnInput -> False]],
            Annotation[#, 
             Style[0.045454545454545456`, {
               GrayLevel[0]}], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             TagBox[
              DynamicBox[{
                FEPrivate`If[
                 CurrentValue["MouseOver"], 
                 EdgeForm[{
                   GrayLevel[0.5], 
                   AbsoluteThickness[1.5], 
                   Opacity[0.66]}], {}, {}], 
                RectangleBox[{8., 0}, 
                 NCache[{9., 
                   Rational[9, 110]}, {9., 0.08181818181818182}], 
                 "RoundingRadius" -> 0]},
               
               ImageSizeCache->{{86.80423326050072, 
                96.59670725489525}, {-43.98455188330598, -18.45930285703895}}],
              StatusArea[#, 0.08181818181818182]& ,
              TagBoxNote->"0.08181818181818182"],
             StyleBox["0.08181818181818182`", {
               GrayLevel[0]}, StripOnInput -> False]],
            Annotation[#, 
             Style[0.08181818181818182, {
               GrayLevel[0]}], "Tooltip"]& ], 
           TagBox[
            TooltipBox[
             TagBox[
              DynamicBox[{
                FEPrivate`If[
                 CurrentValue["MouseOver"], 
                 EdgeForm[{
                   GrayLevel[0.5], 
                   AbsoluteThickness[1.5], 
                   Opacity[0.66]}], {}, {}], 
                RectangleBox[{10., 0}, 
                 NCache[{11., 
                   Rational[1, 110]}, {11., 0.00909090909090909}], 
                 "RoundingRadius" -> 0]},
               
               ImageSizeCache->{{104.38918124928972`, 
                114.18165524368419`}, {-22.184330526624194`, \
-18.45930285703895}}],
              StatusArea[#, 0.00909090909090909]& ,
              TagBoxNote->"0.00909090909090909"],
             StyleBox["0.00909090909090909`", {
               GrayLevel[0]}, StripOnInput -> False]],
            Annotation[#, 
             Style[0.00909090909090909, {
               GrayLevel[0]}], "Tooltip"]& ]}, {}, {}}, {{}, 
          GraphicsComplexBox[{{5.657936507936508, 0.}, {5.657936507936508, 
           0.}, {5.657936507936508, 0.}, {5.657936507936508, 0.}}, {
            {RGBColor[1, 0, 0], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->25], 3], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->25], 4]}, {}}], {}}}, {{}, {}, 
         {RGBColor[1, 0, 0], Thickness[Large], LineBox[CompressedData["
1:eJwVl3c81f8Xx6lkc+81S2Rnd0nZn/O2S5G4ZpS9CqWigawyklFCyqhUojK/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           "]]}}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->{True, True},
       AxesLabel->{
         FormBox["\"L49985\"", TraditionalForm], 
         FormBox["\"pdf\"", TraditionalForm]},
       AxesOrigin->{1., 0},
       FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
       GridLines->{None, None},
       LabelStyle->Medium,
       PlotRange->All,
       PlotRangePadding->{{
          Scaled[0.02], 
          Scaled[0.02]}, {
          Scaled[0.02], 
          Scaled[0.1]}},
       Ticks->{Automatic, Automatic}], {972., -1332.4812797447732`}, 
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996192`}], 
     TagBox[
      InsetBox["", {1360.8000000000002`, -1332.4812797447732`}, {
       Center, Center}, {359.9999999999998, 222.49223594996192`}],
      "InsetString"]}, {InsetBox[
      GraphicsBox[{{{{}, {}, 
          {GrayLevel[0], Thickness[Large], LineBox[CompressedData["
1:eJwVV3k81O8Td3RIzsqZW650WMeSa8aydlV0OJJc0SoquQuRr6yVc7E5djdR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            "]]}}, {{}, {}, 
          {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
           LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQrdT/d/E8uY12ImAwxf7UxNuFL9Lv28P4XnvZ/Z6l
v4fzz/KacbLEMjjA+E79rgeW+3PA+an6v3gNeQXgfF/N1I9i7iJw/qYrtaUn
LSTgfGshrfUs9TJwfvrvSXOXRijA+fnHnhuv91WC87ui2FT/5qjA+cnHq9MM
M9Tg/IPskoHZkRpwvqFgw7SXJVpwfsJnWx2/HB04f+G8ozLfe/Xg/M19Vrcv
BRnA+SW7bAPm+hjC+ftPLf3UGW0E52e6W+7NjDCG8+esMNyanWUC50/8vLex
oNwUzn+2qrQso8gMzj/iNmlGU5M5nM/of+tRf4MFnM/guI1xQaUlnN8h/t33
UrsVnF8QlXzoe7M1nP+w0STFfqoNnC8yeeatzoW2cP4yAa3K47PtEOFVJO+q
vtoezp+nsEDGNsQBzt9b84sh4wKCr+jN/kc53BHO33Jes/vmFQS/59g/A4VY
Jzh/cvHLrIQ7CH6NqBy/UqQznL9Sk/VUyQMEn+0Lo+TBOBc4f7nBxrp5zxF8
zaRVfn9zXeH82547N4W+RvAvLa7StS92g/N/bA60UfqE4P/fUbS1Lc8dzvc2
cHOt+YrgH4/Vz8wu9oDzrdgDNmzdieCv21Dw/f9/BB8AFP/2Og==
            "]]}}}, {{}, GraphicsComplexBox[CompressedData["
1:eJzt04krhEEUAPBtQ3KHkJC7FdK6Fotd1pljc5W0SRsld0JCciRJkuQOyZVC
kiRJjkW7SpKSkJAkSWySUGYm3mv9C3bq6+vXNzPfezPvOclLU/O4HA6ngTz0
3dFXYt68oRJxfob+rF1WrvAGPDhAxzPY+vTgLe1GR/zruKsay/lYc7Hmekfw
9itP1tnkBE6Wm2UGL7mA2yJybg/lruDiu4+Z5yN0ooDOcAd7Lw4/Te/ywL2S
9qK7Wg9w9mq8EbfQC+xy9l5fsOYDlnVuvfLO+X/2R4+Q3RMEvmAWzhx6Wf11
XH2PZvvL/MCtVuSAutFdj3WigBG0CU1gzx8cRcL/UKLd9Bp7JIWB4H56PQYC
MP3cboRm8XWg2f/Cg8B+dKiDwcqq9VFb0xDwpmosetkCzc5Hhr535+vPnqP3
yXR1mBBMLv+qJh2dTwPIQBesVXTbKNCXUlJx5aHg1BWHloeUcM38itAsP2MR
mBbr2A6aFNul1F4MptfvOY3+JMuTrtGsPg0jwGEGJ+Nlw2i2/yRaSAN2iASz
8teVgKeGFI4LvugLV5JBGrqWHpAKHUnK3fkMzfJ7jAKzfnlBs/i50WBWr3lo
T1Zw6FKaAD8GPFFGM4zVzK8yDqztf23/a/v///b/N7160e0=
          "], {
           {GrayLevel[0], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 65], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 66], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 67], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 68], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 69], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 70], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 71], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 72], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 73], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 74], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 75], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 76], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 77], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 78], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 79], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 80], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 81], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 82], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 83], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 84], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 85], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 86], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 87], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 88], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 89], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 90], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 91], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 92], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 93], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 94], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 95], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 96], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 97], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 98], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 99], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 100], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 101], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 102], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 103], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 104], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 105], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 106], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 107], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 108], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 109], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 110], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 111], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 112], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 113], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 114], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 115], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 116], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 117], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 118], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 119], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 120], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 121], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 122], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 123], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 124], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 125], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 126], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 127], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 128]}, {}}], {}}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"kbp\"", TraditionalForm], 
         FormBox["\"pdf\"", TraditionalForm]},
       AxesOrigin->{0, 0.},
       Method->{},
       PlotRange->{All, All},
       PlotRangeClipping->True,
       PlotRangePadding->None], {194.4, -1574.750603334732}, 
      ImageScaled[{0.5, 0.5}], {360.00000000000006`, 222.49223594996192`}], 
     InsetBox[
      GraphicsBox[{{{{}, GraphicsComplexBox[CompressedData["
1:eJztlvlTU1cUx8PShEbQRBYTwIXFEovKJoiEJAdZEgQUcMFStAXRaoqKFJQC
RbEDETfGyuJSRIu4dCyjgpRB0OpkFKkrdKDooDKUoS4UAYFaCvbd+5x3nP4N
eb9kPnNz7jv3e7/nvOOQsDl6rTGPxzM14vHI75yLpX2nb/Sorruk7zuW/iH8
EFwzOPbba1XryqyrITcEQJfDhjiOrp2W+yLKAiaZjNpqu/nwV5bKe3WdCJ4n
v93rJhbAlPa7I0vXiMFdHf77HncBsPsjm52zj02UW3Lcfd/x0Ztxey7eizyD
DhAWqd8+1sKHJ0v2lWz6zhGyTH+U22v5sDhBtHJB9UwwGy1KSHHgg+mKiXMu
TnXhuFLdmWG1yRVydz7e9WmGAK6U2bp1/OEKGv7PQZeyBfC9fsb5FNlciK7Q
nV7cIIRF5sauumF3cK5+8FPPBRFsnvztL01GHhzTfA56gPGlK7+6JdnAzbD5
+QFPPaA3YiDrnJ0tm9+ABzz9Wq+43C9l13meHE8kAgg8uf8z4tVOm4l85gYJ
QNbZEAExnjls49ZsXP/3bH9zxE7ktvJkhbAE+VrTieCaKuRZcQXXh/5EVgiZ
iDHk4sA9ST12Xtz7NvaMnu33RI5kjjc5EPklk35uGPKd28wTjtxVcVQ/IxKZ
6hmP7NbhzM9JQ2Zuq1J9zQvmhR5tf9UqhQO9jKEeIzs9epOt9Z8HDwtydKVf
SEFDAnTI5PpL782D3WlqzQGdBFyJgFO8wbd2a3GDTMLqt9obfN5x2kGJ6YpK
by7+JCNfm4kPF39oE5OwEJlRZ/SsGJn6wRJ54eeMg+2QSTWEhvtAX1DqooYa
Keu/RGR+ThGjODLVKxnZihi4EHk9EaQI+Z9sbX1qCzKtv4fIpHrTZ83n9KX5
zEZm3CCL24xMqqnRxpdjWq/rfKHfc8uOck8J69/TyLR83/pyelK9tAs4DiKC
5SMT+a+UIdN6q0G+N7K0q+IyMtsvkI3Jhc71g9l9q59EeUtgWMYYerkfp3ei
nFQgMm1Ph5BpPVUh14UyCdz0A/8N1RtlyVIg5SGzl0NudF7oungp0OtxQab5
hCC/ZuR99h5Tv8XIuf3ofWTI4Zv6HeHaGCnQ9Pbj/6k+t+RgYhbRG8/0E7bf
IocQlPjD3gvq+vENNnDkMPN8gtwSwTTAw/5Qans/87iNDZt/PTLVtxV5nEn3
I7EChl/GjgQMW7N+jlJw6y4epCMjf0UM9xlyJjUkxtP1MgVcXeOoH+2yBhp+
EpnW27gCjn/ptLU0xRoGmpmEJUqOqX9UyNQf7/F00iCzlbA89eP2qYnWQNt9
oxJinD07PrC2Zvv/MhVofLYldHdbwfkUJqE4ZPp9yUSm99OmgjwrpYtTvJjV
wwg4pv2wAcAyLqbTfNCC3V+PTNphsyIAgiyOKFfpLNjzKZFpPS0JgPXP84oW
pluw+z8IhFdN9kaPUwVAys88Ogjqru9fL4gVsvWfFQyDLwrS6v4Wsu9zDoFT
nU3H7JQTWH88C4GSpKo1Z0omwTLaINTQpC9oNnsiend+NUQmJ20JKhSz+u5S
w3bTnFUTdotZvWqRHahAauicclemNRZDfgBpWBoo3xZ1R3RbBEx3PhFcrIGR
Wy+GOtaK2O/nuAZyCvNPrbITg2E+MMwHhvnAMB8Y5gPDfGCYDwzzwf/ng/8A
2HH7Pw==
           "], {
            {GrayLevel[0.65], {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 131], {
               LineBox[{{0.743, 9.880899300780758}, {0.743, 
                1.2705931396171564`}}], 
               LineBox[{
                Offset[{1.5, 0}, {0.743, 9.880899300780758}], 
                 Offset[{-1.5, 0}, {0.743, 9.880899300780758}]}], 
               LineBox[{
                Offset[{1.5, 0}, {0.743, 1.2705931396171564`}], 
                 Offset[{-1.5, 0}, {0.743, 1.2705931396171564`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 132], {
               LineBox[{{1.302, 9.880899300780758}, {1.302, 
                1.2413019883167435`}}], 
               LineBox[{
                Offset[{1.5, 0}, {1.302, 9.880899300780758}], 
                 Offset[{-1.5, 0}, {1.302, 9.880899300780758}]}], 
               LineBox[{
                Offset[{1.5, 0}, {1.302, 1.2413019883167435`}], 
                 Offset[{-1.5, 0}, {1.302, 1.2413019883167435`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 133], {
               LineBox[{{1.331, 9.880899300780758}, {1.331, 
                1.2413019883167435`}}], 
               LineBox[{
                Offset[{1.5, 0}, {1.331, 9.880899300780758}], 
                 Offset[{-1.5, 0}, {1.331, 9.880899300780758}]}], 
               LineBox[{
                Offset[{1.5, 0}, {1.331, 1.2413019883167435`}], 
                 Offset[{-1.5, 0}, {1.331, 1.2413019883167435`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 134], {
               LineBox[{{3.665, 6.426750597338426}, {3.665, 
                1.2413019883167435`}}], 
               LineBox[{
                Offset[{1.5, 0}, {3.665, 6.426750597338426}], 
                 Offset[{-1.5, 0}, {3.665, 6.426750597338426}]}], 
               LineBox[{
                Offset[{1.5, 0}, {3.665, 1.2413019883167435`}], 
                 Offset[{-1.5, 0}, {3.665, 1.2413019883167435`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 135], {
               LineBox[{{4.182, 6.426750597338426}, {4.182, 
                1.2413019883167435`}}], 
               LineBox[{
                Offset[{1.5, 0}, {4.182, 6.426750597338426}], 
                 Offset[{-1.5, 0}, {4.182, 6.426750597338426}]}], 
               LineBox[{
                Offset[{1.5, 0}, {4.182, 1.2413019883167435`}], 
                 Offset[{-1.5, 0}, {4.182, 1.2413019883167435`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 136], {
               LineBox[{{4.347, 6.426750597338426}, {4.347, 
                1.2413019883167435`}}], 
               LineBox[{
                Offset[{1.5, 0}, {4.347, 6.426750597338426}], 
                 Offset[{-1.5, 0}, {4.347, 6.426750597338426}]}], 
               LineBox[{
                Offset[{1.5, 0}, {4.347, 1.2413019883167435`}], 
                 Offset[{-1.5, 0}, {4.347, 1.2413019883167435`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 137], {
               LineBox[{{4.444, 6.426750597338426}, {4.444, 
                1.2413019883167435`}}], 
               LineBox[{
                Offset[{1.5, 0}, {4.444, 6.426750597338426}], 
                 Offset[{-1.5, 0}, {4.444, 6.426750597338426}]}], 
               LineBox[{
                Offset[{1.5, 0}, {4.444, 1.2413019883167435`}], 
                 Offset[{-1.5, 0}, {4.444, 1.2413019883167435`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 138], {
               LineBox[{{4.808, 6.426750597338426}, {4.808, 
                1.2413019883167435`}}], 
               LineBox[{
                Offset[{1.5, 0}, {4.808, 6.426750597338426}], 
                 Offset[{-1.5, 0}, {4.808, 6.426750597338426}]}], 
               LineBox[{
                Offset[{1.5, 0}, {4.808, 1.2413019883167435`}], 
                 Offset[{-1.5, 0}, {4.808, 1.2413019883167435`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 139], {
               LineBox[{{7.249, 6.426750597338425}, {7.249, 
                1.0947203887883095`}}], 
               LineBox[{
                Offset[{1.5, 0}, {7.249, 6.426750597338425}], 
                 Offset[{-1.5, 0}, {7.249, 6.426750597338425}]}], 
               LineBox[{
                Offset[{1.5, 0}, {7.249, 1.0947203887883095`}], 
                 Offset[{-1.5, 0}, {7.249, 1.0947203887883095`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 140], {
               LineBox[{{8.975, 6.1465077448975745`}, {8.975, 
                1.0947203887883095`}}], 
               LineBox[{
                Offset[{1.5, 0}, {8.975, 6.1465077448975745`}], 
                 Offset[{-1.5, 0}, {8.975, 6.1465077448975745`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {8.975, 1.0947203887883095`}], 
                 Offset[{-1.5, 0}, {8.975, 1.0947203887883095`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 141], {
               LineBox[{{9.286, 6.1465077448975745`}, {9.286, 
                1.0947203887883095`}}], 
               LineBox[{
                Offset[{1.5, 0}, {9.286, 6.1465077448975745`}], 
                 Offset[{-1.5, 0}, {9.286, 6.1465077448975745`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {9.286, 1.0947203887883095`}], 
                 Offset[{-1.5, 0}, {9.286, 1.0947203887883095`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 142], {
               LineBox[{{10.852, 9.348788653909546}, {10.852, 
                1.0528331373431263`}}], 
               LineBox[{
                Offset[{1.5, 0}, {10.852, 9.348788653909546}], 
                 Offset[{-1.5, 0}, {10.852, 9.348788653909546}]}], 
               LineBox[{
                Offset[{1.5, 0}, {10.852, 1.0528331373431263`}], 
                 Offset[{-1.5, 0}, {10.852, 1.0528331373431263`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 143], {
               LineBox[{{11.558, 9.55711731363326}, {11.558, 
                1.0947203887883095`}}], 
               LineBox[{
                Offset[{1.5, 0}, {11.558, 9.55711731363326}], 
                 Offset[{-1.5, 0}, {11.558, 9.55711731363326}]}], 
               LineBox[{
                Offset[{1.5, 0}, {11.558, 1.0947203887883095`}], 
                 Offset[{-1.5, 0}, {11.558, 1.0947203887883095`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 144], {
               LineBox[{{13.715, 11.421825578908159`}, {13.715, 
                1.0947203887883095`}}], 
               LineBox[{
                Offset[{1.5, 0}, {13.715, 11.421825578908159`}], 
                 Offset[{-1.5, 0}, {13.715, 11.421825578908159`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {13.715, 1.0947203887883095`}], 
                 Offset[{-1.5, 0}, {13.715, 1.0947203887883095`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 145], {
               LineBox[{{13.947, 11.558660124896633`}, {13.947, 
                1.0947203887883095`}}], 
               LineBox[{
                Offset[{1.5, 0}, {13.947, 11.558660124896633`}], 
                 Offset[{-1.5, 0}, {13.947, 11.558660124896633`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {13.947, 1.0947203887883095`}], 
                 Offset[{-1.5, 0}, {13.947, 1.0947203887883095`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 146], {
               LineBox[{{15.079, 11.558660124896633`}, {15.079, 
                1.1759068869287206`}}], 
               LineBox[{
                Offset[{1.5, 0}, {15.079, 11.558660124896633`}], 
                 Offset[{-1.5, 0}, {15.079, 11.558660124896633`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {15.079, 1.1759068869287206`}], 
                 Offset[{-1.5, 0}, {15.079, 1.1759068869287206`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 147], {
               LineBox[{{16.963, 12.731143725881255`}, {16.963, 
                1.280423753160517}}], 
               LineBox[{
                Offset[{1.5, 0}, {16.963, 12.731143725881255`}], 
                 Offset[{-1.5, 0}, {16.963, 12.731143725881255`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {16.963, 1.280423753160517}], 
                 Offset[{-1.5, 0}, {16.963, 1.280423753160517}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 148], {
               LineBox[{{17.007, 12.731143725881255`}, {17.007, 
                1.280423753160517}}], 
               LineBox[{
                Offset[{1.5, 0}, {17.007, 12.731143725881255`}], 
                 Offset[{-1.5, 0}, {17.007, 12.731143725881255`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {17.007, 1.280423753160517}], 
                 Offset[{-1.5, 0}, {17.007, 1.280423753160517}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 149], {
               LineBox[{{17.575, 12.831237711501643`}, {17.575, 
                1.280423753160517}}], 
               LineBox[{
                Offset[{1.5, 0}, {17.575, 12.831237711501643`}], 
                 Offset[{-1.5, 0}, {17.575, 12.831237711501643`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {17.575, 1.280423753160517}], 
                 Offset[{-1.5, 0}, {17.575, 1.280423753160517}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 150], {
               LineBox[{{17.876, 12.831237711501643`}, {17.876, 
                2.182104774020174}}], 
               LineBox[{
                Offset[{1.5, 0}, {17.876, 12.831237711501643`}], 
                 Offset[{-1.5, 0}, {17.876, 12.831237711501643`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {17.876, 2.182104774020174}], 
                 Offset[{-1.5, 0}, {17.876, 2.182104774020174}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 151], {
               LineBox[{{17.947, 12.831237711501643`}, {17.947, 
                2.182104774020173}}], 
               LineBox[{
                Offset[{1.5, 0}, {17.947, 12.831237711501643`}], 
                 Offset[{-1.5, 0}, {17.947, 12.831237711501643`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {17.947, 2.182104774020173}], 
                 Offset[{-1.5, 0}, {17.947, 2.182104774020173}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 152], {
               LineBox[{{18.001, 12.831237711501643`}, {18.001, 
                2.182104774020173}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.001, 12.831237711501643`}], 
                 Offset[{-1.5, 0}, {18.001, 12.831237711501643`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.001, 2.182104774020173}], 
                 Offset[{-1.5, 0}, {18.001, 2.182104774020173}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 153], {
               LineBox[{{18.031, 12.831237711501643`}, {18.031, 
                2.182104774020174}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.031, 12.831237711501643`}], 
                 Offset[{-1.5, 0}, {18.031, 12.831237711501643`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.031, 2.182104774020174}], 
                 Offset[{-1.5, 0}, {18.031, 2.182104774020174}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 154], {
               LineBox[{{18.145, 13.49337739468438}, {18.145, 
                2.182104774020174}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.145, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {18.145, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.145, 2.182104774020174}], 
                 Offset[{-1.5, 0}, {18.145, 2.182104774020174}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 155], {
               LineBox[{{18.256, 13.49337739468438}, {18.256, 
                2.182104774020174}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.256, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {18.256, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.256, 2.182104774020174}], 
                 Offset[{-1.5, 0}, {18.256, 2.182104774020174}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 156], {
               LineBox[{{18.328, 13.49337739468438}, {18.328, 
                2.182104774020173}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.328, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {18.328, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.328, 2.182104774020173}], 
                 Offset[{-1.5, 0}, {18.328, 2.182104774020173}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 157], {
               LineBox[{{18.494, 13.49337739468438}, {18.494, 
                2.182104774020174}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.494, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {18.494, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.494, 2.182104774020174}], 
                 Offset[{-1.5, 0}, {18.494, 2.182104774020174}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 158], {
               LineBox[{{18.509, 13.49337739468438}, {18.509, 
                2.182104774020174}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.509, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {18.509, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.509, 2.182104774020174}], 
                 Offset[{-1.5, 0}, {18.509, 2.182104774020174}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 159], {
               LineBox[{{18.59, 13.49337739468438}, {18.59, 
                2.1439556734903116`}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.59, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {18.59, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.59, 2.1439556734903116`}], 
                 Offset[{-1.5, 0}, {18.59, 2.1439556734903116`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 160], {
               LineBox[{{18.702, 13.49337739468438}, {18.702, 
                2.1439556734903116`}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.702, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {18.702, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.702, 2.1439556734903116`}], 
                 Offset[{-1.5, 0}, {18.702, 2.1439556734903116`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 161], {
               LineBox[{{18.91, 13.49337739468438}, {18.91, 
                2.1439556734903116`}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.91, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {18.91, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.91, 2.1439556734903116`}], 
                 Offset[{-1.5, 0}, {18.91, 2.1439556734903116`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 162], {
               LineBox[{{18.99, 13.49337739468438}, {18.99, 
                2.1439556734903116`}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.99, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {18.99, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.99, 2.1439556734903116`}], 
                 Offset[{-1.5, 0}, {18.99, 2.1439556734903116`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 163], {
               LineBox[{{19.109, 13.49337739468438}, {19.109, 
                2.1439556734903107`}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.109, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {19.109, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.109, 2.1439556734903107`}], 
                 Offset[{-1.5, 0}, {19.109, 2.1439556734903107`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 164], {
               LineBox[{{19.199, 13.49337739468438}, {19.199, 
                2.1439556734903107`}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.199, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {19.199, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.199, 2.1439556734903107`}], 
                 Offset[{-1.5, 0}, {19.199, 2.1439556734903107`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 165], {
               LineBox[{{19.262, 13.49337739468438}, {19.262, 
                2.1439556734903107`}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.262, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {19.262, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.262, 2.1439556734903107`}], 
                 Offset[{-1.5, 0}, {19.262, 2.1439556734903107`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 166], {
               LineBox[{{19.295, 13.49337739468438}, {19.295, 
                2.1439556734903107`}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.295, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {19.295, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.295, 2.1439556734903107`}], 
                 Offset[{-1.5, 0}, {19.295, 2.1439556734903107`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 167], {
               LineBox[{{19.3, 13.49337739468438}, {19.3, 
                2.1439556734903107`}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.3, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {19.3, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.3, 2.1439556734903107`}], 
                 Offset[{-1.5, 0}, {19.3, 2.1439556734903107`}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 168], {
               LineBox[{{19.313, 13.49337739468438}, {19.313, 
                2.1439556734903107`}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.313, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {19.313, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.313, 2.1439556734903107`}], 
                 Offset[{-1.5, 0}, {19.313, 2.1439556734903107`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 169], {
               LineBox[{{19.382, 13.49337739468438}, {19.382, 
                2.1439556734903107`}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.382, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {19.382, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.382, 2.1439556734903107`}], 
                 Offset[{-1.5, 0}, {19.382, 2.1439556734903107`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 170], {
               LineBox[{{19.459, 13.49337739468438}, {19.459, 
                2.1439556734903107`}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.459, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {19.459, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.459, 2.1439556734903107`}], 
                 Offset[{-1.5, 0}, {19.459, 2.1439556734903107`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 171], {
               LineBox[{{19.755, 13.49337739468438}, {19.755, 
                2.1439556734903107`}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.755, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {19.755, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.755, 2.1439556734903107`}], 
                 Offset[{-1.5, 0}, {19.755, 2.1439556734903107`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 172], {
               LineBox[{{19.868, 13.49337739468438}, {19.868, 
                2.1439556734903107`}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.868, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {19.868, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.868, 2.1439556734903107`}], 
                 Offset[{-1.5, 0}, {19.868, 2.1439556734903107`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 173], {
               LineBox[{{20.236, 13.49337739468438}, {20.236, 
                2.1439556734903107`}}], 
               LineBox[{
                Offset[{1.5, 0}, {20.236, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {20.236, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {20.236, 2.1439556734903107`}], 
                 Offset[{-1.5, 0}, {20.236, 2.1439556734903107`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 174], {
               LineBox[{{20.53, 13.49337739468438}, {20.53, 
                2.1439556734903107`}}], 
               LineBox[{
                Offset[{1.5, 0}, {20.53, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {20.53, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {20.53, 2.1439556734903107`}], 
                 Offset[{-1.5, 0}, {20.53, 2.1439556734903107`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 175], {
               LineBox[{{20.811, 13.49337739468438}, {20.811, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {20.811, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {20.811, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {20.811, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {20.811, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 176], {
               LineBox[{{21.093, 13.49337739468438}, {21.093, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {21.093, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {21.093, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {21.093, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {21.093, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 177], {
               LineBox[{{21.369, 15.803387118844666`}, {21.369, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {21.369, 15.803387118844666`}], 
                 Offset[{-1.5, 0}, {21.369, 15.803387118844666`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {21.369, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {21.369, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 178], {
               LineBox[{{21.681, 15.803387118844666`}, {21.681, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {21.681, 15.803387118844666`}], 
                 Offset[{-1.5, 0}, {21.681, 15.803387118844666`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {21.681, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {21.681, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 179], {
               LineBox[{{22.015, 15.803387118844666`}, {22.015, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.015, 15.803387118844666`}], 
                 Offset[{-1.5, 0}, {22.015, 15.803387118844666`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.015, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {22.015, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 180], {
               LineBox[{{22.042, 15.803387118844666`}, {22.042, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.042, 15.803387118844666`}], 
                 Offset[{-1.5, 0}, {22.042, 15.803387118844666`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.042, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {22.042, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 181], {
               LineBox[{{22.069, 15.803387118844666`}, {22.069, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.069, 15.803387118844666`}], 
                 Offset[{-1.5, 0}, {22.069, 15.803387118844666`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.069, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {22.069, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 182], {
               LineBox[{{22.075, 15.803387118844666`}, {22.075, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.075, 15.803387118844666`}], 
                 Offset[{-1.5, 0}, {22.075, 15.803387118844666`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.075, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {22.075, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 183], {
               LineBox[{{22.106, 15.803387118844666`}, {22.106, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.106, 15.803387118844666`}], 
                 Offset[{-1.5, 0}, {22.106, 15.803387118844666`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.106, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {22.106, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 184], {
               LineBox[{{22.298, 15.803387118844668`}, {22.298, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.298, 15.803387118844668`}], 
                 Offset[{-1.5, 0}, {22.298, 15.803387118844668`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.298, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {22.298, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 185], {
               LineBox[{{22.394, 15.803387118844668`}, {22.394, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.394, 15.803387118844668`}], 
                 Offset[{-1.5, 0}, {22.394, 15.803387118844668`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.394, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {22.394, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 186], {
               LineBox[{{22.424, 15.803387118844668`}, {22.424, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.424, 15.803387118844668`}], 
                 Offset[{-1.5, 0}, {22.424, 15.803387118844668`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.424, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {22.424, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 187], {
               LineBox[{{22.438, 15.803387118844668`}, {22.438, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.438, 15.803387118844668`}], 
                 Offset[{-1.5, 0}, {22.438, 15.803387118844668`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.438, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {22.438, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 188], {
               LineBox[{{22.58, 15.803387118844668`}, {22.58, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.58, 15.803387118844668`}], 
                 Offset[{-1.5, 0}, {22.58, 15.803387118844668`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.58, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {22.58, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 189], {
               LineBox[{{22.583, 15.803387118844668`}, {22.583, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.583, 15.803387118844668`}], 
                 Offset[{-1.5, 0}, {22.583, 15.803387118844668`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.583, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {22.583, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 190], {
               LineBox[{{22.826, 15.803387118844668`}, {22.826, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.826, 15.803387118844668`}], 
                 Offset[{-1.5, 0}, {22.826, 15.803387118844668`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.826, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {22.826, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 191], {
               LineBox[{{22.853, 15.803387118844668`}, {22.853, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.853, 15.803387118844668`}], 
                 Offset[{-1.5, 0}, {22.853, 15.803387118844668`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.853, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {22.853, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 192], {
               LineBox[{{23.162, 15.560009649225263`}, {23.162, 
                2.0557998473197294`}}], 
               LineBox[{
                Offset[{1.5, 0}, {23.162, 15.560009649225263`}], 
                 Offset[{-1.5, 0}, {23.162, 15.560009649225263`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {23.162, 2.0557998473197294`}], 
                 Offset[{-1.5, 0}, {23.162, 2.0557998473197294`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 193], {
               LineBox[{{23.173, 15.560009649225263`}, {23.173, 
                2.0557998473197294`}}], 
               LineBox[{
                Offset[{1.5, 0}, {23.173, 15.560009649225263`}], 
                 Offset[{-1.5, 0}, {23.173, 15.560009649225263`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {23.173, 2.0557998473197294`}], 
                 Offset[{-1.5, 0}, {23.173, 2.0557998473197294`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 194], {
               LineBox[{{23.435, 15.73547338959265}, {23.435, 
                2.0557998473197294`}}], 
               LineBox[{
                Offset[{1.5, 0}, {23.435, 15.73547338959265}], 
                 Offset[{-1.5, 0}, {23.435, 15.73547338959265}]}], 
               LineBox[{
                Offset[{1.5, 0}, {23.435, 2.0557998473197294`}], 
                 Offset[{-1.5, 0}, {23.435, 2.0557998473197294`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 195], {
               LineBox[{{24.089, 15.73547338959265}, {24.089, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {24.089, 15.73547338959265}], 
                 Offset[{-1.5, 0}, {24.089, 15.73547338959265}]}], 
               LineBox[{
                Offset[{1.5, 0}, {24.089, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {24.089, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 196], {
               LineBox[{{24.401, 15.735473389592649`}, {24.401, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {24.401, 15.735473389592649`}], 
                 Offset[{-1.5, 0}, {24.401, 15.735473389592649`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {24.401, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {24.401, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 197], {
               LineBox[{{24.656, 15.735473389592649`}, {24.656, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {24.656, 15.735473389592649`}], 
                 Offset[{-1.5, 0}, {24.656, 15.735473389592649`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {24.656, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {24.656, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 198], {
               LineBox[{{24.997, 15.73547338959265}, {24.997, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {24.997, 15.73547338959265}], 
                 Offset[{-1.5, 0}, {24.997, 15.73547338959265}]}], 
               LineBox[{
                Offset[{1.5, 0}, {24.997, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {24.997, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 199], {
               LineBox[{{25.417, 15.73547338959265}, {25.417, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {25.417, 15.73547338959265}], 
                 Offset[{-1.5, 0}, {25.417, 15.73547338959265}]}], 
               LineBox[{
                Offset[{1.5, 0}, {25.417, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {25.417, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 200], {
               LineBox[{{25.539, 15.73547338959265}, {25.539, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {25.539, 15.73547338959265}], 
                 Offset[{-1.5, 0}, {25.539, 15.73547338959265}]}], 
               LineBox[{
                Offset[{1.5, 0}, {25.539, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {25.539, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 201], {
               LineBox[{{25.624, 15.73547338959265}, {25.624, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {25.624, 15.73547338959265}], 
                 Offset[{-1.5, 0}, {25.624, 15.73547338959265}]}], 
               LineBox[{
                Offset[{1.5, 0}, {25.624, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {25.624, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 202], {
               LineBox[{{25.713, 15.73547338959265}, {25.713, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {25.713, 15.73547338959265}], 
                 Offset[{-1.5, 0}, {25.713, 15.73547338959265}]}], 
               LineBox[{
                Offset[{1.5, 0}, {25.713, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {25.713, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 203], {
               LineBox[{{25.733, 15.73547338959265}, {25.733, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {25.733, 15.73547338959265}], 
                 Offset[{-1.5, 0}, {25.733, 15.73547338959265}]}], 
               LineBox[{
                Offset[{1.5, 0}, {25.733, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {25.733, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 204], {
               LineBox[{{25.776, 15.73547338959265}, {25.776, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {25.776, 15.73547338959265}], 
                 Offset[{-1.5, 0}, {25.776, 15.73547338959265}]}], 
               LineBox[{
                Offset[{1.5, 0}, {25.776, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {25.776, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 205], {
               LineBox[{{26.183, 15.73547338959265}, {26.183, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {26.183, 15.73547338959265}], 
                 Offset[{-1.5, 0}, {26.183, 15.73547338959265}]}], 
               LineBox[{
                Offset[{1.5, 0}, {26.183, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {26.183, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 206], {
               LineBox[{{26.335, 15.803387118844666`}, {26.335, 
                2.143955673490311}}], 
               LineBox[{
                Offset[{1.5, 0}, {26.335, 15.803387118844666`}], 
                 Offset[{-1.5, 0}, {26.335, 15.803387118844666`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {26.335, 2.143955673490311}], 
                 Offset[{-1.5, 0}, {26.335, 2.143955673490311}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 207], {
               LineBox[{{26.592, 15.803387118844666`}, {26.592, 
                2.143955673490311}}], 
               LineBox[{
                Offset[{1.5, 0}, {26.592, 15.803387118844666`}], 
                 Offset[{-1.5, 0}, {26.592, 15.803387118844666`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {26.592, 2.143955673490311}], 
                 Offset[{-1.5, 0}, {26.592, 2.143955673490311}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 208], {
               LineBox[{{26.595, 15.803387118844666`}, {26.595, 
                2.143955673490311}}], 
               LineBox[{
                Offset[{1.5, 0}, {26.595, 15.803387118844666`}], 
                 Offset[{-1.5, 0}, {26.595, 15.803387118844666`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {26.595, 2.143955673490311}], 
                 Offset[{-1.5, 0}, {26.595, 2.143955673490311}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 209], {
               LineBox[{{26.703, 15.803387118844666`}, {26.703, 
                2.143955673490311}}], 
               LineBox[{
                Offset[{1.5, 0}, {26.703, 15.803387118844666`}], 
                 Offset[{-1.5, 0}, {26.703, 15.803387118844666`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {26.703, 2.143955673490311}], 
                 Offset[{-1.5, 0}, {26.703, 2.143955673490311}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 210], {
               LineBox[{{26.778, 15.803387118844666`}, {26.778, 
                2.1439556734903107`}}], 
               LineBox[{
                Offset[{1.5, 0}, {26.778, 15.803387118844666`}], 
                 Offset[{-1.5, 0}, {26.778, 15.803387118844666`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {26.778, 2.1439556734903107`}], 
                 Offset[{-1.5, 0}, {26.778, 2.1439556734903107`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 211], {
               LineBox[{{27.11, 16.039867058033586`}, {27.11, 
                2.3386400580802933`}}], 
               LineBox[{
                Offset[{1.5, 0}, {27.11, 16.039867058033586`}], 
                 Offset[{-1.5, 0}, {27.11, 16.039867058033586`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.11, 2.3386400580802933`}], 
                 Offset[{-1.5, 0}, {27.11, 2.3386400580802933`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 212], {
               LineBox[{{27.154, 16.039867058033586`}, {27.154, 
                2.3386400580802933`}}], 
               LineBox[{
                Offset[{1.5, 0}, {27.154, 16.039867058033586`}], 
                 Offset[{-1.5, 0}, {27.154, 16.039867058033586`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.154, 2.3386400580802933`}], 
                 Offset[{-1.5, 0}, {27.154, 2.3386400580802933`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 213], {
               LineBox[{{27.276, 16.039867058033586`}, {27.276, 
                2.4972493252177714`}}], 
               LineBox[{
                Offset[{1.5, 0}, {27.276, 16.039867058033586`}], 
                 Offset[{-1.5, 0}, {27.276, 16.039867058033586`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.276, 2.4972493252177714`}], 
                 Offset[{-1.5, 0}, {27.276, 2.4972493252177714`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 214], {
               LineBox[{{27.277, 16.039867058033586`}, {27.277, 
                2.4972493252177714`}}], 
               LineBox[{
                Offset[{1.5, 0}, {27.277, 16.039867058033586`}], 
                 Offset[{-1.5, 0}, {27.277, 16.039867058033586`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.277, 2.4972493252177714`}], 
                 Offset[{-1.5, 0}, {27.277, 2.4972493252177714`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 215], {
               LineBox[{{27.343, 16.039867058033586`}, {27.343, 
                2.4972493252177714`}}], 
               LineBox[{
                Offset[{1.5, 0}, {27.343, 16.039867058033586`}], 
                 Offset[{-1.5, 0}, {27.343, 16.039867058033586`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.343, 2.4972493252177714`}], 
                 Offset[{-1.5, 0}, {27.343, 2.4972493252177714`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 216], {
               LineBox[{{27.478, 16.039867058033586`}, {27.478, 
                2.4972493252177714`}}], 
               LineBox[{
                Offset[{1.5, 0}, {27.478, 16.039867058033586`}], 
                 Offset[{-1.5, 0}, {27.478, 16.039867058033586`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.478, 2.4972493252177714`}], 
                 Offset[{-1.5, 0}, {27.478, 2.4972493252177714`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 217], {
               LineBox[{{27.557, 16.039867058033586`}, {27.557, 
                2.4972493252177714`}}], 
               LineBox[{
                Offset[{1.5, 0}, {27.557, 16.039867058033586`}], 
                 Offset[{-1.5, 0}, {27.557, 16.039867058033586`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.557, 2.4972493252177714`}], 
                 Offset[{-1.5, 0}, {27.557, 2.4972493252177714`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 218], {
               LineBox[{{27.789, 14.867088338069141`}, {27.789, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {27.789, 14.867088338069141`}], 
                 Offset[{-1.5, 0}, {27.789, 14.867088338069141`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.789, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {27.789, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 219], {
               LineBox[{{27.832, 14.867088338069141`}, {27.832, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {27.832, 14.867088338069141`}], 
                 Offset[{-1.5, 0}, {27.832, 14.867088338069141`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.832, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {27.832, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 220], {
               LineBox[{{28.097, 13.91451339484205}, {28.097, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {28.097, 13.91451339484205}], 
                 Offset[{-1.5, 0}, {28.097, 13.91451339484205}]}], 
               LineBox[{
                Offset[{1.5, 0}, {28.097, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {28.097, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 221], {
               LineBox[{{28.35, 12.326095762132013`}, {28.35, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {28.35, 12.326095762132013`}], 
                 Offset[{-1.5, 0}, {28.35, 12.326095762132013`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {28.35, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {28.35, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 222], {
               LineBox[{{28.599, 12.326095762132013`}, {28.599, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {28.599, 12.326095762132013`}], 
                 Offset[{-1.5, 0}, {28.599, 12.326095762132013`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {28.599, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {28.599, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 223], {
               LineBox[{{28.735, 12.326095762132013`}, {28.735, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {28.735, 12.326095762132013`}], 
                 Offset[{-1.5, 0}, {28.735, 12.326095762132013`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {28.735, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {28.735, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 224], {
               LineBox[{{28.838, 12.321746398834286`}, {28.838, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {28.838, 12.321746398834286`}], 
                 Offset[{-1.5, 0}, {28.838, 12.321746398834286`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {28.838, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {28.838, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 225], {
               LineBox[{{29.067, 12.321746398834286`}, {29.067, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {29.067, 12.321746398834286`}], 
                 Offset[{-1.5, 0}, {29.067, 12.321746398834286`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {29.067, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {29.067, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 226], {
               LineBox[{{29.319, 12.473955941640604`}, {29.319, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {29.319, 12.473955941640604`}], 
                 Offset[{-1.5, 0}, {29.319, 12.473955941640604`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {29.319, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {29.319, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 227], {
               LineBox[{{29.352, 12.473955941640604`}, {29.352, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {29.352, 12.473955941640604`}], 
                 Offset[{-1.5, 0}, {29.352, 12.473955941640604`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {29.352, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {29.352, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 228], {
               LineBox[{{29.373, 12.473955941640604`}, {29.373, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {29.373, 12.473955941640604`}], 
                 Offset[{-1.5, 0}, {29.373, 12.473955941640604`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {29.373, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {29.373, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 229], {
               LineBox[{{29.48, 12.473955941640604`}, {29.48, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {29.48, 12.473955941640604`}], 
                 Offset[{-1.5, 0}, {29.48, 12.473955941640604`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {29.48, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {29.48, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 230], {
               LineBox[{{29.623, 12.473955941640604`}, {29.623, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {29.623, 12.473955941640604`}], 
                 Offset[{-1.5, 0}, {29.623, 12.473955941640604`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {29.623, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {29.623, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 231], {
               LineBox[{{29.642, 12.473955941640604`}, {29.642, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {29.642, 12.473955941640604`}], 
                 Offset[{-1.5, 0}, {29.642, 12.473955941640604`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {29.642, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {29.642, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 232], {
               LineBox[{{29.994, 12.473955941640604`}, {29.994, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {29.994, 12.473955941640604`}], 
                 Offset[{-1.5, 0}, {29.994, 12.473955941640604`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {29.994, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {29.994, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 233], {
               LineBox[{{30.094, 12.321746398834286`}, {30.094, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {30.094, 12.321746398834286`}], 
                 Offset[{-1.5, 0}, {30.094, 12.321746398834286`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {30.094, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {30.094, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 234], {
               LineBox[{{30.247, 12.321746398834286`}, {30.247, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {30.247, 12.321746398834286`}], 
                 Offset[{-1.5, 0}, {30.247, 12.321746398834286`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {30.247, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {30.247, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 235], {
               LineBox[{{30.249, 12.321746398834286`}, {30.249, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {30.249, 12.321746398834286`}], 
                 Offset[{-1.5, 0}, {30.249, 12.321746398834286`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {30.249, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {30.249, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 236], {
               LineBox[{{30.495, 12.321746398834286`}, {30.495, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {30.495, 12.321746398834286`}], 
                 Offset[{-1.5, 0}, {30.495, 12.321746398834286`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {30.495, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {30.495, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 237], {
               LineBox[{{30.784, 12.321746398834286`}, {30.784, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {30.784, 12.321746398834286`}], 
                 Offset[{-1.5, 0}, {30.784, 12.321746398834286`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {30.784, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {30.784, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 238], {
               LineBox[{{31.329, 12.321746398834286`}, {31.329, 
                2.6588406238259745`}}], 
               LineBox[{
                Offset[{1.5, 0}, {31.329, 12.321746398834286`}], 
                 Offset[{-1.5, 0}, {31.329, 12.321746398834286`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {31.329, 2.6588406238259745`}], 
                 Offset[{-1.5, 0}, {31.329, 2.6588406238259745`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 239], {
               LineBox[{{31.363, 12.321746398834286`}, {31.363, 
                2.6588406238259745`}}], 
               LineBox[{
                Offset[{1.5, 0}, {31.363, 12.321746398834286`}], 
                 Offset[{-1.5, 0}, {31.363, 12.321746398834286`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {31.363, 2.6588406238259745`}], 
                 Offset[{-1.5, 0}, {31.363, 2.6588406238259745`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 240], {
               LineBox[{{31.482, 12.321746398834286`}, {31.482, 
                1.6016961044634535`}}], 
               LineBox[{
                Offset[{1.5, 0}, {31.482, 12.321746398834286`}], 
                 Offset[{-1.5, 0}, {31.482, 12.321746398834286`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {31.482, 1.6016961044634535`}], 
                 Offset[{-1.5, 0}, {31.482, 1.6016961044634535`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 241], {
               LineBox[{{31.843, 11.605250004565127`}, {31.843, 
                1.3732778136327446`}}], 
               LineBox[{
                Offset[{1.5, 0}, {31.843, 11.605250004565127`}], 
                 Offset[{-1.5, 0}, {31.843, 11.605250004565127`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {31.843, 1.3732778136327446`}], 
                 Offset[{-1.5, 0}, {31.843, 1.3732778136327446`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 242], {
               LineBox[{{32.009, 11.479389690623226`}, {32.009, 
                1.3732778136327446`}}], 
               LineBox[{
                Offset[{1.5, 0}, {32.009, 11.479389690623226`}], 
                 Offset[{-1.5, 0}, {32.009, 11.479389690623226`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {32.009, 1.3732778136327446`}], 
                 Offset[{-1.5, 0}, {32.009, 1.3732778136327446`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 243], {
               LineBox[{{33.48, 8.890651729926178}, {33.48, 
                1.1034861520768264`}}], 
               LineBox[{
                Offset[{1.5, 0}, {33.48, 8.890651729926178}], 
                 Offset[{-1.5, 0}, {33.48, 8.890651729926178}]}], 
               LineBox[{
                Offset[{1.5, 0}, {33.48, 1.1034861520768264`}], 
                 Offset[{-1.5, 0}, {33.48, 1.1034861520768264`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 244], {
               LineBox[{{33.533, 8.890651729926178}, {33.533, 
                1.1034861520768264`}}], 
               LineBox[{
                Offset[{1.5, 0}, {33.533, 8.890651729926178}], 
                 Offset[{-1.5, 0}, {33.533, 8.890651729926178}]}], 
               LineBox[{
                Offset[{1.5, 0}, {33.533, 1.1034861520768264`}], 
                 Offset[{-1.5, 0}, {33.533, 1.1034861520768264`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 245], {
               LineBox[{{34.483, 8.890651729926178}, {34.483, 
                1.0754855450416807`}}], 
               LineBox[{
                Offset[{1.5, 0}, {34.483, 8.890651729926178}], 
                 Offset[{-1.5, 0}, {34.483, 8.890651729926178}]}], 
               LineBox[{
                Offset[{1.5, 0}, {34.483, 1.0754855450416807`}], 
                 Offset[{-1.5, 0}, {34.483, 1.0754855450416807`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 246], {
               LineBox[{{34.488, 8.890651729926178}, {34.488, 
                1.0754855450416807`}}], 
               LineBox[{
                Offset[{1.5, 0}, {34.488, 8.890651729926178}], 
                 Offset[{-1.5, 0}, {34.488, 8.890651729926178}]}], 
               LineBox[{
                Offset[{1.5, 0}, {34.488, 1.0754855450416807`}], 
                 Offset[{-1.5, 0}, {34.488, 1.0754855450416807`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 247], {
               LineBox[{{34.62, 7.953982742084829}, {34.62, 
                1.0754855450416807`}}], 
               LineBox[{
                Offset[{1.5, 0}, {34.62, 7.953982742084829}], 
                 Offset[{-1.5, 0}, {34.62, 7.953982742084829}]}], 
               LineBox[{
                Offset[{1.5, 0}, {34.62, 1.0754855450416807`}], 
                 Offset[{-1.5, 0}, {34.62, 1.0754855450416807`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 248], {
               LineBox[{{39.634, 8.251917320812652}, {39.634, 
                1.0940578650298862`}}], 
               LineBox[{
                Offset[{1.5, 0}, {39.634, 8.251917320812652}], 
                 Offset[{-1.5, 0}, {39.634, 8.251917320812652}]}], 
               LineBox[{
                Offset[{1.5, 0}, {39.634, 1.0940578650298862`}], 
                 Offset[{-1.5, 0}, {39.634, 1.0940578650298862`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 249], {
               LineBox[{{40.641, 8.141752207470867}, {40.641, 
                1.0940578650298862`}}], 
               LineBox[{
                Offset[{1.5, 0}, {40.641, 8.141752207470867}], 
                 Offset[{-1.5, 0}, {40.641, 8.141752207470867}]}], 
               LineBox[{
                Offset[{1.5, 0}, {40.641, 1.0940578650298862`}], 
                 Offset[{-1.5, 0}, {40.641, 1.0940578650298862`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 250], {
               LineBox[{{42.973, 8.277633615714565}, {42.973, 
                1.0940578650298862`}}], 
               LineBox[{
                Offset[{1.5, 0}, {42.973, 8.277633615714565}], 
                 Offset[{-1.5, 0}, {42.973, 8.277633615714565}]}], 
               LineBox[{
                Offset[{1.5, 0}, {42.973, 1.0940578650298862`}], 
                 Offset[{-1.5, 0}, {42.973, 1.0940578650298862`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 251], {
               LineBox[{{44.283, 11.806473530277493`}, {44.283, 
                1.2362306579711335`}}], 
               LineBox[{
                Offset[{1.5, 0}, {44.283, 11.806473530277493`}], 
                 Offset[{-1.5, 0}, {44.283, 11.806473530277493`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {44.283, 1.2362306579711335`}], 
                 Offset[{-1.5, 0}, {44.283, 1.2362306579711335`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 252], {
               LineBox[{{45.828, 8.364676655025551}, {45.828, 
                1.6135481402583909`}}], 
               LineBox[{
                Offset[{1.5, 0}, {45.828, 8.364676655025551}], 
                 Offset[{-1.5, 0}, {45.828, 8.364676655025551}]}], 
               LineBox[{
                Offset[{1.5, 0}, {45.828, 1.6135481402583909`}], 
                 Offset[{-1.5, 0}, {45.828, 1.6135481402583909`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 253], {
               LineBox[{{46.256, 8.157641236046551}, {46.256, 
                1.6927894211139813`}}], 
               LineBox[{
                Offset[{1.5, 0}, {46.256, 8.157641236046551}], 
                 Offset[{-1.5, 0}, {46.256, 8.157641236046551}]}], 
               LineBox[{
                Offset[{1.5, 0}, {46.256, 1.6927894211139813`}], 
                 Offset[{-1.5, 0}, {46.256, 1.6927894211139813`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 254], {
               LineBox[{{46.658, 10.040666090178572`}, {46.658, 
                1.6927894211139813`}}], 
               LineBox[{
                Offset[{1.5, 0}, {46.658, 10.040666090178572`}], 
                 Offset[{-1.5, 0}, {46.658, 10.040666090178572`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {46.658, 1.6927894211139813`}], 
                 Offset[{-1.5, 0}, {46.658, 1.6927894211139813`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 255], {
               LineBox[{{47.063, 9.746942997663497}, {47.063, 
                1.6927894211139813`}}], 
               LineBox[{
                Offset[{1.5, 0}, {47.063, 9.746942997663497}], 
                 Offset[{-1.5, 0}, {47.063, 9.746942997663497}]}], 
               LineBox[{
                Offset[{1.5, 0}, {47.063, 1.6927894211139813`}], 
                 Offset[{-1.5, 0}, {47.063, 1.6927894211139813`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 256], {
               LineBox[{{47.443, 10.415100678555948`}, {47.443, 
                1.6927894211139813`}}], 
               LineBox[{
                Offset[{1.5, 0}, {47.443, 10.415100678555948`}], 
                 Offset[{-1.5, 0}, {47.443, 10.415100678555948`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {47.443, 1.6927894211139813`}], 
                 Offset[{-1.5, 0}, {47.443, 1.6927894211139813`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 257], {
               LineBox[{{47.856, 8.702863472381466}, {47.856, 
                1.6927894211139813`}}], 
               LineBox[{
                Offset[{1.5, 0}, {47.856, 8.702863472381466}], 
                 Offset[{-1.5, 0}, {47.856, 8.702863472381466}]}], 
               LineBox[{
                Offset[{1.5, 0}, {47.856, 1.6927894211139813`}], 
                 Offset[{-1.5, 0}, {47.856, 1.6927894211139813`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 258], {
               LineBox[{{48.272, 8.702863472381466}, {48.272, 
                1.6927894211139813`}}], 
               LineBox[{
                Offset[{1.5, 0}, {48.272, 8.702863472381466}], 
                 Offset[{-1.5, 0}, {48.272, 8.702863472381466}]}], 
               LineBox[{
                Offset[{1.5, 0}, {48.272, 1.6927894211139813`}], 
                 Offset[{-1.5, 0}, {48.272, 1.6927894211139813`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 259], {
               LineBox[{{49.174, 10.279565801221775`}, {49.174, 
                1.7881765610841414`}}], 
               LineBox[{
                Offset[{1.5, 0}, {49.174, 10.279565801221775`}], 
                 Offset[{-1.5, 0}, {49.174, 10.279565801221775`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {49.174, 1.7881765610841414`}], 
                 Offset[{-1.5, 0}, {49.174, 1.7881765610841414`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 260], {
               LineBox[{{49.985, 8.801571361486912}, {49.985, 
                1.7958751621666122`}}], 
               LineBox[{
                Offset[{1.5, 0}, {49.985, 8.801571361486912}], 
                 Offset[{-1.5, 0}, {49.985, 8.801571361486912}]}], 
               LineBox[{
                Offset[{1.5, 0}, {49.985, 1.7958751621666122`}], 
                 Offset[{-1.5, 0}, {49.985, 
                  1.7958751621666122`}]}]}}}, {}}], {}}, {{}, 
          GraphicsComplexBox[CompressedData["
1:eJztlvlTU1cUx8PShEbQRBYTwIXFEovKJoiEJAdZEgQUcMFStAXRaoqKFJQC
RbEDETfGyuJSRIu4dCyjgpRB0OpkFKkrdKDooDKUoS4UAYFaCvbd+5x3nP4N
eb9kPnNz7jv3e7/nvOOQsDl6rTGPxzM14vHI75yLpX2nb/Sorruk7zuW/iH8
EFwzOPbba1XryqyrITcEQJfDhjiOrp2W+yLKAiaZjNpqu/nwV5bKe3WdCJ4n
v93rJhbAlPa7I0vXiMFdHf77HncBsPsjm52zj02UW3Lcfd/x0Ztxey7eizyD
DhAWqd8+1sKHJ0v2lWz6zhGyTH+U22v5sDhBtHJB9UwwGy1KSHHgg+mKiXMu
TnXhuFLdmWG1yRVydz7e9WmGAK6U2bp1/OEKGv7PQZeyBfC9fsb5FNlciK7Q
nV7cIIRF5sauumF3cK5+8FPPBRFsnvztL01GHhzTfA56gPGlK7+6JdnAzbD5
+QFPPaA3YiDrnJ0tm9+ABzz9Wq+43C9l13meHE8kAgg8uf8z4tVOm4l85gYJ
QNbZEAExnjls49ZsXP/3bH9zxE7ktvJkhbAE+VrTieCaKuRZcQXXh/5EVgiZ
iDHk4sA9ST12Xtz7NvaMnu33RI5kjjc5EPklk35uGPKd28wTjtxVcVQ/IxKZ
6hmP7NbhzM9JQ2Zuq1J9zQvmhR5tf9UqhQO9jKEeIzs9epOt9Z8HDwtydKVf
SEFDAnTI5PpL782D3WlqzQGdBFyJgFO8wbd2a3GDTMLqt9obfN5x2kGJ6YpK
by7+JCNfm4kPF39oE5OwEJlRZ/SsGJn6wRJ54eeMg+2QSTWEhvtAX1DqooYa
Keu/RGR+ThGjODLVKxnZihi4EHk9EaQI+Z9sbX1qCzKtv4fIpHrTZ83n9KX5
zEZm3CCL24xMqqnRxpdjWq/rfKHfc8uOck8J69/TyLR83/pyelK9tAs4DiKC
5SMT+a+UIdN6q0G+N7K0q+IyMtsvkI3Jhc71g9l9q59EeUtgWMYYerkfp3ei
nFQgMm1Ph5BpPVUh14UyCdz0A/8N1RtlyVIg5SGzl0NudF7oungp0OtxQab5
hCC/ZuR99h5Tv8XIuf3ofWTI4Zv6HeHaGCnQ9Pbj/6k+t+RgYhbRG8/0E7bf
IocQlPjD3gvq+vENNnDkMPN8gtwSwTTAw/5Qans/87iNDZt/PTLVtxV5nEn3
I7EChl/GjgQMW7N+jlJw6y4epCMjf0UM9xlyJjUkxtP1MgVcXeOoH+2yBhp+
EpnW27gCjn/ptLU0xRoGmpmEJUqOqX9UyNQf7/F00iCzlbA89eP2qYnWQNt9
oxJinD07PrC2Zvv/MhVofLYldHdbwfkUJqE4ZPp9yUSm99OmgjwrpYtTvJjV
wwg4pv2wAcAyLqbTfNCC3V+PTNphsyIAgiyOKFfpLNjzKZFpPS0JgPXP84oW
pluw+z8IhFdN9kaPUwVAys88Ogjqru9fL4gVsvWfFQyDLwrS6v4Wsu9zDoFT
nU3H7JQTWH88C4GSpKo1Z0omwTLaINTQpC9oNnsiend+NUQmJ20JKhSz+u5S
w3bTnFUTdotZvWqRHahAauicclemNRZDfgBpWBoo3xZ1R3RbBEx3PhFcrIGR
Wy+GOtaK2O/nuAZyCvNPrbITg2E+MMwHhvnAMB8Y5gPDfGCYDwzzwf/ng/8A
2HH7Pw==
           "], {
            {GrayLevel[0], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 131], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 132], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 133], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 134], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 135], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 136], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 137], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 138], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 139], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 140], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 141], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 142], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 143], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 144], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 145], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 146], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 147], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 148], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 149], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 150], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 151], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 152], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 153], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 154], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 155], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 156], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 157], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 158], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 159], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 160], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 161], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 162], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 163], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 164], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 165], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 166], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 167], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 168], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 169], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 170], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 171], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 172], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 173], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 174], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 175], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 176], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 177], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 178], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 179], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 180], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 181], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 182], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 183], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 184], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 185], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 186], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 187], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 188], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 189], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 190], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 191], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 192], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 193], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 194], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 195], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 196], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 197], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 198], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 199], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 200], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 201], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 202], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 203], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 204], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 205], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 206], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 207], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 208], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 209], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 210], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 211], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 212], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 213], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 214], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 215], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 216], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 217], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 218], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 219], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 220], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 221], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 222], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 223], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 224], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 225], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 226], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 227], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 228], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 229], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 230], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 231], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 232], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 233], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 234], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 235], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 236], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 237], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 238], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 239], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 240], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 241], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 242], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 243], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 244], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 245], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 246], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 247], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 248], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 249], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 250], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 251], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 252], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 253], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 254], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 255], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 256], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 257], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 258], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 259], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 260]}, {}}], {}}}, {{}, {}, 
         {GrayLevel[0], Thickness[0.003], LineBox[CompressedData["
1:eJxNzX0803sfx/G5nW4UEe3YEZsYuZuRpfAjm7kJUaESkXsh92m1TjpFN+4r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           "]]}}, {{}, {}, 
         {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
          LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ/SZ+oWqR10Y7nfqmH6wFjA5y577M9ttx3x7Gz+pc
VuSz4z2cXx8w9dXzNgYHGN9u8j+/J70ccD47z5mpHmYCcP6rOY8VGapF4Hzp
H5aVp8sk4PzjitHvvh+XgfNtzU751zUpwPn7HNj6umqU4PyaTerR7gtV4PzE
zhe8fQvV4PxTBVvvHZiuAecX7k+3W7JDC+He4p3Nglt14HzPvg/h+nf04PzX
dySXzqkxgPPdVLknPqswhPMdFPOPdHQZwflnzy969b7TGM7/aegZsX6eCZyf
PufrlZR1pnB+xs5Cl/urzeB8jq6E3xv3mcP51rzySz33W8D5G2Y8jr2+yxLO
P3JdKm7vaSs4P+ekYmDGKWs4f1Pe7O7sezZwvpWM9NWUt7ZwflhNlqDyKzs4
X3CCzlTLP/Zwvr72/VauOgc4v1xotUfxbwS/L9hAv6PZEc5/nyvbX8/kBOcr
PDospNyD4M/Sv8S/kscZzjdtTBZZ1YXgL9BZZxMu7ALnh2xMuPdsEoJ/o//M
YiVZVzi/tmh3wc0lCH62ntD2ImU3OF/TRUlxxxoE38B4FssDHXc4P0Jt6vum
VQh+QLHnv4tGHnD+pJmpbcybEHwHgwf7GH8i+G+PRX3/b+8J5wMAwypLiA==

           "]]}, 
         {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
          LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ/SZ+oWqR10Y7qavBc55cEHGQO/dltt+O+/Ywflbn
siKfHe/h/PqAqa+etzE4wPh2k//5PenlgPPZec5M9TATgPNfzXmsyFAtAudL
/7CsPF0mAecfV4x+9/24DJxva3bKv65JAc7f58DW11WjBOfXbFKPdl+oAucn
dr7g7VuoBuefKth678B0DTi/cH+63ZIdWgj3Fu9sFtyqA+d79n0I17+jB+e/
viO5dE6NAZzvpso98VmFIZzvoJh/pKPLCM4/e37Rq/edxnD+T0PPiPXzTOD8
9Dlfr6SsM4XzM3YWutxfbQbnc3Ql/N64zxzOt+aVX+q53wLO3zDjcez1XZZw
/pHrUnF7T1vB+TknFQMzTlnD+ZvyZndn37OB861kpK+mvLWF88NqsgSVX9nB
+YITdKZa/rGH8/W177dy1TnA+eVCqz2KfyP4fcEG+h3NjnD++1zZ/nomJzhf
4dFhIeUeBH+W/iX+lTzOcL5pY7LIqi4Ef4HOOptwYRc4P2Rjwr1nkxD8G/1n
FivJusL5tUW7C24uQfCz9YS2Fym7wfmaLkqKO9Yg+AbGs1ge6LjD+RFqU983
rULwA4o9/1008oDzJ81MbWPehOA7GDzYx/gTwX97LOr7f3tPOB8A9ZuBxA==

           "]]}, 
         {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
          LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ/SZ+oWqR10a72RukOB7UqzvInfsy22/HfXsYP6tz
WZHPjvdwfn3A1FfP2xgcYHy7yf/8nvRywPnsPGemepgJwPmv5jxWZKgWgfOl
f1hWni6TgPOPK0a/+35cBs63NTvlX9ekAOfvc2Dr66pRgvNrNqlHuy9UgfMT
O1/w9i1Ug/NPFWy9d2C6BpxfuD/dbskOLYR7i3c2C27VgfM9+z6E69/Rg/Nf
35FcOqfGAM53U+We+KzCEM53UMw/0tFlBOefPb/o1ftOYzj/p6FnxPp5JnB+
+pyvV1LWmcL5GTsLXe6vNoPzOboSfm/cZw7nW/PKL/XcbwHnb5jxOPb6Lks4
/8h1qbi9p63g/JyTioEZp6zh/E15s7uz79nA+VYy0ldT3trC+WE1WYLKr+zg
fMEJOlMt/9jD+fra91u56hzg/HKh1R7FvxH8vmAD/Y5mRzj/fa5sfz2TE5yv
8OiwkHIPgj9L/xL/Sh5nON+0MVlkVReCv0BnnU24sAucH7Ix4d6zSQj+jf4z
i5VkXeH82qLdBTeXIPjZekLbi5Td4HxNFyXFHWsQfAPjWSwPdNzh/Ai1qe+b
ViH4AcWe/y4aecD5k2amtjFvQvAdDB7sY/yJ4L89FvX9v70nnA8Ak+1daA==

           "]]}}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"x(kbp)\"", TraditionalForm], 
         FormBox["\"L\"", TraditionalForm]},
       AxesOrigin->{-1, 0},
       Method->{},
       PlotRange->{All, All},
       PlotRangeClipping->True,
       PlotRangePadding->None], {583.2, -1574.750603334732}, 
      ImageScaled[{0.5, 0.5}], {360.00000000000006`, 222.49223594996192`}], 
     InsetBox[
      GraphicsBox[{{{{}, 
          {RGBColor[0.24720000000000014`, 0.24, 0.6], PointBox[CompressedData["
1:eJx1VHswnHcUXYwgE0FeSJtGQgwa6r1o195pJlhBkqZKqe4kHhV5kGqkEzak
ZRu0Em1lPBalYWS63rTpIusT2bVI94UOod3FhqHTnYiJNsS0nXy/a/pHvpmd
b86c37333HN+3+47lfpOoiGDwTj/7++/94vHB+bF8RXN4kH2C+wN66y54R2d
AzR2A7tjBwzKSpQ09oNM2dr5y2sKNqkvj6LkGfmE9wBlrHdRHGIvqB/Ke6/1
E9LfH3QmKRWND0n9QaihCpJsTWg+Jxg6UlRr0oIZnP/tMmP6Uvg9Gr8JuqAE
ZaW9hsZM+KL3Lmur5j6NgyC0xc2mY+JXGrtAUWzDo3JTMi8AVhwUAUmrUzR2
gtCRM6qc7b+g/sn8rproEHLeEajKnIpF/hDyvDZ+2UKYCvszPV4rdu7RID4R
Yza1FNGEfj2Xerc/eWOcxp7QXKGKlh9V4v6FodbXGPo+1JPg9UqUeakY8/j7
K4FRRjXR5w6tZ+x3H7u64e+10M8mhV8S3gHE5XvivU7dQb22fbrh5Bgl6nu8
yfZprkiN89kNZqcXHIfxfFyp7KIp1YXz3++39Cyc7sc8TvCKDyY0DeL5Cx+3
G26TSGi8H4S6xaVs7kZ93mSIsnm3FOfP7ktp4JmoX8LbwJ77E2lcTR2NX4V6
SKvqbKVwnsPy9RFRbh/m4xHk9KxE2IvzuywPlCTakPNMoKIyA9M/uIf+xfcF
m5m7Er0BUDDw594srQz9GNW7ZPjUEuwLt2/VpllNy7CfxU7XanX2GPKcBN+Q
H1ekyIduiYH95mrUtzpufrihToJ43Ui7YHJUgn6mrq4Hp54m9zcMzEsVNW4c
Dep5uDQity8n/vvAHeHvy2x3kqc/JAbaTzDbyX0F2MpmrHCfjuJ9yOKsqnex
SL0n8CPqPu2+QOY5wTNjTbMotg/zSHrXKurKVfL9s8Dgu2zLy6JRPJ+f81Z3
5B8U6olOHqmbd3iAeQ0u9foadLRiHqkx1nOf72zDev3xgWiVE8nrbcg6O8Xy
SlChPxwP7x9OPhlCvZFFfkfknVoa24HAwH9+XLfBXy+IZE4dGsd8/49dYHPh
A/6NpnbknePTMwp7KPQ/iH+p35ErQ16Y+1xrTPXiPupFrt509if080bg3E15
uBj3y6vaEcdVbuzXtXm2f8yT8B4gjVDs2mYpwf4r+d8c4vgQP9mgYh8XVivJ
/oHQXdshjrEbw/zPZes3VQVN4j6ePFHWFokUeW+/dJnV6zLkj3w9NpOiakM+
szZcHmfciPMMa2J5xrYTL8Fe8L1rS1ucVov7f/jXOYGFQoH7tzSUX1zn/Ez/
XwMYHF6/lfiREvNx7jET/CaWYj7FKveT0jzyPTDBqFFXcCVMhv3qRYLkzsrb
6F/OzJRP9Nm7qJ+5LKgo6yD+scDGOlHw+JEC5zH2WgT6DVOol+B/ADGb7cQ=

            "]]}, {}}, GraphicsComplexBox[CompressedData["
1:eJx0/XVcVM/7Po5joyIiwoLksuzSLMsGS8+ICKjY3d2K2K1rN3aLiYqBiYiI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          "], {{{}, {}, {}, {}, {}, {}}, {{}, 
            TagBox[
             TooltipBox[
              {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl0bsrxWEcx/FHDDgYsKBImJgVZVQumxTl7hy3hUEyIgb3y5kNKOocl4nB
baJM6JTdYJL/AHW8ToZ379/n+/08zzn9ftWjM13TWSGEWbxEQljCK3KLQojn
hXBUEMIeH/IBSgtDKMGXWTbnYNl8JYPZtjyWH8IWj/MOj/I6x3iVo7zGm9jA
k3NRvxlDv+cL7uO03gCPuHsYcbnBrh675gu8iEF0u6dHpxffej+YQ0JO4hR1
evvOnXk+xyMe0IRm5OlXuiefq/hKt9GZSy6XK3Csd4Jinc9MtrvM3MUpHsQQ
buzT9rd8jXsE7/SO53WT/Gt/ygtYxLvcYtfpfAfaUWveZl7DZf7LhP2H3CpP
yZN4M0twyuw58v8d/wDp1UAb
                "]]},
              "0.25`"],
             Annotation[#, 0.25, "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl07lPlFEUhvGrECOyqGBjkEJBiEEhxsQFqCwsLGTVBMSoJCpYMIU4IwiR
RVAroXRhmRHFyqVRI4mNCPwBYilGS6Wx1Jj4u6F48pz7nnPP981MZndHoql7
QwhhAWs5IaRyQ7ibF8I9ZKnHZElObglhhG9jFOU4gi/5IbzVW+F3XC2rin33
K7ARZ+QJ2T71R3OzzgN8mjN8jac5jRl8Rg+uxx5SSKLF3E3uxw30oReXveMj
foyHmMIkEuYPee60505ha0EI3bIHcdZ5Egf177tfyEXYqV/PDTgs32HmGH+S
p/DS+RVe46iZGb299pVjD8pQihH5d/M/MK/+xo3mm9CMVtTIf8vruNa+Ftkq
vqJE/ovX8BNt+q1ox1mcQ1qeie+AWWzy+Z7wfr1KvLCj1+4a2ZB6GG3Iijs4
O+7kQe87hFtod+5054L6Is7jhGyXHcU46VzhvOzum/i98BIW8Q+XYmZmEQtY
xhKeujOHv+pnfNxcmv84Z/gUrqob4vO5nru4w9x7no/fr/1lKEWf/vP4+/M2
n/uA7IN6O/fEjItQiDpztdis7tQbV1/hfPfGZHcwIeuSFchG89b/C/8Bc0hj
4A==
                "]]},
              "0.2`"],
             Annotation[#, 0.2, "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl01tMjnEcwPGnjQv1ZrPpMIfpxcZsNjdcINLrGHPh5s1hKGc2pkRXFRe4
ZDPjwmyumCJkNhdUjPVWNi7kFNUmS81KziM+/7n47vs7/p/neZ/njZceWLc/
LYqiXuTEouh4RhRd44tjomi8eG5mFM3Da3En3qBP7y5/5Ht8nT+l2+Nu/sC9
XM9Z+je4T75VvAVN8jM80XUmYBYq1d67Tp25WszUn4FFWIlVuK0+YqaBi+Tz
eQF61Dbb/+ycYQzhK74gpd7JLfyWk/zbTrqdDAyoPVfr5w7+yb/wDT/wHXvV
R49l1xzF+/g8numd41JUOavYuQfVyjBHLSlvVb/CLXyZU7zWeQkUmFuMOrVa
5Omv5w1IokBezNvM7jC3Hd3owlL1ZUhgBZbjkrmUXmt4XsTDmeE5nXNS77Ta
qfBM4kz1EvfYr3dHPlv8SPwYw+E9ynvQFd6B2Xxki2/Zv4kT4kqzueIX/BKD
9prVh/gBD/BZbsT98N6RZX6E/+IPiuylqa3hiFdzk2s1oxEX5IXmEpiGqZiO
OCqcf8hOOY7gcECtgmPeU6HdTc7YE94h8uzs5l3YiSX6G/Wf2nkibseUcL/y
QXFOeC55Lr/iyXYmYaE4Hw/VO1Btvt05NXxM/yhK1NvU6rlKXo2a8FuFbyXc
N78L37p4nPgqN4RvHGUoR3bs/3/yH8tch48=
                "]]},
              "0.15`"],
             Annotation[#, 0.15, "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl1FdsjlEcgPG3dpe6MSJWJVZtQUtsNaNEl5EYcWeUWzEuUASJUdpSK+KC
IIQaLeXCik0IYlzha2mi1HZB/E5cPH3Of53T7/3O+6UuWJa9NC6Kos7+/E6M
okkJUfSLJ/ITPMbu5Cgq4D1JUVSGveigp6/cdLV+nM0v4qPoPG8Rn+XNfI4P
8zM8xRRzgziNd3BHe6WiEwaL6+TT+RPnmI3xV+4vV21dgznIddZfuTz+IK7F
ewyQ+8xDuNJcBmdwO07noRiCq+aK9V3jUr6OG/gibqoej2b4JG7MddyEG+np
zsn268Zp6IFD6n24L3qiN3pho3yt3kc+32XrIvNXeKTaKAyXH4HRct/0ZfKY
EKNQfEpPKrcxVyJXjMXiUvkE6+Xy9/g+KsxuFefho3o+z8QMjFd7pyeGt6hB
NS7Kj1O/Zc/byJKbglrzlWoPrB9iu54GzaNoGzfkWWpx/FM8wdxiPUtQgNZy
WeE5hO+bp2EqTqK92iaz1daL1OPD5xHvlz+AMuzDXoySz0IPfd1RbKYERdiF
nVioPl9tfXjW2IA54kKex2t5Lq/jkXqHOW+d+Li4K0/iLtzWeSvUj/MJHMNL
8Wf9+fxdPFbfN87kH9yBv4T7iXrMDWejXv6O+C5uh2eL2aiyz3u1GqwJ3wfH
wr22jszFoUrfpfCsw91TS3J+MhKRguZoK9+Em6IxVmIFVmMVLpiPhXeRK1GB
N+LTXI4z4R0UNwjvC2eYSUcr+7aQS8ER+Wf8HE/D/VEfhwmYrDaRB2FgwP/a
0myi+3BEfBQHzdzU98r6NXKRg2y5P3pzOF+ch03icnv0Sfj/G/QPeJSaQw==

                "]]},
              "0.1`"],
             Annotation[#, 0.1, "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl1WdsVlUYwPFTFZC2FNwSVyQxUeOixRUUHCgYZNVojJqozA92gZqIpXwg
QbEstUWGgialZSQEKBFQKRWMI1JpoUUKlCVNRAVxMC2Ivyd++Pf/rHPu+957
3tsbRxbnF2WklKr9Odw1pdezUmpCl5yUpsgvzkzp2m4pXYfPslP6Ap/jQ716
/hIbsBF1uNRcsmayPcowCefNNnCjehO2y38318xTcY3aPnlf8d/ifnxAfoO4
QnxYXCIuskch9qit4Blq17vmIr6ZP+ZKnDJfwaPNzeHT8g+4P54W9+Nn+EX9
PZxrbR4O2XOw/Fb9dvF4vku9N+6W90GlNc1m5vBi9SpMMLcb5Wo5eme4Ur0C
7+N03Me4p8iJPc105968WO8ScRX34DZchLnyKeZ/M1MvrhA/jxcwTP5YXF+v
GlVYghrcZu1wvp2HuvYwDMcg83fG81K/gzfxIrW9ce+xVJxn3eXiXL4snpNr
ZfM2bkFXZ6KZM3mh+TK9E2Yn86S4B/FZeSfvQityzGehh/gfa7pzR3xnnsW5
ejP5Z3mBtVvFP/l8jVytV8M/4Ih+A58yM5APynuJXxX3NzdbfFLtXT4TzxzP
6Z21Vxt38F7ej2Pm9vFraDG3Em/oT0SZ2uNxbrkkzgCWYgnGYhw6mf/LHp15
vrnBavN4rbxb3DM8IU+cgWnqtebf5r7yUr3zrnWQ/+UDvEp9JcbE709eww+a
34zj1j7AD8V14vvJ58cZwWrxVF7Fb8U9iGeCAfZ9FA+rP4J54rmYYe+B9pke
Z99cZjxXPCu/ytzVuBIX6vWM3436BeI/xRncyWxnHFcvt9/02BMn5bN5Fmbi
hDzbmj7W7JdvkY/kUXhZfIXeSzyGx2I0hpgdx3l8S5wLXhfnhNfzjngXWP8r
fonfnXxAPCNu1//E3Hfim+L9JC7QK4l7wAvk9WY+4g28EXXxXol3kZlj2Ixa
+SZeE59Xf1ScW+vPogP3qT+JLfb5CkdxBMVq483mi0v4KZ7AI+K9xcV4BYVx
zuO+xLnB9/qtXOSaxSgUH+UibjTXhK3Yjm1YbX4NzolrucXs1/FO4h+xAwXy
3bwTrfH7l+/i9+KdGfcVQzAUPdVL7TNN/Kl4Le6P84FyvIPlrrUM9+itxzL7
reMRyA/LD+EPM+28AMvRFs+Su9j/3njXyFfEmce39j3HpfwmJsY9ln/DDebr
sv7/f/QfYWb47w==
                "]]},
              "0.05`"],
             Annotation[#, 0.05, "Tooltip"]& ], {}, {}}}]}, {{}, 
         GraphicsComplexBox[{{19., 0.4}, {19., 0.4}, {19., 0.4}, {19., 0.4}}, {
           {RGBColor[1, 0, 0], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->20], 3], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->20], 4]}, {}}], {}}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"#VisRE\"", TraditionalForm], 
         FormBox["\"r\"", TraditionalForm]},
       AxesOrigin->{0, 0},
       Method->{},
       PlotLabel->FormBox[
         StyleBox["\"Corr=0.62\"", 20, StripOnInput -> False], 
         TraditionalForm],
       PlotRangeClipping->True], {972., -1574.750603334732}, 
      ImageScaled[{0.5, 0.5}], {360., 222.49223594996192`}], InsetBox[
      GraphicsBox[{{{{}, 
          {RGBColor[0.24720000000000014`, 0.24, 0.6], PointBox[CompressedData["
1:eJw9yXk8FHgDx/E5TBqV5FhRbTnWdpCSq934/nq8EqK2Uu5UjIqKjdLmrEVF
keJ53MWmtA+V62lzj1zjyMw4eqgRSa6exRhGxoxnnz+e/vi+Pq/366t10v8Q
i0ahUM7/tf81MVWu9FrELEaqvdKfVTfj5cOMjVk+i5BZDLeqljYhqMAnYeZ7
ebLhp++oqck8mLirfW9znEpCOAvnryxw8eP5y+oJPgokzYndfukmD5GiMZUL
7vKE52Yc7/GXe/uOSRWYdPKoJfpoYVAzHtySrOobZJIhed/0grdcqB2I8nOm
K5NsdqyPhnwzHFJdHcYfLaDEl7/QGDuIKonWG1b4JJJElA/BDq9gNqmot7l5
KRmy9uZl6vSjPXjBa3OFGNdrqiwU++sxzVEW7GDJYPd86+qS3jf4cPex/a5U
Bol3y/uUtpQLt0TDEmWr5USsy/3BRyLA/XsPHatVqMSu048fqfIawrnJKr7X
GvLuZnm2sw0XpoUmNqEf6ISdGZk+HtOCgyOjay4rUUhYUUzqmD0fAkHxmdmV
SsRs+7eJmyr7Mb5uwzol1jwOuzIFwv1PMTP5t7VdxxWJtNG4eNqwB/+QSR7O
sCR4ls53bj/AQxXjnBxjdh5xduo3KBO10PYpVTW5tYx471jjtCKlGhG/2Bdv
n6SSL7cz6Jfuv4ajoufV987LSaGfjuZPV3nICigRLRmQ4YbdtXf5t17DbXV7
z2/mUlSnrfPacfIPBDtZltS+ohGN2qHW0648GPLmKCF1GmRqicZsVFkHGNqC
i745EiCPeWZMrxUS/5DUZZ2z8EjhXFzKLodfZme6Qso0XOqUjOI+1IF+vaLm
ZZkUh8MS9b2fNqP0tuIeZZ1F/HyhmKbc0AD28960Jt1Z5A+NCyM8y6HhUv7F
ynYK0e9seM80GyH7yN1a+opCPmr55oXJd0D96J1wF/WZr3/E7sdd9WQR6+p7
Azz7czFSOB5V81qMRyQgq7SQjeAed6+oYjF0RQmdZVG1GE+lJovnJNhuvXE+
Ob8GU4tTSRqGKqRc6btk1mo2rsRs+WxvJALbKcQy0P0VuKH96VOGNOJVu5e5
wqABU5L2b00FU4ht+nN96AAHh7Ikx1v9xeia2HzJJIeDtb/TBS5yc3jyMCdg
1QcO3mSvPNUR9R+sVDO43xHRjRMUv42O4zOw9Ta1+Ze4Ebm/jE0azU/Abrkr
0V7RgYorebt0zRcg6VmxJy+3AYMTrcrdyYpERh8Ykz/QgHDnTL/SyzL4S2R7
/c/U42xLnEH47xSyIoWbvdW2Hzb63DmzCwt4K+xs10mrQ31WsFZaFI38kf9e
hG08yFU3N+X7KBGWpU6vWTEX0fm8tLXR81AERew524XKL+efl/97AqG2ko5v
LOqwVjP+1yavecTsz71c8XM9Xpi+17fVYpJ5Rv+zMrdatOjVxOkNz8PHcZVT
+NUmqEQpaIwdUCDUBxFKV8q6YJCkerItaBI3I3dVHPnMxrR35b6AswtwPt2Z
O6LbBtenp8Y7WgfRLKwxpZYU4oRLDsdx9wz8XdWHf1UrgthKIXYqlEomDjY5
8zfWYJmmAX2oRoTQswKLHd58SB0cWUNYhO1243+emG7BbPZro2sUBjkSb76v
vXQA1+Vvb1I7SSMZ1J0jPUMtMGhl6iR20UhC7BEzgVUPkqw+xYdo07/6fRCT
tTlBBIW4tpg7T4uRtbP4FPMBlWzyCrwUV8nGY2F0pVyYENYxwXV6nhyw+YG+
jRNC5EdJBxjsGuhnHMlVlC4hHeOeE0s/vsDhBK2SH/8U4o7l8N/bHarBH80O
D8z/iOgsVQ9PXhEO2AweO8gWo1zhY123UTXuuQuTChpopHE/9xtlpQZ4DN/1
to+mEPHNe1a2Jl1oZ/ns3X1RnvBxMP8+jw8nwzb99Tk0UpFTUu26oRt9DGn8
zlIqORcxsSTL+h12zTUb3xgWwSisLHR5QyNGLTb1GEVJYWweyFm1hQPTW3ss
ZZbT2He3e9CXX/TVITkO7R6MAhyS1rrlXpQjtGy3MIZGLzbrMt5Sbyzi/y4e
X78tL2UGvxk8L/IYGECKQlhVsqoKOTZ3LmMll4tgD6OjzK1iPM9LuyizfYkY
nTrj2xtFoO6RPWSd4kFsnLPF+IUS2VTJzOirbsSTttFmS815JPK3nWiM7kD3
6vyel9Ip0AuGYsPtOaD1/aBtnSXCo7KM06WZT1D12T/gthedRA4KTJzPVmFW
KAl6u4dKzEQZ6aklDdBT0hh2BJWsVmdlTH3iYuT69SbxKINQ1q+0NG9lQ/TE
+jRzlP7V/wW1xWKk
            "]]}, {}}, GraphicsComplexBox[CompressedData["
1:eJx0vXd8j9f7x5+EiBViU6s21VbNKtVz+xjValW1NatKqy2t2kpRLaW0Vs0a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          "], {{{}, {}, {}, {}, {}, {}, {}, {}, {}, {}}, {{}, 
            TagBox[
             TooltipBox[
              {RGBColor[0, 1, 0], 
               LineBox[{4390, 5831, 5832, 4202, 4608, 4609, 4606, 6169, 6170, 
                6167, 4607, 6168, 5623, 5624, 5281, 5283, 5282, 4163, 5285, 
                5286, 5284, 4302, 4666, 6255, 4169, 4942, 4561, 6141, 4563, 
                6140, 4562, 5138, 5137, 5136, 4360, 5356, 4687, 5925, 5926, 
                5786, 5787, 6162, 4598, 5827, 5828, 5829, 4905, 4972, 4903, 
                4904, 4597, 6160, 4596, 6161, 4120, 5302, 4121, 5102, 5101, 
                4307, 4714, 4099, 4846, 4745, 4746, 4390}]},
              "2.25`"],
             Annotation[#, 2.25, "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl0Tss3VEcB/CfpQvSoi4JiyAhJe1ibeI1eExmizJ71XPxiOu1tI1IEBMm
dmYWUq/EazKyXSqSNkHS1Oemwyffe87vd37n5H9LvvS0dWdExDhXORGbiYgt
mt9FvMmLqCmMOCuIOGfKfpJqtc9qs37PMM2l+gV7+RGZ8lZPtsxi0owJTvQd
U+WeRvuFckx/r1y07pF/rbNyI0r1l1PGJ/tN6h9ls6wye1XPizc885Rmb9nZ
Dv0rcol2d628j9hXW5IHMmG/0px8WSHX5QZrfLPeNv9E7ym/zf3DB+fO1QcZ
YoARhrlR65df6eOH899JOLfn/l0azEqZXSs79V97e5est67jXs8vHkhxRy3X
b307vSlazGxNfzN3FFPEqBl3avckzf/pzkOO2LH36PyM+bNMM8+C7zMnb9Nv
51/B///9Fc6rURI=
                "]]},
              "2"],
             Annotation[#, 2, "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl0rtPE1AUx/GjKAlWojxq0UjBAIKDSPkHHIjKDIqR6MLAUgIT6CwOosLE
wO5ggeogDi4+oiNhkkQSo0SCCSXykMUAkvBpHL753t+55557+7jQN9Q1eCQi
JtFeEXGnOiKdjFg6E/HgdESd9X2+pd6Nc/JZZPQ+rIzIqo3bn7Se4Ec1EaPW
Deq35Xq9Pfxd7QdGMIw1VJhx0n45dvXXywnrAi/yOm/zPO/wBn/j3/yHG839
wDPyG57lj9zH73maX1ZF5PidfNSdu1zCe9ysfsO9nciaNaE+wKvyL0xhBT+x
cyriYvEMmnAJLXiuP+GOu87ew195gS8XZ6ciWrmTU3zFnDZksKynV2+t7+u4
9Xku5TQf45t8nbv4GnfzF28oWL/GHF6Z+dTv9AxtZnV4R6b4OeRxLLn3K4b0
PpazZozxZ+9+wq16rzpzgH/YR97MT/bf2ss79wI5lKlXe/cmtpCQaziFJE7I
G9yvtzb5/790CNwGU7c=
                "]]},
              "1.75`"],
             Annotation[#, 1.75, "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl0ktsjGEUxvFjgYSgnWmnSCoRNmb0IpFakhBxnV4itCJpZyzEho00KRIJ
sWHVBTYS6rYQsaGT6KYrFFOXlmnasNCuWJKqaEJ/Xyz+ed7zvOf2vfnWF093
nFoUEcNYkYo4VBNxGEfwT7yzNmJvdUSneB/dJS5VRazLwH2GX0/rxYvTEWvF
a5DGR/l/6yKm1cy6n8MvjMor4+eqiA/yxvA+ycc4hvS/Qp/Rq8lcNTNyR8w5
uDoijwNoQyvumzNizis8x0u8QLgbVjOrtuh8WV7O3CzO6F3Rt4//0PmH836k
5PfyLvIK8i7RZvEWNKLKfRM9ye9034V5fTO8P/QWfarPIErYbP8HvAaaw71k
X9zFHQwgo65d3912HrPrV+dptPILavJ0jze8yesRd+MYWvhZ/gn+jHiJeCld
huXIir8lc2mdvH47f0/eEHlMoIJ3Zn7BY9/yCMflF+UXaIkO0Cf0Nh2kG/SZ
t+uoeEr8ln6mr+kELdNxWsEnvNF7Cju8x3a0qE3J2UbTSQ87TKJL34323co7
SiflnuddcHeOdtutByvFm7xbDlmcdXed3sA1/FY7h0b1DSib3Zz8e7x+9e20
Db3qOmr+//cLQ4ZwKA==
                "]]},
              "1.5`"],
             Annotation[#, 1.5, "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl00tIVGEYxvHPknQR5NRMIQQSZVRU00UhGgsMMrtYNgVG5WgaQYssimiR
uoiKFs6M0aZFl02Nq1YF7VqkXUncBF0wkgKrTZtWdrPfR4s/z3t93jPnMIu6
TmZ7ykIIo8jOC+FzIoSDdIpm54bwek4Ix+Rv6D66H5N6DckQZs4PoRwJc5vl
m1Ce0lsQQgYb0aT21MxWWmsvqf+oKoS8vIgCUvJ6vkl6wuw38ZC5EmrkO+hO
bMdRnt145uYy8+f1f5gf4TOMU+qN8i14KX6BavE9mjY/Lf6LUV6v0OKZ+u3d
1nuu3idu49lLx/Dd7y6YKyKPqxjELns36S3cwAPPdB8ldy7iEprNXKGXcZb/
bn57MOhOg520Oxk6pf8bf9Bhp8ZMu/phTCOYO6N3GnvtfjBznI7TVppDO8rM
zUBRXMAFDLhbwaMSs+L7tNPoOQ+on+OXki91bzlWYFytV79TPWe+Ex3x/au/
pe+ij7k78ZvyaHGjiT7WH45+8Tvik1om/k48UR9BrVoivmP+/TgSvye6sZDf
JN8vmI2SfAgD9vKo8Dxf1VfZW4lmXtfVt9G75ir1JvARD9UW86y3cyi+SyyR
52gdXY8+M+/trRN3qa+la1An/olquxvc+SXuQatbE7hmr0hXJ///X/4B6HRt
VA==
                "]]},
              "1.25`"],
             Annotation[#, 1.25, "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl00dI12EYwPFXs0NBmaPyFCo5oGEUCQbx1/JcEbYoL7bUtgZBh5Iy7BIF
DZBoWB3Mhh7CMDAwMhtQNmyQG6TUBl0al+jzo8OX7/M+7zPe3x/NKNuzendc
COEvYtNDKE4KoS4lhOModC6dGUIR56SFkItsvJuhJjmEU9P08Uk+mhpCLTr1
deGSnsvoFW9TH68miOMQjxP2JPAELHZXzPkcZ0ZAq/vn+n/K/8JZe85hMjai
PzGEbnSqeYSHeIwu3NL7lJ/hCd76hh7kmP/A7Gw+6E0d4h9mjzi/F3/ANr0v
ze/GHbTru49Gc5pwHfVqmrkFN3E72ok/3vPGvN/8ml+h3ezD+muwzM7laJFv
xj77Rp2ror3Yihr138z6jq+4574NpfLVfvv1clW8gavVl3jLOvEO8yuxVrwC
5eIKrBSvQoN9X7jArHHO5Z36d+GCu0W8z9yFvMmuuWrmYQ7yMB+H5De734Lz
ejLl8s3J4Bt+q175Ppxxl+Bd/eIGPfXuJonHMFG+xzlNzUw0iafKT8E4Fnhz
HuYj0bnR/AHzh7Db+wb5ihmn+Srfjb6dl0Z/c1zJF3kJd5h9j9vQikr5vdFv
E72Nu/kYv+A+rlE/Fu1yPsLDnKIvGbnekoMsDMqPuk+N9kX7sR0V0WxcM6fM
d8fUFmLINwxjMPqtEPMdhUgXZ6stNz+LD3CM96NEf5b7NbxXbYY5A86ZXCf3
2Z7ZzklIRrl8P1dwKqcgXTwLH73zk/oR1NpR5FwgjiX9/5//B6b6k+c=
                "]]},
              "1"],
             Annotation[#, 1, "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl1FtMj3Ecx/EfLpxGoeKCJjZucJVDDi0bNeZGKVTYTKzpwNAFOSSnymkm
OaScmouunJacZjF0Yc6bjTlt0my2VrhheD1z8f5/vofP8/19/8/z/P9JK0sz
S3qFEBJ9FAwLIW5oCLEJIcTTQTQGg6McD2NCqODZgflxIcxDcWwI3+kPdCN2
SAg9NM3141wzm46n79QHjAjhPe1L+6MfyvX7x+vhvrn30IbL5haorcYV+VW8
d34T/wc6x8xrasX6Rdg9PIRq83bRSvlW59SLyyNVz+JfhD1629R20e10L63h
K6H76QEUqpfKW8y/jnr5Cucux1r5KfkUepC3lq9S3ig+Ks5zRi667Hib/w4K
sAqvcc332sy3BTfNSOfNwAu9l6jDGZ5L9BxN58tALe8x1KGv3m+1X6iXH+Gb
Ip6KyZHaZ4ZnMB0pGClPsV+I+vJ1+OLMTpSKG8xoRBlfBc8OnJNnyTPFC2ku
zabn1S+gCTnyPPUlNNs9XhzdN+cspetom702mX+UbqS1tIw20YX6mXhjh7fY
rhbje00wZyKKomeCYrzTG0UTcYj3MJLV/mAn71+6Hs1YJu9w7+/Z4TPNl28U
b8AoO5e49is9KW+2e6Ezn9A78t5264NUcybxjOEdi7tqHWpdat34Yo9OnNE7
i1l6aeozaaO8AR36n9GuNtoOSXiq/gzPkc//ir6Mnj0G2mMMTzL95LpW+9Sp
H8cJzI3eleh9VP+o30Ib+H/avUccI74lbsUNXMdF9Zt0Jf8+WiE/LW5AjpnZ
+OYe1UTvPqpRhQfRb5x3gV0e6/9Ra6dV6nuQKp+FVJ5pUUwr1ZfaIQ+5eMTf
Ec2iE5yzRX+4eQnimfw/xGvi/v/n/APaFqct
                "]]},
              "0.75`"],
             Annotation[#, 0.75, "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwl1XlM13Ucx/EPpluUB2ri2eFflrM1NyekaYo5ITHFA0wKUyssBWetBgmS
lAdZK7GsaLUy88iDw1aWV5lT0Yb2R8c/Vl61DhPQVAi1x2f98fT1fb3Pz+/z
+/6w/+wFkwsTQgh1/undLYTVmN4rhEraiOFdQzhPL6AZTViWFMLs7iEspc/x
i/AoPwcVYsX8es+5PUN4CNMxAw+ir9mz1OxNDmEPRondi3x7ltAXUI65arLN
yEGzXGd9TTRRPEnsejpP/5PYpX4nasU23BTCRvys5hfcILaDv5E+bsZnnk+I
f0w3YY6zbqZbcFL8FDqp/YHvSOfLv27v53QHksW+oDvxhngB7Sy2R30Xmm/H
bs+nzdlGt6KyRwjVtAZnxH9FV7Xb+SQ6hF9jViF9k6bQVNxldp3eWqyJqr4O
v8nN97m76d0UvzOfvUBfsZpCWiNWjQw16fF+1JfKlWCXngb+GL5FlbrEeE/x
Tj2PNz8TE9BPrEzPVc/XMBQpSMXN9iTIXYd26Mu3ifehV+gps17DefsvYEm8
C7vLaSlfgrN8D2cfoG60e7vNvv5I5+ehvfyn8uvM/whTMA1TsVduqpopKIj3
x6/yPMfcdnq+5BeZeVzuJ3TgB9Mn5OciH68666D47qpr60LFqjzvV1safwPO
WkI38E1yG+kzZj+Le/gRGInTZpyJvxvkYIT8yPhOxrtHnr7ddCZNky92jiIs
4HNpIT0q34BE+VvtnEbfodnxHVBTi03qcswd5tzZ9G56RM9h1ONF+eO0kSbr
W0HT9WXggNrR/DnxUXQh7SRWq74OWWL3mTmJVvM18TtDOQaK/SN3By3jn8cx
/igWe+5o/gyzFvK5dJjYcPzoTlvEWnEJh+Qu0np6mR6k98fvxj23R5HPu96O
Rr3f8d+jhS9y1qfi3xq1T9Mj4t+gpxnJOCfWwTtxi3mHxP/mD9LDqMcD/ES9
E+gWszfHd8SuBKQgX26i3DbxrfHs9mWJZ4pd44MdbfQqrqDV5/pAbC3ex3J7
P6STaZZzVMR32Yyhcb76VKzlq+x5G29hktpMtevsGMTfiffUvIsGXLQjT9/D
GGNOGpbp+cues/gdf+IPrFT/Fd0X33vsx9fxdxPvV994jEMG0nFA/Unzx5pd
qW4V5qvdxz/mPH34ZtqLNtHeNEH+dhroADowvg/4RP6yvu20hZ4wd7n4CizD
S6jAeH2z4n3Z38/+IXRw3O9zj3UPj8jNxCt8Hn2ZrsQ4ff+qb8UwdWn8UvEx
8R0Su4QyfnH8G9f9///D/gPUKP6M
                "]]},
              "0.5`"],
             Annotation[#, 0.5, "Tooltip"]& ], 
            TagBox[
             TooltipBox[
              {RGBColor[0, 1, 0], LineBox[CompressedData["
1:eJwlkLkOQVEURbdeYoohxvgDQ2FqUaDyA4aYCjxP+ByJRKtXilbU/oHCEEFC
JJYoVtY9+5x73s2LNo3q0CKpAh+7lIG0Uxr4pBznqUvK4hRZnyzBeUKWxA6v
dMR2fMANZurw8khvqEEdnjZp45AuzF2hDV3owJJ7C+7M2bln7uaWTsyuyLb0
1szMqA32jCD4eyOzIXzGMeZM8jFEyMZkYTzCJsTp53l3EQoQoGeQ+/GQXgkq
1GXI/3ZTP/AO33Gbb7dgD2VqK+45///qCzuAK/I=
                "]], LineBox[CompressedData["
1:eJwl1WlQl1UUgPGXVNxBQNPEUpaa1GkDLSqzRiunmdDSbM/MxrYPLSqBWNoy
lYmWuAKCtrqWmsu4YWpK07jjhCJo2ohCyqQlLZNZ/e704fG5595zzr3v6/++
pIx6aeiLMVEUnffP4s5RVJAQRZ/zIizEgsQoOoAL8VH0dJco6m08WU6TtQr+
lXfweT7ESXymQxQlciN35O+4GbdAczTotU+feh6hZ4667klRdAVul/u3eLL5
i7wVP6vZwme5Ss1atZXc99Io6oP1WIfH1MaH/hzH9Tyb5+Bd/d7BK/oMUp9j
/LL1sfbsK54mvpHLrZ+Qv5nreBN3svZneDb+gzvyQLkf8p280Vyp/ctwk56D
9MziK/kqvGV9pNyzzrxc/g36ZqAbzstL5qbwjuS9Le8S7m2uTr+TKDb3rPVT
xs/wOHGKnMPGW/Wr5mN4Pszzj0jFC+LjvKWjMQqMT+gxhYus/WKur3364HV9
JqLMWq61Up5gj0ZnflKcb3wXpnieu3lApyi6g5P1S1bXlbtyhtzfubO4C78m
/7Iwxjw9x9tzAh4MPfkhrrBHL+u90Qbt0BZJ6ltxa7RAS8Rih/xMZ46z/zk9
4nmI+D5kI1M8mIfZr4X+h8XNuYZjuZr7c7r+t/Jt6Bfy9N2OjWoL5WzgGZzp
GTLQUr+Z4l7q0sTpuMb4WoxWH2t9uvV16tZjPCYgP5zJektuhbGeYRxycEhN
HufiVRwUt5YzSs90/ks8y/xszMGFcD8wH4vsvxhLsDOc27uoMb+Ba3kTj1dT
zkfFbfQ7wg+bewTzze8Rl/FHWIDO4jP6NWIpluGI3ntR7kyZ6jIw03z38P8T
3gt6qNuPiZ5zHzfJr+RJ4gNchVj7f89r7bMGDeryrW8yN1W8T1zk/T1nLslc
V3EyxpjbzF9jC74RV/r91dljutz9xqXqd6mZx7v5pJz3rNVxtvVJ5t/AVvUV
XGjtJ/XfGmd4jqniTF4of49z7sVO7MYuNLP+Ax/DUayRd5xzOVXPq9UWyOnJ
q8zVWlvNR3gFf4Uy6yvDvTVXgxjMddbT3mcRDxSnh7vFqRzn3GkczyXhXjpr
cfi98LbwW+Ms68PkD8cDeNP8cOepN9/Wfg1c70ynMNJa+/AdMteOz4XecuPw
hHGu+hGcxyvl3iInVV1W+K7wzVziLPNwWM1o547kXW8cw7Vcg6nh74Oc33CP
up7h98aPhnuDWc5dEe4Sz8FsrBBvU9tBTQKSkIihau8P345wv7mEi8PdCu+U
V2F5OG94z/jX/+lSXoYl+BJfIE/+XC7CYH2G4IzcXc5zmrPF9+JTfIIB4Rsq
Nw3dkYIeuCi3JtwvHHTeKhQab5d/Oa8O99hcP33744PwfeGh4R4bJ8uZyd34
kLxq/KNnSbiD8j7GWmct1GdGuGdoL+dxc2PsPy58P8Iz6/cZTzH/lJxRuE7e
+wn//x3/D++BI28=
                "]]},
              "0.25`"],
             Annotation[#, 0.25, "Tooltip"]& ], {}, {}}}]}, {{}, 
         GraphicsComplexBox[{{1., 0.4}, {1., 0.4}, {1., 0.4}, {1., 0.4}}, {
           {RGBColor[1, 0, 0], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->20], 3], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->20], 4]}, {}}], {}}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"\[Theta]\"", TraditionalForm], 
         FormBox["\"r\"", TraditionalForm]},
       AxesOrigin->{0, 0},
       Method->{},
       PlotLabel->FormBox[
         StyleBox["\"Corr=0.28\"", 20, StripOnInput -> False], 
         TraditionalForm],
       PlotRangeClipping->True], {1360.8000000000002`, -1574.750603334732}, 
      ImageScaled[{0.5, 0.5}], {359.9999999999998, 222.49223594996192`}]}, {
     InsetBox[
      GraphicsBox[{{}, {}, 
        {GrayLevel[0], Thickness[Large], LineBox[CompressedData["
1:eJxF1Xk0ld/XAHCZp8qYyHQvFTIl7lXR3qkkGSOpTKEyZSiKkplEGYqQEskU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          "]]}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"inv\"", TraditionalForm], 
         FormBox["\"Freq\"", TraditionalForm]},
       AxesOrigin->{0, 0},
       Method->{},
       PlotRange->{All, All},
       PlotRangeClipping->True,
       PlotRangePadding->{Automatic, Automatic}], {194.4, -1817.0199269246907`},
       ImageScaled[{0.5, 0.5}], {360.00000000000006`, 222.49223594996192`}], 
     InsetBox[
      GraphicsBox[{{}, {}, 
        {GrayLevel[0], Thickness[Large], LineBox[CompressedData["
1:eJxF13k8VP/XAHCJrEmWQsoWhlCKsczkHJMlY8ZS9uykEiJEtqzDTIulbGWn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          "]]}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"vis\"", TraditionalForm], 
         FormBox["\"Freq\"", TraditionalForm]},
       AxesOrigin->{10., 0},
       Method->{},
       PlotRange->{All, All},
       PlotRangeClipping->True,
       PlotRangePadding->{Automatic, Automatic}], {583.2, -1817.0199269246907`},
       ImageScaled[{0.5, 0.5}], {360.00000000000006`, 222.49223594996192`}], 
     InsetBox[
      GraphicsBox[{{}, {}, 
        {GrayLevel[0], Thickness[Large], LineBox[CompressedData["
1:eJwVl3k41O33x2WNoqxRnsiSfcsSYs4ZMmIwY0ZFVCgRka0spXyJ7ESWkDC2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          "]]}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"tot\"", TraditionalForm], 
         FormBox["\"Freq\"", TraditionalForm]},
       AxesOrigin->{0, 0},
       Method->{},
       PlotRange->{All, All},
       PlotRangeClipping->True,
       PlotRangePadding->{Automatic, Automatic}], {972., -1817.0199269246907`},
       ImageScaled[{0.5, 0.5}], {360., 222.49223594996192`}], InsetBox[
      GraphicsBox[{{}, {}, 
        {GrayLevel[0], Thickness[Large], LineBox[CompressedData["
1:eJxF13k8VP/3B3BkLWSphBRpsZYSKvK6thaFPtIiKslSREpJiWxpI0LZU1HZ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          "]]}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"inv/tot\"", TraditionalForm], 
         FormBox["\"Freq\"", TraditionalForm]},
       AxesOrigin->{0, 0},
       Method->{},
       PlotRange->{All, All},
       PlotRangeClipping->True,
       PlotRangePadding->{Automatic, Automatic}], {1360.8000000000002`, -1817.0199269246907`},
       ImageScaled[{0.5, 0.5}], {359.9999999999998, 222.49223594996192`}]}}, \
{}},
  ContentSelectable->True,
  ImageSize->900,
  PlotRangePadding->{6, 5}]], "Output",
 CellChangeTimes->{3.5857641371843786`*^9, 3.585764874941576*^9, 
  3.5857649258144855`*^9},ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
  "******)"}]], "Input",
 CellChangeTimes->{{3.4940977943255997`*^9, 3.494097801075859*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mapfun", "=", 
   RowBox[{"Function", "[", 
    RowBox[{
     RowBox[{"{", "x", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"sls", ",", "trls", ",", "yls"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"sls", ",", "trls"}], "}"}], "=", 
         RowBox[{"Transpose", "[", "x", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"yls", "=", 
         RowBox[{"ysnp", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"trls", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"IndexByInterpolation", "[", 
            RowBox[{"Append", "[", 
             RowBox[{"sls", ",", 
              RowBox[{"nbp", "+", "1"}]}], "]"}], "]"}], "[", "yls", "]"}], 
          "]"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5507285226347723`*^9, 3.5507285241258574`*^9}, 
   3.550793585615654*^9, 3.5507969815848923`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"nminor", "=", 
   RowBox[{"Total", "[", 
    RowBox[{
     RowBox[{"ysnp", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "2"}], "]"}], "]"}], ",", 
     RowBox[{"{", "2", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"1", "\[Equal]", "1"}], ",", 
    RowBox[{"nminor", "=", 
     RowBox[{"nminor", "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"x_", "/;", 
         RowBox[{"x", "\[GreaterEqual]", 
          RowBox[{"nsq", "/", "2"}]}]}], ":>", 
        RowBox[{"nsq", "-", "x"}]}], "}"}]}]}]}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{3.529244754594556*^9, 3.5292713087687902`*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"restr", "=", 
   RowBox[{"rescold", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "4", ",", "All", ",", 
      RowBox[{";;", "2"}]}], "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"restr", "=", 
    RowBox[{"Map", "[", 
     RowBox[{"mapfun", ",", "restr"}], "]"}]}], ";"}], "//", 
  "Timing"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"truetrees", "=", 
    RowBox[{"mapfun", "[", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"truetreeloc", ",", "truetreels"}], "}"}], "]"}], "]"}]}], 
   ";"}], "//", "Timing"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"restr", "=", 
    RowBox[{"N", "[", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"MapThread", "[", 
         RowBox[{"TreeRFDistance", ",", 
          RowBox[{"{", 
           RowBox[{"truetrees", ",", "#"}], "}"}]}], "]"}], "&"}], ",", 
       "restr"}], "]"}], "]"}]}], ";"}], "//", "Timing"}]}], "Input",
 CellChangeTimes->{{3.52503275733928*^9, 3.5250327606204853`*^9}, {
   3.5250328577146482`*^9, 3.525032867277465*^9}, {3.52503291076314*^9, 
   3.525032945227599*^9}, {3.5250329838552666`*^9, 3.5250329842764673`*^9}, {
   3.5250336441591845`*^9, 3.5250336452811866`*^9}, {3.5250343666428103`*^9, 
   3.5250343829104366`*^9}, {3.525034757464673*^9, 3.525034770057495*^9}, {
   3.525034842338419*^9, 3.52503484283762*^9}, {3.525034906088527*^9, 
   3.5250349185125484`*^9}, {3.5250350146951127`*^9, 
   3.5250350148511133`*^9}, {3.5250449058860874`*^9, 
   3.5250449085848923`*^9}, {3.5250457418291554`*^9, 
   3.5250457702992053`*^9}, {3.5250485058777795`*^9, 
   3.5250485150245924`*^9}, {3.5250505893365145`*^9, 
   3.5250505895365148`*^9}, {3.525051506691838*^9, 3.5250515109318438`*^9}, {
   3.529244887187689*^9, 3.5292448876400895`*^9}, {3.5292718856422033`*^9, 
   3.5292718861102047`*^9}, {3.5293423353527894`*^9, 3.529342335652794*^9}, {
   3.52935115183846*^9, 3.5293511592172728`*^9}, {3.54889182719893*^9, 
   3.5488918315357375`*^9}, {3.5561771069459753`*^9, 3.556177107829026*^9}, 
   3.5677475424028106`*^9, {3.571697717948491*^9, 3.5716977345313196`*^9}, {
   3.5716980245982294`*^9, 3.571698027312634*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.29640189999999999592716903862310573459`5.4924808965169785", ",", 
   "Null"}], "}"}]], "Output",
 CellChangeTimes->{3.5857641392924995`*^9, 3.5857648763856583`*^9, 
  3.5857649267455387`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.`", ",", "Null"}], "}"}]], "Output",
 CellChangeTimes->{3.5857641392924995`*^9, 3.5857648763856583`*^9, 
  3.585764926751539*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "3.88442489999999995831103660748340189457`6.609926642659887", ",", "Null"}],
   "}"}]], "Output",
 CellChangeTimes->{3.5857641392924995`*^9, 3.5857648763856583`*^9, 
  3.5857649306367617`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
  "******)"}]], "Input",
 CellChangeTimes->{{3.4940977943255997`*^9, 3.494097801075859*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
  "******)"}]], "Input",
 CellChangeTimes->{{3.4940977943255997`*^9, 3.494097801075859*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"level", "=", 
   RowBox[{"{", 
    RowBox[{"0.025", ",", "0.5", ",", "0.975"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ls", "=", 
   RowBox[{"Quantile", "[", 
    RowBox[{"restr", ",", "level"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"errls", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"ysnp", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "1"}], "]"}], "]"}], "/", "1000."}], ",", 
         RowBox[{"ls", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "2"}], "]"}], "]"}]}], "}"}], "]"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"ErrorBar", "[", "#", "]"}], "&"}], "/@", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"ls", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "1"}], "]"}], "]"}], "-", 
           RowBox[{"ls", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ",", 
          RowBox[{
           RowBox[{"ls", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "3"}], "]"}], "]"}], "-", 
           RowBox[{"ls", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "2"}], "]"}], "]"}]}]}], "}"}], "]"}]}]}], 
     "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"g", "=", 
   RowBox[{"ErrorListPlot", "[", 
    RowBox[{"errls", ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"All", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "0.05"}], ",", "1"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"PlotMarkers", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Automatic", ",", "0"}], "}"}]}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", "linegray"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"g", "=", 
   RowBox[{"Show", "[", 
    RowBox[{"g", ",", 
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"errls", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "1"}], "]"}], "]"}], ",", 
       RowBox[{"PlotMarkers", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Automatic", ",", "6"}], "}"}]}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", "Black"}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"priqdist", "=", 
   RowBox[{"ReadList", "[", 
    RowBox[{
    "\"\<priTreeRFDistance_\>\"", "<>", "dataid", "<>", "\"\<.txt\>\""}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"truetreeloc", "==", 
  RowBox[{"priqdist", "[", 
   RowBox[{"[", 
    RowBox[{"All", ",", "1"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"N", "[", 
  RowBox[{"Mean", "[", 
   RowBox[{"priqdist", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", 
      RowBox[{"-", "1"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "3", ",", "5"}], "}"}]}], "]"}], "]"}], "]"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"g30", "=", 
   RowBox[{"Table", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"ls", "=", 
       RowBox[{"Transpose", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Append", "[", 
              RowBox[{
               RowBox[{"priqdist", "[", 
                RowBox[{"[", 
                 RowBox[{"All", ",", "1"}], "]"}], "]"}], ",", 
               RowBox[{"nbp", "+", "1"}]}], "]"}], "-", "1"}], " ", ")"}], 
           "/", "1000."}], ",", 
          RowBox[{"Prepend", "[", 
           RowBox[{
            RowBox[{"priqdist", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", 
               RowBox[{"-", "1"}], ",", "i"}], "]"}], "]"}], ",", 
            RowBox[{"First", "[", 
             RowBox[{"priqdist", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", 
                RowBox[{"-", "1"}], ",", "i"}], "]"}], "]"}], "]"}]}], 
           "]"}]}], "}"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"ls", "=", 
       RowBox[{"DeleteDuplicates", "[", "ls", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"priq", "=", 
       RowBox[{"Interpolation", "[", 
        RowBox[{"ls", ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "0"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Print", "[", 
       RowBox[{"\"\<i=\>\"", ",", "i", ",", "\"\<;\>\"", ",", 
        RowBox[{
         RowBox[{"priq", "[", 
          RowBox[{"ls", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "1"}], "]"}], "]"}], "]"}], "==", 
         RowBox[{"ls", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "2"}], "]"}], "]"}]}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Plot", "[", 
       RowBox[{
        RowBox[{"priq", "[", "x", "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", "0", ",", 
          RowBox[{"nbp", "/", "1000"}]}], "}"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Gray", ",", 
           RowBox[{"Thickness", "[", "linethick", "]"}], ",", "Dashed"}], 
          "}"}]}], ",", 
        RowBox[{"PlotPoints", "\[Rule]", "100"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "3", ",", "5"}], "}"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Transpose", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"priqdist", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "1"}], "]"}], "]"}], "/", "1000."}], ",", 
     RowBox[{"priqdist", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", 
        RowBox[{"-", "1"}], ",", "1"}], "]"}], "]"}]}], "}"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"g3", "=", 
   RowBox[{"Show", "[", "g30", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gtrcor", "=", 
   RowBox[{"Show", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"g", ",", "g3"}], "}"}], ",", 
     RowBox[{"AxesOrigin", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "0.05"}]}], "}"}]}], ",", 
     RowBox[{"PlotRangePadding", "\[Rule]", "None"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<x(kbp)\>\"", ",", 
        "\"\<RF(T,\!\(\*SubscriptBox[\(T\), \(true\)]\))\>\""}], "}"}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gtrcor2", "=", 
   RowBox[{"Show", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ListPlot", "[", 
      RowBox[{
       RowBox[{"errls", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "1"}], "]"}], "]"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
       RowBox[{"PlotMarkers", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Automatic", ",", "6"}], "}"}]}], ",", 
       RowBox[{"Joined", "\[Rule]", "True"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", "linestyle"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"g30", "[", 
      RowBox[{"[", "3", "]"}], "]"}], ",", 
     RowBox[{"PlotRangePadding", "\[Rule]", "None"}], ",", 
     RowBox[{"AxesLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "\"\<x(kbp)\>\"", ",", 
        "\"\<RF(T,\!\(\*SubscriptBox[\(T\), \(true\)]\))\>\""}], "}"}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"GraphicsGrid", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"gtrcor", ",", "gtrcor2"}], "}"}], "}"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "800"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.525184654698452*^9, 3.525184655213481*^9}, {
   3.5252715089894495`*^9, 3.5252715180218496`*^9}, 3.5252734974760494`*^9, {
   3.5252835959579496`*^9, 3.5252835965679493`*^9}, 3.525358183876421*^9, 
   3.5256113520853376`*^9, {3.5256381487413855`*^9, 3.525638148912986*^9}, {
   3.5256388992536182`*^9, 3.5256388995344186`*^9}, 3.5256557961863155`*^9, 
   3.5257838153815975`*^9, 3.52588007185532*^9, 3.5263001653819933`*^9, 
   3.52631238166194*^9, {3.5265077724603815`*^9, 3.526507787282091*^9}, {
   3.5265082492967796`*^9, 3.5265082577839956`*^9}, {3.5267854283756824`*^9, 
   3.526785442955703*^9}, {3.5267854855157623`*^9, 3.5267856164459457`*^9}, 
   3.526785650425993*^9, {3.526785690296049*^9, 3.52678569129605*^9}, {
   3.52683170396947*^9, 3.526831705810273*^9}, 3.526831811924835*^9, 
   3.5268319608210497`*^9, {3.5268375096210685`*^9, 3.5268375110110703`*^9}, 
   3.527214423607006*^9, 3.5272177562634354`*^9, 3.5293326879024673`*^9, 
   3.529371000625268*^9, 3.5294158627391458`*^9, 3.5295479117814894`*^9, {
   3.5391001218964295`*^9, 3.5391001248027725`*^9}, {3.545436743014824*^9, 
   3.545436743607625*^9}, 3.545437564915292*^9, 3.5507287846297574`*^9, 
   3.5510689417807302`*^9, 3.551148233470498*^9, {3.5560751235461426`*^9, 
   3.5560751476205196`*^9}, 3.5560752322483597`*^9, {3.5560752623740835`*^9, 
   3.55607528819656*^9}, {3.5560753809128633`*^9, 3.556075381223881*^9}, 
   3.5560758019429445`*^9, {3.5560854775788364`*^9, 3.5560855264076295`*^9}, {
   3.5560861200025806`*^9, 3.556086120725622*^9}, {3.556086169966439*^9, 
   3.556086178664936*^9}, {3.5560866688799753`*^9, 3.5560867060481005`*^9}, {
   3.5560881641835012`*^9, 3.556088193656187*^9}, {3.5560890524152665`*^9, 
   3.556089052600277*^9}, 3.5560894201983023`*^9, 3.556089485281025*^9, {
   3.556090588954447*^9, 3.5560905932776947`*^9}, {3.556090630350815*^9, 
   3.556090657782384*^9}, {3.556091473630048*^9, 3.556091475729168*^9}, {
   3.5561028129117317`*^9, 3.556102832508853*^9}, 3.556708710462222*^9, {
   3.556708774958643*^9, 3.5567087768462462`*^9}, {3.556708845996076*^9, 
   3.5567088509029875`*^9}, {3.567747568560857*^9, 3.567747571602862*^9}, {
   3.5716983224027524`*^9, 3.5716983231671534`*^9}, {3.57169837226044*^9, 
   3.57169837249444*^9}, {3.5716997590800767`*^9, 3.5716997793913126`*^9}, {
   3.571830754434538*^9, 3.5718307549225664`*^9}, {3.5718799021475286`*^9, 
   3.571879902412729*^9}, 3.571883469277794*^9, {3.571883714791025*^9, 
   3.5718837294550505`*^9}, 3.5718841060085125`*^9, {3.5718841608114085`*^9, 
   3.5718842007630787`*^9}, {3.571884246627159*^9, 3.57188424695476*^9}, 
   3.571884342645328*^9, 3.571914835690941*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.585764144499797*^9, 3.58576488445212*^9, 
  3.5857649307237663`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"12.215384615384615`", ",", "16.`", ",", "16.`"}], "}"}]], "Output",
 CellChangeTimes->{3.585764144499797*^9, 3.58576488445212*^9, 
  3.585764930725766*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=\"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\";\"\>", "\[InvisibleSpace]", "True"}],
  SequenceForm["i=", 1, ";", True],
  Editable->False]], "Print",
 CellChangeTimes->{3.5857641445037975`*^9, 3.585764884469121*^9, 
  3.585764930752768*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=\"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\";\"\>", "\[InvisibleSpace]", "True"}],
  SequenceForm["i=", 3, ";", True],
  Editable->False]], "Print",
 CellChangeTimes->{3.5857641445037975`*^9, 3.585764884469121*^9, 
  3.5857649307547684`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"i=\"\>", "\[InvisibleSpace]", "5", 
   "\[InvisibleSpace]", "\<\";\"\>", "\[InvisibleSpace]", "True"}],
  SequenceForm["i=", 5, ";", True],
  Editable->False]], "Print",
 CellChangeTimes->{3.5857641445037975`*^9, 3.585764884469121*^9, 
  3.585764930756768*^9}]
}, Open  ]],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{{{{}, GraphicsComplexBox[CompressedData["
1:eJxd1QlIVFEUBuDRwkJMNM2GMlPLVKayzcx1xtxTc21FWi1KSsUyQkWwEpOo
aHGrRCzFhJDIEElbDGmRyrJISmyhRaXNXcycuvc4nt/pwTB83Hcf5517znl2
O5KidxkqFIpj4if/F90o/lXxoEOtoKtbrW9bzeWAmr7RV/1sWg4dYEfX2mR/
i5qmGffPDLXrlltm7Jlvng3F7DRnjz0fnnrNenO8pwX763P7tmGtNXu5vPrs
2O8jThYknrVnr91httH9poPOSs3k9aaLbsxx5PWqoI9plokqXr9bMsul/bOK
1y812l5PcVrMXmNiqMoZXML3J00/eq/JYCmb4jkHPwx1y/X9AFN8vf+tK5ax
TWUCpsAiebU2DvDVB3IDnGMlEwiLl310KBP+U9nTEn4Ebr2S7G1cADc0lQbU
VMPOcafvD3TCPsZixyic73diX8fs5ez9HSOVPcvgSPF60/3g7yL87FD46RNx
hcGfyi822kbClM/tsEv7fKOsVFicVlVQA3z2hyiod/C8tuHMBK8V7GC5IQeW
x1/cDKtkAme66udvC5x6Tjl5fRVcJtLXOmkluzBRBGwMi+yMVJrDVA8W8Opt
X57bz4Y1ohtCwmCqv3jYKCtPZBymfCXDM2QBn4f3nhEJyYN/ZybUH3wJU/+9
hWX3HnZ2049nISyqwSkuCTaXCbJapbPZWL/uhql+K2Bq378w5SvBne0vE5YL
y/TfKYGp32rg5qGYT+V18Ni8gA3lgS72YA86iYJeB+/ylB0I03gqhKmfquG6
EBHAQ1i2h5O1J5uOxxGmeALhfpHergmmetswbt15pMFeMrxTMOXnMfaPzVs4
UFLpxb5QJK5N8MtwMQCLYIq/Hqb8voa1ItwF5t5squco2HGpnMjwgT2i4LbC
6ZayIP9bL4FpexlM/aaFe1tEwEofNtWPGvaQ9THBc+WAzIRp3D+Caf7HqtnX
U0RAcTB9X9JhOp9WmPJhoOHzoHl4G6bnN8KdYhy2ePuy6f18YOqnCJie/8KP
LdvPJNqfTf2fEaCz7ns2P5BN9dEVyPfH0oAI0o8vFqb8HocpX7WwHSUIzvWV
AyuY80HfS+24u9ViWpcG5Afz/frrSs0/TXL6Xg==
          "], {
           {GrayLevel[0.65], {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 2], {LineBox[{{0.743, 12.}, {0.743, 2.}}], 
              LineBox[{
               Offset[{1.5, 0}, {0.743, 12.}], 
                Offset[{-1.5, 0}, {0.743, 12.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {0.743, 2.}], 
                Offset[{-1.5, 0}, {0.743, 2.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 3], {LineBox[{{1.302, 12.}, {1.302, 2.}}], 
              LineBox[{
               Offset[{1.5, 0}, {1.302, 12.}], 
                Offset[{-1.5, 0}, {1.302, 12.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {1.302, 2.}], 
                Offset[{-1.5, 0}, {1.302, 2.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 4], {LineBox[{{1.331, 12.}, {1.331, 2.}}], 
              LineBox[{
               Offset[{1.5, 0}, {1.331, 12.}], 
                Offset[{-1.5, 0}, {1.331, 12.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {1.331, 2.}], 
                Offset[{-1.5, 0}, {1.331, 2.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 5], {LineBox[{{3.665, 12.}, {3.665, 2.}}], 
              LineBox[{
               Offset[{1.5, 0}, {3.665, 12.}], 
                Offset[{-1.5, 0}, {3.665, 12.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {3.665, 2.}], 
                Offset[{-1.5, 0}, {3.665, 2.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 6], {LineBox[{{4.182, 12.}, {4.182, 2.}}], 
              LineBox[{
               Offset[{1.5, 0}, {4.182, 12.}], 
                Offset[{-1.5, 0}, {4.182, 12.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {4.182, 2.}], 
                Offset[{-1.5, 0}, {4.182, 2.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 7], {LineBox[{{4.347, 12.}, {4.347, 2.}}], 
              LineBox[{
               Offset[{1.5, 0}, {4.347, 12.}], 
                Offset[{-1.5, 0}, {4.347, 12.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {4.347, 2.}], 
                Offset[{-1.5, 0}, {4.347, 2.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 8], {LineBox[{{4.444, 12.}, {4.444, 2.}}], 
              LineBox[{
               Offset[{1.5, 0}, {4.444, 12.}], 
                Offset[{-1.5, 0}, {4.444, 12.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {4.444, 2.}], 
                Offset[{-1.5, 0}, {4.444, 2.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 9], {LineBox[{{4.808, 12.}, {4.808, 2.}}], 
              LineBox[{
               Offset[{1.5, 0}, {4.808, 12.}], 
                Offset[{-1.5, 0}, {4.808, 12.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {4.808, 2.}], 
                Offset[{-1.5, 0}, {4.808, 2.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 10], {
              LineBox[{{7.2490000000000006`, 12.}, {7.2490000000000006`, 
               2.}}], LineBox[{
               Offset[{1.5, 0}, {7.2490000000000006`, 12.}], 
                Offset[{-1.5, 0}, {7.2490000000000006`, 12.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {7.2490000000000006`, 2.}], 
                Offset[{-1.5, 0}, {7.2490000000000006`, 2.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 11], {LineBox[{{8.975, 10.}, {8.975, 2.}}], 
              LineBox[{
               Offset[{1.5, 0}, {8.975, 10.}], 
                Offset[{-1.5, 0}, {8.975, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {8.975, 2.}], 
                Offset[{-1.5, 0}, {8.975, 2.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 12], {LineBox[{{9.286, 10.}, {9.286, 2.}}], 
              LineBox[{
               Offset[{1.5, 0}, {9.286, 10.}], 
                Offset[{-1.5, 0}, {9.286, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {9.286, 2.}], 
                Offset[{-1.5, 0}, {9.286, 2.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 13], {LineBox[{{10.852, 12.}, {10.852, 2.}}], 
              LineBox[{
               Offset[{1.5, 0}, {10.852, 12.}], 
                Offset[{-1.5, 0}, {10.852, 12.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {10.852, 2.}], 
                Offset[{-1.5, 0}, {10.852, 2.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 14], {LineBox[{{11.558, 12.}, {11.558, 2.}}], 
              LineBox[{
               Offset[{1.5, 0}, {11.558, 12.}], 
                Offset[{-1.5, 0}, {11.558, 12.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {11.558, 2.}], 
                Offset[{-1.5, 0}, {11.558, 2.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 15], {LineBox[{{13.715, 12.}, {13.715, 2.}}], 
              LineBox[{
               Offset[{1.5, 0}, {13.715, 12.}], 
                Offset[{-1.5, 0}, {13.715, 12.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {13.715, 2.}], 
                Offset[{-1.5, 0}, {13.715, 2.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 16], {
              LineBox[{{13.947000000000001`, 12.}, {13.947000000000001`, 
               2.}}], LineBox[{
               Offset[{1.5, 0}, {13.947000000000001`, 12.}], 
                Offset[{-1.5, 0}, {13.947000000000001`, 12.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {13.947000000000001`, 2.}], 
                Offset[{-1.5, 0}, {13.947000000000001`, 2.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 17], {LineBox[{{15.079, 12.}, {15.079, 2.}}], 
              LineBox[{
               Offset[{1.5, 0}, {15.079, 12.}], 
                Offset[{-1.5, 0}, {15.079, 12.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {15.079, 2.}], 
                Offset[{-1.5, 0}, {15.079, 2.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 18], {LineBox[{{16.963, 12.}, {16.963, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {16.963, 12.}], 
                Offset[{-1.5, 0}, {16.963, 12.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {16.963, 0.}], 
                Offset[{-1.5, 0}, {16.963, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 19], {LineBox[{{17.007, 12.}, {17.007, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {17.007, 12.}], 
                Offset[{-1.5, 0}, {17.007, 12.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {17.007, 0.}], 
                Offset[{-1.5, 0}, {17.007, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 20], {LineBox[{{17.575, 10.}, {17.575, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {17.575, 10.}], 
                Offset[{-1.5, 0}, {17.575, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {17.575, 0.}], 
                Offset[{-1.5, 0}, {17.575, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 21], {LineBox[{{17.876, 10.}, {17.876, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {17.876, 10.}], 
                Offset[{-1.5, 0}, {17.876, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {17.876, 0.}], 
                Offset[{-1.5, 0}, {17.876, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 22], {LineBox[{{17.947, 10.}, {17.947, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {17.947, 10.}], 
                Offset[{-1.5, 0}, {17.947, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {17.947, 0.}], 
                Offset[{-1.5, 0}, {17.947, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 23], {LineBox[{{18.001, 10.}, {18.001, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {18.001, 10.}], 
                Offset[{-1.5, 0}, {18.001, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {18.001, 0.}], 
                Offset[{-1.5, 0}, {18.001, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 24], {LineBox[{{18.031, 10.}, {18.031, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {18.031, 10.}], 
                Offset[{-1.5, 0}, {18.031, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {18.031, 0.}], 
                Offset[{-1.5, 0}, {18.031, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 25], {LineBox[{{18.145, 10.}, {18.145, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {18.145, 10.}], 
                Offset[{-1.5, 0}, {18.145, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {18.145, 0.}], 
                Offset[{-1.5, 0}, {18.145, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 26], {LineBox[{{18.256, 10.}, {18.256, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {18.256, 10.}], 
                Offset[{-1.5, 0}, {18.256, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {18.256, 0.}], 
                Offset[{-1.5, 0}, {18.256, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 27], {LineBox[{{18.328, 10.}, {18.328, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {18.328, 10.}], 
                Offset[{-1.5, 0}, {18.328, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {18.328, 0.}], 
                Offset[{-1.5, 0}, {18.328, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 28], {LineBox[{{18.494, 10.}, {18.494, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {18.494, 10.}], 
                Offset[{-1.5, 0}, {18.494, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {18.494, 0.}], 
                Offset[{-1.5, 0}, {18.494, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 29], {LineBox[{{18.509, 10.}, {18.509, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {18.509, 10.}], 
                Offset[{-1.5, 0}, {18.509, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {18.509, 0.}], 
                Offset[{-1.5, 0}, {18.509, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 30], {LineBox[{{18.59, 10.}, {18.59, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {18.59, 10.}], 
                Offset[{-1.5, 0}, {18.59, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {18.59, 0.}], 
                Offset[{-1.5, 0}, {18.59, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 31], {LineBox[{{18.702, 10.}, {18.702, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {18.702, 10.}], 
                Offset[{-1.5, 0}, {18.702, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {18.702, 0.}], 
                Offset[{-1.5, 0}, {18.702, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 32], {LineBox[{{18.91, 10.}, {18.91, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {18.91, 10.}], 
                Offset[{-1.5, 0}, {18.91, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {18.91, 0.}], 
                Offset[{-1.5, 0}, {18.91, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 33], {
              LineBox[{{18.990000000000002`, 10.}, {18.990000000000002`, 
               0.}}], LineBox[{
               Offset[{1.5, 0}, {18.990000000000002`, 10.}], 
                Offset[{-1.5, 0}, {18.990000000000002`, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {18.990000000000002`, 0.}], 
                Offset[{-1.5, 0}, {18.990000000000002`, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 34], {LineBox[{{19.109, 10.}, {19.109, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {19.109, 10.}], 
                Offset[{-1.5, 0}, {19.109, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {19.109, 0.}], 
                Offset[{-1.5, 0}, {19.109, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 35], {LineBox[{{19.199, 10.}, {19.199, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {19.199, 10.}], 
                Offset[{-1.5, 0}, {19.199, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {19.199, 0.}], 
                Offset[{-1.5, 0}, {19.199, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 36], {LineBox[{{19.262, 10.}, {19.262, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {19.262, 10.}], 
                Offset[{-1.5, 0}, {19.262, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {19.262, 0.}], 
                Offset[{-1.5, 0}, {19.262, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 37], {LineBox[{{19.295, 10.}, {19.295, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {19.295, 10.}], 
                Offset[{-1.5, 0}, {19.295, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {19.295, 0.}], 
                Offset[{-1.5, 0}, {19.295, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 38], {LineBox[{{19.3, 10.}, {19.3, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {19.3, 10.}], 
                Offset[{-1.5, 0}, {19.3, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {19.3, 0.}], 
                Offset[{-1.5, 0}, {19.3, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 39], {LineBox[{{19.313, 10.}, {19.313, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {19.313, 10.}], 
                Offset[{-1.5, 0}, {19.313, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {19.313, 0.}], 
                Offset[{-1.5, 0}, {19.313, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 40], {LineBox[{{19.382, 10.}, {19.382, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {19.382, 10.}], 
                Offset[{-1.5, 0}, {19.382, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {19.382, 0.}], 
                Offset[{-1.5, 0}, {19.382, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 41], {LineBox[{{19.459, 10.}, {19.459, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {19.459, 10.}], 
                Offset[{-1.5, 0}, {19.459, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {19.459, 0.}], 
                Offset[{-1.5, 0}, {19.459, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 42], {LineBox[{{19.755, 10.}, {19.755, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {19.755, 10.}], 
                Offset[{-1.5, 0}, {19.755, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {19.755, 0.}], 
                Offset[{-1.5, 0}, {19.755, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 43], {
              LineBox[{{19.868000000000002`, 10.}, {19.868000000000002`, 
               0.}}], LineBox[{
               Offset[{1.5, 0}, {19.868000000000002`, 10.}], 
                Offset[{-1.5, 0}, {19.868000000000002`, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {19.868000000000002`, 0.}], 
                Offset[{-1.5, 0}, {19.868000000000002`, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 44], {LineBox[{{20.236, 10.}, {20.236, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {20.236, 10.}], 
                Offset[{-1.5, 0}, {20.236, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {20.236, 0.}], 
                Offset[{-1.5, 0}, {20.236, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 45], {LineBox[{{20.53, 10.}, {20.53, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {20.53, 10.}], 
                Offset[{-1.5, 0}, {20.53, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {20.53, 0.}], 
                Offset[{-1.5, 0}, {20.53, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 46], {LineBox[{{20.811, 10.}, {20.811, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {20.811, 10.}], 
                Offset[{-1.5, 0}, {20.811, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {20.811, 0.}], 
                Offset[{-1.5, 0}, {20.811, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 47], {LineBox[{{21.093, 10.}, {21.093, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {21.093, 10.}], 
                Offset[{-1.5, 0}, {21.093, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {21.093, 0.}], 
                Offset[{-1.5, 0}, {21.093, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 48], {LineBox[{{21.369, 10.}, {21.369, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {21.369, 10.}], 
                Offset[{-1.5, 0}, {21.369, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {21.369, 0.}], 
                Offset[{-1.5, 0}, {21.369, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 49], {LineBox[{{21.681, 10.}, {21.681, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {21.681, 10.}], 
                Offset[{-1.5, 0}, {21.681, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {21.681, 0.}], 
                Offset[{-1.5, 0}, {21.681, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 50], {LineBox[{{22.015, 10.}, {22.015, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {22.015, 10.}], 
                Offset[{-1.5, 0}, {22.015, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {22.015, 0.}], 
                Offset[{-1.5, 0}, {22.015, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 51], {LineBox[{{22.042, 10.}, {22.042, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {22.042, 10.}], 
                Offset[{-1.5, 0}, {22.042, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {22.042, 0.}], 
                Offset[{-1.5, 0}, {22.042, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 52], {LineBox[{{22.069, 10.}, {22.069, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {22.069, 10.}], 
                Offset[{-1.5, 0}, {22.069, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {22.069, 0.}], 
                Offset[{-1.5, 0}, {22.069, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 53], {LineBox[{{22.075, 10.}, {22.075, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {22.075, 10.}], 
                Offset[{-1.5, 0}, {22.075, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {22.075, 0.}], 
                Offset[{-1.5, 0}, {22.075, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 54], {LineBox[{{22.106, 10.}, {22.106, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {22.106, 10.}], 
                Offset[{-1.5, 0}, {22.106, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {22.106, 0.}], 
                Offset[{-1.5, 0}, {22.106, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 55], {
              LineBox[{{22.298000000000002`, 10.}, {22.298000000000002`, 
               0.}}], LineBox[{
               Offset[{1.5, 0}, {22.298000000000002`, 10.}], 
                Offset[{-1.5, 0}, {22.298000000000002`, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {22.298000000000002`, 0.}], 
                Offset[{-1.5, 0}, {22.298000000000002`, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 56], {
              LineBox[{{22.394000000000002`, 10.}, {22.394000000000002`, 
               0.}}], LineBox[{
               Offset[{1.5, 0}, {22.394000000000002`, 10.}], 
                Offset[{-1.5, 0}, {22.394000000000002`, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {22.394000000000002`, 0.}], 
                Offset[{-1.5, 0}, {22.394000000000002`, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 57], {LineBox[{{22.424, 10.}, {22.424, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {22.424, 10.}], 
                Offset[{-1.5, 0}, {22.424, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {22.424, 0.}], 
                Offset[{-1.5, 0}, {22.424, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 58], {LineBox[{{22.438, 10.}, {22.438, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {22.438, 10.}], 
                Offset[{-1.5, 0}, {22.438, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {22.438, 0.}], 
                Offset[{-1.5, 0}, {22.438, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 59], {
              LineBox[{{22.580000000000002`, 10.}, {22.580000000000002`, 
               0.}}], LineBox[{
               Offset[{1.5, 0}, {22.580000000000002`, 10.}], 
                Offset[{-1.5, 0}, {22.580000000000002`, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {22.580000000000002`, 0.}], 
                Offset[{-1.5, 0}, {22.580000000000002`, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 60], {
              LineBox[{{22.583000000000002`, 10.}, {22.583000000000002`, 
               0.}}], LineBox[{
               Offset[{1.5, 0}, {22.583000000000002`, 10.}], 
                Offset[{-1.5, 0}, {22.583000000000002`, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {22.583000000000002`, 0.}], 
                Offset[{-1.5, 0}, {22.583000000000002`, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 61], {LineBox[{{22.826, 10.}, {22.826, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {22.826, 10.}], 
                Offset[{-1.5, 0}, {22.826, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {22.826, 0.}], 
                Offset[{-1.5, 0}, {22.826, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 62], {LineBox[{{22.853, 10.}, {22.853, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {22.853, 10.}], 
                Offset[{-1.5, 0}, {22.853, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {22.853, 0.}], 
                Offset[{-1.5, 0}, {22.853, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 63], {LineBox[{{23.162, 10.}, {23.162, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {23.162, 10.}], 
                Offset[{-1.5, 0}, {23.162, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {23.162, 0.}], 
                Offset[{-1.5, 0}, {23.162, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 64], {
              LineBox[{{23.173000000000002`, 10.}, {23.173000000000002`, 
               0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {23.173000000000002`, 10.}], 
                Offset[{-1.5, 0}, {23.173000000000002`, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {23.173000000000002`, 0.}], 
                Offset[{-1.5, 0}, {23.173000000000002`, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 65], {LineBox[{{23.435, 10.}, {23.435, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {23.435, 10.}], 
                Offset[{-1.5, 0}, {23.435, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {23.435, 0.}], 
                Offset[{-1.5, 0}, {23.435, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 66], {
              LineBox[{{24.089000000000002`, 10.}, {24.089000000000002`, 
               0.}}], LineBox[{
               Offset[{1.5, 0}, {24.089000000000002`, 10.}], 
                Offset[{-1.5, 0}, {24.089000000000002`, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {24.089000000000002`, 0.}], 
                Offset[{-1.5, 0}, {24.089000000000002`, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 67], {LineBox[{{24.401, 10.}, {24.401, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {24.401, 10.}], 
                Offset[{-1.5, 0}, {24.401, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {24.401, 0.}], 
                Offset[{-1.5, 0}, {24.401, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 68], {LineBox[{{24.656, 10.}, {24.656, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {24.656, 10.}], 
                Offset[{-1.5, 0}, {24.656, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {24.656, 0.}], 
                Offset[{-1.5, 0}, {24.656, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 69], {LineBox[{{24.997, 10.}, {24.997, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {24.997, 10.}], 
                Offset[{-1.5, 0}, {24.997, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {24.997, 0.}], 
                Offset[{-1.5, 0}, {24.997, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 70], {LineBox[{{25.417, 10.}, {25.417, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {25.417, 10.}], 
                Offset[{-1.5, 0}, {25.417, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {25.417, 0.}], 
                Offset[{-1.5, 0}, {25.417, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 71], {LineBox[{{25.539, 10.}, {25.539, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {25.539, 10.}], 
                Offset[{-1.5, 0}, {25.539, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {25.539, 0.}], 
                Offset[{-1.5, 0}, {25.539, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 72], {LineBox[{{25.624, 10.}, {25.624, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {25.624, 10.}], 
                Offset[{-1.5, 0}, {25.624, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {25.624, 0.}], 
                Offset[{-1.5, 0}, {25.624, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 73], {LineBox[{{25.713, 10.}, {25.713, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {25.713, 10.}], 
                Offset[{-1.5, 0}, {25.713, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {25.713, 0.}], 
                Offset[{-1.5, 0}, {25.713, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 74], {LineBox[{{25.733, 10.}, {25.733, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {25.733, 10.}], 
                Offset[{-1.5, 0}, {25.733, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {25.733, 0.}], 
                Offset[{-1.5, 0}, {25.733, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 75], {LineBox[{{25.776, 10.}, {25.776, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {25.776, 10.}], 
                Offset[{-1.5, 0}, {25.776, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {25.776, 0.}], 
                Offset[{-1.5, 0}, {25.776, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 76], {LineBox[{{26.183, 10.}, {26.183, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {26.183, 10.}], 
                Offset[{-1.5, 0}, {26.183, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {26.183, 0.}], 
                Offset[{-1.5, 0}, {26.183, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 77], {LineBox[{{26.335, 10.}, {26.335, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {26.335, 10.}], 
                Offset[{-1.5, 0}, {26.335, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {26.335, 0.}], 
                Offset[{-1.5, 0}, {26.335, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 78], {
              LineBox[{{26.592000000000002`, 10.}, {26.592000000000002`, 
               0.}}], LineBox[{
               Offset[{1.5, 0}, {26.592000000000002`, 10.}], 
                Offset[{-1.5, 0}, {26.592000000000002`, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {26.592000000000002`, 0.}], 
                Offset[{-1.5, 0}, {26.592000000000002`, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 79], {LineBox[{{26.595, 10.}, {26.595, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {26.595, 10.}], 
                Offset[{-1.5, 0}, {26.595, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {26.595, 0.}], 
                Offset[{-1.5, 0}, {26.595, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 80], {LineBox[{{26.703, 10.}, {26.703, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {26.703, 10.}], 
                Offset[{-1.5, 0}, {26.703, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {26.703, 0.}], 
                Offset[{-1.5, 0}, {26.703, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 81], {
              LineBox[{{26.778000000000002`, 10.}, {26.778000000000002`, 
               0.}}], LineBox[{
               Offset[{1.5, 0}, {26.778000000000002`, 10.}], 
                Offset[{-1.5, 0}, {26.778000000000002`, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {26.778000000000002`, 0.}], 
                Offset[{-1.5, 0}, {26.778000000000002`, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 82], {LineBox[{{27.11, 10.}, {27.11, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {27.11, 10.}], 
                Offset[{-1.5, 0}, {27.11, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {27.11, 0.}], 
                Offset[{-1.5, 0}, {27.11, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 83], {LineBox[{{27.154, 10.}, {27.154, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {27.154, 10.}], 
                Offset[{-1.5, 0}, {27.154, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {27.154, 0.}], 
                Offset[{-1.5, 0}, {27.154, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 84], {LineBox[{{27.276, 10.}, {27.276, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {27.276, 10.}], 
                Offset[{-1.5, 0}, {27.276, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {27.276, 0.}], 
                Offset[{-1.5, 0}, {27.276, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 85], {LineBox[{{27.277, 10.}, {27.277, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {27.277, 10.}], 
                Offset[{-1.5, 0}, {27.277, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {27.277, 0.}], 
                Offset[{-1.5, 0}, {27.277, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 86], {LineBox[{{27.343, 10.}, {27.343, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {27.343, 10.}], 
                Offset[{-1.5, 0}, {27.343, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {27.343, 0.}], 
                Offset[{-1.5, 0}, {27.343, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 87], {LineBox[{{27.478, 10.}, {27.478, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {27.478, 10.}], 
                Offset[{-1.5, 0}, {27.478, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {27.478, 0.}], 
                Offset[{-1.5, 0}, {27.478, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 88], {
              LineBox[{{27.557000000000002`, 10.}, {27.557000000000002`, 
               0.}}], LineBox[{
               Offset[{1.5, 0}, {27.557000000000002`, 10.}], 
                Offset[{-1.5, 0}, {27.557000000000002`, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {27.557000000000002`, 0.}], 
                Offset[{-1.5, 0}, {27.557000000000002`, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 89], {LineBox[{{27.789, 10.}, {27.789, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {27.789, 10.}], 
                Offset[{-1.5, 0}, {27.789, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {27.789, 0.}], 
                Offset[{-1.5, 0}, {27.789, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 90], {LineBox[{{27.832, 10.}, {27.832, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {27.832, 10.}], 
                Offset[{-1.5, 0}, {27.832, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {27.832, 0.}], 
                Offset[{-1.5, 0}, {27.832, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 91], {LineBox[{{28.097, 10.}, {28.097, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {28.097, 10.}], 
                Offset[{-1.5, 0}, {28.097, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {28.097, 0.}], 
                Offset[{-1.5, 0}, {28.097, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 92], {LineBox[{{28.35, 10.}, {28.35, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {28.35, 10.}], 
                Offset[{-1.5, 0}, {28.35, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {28.35, 0.}], 
                Offset[{-1.5, 0}, {28.35, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 93], {LineBox[{{28.599, 10.}, {28.599, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {28.599, 10.}], 
                Offset[{-1.5, 0}, {28.599, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {28.599, 0.}], 
                Offset[{-1.5, 0}, {28.599, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 94], {LineBox[{{28.735, 10.}, {28.735, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {28.735, 10.}], 
                Offset[{-1.5, 0}, {28.735, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {28.735, 0.}], 
                Offset[{-1.5, 0}, {28.735, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 95], {LineBox[{{28.838, 10.}, {28.838, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {28.838, 10.}], 
                Offset[{-1.5, 0}, {28.838, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {28.838, 0.}], 
                Offset[{-1.5, 0}, {28.838, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 96], {LineBox[{{29.067, 10.}, {29.067, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {29.067, 10.}], 
                Offset[{-1.5, 0}, {29.067, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {29.067, 0.}], 
                Offset[{-1.5, 0}, {29.067, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 97], {LineBox[{{29.319, 8.}, {29.319, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {29.319, 8.}], 
                Offset[{-1.5, 0}, {29.319, 8.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {29.319, 0.}], 
                Offset[{-1.5, 0}, {29.319, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 98], {LineBox[{{29.352, 8.}, {29.352, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {29.352, 8.}], 
                Offset[{-1.5, 0}, {29.352, 8.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {29.352, 0.}], 
                Offset[{-1.5, 0}, {29.352, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 99], {LineBox[{{29.373, 8.}, {29.373, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {29.373, 8.}], 
                Offset[{-1.5, 0}, {29.373, 8.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {29.373, 0.}], 
                Offset[{-1.5, 0}, {29.373, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 100], {LineBox[{{29.48, 8.}, {29.48, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {29.48, 8.}], 
                Offset[{-1.5, 0}, {29.48, 8.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {29.48, 0.}], 
                Offset[{-1.5, 0}, {29.48, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 101], {LineBox[{{29.623, 10.}, {29.623, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {29.623, 10.}], 
                Offset[{-1.5, 0}, {29.623, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {29.623, 0.}], 
                Offset[{-1.5, 0}, {29.623, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 102], {LineBox[{{29.642, 10.}, {29.642, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {29.642, 10.}], 
                Offset[{-1.5, 0}, {29.642, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {29.642, 0.}], 
                Offset[{-1.5, 0}, {29.642, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 103], {LineBox[{{29.994, 10.}, {29.994, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {29.994, 10.}], 
                Offset[{-1.5, 0}, {29.994, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {29.994, 0.}], 
                Offset[{-1.5, 0}, {29.994, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 104], {LineBox[{{30.094, 10.}, {30.094, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {30.094, 10.}], 
                Offset[{-1.5, 0}, {30.094, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {30.094, 0.}], 
                Offset[{-1.5, 0}, {30.094, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 105], {LineBox[{{30.247, 10.}, {30.247, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {30.247, 10.}], 
                Offset[{-1.5, 0}, {30.247, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {30.247, 0.}], 
                Offset[{-1.5, 0}, {30.247, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 106], {
              LineBox[{{30.249000000000002`, 10.}, {30.249000000000002`, 
               0.}}], LineBox[{
               Offset[{1.5, 0}, {30.249000000000002`, 10.}], 
                Offset[{-1.5, 0}, {30.249000000000002`, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {30.249000000000002`, 0.}], 
                Offset[{-1.5, 0}, {30.249000000000002`, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 107], {LineBox[{{30.495, 10.}, {30.495, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {30.495, 10.}], 
                Offset[{-1.5, 0}, {30.495, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {30.495, 0.}], 
                Offset[{-1.5, 0}, {30.495, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 108], {LineBox[{{30.784, 10.}, {30.784, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {30.784, 10.}], 
                Offset[{-1.5, 0}, {30.784, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {30.784, 0.}], 
                Offset[{-1.5, 0}, {30.784, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 109], {LineBox[{{31.329, 10.}, {31.329, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {31.329, 10.}], 
                Offset[{-1.5, 0}, {31.329, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {31.329, 0.}], 
                Offset[{-1.5, 0}, {31.329, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 110], {LineBox[{{31.363, 10.}, {31.363, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {31.363, 10.}], 
                Offset[{-1.5, 0}, {31.363, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {31.363, 0.}], 
                Offset[{-1.5, 0}, {31.363, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 111], {LineBox[{{31.482, 10.}, {31.482, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {31.482, 10.}], 
                Offset[{-1.5, 0}, {31.482, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {31.482, 0.}], 
                Offset[{-1.5, 0}, {31.482, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 112], {LineBox[{{31.843, 10.}, {31.843, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {31.843, 10.}], 
                Offset[{-1.5, 0}, {31.843, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {31.843, 0.}], 
                Offset[{-1.5, 0}, {31.843, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 113], {LineBox[{{32.009, 10.}, {32.009, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {32.009, 10.}], 
                Offset[{-1.5, 0}, {32.009, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {32.009, 0.}], 
                Offset[{-1.5, 0}, {32.009, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 114], {
              LineBox[{{33.480000000000004`, 10.}, {33.480000000000004`, 
               0.}}], LineBox[{
               Offset[{1.5, 0}, {33.480000000000004`, 10.}], 
                Offset[{-1.5, 0}, {33.480000000000004`, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {33.480000000000004`, 0.}], 
                Offset[{-1.5, 0}, {33.480000000000004`, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 115], {LineBox[{{33.533, 10.}, {33.533, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {33.533, 10.}], 
                Offset[{-1.5, 0}, {33.533, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {33.533, 0.}], 
                Offset[{-1.5, 0}, {33.533, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 116], {
              LineBox[{{34.483000000000004`, 10.}, {34.483000000000004`, 
               2.}}], LineBox[{
               Offset[{1.5, 0}, {34.483000000000004`, 10.}], 
                Offset[{-1.5, 0}, {34.483000000000004`, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {34.483000000000004`, 2.}], 
                Offset[{-1.5, 0}, {34.483000000000004`, 2.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 117], {LineBox[{{34.488, 10.}, {34.488, 2.}}], 
              LineBox[{
               Offset[{1.5, 0}, {34.488, 10.}], 
                Offset[{-1.5, 0}, {34.488, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {34.488, 2.}], 
                Offset[{-1.5, 0}, {34.488, 2.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 118], {LineBox[{{34.62, 10.}, {34.62, 2.}}], 
              LineBox[{
               Offset[{1.5, 0}, {34.62, 10.}], 
                Offset[{-1.5, 0}, {34.62, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {34.62, 2.}], 
                Offset[{-1.5, 0}, {34.62, 2.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 119], {LineBox[{{39.634, 14.}, {39.634, 2.}}], 
              LineBox[{
               Offset[{1.5, 0}, {39.634, 14.}], 
                Offset[{-1.5, 0}, {39.634, 14.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {39.634, 2.}], 
                Offset[{-1.5, 0}, {39.634, 2.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 120], {LineBox[{{40.641, 12.}, {40.641, 2.}}], 
              LineBox[{
               Offset[{1.5, 0}, {40.641, 12.}], 
                Offset[{-1.5, 0}, {40.641, 12.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {40.641, 2.}], 
                Offset[{-1.5, 0}, {40.641, 2.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 121], {LineBox[{{42.973, 12.}, {42.973, 2.}}], 
              LineBox[{
               Offset[{1.5, 0}, {42.973, 12.}], 
                Offset[{-1.5, 0}, {42.973, 12.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {42.973, 2.}], 
                Offset[{-1.5, 0}, {42.973, 2.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 122], {LineBox[{{44.283, 12.}, {44.283, 2.}}], 
              LineBox[{
               Offset[{1.5, 0}, {44.283, 12.}], 
                Offset[{-1.5, 0}, {44.283, 12.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {44.283, 2.}], 
                Offset[{-1.5, 0}, {44.283, 2.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 123], {LineBox[{{45.828, 12.}, {45.828, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {45.828, 12.}], 
                Offset[{-1.5, 0}, {45.828, 12.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {45.828, 0.}], 
                Offset[{-1.5, 0}, {45.828, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 124], {LineBox[{{46.256, 10.}, {46.256, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {46.256, 10.}], 
                Offset[{-1.5, 0}, {46.256, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {46.256, 0.}], 
                Offset[{-1.5, 0}, {46.256, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 125], {LineBox[{{46.658, 10.}, {46.658, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {46.658, 10.}], 
                Offset[{-1.5, 0}, {46.658, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {46.658, 0.}], 
                Offset[{-1.5, 0}, {46.658, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 126], {LineBox[{{47.063, 10.}, {47.063, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {47.063, 10.}], 
                Offset[{-1.5, 0}, {47.063, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {47.063, 0.}], 
                Offset[{-1.5, 0}, {47.063, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 127], {LineBox[{{47.443, 10.}, {47.443, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {47.443, 10.}], 
                Offset[{-1.5, 0}, {47.443, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {47.443, 0.}], 
                Offset[{-1.5, 0}, {47.443, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 128], {LineBox[{{47.856, 10.}, {47.856, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {47.856, 10.}], 
                Offset[{-1.5, 0}, {47.856, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {47.856, 0.}], 
                Offset[{-1.5, 0}, {47.856, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 129], {LineBox[{{48.272, 10.}, {48.272, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {48.272, 10.}], 
                Offset[{-1.5, 0}, {48.272, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {48.272, 0.}], 
                Offset[{-1.5, 0}, {48.272, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 131], {LineBox[{{49.174, 10.}, {49.174, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {49.174, 10.}], 
                Offset[{-1.5, 0}, {49.174, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {49.174, 0.}], 
                Offset[{-1.5, 0}, {49.174, 0.}]}]}}, {InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->0], 132], {LineBox[{{49.985, 10.}, {49.985, 0.}}], 
              LineBox[{
               Offset[{1.5, 0}, {49.985, 10.}], 
                Offset[{-1.5, 0}, {49.985, 10.}]}], 
              LineBox[{
               Offset[{1.5, 0}, {49.985, 0.}], 
                Offset[{-1.5, 0}, {49.985, 0.}]}]}}}, {}}], {}}, {{}, 
         GraphicsComplexBox[CompressedData["
1:eJzt1vlLVFEUB/DRpEJMXFqGMlPLVKY0NTPXGdNxyRa3VsTKNEpKwzJCRbAI
k6hIs7ISsYUSQkJDJG0xRE1aTCMpsYUWlTZKLcycuvfMdL7p3zDvl+HDnfc4
79xzzruOyRlxqaYKhcLMRKGQvwury75eae5VK+hy0FzQ1g6MPh1k03L0EDuu
zv7Qx9gpmn/+kqv2SbppxZ7x/NHP+K3WbP3z4cnX7DamBNiyP7Q7dQ/r7Nje
8hpwZL9affR0epETe1Wy1Xq/G84GKzVmay0XVs924fWqiDfZU9NVvH6nfKZH
zzsVr59vcrie6erOXm5hqir4sYj/n2Fz8G6biSeb4imGW6J9C0NewxTf93Hr
Ci+2pUzAJFgkr87eGb7aLG+AC6bLBMLiZVv35cG/K791rDwAd13cHWR+Gm5s
q9DW1sBuicfvDfXBwebijlH4VOiRnb2zvNm7ekcqv3nBMeL1bELhTyL8Q9Hw
wwfiWgG/vXyuySEGpnxugT165k3Mz4LFblVFNMJFn0VBvYTndg/npQUuZkfK
Gwpguf1lj2GVTOAMn7H5S4KzipVma6vgSyJ9XROWsM+ki4DNYZGdkUprmOrB
Fl62+X270yxYI7ohagVM9ZcCT8wvERmHKV+74WmygE/CO06IhJTAv/LSGvZ2
wtR/L2DZvfvdfMfGswAW1eCamAFbywRNX2qwlb5ft8FUv1dgat8/MOUrzY8d
JhNWCMv03y6Hqd9q4cc/499erof18wI2lRvq7s/+4SoKeg2cGiA7EKbxdAam
fqqB66NEAC2wbA9XuwA2bY8LTPGEw4Mivf3/mept3T8b9iMbDpThHYMpP/dx
v37ewuGSykD22VJxbYA7V4oBWApT/A0w5fcZrBPhzrcOYlM9x8IunnIiw3u2
i4LbBOdMlQU5br0cptsvwdRvOvh7hwhYGcym+lHD/rI+/vMcOSDzYBr3rTDN
/wQ1+3qmCCgRpu9LDkz70wVTPkw0vB80D2/B9PwmuE+Mw46gEDa9XzBM/bQa
puc/CWXL9rOIC2NT/+dqDTZ8z+aFs6k++sP5/wk0ICLGxpcAU34Pw5SvOtiR
EgQXhsiBFcn5ENO5Qnsqktfp+6mDjecD4/nAeD4wng/0Np4PjOcD4/nAeD6A
/wI8TNuO
          "], {
           {GrayLevel[0], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 131], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 132], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 133], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 134], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 135], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 136], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 137], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 138], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 139], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 140], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 141], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 142], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 143], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 144], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 145], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 146], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 147], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 148], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 149], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 150], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 151], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 152], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 153], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 154], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 155], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 156], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 157], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 158], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 159], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 160], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 161], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 162], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 163], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 164], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 165], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 166], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 167], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 168], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 169], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 170], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 171], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 172], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 173], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 174], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 175], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 176], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 177], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 178], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 179], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 180], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 181], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 182], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 183], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 184], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 185], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 186], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 187], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 188], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 189], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 190], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 191], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 192], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 193], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 194], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 195], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 196], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 197], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 198], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 199], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 200], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 201], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 202], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 203], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 204], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 205], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 206], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 207], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 208], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 209], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 210], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 211], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 212], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 213], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 214], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 215], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 216], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 217], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 218], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 219], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 220], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 221], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 222], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 223], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 224], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 225], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 226], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 227], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 228], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 229], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 230], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 231], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 232], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 233], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 234], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 235], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 236], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 237], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 238], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 239], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 240], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 241], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 242], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 243], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 244], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 245], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 246], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 247], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 248], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 249], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 250], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 251], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 252], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 253], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 254], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 255], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 256], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 257], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 258], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 259], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 260]}, {}}], {}}}, {{{}, {}, 
         {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
          LineBox[CompressedData["
1:eJxN0Ak0FHgYAPAhqveodUVRYhRjTBhMGMcMk2NczcibHCmyucpQjk3aHA+F
ol3Xrl33VUnCGw3edrEioha1LTrsyFbudUbZ4z3f53vve//3e+/7/u/7PvXj
oa4nxAkEwpV/87/3Bcmx22OmyJLwf1CYh2yovnWKPYw1p0q9s76t+BpcVurf
X28wBU44TLN+LLMINjG3u3T00Sq4qG0ysVJOgrnmOmHXDq1Pm8Djb051udGk
wR2cFwIfXRnwn9lxNZ6qcmC5KCmhjokCeHNzQTBTVxFs1JWQGaG8HRxx1r4z
Vl8ZHJOiWN1N3AnOobXlz1qqgu+dtuUq2e8Gz/L8xPNJauDAc5Wah/XRQ/kf
HWRN0D/UbPGeMFszien6QC+0k4GW7uXGX2Oh20ThmUl26Fs6KwNLPHTumcQ9
fH90ICFbwEtC09PLbRll6KHrbYEyw+i4X0dT3+5WB6f5DX+/VI7OERvKk6UQ
wTJhz2P9NDXACjeZY0W0PWBDl175CcZecAMxWMbbRBPc0no6646NFtb/+O24
oRUJfLe3Vuy+sTa4b4CXb8wig50VCVufmeuAOarKG3mOFDD/8pHGD277wFOU
UqtiJ13wSp4nl+Whh/PtkvppA1kfvKz2OXi8DC2ZVvnFiUwFW23tO/9LBdp6
UXi3dJ8BOHJ598e8KrSAqjK3Q8sQ3NTd/XBrNXo6USJGgWwEHi+emc+oRS9M
R3Ay99PwXl7RWZV1aCOd/T9TTfeD/RUi07sa0BX69kcnqcbgqvre6Yt30MMH
34ZSjUzAr1wraznN6NFLYs8WGKZg4u9Df9Q0r3P6mWtDVnSwm3eKz857aMdM
98GntmZgzkozbUsXOvlCcbSnvTk4PoARv6sHfSvoWPi0kwX4fYE8y7l9nelx
z1VdLMHKU3w3sU60rLRijocrA7zNiyswfYEu9714LFubifuwrdvaT6FNLCxL
EqvQ/Q4SIRLv1zmtYsc9HStwyMsUM/FgdKAnmxFXjTYo7ojZ8AS9MsoWJo+h
W74zd11aRqea6Y2dlLLG/6+STPfKozkj6smvlNFjXz2o6VdBp9B9XnbtRGue
WBVv3YV+mFFAaVZdM4W5LBqMva6GNqKr9OYS0RWi3OgITbRShoIal4zmrYy2
9jqis4Kag3gh6BucUpKoCv3OWzK6/Qla42RAx81JdAnVw+vLApq46DB+kMAC
Pwx6xP1aHH18gNVwVgJtoJDwV4IkWtz5vvKVjWsmMX9L+uKUuwldctc8tngz
eriYZv9YGk1M0pX9W2ad5eRoOerrXDjnbmqA5jO8B1hcdNPrVm+XMLTgUNiB
gno0u+9IUdQM2o8v/1FO/wD4jVmF0ocz6Plt5xrZtWi+BtlCNIsOcSirsTa2
AUteOJarHYkmjMz7OArRme49hXPz6OqR00/8jGzB5IqpQelv0Mzw276WArQw
3Kn9xiK6I067rNDYDuxb+ZTvHon2EnNTcRKiJwK2W7TPo0VijcxYuj32CzQM
P51HR0X25H1uQseHsjsvDKEvB7Usr66i/wGSVRjY
           "]]}}, {{}, {}, 
         {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
          LineBox[CompressedData["
1:eJxN0HssFAAYAPA76bGRietEJU6FI91x587rXojLpcNNHglZRDmK05tjRtLq
D9RSXtFdCwm7Om6p9RC5qFF66amshzzGZVF6bH2fb/v27bd93/Z9n/X2lOAd
egQCIf5P/q39dgHd4eOVHMK/oPFCfOmxTeQe7n8fM/gouEJ+Da6pjn/c7DwK
ztnCFNw3ngKzPf2Obrs3C65sH8lVmujz/rtJrTW3/bEQPPxmt1bCNAR3ivtV
MU7G4Pcl8oYISxOwSYaB2oFNAi/SlCfxnMhghjanKN1iGTh9v39XFs0CfKiA
XN9NWQE+xWwvm+BYgidC4/TK7KzA8rtDx96ussZ+4kDpEkcK2Dj1SVbcWhsw
qY73tZK5GuwS2Gv6jbsGfJWSZBzFXgu+fWdP8TVfW+w/c2TYhW8HbuttJN5k
2YP7XoSWsbyp4E1kgtEjTwew2NJiQWiAI1h6fGvLZ8k68KhjNb9K5ASeKY0I
8g5fj/utNDg7j0oDT1v9TBquQc8vVP4SUelgvlHf4esKtGBK3Va9zhksm171
pbQWraIvnzS3dQG3dnffMqpHj+XqHyJRGeDhqnHdyUb097F0cZErE/8VeaBY
2YRmOLieo7u5guNJshPaq2gFzX/bCJ0Frm3uHcu/hn63+W0KncEGvwpWNoo1
6KGjxEffuW5gytOB5w2aOT6x9+IA3x0siSqIWXEDHVAU9vLhBg+weEbDXKxF
52VWHYjw9wRnJ3CzV/agLydGp42JvMCfyk29N3XMsbv8iWUgB2wxKpUQu9BL
DMmnwoO54KWRQSq3fvSF2PzoEnse3iMUtHfsRrO9OOdza9GPN+on63+a40KF
+Q0HPjj5WYGHXhJ6Z4SQK69HzwwJ1Xlf0WYnSVZBVAG4OFGTGJqMviSuthus
RdvsSuisG0FTKibD3Jy9wa2v70QFpqJVIak+5c1oYd/WyoxxdJzU9IsJzQf8
xkNh9nkvWrf0YIuwES21oXoNTqCTN9Y0CFi+4PmZ0aftZWjCB11MgBpdFNZT
MalD13/Y8yCOsQFMVYy+NNyH5qVdieWo0Oo0UcelKXSn3L6mguUHjlU+lIbJ
0JFEyXKRGv0tYZlXhw49SGzhZbn747zKxuXHYXSGrKf0Zys6O0XYlTmAPp54
e3p2Fv0bw5OLTg==
           "]]}}, {{}, {}, 
         {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
          LineBox[CompressedData["
1:eJxN0HssFAAYAPA76bGRietEJU6FI91x587rXojLpcNNHglZRDmK05tjRtLq
D9RSXtFdCwm7Om6p9RC5qFF66amshzzGZVF6bH2fb/v27bd93/Z9n/X2lOAd
egQCIf5P/q39dgHd4eOVHMK/oPFCfOmxTeQe7n8fM/gouEJ+Da6pjn/c7DwK
ztnCFNw3ngKzPf2Obrs3C65sH8lVmujz/rtJrTW3/bEQPPxmt1bCNAR3ivtV
MU7G4Pcl8oYISxOwSYaB2oFNAi/SlCfxnMhghjanKN1iGTh9v39XFs0CfKiA
XN9NWQE+xWwvm+BYgidC4/TK7KzA8rtDx96ussZ+4kDpEkcK2Dj1SVbcWhsw
qY73tZK5GuwS2Gv6jbsGfJWSZBzFXgu+fWdP8TVfW+w/c2TYhW8HbuttJN5k
2YP7XoSWsbyp4E1kgtEjTwew2NJiQWiAI1h6fGvLZ8k68KhjNb9K5ASeKY0I
8g5fj/utNDg7j0oDT1v9TBquQc8vVP4SUelgvlHf4esKtGBK3Va9zhksm171
pbQWraIvnzS3dQG3dnffMqpHj+XqHyJRGeDhqnHdyUb097F0cZErE/8VeaBY
2YRmOLieo7u5guNJshPaq2gFzX/bCJ0Frm3uHcu/hn63+W0KncEGvwpWNoo1
6KGjxEffuW5gytOB5w2aOT6x9+IA3x0siSqIWXEDHVAU9vLhBg+weEbDXKxF
52VWHYjw9wRnJ3CzV/agLydGp42JvMCfyk29N3XMsbv8iWUgB2wxKpUQu9BL
DMmnwoO54KWRQSq3fvSF2PzoEnse3iMUtHfsRrO9OOdza9GPN+on63+a40KF
+Q0HPjj5WYGHXhJ6Z4SQK69HzwwJ1Xlf0WYnSVZBVAG4OFGTGJqMviSuthus
RdvsSuisG0FTKibD3Jy9wa2v70QFpqJVIak+5c1oYd/WyoxxdJzU9IsJzQf8
xkNh9nkvWrf0YIuwES21oXoNTqCTN9Y0CFi+4PmZ0aftZWjCB11MgBpdFNZT
MalD13/Y8yCOsQFMVYy+NNyH5qVdieWo0Oo0UcelKXSn3L6mguUHjlU+lIbJ
0JFEyXKRGv0tYZlXhw49SGzhZbn747zKxuXHYXSGrKf0Zys6O0XYlTmAPp54
e3p2Fv0bw5OLTg==
           "]]}}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      Axes->True,
      AxesLabel->{
        FormBox["\"x(kbp)\"", TraditionalForm], 
        FormBox[
        "\"RF(T,\\!\\(\\*SubscriptBox[\\(T\\), \\(true\\)]\\))\"", 
         TraditionalForm]},
      AxesOrigin->{-1, -0.05},
      Method->{},
      PlotRange->All,
      PlotRangeClipping->True,
      PlotRangePadding->None], {192., -116.80842387373012`}, 
     ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}], InsetBox[
     GraphicsBox[{{{}, GraphicsComplexBox[CompressedData["
1:eJxd1QlIVFEUBuDRpEJKHLUc0krNcsS0tGxxmzGdUdNyzRbEyjRKSqUyomIg
Q0yiIs2lRcRSSggRDZG0xRC1aNVISmzBSqWNUgtbpu49TufPHoh83HmP8/57
zn3OKZlxaeYKhSJH/Mn/nnVlny629WsUdDlpz+sahn49HmbTcuQIO65xVu67
2Knav/54UOObfNWabf/0/rf4LUr22PPhyZcdN6T627LfPnTpGTU6shfJa8iZ
/SL6WElGgQt7dYr1uuVX5pqs0lokWnnWzXTj9ZqwV/vtMjx4/Ub5jAW9rz14
/VyrU+0utRd75RRzj7yvC/n3mTaHb94x82ZTPYVwe+TS/OCXMNX35b91hQ/b
SgYwCRbhNc6aC19qkzfAedNlgLB42Y69Bvhn9efOVTlw94WsQMsSuOVOha6h
HnZPOnFrZAAOshR3/IKLQ47u6HdYxN7Z/6P6sw8cI17PJgR+L8rPjYTv3RVX
FNxXdbbVKQamPDfDC3pdJx7KhsVu1YS1wAUfREM9h+f0jBrSAxazw+UNebDc
/rIHsIcM0N53fH7JcHahyiKxBq4U8XVPWMIuzRAFW8IinR/VSpj6wRZesenN
QxcHWCumISIKpv5LhSceKhKJw5RXFjxNNvApePtJEUgR/N2Q3rynC6b5ewbL
6d3nvnR8PfNh0Q3qpExYKQOavsxk67F53QpT/16EaXx/w5RX+nJ2qAwsH5bx
Xy+Had4a4Aff4vuqmuCx8wI2lxvq5cf+qhYNvQZO85cTCNPxVArTPNXDTRGi
gHZYjofa0Z9N2+MGUz16eFjEO/iPqd/W/rVpP/bDAbK84zDlcxv3j523sF5S
FcA+c1pc6+GuVeIAPA1T/c0w5fsENopy5ykD2dTPsbCbtzyR4d3bRMNthA/Y
yYb8b70cptsrYZo3I/ylUxSsCmJT/2hgP9kf/3i2PCANMB33HTCd/wkadu0u
UVASTN+XAzDtTzdMeZhpeT/oPLwG0/Nb4QFxHHYGBrPp/YJgmqdomJ7/KIQt
x29KXCib5v+gzmTT98xVz6b+GNTz7xPogAgbX18CTPkegSmvRtiZAoLzg+WB
Fc55iNO5Qlcczuv0/TTCfwAHie8W
         "], {{{}, {}, 
           {GrayLevel[0], Thickness[Large], 
            LineBox[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 
             17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 
             33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 
             49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 
             65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 
             81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 
             97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 
             110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 
             123, 124, 125, 126, 127, 128, 129, 130}]}}, {
           {GrayLevel[0], Thickness[Large], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 1], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 2], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 3], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 4], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 5], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 6], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 7], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 8], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 9], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 10], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 11], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 12], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 13], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 14], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 15], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 16], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 17], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 18], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 19], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 20], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 21], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 22], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 23], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 24], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 25], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 26], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 27], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 28], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 29], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 30], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 31], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 32], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 33], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 34], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 35], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 36], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 37], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 38], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 39], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 40], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 41], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 42], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 43], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 44], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 45], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 46], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 47], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 48], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 49], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 50], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 51], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 52], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 53], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 54], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 55], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 56], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 57], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 58], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 59], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 60], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 61], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 62], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 63], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 64], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 65], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 66], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 67], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 68], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 69], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 70], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 71], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 72], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 73], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 74], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 75], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 76], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 77], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 78], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 79], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 80], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 81], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 82], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 83], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 84], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 85], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 86], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 87], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 88], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 89], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 90], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 91], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 92], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 93], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 94], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 95], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 96], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 97], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 98], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 99], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 100], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 101], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 102], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 103], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 104], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 105], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 106], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 107], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 108], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 109], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 110], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 111], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 112], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 113], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 114], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 115], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 116], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 117], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 118], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 119], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 120], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 121], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 122], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 123], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 124], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 125], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 126], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 127], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 128], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 129], InsetBox[
             StyleBox["\<\"\[FilledCircle]\"\>",
              StripOnInput->False,
              FontSize->6], 130]}, {}}}], {}}, {{}, {}, 
        {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
         LineBox[CompressedData["
1:eJxN0HssFAAYAPA76bGRietEJU6FI91x587rXojLpcNNHglZRDmK05tjRtLq
D9RSXtFdCwm7Om6p9RC5qFF66amshzzGZVF6bH2fb/v27bd93/Z9n/X2lOAd
egQCIf5P/q39dgHd4eOVHMK/oPFCfOmxTeQe7n8fM/gouEJ+Da6pjn/c7DwK
ztnCFNw3ngKzPf2Obrs3C65sH8lVmujz/rtJrTW3/bEQPPxmt1bCNAR3ivtV
MU7G4Pcl8oYISxOwSYaB2oFNAi/SlCfxnMhghjanKN1iGTh9v39XFs0CfKiA
XN9NWQE+xWwvm+BYgidC4/TK7KzA8rtDx96ussZ+4kDpEkcK2Dj1SVbcWhsw
qY73tZK5GuwS2Gv6jbsGfJWSZBzFXgu+fWdP8TVfW+w/c2TYhW8HbuttJN5k
2YP7XoSWsbyp4E1kgtEjTwew2NJiQWiAI1h6fGvLZ8k68KhjNb9K5ASeKY0I
8g5fj/utNDg7j0oDT1v9TBquQc8vVP4SUelgvlHf4esKtGBK3Va9zhksm171
pbQWraIvnzS3dQG3dnffMqpHj+XqHyJRGeDhqnHdyUb097F0cZErE/8VeaBY
2YRmOLieo7u5guNJshPaq2gFzX/bCJ0Frm3uHcu/hn63+W0KncEGvwpWNoo1
6KGjxEffuW5gytOB5w2aOT6x9+IA3x0siSqIWXEDHVAU9vLhBg+weEbDXKxF
52VWHYjw9wRnJ3CzV/agLydGp42JvMCfyk29N3XMsbv8iWUgB2wxKpUQu9BL
DMmnwoO54KWRQSq3fvSF2PzoEnse3iMUtHfsRrO9OOdza9GPN+on63+a40KF
+Q0HPjj5WYGHXhJ6Z4SQK69HzwwJ1Xlf0WYnSVZBVAG4OFGTGJqMviSuthus
RdvsSuisG0FTKibD3Jy9wa2v70QFpqJVIak+5c1oYd/WyoxxdJzU9IsJzQf8
xkNh9nkvWrf0YIuwES21oXoNTqCTN9Y0CFi+4PmZ0aftZWjCB11MgBpdFNZT
MalD13/Y8yCOsQFMVYy+NNyH5qVdieWo0Oo0UcelKXSn3L6mguUHjlU+lIbJ
0JFEyXKRGv0tYZlXhw49SGzhZbn747zKxuXHYXSGrKf0Zys6O0XYlTmAPp54
e3p2Fv0bw5OLTg==
          "]]}}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      Axes->True,
      AxesLabel->{
        FormBox["\"x(kbp)\"", TraditionalForm], 
        FormBox[
        "\"RF(T,\\!\\(\\*SubscriptBox[\\(T\\), \\(true\\)]\\))\"", 
         TraditionalForm]},
      AxesOrigin->{0.743, 4.},
      Method->{},
      PlotRange->{All, All},
      PlotRangeClipping->True,
      PlotRangePadding->None], {576., -116.80842387373012`}, 
     ImageScaled[{0.5, 0.5}], {360., 222.49223594996212`}]}, {}},
  ContentSelectable->True,
  ImageSize->800,
  PlotRangePadding->{6, 5}]], "Output",
 CellChangeTimes->{3.585764144499797*^9, 3.58576488445212*^9, 
  3.5857649309757805`*^9},ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
  "******)"}]], "Input",
 CellChangeTimes->{{3.4940977943255997`*^9, 3.494097801075859*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"ggmx", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"gh3", "[", 
      RowBox[{"[", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2", ",", "3"}], "}"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"gtbl", ",", "gtrcor", ",", "gcp"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"gtbl2", ",", "gtrcor2", ",", "gcpcpf"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ggoutput", "=", 
  RowBox[{"GraphicsGrid", "[", 
   RowBox[{"ggmx", ",", 
    RowBox[{"ImageSize", "\[Rule]", "1000"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.524322591136654*^9, 3.5243226053794794`*^9}, 
   3.5243226475463533`*^9, {3.5243228029382257`*^9, 3.5243228146226463`*^9}, 
   3.5243230115115924`*^9, {3.5243232398839436`*^9, 3.5243232403059673`*^9}, {
   3.524326188849615*^9, 3.5243261951129727`*^9}, {3.524328366710181*^9, 
   3.5243283688363028`*^9}, {3.5243978534274225`*^9, 
   3.5243978554086256`*^9}, {3.5244063337914405`*^9, 3.524406336069044*^9}, {
   3.524406781137826*^9, 3.524406781590227*^9}, {3.525001608581476*^9, 
   3.525001611105621*^9}, {3.525001659262375*^9, 3.5250016662947774`*^9}, {
   3.525010473768496*^9, 3.5250105070121546`*^9}, {3.525052244838575*^9, 
   3.5250523045386586`*^9}, {3.5250535701528993`*^9, 3.5250535705829*^9}, {
   3.5250553123957753`*^9, 3.5250553757258635`*^9}, {3.5251740154669228`*^9, 
   3.5251740339419794`*^9}, {3.525174067313888*^9, 3.525174074922323*^9}, {
   3.5251742002224903`*^9, 3.525174213986277*^9}, {3.5251742445490255`*^9, 
   3.525174268883417*^9}, {3.5251832970277977`*^9, 3.525183302197093*^9}, {
   3.525183741081196*^9, 3.525183742988305*^9}, 3.5251846686362495`*^9, {
   3.525524733974943*^9, 3.525524762001546*^9}, {3.5255269656148148`*^9, 
   3.525527036898892*^9}, {3.525527184123313*^9, 3.525527205540538*^9}, {
   3.5255273949153695`*^9, 3.525527397306506*^9}, {3.5267856261659594`*^9, 
   3.526785627705961*^9}, {3.5267856992560616`*^9, 3.5267856997460623`*^9}, {
   3.5286345738744507`*^9, 3.5286345842796693`*^9}, {3.528815610423953*^9, 
   3.5288156124675565`*^9}, {3.5288156671300526`*^9, 
   3.5288156676292534`*^9}, {3.528815698642108*^9, 3.528815725208955*^9}, {
   3.550028192118927*^9, 3.550028194536931*^9}, {3.5508154349783525`*^9, 
   3.5508154364183545`*^9}, {3.5508188545711346`*^9, 
   3.5508188556631365`*^9}, {3.556075002801236*^9, 3.556075021367298*^9}, {
   3.556075055509251*^9, 3.5560750775365114`*^9}, {3.5560861339663796`*^9, 
   3.556086138061614*^9}, {3.556086391487109*^9, 3.5560863948523016`*^9}, {
   3.556088812167564*^9, 3.556088823444209*^9}, {3.556089002079387*^9, 
   3.556089016695223*^9}, {3.556095170436493*^9, 3.5560951734746666`*^9}, {
   3.5560952118388605`*^9, 3.556095218937267*^9}, {3.556102512943575*^9, 
   3.55610251496469*^9}, {3.556102912216412*^9, 3.556102915067575*^9}, {
   3.5561778529816465`*^9, 3.5561778572438903`*^9}, {3.556178873401011*^9, 
   3.556178875693142*^9}, {3.5562711678082027`*^9, 3.5562711803194246`*^9}, {
   3.5566986346481338`*^9, 3.5566986481133404`*^9}, 3.5567040747150364`*^9, {
   3.5567087288936567`*^9, 3.5567087471627884`*^9}, {3.571879922021963*^9, 
   3.5718799491972113`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {{InsetBox[
      GraphicsBox[{{{}, {}, 
         {GrayLevel[0], Thickness[Large], LineBox[CompressedData["
1:eJwVVHk8FN4XRQgzlhnNZGaE7CKksoTuk62UkqTQQknIlqxJpE3ZR5bwLZF9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           "]]}}, {{}, {}, 
         {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
          LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQXXwqXW/awSa7WTNBYKf9zqA8VweTjfYw/uX3IZL2
Jgfh/E22ra2Vby/C+aG+ZpfnLboF56/4mM/EOu0hnO9vkywTYf4Mzn+8+uCD
CZ2v4HyF2XZq6Rbv4fyjz27rbXjxEc4vEDo3fz7vFzj/Q63/xbsJ3+D859Vs
N/p6fsD5JbN3hweu/QXnX/31f3rSnz9w/to3lWufKf+H83X6Dx68s4fBAcY/
a+H60u8RI5y/cnVy9a/PTHB+wb6TuWdlWOD8olmnTt00ZIXz48SEO3jj2OB8
0cW3GE+1sMP5HD9tnu2fzgHnP333TOvuQU44/+9a7VvGN7jg/Ae1712FX3LD
+Wvf/hKUEuSF87epLfSIUuVDuPd/3/2DAfxw/pYvtZKR1gJwvsG5xh+5RxD8
heUr28UiBeH8Da1yZ24/RvBVZC7nPc0WgvP7mlYfbPqP4E/1vXjSplMYzp/4
QqqpS04Eztd+sfH9l5VI/IKO3YuNROF8hRNN5s+OIfibWk5luAaKwflWgmZe
Fs8RfHW1h535VeII9fNv1h1mloDzjV5+VV49A8H3nx5ft15ZEs6/dJbD/Mdq
BN/rytX5V+yl4PwE+w97z55E8OeZHbC8ICYN59/WnbD1UjKCDwCQ37QC
           "]]}}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"\[Theta]\"", TraditionalForm], 
         FormBox["\"pdf\"", TraditionalForm]},
       AxesOrigin->{0, 0},
       Method->{},
       PlotRange->All,
       PlotRangeClipping->True,
       PlotRangePadding->None], {193.5, -119.58957682310464`}, 
      ImageScaled[{0.5, 0.5}], {360., 222.4922359499621}], InsetBox[
      GraphicsBox[{{{}, {}, 
         {GrayLevel[0], Thickness[Large], LineBox[CompressedData["
1:eJxF13k4VO/7B/AxFCUR0iKJohV9IhXxPgltkiwlIiJLRQiVtUTZS0UUyhJC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           "]]}}, {{}, {}, 
         {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
          LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQLZV37tzhBRl21SLr3B9Wtdh3XXpjyTV9mj2MP3fq
g/Uc05fB+bumJt6279oO5xskMpyfX3MQzr91vDQ3S/w4nH9urx7LRe2zcH5A
kP1dnZyLcH4cb6eJff0VOH/6htRX35qvw/n2Z3g37A+5Bef3rL9eGJZ0F85f
0rpN8b/sAzh/xvJTO5c2P0SYv/a9/2b2x3B+TP6v3JOFT+B8HVGxLrdfT+F8
If3q0GnVz+F8fdZjK949egHny+9X/LU24xWc72aafLn0yms436F/66olcW/h
fP/YQMNlD9/B+aeKX8pHqH6A86+vMlom8BLB/78/r+Ds/I9wvlG//6TPQZ/g
fL8LFsa+op/h/Lb3IhKrTyH4yxt+Vtv0f4HzL59uMjcP+ArnS3/9Z2bG8g3O
95nQvDXjOII/k/N3+fza73D+RxvxSfYGPxDueWStLfwJwe9PDeZ4vewnnH81
qjjlW9YvON9Mr42FTek3nL9ot+2fuqsI/o9df4u0Z/yB8zNnbNC94/sXzj/8
PDv9gNA/OF/j4+kfvFcQ/JU35M7Fd/yH8zklbSd+UmVwgPHPmKTEmjci+FPW
xl7dcAvBD4y/zXPEmhHOl2kISouchuDXLfbpfHECwb9/zG1N+W8EHwAgepBe

           "]]}}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"\[CurlyEpsilon]\"", TraditionalForm], 
         FormBox["\"pdf\"", TraditionalForm]},
       AxesOrigin->{0, 0},
       Method->{},
       PlotRange->All,
       PlotRangeClipping->True,
       PlotRangePadding->None], {580.5, -119.58957682310464`}, 
      ImageScaled[{0.5, 0.5}], {360., 222.4922359499621}], InsetBox[
      GraphicsBox[{{{}, {}, 
         {GrayLevel[0], Thickness[Large], LineBox[CompressedData["
1:eJwVlHc01f8fxyXkXrkkZZWREiEpZeb5qa+WNGiYZYQSUbKzSmSVRFpGZioa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           "]]}}, {{}, {}, 
         {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
          LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQXZv17O+yw152s2aCwE5796udrGt6Kuxh/MxU/8hV
PR1wvtiXiRG/psyE8w9/v5TznmExnP9BM+CtnsRKOD/bvvbGtM3r4fzvM+TN
+d9vgvMfNEeYp7ttg/OZObuvq/bthPNX/WH3LZm7B87/8fDO92vv9sP5T6T+
7X7SfBDOfzWRy2cix2GE+xgPf3NfdwTOv7dCoeeY+TE4/6yHlo3/o+Nw/s2t
BjbcrSfhfPWoO2r93KfhfI/vxjqym8/A+atPG8gU252D8x/NuKl2+dV5OH/2
zP0Om49fgPPTmFIfP+i+iJBPT5g8OeESnF+Ysc5CS/0ynH/1/K/WWy8R/MXG
cx/w770C5wsZTzLQbLoK57/Wu9t7PPwanB80UW1yveZ1OD+q/1Cv9FsE/0zn
lqk2B2/A+fflf05ybL8J5zfK2FgkeN6C83tEr75ilrkN51usOjCp+wGC72fN
5DFj6x04nzVj2qeOmrtwvvdvDdfJ9vfg/F9dgkuVhO/D+V7bfH5NvYHgM7/P
03MPfwDna2zbZhxwAMGXPb3c2FvpIZzvfs95V0cPgu9k32m94z2C33L57IQv
AY/g/N+pe3OKdyH4Tm5hzk9kHsP5cx7vlrkWjOB/bVD8drwLwQcAMrXDHQ==

           "]]}}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"r\"", TraditionalForm], 
         FormBox["\"pdf\"", TraditionalForm]},
       AxesOrigin->{0, 0},
       Method->{},
       PlotRange->All,
       PlotRangeClipping->True,
       PlotRangePadding->None], {967.5, -119.58957682310464`}, 
      ImageScaled[{0.5, 0.5}], {360., 222.4922359499621}]}, {InsetBox[
      GraphicsBox[{{{{}, GraphicsComplexBox[CompressedData["
1:eJztlvlTU1cUx8PShEbQRBYTwIXFEovKJoiEJAdZEgQUcMFStAXRaoqKFJQC
RbEDETfGyuJSRIu4dCyjgpRB0OpkFKkrdKDooDKUoS4UAYFaCvbd+5x3nP4N
eb9kPnNz7jv3e7/nvOOQsDl6rTGPxzM14vHI75yLpX2nb/Sorruk7zuW/iH8
EFwzOPbba1XryqyrITcEQJfDhjiOrp2W+yLKAiaZjNpqu/nwV5bKe3WdCJ4n
v93rJhbAlPa7I0vXiMFdHf77HncBsPsjm52zj02UW3Lcfd/x0Ztxey7eizyD
DhAWqd8+1sKHJ0v2lWz6zhGyTH+U22v5sDhBtHJB9UwwGy1KSHHgg+mKiXMu
TnXhuFLdmWG1yRVydz7e9WmGAK6U2bp1/OEKGv7PQZeyBfC9fsb5FNlciK7Q
nV7cIIRF5sauumF3cK5+8FPPBRFsnvztL01GHhzTfA56gPGlK7+6JdnAzbD5
+QFPPaA3YiDrnJ0tm9+ABzz9Wq+43C9l13meHE8kAgg8uf8z4tVOm4l85gYJ
QNbZEAExnjls49ZsXP/3bH9zxE7ktvJkhbAE+VrTieCaKuRZcQXXh/5EVgiZ
iDHk4sA9ST12Xtz7NvaMnu33RI5kjjc5EPklk35uGPKd28wTjtxVcVQ/IxKZ
6hmP7NbhzM9JQ2Zuq1J9zQvmhR5tf9UqhQO9jKEeIzs9epOt9Z8HDwtydKVf
SEFDAnTI5PpL782D3WlqzQGdBFyJgFO8wbd2a3GDTMLqt9obfN5x2kGJ6YpK
by7+JCNfm4kPF39oE5OwEJlRZ/SsGJn6wRJ54eeMg+2QSTWEhvtAX1DqooYa
Keu/RGR+ThGjODLVKxnZihi4EHk9EaQI+Z9sbX1qCzKtv4fIpHrTZ83n9KX5
zEZm3CCL24xMqqnRxpdjWq/rfKHfc8uOck8J69/TyLR83/pyelK9tAs4DiKC
5SMT+a+UIdN6q0G+N7K0q+IyMtsvkI3Jhc71g9l9q59EeUtgWMYYerkfp3ei
nFQgMm1Ph5BpPVUh14UyCdz0A/8N1RtlyVIg5SGzl0NudF7oungp0OtxQab5
hCC/ZuR99h5Tv8XIuf3ofWTI4Zv6HeHaGCnQ9Pbj/6k+t+RgYhbRG8/0E7bf
IocQlPjD3gvq+vENNnDkMPN8gtwSwTTAw/5Qans/87iNDZt/PTLVtxV5nEn3
I7EChl/GjgQMW7N+jlJw6y4epCMjf0UM9xlyJjUkxtP1MgVcXeOoH+2yBhp+
EpnW27gCjn/ptLU0xRoGmpmEJUqOqX9UyNQf7/F00iCzlbA89eP2qYnWQNt9
oxJinD07PrC2Zvv/MhVofLYldHdbwfkUJqE4ZPp9yUSm99OmgjwrpYtTvJjV
wwg4pv2wAcAyLqbTfNCC3V+PTNphsyIAgiyOKFfpLNjzKZFpPS0JgPXP84oW
pluw+z8IhFdN9kaPUwVAys88Ogjqru9fL4gVsvWfFQyDLwrS6v4Wsu9zDoFT
nU3H7JQTWH88C4GSpKo1Z0omwTLaINTQpC9oNnsiend+NUQmJ20JKhSz+u5S
w3bTnFUTdotZvWqRHahAauicclemNRZDfgBpWBoo3xZ1R3RbBEx3PhFcrIGR
Wy+GOtaK2O/nuAZyCvNPrbITg2E+MMwHhvnAMB8Y5gPDfGCYDwzzwf/ng/8A
2HH7Pw==
           "], {
            {GrayLevel[0.65], {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 131], {
               LineBox[{{0.743, 9.880899300780758}, {0.743, 
                1.2705931396171564`}}], 
               LineBox[{
                Offset[{1.5, 0}, {0.743, 9.880899300780758}], 
                 Offset[{-1.5, 0}, {0.743, 9.880899300780758}]}], 
               LineBox[{
                Offset[{1.5, 0}, {0.743, 1.2705931396171564`}], 
                 Offset[{-1.5, 0}, {0.743, 1.2705931396171564`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 132], {
               LineBox[{{1.302, 9.880899300780758}, {1.302, 
                1.2413019883167435`}}], 
               LineBox[{
                Offset[{1.5, 0}, {1.302, 9.880899300780758}], 
                 Offset[{-1.5, 0}, {1.302, 9.880899300780758}]}], 
               LineBox[{
                Offset[{1.5, 0}, {1.302, 1.2413019883167435`}], 
                 Offset[{-1.5, 0}, {1.302, 1.2413019883167435`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 133], {
               LineBox[{{1.331, 9.880899300780758}, {1.331, 
                1.2413019883167435`}}], 
               LineBox[{
                Offset[{1.5, 0}, {1.331, 9.880899300780758}], 
                 Offset[{-1.5, 0}, {1.331, 9.880899300780758}]}], 
               LineBox[{
                Offset[{1.5, 0}, {1.331, 1.2413019883167435`}], 
                 Offset[{-1.5, 0}, {1.331, 1.2413019883167435`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 134], {
               LineBox[{{3.665, 6.426750597338426}, {3.665, 
                1.2413019883167435`}}], 
               LineBox[{
                Offset[{1.5, 0}, {3.665, 6.426750597338426}], 
                 Offset[{-1.5, 0}, {3.665, 6.426750597338426}]}], 
               LineBox[{
                Offset[{1.5, 0}, {3.665, 1.2413019883167435`}], 
                 Offset[{-1.5, 0}, {3.665, 1.2413019883167435`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 135], {
               LineBox[{{4.182, 6.426750597338426}, {4.182, 
                1.2413019883167435`}}], 
               LineBox[{
                Offset[{1.5, 0}, {4.182, 6.426750597338426}], 
                 Offset[{-1.5, 0}, {4.182, 6.426750597338426}]}], 
               LineBox[{
                Offset[{1.5, 0}, {4.182, 1.2413019883167435`}], 
                 Offset[{-1.5, 0}, {4.182, 1.2413019883167435`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 136], {
               LineBox[{{4.347, 6.426750597338426}, {4.347, 
                1.2413019883167435`}}], 
               LineBox[{
                Offset[{1.5, 0}, {4.347, 6.426750597338426}], 
                 Offset[{-1.5, 0}, {4.347, 6.426750597338426}]}], 
               LineBox[{
                Offset[{1.5, 0}, {4.347, 1.2413019883167435`}], 
                 Offset[{-1.5, 0}, {4.347, 1.2413019883167435`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 137], {
               LineBox[{{4.444, 6.426750597338426}, {4.444, 
                1.2413019883167435`}}], 
               LineBox[{
                Offset[{1.5, 0}, {4.444, 6.426750597338426}], 
                 Offset[{-1.5, 0}, {4.444, 6.426750597338426}]}], 
               LineBox[{
                Offset[{1.5, 0}, {4.444, 1.2413019883167435`}], 
                 Offset[{-1.5, 0}, {4.444, 1.2413019883167435`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 138], {
               LineBox[{{4.808, 6.426750597338426}, {4.808, 
                1.2413019883167435`}}], 
               LineBox[{
                Offset[{1.5, 0}, {4.808, 6.426750597338426}], 
                 Offset[{-1.5, 0}, {4.808, 6.426750597338426}]}], 
               LineBox[{
                Offset[{1.5, 0}, {4.808, 1.2413019883167435`}], 
                 Offset[{-1.5, 0}, {4.808, 1.2413019883167435`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 139], {
               LineBox[{{7.249, 6.426750597338425}, {7.249, 
                1.0947203887883095`}}], 
               LineBox[{
                Offset[{1.5, 0}, {7.249, 6.426750597338425}], 
                 Offset[{-1.5, 0}, {7.249, 6.426750597338425}]}], 
               LineBox[{
                Offset[{1.5, 0}, {7.249, 1.0947203887883095`}], 
                 Offset[{-1.5, 0}, {7.249, 1.0947203887883095`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 140], {
               LineBox[{{8.975, 6.1465077448975745`}, {8.975, 
                1.0947203887883095`}}], 
               LineBox[{
                Offset[{1.5, 0}, {8.975, 6.1465077448975745`}], 
                 Offset[{-1.5, 0}, {8.975, 6.1465077448975745`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {8.975, 1.0947203887883095`}], 
                 Offset[{-1.5, 0}, {8.975, 1.0947203887883095`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 141], {
               LineBox[{{9.286, 6.1465077448975745`}, {9.286, 
                1.0947203887883095`}}], 
               LineBox[{
                Offset[{1.5, 0}, {9.286, 6.1465077448975745`}], 
                 Offset[{-1.5, 0}, {9.286, 6.1465077448975745`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {9.286, 1.0947203887883095`}], 
                 Offset[{-1.5, 0}, {9.286, 1.0947203887883095`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 142], {
               LineBox[{{10.852, 9.348788653909546}, {10.852, 
                1.0528331373431263`}}], 
               LineBox[{
                Offset[{1.5, 0}, {10.852, 9.348788653909546}], 
                 Offset[{-1.5, 0}, {10.852, 9.348788653909546}]}], 
               LineBox[{
                Offset[{1.5, 0}, {10.852, 1.0528331373431263`}], 
                 Offset[{-1.5, 0}, {10.852, 1.0528331373431263`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 143], {
               LineBox[{{11.558, 9.55711731363326}, {11.558, 
                1.0947203887883095`}}], 
               LineBox[{
                Offset[{1.5, 0}, {11.558, 9.55711731363326}], 
                 Offset[{-1.5, 0}, {11.558, 9.55711731363326}]}], 
               LineBox[{
                Offset[{1.5, 0}, {11.558, 1.0947203887883095`}], 
                 Offset[{-1.5, 0}, {11.558, 1.0947203887883095`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 144], {
               LineBox[{{13.715, 11.421825578908159`}, {13.715, 
                1.0947203887883095`}}], 
               LineBox[{
                Offset[{1.5, 0}, {13.715, 11.421825578908159`}], 
                 Offset[{-1.5, 0}, {13.715, 11.421825578908159`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {13.715, 1.0947203887883095`}], 
                 Offset[{-1.5, 0}, {13.715, 1.0947203887883095`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 145], {
               LineBox[{{13.947, 11.558660124896633`}, {13.947, 
                1.0947203887883095`}}], 
               LineBox[{
                Offset[{1.5, 0}, {13.947, 11.558660124896633`}], 
                 Offset[{-1.5, 0}, {13.947, 11.558660124896633`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {13.947, 1.0947203887883095`}], 
                 Offset[{-1.5, 0}, {13.947, 1.0947203887883095`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 146], {
               LineBox[{{15.079, 11.558660124896633`}, {15.079, 
                1.1759068869287206`}}], 
               LineBox[{
                Offset[{1.5, 0}, {15.079, 11.558660124896633`}], 
                 Offset[{-1.5, 0}, {15.079, 11.558660124896633`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {15.079, 1.1759068869287206`}], 
                 Offset[{-1.5, 0}, {15.079, 1.1759068869287206`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 147], {
               LineBox[{{16.963, 12.731143725881255`}, {16.963, 
                1.280423753160517}}], 
               LineBox[{
                Offset[{1.5, 0}, {16.963, 12.731143725881255`}], 
                 Offset[{-1.5, 0}, {16.963, 12.731143725881255`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {16.963, 1.280423753160517}], 
                 Offset[{-1.5, 0}, {16.963, 1.280423753160517}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 148], {
               LineBox[{{17.007, 12.731143725881255`}, {17.007, 
                1.280423753160517}}], 
               LineBox[{
                Offset[{1.5, 0}, {17.007, 12.731143725881255`}], 
                 Offset[{-1.5, 0}, {17.007, 12.731143725881255`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {17.007, 1.280423753160517}], 
                 Offset[{-1.5, 0}, {17.007, 1.280423753160517}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 149], {
               LineBox[{{17.575, 12.831237711501643`}, {17.575, 
                1.280423753160517}}], 
               LineBox[{
                Offset[{1.5, 0}, {17.575, 12.831237711501643`}], 
                 Offset[{-1.5, 0}, {17.575, 12.831237711501643`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {17.575, 1.280423753160517}], 
                 Offset[{-1.5, 0}, {17.575, 1.280423753160517}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 150], {
               LineBox[{{17.876, 12.831237711501643`}, {17.876, 
                2.182104774020174}}], 
               LineBox[{
                Offset[{1.5, 0}, {17.876, 12.831237711501643`}], 
                 Offset[{-1.5, 0}, {17.876, 12.831237711501643`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {17.876, 2.182104774020174}], 
                 Offset[{-1.5, 0}, {17.876, 2.182104774020174}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 151], {
               LineBox[{{17.947, 12.831237711501643`}, {17.947, 
                2.182104774020173}}], 
               LineBox[{
                Offset[{1.5, 0}, {17.947, 12.831237711501643`}], 
                 Offset[{-1.5, 0}, {17.947, 12.831237711501643`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {17.947, 2.182104774020173}], 
                 Offset[{-1.5, 0}, {17.947, 2.182104774020173}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 152], {
               LineBox[{{18.001, 12.831237711501643`}, {18.001, 
                2.182104774020173}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.001, 12.831237711501643`}], 
                 Offset[{-1.5, 0}, {18.001, 12.831237711501643`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.001, 2.182104774020173}], 
                 Offset[{-1.5, 0}, {18.001, 2.182104774020173}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 153], {
               LineBox[{{18.031, 12.831237711501643`}, {18.031, 
                2.182104774020174}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.031, 12.831237711501643`}], 
                 Offset[{-1.5, 0}, {18.031, 12.831237711501643`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.031, 2.182104774020174}], 
                 Offset[{-1.5, 0}, {18.031, 2.182104774020174}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 154], {
               LineBox[{{18.145, 13.49337739468438}, {18.145, 
                2.182104774020174}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.145, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {18.145, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.145, 2.182104774020174}], 
                 Offset[{-1.5, 0}, {18.145, 2.182104774020174}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 155], {
               LineBox[{{18.256, 13.49337739468438}, {18.256, 
                2.182104774020174}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.256, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {18.256, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.256, 2.182104774020174}], 
                 Offset[{-1.5, 0}, {18.256, 2.182104774020174}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 156], {
               LineBox[{{18.328, 13.49337739468438}, {18.328, 
                2.182104774020173}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.328, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {18.328, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.328, 2.182104774020173}], 
                 Offset[{-1.5, 0}, {18.328, 2.182104774020173}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 157], {
               LineBox[{{18.494, 13.49337739468438}, {18.494, 
                2.182104774020174}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.494, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {18.494, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.494, 2.182104774020174}], 
                 Offset[{-1.5, 0}, {18.494, 2.182104774020174}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 158], {
               LineBox[{{18.509, 13.49337739468438}, {18.509, 
                2.182104774020174}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.509, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {18.509, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.509, 2.182104774020174}], 
                 Offset[{-1.5, 0}, {18.509, 2.182104774020174}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 159], {
               LineBox[{{18.59, 13.49337739468438}, {18.59, 
                2.1439556734903116`}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.59, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {18.59, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.59, 2.1439556734903116`}], 
                 Offset[{-1.5, 0}, {18.59, 2.1439556734903116`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 160], {
               LineBox[{{18.702, 13.49337739468438}, {18.702, 
                2.1439556734903116`}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.702, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {18.702, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.702, 2.1439556734903116`}], 
                 Offset[{-1.5, 0}, {18.702, 2.1439556734903116`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 161], {
               LineBox[{{18.91, 13.49337739468438}, {18.91, 
                2.1439556734903116`}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.91, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {18.91, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.91, 2.1439556734903116`}], 
                 Offset[{-1.5, 0}, {18.91, 2.1439556734903116`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 162], {
               LineBox[{{18.99, 13.49337739468438}, {18.99, 
                2.1439556734903116`}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.99, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {18.99, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.99, 2.1439556734903116`}], 
                 Offset[{-1.5, 0}, {18.99, 2.1439556734903116`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 163], {
               LineBox[{{19.109, 13.49337739468438}, {19.109, 
                2.1439556734903107`}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.109, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {19.109, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.109, 2.1439556734903107`}], 
                 Offset[{-1.5, 0}, {19.109, 2.1439556734903107`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 164], {
               LineBox[{{19.199, 13.49337739468438}, {19.199, 
                2.1439556734903107`}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.199, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {19.199, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.199, 2.1439556734903107`}], 
                 Offset[{-1.5, 0}, {19.199, 2.1439556734903107`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 165], {
               LineBox[{{19.262, 13.49337739468438}, {19.262, 
                2.1439556734903107`}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.262, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {19.262, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.262, 2.1439556734903107`}], 
                 Offset[{-1.5, 0}, {19.262, 2.1439556734903107`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 166], {
               LineBox[{{19.295, 13.49337739468438}, {19.295, 
                2.1439556734903107`}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.295, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {19.295, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.295, 2.1439556734903107`}], 
                 Offset[{-1.5, 0}, {19.295, 2.1439556734903107`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 167], {
               LineBox[{{19.3, 13.49337739468438}, {19.3, 
                2.1439556734903107`}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.3, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {19.3, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.3, 2.1439556734903107`}], 
                 Offset[{-1.5, 0}, {19.3, 2.1439556734903107`}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 168], {
               LineBox[{{19.313, 13.49337739468438}, {19.313, 
                2.1439556734903107`}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.313, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {19.313, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.313, 2.1439556734903107`}], 
                 Offset[{-1.5, 0}, {19.313, 2.1439556734903107`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 169], {
               LineBox[{{19.382, 13.49337739468438}, {19.382, 
                2.1439556734903107`}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.382, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {19.382, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.382, 2.1439556734903107`}], 
                 Offset[{-1.5, 0}, {19.382, 2.1439556734903107`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 170], {
               LineBox[{{19.459, 13.49337739468438}, {19.459, 
                2.1439556734903107`}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.459, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {19.459, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.459, 2.1439556734903107`}], 
                 Offset[{-1.5, 0}, {19.459, 2.1439556734903107`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 171], {
               LineBox[{{19.755, 13.49337739468438}, {19.755, 
                2.1439556734903107`}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.755, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {19.755, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.755, 2.1439556734903107`}], 
                 Offset[{-1.5, 0}, {19.755, 2.1439556734903107`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 172], {
               LineBox[{{19.868, 13.49337739468438}, {19.868, 
                2.1439556734903107`}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.868, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {19.868, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.868, 2.1439556734903107`}], 
                 Offset[{-1.5, 0}, {19.868, 2.1439556734903107`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 173], {
               LineBox[{{20.236, 13.49337739468438}, {20.236, 
                2.1439556734903107`}}], 
               LineBox[{
                Offset[{1.5, 0}, {20.236, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {20.236, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {20.236, 2.1439556734903107`}], 
                 Offset[{-1.5, 0}, {20.236, 2.1439556734903107`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 174], {
               LineBox[{{20.53, 13.49337739468438}, {20.53, 
                2.1439556734903107`}}], 
               LineBox[{
                Offset[{1.5, 0}, {20.53, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {20.53, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {20.53, 2.1439556734903107`}], 
                 Offset[{-1.5, 0}, {20.53, 2.1439556734903107`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 175], {
               LineBox[{{20.811, 13.49337739468438}, {20.811, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {20.811, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {20.811, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {20.811, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {20.811, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 176], {
               LineBox[{{21.093, 13.49337739468438}, {21.093, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {21.093, 13.49337739468438}], 
                 Offset[{-1.5, 0}, {21.093, 13.49337739468438}]}], 
               LineBox[{
                Offset[{1.5, 0}, {21.093, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {21.093, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 177], {
               LineBox[{{21.369, 15.803387118844666`}, {21.369, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {21.369, 15.803387118844666`}], 
                 Offset[{-1.5, 0}, {21.369, 15.803387118844666`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {21.369, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {21.369, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 178], {
               LineBox[{{21.681, 15.803387118844666`}, {21.681, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {21.681, 15.803387118844666`}], 
                 Offset[{-1.5, 0}, {21.681, 15.803387118844666`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {21.681, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {21.681, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 179], {
               LineBox[{{22.015, 15.803387118844666`}, {22.015, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.015, 15.803387118844666`}], 
                 Offset[{-1.5, 0}, {22.015, 15.803387118844666`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.015, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {22.015, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 180], {
               LineBox[{{22.042, 15.803387118844666`}, {22.042, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.042, 15.803387118844666`}], 
                 Offset[{-1.5, 0}, {22.042, 15.803387118844666`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.042, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {22.042, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 181], {
               LineBox[{{22.069, 15.803387118844666`}, {22.069, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.069, 15.803387118844666`}], 
                 Offset[{-1.5, 0}, {22.069, 15.803387118844666`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.069, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {22.069, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 182], {
               LineBox[{{22.075, 15.803387118844666`}, {22.075, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.075, 15.803387118844666`}], 
                 Offset[{-1.5, 0}, {22.075, 15.803387118844666`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.075, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {22.075, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 183], {
               LineBox[{{22.106, 15.803387118844666`}, {22.106, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.106, 15.803387118844666`}], 
                 Offset[{-1.5, 0}, {22.106, 15.803387118844666`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.106, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {22.106, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 184], {
               LineBox[{{22.298, 15.803387118844668`}, {22.298, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.298, 15.803387118844668`}], 
                 Offset[{-1.5, 0}, {22.298, 15.803387118844668`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.298, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {22.298, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 185], {
               LineBox[{{22.394, 15.803387118844668`}, {22.394, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.394, 15.803387118844668`}], 
                 Offset[{-1.5, 0}, {22.394, 15.803387118844668`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.394, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {22.394, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 186], {
               LineBox[{{22.424, 15.803387118844668`}, {22.424, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.424, 15.803387118844668`}], 
                 Offset[{-1.5, 0}, {22.424, 15.803387118844668`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.424, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {22.424, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 187], {
               LineBox[{{22.438, 15.803387118844668`}, {22.438, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.438, 15.803387118844668`}], 
                 Offset[{-1.5, 0}, {22.438, 15.803387118844668`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.438, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {22.438, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 188], {
               LineBox[{{22.58, 15.803387118844668`}, {22.58, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.58, 15.803387118844668`}], 
                 Offset[{-1.5, 0}, {22.58, 15.803387118844668`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.58, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {22.58, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 189], {
               LineBox[{{22.583, 15.803387118844668`}, {22.583, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.583, 15.803387118844668`}], 
                 Offset[{-1.5, 0}, {22.583, 15.803387118844668`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.583, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {22.583, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 190], {
               LineBox[{{22.826, 15.803387118844668`}, {22.826, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.826, 15.803387118844668`}], 
                 Offset[{-1.5, 0}, {22.826, 15.803387118844668`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.826, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {22.826, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 191], {
               LineBox[{{22.853, 15.803387118844668`}, {22.853, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.853, 15.803387118844668`}], 
                 Offset[{-1.5, 0}, {22.853, 15.803387118844668`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.853, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {22.853, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 192], {
               LineBox[{{23.162, 15.560009649225263`}, {23.162, 
                2.0557998473197294`}}], 
               LineBox[{
                Offset[{1.5, 0}, {23.162, 15.560009649225263`}], 
                 Offset[{-1.5, 0}, {23.162, 15.560009649225263`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {23.162, 2.0557998473197294`}], 
                 Offset[{-1.5, 0}, {23.162, 2.0557998473197294`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 193], {
               LineBox[{{23.173, 15.560009649225263`}, {23.173, 
                2.0557998473197294`}}], 
               LineBox[{
                Offset[{1.5, 0}, {23.173, 15.560009649225263`}], 
                 Offset[{-1.5, 0}, {23.173, 15.560009649225263`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {23.173, 2.0557998473197294`}], 
                 Offset[{-1.5, 0}, {23.173, 2.0557998473197294`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 194], {
               LineBox[{{23.435, 15.73547338959265}, {23.435, 
                2.0557998473197294`}}], 
               LineBox[{
                Offset[{1.5, 0}, {23.435, 15.73547338959265}], 
                 Offset[{-1.5, 0}, {23.435, 15.73547338959265}]}], 
               LineBox[{
                Offset[{1.5, 0}, {23.435, 2.0557998473197294`}], 
                 Offset[{-1.5, 0}, {23.435, 2.0557998473197294`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 195], {
               LineBox[{{24.089, 15.73547338959265}, {24.089, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {24.089, 15.73547338959265}], 
                 Offset[{-1.5, 0}, {24.089, 15.73547338959265}]}], 
               LineBox[{
                Offset[{1.5, 0}, {24.089, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {24.089, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 196], {
               LineBox[{{24.401, 15.735473389592649`}, {24.401, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {24.401, 15.735473389592649`}], 
                 Offset[{-1.5, 0}, {24.401, 15.735473389592649`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {24.401, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {24.401, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 197], {
               LineBox[{{24.656, 15.735473389592649`}, {24.656, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {24.656, 15.735473389592649`}], 
                 Offset[{-1.5, 0}, {24.656, 15.735473389592649`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {24.656, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {24.656, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 198], {
               LineBox[{{24.997, 15.73547338959265}, {24.997, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {24.997, 15.73547338959265}], 
                 Offset[{-1.5, 0}, {24.997, 15.73547338959265}]}], 
               LineBox[{
                Offset[{1.5, 0}, {24.997, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {24.997, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 199], {
               LineBox[{{25.417, 15.73547338959265}, {25.417, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {25.417, 15.73547338959265}], 
                 Offset[{-1.5, 0}, {25.417, 15.73547338959265}]}], 
               LineBox[{
                Offset[{1.5, 0}, {25.417, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {25.417, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 200], {
               LineBox[{{25.539, 15.73547338959265}, {25.539, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {25.539, 15.73547338959265}], 
                 Offset[{-1.5, 0}, {25.539, 15.73547338959265}]}], 
               LineBox[{
                Offset[{1.5, 0}, {25.539, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {25.539, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 201], {
               LineBox[{{25.624, 15.73547338959265}, {25.624, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {25.624, 15.73547338959265}], 
                 Offset[{-1.5, 0}, {25.624, 15.73547338959265}]}], 
               LineBox[{
                Offset[{1.5, 0}, {25.624, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {25.624, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 202], {
               LineBox[{{25.713, 15.73547338959265}, {25.713, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {25.713, 15.73547338959265}], 
                 Offset[{-1.5, 0}, {25.713, 15.73547338959265}]}], 
               LineBox[{
                Offset[{1.5, 0}, {25.713, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {25.713, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 203], {
               LineBox[{{25.733, 15.73547338959265}, {25.733, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {25.733, 15.73547338959265}], 
                 Offset[{-1.5, 0}, {25.733, 15.73547338959265}]}], 
               LineBox[{
                Offset[{1.5, 0}, {25.733, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {25.733, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 204], {
               LineBox[{{25.776, 15.73547338959265}, {25.776, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {25.776, 15.73547338959265}], 
                 Offset[{-1.5, 0}, {25.776, 15.73547338959265}]}], 
               LineBox[{
                Offset[{1.5, 0}, {25.776, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {25.776, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 205], {
               LineBox[{{26.183, 15.73547338959265}, {26.183, 
                2.131498096857408}}], 
               LineBox[{
                Offset[{1.5, 0}, {26.183, 15.73547338959265}], 
                 Offset[{-1.5, 0}, {26.183, 15.73547338959265}]}], 
               LineBox[{
                Offset[{1.5, 0}, {26.183, 2.131498096857408}], 
                 Offset[{-1.5, 0}, {26.183, 2.131498096857408}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 206], {
               LineBox[{{26.335, 15.803387118844666`}, {26.335, 
                2.143955673490311}}], 
               LineBox[{
                Offset[{1.5, 0}, {26.335, 15.803387118844666`}], 
                 Offset[{-1.5, 0}, {26.335, 15.803387118844666`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {26.335, 2.143955673490311}], 
                 Offset[{-1.5, 0}, {26.335, 2.143955673490311}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 207], {
               LineBox[{{26.592, 15.803387118844666`}, {26.592, 
                2.143955673490311}}], 
               LineBox[{
                Offset[{1.5, 0}, {26.592, 15.803387118844666`}], 
                 Offset[{-1.5, 0}, {26.592, 15.803387118844666`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {26.592, 2.143955673490311}], 
                 Offset[{-1.5, 0}, {26.592, 2.143955673490311}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 208], {
               LineBox[{{26.595, 15.803387118844666`}, {26.595, 
                2.143955673490311}}], 
               LineBox[{
                Offset[{1.5, 0}, {26.595, 15.803387118844666`}], 
                 Offset[{-1.5, 0}, {26.595, 15.803387118844666`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {26.595, 2.143955673490311}], 
                 Offset[{-1.5, 0}, {26.595, 2.143955673490311}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 209], {
               LineBox[{{26.703, 15.803387118844666`}, {26.703, 
                2.143955673490311}}], 
               LineBox[{
                Offset[{1.5, 0}, {26.703, 15.803387118844666`}], 
                 Offset[{-1.5, 0}, {26.703, 15.803387118844666`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {26.703, 2.143955673490311}], 
                 Offset[{-1.5, 0}, {26.703, 2.143955673490311}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 210], {
               LineBox[{{26.778, 15.803387118844666`}, {26.778, 
                2.1439556734903107`}}], 
               LineBox[{
                Offset[{1.5, 0}, {26.778, 15.803387118844666`}], 
                 Offset[{-1.5, 0}, {26.778, 15.803387118844666`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {26.778, 2.1439556734903107`}], 
                 Offset[{-1.5, 0}, {26.778, 2.1439556734903107`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 211], {
               LineBox[{{27.11, 16.039867058033586`}, {27.11, 
                2.3386400580802933`}}], 
               LineBox[{
                Offset[{1.5, 0}, {27.11, 16.039867058033586`}], 
                 Offset[{-1.5, 0}, {27.11, 16.039867058033586`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.11, 2.3386400580802933`}], 
                 Offset[{-1.5, 0}, {27.11, 2.3386400580802933`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 212], {
               LineBox[{{27.154, 16.039867058033586`}, {27.154, 
                2.3386400580802933`}}], 
               LineBox[{
                Offset[{1.5, 0}, {27.154, 16.039867058033586`}], 
                 Offset[{-1.5, 0}, {27.154, 16.039867058033586`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.154, 2.3386400580802933`}], 
                 Offset[{-1.5, 0}, {27.154, 2.3386400580802933`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 213], {
               LineBox[{{27.276, 16.039867058033586`}, {27.276, 
                2.4972493252177714`}}], 
               LineBox[{
                Offset[{1.5, 0}, {27.276, 16.039867058033586`}], 
                 Offset[{-1.5, 0}, {27.276, 16.039867058033586`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.276, 2.4972493252177714`}], 
                 Offset[{-1.5, 0}, {27.276, 2.4972493252177714`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 214], {
               LineBox[{{27.277, 16.039867058033586`}, {27.277, 
                2.4972493252177714`}}], 
               LineBox[{
                Offset[{1.5, 0}, {27.277, 16.039867058033586`}], 
                 Offset[{-1.5, 0}, {27.277, 16.039867058033586`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.277, 2.4972493252177714`}], 
                 Offset[{-1.5, 0}, {27.277, 2.4972493252177714`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 215], {
               LineBox[{{27.343, 16.039867058033586`}, {27.343, 
                2.4972493252177714`}}], 
               LineBox[{
                Offset[{1.5, 0}, {27.343, 16.039867058033586`}], 
                 Offset[{-1.5, 0}, {27.343, 16.039867058033586`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.343, 2.4972493252177714`}], 
                 Offset[{-1.5, 0}, {27.343, 2.4972493252177714`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 216], {
               LineBox[{{27.478, 16.039867058033586`}, {27.478, 
                2.4972493252177714`}}], 
               LineBox[{
                Offset[{1.5, 0}, {27.478, 16.039867058033586`}], 
                 Offset[{-1.5, 0}, {27.478, 16.039867058033586`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.478, 2.4972493252177714`}], 
                 Offset[{-1.5, 0}, {27.478, 2.4972493252177714`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 217], {
               LineBox[{{27.557, 16.039867058033586`}, {27.557, 
                2.4972493252177714`}}], 
               LineBox[{
                Offset[{1.5, 0}, {27.557, 16.039867058033586`}], 
                 Offset[{-1.5, 0}, {27.557, 16.039867058033586`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.557, 2.4972493252177714`}], 
                 Offset[{-1.5, 0}, {27.557, 2.4972493252177714`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 218], {
               LineBox[{{27.789, 14.867088338069141`}, {27.789, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {27.789, 14.867088338069141`}], 
                 Offset[{-1.5, 0}, {27.789, 14.867088338069141`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.789, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {27.789, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 219], {
               LineBox[{{27.832, 14.867088338069141`}, {27.832, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {27.832, 14.867088338069141`}], 
                 Offset[{-1.5, 0}, {27.832, 14.867088338069141`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.832, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {27.832, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 220], {
               LineBox[{{28.097, 13.91451339484205}, {28.097, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {28.097, 13.91451339484205}], 
                 Offset[{-1.5, 0}, {28.097, 13.91451339484205}]}], 
               LineBox[{
                Offset[{1.5, 0}, {28.097, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {28.097, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 221], {
               LineBox[{{28.35, 12.326095762132013`}, {28.35, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {28.35, 12.326095762132013`}], 
                 Offset[{-1.5, 0}, {28.35, 12.326095762132013`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {28.35, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {28.35, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 222], {
               LineBox[{{28.599, 12.326095762132013`}, {28.599, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {28.599, 12.326095762132013`}], 
                 Offset[{-1.5, 0}, {28.599, 12.326095762132013`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {28.599, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {28.599, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 223], {
               LineBox[{{28.735, 12.326095762132013`}, {28.735, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {28.735, 12.326095762132013`}], 
                 Offset[{-1.5, 0}, {28.735, 12.326095762132013`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {28.735, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {28.735, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 224], {
               LineBox[{{28.838, 12.321746398834286`}, {28.838, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {28.838, 12.321746398834286`}], 
                 Offset[{-1.5, 0}, {28.838, 12.321746398834286`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {28.838, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {28.838, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 225], {
               LineBox[{{29.067, 12.321746398834286`}, {29.067, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {29.067, 12.321746398834286`}], 
                 Offset[{-1.5, 0}, {29.067, 12.321746398834286`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {29.067, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {29.067, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 226], {
               LineBox[{{29.319, 12.473955941640604`}, {29.319, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {29.319, 12.473955941640604`}], 
                 Offset[{-1.5, 0}, {29.319, 12.473955941640604`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {29.319, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {29.319, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 227], {
               LineBox[{{29.352, 12.473955941640604`}, {29.352, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {29.352, 12.473955941640604`}], 
                 Offset[{-1.5, 0}, {29.352, 12.473955941640604`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {29.352, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {29.352, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 228], {
               LineBox[{{29.373, 12.473955941640604`}, {29.373, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {29.373, 12.473955941640604`}], 
                 Offset[{-1.5, 0}, {29.373, 12.473955941640604`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {29.373, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {29.373, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 229], {
               LineBox[{{29.48, 12.473955941640604`}, {29.48, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {29.48, 12.473955941640604`}], 
                 Offset[{-1.5, 0}, {29.48, 12.473955941640604`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {29.48, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {29.48, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 230], {
               LineBox[{{29.623, 12.473955941640604`}, {29.623, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {29.623, 12.473955941640604`}], 
                 Offset[{-1.5, 0}, {29.623, 12.473955941640604`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {29.623, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {29.623, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 231], {
               LineBox[{{29.642, 12.473955941640604`}, {29.642, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {29.642, 12.473955941640604`}], 
                 Offset[{-1.5, 0}, {29.642, 12.473955941640604`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {29.642, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {29.642, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 232], {
               LineBox[{{29.994, 12.473955941640604`}, {29.994, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {29.994, 12.473955941640604`}], 
                 Offset[{-1.5, 0}, {29.994, 12.473955941640604`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {29.994, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {29.994, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 233], {
               LineBox[{{30.094, 12.321746398834286`}, {30.094, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {30.094, 12.321746398834286`}], 
                 Offset[{-1.5, 0}, {30.094, 12.321746398834286`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {30.094, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {30.094, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 234], {
               LineBox[{{30.247, 12.321746398834286`}, {30.247, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {30.247, 12.321746398834286`}], 
                 Offset[{-1.5, 0}, {30.247, 12.321746398834286`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {30.247, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {30.247, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 235], {
               LineBox[{{30.249, 12.321746398834286`}, {30.249, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {30.249, 12.321746398834286`}], 
                 Offset[{-1.5, 0}, {30.249, 12.321746398834286`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {30.249, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {30.249, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 236], {
               LineBox[{{30.495, 12.321746398834286`}, {30.495, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {30.495, 12.321746398834286`}], 
                 Offset[{-1.5, 0}, {30.495, 12.321746398834286`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {30.495, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {30.495, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 237], {
               LineBox[{{30.784, 12.321746398834286`}, {30.784, 
                2.698683656174475}}], 
               LineBox[{
                Offset[{1.5, 0}, {30.784, 12.321746398834286`}], 
                 Offset[{-1.5, 0}, {30.784, 12.321746398834286`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {30.784, 2.698683656174475}], 
                 Offset[{-1.5, 0}, {30.784, 2.698683656174475}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 238], {
               LineBox[{{31.329, 12.321746398834286`}, {31.329, 
                2.6588406238259745`}}], 
               LineBox[{
                Offset[{1.5, 0}, {31.329, 12.321746398834286`}], 
                 Offset[{-1.5, 0}, {31.329, 12.321746398834286`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {31.329, 2.6588406238259745`}], 
                 Offset[{-1.5, 0}, {31.329, 2.6588406238259745`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 239], {
               LineBox[{{31.363, 12.321746398834286`}, {31.363, 
                2.6588406238259745`}}], 
               LineBox[{
                Offset[{1.5, 0}, {31.363, 12.321746398834286`}], 
                 Offset[{-1.5, 0}, {31.363, 12.321746398834286`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {31.363, 2.6588406238259745`}], 
                 Offset[{-1.5, 0}, {31.363, 2.6588406238259745`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 240], {
               LineBox[{{31.482, 12.321746398834286`}, {31.482, 
                1.6016961044634535`}}], 
               LineBox[{
                Offset[{1.5, 0}, {31.482, 12.321746398834286`}], 
                 Offset[{-1.5, 0}, {31.482, 12.321746398834286`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {31.482, 1.6016961044634535`}], 
                 Offset[{-1.5, 0}, {31.482, 1.6016961044634535`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 241], {
               LineBox[{{31.843, 11.605250004565127`}, {31.843, 
                1.3732778136327446`}}], 
               LineBox[{
                Offset[{1.5, 0}, {31.843, 11.605250004565127`}], 
                 Offset[{-1.5, 0}, {31.843, 11.605250004565127`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {31.843, 1.3732778136327446`}], 
                 Offset[{-1.5, 0}, {31.843, 1.3732778136327446`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 242], {
               LineBox[{{32.009, 11.479389690623226`}, {32.009, 
                1.3732778136327446`}}], 
               LineBox[{
                Offset[{1.5, 0}, {32.009, 11.479389690623226`}], 
                 Offset[{-1.5, 0}, {32.009, 11.479389690623226`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {32.009, 1.3732778136327446`}], 
                 Offset[{-1.5, 0}, {32.009, 1.3732778136327446`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 243], {
               LineBox[{{33.48, 8.890651729926178}, {33.48, 
                1.1034861520768264`}}], 
               LineBox[{
                Offset[{1.5, 0}, {33.48, 8.890651729926178}], 
                 Offset[{-1.5, 0}, {33.48, 8.890651729926178}]}], 
               LineBox[{
                Offset[{1.5, 0}, {33.48, 1.1034861520768264`}], 
                 Offset[{-1.5, 0}, {33.48, 1.1034861520768264`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 244], {
               LineBox[{{33.533, 8.890651729926178}, {33.533, 
                1.1034861520768264`}}], 
               LineBox[{
                Offset[{1.5, 0}, {33.533, 8.890651729926178}], 
                 Offset[{-1.5, 0}, {33.533, 8.890651729926178}]}], 
               LineBox[{
                Offset[{1.5, 0}, {33.533, 1.1034861520768264`}], 
                 Offset[{-1.5, 0}, {33.533, 1.1034861520768264`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 245], {
               LineBox[{{34.483, 8.890651729926178}, {34.483, 
                1.0754855450416807`}}], 
               LineBox[{
                Offset[{1.5, 0}, {34.483, 8.890651729926178}], 
                 Offset[{-1.5, 0}, {34.483, 8.890651729926178}]}], 
               LineBox[{
                Offset[{1.5, 0}, {34.483, 1.0754855450416807`}], 
                 Offset[{-1.5, 0}, {34.483, 1.0754855450416807`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 246], {
               LineBox[{{34.488, 8.890651729926178}, {34.488, 
                1.0754855450416807`}}], 
               LineBox[{
                Offset[{1.5, 0}, {34.488, 8.890651729926178}], 
                 Offset[{-1.5, 0}, {34.488, 8.890651729926178}]}], 
               LineBox[{
                Offset[{1.5, 0}, {34.488, 1.0754855450416807`}], 
                 Offset[{-1.5, 0}, {34.488, 1.0754855450416807`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 247], {
               LineBox[{{34.62, 7.953982742084829}, {34.62, 
                1.0754855450416807`}}], 
               LineBox[{
                Offset[{1.5, 0}, {34.62, 7.953982742084829}], 
                 Offset[{-1.5, 0}, {34.62, 7.953982742084829}]}], 
               LineBox[{
                Offset[{1.5, 0}, {34.62, 1.0754855450416807`}], 
                 Offset[{-1.5, 0}, {34.62, 1.0754855450416807`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 248], {
               LineBox[{{39.634, 8.251917320812652}, {39.634, 
                1.0940578650298862`}}], 
               LineBox[{
                Offset[{1.5, 0}, {39.634, 8.251917320812652}], 
                 Offset[{-1.5, 0}, {39.634, 8.251917320812652}]}], 
               LineBox[{
                Offset[{1.5, 0}, {39.634, 1.0940578650298862`}], 
                 Offset[{-1.5, 0}, {39.634, 1.0940578650298862`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 249], {
               LineBox[{{40.641, 8.141752207470867}, {40.641, 
                1.0940578650298862`}}], 
               LineBox[{
                Offset[{1.5, 0}, {40.641, 8.141752207470867}], 
                 Offset[{-1.5, 0}, {40.641, 8.141752207470867}]}], 
               LineBox[{
                Offset[{1.5, 0}, {40.641, 1.0940578650298862`}], 
                 Offset[{-1.5, 0}, {40.641, 1.0940578650298862`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 250], {
               LineBox[{{42.973, 8.277633615714565}, {42.973, 
                1.0940578650298862`}}], 
               LineBox[{
                Offset[{1.5, 0}, {42.973, 8.277633615714565}], 
                 Offset[{-1.5, 0}, {42.973, 8.277633615714565}]}], 
               LineBox[{
                Offset[{1.5, 0}, {42.973, 1.0940578650298862`}], 
                 Offset[{-1.5, 0}, {42.973, 1.0940578650298862`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 251], {
               LineBox[{{44.283, 11.806473530277493`}, {44.283, 
                1.2362306579711335`}}], 
               LineBox[{
                Offset[{1.5, 0}, {44.283, 11.806473530277493`}], 
                 Offset[{-1.5, 0}, {44.283, 11.806473530277493`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {44.283, 1.2362306579711335`}], 
                 Offset[{-1.5, 0}, {44.283, 1.2362306579711335`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 252], {
               LineBox[{{45.828, 8.364676655025551}, {45.828, 
                1.6135481402583909`}}], 
               LineBox[{
                Offset[{1.5, 0}, {45.828, 8.364676655025551}], 
                 Offset[{-1.5, 0}, {45.828, 8.364676655025551}]}], 
               LineBox[{
                Offset[{1.5, 0}, {45.828, 1.6135481402583909`}], 
                 Offset[{-1.5, 0}, {45.828, 1.6135481402583909`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 253], {
               LineBox[{{46.256, 8.157641236046551}, {46.256, 
                1.6927894211139813`}}], 
               LineBox[{
                Offset[{1.5, 0}, {46.256, 8.157641236046551}], 
                 Offset[{-1.5, 0}, {46.256, 8.157641236046551}]}], 
               LineBox[{
                Offset[{1.5, 0}, {46.256, 1.6927894211139813`}], 
                 Offset[{-1.5, 0}, {46.256, 1.6927894211139813`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 254], {
               LineBox[{{46.658, 10.040666090178572`}, {46.658, 
                1.6927894211139813`}}], 
               LineBox[{
                Offset[{1.5, 0}, {46.658, 10.040666090178572`}], 
                 Offset[{-1.5, 0}, {46.658, 10.040666090178572`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {46.658, 1.6927894211139813`}], 
                 Offset[{-1.5, 0}, {46.658, 1.6927894211139813`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 255], {
               LineBox[{{47.063, 9.746942997663497}, {47.063, 
                1.6927894211139813`}}], 
               LineBox[{
                Offset[{1.5, 0}, {47.063, 9.746942997663497}], 
                 Offset[{-1.5, 0}, {47.063, 9.746942997663497}]}], 
               LineBox[{
                Offset[{1.5, 0}, {47.063, 1.6927894211139813`}], 
                 Offset[{-1.5, 0}, {47.063, 1.6927894211139813`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 256], {
               LineBox[{{47.443, 10.415100678555948`}, {47.443, 
                1.6927894211139813`}}], 
               LineBox[{
                Offset[{1.5, 0}, {47.443, 10.415100678555948`}], 
                 Offset[{-1.5, 0}, {47.443, 10.415100678555948`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {47.443, 1.6927894211139813`}], 
                 Offset[{-1.5, 0}, {47.443, 1.6927894211139813`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 257], {
               LineBox[{{47.856, 8.702863472381466}, {47.856, 
                1.6927894211139813`}}], 
               LineBox[{
                Offset[{1.5, 0}, {47.856, 8.702863472381466}], 
                 Offset[{-1.5, 0}, {47.856, 8.702863472381466}]}], 
               LineBox[{
                Offset[{1.5, 0}, {47.856, 1.6927894211139813`}], 
                 Offset[{-1.5, 0}, {47.856, 1.6927894211139813`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 258], {
               LineBox[{{48.272, 8.702863472381466}, {48.272, 
                1.6927894211139813`}}], 
               LineBox[{
                Offset[{1.5, 0}, {48.272, 8.702863472381466}], 
                 Offset[{-1.5, 0}, {48.272, 8.702863472381466}]}], 
               LineBox[{
                Offset[{1.5, 0}, {48.272, 1.6927894211139813`}], 
                 Offset[{-1.5, 0}, {48.272, 1.6927894211139813`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 259], {
               LineBox[{{49.174, 10.279565801221775`}, {49.174, 
                1.7881765610841414`}}], 
               LineBox[{
                Offset[{1.5, 0}, {49.174, 10.279565801221775`}], 
                 Offset[{-1.5, 0}, {49.174, 10.279565801221775`}]}], 
               LineBox[{
                Offset[{1.5, 0}, {49.174, 1.7881765610841414`}], 
                 Offset[{-1.5, 0}, {49.174, 1.7881765610841414`}]}]}}, {
              InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 260], {
               LineBox[{{49.985, 8.801571361486912}, {49.985, 
                1.7958751621666122`}}], 
               LineBox[{
                Offset[{1.5, 0}, {49.985, 8.801571361486912}], 
                 Offset[{-1.5, 0}, {49.985, 8.801571361486912}]}], 
               LineBox[{
                Offset[{1.5, 0}, {49.985, 1.7958751621666122`}], 
                 Offset[{-1.5, 0}, {49.985, 
                  1.7958751621666122`}]}]}}}, {}}], {}}, {{}, 
          GraphicsComplexBox[CompressedData["
1:eJztlvlTU1cUx8PShEbQRBYTwIXFEovKJoiEJAdZEgQUcMFStAXRaoqKFJQC
RbEDETfGyuJSRIu4dCyjgpRB0OpkFKkrdKDooDKUoS4UAYFaCvbd+5x3nP4N
eb9kPnNz7jv3e7/nvOOQsDl6rTGPxzM14vHI75yLpX2nb/Sorruk7zuW/iH8
EFwzOPbba1XryqyrITcEQJfDhjiOrp2W+yLKAiaZjNpqu/nwV5bKe3WdCJ4n
v93rJhbAlPa7I0vXiMFdHf77HncBsPsjm52zj02UW3Lcfd/x0Ztxey7eizyD
DhAWqd8+1sKHJ0v2lWz6zhGyTH+U22v5sDhBtHJB9UwwGy1KSHHgg+mKiXMu
TnXhuFLdmWG1yRVydz7e9WmGAK6U2bp1/OEKGv7PQZeyBfC9fsb5FNlciK7Q
nV7cIIRF5sauumF3cK5+8FPPBRFsnvztL01GHhzTfA56gPGlK7+6JdnAzbD5
+QFPPaA3YiDrnJ0tm9+ABzz9Wq+43C9l13meHE8kAgg8uf8z4tVOm4l85gYJ
QNbZEAExnjls49ZsXP/3bH9zxE7ktvJkhbAE+VrTieCaKuRZcQXXh/5EVgiZ
iDHk4sA9ST12Xtz7NvaMnu33RI5kjjc5EPklk35uGPKd28wTjtxVcVQ/IxKZ
6hmP7NbhzM9JQ2Zuq1J9zQvmhR5tf9UqhQO9jKEeIzs9epOt9Z8HDwtydKVf
SEFDAnTI5PpL782D3WlqzQGdBFyJgFO8wbd2a3GDTMLqt9obfN5x2kGJ6YpK
by7+JCNfm4kPF39oE5OwEJlRZ/SsGJn6wRJ54eeMg+2QSTWEhvtAX1DqooYa
Keu/RGR+ThGjODLVKxnZihi4EHk9EaQI+Z9sbX1qCzKtv4fIpHrTZ83n9KX5
zEZm3CCL24xMqqnRxpdjWq/rfKHfc8uOck8J69/TyLR83/pyelK9tAs4DiKC
5SMT+a+UIdN6q0G+N7K0q+IyMtsvkI3Jhc71g9l9q59EeUtgWMYYerkfp3ei
nFQgMm1Ph5BpPVUh14UyCdz0A/8N1RtlyVIg5SGzl0NudF7oungp0OtxQab5
hCC/ZuR99h5Tv8XIuf3ofWTI4Zv6HeHaGCnQ9Pbj/6k+t+RgYhbRG8/0E7bf
IocQlPjD3gvq+vENNnDkMPN8gtwSwTTAw/5Qans/87iNDZt/PTLVtxV5nEn3
I7EChl/GjgQMW7N+jlJw6y4epCMjf0UM9xlyJjUkxtP1MgVcXeOoH+2yBhp+
EpnW27gCjn/ptLU0xRoGmpmEJUqOqX9UyNQf7/F00iCzlbA89eP2qYnWQNt9
oxJinD07PrC2Zvv/MhVofLYldHdbwfkUJqE4ZPp9yUSm99OmgjwrpYtTvJjV
wwg4pv2wAcAyLqbTfNCC3V+PTNphsyIAgiyOKFfpLNjzKZFpPS0JgPXP84oW
pluw+z8IhFdN9kaPUwVAys88Ogjqru9fL4gVsvWfFQyDLwrS6v4Wsu9zDoFT
nU3H7JQTWH88C4GSpKo1Z0omwTLaINTQpC9oNnsiend+NUQmJ20JKhSz+u5S
w3bTnFUTdotZvWqRHahAauicclemNRZDfgBpWBoo3xZ1R3RbBEx3PhFcrIGR
Wy+GOtaK2O/nuAZyCvNPrbITg2E+MMwHhvnAMB8Y5gPDfGCYDwzzwf/ng/8A
2HH7Pw==
           "], {
            {GrayLevel[0], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 131], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 132], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 133], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 134], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 135], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 136], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 137], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 138], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 139], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 140], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 141], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 142], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 143], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 144], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 145], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 146], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 147], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 148], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 149], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 150], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 151], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 152], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 153], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 154], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 155], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 156], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 157], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 158], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 159], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 160], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 161], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 162], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 163], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 164], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 165], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 166], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 167], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 168], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 169], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 170], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 171], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 172], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 173], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 174], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 175], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 176], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 177], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 178], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 179], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 180], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 181], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 182], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 183], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 184], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 185], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 186], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 187], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 188], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 189], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 190], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 191], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 192], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 193], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 194], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 195], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 196], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 197], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 198], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 199], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 200], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 201], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 202], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 203], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 204], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 205], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 206], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 207], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 208], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 209], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 210], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 211], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 212], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 213], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 214], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 215], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 216], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 217], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 218], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 219], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 220], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 221], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 222], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 223], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 224], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 225], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 226], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 227], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 228], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 229], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 230], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 231], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 232], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 233], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 234], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 235], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 236], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 237], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 238], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 239], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 240], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 241], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 242], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 243], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 244], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 245], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 246], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 247], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 248], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 249], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 250], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 251], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 252], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 253], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 254], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 255], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 256], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 257], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 258], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 259], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 260]}, {}}], {}}}, {{}, {}, 
         {GrayLevel[0], Thickness[0.003], LineBox[CompressedData["
1:eJxNzX0803sfx/G5nW4UEe3YEZsYuZuRpfAjm7kJUaESkXsh92m1TjpFN+4r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           "]]}}, {{}, {}, 
         {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
          LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ/SZ+oWqR10Y7nfqmH6wFjA5y577M9ttx3x7Gz+pc
VuSz4z2cXx8w9dXzNgYHGN9u8j+/J70ccD47z5mpHmYCcP6rOY8VGapF4Hzp
H5aVp8sk4PzjitHvvh+XgfNtzU751zUpwPn7HNj6umqU4PyaTerR7gtV4PzE
zhe8fQvV4PxTBVvvHZiuAecX7k+3W7JDC+He4p3Nglt14HzPvg/h+nf04PzX
dySXzqkxgPPdVLknPqswhPMdFPOPdHQZwflnzy969b7TGM7/aegZsX6eCZyf
PufrlZR1pnB+xs5Cl/urzeB8jq6E3xv3mcP51rzySz33W8D5G2Y8jr2+yxLO
P3JdKm7vaSs4P+ekYmDGKWs4f1Pe7O7sezZwvpWM9NWUt7ZwflhNlqDyKzs4
X3CCzlTLP/Zwvr72/VauOgc4v1xotUfxbwS/L9hAv6PZEc5/nyvbX8/kBOcr
PDospNyD4M/Sv8S/kscZzjdtTBZZ1YXgL9BZZxMu7ALnh2xMuPdsEoJ/o//M
YiVZVzi/tmh3wc0lCH62ntD2ImU3OF/TRUlxxxoE38B4FssDHXc4P0Jt6vum
VQh+QLHnv4tGHnD+pJmpbcybEHwHgwf7GH8i+G+PRX3/b+8J5wMAwypLiA==

           "]]}, 
         {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
          LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ/SZ+oWqR10Y7qavBc55cEHGQO/dltt+O+/Ywflbn
siKfHe/h/PqAqa+etzE4wPh2k//5PenlgPPZec5M9TATgPNfzXmsyFAtAudL
/7CsPF0mAecfV4x+9/24DJxva3bKv65JAc7f58DW11WjBOfXbFKPdl+oAucn
dr7g7VuoBuefKth678B0DTi/cH+63ZIdWgj3Fu9sFtyqA+d79n0I17+jB+e/
viO5dE6NAZzvpso98VmFIZzvoJh/pKPLCM4/e37Rq/edxnD+T0PPiPXzTOD8
9Dlfr6SsM4XzM3YWutxfbQbnc3Ql/N64zxzOt+aVX+q53wLO3zDjcez1XZZw
/pHrUnF7T1vB+TknFQMzTlnD+ZvyZndn37OB861kpK+mvLWF88NqsgSVX9nB
+YITdKZa/rGH8/W177dy1TnA+eVCqz2KfyP4fcEG+h3NjnD++1zZ/nomJzhf
4dFhIeUeBH+W/iX+lTzOcL5pY7LIqi4Ef4HOOptwYRc4P2Rjwr1nkxD8G/1n
FivJusL5tUW7C24uQfCz9YS2Fym7wfmaLkqKO9Yg+AbGs1ge6LjD+RFqU983
rULwA4o9/1008oDzJ81MbWPehOA7GDzYx/gTwX97LOr7f3tPOB8A9ZuBxA==

           "]]}, 
         {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
          LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ/SZ+oWqR10a72RukOB7UqzvInfsy22/HfXsYP6tz
WZHPjvdwfn3A1FfP2xgcYHy7yf/8nvRywPnsPGemepgJwPmv5jxWZKgWgfOl
f1hWni6TgPOPK0a/+35cBs63NTvlX9ekAOfvc2Dr66pRgvNrNqlHuy9UgfMT
O1/w9i1Ug/NPFWy9d2C6BpxfuD/dbskOLYR7i3c2C27VgfM9+z6E69/Rg/Nf
35FcOqfGAM53U+We+KzCEM53UMw/0tFlBOefPb/o1ftOYzj/p6FnxPp5JnB+
+pyvV1LWmcL5GTsLXe6vNoPzOboSfm/cZw7nW/PKL/XcbwHnb5jxOPb6Lks4
/8h1qbi9p63g/JyTioEZp6zh/E15s7uz79nA+VYy0ldT3trC+WE1WYLKr+zg
fMEJOlMt/9jD+fra91u56hzg/HKh1R7FvxH8vmAD/Y5mRzj/fa5sfz2TE5yv
8OiwkHIPgj9L/xL/Sh5nON+0MVlkVReCv0BnnU24sAucH7Ix4d6zSQj+jf4z
i5VkXeH82qLdBTeXIPjZekLbi5Td4HxNFyXFHWsQfAPjWSwPdNzh/Ai1qe+b
ViH4AcWe/y4aecD5k2amtjFvQvAdDB7sY/yJ4L89FvX9v70nnA8Ak+1daA==

           "]]}}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"x(kbp)\"", TraditionalForm], 
         FormBox["\"L\"", TraditionalForm]},
       AxesOrigin->{-1, 0},
       Method->{},
       PlotRange->{All, All},
       PlotRangeClipping->True,
       PlotRangePadding->None], {193.5, -358.76873046931394`}, 
      ImageScaled[{0.5, 0.5}], {360., 222.4922359499621}], InsetBox[
      GraphicsBox[{{{{}, GraphicsComplexBox[CompressedData["
1:eJxd1QlIVFEUBuDRwkJMNM2GMlPLVKayzcx1xtxTc21FWi1KSsUyQkWwEpOo
aHGrRCzFhJDIEElbDGmRyrJISmyhRaXNXcycuvc4nt/pwTB83Hcf5517znl2
O5KidxkqFIpj4if/F90o/lXxoEOtoKtbrW9bzeWAmr7RV/1sWg4dYEfX2mR/
i5qmGffPDLXrlltm7Jlvng3F7DRnjz0fnnrNenO8pwX763P7tmGtNXu5vPrs
2O8jThYknrVnr91httH9poPOSs3k9aaLbsxx5PWqoI9plokqXr9bMsul/bOK
1y812l5PcVrMXmNiqMoZXML3J00/eq/JYCmb4jkHPwx1y/X9AFN8vf+tK5ax
TWUCpsAiebU2DvDVB3IDnGMlEwiLl310KBP+U9nTEn4Ebr2S7G1cADc0lQbU
VMPOcafvD3TCPsZixyic73diX8fs5ez9HSOVPcvgSPF60/3g7yL87FD46RNx
hcGfyi822kbClM/tsEv7fKOsVFicVlVQA3z2hyiod/C8tuHMBK8V7GC5IQeW
x1/cDKtkAme66udvC5x6Tjl5fRVcJtLXOmkluzBRBGwMi+yMVJrDVA8W8Opt
X57bz4Y1ohtCwmCqv3jYKCtPZBymfCXDM2QBn4f3nhEJyYN/ZybUH3wJU/+9
hWX3HnZ2049nISyqwSkuCTaXCbJapbPZWL/uhql+K2Bq378w5SvBne0vE5YL
y/TfKYGp32rg5qGYT+V18Ni8gA3lgS72YA86iYJeB+/ylB0I03gqhKmfquG6
EBHAQ1i2h5O1J5uOxxGmeALhfpHergmmetswbt15pMFeMrxTMOXnMfaPzVs4
UFLpxb5QJK5N8MtwMQCLYIq/Hqb8voa1ItwF5t5squco2HGpnMjwgT2i4LbC
6ZayIP9bL4FpexlM/aaFe1tEwEofNtWPGvaQ9THBc+WAzIRp3D+Caf7HqtnX
U0RAcTB9X9JhOp9WmPJhoOHzoHl4G6bnN8KdYhy2ePuy6f18YOqnCJie/8KP
LdvPJNqfTf2fEaCz7ns2P5BN9dEVyPfH0oAI0o8vFqb8HocpX7WwHSUIzvWV
AyuY80HfS+24u9ViWpcG5Afz/frrSs0/TXL6Xg==
           "], {
            {GrayLevel[0.65], {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 2], {LineBox[{{0.743, 12.}, {0.743, 2.}}], 
               LineBox[{
                Offset[{1.5, 0}, {0.743, 12.}], 
                 Offset[{-1.5, 0}, {0.743, 12.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {0.743, 2.}], 
                 Offset[{-1.5, 0}, {0.743, 2.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 3], {LineBox[{{1.302, 12.}, {1.302, 2.}}], 
               LineBox[{
                Offset[{1.5, 0}, {1.302, 12.}], 
                 Offset[{-1.5, 0}, {1.302, 12.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {1.302, 2.}], 
                 Offset[{-1.5, 0}, {1.302, 2.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 4], {LineBox[{{1.331, 12.}, {1.331, 2.}}], 
               LineBox[{
                Offset[{1.5, 0}, {1.331, 12.}], 
                 Offset[{-1.5, 0}, {1.331, 12.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {1.331, 2.}], 
                 Offset[{-1.5, 0}, {1.331, 2.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 5], {LineBox[{{3.665, 12.}, {3.665, 2.}}], 
               LineBox[{
                Offset[{1.5, 0}, {3.665, 12.}], 
                 Offset[{-1.5, 0}, {3.665, 12.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {3.665, 2.}], 
                 Offset[{-1.5, 0}, {3.665, 2.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 6], {LineBox[{{4.182, 12.}, {4.182, 2.}}], 
               LineBox[{
                Offset[{1.5, 0}, {4.182, 12.}], 
                 Offset[{-1.5, 0}, {4.182, 12.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {4.182, 2.}], 
                 Offset[{-1.5, 0}, {4.182, 2.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 7], {LineBox[{{4.347, 12.}, {4.347, 2.}}], 
               LineBox[{
                Offset[{1.5, 0}, {4.347, 12.}], 
                 Offset[{-1.5, 0}, {4.347, 12.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {4.347, 2.}], 
                 Offset[{-1.5, 0}, {4.347, 2.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 8], {LineBox[{{4.444, 12.}, {4.444, 2.}}], 
               LineBox[{
                Offset[{1.5, 0}, {4.444, 12.}], 
                 Offset[{-1.5, 0}, {4.444, 12.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {4.444, 2.}], 
                 Offset[{-1.5, 0}, {4.444, 2.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 9], {LineBox[{{4.808, 12.}, {4.808, 2.}}], 
               LineBox[{
                Offset[{1.5, 0}, {4.808, 12.}], 
                 Offset[{-1.5, 0}, {4.808, 12.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {4.808, 2.}], 
                 Offset[{-1.5, 0}, {4.808, 2.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 10], {
               LineBox[{{7.2490000000000006`, 12.}, {7.2490000000000006`, 
                2.}}], LineBox[{
                Offset[{1.5, 0}, {7.2490000000000006`, 12.}], 
                 Offset[{-1.5, 0}, {7.2490000000000006`, 12.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {7.2490000000000006`, 2.}], 
                 Offset[{-1.5, 0}, {7.2490000000000006`, 2.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 11], {LineBox[{{8.975, 10.}, {8.975, 2.}}], 
               LineBox[{
                Offset[{1.5, 0}, {8.975, 10.}], 
                 Offset[{-1.5, 0}, {8.975, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {8.975, 2.}], 
                 Offset[{-1.5, 0}, {8.975, 2.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 12], {LineBox[{{9.286, 10.}, {9.286, 2.}}], 
               LineBox[{
                Offset[{1.5, 0}, {9.286, 10.}], 
                 Offset[{-1.5, 0}, {9.286, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {9.286, 2.}], 
                 Offset[{-1.5, 0}, {9.286, 2.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 13], {LineBox[{{10.852, 12.}, {10.852, 2.}}], 
               LineBox[{
                Offset[{1.5, 0}, {10.852, 12.}], 
                 Offset[{-1.5, 0}, {10.852, 12.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {10.852, 2.}], 
                 Offset[{-1.5, 0}, {10.852, 2.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 14], {LineBox[{{11.558, 12.}, {11.558, 2.}}], 
               LineBox[{
                Offset[{1.5, 0}, {11.558, 12.}], 
                 Offset[{-1.5, 0}, {11.558, 12.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {11.558, 2.}], 
                 Offset[{-1.5, 0}, {11.558, 2.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 15], {LineBox[{{13.715, 12.}, {13.715, 2.}}], 
               LineBox[{
                Offset[{1.5, 0}, {13.715, 12.}], 
                 Offset[{-1.5, 0}, {13.715, 12.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {13.715, 2.}], 
                 Offset[{-1.5, 0}, {13.715, 2.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 16], {
               LineBox[{{13.947000000000001`, 12.}, {13.947000000000001`, 
                2.}}], LineBox[{
                Offset[{1.5, 0}, {13.947000000000001`, 12.}], 
                 Offset[{-1.5, 0}, {13.947000000000001`, 12.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {13.947000000000001`, 2.}], 
                 Offset[{-1.5, 0}, {13.947000000000001`, 2.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 17], {LineBox[{{15.079, 12.}, {15.079, 2.}}], 
               LineBox[{
                Offset[{1.5, 0}, {15.079, 12.}], 
                 Offset[{-1.5, 0}, {15.079, 12.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {15.079, 2.}], 
                 Offset[{-1.5, 0}, {15.079, 2.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 18], {LineBox[{{16.963, 12.}, {16.963, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {16.963, 12.}], 
                 Offset[{-1.5, 0}, {16.963, 12.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {16.963, 0.}], 
                 Offset[{-1.5, 0}, {16.963, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 19], {LineBox[{{17.007, 12.}, {17.007, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {17.007, 12.}], 
                 Offset[{-1.5, 0}, {17.007, 12.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {17.007, 0.}], 
                 Offset[{-1.5, 0}, {17.007, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 20], {LineBox[{{17.575, 10.}, {17.575, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {17.575, 10.}], 
                 Offset[{-1.5, 0}, {17.575, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {17.575, 0.}], 
                 Offset[{-1.5, 0}, {17.575, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 21], {LineBox[{{17.876, 10.}, {17.876, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {17.876, 10.}], 
                 Offset[{-1.5, 0}, {17.876, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {17.876, 0.}], 
                 Offset[{-1.5, 0}, {17.876, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 22], {LineBox[{{17.947, 10.}, {17.947, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {17.947, 10.}], 
                 Offset[{-1.5, 0}, {17.947, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {17.947, 0.}], 
                 Offset[{-1.5, 0}, {17.947, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 23], {LineBox[{{18.001, 10.}, {18.001, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.001, 10.}], 
                 Offset[{-1.5, 0}, {18.001, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.001, 0.}], 
                 Offset[{-1.5, 0}, {18.001, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 24], {LineBox[{{18.031, 10.}, {18.031, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.031, 10.}], 
                 Offset[{-1.5, 0}, {18.031, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.031, 0.}], 
                 Offset[{-1.5, 0}, {18.031, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 25], {LineBox[{{18.145, 10.}, {18.145, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.145, 10.}], 
                 Offset[{-1.5, 0}, {18.145, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.145, 0.}], 
                 Offset[{-1.5, 0}, {18.145, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 26], {LineBox[{{18.256, 10.}, {18.256, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.256, 10.}], 
                 Offset[{-1.5, 0}, {18.256, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.256, 0.}], 
                 Offset[{-1.5, 0}, {18.256, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 27], {LineBox[{{18.328, 10.}, {18.328, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.328, 10.}], 
                 Offset[{-1.5, 0}, {18.328, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.328, 0.}], 
                 Offset[{-1.5, 0}, {18.328, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 28], {LineBox[{{18.494, 10.}, {18.494, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.494, 10.}], 
                 Offset[{-1.5, 0}, {18.494, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.494, 0.}], 
                 Offset[{-1.5, 0}, {18.494, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 29], {LineBox[{{18.509, 10.}, {18.509, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.509, 10.}], 
                 Offset[{-1.5, 0}, {18.509, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.509, 0.}], 
                 Offset[{-1.5, 0}, {18.509, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 30], {LineBox[{{18.59, 10.}, {18.59, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.59, 10.}], 
                 Offset[{-1.5, 0}, {18.59, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.59, 0.}], 
                 Offset[{-1.5, 0}, {18.59, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 31], {LineBox[{{18.702, 10.}, {18.702, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.702, 10.}], 
                 Offset[{-1.5, 0}, {18.702, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.702, 0.}], 
                 Offset[{-1.5, 0}, {18.702, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 32], {LineBox[{{18.91, 10.}, {18.91, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {18.91, 10.}], 
                 Offset[{-1.5, 0}, {18.91, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.91, 0.}], 
                 Offset[{-1.5, 0}, {18.91, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 33], {
               LineBox[{{18.990000000000002`, 10.}, {18.990000000000002`, 
                0.}}], LineBox[{
                Offset[{1.5, 0}, {18.990000000000002`, 10.}], 
                 Offset[{-1.5, 0}, {18.990000000000002`, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {18.990000000000002`, 0.}], 
                 Offset[{-1.5, 0}, {18.990000000000002`, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 34], {LineBox[{{19.109, 10.}, {19.109, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.109, 10.}], 
                 Offset[{-1.5, 0}, {19.109, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.109, 0.}], 
                 Offset[{-1.5, 0}, {19.109, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 35], {LineBox[{{19.199, 10.}, {19.199, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.199, 10.}], 
                 Offset[{-1.5, 0}, {19.199, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.199, 0.}], 
                 Offset[{-1.5, 0}, {19.199, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 36], {LineBox[{{19.262, 10.}, {19.262, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.262, 10.}], 
                 Offset[{-1.5, 0}, {19.262, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.262, 0.}], 
                 Offset[{-1.5, 0}, {19.262, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 37], {LineBox[{{19.295, 10.}, {19.295, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.295, 10.}], 
                 Offset[{-1.5, 0}, {19.295, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.295, 0.}], 
                 Offset[{-1.5, 0}, {19.295, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 38], {LineBox[{{19.3, 10.}, {19.3, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.3, 10.}], 
                 Offset[{-1.5, 0}, {19.3, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.3, 0.}], 
                 Offset[{-1.5, 0}, {19.3, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 39], {LineBox[{{19.313, 10.}, {19.313, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.313, 10.}], 
                 Offset[{-1.5, 0}, {19.313, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.313, 0.}], 
                 Offset[{-1.5, 0}, {19.313, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 40], {LineBox[{{19.382, 10.}, {19.382, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.382, 10.}], 
                 Offset[{-1.5, 0}, {19.382, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.382, 0.}], 
                 Offset[{-1.5, 0}, {19.382, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 41], {LineBox[{{19.459, 10.}, {19.459, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.459, 10.}], 
                 Offset[{-1.5, 0}, {19.459, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.459, 0.}], 
                 Offset[{-1.5, 0}, {19.459, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 42], {LineBox[{{19.755, 10.}, {19.755, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {19.755, 10.}], 
                 Offset[{-1.5, 0}, {19.755, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.755, 0.}], 
                 Offset[{-1.5, 0}, {19.755, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 43], {
               LineBox[{{19.868000000000002`, 10.}, {19.868000000000002`, 
                0.}}], LineBox[{
                Offset[{1.5, 0}, {19.868000000000002`, 10.}], 
                 Offset[{-1.5, 0}, {19.868000000000002`, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {19.868000000000002`, 0.}], 
                 Offset[{-1.5, 0}, {19.868000000000002`, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 44], {LineBox[{{20.236, 10.}, {20.236, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {20.236, 10.}], 
                 Offset[{-1.5, 0}, {20.236, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {20.236, 0.}], 
                 Offset[{-1.5, 0}, {20.236, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 45], {LineBox[{{20.53, 10.}, {20.53, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {20.53, 10.}], 
                 Offset[{-1.5, 0}, {20.53, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {20.53, 0.}], 
                 Offset[{-1.5, 0}, {20.53, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 46], {LineBox[{{20.811, 10.}, {20.811, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {20.811, 10.}], 
                 Offset[{-1.5, 0}, {20.811, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {20.811, 0.}], 
                 Offset[{-1.5, 0}, {20.811, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 47], {LineBox[{{21.093, 10.}, {21.093, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {21.093, 10.}], 
                 Offset[{-1.5, 0}, {21.093, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {21.093, 0.}], 
                 Offset[{-1.5, 0}, {21.093, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 48], {LineBox[{{21.369, 10.}, {21.369, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {21.369, 10.}], 
                 Offset[{-1.5, 0}, {21.369, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {21.369, 0.}], 
                 Offset[{-1.5, 0}, {21.369, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 49], {LineBox[{{21.681, 10.}, {21.681, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {21.681, 10.}], 
                 Offset[{-1.5, 0}, {21.681, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {21.681, 0.}], 
                 Offset[{-1.5, 0}, {21.681, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 50], {LineBox[{{22.015, 10.}, {22.015, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.015, 10.}], 
                 Offset[{-1.5, 0}, {22.015, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.015, 0.}], 
                 Offset[{-1.5, 0}, {22.015, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 51], {LineBox[{{22.042, 10.}, {22.042, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.042, 10.}], 
                 Offset[{-1.5, 0}, {22.042, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.042, 0.}], 
                 Offset[{-1.5, 0}, {22.042, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 52], {LineBox[{{22.069, 10.}, {22.069, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.069, 10.}], 
                 Offset[{-1.5, 0}, {22.069, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.069, 0.}], 
                 Offset[{-1.5, 0}, {22.069, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 53], {LineBox[{{22.075, 10.}, {22.075, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.075, 10.}], 
                 Offset[{-1.5, 0}, {22.075, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.075, 0.}], 
                 Offset[{-1.5, 0}, {22.075, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 54], {LineBox[{{22.106, 10.}, {22.106, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.106, 10.}], 
                 Offset[{-1.5, 0}, {22.106, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.106, 0.}], 
                 Offset[{-1.5, 0}, {22.106, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 55], {
               LineBox[{{22.298000000000002`, 10.}, {22.298000000000002`, 
                0.}}], LineBox[{
                Offset[{1.5, 0}, {22.298000000000002`, 10.}], 
                 Offset[{-1.5, 0}, {22.298000000000002`, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.298000000000002`, 0.}], 
                 Offset[{-1.5, 0}, {22.298000000000002`, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 56], {
               LineBox[{{22.394000000000002`, 10.}, {22.394000000000002`, 
                0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.394000000000002`, 10.}], 
                 Offset[{-1.5, 0}, {22.394000000000002`, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.394000000000002`, 0.}], 
                 Offset[{-1.5, 0}, {22.394000000000002`, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 57], {LineBox[{{22.424, 10.}, {22.424, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.424, 10.}], 
                 Offset[{-1.5, 0}, {22.424, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.424, 0.}], 
                 Offset[{-1.5, 0}, {22.424, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 58], {LineBox[{{22.438, 10.}, {22.438, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.438, 10.}], 
                 Offset[{-1.5, 0}, {22.438, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.438, 0.}], 
                 Offset[{-1.5, 0}, {22.438, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 59], {
               LineBox[{{22.580000000000002`, 10.}, {22.580000000000002`, 
                0.}}], LineBox[{
                Offset[{1.5, 0}, {22.580000000000002`, 10.}], 
                 Offset[{-1.5, 0}, {22.580000000000002`, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.580000000000002`, 0.}], 
                 Offset[{-1.5, 0}, {22.580000000000002`, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 60], {
               LineBox[{{22.583000000000002`, 10.}, {22.583000000000002`, 
                0.}}], LineBox[{
                Offset[{1.5, 0}, {22.583000000000002`, 10.}], 
                 Offset[{-1.5, 0}, {22.583000000000002`, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.583000000000002`, 0.}], 
                 Offset[{-1.5, 0}, {22.583000000000002`, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 61], {LineBox[{{22.826, 10.}, {22.826, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.826, 10.}], 
                 Offset[{-1.5, 0}, {22.826, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.826, 0.}], 
                 Offset[{-1.5, 0}, {22.826, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 62], {LineBox[{{22.853, 10.}, {22.853, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {22.853, 10.}], 
                 Offset[{-1.5, 0}, {22.853, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {22.853, 0.}], 
                 Offset[{-1.5, 0}, {22.853, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 63], {LineBox[{{23.162, 10.}, {23.162, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {23.162, 10.}], 
                 Offset[{-1.5, 0}, {23.162, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {23.162, 0.}], 
                 Offset[{-1.5, 0}, {23.162, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 64], {
               LineBox[{{23.173000000000002`, 10.}, {23.173000000000002`, 
                0.}}], LineBox[{
                Offset[{1.5, 0}, {23.173000000000002`, 10.}], 
                 Offset[{-1.5, 0}, {23.173000000000002`, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {23.173000000000002`, 0.}], 
                 Offset[{-1.5, 0}, {23.173000000000002`, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 65], {LineBox[{{23.435, 10.}, {23.435, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {23.435, 10.}], 
                 Offset[{-1.5, 0}, {23.435, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {23.435, 0.}], 
                 Offset[{-1.5, 0}, {23.435, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 66], {
               LineBox[{{24.089000000000002`, 10.}, {24.089000000000002`, 
                0.}}], LineBox[{
                Offset[{1.5, 0}, {24.089000000000002`, 10.}], 
                 Offset[{-1.5, 0}, {24.089000000000002`, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {24.089000000000002`, 0.}], 
                 Offset[{-1.5, 0}, {24.089000000000002`, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 67], {LineBox[{{24.401, 10.}, {24.401, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {24.401, 10.}], 
                 Offset[{-1.5, 0}, {24.401, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {24.401, 0.}], 
                 Offset[{-1.5, 0}, {24.401, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 68], {LineBox[{{24.656, 10.}, {24.656, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {24.656, 10.}], 
                 Offset[{-1.5, 0}, {24.656, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {24.656, 0.}], 
                 Offset[{-1.5, 0}, {24.656, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 69], {LineBox[{{24.997, 10.}, {24.997, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {24.997, 10.}], 
                 Offset[{-1.5, 0}, {24.997, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {24.997, 0.}], 
                 Offset[{-1.5, 0}, {24.997, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 70], {LineBox[{{25.417, 10.}, {25.417, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {25.417, 10.}], 
                 Offset[{-1.5, 0}, {25.417, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {25.417, 0.}], 
                 Offset[{-1.5, 0}, {25.417, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 71], {LineBox[{{25.539, 10.}, {25.539, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {25.539, 10.}], 
                 Offset[{-1.5, 0}, {25.539, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {25.539, 0.}], 
                 Offset[{-1.5, 0}, {25.539, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 72], {LineBox[{{25.624, 10.}, {25.624, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {25.624, 10.}], 
                 Offset[{-1.5, 0}, {25.624, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {25.624, 0.}], 
                 Offset[{-1.5, 0}, {25.624, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 73], {LineBox[{{25.713, 10.}, {25.713, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {25.713, 10.}], 
                 Offset[{-1.5, 0}, {25.713, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {25.713, 0.}], 
                 Offset[{-1.5, 0}, {25.713, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 74], {LineBox[{{25.733, 10.}, {25.733, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {25.733, 10.}], 
                 Offset[{-1.5, 0}, {25.733, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {25.733, 0.}], 
                 Offset[{-1.5, 0}, {25.733, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 75], {LineBox[{{25.776, 10.}, {25.776, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {25.776, 10.}], 
                 Offset[{-1.5, 0}, {25.776, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {25.776, 0.}], 
                 Offset[{-1.5, 0}, {25.776, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 76], {LineBox[{{26.183, 10.}, {26.183, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {26.183, 10.}], 
                 Offset[{-1.5, 0}, {26.183, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {26.183, 0.}], 
                 Offset[{-1.5, 0}, {26.183, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 77], {LineBox[{{26.335, 10.}, {26.335, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {26.335, 10.}], 
                 Offset[{-1.5, 0}, {26.335, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {26.335, 0.}], 
                 Offset[{-1.5, 0}, {26.335, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 78], {
               LineBox[{{26.592000000000002`, 10.}, {26.592000000000002`, 
                0.}}], LineBox[{
                Offset[{1.5, 0}, {26.592000000000002`, 10.}], 
                 Offset[{-1.5, 0}, {26.592000000000002`, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {26.592000000000002`, 0.}], 
                 Offset[{-1.5, 0}, {26.592000000000002`, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 79], {LineBox[{{26.595, 10.}, {26.595, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {26.595, 10.}], 
                 Offset[{-1.5, 0}, {26.595, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {26.595, 0.}], 
                 Offset[{-1.5, 0}, {26.595, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 80], {LineBox[{{26.703, 10.}, {26.703, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {26.703, 10.}], 
                 Offset[{-1.5, 0}, {26.703, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {26.703, 0.}], 
                 Offset[{-1.5, 0}, {26.703, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 81], {
               LineBox[{{26.778000000000002`, 10.}, {26.778000000000002`, 
                0.}}], LineBox[{
                Offset[{1.5, 0}, {26.778000000000002`, 10.}], 
                 Offset[{-1.5, 0}, {26.778000000000002`, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {26.778000000000002`, 0.}], 
                 Offset[{-1.5, 0}, {26.778000000000002`, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 82], {LineBox[{{27.11, 10.}, {27.11, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {27.11, 10.}], 
                 Offset[{-1.5, 0}, {27.11, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.11, 0.}], 
                 Offset[{-1.5, 0}, {27.11, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 83], {LineBox[{{27.154, 10.}, {27.154, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {27.154, 10.}], 
                 Offset[{-1.5, 0}, {27.154, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.154, 0.}], 
                 Offset[{-1.5, 0}, {27.154, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 84], {LineBox[{{27.276, 10.}, {27.276, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {27.276, 10.}], 
                 Offset[{-1.5, 0}, {27.276, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.276, 0.}], 
                 Offset[{-1.5, 0}, {27.276, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 85], {LineBox[{{27.277, 10.}, {27.277, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {27.277, 10.}], 
                 Offset[{-1.5, 0}, {27.277, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.277, 0.}], 
                 Offset[{-1.5, 0}, {27.277, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 86], {LineBox[{{27.343, 10.}, {27.343, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {27.343, 10.}], 
                 Offset[{-1.5, 0}, {27.343, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.343, 0.}], 
                 Offset[{-1.5, 0}, {27.343, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 87], {LineBox[{{27.478, 10.}, {27.478, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {27.478, 10.}], 
                 Offset[{-1.5, 0}, {27.478, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.478, 0.}], 
                 Offset[{-1.5, 0}, {27.478, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 88], {
               LineBox[{{27.557000000000002`, 10.}, {27.557000000000002`, 
                0.}}], LineBox[{
                Offset[{1.5, 0}, {27.557000000000002`, 10.}], 
                 Offset[{-1.5, 0}, {27.557000000000002`, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.557000000000002`, 0.}], 
                 Offset[{-1.5, 0}, {27.557000000000002`, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 89], {LineBox[{{27.789, 10.}, {27.789, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {27.789, 10.}], 
                 Offset[{-1.5, 0}, {27.789, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.789, 0.}], 
                 Offset[{-1.5, 0}, {27.789, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 90], {LineBox[{{27.832, 10.}, {27.832, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {27.832, 10.}], 
                 Offset[{-1.5, 0}, {27.832, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {27.832, 0.}], 
                 Offset[{-1.5, 0}, {27.832, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 91], {LineBox[{{28.097, 10.}, {28.097, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {28.097, 10.}], 
                 Offset[{-1.5, 0}, {28.097, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {28.097, 0.}], 
                 Offset[{-1.5, 0}, {28.097, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 92], {LineBox[{{28.35, 10.}, {28.35, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {28.35, 10.}], 
                 Offset[{-1.5, 0}, {28.35, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {28.35, 0.}], 
                 Offset[{-1.5, 0}, {28.35, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 93], {LineBox[{{28.599, 10.}, {28.599, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {28.599, 10.}], 
                 Offset[{-1.5, 0}, {28.599, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {28.599, 0.}], 
                 Offset[{-1.5, 0}, {28.599, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 94], {LineBox[{{28.735, 10.}, {28.735, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {28.735, 10.}], 
                 Offset[{-1.5, 0}, {28.735, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {28.735, 0.}], 
                 Offset[{-1.5, 0}, {28.735, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 95], {LineBox[{{28.838, 10.}, {28.838, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {28.838, 10.}], 
                 Offset[{-1.5, 0}, {28.838, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {28.838, 0.}], 
                 Offset[{-1.5, 0}, {28.838, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 96], {LineBox[{{29.067, 10.}, {29.067, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {29.067, 10.}], 
                 Offset[{-1.5, 0}, {29.067, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {29.067, 0.}], 
                 Offset[{-1.5, 0}, {29.067, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 97], {LineBox[{{29.319, 8.}, {29.319, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {29.319, 8.}], 
                 Offset[{-1.5, 0}, {29.319, 8.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {29.319, 0.}], 
                 Offset[{-1.5, 0}, {29.319, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 98], {LineBox[{{29.352, 8.}, {29.352, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {29.352, 8.}], 
                 Offset[{-1.5, 0}, {29.352, 8.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {29.352, 0.}], 
                 Offset[{-1.5, 0}, {29.352, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 99], {LineBox[{{29.373, 8.}, {29.373, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {29.373, 8.}], 
                 Offset[{-1.5, 0}, {29.373, 8.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {29.373, 0.}], 
                 Offset[{-1.5, 0}, {29.373, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 100], {LineBox[{{29.48, 8.}, {29.48, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {29.48, 8.}], 
                 Offset[{-1.5, 0}, {29.48, 8.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {29.48, 0.}], 
                 Offset[{-1.5, 0}, {29.48, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 101], {LineBox[{{29.623, 10.}, {29.623, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {29.623, 10.}], 
                 Offset[{-1.5, 0}, {29.623, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {29.623, 0.}], 
                 Offset[{-1.5, 0}, {29.623, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 102], {LineBox[{{29.642, 10.}, {29.642, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {29.642, 10.}], 
                 Offset[{-1.5, 0}, {29.642, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {29.642, 0.}], 
                 Offset[{-1.5, 0}, {29.642, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 103], {LineBox[{{29.994, 10.}, {29.994, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {29.994, 10.}], 
                 Offset[{-1.5, 0}, {29.994, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {29.994, 0.}], 
                 Offset[{-1.5, 0}, {29.994, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 104], {LineBox[{{30.094, 10.}, {30.094, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {30.094, 10.}], 
                 Offset[{-1.5, 0}, {30.094, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {30.094, 0.}], 
                 Offset[{-1.5, 0}, {30.094, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 105], {LineBox[{{30.247, 10.}, {30.247, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {30.247, 10.}], 
                 Offset[{-1.5, 0}, {30.247, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {30.247, 0.}], 
                 Offset[{-1.5, 0}, {30.247, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 106], {
               LineBox[{{30.249000000000002`, 10.}, {30.249000000000002`, 
                0.}}], LineBox[{
                Offset[{1.5, 0}, {30.249000000000002`, 10.}], 
                 Offset[{-1.5, 0}, {30.249000000000002`, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {30.249000000000002`, 0.}], 
                 Offset[{-1.5, 0}, {30.249000000000002`, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 107], {LineBox[{{30.495, 10.}, {30.495, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {30.495, 10.}], 
                 Offset[{-1.5, 0}, {30.495, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {30.495, 0.}], 
                 Offset[{-1.5, 0}, {30.495, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 108], {LineBox[{{30.784, 10.}, {30.784, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {30.784, 10.}], 
                 Offset[{-1.5, 0}, {30.784, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {30.784, 0.}], 
                 Offset[{-1.5, 0}, {30.784, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 109], {LineBox[{{31.329, 10.}, {31.329, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {31.329, 10.}], 
                 Offset[{-1.5, 0}, {31.329, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {31.329, 0.}], 
                 Offset[{-1.5, 0}, {31.329, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 110], {LineBox[{{31.363, 10.}, {31.363, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {31.363, 10.}], 
                 Offset[{-1.5, 0}, {31.363, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {31.363, 0.}], 
                 Offset[{-1.5, 0}, {31.363, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 111], {LineBox[{{31.482, 10.}, {31.482, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {31.482, 10.}], 
                 Offset[{-1.5, 0}, {31.482, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {31.482, 0.}], 
                 Offset[{-1.5, 0}, {31.482, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 112], {LineBox[{{31.843, 10.}, {31.843, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {31.843, 10.}], 
                 Offset[{-1.5, 0}, {31.843, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {31.843, 0.}], 
                 Offset[{-1.5, 0}, {31.843, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 113], {LineBox[{{32.009, 10.}, {32.009, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {32.009, 10.}], 
                 Offset[{-1.5, 0}, {32.009, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {32.009, 0.}], 
                 Offset[{-1.5, 0}, {32.009, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 114], {
               LineBox[{{33.480000000000004`, 10.}, {33.480000000000004`, 
                0.}}], LineBox[{
                Offset[{1.5, 0}, {33.480000000000004`, 10.}], 
                 Offset[{-1.5, 0}, {33.480000000000004`, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {33.480000000000004`, 0.}], 
                 Offset[{-1.5, 0}, {33.480000000000004`, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 115], {LineBox[{{33.533, 10.}, {33.533, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {33.533, 10.}], 
                 Offset[{-1.5, 0}, {33.533, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {33.533, 0.}], 
                 Offset[{-1.5, 0}, {33.533, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 116], {
               LineBox[{{34.483000000000004`, 10.}, {34.483000000000004`, 
                2.}}], LineBox[{
                Offset[{1.5, 0}, {34.483000000000004`, 10.}], 
                 Offset[{-1.5, 0}, {34.483000000000004`, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {34.483000000000004`, 2.}], 
                 Offset[{-1.5, 0}, {34.483000000000004`, 2.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 117], {LineBox[{{34.488, 10.}, {34.488, 2.}}], 
               LineBox[{
                Offset[{1.5, 0}, {34.488, 10.}], 
                 Offset[{-1.5, 0}, {34.488, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {34.488, 2.}], 
                 Offset[{-1.5, 0}, {34.488, 2.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 118], {LineBox[{{34.62, 10.}, {34.62, 2.}}], 
               LineBox[{
                Offset[{1.5, 0}, {34.62, 10.}], 
                 Offset[{-1.5, 0}, {34.62, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {34.62, 2.}], 
                 Offset[{-1.5, 0}, {34.62, 2.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 119], {LineBox[{{39.634, 14.}, {39.634, 2.}}], 
               LineBox[{
                Offset[{1.5, 0}, {39.634, 14.}], 
                 Offset[{-1.5, 0}, {39.634, 14.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {39.634, 2.}], 
                 Offset[{-1.5, 0}, {39.634, 2.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 120], {LineBox[{{40.641, 12.}, {40.641, 2.}}], 
               LineBox[{
                Offset[{1.5, 0}, {40.641, 12.}], 
                 Offset[{-1.5, 0}, {40.641, 12.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {40.641, 2.}], 
                 Offset[{-1.5, 0}, {40.641, 2.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 121], {LineBox[{{42.973, 12.}, {42.973, 2.}}], 
               LineBox[{
                Offset[{1.5, 0}, {42.973, 12.}], 
                 Offset[{-1.5, 0}, {42.973, 12.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {42.973, 2.}], 
                 Offset[{-1.5, 0}, {42.973, 2.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 122], {LineBox[{{44.283, 12.}, {44.283, 2.}}], 
               LineBox[{
                Offset[{1.5, 0}, {44.283, 12.}], 
                 Offset[{-1.5, 0}, {44.283, 12.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {44.283, 2.}], 
                 Offset[{-1.5, 0}, {44.283, 2.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 123], {LineBox[{{45.828, 12.}, {45.828, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {45.828, 12.}], 
                 Offset[{-1.5, 0}, {45.828, 12.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {45.828, 0.}], 
                 Offset[{-1.5, 0}, {45.828, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 124], {LineBox[{{46.256, 10.}, {46.256, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {46.256, 10.}], 
                 Offset[{-1.5, 0}, {46.256, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {46.256, 0.}], 
                 Offset[{-1.5, 0}, {46.256, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 125], {LineBox[{{46.658, 10.}, {46.658, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {46.658, 10.}], 
                 Offset[{-1.5, 0}, {46.658, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {46.658, 0.}], 
                 Offset[{-1.5, 0}, {46.658, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 126], {LineBox[{{47.063, 10.}, {47.063, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {47.063, 10.}], 
                 Offset[{-1.5, 0}, {47.063, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {47.063, 0.}], 
                 Offset[{-1.5, 0}, {47.063, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 127], {LineBox[{{47.443, 10.}, {47.443, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {47.443, 10.}], 
                 Offset[{-1.5, 0}, {47.443, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {47.443, 0.}], 
                 Offset[{-1.5, 0}, {47.443, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 128], {LineBox[{{47.856, 10.}, {47.856, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {47.856, 10.}], 
                 Offset[{-1.5, 0}, {47.856, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {47.856, 0.}], 
                 Offset[{-1.5, 0}, {47.856, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 129], {LineBox[{{48.272, 10.}, {48.272, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {48.272, 10.}], 
                 Offset[{-1.5, 0}, {48.272, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {48.272, 0.}], 
                 Offset[{-1.5, 0}, {48.272, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 131], {LineBox[{{49.174, 10.}, {49.174, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {49.174, 10.}], 
                 Offset[{-1.5, 0}, {49.174, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {49.174, 0.}], 
                 Offset[{-1.5, 0}, {49.174, 0.}]}]}}, {InsetBox[
               StyleBox["\<\"\[FilledCircle]\"\>",
                StripOnInput->False,
                FontSize->0], 132], {LineBox[{{49.985, 10.}, {49.985, 0.}}], 
               LineBox[{
                Offset[{1.5, 0}, {49.985, 10.}], 
                 Offset[{-1.5, 0}, {49.985, 10.}]}], 
               LineBox[{
                Offset[{1.5, 0}, {49.985, 0.}], 
                 Offset[{-1.5, 0}, {49.985, 0.}]}]}}}, {}}], {}}, {{}, 
          GraphicsComplexBox[CompressedData["
1:eJzt1vlLVFEUB/DRpEJMXFqGMlPLVKY0NTPXGdNxyRa3VsTKNEpKwzJCRbAI
k6hIs7ISsYUSQkJDJG0xRE1aTCMpsYUWlTZKLcycuvfMdL7p3zDvl+HDnfc4
79xzzruOyRlxqaYKhcLMRKGQvwury75eae5VK+hy0FzQ1g6MPh1k03L0EDuu
zv7Qx9gpmn/+kqv2SbppxZ7x/NHP+K3WbP3z4cnX7DamBNiyP7Q7dQ/r7Nje
8hpwZL9affR0epETe1Wy1Xq/G84GKzVmay0XVs924fWqiDfZU9NVvH6nfKZH
zzsVr59vcrie6erOXm5hqir4sYj/n2Fz8G6biSeb4imGW6J9C0NewxTf93Hr
Ci+2pUzAJFgkr87eGb7aLG+AC6bLBMLiZVv35cG/K791rDwAd13cHWR+Gm5s
q9DW1sBuicfvDfXBwebijlH4VOiRnb2zvNm7ekcqv3nBMeL1bELhTyL8Q9Hw
wwfiWgG/vXyuySEGpnxugT165k3Mz4LFblVFNMJFn0VBvYTndg/npQUuZkfK
Gwpguf1lj2GVTOAMn7H5S4KzipVma6vgSyJ9XROWsM+ki4DNYZGdkUprmOrB
Fl62+X270yxYI7ohagVM9ZcCT8wvERmHKV+74WmygE/CO06IhJTAv/LSGvZ2
wtR/L2DZvfvdfMfGswAW1eCamAFbywRNX2qwlb5ft8FUv1dgat8/MOUrzY8d
JhNWCMv03y6Hqd9q4cc/499erof18wI2lRvq7s/+4SoKeg2cGiA7EKbxdAam
fqqB66NEAC2wbA9XuwA2bY8LTPGEw4Mivf3/mept3T8b9iMbDpThHYMpP/dx
v37ewuGSykD22VJxbYA7V4oBWApT/A0w5fcZrBPhzrcOYlM9x8IunnIiw3u2
i4LbBOdMlQU5br0cptsvwdRvOvh7hwhYGcym+lHD/rI+/vMcOSDzYBr3rTDN
/wQ1+3qmCCgRpu9LDkz70wVTPkw0vB80D2/B9PwmuE+Mw46gEDa9XzBM/bQa
puc/CWXL9rOIC2NT/+dqDTZ8z+aFs6k++sP5/wk0ICLGxpcAU34Pw5SvOtiR
EgQXhsiBFcn5ENO5Qnsqktfp+6mDjecD4/nAeD4wng/0Np4PjOcD4/nAeD6A
/wI8TNuO
           "], {
            {GrayLevel[0], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 131], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 132], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 133], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 134], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 135], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 136], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 137], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 138], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 139], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 140], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 141], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 142], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 143], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 144], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 145], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 146], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 147], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 148], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 149], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 150], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 151], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 152], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 153], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 154], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 155], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 156], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 157], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 158], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 159], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 160], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 161], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 162], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 163], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 164], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 165], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 166], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 167], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 168], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 169], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 170], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 171], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 172], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 173], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 174], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 175], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 176], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 177], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 178], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 179], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 180], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 181], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 182], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 183], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 184], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 185], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 186], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 187], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 188], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 189], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 190], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 191], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 192], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 193], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 194], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 195], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 196], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 197], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 198], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 199], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 200], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 201], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 202], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 203], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 204], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 205], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 206], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 207], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 208], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 209], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 210], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 211], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 212], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 213], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 214], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 215], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 216], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 217], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 218], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 219], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 220], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 221], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 222], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 223], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 224], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 225], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 226], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 227], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 228], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 229], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 230], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 231], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 232], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 233], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 234], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 235], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 236], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 237], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 238], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 239], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 240], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 241], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 242], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 243], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 244], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 245], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 246], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 247], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 248], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 249], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 250], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 251], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 252], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 253], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 254], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 255], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 256], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 257], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 258], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 259], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 260]}, {}}], {}}}, {{{}, {}, 
          {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
           LineBox[CompressedData["
1:eJxN0Ak0FHgYAPAhqveodUVRYhRjTBhMGMcMk2NczcibHCmyucpQjk3aHA+F
ol3Xrl33VUnCGw3edrEioha1LTrsyFbudUbZ4z3f53vve//3e+/7/u/7PvXj
oa4nxAkEwpV/87/3Bcmx22OmyJLwf1CYh2yovnWKPYw1p0q9s76t+BpcVurf
X28wBU44TLN+LLMINjG3u3T00Sq4qG0ysVJOgrnmOmHXDq1Pm8Djb051udGk
wR2cFwIfXRnwn9lxNZ6qcmC5KCmhjokCeHNzQTBTVxFs1JWQGaG8HRxx1r4z
Vl8ZHJOiWN1N3AnOobXlz1qqgu+dtuUq2e8Gz/L8xPNJauDAc5Wah/XRQ/kf
HWRN0D/UbPGeMFszien6QC+0k4GW7uXGX2Oh20ThmUl26Fs6KwNLPHTumcQ9
fH90ICFbwEtC09PLbRll6KHrbYEyw+i4X0dT3+5WB6f5DX+/VI7OERvKk6UQ
wTJhz2P9NDXACjeZY0W0PWBDl175CcZecAMxWMbbRBPc0no6646NFtb/+O24
oRUJfLe3Vuy+sTa4b4CXb8wig50VCVufmeuAOarKG3mOFDD/8pHGD277wFOU
UqtiJ13wSp4nl+Whh/PtkvppA1kfvKz2OXi8DC2ZVvnFiUwFW23tO/9LBdp6
UXi3dJ8BOHJ598e8KrSAqjK3Q8sQ3NTd/XBrNXo6USJGgWwEHi+emc+oRS9M
R3Ay99PwXl7RWZV1aCOd/T9TTfeD/RUi07sa0BX69kcnqcbgqvre6Yt30MMH
34ZSjUzAr1wraznN6NFLYs8WGKZg4u9Df9Q0r3P6mWtDVnSwm3eKz857aMdM
98GntmZgzkozbUsXOvlCcbSnvTk4PoARv6sHfSvoWPi0kwX4fYE8y7l9nelx
z1VdLMHKU3w3sU60rLRijocrA7zNiyswfYEu9714LFubifuwrdvaT6FNLCxL
EqvQ/Q4SIRLv1zmtYsc9HStwyMsUM/FgdKAnmxFXjTYo7ojZ8AS9MsoWJo+h
W74zd11aRqea6Y2dlLLG/6+STPfKozkj6smvlNFjXz2o6VdBp9B9XnbtRGue
WBVv3YV+mFFAaVZdM4W5LBqMva6GNqKr9OYS0RWi3OgITbRShoIal4zmrYy2
9jqis4Kag3gh6BucUpKoCv3OWzK6/Qla42RAx81JdAnVw+vLApq46DB+kMAC
Pwx6xP1aHH18gNVwVgJtoJDwV4IkWtz5vvKVjWsmMX9L+uKUuwldctc8tngz
eriYZv9YGk1M0pX9W2ad5eRoOerrXDjnbmqA5jO8B1hcdNPrVm+XMLTgUNiB
gno0u+9IUdQM2o8v/1FO/wD4jVmF0ocz6Plt5xrZtWi+BtlCNIsOcSirsTa2
AUteOJarHYkmjMz7OArRme49hXPz6OqR00/8jGzB5IqpQelv0Mzw276WArQw
3Kn9xiK6I067rNDYDuxb+ZTvHon2EnNTcRKiJwK2W7TPo0VijcxYuj32CzQM
P51HR0X25H1uQseHsjsvDKEvB7Usr66i/wGSVRjY
            "]]}}, {{}, {}, 
          {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
           LineBox[CompressedData["
1:eJxN0HssFAAYAPA76bGRietEJU6FI91x587rXojLpcNNHglZRDmK05tjRtLq
D9RSXtFdCwm7Om6p9RC5qFF66amshzzGZVF6bH2fb/v27bd93/Z9n/X2lOAd
egQCIf5P/q39dgHd4eOVHMK/oPFCfOmxTeQe7n8fM/gouEJ+Da6pjn/c7DwK
ztnCFNw3ngKzPf2Obrs3C65sH8lVmujz/rtJrTW3/bEQPPxmt1bCNAR3ivtV
MU7G4Pcl8oYISxOwSYaB2oFNAi/SlCfxnMhghjanKN1iGTh9v39XFs0CfKiA
XN9NWQE+xWwvm+BYgidC4/TK7KzA8rtDx96ussZ+4kDpEkcK2Dj1SVbcWhsw
qY73tZK5GuwS2Gv6jbsGfJWSZBzFXgu+fWdP8TVfW+w/c2TYhW8HbuttJN5k
2YP7XoSWsbyp4E1kgtEjTwew2NJiQWiAI1h6fGvLZ8k68KhjNb9K5ASeKY0I
8g5fj/utNDg7j0oDT1v9TBquQc8vVP4SUelgvlHf4esKtGBK3Va9zhksm171
pbQWraIvnzS3dQG3dnffMqpHj+XqHyJRGeDhqnHdyUb097F0cZErE/8VeaBY
2YRmOLieo7u5guNJshPaq2gFzX/bCJ0Frm3uHcu/hn63+W0KncEGvwpWNoo1
6KGjxEffuW5gytOB5w2aOT6x9+IA3x0siSqIWXEDHVAU9vLhBg+weEbDXKxF
52VWHYjw9wRnJ3CzV/agLydGp42JvMCfyk29N3XMsbv8iWUgB2wxKpUQu9BL
DMmnwoO54KWRQSq3fvSF2PzoEnse3iMUtHfsRrO9OOdza9GPN+on63+a40KF
+Q0HPjj5WYGHXhJ6Z4SQK69HzwwJ1Xlf0WYnSVZBVAG4OFGTGJqMviSuthus
RdvsSuisG0FTKibD3Jy9wa2v70QFpqJVIak+5c1oYd/WyoxxdJzU9IsJzQf8
xkNh9nkvWrf0YIuwES21oXoNTqCTN9Y0CFi+4PmZ0aftZWjCB11MgBpdFNZT
MalD13/Y8yCOsQFMVYy+NNyH5qVdieWo0Oo0UcelKXSn3L6mguUHjlU+lIbJ
0JFEyXKRGv0tYZlXhw49SGzhZbn747zKxuXHYXSGrKf0Zys6O0XYlTmAPp54
e3p2Fv0bw5OLTg==
            "]]}}, {{}, {}, 
          {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
           LineBox[CompressedData["
1:eJxN0HssFAAYAPA76bGRietEJU6FI91x587rXojLpcNNHglZRDmK05tjRtLq
D9RSXtFdCwm7Om6p9RC5qFF66amshzzGZVF6bH2fb/v27bd93/Z9n/X2lOAd
egQCIf5P/q39dgHd4eOVHMK/oPFCfOmxTeQe7n8fM/gouEJ+Da6pjn/c7DwK
ztnCFNw3ngKzPf2Obrs3C65sH8lVmujz/rtJrTW3/bEQPPxmt1bCNAR3ivtV
MU7G4Pcl8oYISxOwSYaB2oFNAi/SlCfxnMhghjanKN1iGTh9v39XFs0CfKiA
XN9NWQE+xWwvm+BYgidC4/TK7KzA8rtDx96ussZ+4kDpEkcK2Dj1SVbcWhsw
qY73tZK5GuwS2Gv6jbsGfJWSZBzFXgu+fWdP8TVfW+w/c2TYhW8HbuttJN5k
2YP7XoSWsbyp4E1kgtEjTwew2NJiQWiAI1h6fGvLZ8k68KhjNb9K5ASeKY0I
8g5fj/utNDg7j0oDT1v9TBquQc8vVP4SUelgvlHf4esKtGBK3Va9zhksm171
pbQWraIvnzS3dQG3dnffMqpHj+XqHyJRGeDhqnHdyUb097F0cZErE/8VeaBY
2YRmOLieo7u5guNJshPaq2gFzX/bCJ0Frm3uHcu/hn63+W0KncEGvwpWNoo1
6KGjxEffuW5gytOB5w2aOT6x9+IA3x0siSqIWXEDHVAU9vLhBg+weEbDXKxF
52VWHYjw9wRnJ3CzV/agLydGp42JvMCfyk29N3XMsbv8iWUgB2wxKpUQu9BL
DMmnwoO54KWRQSq3fvSF2PzoEnse3iMUtHfsRrO9OOdza9GPN+on63+a40KF
+Q0HPjj5WYGHXhJ6Z4SQK69HzwwJ1Xlf0WYnSVZBVAG4OFGTGJqMviSuthus
RdvsSuisG0FTKibD3Jy9wa2v70QFpqJVIak+5c1oYd/WyoxxdJzU9IsJzQf8
xkNh9nkvWrf0YIuwES21oXoNTqCTN9Y0CFi+4PmZ0aftZWjCB11MgBpdFNZT
MalD13/Y8yCOsQFMVYy+NNyH5qVdieWo0Oo0UcelKXSn3L6mguUHjlU+lIbJ
0JFEyXKRGv0tYZlXhw49SGzhZbn747zKxuXHYXSGrKf0Zys6O0XYlTmAPp54
e3p2Fv0bw5OLTg==
            "]]}}}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"x(kbp)\"", TraditionalForm], 
         FormBox[
         "\"RF(T,\\!\\(\\*SubscriptBox[\\(T\\), \\(true\\)]\\))\"", 
          TraditionalForm]},
       AxesOrigin->{-1, -0.05},
       Method->{},
       PlotRange->All,
       PlotRangeClipping->True,
       PlotRangePadding->None], {580.5, -358.76873046931394`}, 
      ImageScaled[{0.5, 0.5}], {360., 222.4922359499621}], InsetBox[
      GraphicsBox[{{{{}, {}, 
          {GrayLevel[0], Thickness[Large], LineBox[CompressedData["
1:eJwVV3k81O8Td3RIzsqZW650WMeSa8aydlV0OJJc0SoquQuRr6yVc7E5djdR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            "]]}}, {{}, {}, 
          {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
           LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQrdT/d/E8uY12ImAwxf7UxNuFL9Lv28P4XnvZ/Z6l
v4fzz/KacbLEMjjA+E79rgeW+3PA+an6v3gNeQXgfF/N1I9i7iJw/qYrtaUn
LSTgfGshrfUs9TJwfvrvSXOXRijA+fnHnhuv91WC87ui2FT/5qjA+cnHq9MM
M9Tg/IPskoHZkRpwvqFgw7SXJVpwfsJnWx2/HB04f+G8ozLfe/Xg/M19Vrcv
BRnA+SW7bAPm+hjC+ftPLf3UGW0E52e6W+7NjDCG8+esMNyanWUC50/8vLex
oNwUzn+2qrQso8gMzj/iNmlGU5M5nM/of+tRf4MFnM/guI1xQaUlnN8h/t33
UrsVnF8QlXzoe7M1nP+w0STFfqoNnC8yeeatzoW2cP4yAa3K47PtEOFVJO+q
vtoezp+nsEDGNsQBzt9b84sh4wKCr+jN/kc53BHO33Jes/vmFQS/59g/A4VY
Jzh/cvHLrIQ7CH6NqBy/UqQznL9Sk/VUyQMEn+0Lo+TBOBc4f7nBxrp5zxF8
zaRVfn9zXeH82547N4W+RvAvLa7StS92g/N/bA60UfqE4P/fUbS1Lc8dzvc2
cHOt+YrgH4/Vz8wu9oDzrdgDNmzdieCv21Dw/f9/BB8AFP/2Og==
            "]]}}}, {{}, GraphicsComplexBox[CompressedData["
1:eJzt04krhEEUAPBtQ3KHkJC7FdK6Fotd1pljc5W0SRsld0JCciRJkuQOyZVC
kiRJjkW7SpKSkJAkSWySUGYm3mv9C3bq6+vXNzPfezPvOclLU/O4HA6ngTz0
3dFXYt68oRJxfob+rF1WrvAGPDhAxzPY+vTgLe1GR/zruKsay/lYc7Hmekfw
9itP1tnkBE6Wm2UGL7mA2yJybg/lruDiu4+Z5yN0ooDOcAd7Lw4/Te/ywL2S
9qK7Wg9w9mq8EbfQC+xy9l5fsOYDlnVuvfLO+X/2R4+Q3RMEvmAWzhx6Wf11
XH2PZvvL/MCtVuSAutFdj3WigBG0CU1gzx8cRcL/UKLd9Bp7JIWB4H56PQYC
MP3cboRm8XWg2f/Cg8B+dKiDwcqq9VFb0xDwpmosetkCzc5Hhr535+vPnqP3
yXR1mBBMLv+qJh2dTwPIQBesVXTbKNCXUlJx5aHg1BWHloeUcM38itAsP2MR
mBbr2A6aFNul1F4MptfvOY3+JMuTrtGsPg0jwGEGJ+Nlw2i2/yRaSAN2iASz
8teVgKeGFI4LvugLV5JBGrqWHpAKHUnK3fkMzfJ7jAKzfnlBs/i50WBWr3lo
T1Zw6FKaAD8GPFFGM4zVzK8yDqztf23/a/v///b/N7160e0=
          "], {
           {GrayLevel[0], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 65], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 66], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 67], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 68], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 69], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 70], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 71], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 72], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 73], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 74], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 75], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 76], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 77], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 78], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 79], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 80], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 81], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 82], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 83], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 84], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 85], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 86], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 87], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 88], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 89], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 90], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 91], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 92], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 93], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 94], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 95], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 96], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 97], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 98], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 99], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 100], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 101], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 102], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 103], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 104], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 105], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 106], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 107], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 108], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 109], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 110], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 111], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 112], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 113], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 114], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 115], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 116], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 117], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 118], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 119], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 120], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 121], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 122], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 123], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 124], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 125], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 126], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 127], InsetBox[
             StyleBox["\<\"|\"\>",
              StripOnInput->False,
              FontSize->20], 128]}, {}}], {}}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"kbp\"", TraditionalForm], 
         FormBox["\"pdf\"", TraditionalForm]},
       AxesOrigin->{0, 0.},
       Method->{},
       PlotRange->{All, All},
       PlotRangeClipping->True,
       PlotRangePadding->None], {967.5, -358.76873046931394`}, 
      ImageScaled[{0.5, 0.5}], {360., 222.4922359499621}]}, {InsetBox[
      GraphicsBox[{{{}, {}, 
         {GrayLevel[0], Thickness[0.003], LineBox[CompressedData["
1:eJxNzX0803sfx/G5nW4UEe3YEZsYuZuRpfAjm7kJUaESkXsh92m1TjpFN+4r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           "]]}}, {{}, {}, 
         {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
          LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAWIQ/SZ+oWqR10Y7qavBc55cEHGQO/dltt+O+/Ywflbn
siKfHe/h/PqAqa+etzE4wPh2k//5PenlgPPZec5M9TATgPNfzXmsyFAtAudL
/7CsPF0mAecfV4x+9/24DJxva3bKv65JAc7f58DW11WjBOfXbFKPdl+oAucn
dr7g7VuoBuefKth678B0DTi/cH+63ZIdWgj3Fu9sFtyqA+d79n0I17+jB+e/
viO5dE6NAZzvpso98VmFIZzvoJh/pKPLCM4/e37Rq/edxnD+T0PPiPXzTOD8
9Dlfr6SsM4XzM3YWutxfbQbnc3Ql/N64zxzOt+aVX+q53wLO3zDjcez1XZZw
/pHrUnF7T1vB+TknFQMzTlnD+ZvyZndn37OB861kpK+mvLWF88NqsgSVX9nB
+YITdKZa/rGH8/W177dy1TnA+eVCqz2KfyP4fcEG+h3NjnD++1zZ/nomJzhf
4dFhIeUeBH+W/iX+lTzOcL5pY7LIqi4Ef4HOOptwYRc4P2Rjwr1nkxD8G/1n
FivJusL5tUW7C24uQfCz9YS2Fym7wfmaLkqKO9Yg+AbGs1ge6LjD+RFqU983
rULwA4o9/1008oDzJ81MbWPehOA7GDzYx/gTwX97LOr7f3tPOB8A9ZuBxA==

           "]]}}, {{}, {{}, {}, 
          {GrayLevel[0], Thickness[Large], LineBox[CompressedData["
1:eJxNlQ0wlHkcx73drhO1W2gXdSmd7VReQrJ296ewKxR60TnckTrtCTnkyind
aNOb6Qq9nNSV5KYzvTojdJkdyfXKDVcNMs64khPCdS7d//9/mufXM7Oz85n/
8/s/v+f7//6+j31ccvgGIwMDg13kR/8XXC4eKGvoVdU7Zh44mfkh/OhfOfzm
91eq1nVZNwIahMCWg0Z4Dq+amdsXZgFTjMdttD0C+DtL5RFTLYLnKW/3O4uF
MP3RvbFV68Xgog7+Y5+LELj9kU0v2EXGy6fx3PNg9pPXE3Z8/SJ6DdtDUKh+
x5sWAXSuPFCU9P1syDL5SW6nFcCKONG6JVfngul4QVyqvQBM1k5ecHmGI88V
6q5tlklOkLurY89n24RQV2Lj3P6nE2gEv/hdyxbCD/pZF1NlCyG8VFe2otYM
lpsbOelGXcDh6sOfey+JIHnqd782GbryzPo57ApG1+p+c060hltBi/N8n7pC
f8hQ1gVbG66/IVd4+o1ecX1Qyq0buPE8mQogdOPvJ+JVzZyLfL6BFiDrrKmA
WE9etjEjG9f/Kx9sDtmF3HYmRWFWhHyz6bR/5RXkeVH59SN/ISvMSMUb5MJl
+xJ7bRfxz9vcO14+6IYcSl5v6jLkF6T93CDku3fIFYzcXXpCPysUmekZi+zc
7iDISUcmp1WhvrkI3ANPPHrZKoVD/cRQHchznrzO1vq4w+P8HF3xl1LQ0AId
Mj3+4vvusDddrTmkk4ATFXC6B3hVZRTWyiScfjEe4PmO0w9LTNZWePD1Z4l8
bcaefP3RJNKwGTJRZ7xcjMz8MA156RfEwbbIdBoCgz1hwC9teW2llPNfPLIg
p4Aojsz0SkG2pAY+gpxABSlA/jdbW5PWgszm7zEynd7MeYt5fVk/85GJG2RR
ych0mhqtvXhm87rRCwbdtuw84ybh/FuGzMb3rRevJ9NLu4RnPypYHjKVv64E
mc1bJfL9sVXdpdeRubxANqIHutAb5g/EdIZ5SGBURgy9xpvXO15OJxCZxdNR
ZDZPV5CrA0kDt7zBZ9PVzbIUKdDxkNnJITd8d+DGWCmw43FEZv0EIL8i8j57
j5nfIuT8fuw8tsnh25qdwdoIKbD2DuL9TJ/bcjA2DemPJXnC5S1yAEWJD+y/
pK6Z2GQNx4+R61PklhASgMd8oNjmwfZT1tZc/zXITN9W5AnS7sdiBYy+iBzz
HbXi/Bym4NcdXWkiI39NDfc58nZmSKxn6yUKuLF+tn682wpY+VlkNm8TCjj1
1ZyM4lQrGGomDUuUPDP/qJCZP97jj2hAZithTdonj2bEWwGL+0YlRDi4tX9g
ZcXl/2oVaDy3xvX0WMLFVNJQFDL7vmxHZufTpoLdlkrHObFiTg9D4JnlYS3A
tKiILvNhC25/PTKNw2aFL/hZHFdG6yy491Mis3la6QsJz3cXLM204PZ/uAxe
NtkZdqQJgY6febgfVNcfTBBGmnHzn+UPw3356dX/mHHPcwiAc11NJ22Vkzh/
PAuAosQr688XTYHVLCDU0KTPbzbtFL17fzWEpiRu8Tsi5vTdo4YdJjnRk/aK
Ob2qkO2ZQGromn5PpjUSQ54vDSwNnNkadld0RwQknU/7F2pg7HbfSPsGEff9
nNBAzpG8c9G2Yvgfckx+9g==
            "]]}}, {}}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"x(kbp)\"", TraditionalForm], 
         FormBox["\"L\"", TraditionalForm]},
       AxesOrigin->0,
       Method->{},
       PlotRange->{{0, All}, {0, All}},
       PlotRangeClipping->True,
       PlotRangePadding->{Automatic, Automatic}], {193.5, -597.9478841155233},
       ImageScaled[{0.5, 0.5}], {360., 222.4922359499622}], InsetBox[
      GraphicsBox[{{{}, GraphicsComplexBox[CompressedData["
1:eJxd1QlIVFEUBuDRpEJKHLUc0krNcsS0tGxxmzGdUdNyzRbEyjRKSqUyomIg
Q0yiIs2lRcRSSggRDZG0xRC1aNVISmzBSqWNUgtbpu49TufPHoh83HmP8/57
zn3OKZlxaeYKhSJH/Mn/nnVlny629WsUdDlpz+sahn49HmbTcuQIO65xVu67
2Knav/54UOObfNWabf/0/rf4LUr22PPhyZcdN6T627LfPnTpGTU6shfJa8iZ
/SL6WElGgQt7dYr1uuVX5pqs0lokWnnWzXTj9ZqwV/vtMjx4/Ub5jAW9rz14
/VyrU+0utRd75RRzj7yvC/n3mTaHb94x82ZTPYVwe+TS/OCXMNX35b91hQ/b
SgYwCRbhNc6aC19qkzfAedNlgLB42Y69Bvhn9efOVTlw94WsQMsSuOVOha6h
HnZPOnFrZAAOshR3/IKLQ47u6HdYxN7Z/6P6sw8cI17PJgR+L8rPjYTv3RVX
FNxXdbbVKQamPDfDC3pdJx7KhsVu1YS1wAUfREM9h+f0jBrSAxazw+UNebDc
/rIHsIcM0N53fH7JcHahyiKxBq4U8XVPWMIuzRAFW8IinR/VSpj6wRZesenN
QxcHWCumISIKpv5LhSceKhKJw5RXFjxNNvApePtJEUgR/N2Q3rynC6b5ewbL
6d3nvnR8PfNh0Q3qpExYKQOavsxk67F53QpT/16EaXx/w5RX+nJ2qAwsH5bx
Xy+Had4a4Aff4vuqmuCx8wI2lxvq5cf+qhYNvQZO85cTCNPxVArTPNXDTRGi
gHZYjofa0Z9N2+MGUz16eFjEO/iPqd/W/rVpP/bDAbK84zDlcxv3j523sF5S
FcA+c1pc6+GuVeIAPA1T/c0w5fsENopy5ykD2dTPsbCbtzyR4d3bRMNthA/Y
yYb8b70cptsrYZo3I/ylUxSsCmJT/2hgP9kf/3i2PCANMB33HTCd/wkadu0u
UVASTN+XAzDtTzdMeZhpeT/oPLwG0/Nb4QFxHHYGBrPp/YJgmqdomJ7/KIQt
x29KXCib5v+gzmTT98xVz6b+GNTz7xPogAgbX18CTPkegSmvRtiZAoLzg+WB
Fc55iNO5Qlcczuv0/TTCfwAHie8W
          "], {{{}, {}, 
            {GrayLevel[0], Thickness[Large], 
             LineBox[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 
              17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 
              33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 
              49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 
              65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 
              81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 
              97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 
              110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122,
               123, 124, 125, 126, 127, 128, 129, 130}]}}, {
            {GrayLevel[0], Thickness[Large], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 1], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 2], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 3], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 4], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 5], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 6], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 7], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 8], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 9], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 10], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 11], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 12], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 13], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 14], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 15], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 16], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 17], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 18], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 19], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 20], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 21], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 22], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 23], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 24], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 25], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 26], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 27], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 28], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 29], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 30], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 31], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 32], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 33], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 34], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 35], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 36], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 37], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 38], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 39], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 40], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 41], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 42], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 43], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 44], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 45], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 46], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 47], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 48], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 49], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 50], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 51], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 52], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 53], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 54], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 55], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 56], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 57], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 58], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 59], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 60], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 61], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 62], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 63], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 64], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 65], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 66], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 67], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 68], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 69], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 70], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 71], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 72], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 73], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 74], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 75], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 76], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 77], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 78], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 79], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 80], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 81], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 82], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 83], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 84], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 85], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 86], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 87], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 88], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 89], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 90], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 91], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 92], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 93], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 94], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 95], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 96], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 97], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 98], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 99], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 100], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 101], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 102], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 103], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 104], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 105], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 106], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 107], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 108], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 109], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 110], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 111], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 112], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 113], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 114], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 115], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 116], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 117], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 118], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 119], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 120], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 121], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 122], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 123], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 124], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 125], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 126], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 127], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 128], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 129], InsetBox[
              StyleBox["\<\"\[FilledCircle]\"\>",
               StripOnInput->False,
               FontSize->6], 130]}, {}}}], {}}, {{}, {}, 
         {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
          LineBox[CompressedData["
1:eJxN0HssFAAYAPA76bGRietEJU6FI91x587rXojLpcNNHglZRDmK05tjRtLq
D9RSXtFdCwm7Om6p9RC5qFF66amshzzGZVF6bH2fb/v27bd93/Z9n/X2lOAd
egQCIf5P/q39dgHd4eOVHMK/oPFCfOmxTeQe7n8fM/gouEJ+Da6pjn/c7DwK
ztnCFNw3ngKzPf2Obrs3C65sH8lVmujz/rtJrTW3/bEQPPxmt1bCNAR3ivtV
MU7G4Pcl8oYISxOwSYaB2oFNAi/SlCfxnMhghjanKN1iGTh9v39XFs0CfKiA
XN9NWQE+xWwvm+BYgidC4/TK7KzA8rtDx96ussZ+4kDpEkcK2Dj1SVbcWhsw
qY73tZK5GuwS2Gv6jbsGfJWSZBzFXgu+fWdP8TVfW+w/c2TYhW8HbuttJN5k
2YP7XoSWsbyp4E1kgtEjTwew2NJiQWiAI1h6fGvLZ8k68KhjNb9K5ASeKY0I
8g5fj/utNDg7j0oDT1v9TBquQc8vVP4SUelgvlHf4esKtGBK3Va9zhksm171
pbQWraIvnzS3dQG3dnffMqpHj+XqHyJRGeDhqnHdyUb097F0cZErE/8VeaBY
2YRmOLieo7u5guNJshPaq2gFzX/bCJ0Frm3uHcu/hn63+W0KncEGvwpWNoo1
6KGjxEffuW5gytOB5w2aOT6x9+IA3x0siSqIWXEDHVAU9vLhBg+weEbDXKxF
52VWHYjw9wRnJ3CzV/agLydGp42JvMCfyk29N3XMsbv8iWUgB2wxKpUQu9BL
DMmnwoO54KWRQSq3fvSF2PzoEnse3iMUtHfsRrO9OOdza9GPN+on63+a40KF
+Q0HPjj5WYGHXhJ6Z4SQK69HzwwJ1Xlf0WYnSVZBVAG4OFGTGJqMviSuthus
RdvsSuisG0FTKibD3Jy9wa2v70QFpqJVIak+5c1oYd/WyoxxdJzU9IsJzQf8
xkNh9nkvWrf0YIuwES21oXoNTqCTN9Y0CFi+4PmZ0aftZWjCB11MgBpdFNZT
MalD13/Y8yCOsQFMVYy+NNyH5qVdieWo0Oo0UcelKXSn3L6mguUHjlU+lIbJ
0JFEyXKRGv0tYZlXhw49SGzhZbn747zKxuXHYXSGrKf0Zys6O0XYlTmAPp54
e3p2Fv0bw5OLTg==
           "]]}}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"x(kbp)\"", TraditionalForm], 
         FormBox[
         "\"RF(T,\\!\\(\\*SubscriptBox[\\(T\\), \\(true\\)]\\))\"", 
          TraditionalForm]},
       AxesOrigin->{0.743, 4.},
       Method->{},
       PlotRange->{All, All},
       PlotRangeClipping->True,
       PlotRangePadding->None], {580.5, -597.9478841155233}, 
      ImageScaled[{0.5, 0.5}], {360., 222.4922359499622}], InsetBox[
      GraphicsBox[{{{
          {GrayLevel[0], Thickness[0.003]}, 
          {GrayLevel[0], Thickness[Large]}}, {
          {GrayLevel[0], Thickness[0.003], LineBox[CompressedData["
1:eJxl2MtrXHUYxvHTi/fxUk0v06s1OsZcG08aG03SMUYTYVbushU8Ll3MP3D+
gCzcHleuBpfCcaHgYhARlaOg9cKIl2r11NZWK6OiKGIzz/v7PbyPAT186ZzP
PH0pRTz57AvPPLcnSZJd1//5/fq/dif//3mp2Pl546zv92IvpDs/56xfPItf
H8TG83xsfP5C7OeznZ/a+mV7/1LsD6qdnyux8bwmn//V+hXzh7Hx/m+x8X1/
xMbzz9jw/hLvb/H+Ee9f8ZK2/zwb/q62f393bHzfnrb39oq3V7wbrF8178bY
8G6KjefNseGx4d0i3q3i3SZeQ7yGeLeLd4d4d4p3l3yeDZ89ej3dJ9+3T7y7
xQv9mnls7LknNjw2nmOx4Y2JNybefvH2i3dAvAPiHRDvoHgHxTsk3iHxDonX
FK8p3mHxDot3WLwj4h0R76h4R8U7Kt4x8Y6Jd1y84+IdF++EeCfEuzc2/nyx
4Yd+3d5n4/vYeJ6MDY8N76R4od80j43nfbHhseGx4bHhsfEcj437jIs3Lt64
eKH75t0fGx4bXui3zGPDY+P5gPXb5rHhseGx4bHxbInXEq8lXku8lngPWr9j
HhseGx4bHhvPCfEmxJsQb0K80O+a91BseGx4bHih3zePjedkbHhseGx4k+JN
ijcl3pR4U+JNiTcl3rR40+JNixe6Mo+N50xseGx4bHgz4s2INyverHiz4s2K
NyvenHhz4s2JNyde6A/NOxV79PkmG3/fsEfvd9j4vlPey8UrxCvFq8SrxUvm
Zd+899J573XmvZfNey8XrxCvFK8Srw79ke17ODb2sbGPjX2hP7Z9bOxjYx8b
+0Kfs31s7GPjmVp/YvvY+PPDxj429oX+1PaxsS/0Z/DK0J/bPjb2sfFciI19
bOxb8F5nwXvZgvdy8QrxSvGq0APbx8bzdGzsY2MfG/tOey877b1cvEK8UrxK
vFq8ZFH2LXovXfReZ9F72aL38tBf2D429rGxj419bDwf8V4z9Je2j419bOxj
Yx8b+0J/ZfvY2MfGPjaeZ2Jj3xnvpWe81wn9te1jYx8b+9jYx8Y+8WrxkiXv
NZe8ly55r7PkvWzJe7l4hXileJV4tXjJo9bf2D7r/LztY2MfG/vC+9/aPjb2
sbGPjX1s7Au+ecljsbGPjX1s7LNOvrN9oe3/Y+Rs7GNjHxv7gn/B9rHxueXY
2MfGPjb2LXsvW/Zebp18b/vY2MfGPjb2sfFc8V5zxXvpivc6K97LVryXi1eI
V4pXiVeLl6zKvlXvpave66x6L7POw77w6z/YPjb2sbGPjX1sPM96r2mdm5ey
sY+NfWw82dgnXileFb6/tn1sPNuxR59vsLG37d9vWee1/fcN27jY+P2wR94W
G78/8bri5eJti1eI1xOvDPsvwuuzcR/2yBuwca/gXYQ3ZONzj8fG/ayTH+1+
bNyPjfuxcT827ifelniZeF3xcvG2xSvE64W+ZPdj435s3I+N+7FxP/GG4iVr
3musea+55r2WdW5eysb92LgfG/dj437idcXLxdsWrxCvJ14pXl+8SryBeLV4
Q/GSJ7zXsE4u2/3YuB8bf/+E9y/b/di4Hxv3C+//ZPdjj7wuG++xcT827ide
T7xSvL54Vdhn3oCN+4XPX4E3ZOO5Hhv3Y+N+bNxv3Xvpuvfa4nXE2xIvE68r
Xi7etniFeD3xSvH64lXiDcSrxRuGvmr3ezI27medX7X7sXE/Nu7Hxv3YuJ94
W+Jl4ft/tvux8Tk27sfG/di4n3ileH3xKvEG4tXiDcVLnrLfj3kNNu7Hxv3Y
uJ918ovdj437sXE/Nu7Hxv3Ey8XbFq8QrydeKV5fvEq8gXi1eEPxkg3vNTa8
19zwXmvDe+mG99ridcTbEi8TryteLt62eIV4Pes83I+N+7FxPzbux8b9xBuK
l2x6r7Hpveam91qb3ks3vdcWryPelniZeF3xcuvkmt2PjfuxcT827sfG/cSr
xBuIV4s3FC95OvZ/JHv+kA==
            "]], {}, {}}, 
          {GrayLevel[0], Thickness[Large], LineBox[CompressedData["
1:eJxl2WdYVFfbBWDsDSsWsGOh96G3WTPDFBVLbAlqbHnFHgsaNUYl9h5bVNQY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            "]], {}, {}}}}, {{}, {}, 
         {GrayLevel[0.5], Thickness[0.003], Dashing[{Small, Small}], 
          LineBox[CompressedData["
1:eJwVz3k41AkYwPGZLqod11YaOSKqsZVREyG9r/uXUCY9ksi6ZijlaqPV1hRy
NkrnunOWp5lctUIisdmEoVXIlTQy/FI0S8ts+8f3+fz91fY+wfZbQKFQHL/3
vzr8udxMzZJd9n7i9iejB3Y9lGdoBXH5sNhKLbifzoK6CEHeRm4WsLJuppfR
raGRGcJZwhWCQ0tXaQbdBf5MEhHTnFpw9ZXWXKH7wnPTC5USTiu8NbholUwP
h+bLPSFiTj9kr9wbm0CPBvsaOacRDgk8+bIN8fSr0EIzWrrIg4IH3XKEnybz
wJJv86RwrzzSZLzDdppC8DOYpRnSlFDPeUL8NLEcHBl+k6vsVuCplyZwc6oS
SjvPnHy+YzWqliv3Uam1YKaiL1x0Vh0rhqxetO6sB863Kxn5B9diXWDGGjdJ
A5xo/LBN6KiD0+vNFe8FNUHCoSV6c8d0ceFMsdIavWbwafrV35C7Ho1lXg/2
C15AnRzd+ajbRnwZzXrZqN8Khsrnro+G66NWytjMnYk28Ppivsnp2CaUSPv7
XjFFkJP5TF2avAXzP1Y1K1zqgLJLpj0iNhMVNArJ4eFOCH9kvi/DwRATAir8
s3X/htrm/M/x7ltxGouHuWe7IMDOpCbg4DYM3dpQvurpa0gvMqw4GsjCXkFD
Yrt2N1z+UsMLPrUdpYGdaYzTPTBy9+Qv3FAj3GAhN+9f1QsNtldunj9vjFa3
tTklqn1A3ds9xD+3A0M1jugMHu4HisUDanakCTIkB5Z3OQ5AnKrUUXTRFBUV
P8k3zA5A8CGfeukFM6TUpgnXpQ/CII/lC9d2IodV9WbpniFYkXqrOz7HHAt3
e2c//joEBUr6kU1pu5AcU1Mauf4O6kK1bDYUAwr32y28aj0MmWuz1c1dECOI
mKzykWGoiZqlcNsQ17y1f50b8x6098j9u87VArcbR1+lbx2B8lZG4ptOC3TV
bJ2hdoxAUuM8c62HJU42Jw8F8z5AathooFevJaYu8gxn64ohaqWmoo6bFSr1
Vdxe0CCGO4zFzeEDVkg9w3MxCRmFJVNUep2nNc4XeQqHVD5CIbPkt8wP1hj8
uzBZpf4jMLzvOs0F2eCjn+LklY+PQc/uytIDYzaoYB+66byCBES5pzdDmC12
b27riKyWwD9lzjt1PtuiIBN0hz3HQfZHaEXscTt0Fxopa8yPwx6mrU3UtB2e
jcnh9d6dgCYPg4CjYQTeE2ukKTiQoOLDrco4SWBcRoxXnxMJntwcWtspAn3Z
43oCZxK+hv5YyooiUL26+r6jKwm6cdLZuWgCE/jujUneJJwrrU1KuU4gx+jW
5LJIEkzl9t2vqCRQO3oFIVdAQuwP8QvEVQTO74iidRWR0K5c76L2mMA34+9E
BcUkcNVZM7/VE5jiWuZhW0LCDcPVlsRfBMr02WEx1SRMuQ90dPcS2NvOz1zY
QQL+TF9P6yewMlbq0/GKhER/dgQMEphqdoSR+5oEnZAG9bz3BNrnbym37CPB
ObbIL2iCwEcRLc95oySkJw4+zPpE4LXN2/nOEhLEKWrLRJ8JDBlKd9Emv/+k
JQmMpAQyHI71P5ki4UX2M0rADIGLqZ15KVISVAvm2WnfCByoMAv0miXBu9g4
v2WOwKrAXAPmHAmC+8FSmYzAG1rLp2UyEv4D9blOIA==
           "]]}}},
       AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
       Axes->True,
       AxesLabel->{
         FormBox["\"kbp\"", TraditionalForm], 
         FormBox["\"cdf\"", TraditionalForm]},
       AxesOrigin->{0, 0},
       Method->{"MessagesHead" -> DiscretePlot},
       PlotRange->{{0., 50.}, {0, 1.}},
       PlotRangePadding->{{
          Scaled[0.02], 
          Scaled[0.02]}, {
          Scaled[0.02], 
          Scaled[0.02]}}], {967.5, -597.9478841155233}, 
      ImageScaled[{0.5, 0.5}], {360., 222.4922359499622}]}}, {}},
  ContentSelectable->True,
  ImageSize->1000,
  PlotRangePadding->{6, 5}]], "Output",
 CellChangeTimes->{3.585764146045885*^9, 3.585764885901203*^9, 
  3.5857649315618143`*^9},ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"Export", "[", 
    RowBox[{
     RowBox[{"\"\<ggoutput_RF_\>\"", "<>", "dataid", "<>", "\"\<.pdf\>\""}], 
     ",", "ggoutput"}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"Export", "[", 
    RowBox[{
     RowBox[{"\"\<ggmx_RF_\>\"", "<>", "dataid", "<>", "\"\<.mx\>\""}], ",", 
     "ggmx"}], "]"}]}], "\[IndentingNewLine]", "*)"}]], "Input",
 CellChangeTimes->{{3.5286344146923704`*^9, 3.5286344290131955`*^9}, {
   3.5286344940169106`*^9, 3.52863455058361*^9}, 3.528634592048483*^9, {
   3.5288176775300417`*^9, 3.528817678793644*^9}, {3.5369325867180004`*^9, 
   3.5369325932494593`*^9}, {3.567747090052015*^9, 3.567747091112817*^9}, {
   3.5857628967644305`*^9, 3.585762903140795*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}], 
  "******)"}]], "Input",
 CellChangeTimes->{{3.4940977943255997`*^9, 3.494097801075859*^9}}]
},
WindowSize->{1664, 915},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrivateNotebookOptions->{"VersionedStylesheet"->{"Default.nb"[8.] -> False}},
ShowSelection->True,
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 1483, 24, 132, "Input"],
Cell[2053, 48, 229, 3, 31, "Output"]
}, Open  ]],
Cell[2297, 54, 4039, 121, 204, "Input"],
Cell[CellGroupData[{
Cell[6361, 179, 5375, 84, 172, "Input"],
Cell[11739, 265, 130, 2, 31, "Output"],
Cell[11872, 269, 130, 2, 31, "Output"],
Cell[12005, 273, 167, 2, 31, "Output"]
}, Open  ]],
Cell[12187, 278, 444, 8, 31, "Input"],
Cell[12634, 288, 94, 1, 31, "Input"],
Cell[CellGroupData[{
Cell[12753, 293, 21617, 388, 932, "Input"],
Cell[34373, 683, 218, 5, 31, "Output"],
Cell[34594, 690, 218, 5, 31, "Output"],
Cell[34815, 697, 219, 5, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[35071, 707, 475, 13, 52, "Input"],
Cell[35549, 722, 143, 2, 31, "Output"],
Cell[35695, 726, 266, 8, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[35998, 739, 134, 2, 31, "Input"],
Cell[36135, 743, 168, 4, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[36340, 752, 727, 15, 31, "Input"],
Cell[37070, 769, 1915, 43, 447, "Output"]
}, Open  ]],
Cell[39000, 815, 444, 8, 31, "Input"],
Cell[39447, 825, 1309, 36, 132, "Input"],
Cell[CellGroupData[{
Cell[40781, 865, 4418, 64, 52, "Input"],
Cell[45202, 931, 230, 6, 31, "Output"],
Cell[45435, 939, 178, 4, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[45650, 948, 7021, 125, 192, "Input"],
Cell[52674, 1075, 141, 3, 31, "Output"],
Cell[52818, 1080, 233, 6, 31, "Output"],
Cell[53054, 1088, 170, 4, 31, "Output"]
}, Open  ]],
Cell[53239, 1095, 469, 8, 31, "Input"],
Cell[CellGroupData[{
Cell[53733, 1107, 1516, 39, 52, "Input"],
Cell[55252, 1148, 169, 4, 31, "Output"],
Cell[CellGroupData[{
Cell[55446, 1156, 187, 3, 23, "Print"],
Cell[55636, 1161, 185, 3, 23, "Print"],
Cell[55824, 1166, 2253, 58, 72, "Print"],
Cell[58080, 1226, 2203, 56, 72, "Print"],
Cell[60286, 1284, 187, 3, 23, "Print"],
Cell[60476, 1289, 180, 3, 23, "Print"],
Cell[60659, 1294, 1935, 49, 56, "Print"],
Cell[62597, 1345, 146, 2, 23, "Print"],
Cell[62746, 1349, 2117, 48, 261, "Print"],
Cell[64866, 1399, 184, 3, 23, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[65099, 1408, 57, 1, 31, "Input"],
Cell[65159, 1411, 162, 3, 31, "Output"]
}, Open  ]],
Cell[65336, 1417, 145, 3, 31, "Input"],
Cell[65484, 1422, 184, 4, 31, "Input"],
Cell[CellGroupData[{
Cell[65693, 1430, 614, 10, 31, "Input"],
Cell[66310, 1442, 242, 6, 31, "Output"]
}, Open  ]],
Cell[66567, 1451, 469, 8, 31, "Input"],
Cell[CellGroupData[{
Cell[67061, 1463, 1331, 32, 52, "Input"],
Cell[68395, 1497, 2700, 56, 212, "Output"]
}, Open  ]],
Cell[71110, 1556, 444, 8, 31, "Input"],
Cell[CellGroupData[{
Cell[71579, 1568, 2088, 54, 92, "Input"],
Cell[73670, 1624, 32604, 602, 139, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[106311, 2231, 1241, 26, 31, "Input"],
Cell[107555, 2259, 38216, 798, 132, "Output"]
}, Open  ]],
Cell[145786, 3060, 444, 8, 31, "Input"],
Cell[146233, 3070, 8808, 215, 332, "Input"],
Cell[CellGroupData[{
Cell[155066, 3289, 1455, 28, 112, "Input"],
Cell[156524, 3319, 178, 4, 31, "Output"],
Cell[156705, 3325, 166, 4, 31, "Output"],
Cell[156874, 3331, 235, 6, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[157146, 3342, 2489, 44, 72, "Input"],
Cell[159638, 3388, 146, 2, 31, "Output"],
Cell[159787, 3392, 146, 2, 31, "Output"],
Cell[159936, 3396, 144, 2, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[160117, 3403, 1572, 47, 72, "Input"],
Cell[161692, 3452, 1243, 31, 86, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[162972, 3488, 4061, 116, 172, "Input"],
Cell[167036, 3606, 7396, 144, 143, "Output"],
Cell[174435, 3752, 27926, 485, 145, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[202398, 4242, 1573, 38, 52, "Input"],
Cell[203974, 4282, 4002, 85, 117, "Output"]
}, Open  ]],
Cell[207991, 4370, 444, 8, 31, "Input"],
Cell[208438, 4380, 444, 8, 31, "Input"],
Cell[CellGroupData[{
Cell[208907, 4392, 3802, 84, 112, "Input"],
Cell[212712, 4478, 18608, 402, 241, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[231357, 4885, 3031, 72, 112, "Input"],
Cell[234391, 4959, 10399, 182, 247, "Output"]
}, Open  ]],
Cell[244805, 5144, 2622, 69, 152, "Input"],
Cell[247430, 5215, 444, 8, 31, "Input"],
Cell[247877, 5225, 444, 8, 31, "Input"],
Cell[CellGroupData[{
Cell[248346, 5237, 11857, 327, 772, "Input"],
Cell[260206, 5566, 104043, 2146, 245, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[364286, 7717, 2388, 58, 112, "Input"],
Cell[366677, 7777, 132341, 2899, 140, "Output"]
}, Open  ]],
Cell[499033, 10679, 2646, 57, 92, "Input"],
Cell[CellGroupData[{
Cell[501704, 10740, 4971, 132, 252, "Input"],
Cell[506678, 10874, 230, 6, 31, "Output"],
Cell[506911, 10882, 7515, 148, 140, "Output"],
Cell[514429, 11032, 231, 6, 31, "Output"],
Cell[514663, 11040, 52343, 1117, 140, "Output"]
}, Open  ]],
Cell[567021, 12160, 444, 8, 31, "Input"],
Cell[CellGroupData[{
Cell[567490, 12172, 5829, 137, 292, "Input"],
Cell[573322, 12311, 38913, 667, 255, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[612272, 12983, 4527, 110, 292, "Input"],
Cell[616802, 13095, 223, 5, 31, "Output"],
Cell[617028, 13102, 205647, 3467, 170, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[822712, 16574, 4387, 110, 252, "Input"],
Cell[827102, 16686, 124539, 2137, 159, "Output"]
}, Open  ]],
Cell[951656, 18826, 444, 8, 31, "Input"],
Cell[952103, 18836, 444, 8, 31, "Input"],
Cell[CellGroupData[{
Cell[952572, 18848, 2970, 87, 192, "Input"],
Cell[955545, 18937, 264, 6, 23, "Print"],
Cell[955812, 18945, 2917, 66, 140, "Output"],
Cell[958732, 19013, 454, 13, 31, "Output"],
Cell[959189, 19028, 35272, 606, 144, "Output"]
}, Open  ]],
Cell[994476, 19637, 444, 8, 31, "Input"],
Cell[CellGroupData[{
Cell[994945, 19649, 526, 13, 31, "Input"],
Cell[995474, 19664, 503944, 9180, 1146, 378025, 7115, "CachedBoxData", \
"BoxData", "Output"]
}, Open  ]],
Cell[1499433, 28847, 444, 8, 31, "Input"],
Cell[1499880, 28857, 1174, 31, 152, "Input"],
Cell[1501057, 28890, 702, 21, 52, "Input"],
Cell[CellGroupData[{
Cell[1501784, 28915, 2242, 50, 92, "Input"],
Cell[1504029, 28967, 236, 6, 31, "Output"],
Cell[1504268, 28975, 171, 4, 31, "Output"],
Cell[1504442, 28981, 234, 6, 31, "Output"]
}, Open  ]],
Cell[1504691, 28990, 444, 8, 31, "Input"],
Cell[1505138, 29000, 444, 8, 31, "Input"],
Cell[CellGroupData[{
Cell[1505607, 29012, 10543, 264, 432, "Input"],
Cell[1516153, 29278, 121, 2, 31, "Output"],
Cell[1516277, 29282, 195, 4, 31, "Output"],
Cell[CellGroupData[{
Cell[1516497, 29290, 309, 7, 23, "Print"],
Cell[1516809, 29299, 311, 7, 23, "Print"],
Cell[1517123, 29308, 309, 7, 23, "Print"]
}, Open  ]],
Cell[1517447, 29318, 113411, 2377, 278, 100999, 2172, "CachedBoxData", \
"BoxData", "Output"]
}, Open  ]],
Cell[1630873, 31698, 444, 8, 31, "Input"],
Cell[CellGroupData[{
Cell[1631342, 31710, 3182, 53, 52, "Input"],
Cell[1634527, 31765, 318574, 6236, 633, 267386, 5396, "CachedBoxData", \
"BoxData", "Output"]
}, Open  ]],
Cell[1953116, 38004, 743, 15, 72, "Input"],
Cell[1953862, 38021, 444, 8, 31, "Input"]
}
]
*)

(* End of internal cache information *)
