(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     19958,        602]
NotebookOptionsPosition[     17338,        519]
NotebookOutlinePosition[     18978,        566]
CellTagsIndexPosition[     18893,        561]
WindowTitle->GetTreeTopology - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["Genealogy",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:Genealogy/guide/Genealogy"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {Cell["GENEALOGY PACKAGE PACLET SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Genealogy Package\"\>":>
       Documentation`HelpLookup["paclet:Genealogy/guide/Genealogy"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Genealogy/ref/GetTreeTopology\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Genealogy/ref/GetTreeTopology"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Genealogy/ref/\
GetTreeTopology.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Genealogy/ref/GetTreeTopology", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell["GetTreeTopology", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"GetTreeTopology", "[", 
       RowBox[{
        StyleBox["tr", "TI"], ",", 
        StyleBox["bool", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]gets the topology of the tree ",
     StyleBox["tr", "TI"],
     ", and rules of forming internal nodes if ",
     StyleBox["bool", "TI"],
     "=True."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->10352747],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection",
 CellID->157948716],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<Genealogy`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->310500858],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GetTreeTopology", "[", 
  RowBox[{"RandomGenealogy", "[", "4", "]"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->215467811],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"1", ",", 
    RowBox[{"{", 
     RowBox[{"3", ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "4"}], "}"}]}], "}"}]}], "}"}], "}"}]], "Output",
 ImageSize->{121, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->537464951]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"tr", "=", 
   RowBox[{"RandomGenealogy", "[", "4", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"GetTreeTopology", "[", 
  RowBox[{"tr", ",", "True"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{"ShowLabeledGraph", "[", 
    RowBox[{
     RowBox[{"ResetTreeX", "[", "tr", "]"}], ",", 
     RowBox[{"VertexColor", "\[Rule]", "Red"}], ",", 
     RowBox[{"EdgeColor", "\[Rule]", "Blue"}]}], "]"}], ",", 
   RowBox[{"TreeForm", "[", 
    RowBox[{"First", "[", "%", "]"}], "]"}]}], "}"}]}], "Input",
 CellLabel->"In[3]:=",
 CellID->75931789],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"2", ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "4"}], "}"}]}], "}"}]}], "}"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "4"}], "}"}], "\[Rule]", "5"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"3", ",", "5"}], "}"}], "\[Rule]", "6"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"2", ",", "6"}], "}"}], "\[Rule]", "7"}]}], "}"}]}], 
  "}"}]], "Output",
 ImageSize->{371, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->138011198],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[{{
      {RGBColor[0, 0, 1], Thickness[0.005], 
       ArrowBox[{{1., 0.}, {0.875, 0.024328857772993047`}}], 
       {GrayLevel[0]}}, 
      {RGBColor[0, 0, 1], Thickness[0.005], 
       ArrowBox[{{0.75, 0.}, {0.875, 0.024328857772993047`}}], 
       {GrayLevel[0]}}, 
      {RGBColor[0, 0, 1], Thickness[0.005], 
       ArrowBox[{{0.875, 0.024328857772993047`}, {0.6875, 
        0.3211194156615394}}], 
       {GrayLevel[0]}}, 
      {RGBColor[0, 0, 1], Thickness[0.005], 
       ArrowBox[{{0.5, 0.}, {0.6875, 0.3211194156615394}}], 
       {GrayLevel[0]}}, 
      {RGBColor[0, 0, 1], Thickness[0.005], 
       ArrowBox[{{0.6875, 0.3211194156615394}, {0.46875, 
        0.4677101287764174}}], 
       {GrayLevel[0]}}, 
      {RGBColor[0, 0, 1], Thickness[0.005], 
       ArrowBox[{{0.25, 0.}, {0.46875, 0.4677101287764174}}], 
       {GrayLevel[0]}}}, {
      {RGBColor[1, 0, 0], 
       {PointSize[0.025], PointBox[{0.75, 0.}]}, 
       {GrayLevel[0], 
        InsetBox["1", Scaled[{-0.02, -0.02}, {0.75, 0.}], {1, 0}]}, 
       {GrayLevel[0]}}, 
      {RGBColor[1, 0, 0], 
       {PointSize[0.025], PointBox[{0.25, 0.}]}, 
       {GrayLevel[0], 
        InsetBox["2", Scaled[{-0.02, -0.02}, {0.25, 0.}], {1, 0}]}, 
       {GrayLevel[0]}}, 
      {RGBColor[1, 0, 0], 
       {PointSize[0.025], PointBox[{0.5, 0.}]}, 
       {GrayLevel[0], 
        InsetBox["3", Scaled[{-0.02, -0.02}, {0.5, 0.}], {1, 0}]}, 
       {GrayLevel[0]}}, 
      {RGBColor[1, 0, 0], 
       {PointSize[0.025], PointBox[{1., 0.}]}, 
       {GrayLevel[0], 
        InsetBox["4", Scaled[{-0.02, -0.02}, {1., 0.}], {1, 0}]}, 
       {GrayLevel[0]}}, 
      {RGBColor[1, 0, 0], 
       {PointSize[0.025], PointBox[{0.875, 0.024328857772993047`}]}, 
       {GrayLevel[0], 
        InsetBox["5", 
         Scaled[{-0.02, -0.02}, {0.875, 0.024328857772993047`}], {1, 0}]}, 
       {GrayLevel[0]}}, 
      {RGBColor[1, 0, 0], 
       {PointSize[0.025], PointBox[{0.6875, 0.3211194156615394}]}, 
       {GrayLevel[0], 
        InsetBox["6", 
         Scaled[{-0.02, -0.02}, {0.6875, 0.3211194156615394}], {1, 0}]}, 
       {GrayLevel[0]}}, 
      {RGBColor[1, 0, 0], 
       {PointSize[0.025], PointBox[{0.46875, 0.4677101287764174}]}, 
       {GrayLevel[0], 
        InsetBox["7", 
         Scaled[{-0.02, -0.02}, {0.46875, 0.4677101287764174}], {1, 0}]}, 
       {GrayLevel[0]}}}},
    AlignmentPoint->Center,
    AspectRatio->Automatic,
    Axes->False,
    AxesLabel->None,
    AxesOrigin->Automatic,
    AxesStyle->{},
    Background->None,
    BaseStyle->{},
    BaselinePosition->Automatic,
    ColorOutput->Automatic,
    ContentSelectable->Automatic,
    CoordinatesToolOptions:>Automatic,
    DisplayFunction:>$DisplayFunction,
    Epilog->{},
    FormatType:>TraditionalForm,
    Frame->False,
    FrameLabel->None,
    FrameStyle->{},
    FrameTicks->Automatic,
    FrameTicksStyle->{},
    GridLines->None,
    GridLinesStyle->{},
    ImageMargins->0.,
    ImagePadding->All,
    ImageSize->Automatic,
    ImageSizeRaw->Automatic,
    LabelStyle->{},
    Method->Automatic,
    PlotLabel->None,
    PlotRange->{{0.2, 1.05}, {-0.05, 0.5177101287764174}},
    PlotRangeClipping->False,
    PlotRangePadding->Automatic,
    PlotRegion->Automatic,
    PreserveImageOptions->Automatic,
    Prolog->{},
    RotateLabel->True,
    Ticks->Automatic,
    TicksStyle->{}], ",", 
   GraphicsBox[
    TagBox[
     GraphicsComplexBox[{{0.4537426064865151, 3.629940851892121}, {
      0.4537426064865151, 2.7224556389190906`}, {0., 1.8149704259460604`}, {
      0.9074852129730302, 1.8149704259460604`}, {0.4537426064865151, 
      0.9074852129730302}, {1.3612278194595453`, 0.9074852129730302}, {
      0.9074852129730302, 0.}, {1.8149704259460604`, 0.}}, {
       {RGBColor[0.55, 0.45, 0.45], 
        LineBox[{{1, 2}, {2, 3}, {2, 4}, {4, 5}, {4, 6}, {6, 7}, {6, 8}}]}, {
        TagBox[
         TooltipBox[InsetBox[
           FrameBox[
            StyleBox["List", "StandardForm", "Output",
             StripOnInput->False,
             FrontFaceColor->GrayLevel[0],
             BackFaceColor->GrayLevel[0],
             GraphicsColor->GrayLevel[0],
             FontSize->Scaled[0.05],
             FontColor->GrayLevel[0]],
            Background->RGBColor[1., 1., 0.871],
            FrameStyle->GrayLevel[0.5],
            StripOnInput->False], 1],
          TagBox[
           RowBox[{"{", 
             RowBox[{"{", 
               RowBox[{"2", ",", 
                 RowBox[{"{", 
                   RowBox[{"3", ",", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "4"}], "}"}]}], "}"}]}], "}"}], "}"}], 
           HoldForm]],
         Annotation[#, 
          HoldForm[{{2, {3, {1, 4}}}}], "Tooltip"]& ], 
        TagBox[
         TooltipBox[InsetBox[
           FrameBox[
            StyleBox["List", "StandardForm", "Output",
             StripOnInput->False,
             FrontFaceColor->GrayLevel[0],
             BackFaceColor->GrayLevel[0],
             GraphicsColor->GrayLevel[0],
             FontSize->Scaled[0.05],
             FontColor->GrayLevel[0]],
            Background->RGBColor[1., 1., 0.871],
            FrameStyle->GrayLevel[0.5],
            StripOnInput->False], 2],
          TagBox[
           RowBox[{"{", 
             RowBox[{"2", ",", 
               RowBox[{"{", 
                 RowBox[{"3", ",", 
                   RowBox[{"{", 
                    RowBox[{"1", ",", "4"}], "}"}]}], "}"}]}], "}"}], 
           HoldForm]],
         Annotation[#, 
          HoldForm[{2, {3, {1, 4}}}], "Tooltip"]& ], 
        TagBox[
         TooltipBox[InsetBox[
           FrameBox[
            StyleBox[
             TagBox["2",
              HoldForm], "StandardForm", "Output",
             StripOnInput->False,
             FrontFaceColor->GrayLevel[0],
             BackFaceColor->GrayLevel[0],
             GraphicsColor->GrayLevel[0],
             FontSize->Scaled[0.05],
             FontColor->GrayLevel[0]],
            Background->RGBColor[1., 1., 0.871],
            FrameStyle->GrayLevel[0.5],
            StripOnInput->False], 3],
          TagBox["2", HoldForm]],
         Annotation[#, 
          HoldForm[2], "Tooltip"]& ], 
        TagBox[
         TooltipBox[InsetBox[
           FrameBox[
            StyleBox["List", "StandardForm", "Output",
             StripOnInput->False,
             FrontFaceColor->GrayLevel[0],
             BackFaceColor->GrayLevel[0],
             GraphicsColor->GrayLevel[0],
             FontSize->Scaled[0.05],
             FontColor->GrayLevel[0]],
            Background->RGBColor[1., 1., 0.871],
            FrameStyle->GrayLevel[0.5],
            StripOnInput->False], 4],
          TagBox[
           RowBox[{"{", 
             RowBox[{"3", ",", 
               RowBox[{"{", 
                 RowBox[{"1", ",", "4"}], "}"}]}], "}"}], HoldForm]],
         Annotation[#, 
          HoldForm[{3, {1, 4}}], "Tooltip"]& ], 
        TagBox[
         TooltipBox[InsetBox[
           FrameBox[
            StyleBox[
             TagBox["3",
              HoldForm], "StandardForm", "Output",
             StripOnInput->False,
             FrontFaceColor->GrayLevel[0],
             BackFaceColor->GrayLevel[0],
             GraphicsColor->GrayLevel[0],
             FontSize->Scaled[0.05],
             FontColor->GrayLevel[0]],
            Background->RGBColor[1., 1., 0.871],
            FrameStyle->GrayLevel[0.5],
            StripOnInput->False], 5],
          TagBox["3", HoldForm]],
         Annotation[#, 
          HoldForm[3], "Tooltip"]& ], 
        TagBox[
         TooltipBox[InsetBox[
           FrameBox[
            StyleBox["List", "StandardForm", "Output",
             StripOnInput->False,
             FrontFaceColor->GrayLevel[0],
             BackFaceColor->GrayLevel[0],
             GraphicsColor->GrayLevel[0],
             FontSize->Scaled[0.05],
             FontColor->GrayLevel[0]],
            Background->RGBColor[1., 1., 0.871],
            FrameStyle->GrayLevel[0.5],
            StripOnInput->False], 6],
          TagBox[
           RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], HoldForm]],
         Annotation[#, 
          HoldForm[{1, 4}], "Tooltip"]& ], 
        TagBox[
         TooltipBox[InsetBox[
           FrameBox[
            StyleBox[
             TagBox["1",
              HoldForm], "StandardForm", "Output",
             StripOnInput->False,
             FrontFaceColor->GrayLevel[0],
             BackFaceColor->GrayLevel[0],
             GraphicsColor->GrayLevel[0],
             FontSize->Scaled[0.05],
             FontColor->GrayLevel[0]],
            Background->RGBColor[1., 1., 0.871],
            FrameStyle->GrayLevel[0.5],
            StripOnInput->False], 7],
          TagBox["1", HoldForm]],
         Annotation[#, 
          HoldForm[1], "Tooltip"]& ], 
        TagBox[
         TooltipBox[InsetBox[
           FrameBox[
            StyleBox[
             TagBox["4",
              HoldForm], "StandardForm", "Output",
             StripOnInput->False,
             FrontFaceColor->GrayLevel[0],
             BackFaceColor->GrayLevel[0],
             GraphicsColor->GrayLevel[0],
             FontSize->Scaled[0.05],
             FontColor->GrayLevel[0]],
            Background->RGBColor[1., 1., 0.871],
            FrameStyle->GrayLevel[0.5],
            StripOnInput->False], 8],
          TagBox["4", HoldForm]],
         Annotation[#, 
          HoldForm[4], "Tooltip"]& ]}}],
     Annotation[#, 
      VertexCoordinateRules -> {{0.4537426064865151, 3.629940851892121}, {
       0.4537426064865151, 2.7224556389190906`}, {0., 1.8149704259460604`}, {
       0.9074852129730302, 1.8149704259460604`}, {0.4537426064865151, 
       0.9074852129730302}, {1.3612278194595453`, 0.9074852129730302}, {
       0.9074852129730302, 0.}, {1.8149704259460604`, 0.}}]& ],
    AspectRatio->NCache[2^Rational[1, 2], 1.4142135623730951`],
    FrameTicks->Automatic,
    PlotRange->All,
    PlotRangePadding->Scaled[0.1]]}], "}"}]], "Output",
 ImageSize->{362, 218},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->656877441]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 CellID->38303248],

Cell[TextData[ButtonBox["Genealogy Package",
 BaseStyle->"Link",
 ButtonData->"paclet:Genealogy/guide/Genealogy"]], "MoreAbout",
 CellID->1665078683]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 730},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"GetTreeTopology - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2013, 7, 27, 22, 7, 1.0847640}", "context" -> "Genealogy`", 
    "keywords" -> {}, "index" -> True, "label" -> 
    "Genealogy Package Paclet Symbol", "language" -> "en", "paclet" -> 
    "Genealogy Package", "status" -> "None", "summary" -> 
    "GetTreeTopology[tr, bool] gets the topology of the tree tr, and rules of \
forming internal nodes if bool=True.", "synonyms" -> {}, "title" -> 
    "GetTreeTopology", "type" -> "Symbol", "uri" -> 
    "Genealogy/ref/GetTreeTopology"}, "LinkTrails" -> "", 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "9.0 for Microsoft Windows (64-bit) (January 25, 2013)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[3861, 110, 460, 13, 70, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->10352747]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 18751, 554}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[608, 21, 76, 1, 70, "SymbolColorBar"],
Cell[687, 24, 182, 5, 70, "LinkTrail"],
Cell[872, 31, 2347, 53, 70, "AnchorBarGrid",
 CellID->1],
Cell[3222, 86, 58, 1, 70, "ObjectName",
 CellID->1224892054],
Cell[3283, 89, 553, 17, 70, "Usage"],
Cell[CellGroupData[{
Cell[3861, 110, 460, 13, 70, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->10352747],
Cell[CellGroupData[{
Cell[4346, 127, 148, 5, 70, "ExampleSection",
 CellID->157948716],
Cell[4497, 134, 118, 3, 70, "Input",
 CellID->310500858],
Cell[CellGroupData[{
Cell[4640, 141, 153, 4, 70, "Input",
 CellID->215467811],
Cell[4796, 147, 334, 12, 36, "Output",
 CellID->537464951]
}, Open  ]],
Cell[CellGroupData[{
Cell[5167, 164, 601, 16, 70, "Input",
 CellID->75931789],
Cell[5771, 182, 716, 26, 36, "Output",
 CellID->138011198],
Cell[6490, 210, 10174, 280, 70, "Output",
 CellID->656877441]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[16725, 497, 419, 12, 70, "MoreAboutSection",
 CellID->38303248],
Cell[17147, 511, 149, 3, 70, "MoreAbout",
 CellID->1665078683]
}, Open  ]],
Cell[17311, 517, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

