(************** Content-type: application/mathematica **************

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     87701,       2880]*)
(*NotebookOutlinePosition[     88347,       2902]*)
(*  CellTagsIndexPosition[     88303,       2898]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[
    \(\(Export["\<LeftGuillemet.gif\>", 
        Cell["\<\[LeftGuillemet]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Hyphen.gif\>", 
        Cell["\<\[Hyphen]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightGuillemet.gif\>", 
        Cell["\<\[RightGuillemet]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalAGrave.gif\>", 
        Cell["\<\[CapitalAGrave]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalAAcute.gif\>", 
        Cell["\<\[CapitalAAcute]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalAHat.gif\>", 
        Cell["\<\[CapitalAHat]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalATilde.gif\>", 
        Cell["\<\[CapitalATilde]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalADoubleDot.gif\>", 
        Cell["\<\[CapitalADoubleDot]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalARing.gif\>", 
        Cell["\<\[CapitalARing]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalAE.gif\>", 
        Cell["\<\[CapitalAE]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalCCedilla.gif\>", 
        Cell["\<\[CapitalCCedilla]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalEGrave.gif\>", 
        Cell["\<\[CapitalEGrave]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalEAcute.gif\>", 
        Cell["\<\[CapitalEAcute]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalEHat.gif\>", 
        Cell["\<\[CapitalEHat]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalEDoubleDot.gif\>", 
        Cell["\<\[CapitalEDoubleDot]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalIGrave.gif\>", 
        Cell["\<\[CapitalIGrave]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalIAcute.gif\>", 
        Cell["\<\[CapitalIAcute]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalIHat.gif\>", 
        Cell["\<\[CapitalIHat]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalIDoubleDot.gif\>", 
        Cell["\<\[CapitalIDoubleDot]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalEth.gif\>", 
        Cell["\<\[CapitalEth]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalNTilde.gif\>", 
        Cell["\<\[CapitalNTilde]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalOGrave.gif\>", 
        Cell["\<\[CapitalOGrave]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalOAcute.gif\>", 
        Cell["\<\[CapitalOAcute]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalOHat.gif\>", 
        Cell["\<\[CapitalOHat]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalOTilde.gif\>", 
        Cell["\<\[CapitalOTilde]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalODoubleDot.gif\>", 
        Cell["\<\[CapitalODoubleDot]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalOSlash.gif\>", 
        Cell["\<\[CapitalOSlash]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalUGrave.gif\>", 
        Cell["\<\[CapitalUGrave]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalUAcute.gif\>", 
        Cell["\<\[CapitalUAcute]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalUHat.gif\>", 
        Cell["\<\[CapitalUHat]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalUDoubleDot.gif\>", 
        Cell["\<\[CapitalUDoubleDot]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalYAcute.gif\>", 
        Cell["\<\[CapitalYAcute]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalThorn.gif\>", 
        Cell["\<\[CapitalThorn]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<SZ.gif\>", Cell["\<\[SZ]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<AGrave.gif\>", 
        Cell["\<\[AGrave]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<AAcute.gif\>", 
        Cell["\<\[AAcute]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<AHat.gif\>", Cell["\<\[AHat]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ATilde.gif\>", 
        Cell["\<\[ATilde]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ADoubleDot.gif\>", 
        Cell["\<\[ADoubleDot]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ARing.gif\>", 
        Cell["\<\[ARing]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<AE.gif\>", Cell["\<\[AE]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CCedilla.gif\>", 
        Cell["\<\[CCedilla]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<EGrave.gif\>", 
        Cell["\<\[EGrave]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<EAcute.gif\>", 
        Cell["\<\[EAcute]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<EHat.gif\>", Cell["\<\[EHat]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<EDoubleDot.gif\>", 
        Cell["\<\[EDoubleDot]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<IGrave.gif\>", 
        Cell["\<\[IGrave]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<IAcute.gif\>", 
        Cell["\<\[IAcute]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<IHat.gif\>", Cell["\<\[IHat]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<IDoubleDot.gif\>", 
        Cell["\<\[IDoubleDot]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Eth.gif\>", Cell["\<\[Eth]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NTilde.gif\>", 
        Cell["\<\[NTilde]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<OGrave.gif\>", 
        Cell["\<\[OGrave]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<OAcute.gif\>", 
        Cell["\<\[OAcute]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<OHat.gif\>", Cell["\<\[OHat]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<OTilde.gif\>", 
        Cell["\<\[OTilde]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ODoubleDot.gif\>", 
        Cell["\<\[ODoubleDot]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<OSlash.gif\>", 
        Cell["\<\[OSlash]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<UGrave.gif\>", 
        Cell["\<\[UGrave]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<UAcute.gif\>", 
        Cell["\<\[UAcute]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<UHat.gif\>", Cell["\<\[UHat]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<UDoubleDot.gif\>", 
        Cell["\<\[UDoubleDot]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<YAcute.gif\>", 
        Cell["\<\[YAcute]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Thorn.gif\>", 
        Cell["\<\[Thorn]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<YDoubleDot.gif\>", 
        Cell["\<\[YDoubleDot]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ABar.gif\>", Cell["\<\[ABar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalABar.gif\>", 
        Cell["\<\[CapitalABar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ACup.gif\>", Cell["\<\[ACup]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalACup.gif\>", 
        Cell["\<\[CapitalACup]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CAcute.gif\>", 
        Cell["\<\[CAcute]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalCAcute.gif\>", 
        Cell["\<\[CapitalCAcute]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CHacek.gif\>", 
        Cell["\<\[CHacek]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalCHacek.gif\>", 
        Cell["\<\[CapitalCHacek]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<EBar.gif\>", Cell["\<\[EBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalEBar.gif\>", 
        Cell["\<\[CapitalEBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ECup.gif\>", Cell["\<\[ECup]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalECup.gif\>", 
        Cell["\<\[CapitalECup]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ICup.gif\>", Cell["\<\[ICup]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalICup.gif\>", 
        Cell["\<\[CapitalICup]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LSlash.gif\>", 
        Cell["\<\[LSlash]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalLSlash.gif\>", 
        Cell["\<\[CapitalLSlash]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ODoubleAcute.gif\>", 
        Cell["\<\[ODoubleAcute]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalODoubleAcute.gif\>", 
        Cell["\<\[CapitalODoubleAcute]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<SHacek.gif\>", 
        Cell["\<\[SHacek]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalSHacek.gif\>", 
        Cell["\<\[CapitalSHacek]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<UDoubleAcute.gif\>", 
        Cell["\<\[UDoubleAcute]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalUDoubleAcute.gif\>", 
        Cell["\<\[CapitalUDoubleAcute]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Florin.gif\>", 
        Cell["\<\[Florin]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Breve.gif\>", 
        Cell["\<\[Breve]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleDot.gif\>", 
        Cell["\<\[DoubleDot]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<TripleDot.gif\>", 
        Cell["\<\[TripleDot]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Hacek.gif\>", 
        Cell["\<\[Hacek]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DownBreve.gif\>", 
        Cell["\<\[DownBreve]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Cedilla.gif\>", 
        Cell["\<\[Cedilla]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalAlpha.gif\>", 
        Cell["\<\[CapitalAlpha]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalBeta.gif\>", 
        Cell["\<\[CapitalBeta]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalGamma.gif\>", 
        Cell["\<\[CapitalGamma]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalDelta.gif\>", 
        Cell["\<\[CapitalDelta]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalEpsilon.gif\>", 
        Cell["\<\[CapitalEpsilon]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalZeta.gif\>", 
        Cell["\<\[CapitalZeta]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalEta.gif\>", 
        Cell["\<\[CapitalEta]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalTheta.gif\>", 
        Cell["\<\[CapitalTheta]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalIota.gif\>", 
        Cell["\<\[CapitalIota]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalKappa.gif\>", 
        Cell["\<\[CapitalKappa]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalLambda.gif\>", 
        Cell["\<\[CapitalLambda]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalMu.gif\>", 
        Cell["\<\[CapitalMu]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalNu.gif\>", 
        Cell["\<\[CapitalNu]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalXi.gif\>", 
        Cell["\<\[CapitalXi]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalOmicron.gif\>", 
        Cell["\<\[CapitalOmicron]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalPi.gif\>", 
        Cell["\<\[CapitalPi]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalRho.gif\>", 
        Cell["\<\[CapitalRho]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalSigma.gif\>", 
        Cell["\<\[CapitalSigma]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalTau.gif\>", 
        Cell["\<\[CapitalTau]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalUpsilon.gif\>", 
        Cell["\<\[CapitalUpsilon]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CurlyCapitalUpsilon.gif\>", 
        Cell["\<\[CurlyCapitalUpsilon]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalPhi.gif\>", 
        Cell["\<\[CapitalPhi]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalChi.gif\>", 
        Cell["\<\[CapitalChi]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalPsi.gif\>", 
        Cell["\<\[CapitalPsi]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalOmega.gif\>", 
        Cell["\<\[CapitalOmega]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalDigamma.gif\>", 
        Cell["\<\[CapitalDigamma]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalStigma.gif\>", 
        Cell["\<\[CapitalStigma]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalKoppa.gif\>", 
        Cell["\<\[CapitalKoppa]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalSampi.gif\>", 
        Cell["\<\[CapitalSampi]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Alpha.gif\>", 
        Cell["\<\[Alpha]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Beta.gif\>", Cell["\<\[Beta]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Gamma.gif\>", 
        Cell["\<\[Gamma]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Delta.gif\>", 
        Cell["\<\[Delta]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Epsilon.gif\>", 
        Cell["\<\[Epsilon]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CurlyEpsilon.gif\>", 
        Cell["\<\[CurlyEpsilon]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Zeta.gif\>", Cell["\<\[Zeta]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Eta.gif\>", Cell["\<\[Eta]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Theta.gif\>", 
        Cell["\<\[Theta]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CurlyTheta.gif\>", 
        Cell["\<\[CurlyTheta]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Iota.gif\>", Cell["\<\[Iota]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Kappa.gif\>", 
        Cell["\<\[Kappa]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CurlyKappa.gif\>", 
        Cell["\<\[CurlyKappa]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Lambda.gif\>", 
        Cell["\<\[Lambda]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Mu.gif\>", Cell["\<\[Mu]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Nu.gif\>", Cell["\<\[Nu]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Xi.gif\>", Cell["\<\[Xi]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Omicron.gif\>", 
        Cell["\<\[Omicron]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Pi.gif\>", Cell["\<\[Pi]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CurlyPi.gif\>", 
        Cell["\<\[CurlyPi]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Rho.gif\>", Cell["\<\[Rho]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CurlyRho.gif\>", 
        Cell["\<\[CurlyRho]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Sigma.gif\>", 
        Cell["\<\[Sigma]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<FinalSigma.gif\>", 
        Cell["\<\[FinalSigma]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Tau.gif\>", Cell["\<\[Tau]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Upsilon.gif\>", 
        Cell["\<\[Upsilon]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Phi.gif\>", Cell["\<\[Phi]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CurlyPhi.gif\>", 
        Cell["\<\[CurlyPhi]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Chi.gif\>", Cell["\<\[Chi]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Psi.gif\>", Cell["\<\[Psi]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Omega.gif\>", 
        Cell["\<\[Omega]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Stigma.gif\>", 
        Cell["\<\[Stigma]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Digamma.gif\>", 
        Cell["\<\[Digamma]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Koppa.gif\>", 
        Cell["\<\[Koppa]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Sampi.gif\>", 
        Cell["\<\[Sampi]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Infinity.gif\>", 
        Cell["\<\[Infinity]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ExponentialE.gif\>", 
        Cell["\<\[ExponentialE]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ImaginaryI.gif\>", 
        Cell["\<\[ImaginaryI]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ImaginaryJ.gif\>", 
        Cell["\<\[ImaginaryJ]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubledGamma.gif\>", 
        Cell["\<\[DoubledGamma]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubledPi.gif\>", 
        Cell["\<\[DoubledPi]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ConstantC.gif\>", 
        Cell["\<\[ConstantC]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptA.gif\>", 
        Cell["\<\[ScriptA]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptB.gif\>", 
        Cell["\<\[ScriptB]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptC.gif\>", 
        Cell["\<\[ScriptC]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptD.gif\>", 
        Cell["\<\[ScriptD]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptE.gif\>", 
        Cell["\<\[ScriptE]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptF.gif\>", 
        Cell["\<\[ScriptF]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptG.gif\>", 
        Cell["\<\[ScriptG]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptH.gif\>", 
        Cell["\<\[ScriptH]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptI.gif\>", 
        Cell["\<\[ScriptI]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptJ.gif\>", 
        Cell["\<\[ScriptJ]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptK.gif\>", 
        Cell["\<\[ScriptK]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptL.gif\>", 
        Cell["\<\[ScriptL]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptM.gif\>", 
        Cell["\<\[ScriptM]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptN.gif\>", 
        Cell["\<\[ScriptN]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptO.gif\>", 
        Cell["\<\[ScriptO]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptP.gif\>", 
        Cell["\<\[ScriptP]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptQ.gif\>", 
        Cell["\<\[ScriptQ]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptR.gif\>", 
        Cell["\<\[ScriptR]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptS.gif\>", 
        Cell["\<\[ScriptS]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptT.gif\>", 
        Cell["\<\[ScriptT]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptU.gif\>", 
        Cell["\<\[ScriptU]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptV.gif\>", 
        Cell["\<\[ScriptV]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptW.gif\>", 
        Cell["\<\[ScriptW]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptX.gif\>", 
        Cell["\<\[ScriptX]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptY.gif\>", 
        Cell["\<\[ScriptY]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptZ.gif\>", 
        Cell["\<\[ScriptZ]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptCapitalA.gif\>", 
        Cell["\<\[ScriptCapitalA]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptCapitalB.gif\>", 
        Cell["\<\[ScriptCapitalB]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptCapitalC.gif\>", 
        Cell["\<\[ScriptCapitalC]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptCapitalD.gif\>", 
        Cell["\<\[ScriptCapitalD]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptCapitalE.gif\>", 
        Cell["\<\[ScriptCapitalE]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptCapitalF.gif\>", 
        Cell["\<\[ScriptCapitalF]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptCapitalG.gif\>", 
        Cell["\<\[ScriptCapitalG]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptCapitalH.gif\>", 
        Cell["\<\[ScriptCapitalH]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptCapitalI.gif\>", 
        Cell["\<\[ScriptCapitalI]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptCapitalJ.gif\>", 
        Cell["\<\[ScriptCapitalJ]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptCapitalK.gif\>", 
        Cell["\<\[ScriptCapitalK]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptCapitalL.gif\>", 
        Cell["\<\[ScriptCapitalL]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptCapitalM.gif\>", 
        Cell["\<\[ScriptCapitalM]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptCapitalN.gif\>", 
        Cell["\<\[ScriptCapitalN]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptCapitalO.gif\>", 
        Cell["\<\[ScriptCapitalO]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptCapitalP.gif\>", 
        Cell["\<\[ScriptCapitalP]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptCapitalQ.gif\>", 
        Cell["\<\[ScriptCapitalQ]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptCapitalR.gif\>", 
        Cell["\<\[ScriptCapitalR]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptCapitalS.gif\>", 
        Cell["\<\[ScriptCapitalS]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptCapitalT.gif\>", 
        Cell["\<\[ScriptCapitalT]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptCapitalU.gif\>", 
        Cell["\<\[ScriptCapitalU]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptCapitalV.gif\>", 
        Cell["\<\[ScriptCapitalV]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptCapitalW.gif\>", 
        Cell["\<\[ScriptCapitalW]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptCapitalX.gif\>", 
        Cell["\<\[ScriptCapitalX]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptCapitalY.gif\>", 
        Cell["\<\[ScriptCapitalY]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptCapitalZ.gif\>", 
        Cell["\<\[ScriptCapitalZ]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicA.gif\>", 
        Cell["\<\[GothicA]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicB.gif\>", 
        Cell["\<\[GothicB]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicC.gif\>", 
        Cell["\<\[GothicC]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicD.gif\>", 
        Cell["\<\[GothicD]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicE.gif\>", 
        Cell["\<\[GothicE]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicF.gif\>", 
        Cell["\<\[GothicF]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicG.gif\>", 
        Cell["\<\[GothicG]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicH.gif\>", 
        Cell["\<\[GothicH]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicI.gif\>", 
        Cell["\<\[GothicI]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicJ.gif\>", 
        Cell["\<\[GothicJ]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicK.gif\>", 
        Cell["\<\[GothicK]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicL.gif\>", 
        Cell["\<\[GothicL]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicM.gif\>", 
        Cell["\<\[GothicM]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicN.gif\>", 
        Cell["\<\[GothicN]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicO.gif\>", 
        Cell["\<\[GothicO]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicP.gif\>", 
        Cell["\<\[GothicP]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicQ.gif\>", 
        Cell["\<\[GothicQ]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicR.gif\>", 
        Cell["\<\[GothicR]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicS.gif\>", 
        Cell["\<\[GothicS]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicT.gif\>", 
        Cell["\<\[GothicT]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicU.gif\>", 
        Cell["\<\[GothicU]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicV.gif\>", 
        Cell["\<\[GothicV]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicW.gif\>", 
        Cell["\<\[GothicW]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicX.gif\>", 
        Cell["\<\[GothicX]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicY.gif\>", 
        Cell["\<\[GothicY]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicZ.gif\>", 
        Cell["\<\[GothicZ]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicCapitalA.gif\>", 
        Cell["\<\[GothicCapitalA]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicCapitalB.gif\>", 
        Cell["\<\[GothicCapitalB]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicCapitalC.gif\>", 
        Cell["\<\[GothicCapitalC]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicCapitalD.gif\>", 
        Cell["\<\[GothicCapitalD]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicCapitalE.gif\>", 
        Cell["\<\[GothicCapitalE]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicCapitalF.gif\>", 
        Cell["\<\[GothicCapitalF]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicCapitalG.gif\>", 
        Cell["\<\[GothicCapitalG]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicCapitalH.gif\>", 
        Cell["\<\[GothicCapitalH]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicCapitalI.gif\>", 
        Cell["\<\[GothicCapitalI]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicCapitalJ.gif\>", 
        Cell["\<\[GothicCapitalJ]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicCapitalK.gif\>", 
        Cell["\<\[GothicCapitalK]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicCapitalL.gif\>", 
        Cell["\<\[GothicCapitalL]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicCapitalM.gif\>", 
        Cell["\<\[GothicCapitalM]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicCapitalN.gif\>", 
        Cell["\<\[GothicCapitalN]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicCapitalO.gif\>", 
        Cell["\<\[GothicCapitalO]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicCapitalP.gif\>", 
        Cell["\<\[GothicCapitalP]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicCapitalQ.gif\>", 
        Cell["\<\[GothicCapitalQ]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicCapitalR.gif\>", 
        Cell["\<\[GothicCapitalR]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicCapitalS.gif\>", 
        Cell["\<\[GothicCapitalS]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicCapitalT.gif\>", 
        Cell["\<\[GothicCapitalT]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicCapitalU.gif\>", 
        Cell["\<\[GothicCapitalU]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicCapitalV.gif\>", 
        Cell["\<\[GothicCapitalV]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicCapitalW.gif\>", 
        Cell["\<\[GothicCapitalW]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicCapitalX.gif\>", 
        Cell["\<\[GothicCapitalX]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicCapitalY.gif\>", 
        Cell["\<\[GothicCapitalY]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GothicCapitalZ.gif\>", 
        Cell["\<\[GothicCapitalZ]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckA.gif\>", 
        Cell["\<\[DoubleStruckA]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckB.gif\>", 
        Cell["\<\[DoubleStruckB]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckC.gif\>", 
        Cell["\<\[DoubleStruckC]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckD.gif\>", 
        Cell["\<\[DoubleStruckD]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckE.gif\>", 
        Cell["\<\[DoubleStruckE]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckF.gif\>", 
        Cell["\<\[DoubleStruckF]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckG.gif\>", 
        Cell["\<\[DoubleStruckG]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckH.gif\>", 
        Cell["\<\[DoubleStruckH]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckI.gif\>", 
        Cell["\<\[DoubleStruckI]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckJ.gif\>", 
        Cell["\<\[DoubleStruckJ]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckK.gif\>", 
        Cell["\<\[DoubleStruckK]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckL.gif\>", 
        Cell["\<\[DoubleStruckL]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckM.gif\>", 
        Cell["\<\[DoubleStruckM]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckN.gif\>", 
        Cell["\<\[DoubleStruckN]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckO.gif\>", 
        Cell["\<\[DoubleStruckO]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckP.gif\>", 
        Cell["\<\[DoubleStruckP]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckQ.gif\>", 
        Cell["\<\[DoubleStruckQ]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckR.gif\>", 
        Cell["\<\[DoubleStruckR]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckS.gif\>", 
        Cell["\<\[DoubleStruckS]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckT.gif\>", 
        Cell["\<\[DoubleStruckT]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckU.gif\>", 
        Cell["\<\[DoubleStruckU]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckV.gif\>", 
        Cell["\<\[DoubleStruckV]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckW.gif\>", 
        Cell["\<\[DoubleStruckW]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckX.gif\>", 
        Cell["\<\[DoubleStruckX]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckY.gif\>", 
        Cell["\<\[DoubleStruckY]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckZ.gif\>", 
        Cell["\<\[DoubleStruckZ]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckCapitalA.gif\>", 
        Cell["\<\[DoubleStruckCapitalA]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckCapitalB.gif\>", 
        Cell["\<\[DoubleStruckCapitalB]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckCapitalC.gif\>", 
        Cell["\<\[DoubleStruckCapitalC]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckCapitalD.gif\>", 
        Cell["\<\[DoubleStruckCapitalD]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckCapitalE.gif\>", 
        Cell["\<\[DoubleStruckCapitalE]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckCapitalF.gif\>", 
        Cell["\<\[DoubleStruckCapitalF]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckCapitalG.gif\>", 
        Cell["\<\[DoubleStruckCapitalG]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckCapitalH.gif\>", 
        Cell["\<\[DoubleStruckCapitalH]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckCapitalI.gif\>", 
        Cell["\<\[DoubleStruckCapitalI]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckCapitalJ.gif\>", 
        Cell["\<\[DoubleStruckCapitalJ]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckCapitalK.gif\>", 
        Cell["\<\[DoubleStruckCapitalK]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckCapitalL.gif\>", 
        Cell["\<\[DoubleStruckCapitalL]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckCapitalM.gif\>", 
        Cell["\<\[DoubleStruckCapitalM]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckCapitalN.gif\>", 
        Cell["\<\[DoubleStruckCapitalN]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckCapitalO.gif\>", 
        Cell["\<\[DoubleStruckCapitalO]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckCapitalP.gif\>", 
        Cell["\<\[DoubleStruckCapitalP]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckCapitalQ.gif\>", 
        Cell["\<\[DoubleStruckCapitalQ]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckCapitalR.gif\>", 
        Cell["\<\[DoubleStruckCapitalR]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckCapitalS.gif\>", 
        Cell["\<\[DoubleStruckCapitalS]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckCapitalT.gif\>", 
        Cell["\<\[DoubleStruckCapitalT]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckCapitalU.gif\>", 
        Cell["\<\[DoubleStruckCapitalU]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckCapitalV.gif\>", 
        Cell["\<\[DoubleStruckCapitalV]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckCapitalW.gif\>", 
        Cell["\<\[DoubleStruckCapitalW]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckCapitalX.gif\>", 
        Cell["\<\[DoubleStruckCapitalX]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckCapitalY.gif\>", 
        Cell["\<\[DoubleStruckCapitalY]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleStruckCapitalZ.gif\>", 
        Cell["\<\[DoubleStruckCapitalZ]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<WeierstrassP.gif\>", 
        Cell["\<\[WeierstrassP]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Aleph.gif\>", 
        Cell["\<\[Aleph]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Bet.gif\>", Cell["\<\[Bet]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Gimel.gif\>", 
        Cell["\<\[Gimel]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Dalet.gif\>", 
        Cell["\<\[Dalet]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DownExclamation.gif\>", 
        Cell["\<\[DownExclamation]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Cent.gif\>", Cell["\<\[Cent]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Sterling.gif\>", 
        Cell["\<\[Sterling]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Currency.gif\>", 
        Cell["\<\[Currency]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Euro.gif\>", Cell["\<\[Euro]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Yen.gif\>", Cell["\<\[Yen]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Section.gif\>", 
        Cell["\<\[Section]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Copyright.gif\>", 
        Cell["\<\[Copyright]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RegisteredTrademark.gif\>", 
        Cell["\<\[RegisteredTrademark]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Trademark.gif\>", 
        Cell["\<\[Trademark]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Degree.gif\>", 
        Cell["\<\[Degree]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Micro.gif\>", 
        Cell["\<\[Micro]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Paragraph.gif\>", 
        Cell["\<\[Paragraph]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DownQuestion.gif\>", 
        Cell["\<\[DownQuestion]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<HBar.gif\>", Cell["\<\[HBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Mho.gif\>", Cell["\<\[Mho]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Angstrom.gif\>", 
        Cell["\<\[Angstrom]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<EmptySet.gif\>", 
        Cell["\<\[EmptySet]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Dash.gif\>", Cell["\<\[Dash]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LongDash.gif\>", 
        Cell["\<\[LongDash]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Dagger.gif\>", 
        Cell["\<\[Dagger]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleDagger.gif\>", 
        Cell["\<\[DoubleDagger]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Bullet.gif\>", 
        Cell["\<\[Bullet]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DotlessI.gif\>", 
        Cell["\<\[DotlessI]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DotlessJ.gif\>", 
        Cell["\<\[DotlessJ]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<FiLigature.gif\>", 
        Cell["\<\[FiLigature]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<FlLigature.gif\>", 
        Cell["\<\[FlLigature]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptDotlessI.gif\>", 
        Cell["\<\[ScriptDotlessI]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ScriptDotlessJ.gif\>", 
        Cell["\<\[ScriptDotlessJ]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Angle.gif\>", 
        Cell["\<\[Angle]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightAngle.gif\>", 
        Cell["\<\[RightAngle]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<MeasuredAngle.gif\>", 
        Cell["\<\[MeasuredAngle]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<SphericalAngle.gif\>", 
        Cell["\<\[SphericalAngle]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Diameter.gif\>", 
        Cell["\<\[Diameter]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Ellipsis.gif\>", 
        Cell["\<\[Ellipsis]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<VerticalEllipsis.gif\>", 
        Cell["\<\[VerticalEllipsis]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CenterEllipsis.gif\>", 
        Cell["\<\[CenterEllipsis]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<AscendingEllipsis.gif\>", 
        Cell["\<\[AscendingEllipsis]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DescendingEllipsis.gif\>", 
        Cell["\<\[DescendingEllipsis]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Prime.gif\>", 
        Cell["\<\[Prime]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoublePrime.gif\>", 
        Cell["\<\[DoublePrime]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ReversePrime.gif\>", 
        Cell["\<\[ReversePrime]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ReverseDoublePrime.gif\>", 
        Cell["\<\[ReverseDoublePrime]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ForAll.gif\>", 
        Cell["\<\[ForAll]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Exists.gif\>", 
        Cell["\<\[Exists]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotExists.gif\>", 
        Cell["\<\[NotExists]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Element.gif\>", 
        Cell["\<\[Element]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotElement.gif\>", 
        Cell["\<\[NotElement]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ReverseElement.gif\>", 
        Cell["\<\[ReverseElement]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotReverseElement.gif\>", 
        Cell["\<\[NotReverseElement]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Because.gif\>", 
        Cell["\<\[Because]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<SuchThat.gif\>", 
        Cell["\<\[SuchThat]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<VerticalSeparator.gif\>", 
        Cell["\<\[VerticalSeparator]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Therefore.gif\>", 
        Cell["\<\[Therefore]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Implies.gif\>", 
        Cell["\<\[Implies]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RoundImplies.gif\>", 
        Cell["\<\[RoundImplies]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Tilde.gif\>", 
        Cell["\<\[Tilde]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotTilde.gif\>", 
        Cell["\<\[NotTilde]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<EqualTilde.gif\>", 
        Cell["\<\[EqualTilde]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<TildeEqual.gif\>", 
        Cell["\<\[TildeEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotTildeEqual.gif\>", 
        Cell["\<\[NotTildeEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<TildeFullEqual.gif\>", 
        Cell["\<\[TildeFullEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<TildeTilde.gif\>", 
        Cell["\<\[TildeTilde]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotTildeTilde.gif\>", 
        Cell["\<\[NotTildeTilde]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotEqualTilde.gif\>", 
        Cell["\<\[NotEqualTilde]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotTildeFullEqual.gif\>", 
        Cell["\<\[NotTildeFullEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LessTilde.gif\>", 
        Cell["\<\[LessTilde]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GreaterTilde.gif\>", 
        Cell["\<\[GreaterTilde]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotLessTilde.gif\>", 
        Cell["\<\[NotLessTilde]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotGreaterTilde.gif\>", 
        Cell["\<\[NotGreaterTilde]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftTriangle.gif\>", 
        Cell["\<\[LeftTriangle]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightTriangle.gif\>", 
        Cell["\<\[RightTriangle]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftTriangleEqual.gif\>", 
        Cell["\<\[LeftTriangleEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightTriangleEqual.gif\>", 
        Cell["\<\[RightTriangleEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftTriangleBar.gif\>", 
        Cell["\<\[LeftTriangleBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightTriangleBar.gif\>", 
        Cell["\<\[RightTriangleBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotLeftTriangleBar.gif\>", 
        Cell["\<\[NotLeftTriangleBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotRightTriangleBar.gif\>", 
        Cell["\<\[NotRightTriangleBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotLeftTriangle.gif\>", 
        Cell["\<\[NotLeftTriangle]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotLeftTriangleEqual.gif\>", 
        Cell["\<\[NotLeftTriangleEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotRightTriangle.gif\>", 
        Cell["\<\[NotRightTriangle]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotRightTriangleEqual.gif\>", 
        Cell["\<\[NotRightTriangleEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotEqual.gif\>", 
        Cell["\<\[NotEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotLess.gif\>", 
        Cell["\<\[NotLess]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotGreater.gif\>", 
        Cell["\<\[NotGreater]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LessEqual.gif\>", 
        Cell["\<\[LessEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LessLess.gif\>", 
        Cell["\<\[LessLess]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GreaterGreater.gif\>", 
        Cell["\<\[GreaterGreater]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotLessEqual.gif\>", 
        Cell["\<\[NotLessEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GreaterEqual.gif\>", 
        Cell["\<\[GreaterEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotGreaterEqual.gif\>", 
        Cell["\<\[NotGreaterEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LessSlantEqual.gif\>", 
        Cell["\<\[LessSlantEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LessFullEqual.gif\>", 
        Cell["\<\[LessFullEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotLessLess.gif\>", 
        Cell["\<\[NotLessLess]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotNestedLessLess.gif\>", 
        Cell["\<\[NotNestedLessLess]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotLessSlantEqual.gif\>", 
        Cell["\<\[NotLessSlantEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotLessFullEqual.gif\>", 
        Cell["\<\[NotLessFullEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NestedLessLess.gif\>", 
        Cell["\<\[NestedLessLess]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NestedGreaterGreater.gif\>", 
        Cell["\<\[NestedGreaterGreater]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GreaterSlantEqual.gif\>", 
        Cell["\<\[GreaterSlantEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GreaterFullEqual.gif\>", 
        Cell["\<\[GreaterFullEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotGreaterGreater.gif\>", 
        Cell["\<\[NotGreaterGreater]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotNestedGreaterGreater.gif\>", 
        Cell["\<\[NotNestedGreaterGreater]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotGreaterSlantEqual.gif\>", 
        Cell["\<\[NotGreaterSlantEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotGreaterFullEqual.gif\>", 
        Cell["\<\[NotGreaterFullEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LessGreater.gif\>", 
        Cell["\<\[LessGreater]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GreaterLess.gif\>", 
        Cell["\<\[GreaterLess]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotLessGreater.gif\>", 
        Cell["\<\[NotLessGreater]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotGreaterLess.gif\>", 
        Cell["\<\[NotGreaterLess]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LessEqualGreater.gif\>", 
        Cell["\<\[LessEqualGreater]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GreaterEqualLess.gif\>", 
        Cell["\<\[GreaterEqualLess]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Subset.gif\>", 
        Cell["\<\[Subset]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Superset.gif\>", 
        Cell["\<\[Superset]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotSubset.gif\>", 
        Cell["\<\[NotSubset]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotSuperset.gif\>", 
        Cell["\<\[NotSuperset]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<SubsetEqual.gif\>", 
        Cell["\<\[SubsetEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<SupersetEqual.gif\>", 
        Cell["\<\[SupersetEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotSubsetEqual.gif\>", 
        Cell["\<\[NotSubsetEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotSupersetEqual.gif\>", 
        Cell["\<\[NotSupersetEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<SquareSubset.gif\>", 
        Cell["\<\[SquareSubset]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<SquareSuperset.gif\>", 
        Cell["\<\[SquareSuperset]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<SquareSubsetEqual.gif\>", 
        Cell["\<\[SquareSubsetEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<SquareSupersetEqual.gif\>", 
        Cell["\<\[SquareSupersetEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotSquareSubset.gif\>", 
        Cell["\<\[NotSquareSubset]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotSquareSuperset.gif\>", 
        Cell["\<\[NotSquareSuperset]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotSquareSubsetEqual.gif\>", 
        Cell["\<\[NotSquareSubsetEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotSquareSupersetEqual.gif\>", 
        Cell["\<\[NotSquareSupersetEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Precedes.gif\>", 
        Cell["\<\[Precedes]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Succeeds.gif\>", 
        Cell["\<\[Succeeds]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<PrecedesEqual.gif\>", 
        Cell["\<\[PrecedesEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<SucceedsEqual.gif\>", 
        Cell["\<\[SucceedsEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<PrecedesTilde.gif\>", 
        Cell["\<\[PrecedesTilde]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<SucceedsTilde.gif\>", 
        Cell["\<\[SucceedsTilde]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotPrecedes.gif\>", 
        Cell["\<\[NotPrecedes]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotSucceeds.gif\>", 
        Cell["\<\[NotSucceeds]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<PrecedesSlantEqual.gif\>", 
        Cell["\<\[PrecedesSlantEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotPrecedesEqual.gif\>", 
        Cell["\<\[NotPrecedesEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotPrecedesSlantEqual.gif\>", 
        Cell["\<\[NotPrecedesSlantEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotPrecedesTilde.gif\>", 
        Cell["\<\[NotPrecedesTilde]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<SucceedsSlantEqual.gif\>", 
        Cell["\<\[SucceedsSlantEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotSucceedsEqual.gif\>", 
        Cell["\<\[NotSucceedsEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotSucceedsSlantEqual.gif\>", 
        Cell["\<\[NotSucceedsSlantEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotSucceedsTilde.gif\>", 
        Cell["\<\[NotSucceedsTilde]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<UpTee.gif\>", 
        Cell["\<\[UpTee]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Proportional.gif\>", 
        Cell["\<\[Proportional]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Proportion.gif\>", 
        Cell["\<\[Proportion]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Congruent.gif\>", 
        Cell["\<\[Congruent]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotCongruent.gif\>", 
        Cell["\<\[NotCongruent]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CupCap.gif\>", 
        Cell["\<\[CupCap]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotCupCap.gif\>", 
        Cell["\<\[NotCupCap]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Equilibrium.gif\>", 
        Cell["\<\[Equilibrium]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ReverseEquilibrium.gif\>", 
        Cell["\<\[ReverseEquilibrium]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<UpEquilibrium.gif\>", 
        Cell["\<\[UpEquilibrium]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ReverseUpEquilibrium.gif\>", 
        Cell["\<\[ReverseUpEquilibrium]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightTee.gif\>", 
        Cell["\<\[RightTee]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftTee.gif\>", 
        Cell["\<\[LeftTee]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DownTee.gif\>", 
        Cell["\<\[DownTee]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleRightTee.gif\>", 
        Cell["\<\[DoubleRightTee]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleLeftTee.gif\>", 
        Cell["\<\[DoubleLeftTee]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<HumpEqual.gif\>", 
        Cell["\<\[HumpEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotHumpEqual.gif\>", 
        Cell["\<\[NotHumpEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<HumpDownHump.gif\>", 
        Cell["\<\[HumpDownHump]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotHumpDownHump.gif\>", 
        Cell["\<\[NotHumpDownHump]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DotEqual.gif\>", 
        Cell["\<\[DotEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Colon.gif\>", 
        Cell["\<\[Colon]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Equal.gif\>", 
        Cell["\<\[Equal]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LongEqual.gif\>", 
        Cell["\<\[LongEqual]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Sqrt.gif\>", Cell["\<\[Sqrt]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<VerticalBar.gif\>", 
        Cell["\<\[VerticalBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotVerticalBar.gif\>", 
        Cell["\<\[NotVerticalBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleVerticalBar.gif\>", 
        Cell["\<\[DoubleVerticalBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NotDoubleVerticalBar.gif\>", 
        Cell["\<\[NotDoubleVerticalBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Not.gif\>", Cell["\<\[Not]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<VerticalTilde.gif\>", 
        Cell["\<\[VerticalTilde]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Times.gif\>", 
        Cell["\<\[Times]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<PlusMinus.gif\>", 
        Cell["\<\[PlusMinus]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<MinusPlus.gif\>", 
        Cell["\<\[MinusPlus]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Divide.gif\>", 
        Cell["\<\[Divide]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CenterDot.gif\>", 
        Cell["\<\[CenterDot]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<SmallCircle.gif\>", 
        Cell["\<\[SmallCircle]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Cross.gif\>", 
        Cell["\<\[Cross]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CirclePlus.gif\>", 
        Cell["\<\[CirclePlus]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CircleMinus.gif\>", 
        Cell["\<\[CircleMinus]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CircleTimes.gif\>", 
        Cell["\<\[CircleTimes]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CircleDot.gif\>", 
        Cell["\<\[CircleDot]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Star.gif\>", Cell["\<\[Star]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Square.gif\>", 
        Cell["\<\[Square]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Diamond.gif\>", 
        Cell["\<\[Diamond]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Del.gif\>", Cell["\<\[Del]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Backslash.gif\>", 
        Cell["\<\[Backslash]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Cap.gif\>", Cell["\<\[Cap]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Cup.gif\>", Cell["\<\[Cup]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Coproduct.gif\>", 
        Cell["\<\[Coproduct]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Integral.gif\>", 
        Cell["\<\[Integral]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ContourIntegral.gif\>", 
        Cell["\<\[ContourIntegral]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleContourIntegral.gif\>", 
        Cell["\<\[DoubleContourIntegral]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CounterClockwiseContourIntegral.gif\>", 
        Cell["\<\[CounterClockwiseContourIntegral]\>", "\<Text\>"]];\)\)], \
"Input"],

Cell[BoxData[
    \(\(Export["\<ClockwiseContourIntegral.gif\>", 
        Cell["\<\[ClockwiseContourIntegral]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Sum.gif\>", Cell["\<\[Sum]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Product.gif\>", 
        Cell["\<\[Product]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Intersection.gif\>", 
        Cell["\<\[Intersection]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Union.gif\>", 
        Cell["\<\[Union]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<UnionPlus.gif\>", 
        Cell["\<\[UnionPlus]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<SquareIntersection.gif\>", 
        Cell["\<\[SquareIntersection]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<SquareUnion.gif\>", 
        Cell["\<\[SquareUnion]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Wedge.gif\>", 
        Cell["\<\[Wedge]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<And.gif\>", Cell["\<\[And]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Nand.gif\>", Cell["\<\[Nand]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Vee.gif\>", Cell["\<\[Vee]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Or.gif\>", Cell["\<\[Or]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Nor.gif\>", Cell["\<\[Nor]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Xor.gif\>", Cell["\<\[Xor]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<PartialD.gif\>", 
        Cell["\<\[PartialD]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DifferentialD.gif\>", 
        Cell["\<\[DifferentialD]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CapitalDifferentialD.gif\>", 
        Cell["\<\[CapitalDifferentialD]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightArrow.gif\>", 
        Cell["\<\[RightArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftArrow.gif\>", 
        Cell["\<\[LeftArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<UpArrow.gif\>", 
        Cell["\<\[UpArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DownArrow.gif\>", 
        Cell["\<\[DownArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftRightArrow.gif\>", 
        Cell["\<\[LeftRightArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<UpDownArrow.gif\>", 
        Cell["\<\[UpDownArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ShortRightArrow.gif\>", 
        Cell["\<\[ShortRightArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ShortLeftArrow.gif\>", 
        Cell["\<\[ShortLeftArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ShortUpArrow.gif\>", 
        Cell["\<\[ShortUpArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ShortDownArrow.gif\>", 
        Cell["\<\[ShortDownArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RuleDelayed.gif\>", 
        Cell["\<\[RuleDelayed]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Rule.gif\>", Cell["\<\[Rule]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleRightArrow.gif\>", 
        Cell["\<\[DoubleRightArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleLeftArrow.gif\>", 
        Cell["\<\[DoubleLeftArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleUpArrow.gif\>", 
        Cell["\<\[DoubleUpArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleDownArrow.gif\>", 
        Cell["\<\[DoubleDownArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleLeftRightArrow.gif\>", 
        Cell["\<\[DoubleLeftRightArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleUpDownArrow.gif\>", 
        Cell["\<\[DoubleUpDownArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightArrowBar.gif\>", 
        Cell["\<\[RightArrowBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftArrowBar.gif\>", 
        Cell["\<\[LeftArrowBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<UpArrowBar.gif\>", 
        Cell["\<\[UpArrowBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DownArrowBar.gif\>", 
        Cell["\<\[DownArrowBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightTeeArrow.gif\>", 
        Cell["\<\[RightTeeArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftTeeArrow.gif\>", 
        Cell["\<\[LeftTeeArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<UpTeeArrow.gif\>", 
        Cell["\<\[UpTeeArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DownTeeArrow.gif\>", 
        Cell["\<\[DownTeeArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<UpperLeftArrow.gif\>", 
        Cell["\<\[UpperLeftArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<UpperRightArrow.gif\>", 
        Cell["\<\[UpperRightArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LowerRightArrow.gif\>", 
        Cell["\<\[LowerRightArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LowerLeftArrow.gif\>", 
        Cell["\<\[LowerLeftArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LongRightArrow.gif\>", 
        Cell["\<\[LongRightArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LongLeftArrow.gif\>", 
        Cell["\<\[LongLeftArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleLongLeftArrow.gif\>", 
        Cell["\<\[DoubleLongLeftArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleLongRightArrow.gif\>", 
        Cell["\<\[DoubleLongRightArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LongLeftRightArrow.gif\>", 
        Cell["\<\[LongLeftRightArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DoubleLongLeftRightArrow.gif\>", 
        Cell["\<\[DoubleLongLeftRightArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightArrowLeftArrow.gif\>", 
        Cell["\<\[RightArrowLeftArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftArrowRightArrow.gif\>", 
        Cell["\<\[LeftArrowRightArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<UpArrowDownArrow.gif\>", 
        Cell["\<\[UpArrowDownArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DownArrowUpArrow.gif\>", 
        Cell["\<\[DownArrowUpArrow]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightVector.gif\>", 
        Cell["\<\[RightVector]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DownRightVector.gif\>", 
        Cell["\<\[DownRightVector]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftVector.gif\>", 
        Cell["\<\[LeftVector]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DownLeftVector.gif\>", 
        Cell["\<\[DownLeftVector]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightUpVector.gif\>", 
        Cell["\<\[RightUpVector]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftUpVector.gif\>", 
        Cell["\<\[LeftUpVector]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightDownVector.gif\>", 
        Cell["\<\[RightDownVector]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftDownVector.gif\>", 
        Cell["\<\[LeftDownVector]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftRightVector.gif\>", 
        Cell["\<\[LeftRightVector]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DownLeftRightVector.gif\>", 
        Cell["\<\[DownLeftRightVector]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightUpDownVector.gif\>", 
        Cell["\<\[RightUpDownVector]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftUpDownVector.gif\>", 
        Cell["\<\[LeftUpDownVector]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightVectorBar.gif\>", 
        Cell["\<\[RightVectorBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DownRightVectorBar.gif\>", 
        Cell["\<\[DownRightVectorBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftVectorBar.gif\>", 
        Cell["\<\[LeftVectorBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DownLeftVectorBar.gif\>", 
        Cell["\<\[DownLeftVectorBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightUpVectorBar.gif\>", 
        Cell["\<\[RightUpVectorBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftUpVectorBar.gif\>", 
        Cell["\<\[LeftUpVectorBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightDownVectorBar.gif\>", 
        Cell["\<\[RightDownVectorBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftDownVectorBar.gif\>", 
        Cell["\<\[LeftDownVectorBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightTeeVector.gif\>", 
        Cell["\<\[RightTeeVector]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DownRightTeeVector.gif\>", 
        Cell["\<\[DownRightTeeVector]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftTeeVector.gif\>", 
        Cell["\<\[LeftTeeVector]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DownLeftTeeVector.gif\>", 
        Cell["\<\[DownLeftTeeVector]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightUpTeeVector.gif\>", 
        Cell["\<\[RightUpTeeVector]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftUpTeeVector.gif\>", 
        Cell["\<\[LeftUpTeeVector]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightDownTeeVector.gif\>", 
        Cell["\<\[RightDownTeeVector]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftDownTeeVector.gif\>", 
        Cell["\<\[LeftDownTeeVector]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftDoubleBracket.gif\>", 
        Cell["\<\[LeftDoubleBracket]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightDoubleBracket.gif\>", 
        Cell["\<\[RightDoubleBracket]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftAngleBracket.gif\>", 
        Cell["\<\[LeftAngleBracket]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightAngleBracket.gif\>", 
        Cell["\<\[RightAngleBracket]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftFloor.gif\>", 
        Cell["\<\[LeftFloor]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightFloor.gif\>", 
        Cell["\<\[RightFloor]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftCeiling.gif\>", 
        Cell["\<\[LeftCeiling]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightCeiling.gif\>", 
        Cell["\<\[RightCeiling]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftBracketingBar.gif\>", 
        Cell["\<\[LeftBracketingBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightBracketingBar.gif\>", 
        Cell["\<\[RightBracketingBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftDoubleBracketingBar.gif\>", 
        Cell["\<\[LeftDoubleBracketingBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightDoubleBracketingBar.gif\>", 
        Cell["\<\[RightDoubleBracketingBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DottedSquare.gif\>", 
        Cell["\<\[DottedSquare]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<EmptySmallCircle.gif\>", 
        Cell["\<\[EmptySmallCircle]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<FilledSmallCircle.gif\>", 
        Cell["\<\[FilledSmallCircle]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<EmptyCircle.gif\>", 
        Cell["\<\[EmptyCircle]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<FilledCircle.gif\>", 
        Cell["\<\[FilledCircle]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<EmptyDiamond.gif\>", 
        Cell["\<\[EmptyDiamond]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<FilledDiamond.gif\>", 
        Cell["\<\[FilledDiamond]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<EmptyRectangle.gif\>", 
        Cell["\<\[EmptyRectangle]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<FilledRectangle.gif\>", 
        Cell["\<\[FilledRectangle]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<EmptySquare.gif\>", 
        Cell["\<\[EmptySquare]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<EmptySmallSquare.gif\>", 
        Cell["\<\[EmptySmallSquare]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<EmptyVerySmallSquare.gif\>", 
        Cell["\<\[EmptyVerySmallSquare]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<FilledSquare.gif\>", 
        Cell["\<\[FilledSquare]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<FilledSmallSquare.gif\>", 
        Cell["\<\[FilledSmallSquare]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<FilledVerySmallSquare.gif\>", 
        Cell["\<\[FilledVerySmallSquare]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<EmptyUpTriangle.gif\>", 
        Cell["\<\[EmptyUpTriangle]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<FilledUpTriangle.gif\>", 
        Cell["\<\[FilledUpTriangle]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<EmptyDownTriangle.gif\>", 
        Cell["\<\[EmptyDownTriangle]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<FilledDownTriangle.gif\>", 
        Cell["\<\[FilledDownTriangle]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<FivePointedStar.gif\>", 
        Cell["\<\[FivePointedStar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<SixPointedStar.gif\>", 
        Cell["\<\[SixPointedStar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GraySquare.gif\>", 
        Cell["\<\[GraySquare]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<GrayCircle.gif\>", 
        Cell["\<\[GrayCircle]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<WatchIcon.gif\>", 
        Cell["\<\[WatchIcon]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<KernelIcon.gif\>", 
        Cell["\<\[KernelIcon]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<MathematicaIcon.gif\>", 
        Cell["\<\[MathematicaIcon]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Flat.gif\>", Cell["\<\[Flat]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Natural.gif\>", 
        Cell["\<\[Natural]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Sharp.gif\>", 
        Cell["\<\[Sharp]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<SpadeSuit.gif\>", 
        Cell["\<\[SpadeSuit]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<HeartSuit.gif\>", 
        Cell["\<\[HeartSuit]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DiamondSuit.gif\>", 
        Cell["\<\[DiamondSuit]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ClubSuit.gif\>", 
        Cell["\<\[ClubSuit]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Wolf.gif\>", Cell["\<\[Wolf]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Villa.gif\>", 
        Cell["\<\[Villa]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Akuz.gif\>", Cell["\<\[Akuz]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Andy.gif\>", Cell["\<\[Andy]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Spooky.gif\>", 
        Cell["\<\[Spooky]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<HappySmiley.gif\>", 
        Cell["\<\[HappySmiley]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<SadSmiley.gif\>", 
        Cell["\<\[SadSmiley]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<FreakedSmiley.gif\>", 
        Cell["\<\[FreakedSmiley]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NeutralSmiley.gif\>", 
        Cell["\<\[NeutralSmiley]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LightBulb.gif\>", 
        Cell["\<\[LightBulb]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NumberSign.gif\>", 
        Cell["\<\[NumberSign]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<WarningSign.gif\>", 
        Cell["\<\[WarningSign]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<UnknownGlyph.gif\>", 
        Cell["\<\[UnknownGlyph]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<InvisibleSpace.gif\>", 
        Cell["\<\[InvisibleSpace]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<VeryThinSpace.gif\>", 
        Cell["\<\[VeryThinSpace]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ThinSpace.gif\>", 
        Cell["\<\[ThinSpace]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<MediumSpace.gif\>", 
        Cell["\<\[MediumSpace]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ThickSpace.gif\>", 
        Cell["\<\[ThickSpace]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NegativeVeryThinSpace.gif\>", 
        Cell["\<\[NegativeVeryThinSpace]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NegativeThinSpace.gif\>", 
        Cell["\<\[NegativeThinSpace]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NegativeMediumSpace.gif\>", 
        Cell["\<\[NegativeMediumSpace]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NegativeThickSpace.gif\>", 
        Cell["\<\[NegativeThickSpace]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<OpenCurlyQuote.gif\>", 
        Cell["\<\[OpenCurlyQuote]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CloseCurlyQuote.gif\>", 
        Cell["\<\[CloseCurlyQuote]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<OpenCurlyDoubleQuote.gif\>", 
        Cell["\<\[OpenCurlyDoubleQuote]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CloseCurlyDoubleQuote.gif\>", 
        Cell["\<\[CloseCurlyDoubleQuote]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<OverParenthesis.gif\>", 
        Cell["\<\[OverParenthesis]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<UnderParenthesis.gif\>", 
        Cell["\<\[UnderParenthesis]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<OverBrace.gif\>", 
        Cell["\<\[OverBrace]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<UnderBrace.gif\>", 
        Cell["\<\[UnderBrace]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<OverBracket.gif\>", 
        Cell["\<\[OverBracket]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<UnderBracket.gif\>", 
        Cell["\<\[UnderBracket]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<NonBreakingSpace.gif\>", 
        Cell["\<\[NonBreakingSpace]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Continuation.gif\>", 
        Cell["\<\[Continuation]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<SpaceIndicator.gif\>", 
        Cell["\<\[SpaceIndicator]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RoundSpaceIndicator.gif\>", 
        Cell["\<\[RoundSpaceIndicator]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CommandKey.gif\>", 
        Cell["\<\[CommandKey]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftModified.gif\>", 
        Cell["\<\[LeftModified]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightModified.gif\>", 
        Cell["\<\[RightModified]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<InvisibleApplication.gif\>", 
        Cell["\<\[InvisibleApplication]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<CloverLeaf.gif\>", 
        Cell["\<\[CloverLeaf]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ControlKey.gif\>", 
        Cell["\<\[ControlKey]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<EscapeKey.gif\>", 
        Cell["\<\[EscapeKey]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<TabKey.gif\>", 
        Cell["\<\[TabKey]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<SpaceKey.gif\>", 
        Cell["\<\[SpaceKey]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<DeleteKey.gif\>", 
        Cell["\<\[DeleteKey]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<AltKey.gif\>", 
        Cell["\<\[AltKey]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<OptionKey.gif\>", 
        Cell["\<\[OptionKey]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<KeyBar.gif\>", 
        Cell["\<\[KeyBar]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<EnterKey.gif\>", 
        Cell["\<\[EnterKey]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ShiftKey.gif\>", 
        Cell["\<\[ShiftKey]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Mod1Key.gif\>", 
        Cell["\<\[Mod1Key]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Mod2Key.gif\>", 
        Cell["\<\[Mod2Key]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<AliasDelimiter.gif\>", 
        Cell["\<\[AliasDelimiter]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<AliasIndicator.gif\>", 
        Cell["\<\[AliasIndicator]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ReturnIndicator.gif\>", 
        Cell["\<\[ReturnIndicator]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<VerticalLine.gif\>", 
        Cell["\<\[VerticalLine]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<InvisibleComma.gif\>", 
        Cell["\<\[InvisibleComma]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ReturnKey.gif\>", 
        Cell["\<\[ReturnKey]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<SelectionPlaceholder.gif\>", 
        Cell["\<\[SelectionPlaceholder]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<Placeholder.gif\>", 
        Cell["\<\[Placeholder]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<AlignmentMarker.gif\>", 
        Cell["\<\[AlignmentMarker]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<SkeletonIndicator.gif\>", 
        Cell["\<\[SkeletonIndicator]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<LeftSkeleton.gif\>", 
        Cell["\<\[LeftSkeleton]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<RightSkeleton.gif\>", 
        Cell["\<\[RightSkeleton]\>", "\<Text\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Export["\<ErrorIndicator.gif\>", 
        Cell["\<\[ErrorIndicator]\>", "\<Text\>"]];\)\)], "Input"]
},
FrontEndVersion->"4.1 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 695}},
WindowSize->{496, 537},
WindowMargins->{{260, Automatic}, {Automatic, 65}}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1705, 50, 120, 2, 30, "Input"],
Cell[1828, 54, 106, 2, 30, "Input"],
Cell[1937, 58, 122, 2, 30, "Input"],
Cell[2062, 62, 120, 2, 31, "Input"],
Cell[2185, 66, 120, 2, 31, "Input"],
Cell[2308, 70, 116, 2, 31, "Input"],
Cell[2427, 74, 120, 2, 31, "Input"],
Cell[2550, 78, 128, 2, 30, "Input"],
Cell[2681, 82, 118, 2, 31, "Input"],
Cell[2802, 86, 112, 2, 30, "Input"],
Cell[2917, 90, 124, 2, 30, "Input"],
Cell[3044, 94, 120, 2, 31, "Input"],
Cell[3167, 98, 120, 2, 31, "Input"],
Cell[3290, 102, 116, 2, 31, "Input"],
Cell[3409, 106, 128, 2, 30, "Input"],
Cell[3540, 110, 120, 2, 31, "Input"],
Cell[3663, 114, 120, 2, 31, "Input"],
Cell[3786, 118, 116, 2, 31, "Input"],
Cell[3905, 122, 128, 2, 30, "Input"],
Cell[4036, 126, 114, 2, 30, "Input"],
Cell[4153, 130, 120, 2, 31, "Input"],
Cell[4276, 134, 120, 2, 31, "Input"],
Cell[4399, 138, 120, 2, 31, "Input"],
Cell[4522, 142, 116, 2, 31, "Input"],
Cell[4641, 146, 120, 2, 31, "Input"],
Cell[4764, 150, 128, 2, 30, "Input"],
Cell[4895, 154, 120, 2, 30, "Input"],
Cell[5018, 158, 120, 2, 31, "Input"],
Cell[5141, 162, 120, 2, 31, "Input"],
Cell[5264, 166, 116, 2, 31, "Input"],
Cell[5383, 170, 128, 2, 30, "Input"],
Cell[5514, 174, 120, 2, 31, "Input"],
Cell[5637, 178, 118, 2, 30, "Input"],
Cell[5758, 182, 89, 1, 30, "Input"],
Cell[5850, 185, 106, 2, 30, "Input"],
Cell[5959, 189, 106, 2, 30, "Input"],
Cell[6068, 193, 93, 1, 30, "Input"],
Cell[6164, 196, 106, 2, 30, "Input"],
Cell[6273, 200, 114, 2, 30, "Input"],
Cell[6390, 204, 104, 2, 30, "Input"],
Cell[6497, 208, 89, 1, 30, "Input"],
Cell[6589, 211, 110, 2, 30, "Input"],
Cell[6702, 215, 106, 2, 30, "Input"],
Cell[6811, 219, 106, 2, 30, "Input"],
Cell[6920, 223, 93, 1, 30, "Input"],
Cell[7016, 226, 114, 2, 30, "Input"],
Cell[7133, 230, 106, 2, 30, "Input"],
Cell[7242, 234, 106, 2, 30, "Input"],
Cell[7351, 238, 93, 1, 30, "Input"],
Cell[7447, 241, 114, 2, 30, "Input"],
Cell[7564, 245, 91, 1, 30, "Input"],
Cell[7658, 248, 106, 2, 30, "Input"],
Cell[7767, 252, 106, 2, 30, "Input"],
Cell[7876, 256, 106, 2, 30, "Input"],
Cell[7985, 260, 93, 1, 30, "Input"],
Cell[8081, 263, 106, 2, 30, "Input"],
Cell[8190, 267, 114, 2, 30, "Input"],
Cell[8307, 271, 106, 2, 30, "Input"],
Cell[8416, 275, 106, 2, 30, "Input"],
Cell[8525, 279, 106, 2, 30, "Input"],
Cell[8634, 283, 93, 1, 30, "Input"],
Cell[8730, 286, 114, 2, 30, "Input"],
Cell[8847, 290, 106, 2, 30, "Input"],
Cell[8956, 294, 104, 2, 30, "Input"],
Cell[9063, 298, 114, 2, 30, "Input"],
Cell[9180, 302, 93, 1, 30, "Input"],
Cell[9276, 305, 116, 2, 30, "Input"],
Cell[9395, 309, 93, 1, 30, "Input"],
Cell[9491, 312, 116, 2, 30, "Input"],
Cell[9610, 316, 106, 2, 30, "Input"],
Cell[9719, 320, 120, 2, 30, "Input"],
Cell[9842, 324, 106, 2, 30, "Input"],
Cell[9951, 328, 120, 2, 30, "Input"],
Cell[10074, 332, 93, 1, 30, "Input"],
Cell[10170, 335, 116, 2, 30, "Input"],
Cell[10289, 339, 93, 1, 30, "Input"],
Cell[10385, 342, 116, 2, 30, "Input"],
Cell[10504, 346, 93, 1, 30, "Input"],
Cell[10600, 349, 116, 2, 30, "Input"],
Cell[10719, 353, 106, 2, 30, "Input"],
Cell[10828, 357, 120, 2, 30, "Input"],
Cell[10951, 361, 118, 2, 30, "Input"],
Cell[11072, 365, 132, 2, 30, "Input"],
Cell[11207, 369, 106, 2, 30, "Input"],
Cell[11316, 373, 120, 2, 31, "Input"],
Cell[11439, 377, 118, 2, 30, "Input"],
Cell[11560, 381, 132, 2, 30, "Input"],
Cell[11695, 385, 106, 2, 30, "Input"],
Cell[11804, 389, 104, 2, 30, "Input"],
Cell[11911, 393, 112, 2, 30, "Input"],
Cell[12026, 397, 112, 2, 30, "Input"],
Cell[12141, 401, 104, 2, 30, "Input"],
Cell[12248, 405, 112, 2, 30, "Input"],
Cell[12363, 409, 108, 2, 30, "Input"],
Cell[12474, 413, 118, 2, 30, "Input"],
Cell[12595, 417, 116, 2, 30, "Input"],
Cell[12714, 421, 118, 2, 30, "Input"],
Cell[12835, 425, 118, 2, 30, "Input"],
Cell[12956, 429, 122, 2, 30, "Input"],
Cell[13081, 433, 116, 2, 30, "Input"],
Cell[13200, 437, 114, 2, 30, "Input"],
Cell[13317, 441, 118, 2, 30, "Input"],
Cell[13438, 445, 116, 2, 30, "Input"],
Cell[13557, 449, 118, 2, 30, "Input"],
Cell[13678, 453, 120, 2, 30, "Input"],
Cell[13801, 457, 112, 2, 30, "Input"],
Cell[13916, 461, 112, 2, 30, "Input"],
Cell[14031, 465, 112, 2, 30, "Input"],
Cell[14146, 469, 122, 2, 30, "Input"],
Cell[14271, 473, 112, 2, 30, "Input"],
Cell[14386, 477, 114, 2, 30, "Input"],
Cell[14503, 481, 118, 2, 30, "Input"],
Cell[14624, 485, 114, 2, 30, "Input"],
Cell[14741, 489, 122, 2, 30, "Input"],
Cell[14866, 493, 132, 2, 30, "Input"],
Cell[15001, 497, 114, 2, 30, "Input"],
Cell[15118, 501, 114, 2, 30, "Input"],
Cell[15235, 505, 114, 2, 30, "Input"],
Cell[15352, 509, 118, 2, 30, "Input"],
Cell[15473, 513, 122, 2, 30, "Input"],
Cell[15598, 517, 120, 2, 30, "Input"],
Cell[15721, 521, 118, 2, 30, "Input"],
Cell[15842, 525, 118, 2, 30, "Input"],
Cell[15963, 529, 104, 2, 30, "Input"],
Cell[16070, 533, 93, 1, 30, "Input"],
Cell[16166, 536, 104, 2, 30, "Input"],
Cell[16273, 540, 104, 2, 30, "Input"],
Cell[16380, 544, 108, 2, 30, "Input"],
Cell[16491, 548, 118, 2, 30, "Input"],
Cell[16612, 552, 93, 1, 30, "Input"],
Cell[16708, 555, 91, 1, 30, "Input"],
Cell[16802, 558, 104, 2, 30, "Input"],
Cell[16909, 562, 114, 2, 30, "Input"],
Cell[17026, 566, 93, 1, 30, "Input"],
Cell[17122, 569, 104, 2, 30, "Input"],
Cell[17229, 573, 114, 2, 30, "Input"],
Cell[17346, 577, 106, 2, 30, "Input"],
Cell[17455, 581, 89, 1, 30, "Input"],
Cell[17547, 584, 89, 1, 30, "Input"],
Cell[17639, 587, 89, 1, 30, "Input"],
Cell[17731, 590, 108, 2, 30, "Input"],
Cell[17842, 594, 89, 1, 30, "Input"],
Cell[17934, 597, 108, 2, 30, "Input"],
Cell[18045, 601, 91, 1, 30, "Input"],
Cell[18139, 604, 110, 2, 30, "Input"],
Cell[18252, 608, 104, 2, 30, "Input"],
Cell[18359, 612, 114, 2, 30, "Input"],
Cell[18476, 616, 91, 1, 30, "Input"],
Cell[18570, 619, 108, 2, 30, "Input"],
Cell[18681, 623, 91, 1, 30, "Input"],
Cell[18775, 626, 110, 2, 30, "Input"],
Cell[18888, 630, 91, 1, 30, "Input"],
Cell[18982, 633, 91, 1, 30, "Input"],
Cell[19076, 636, 104, 2, 30, "Input"],
Cell[19183, 640, 106, 2, 30, "Input"],
Cell[19292, 644, 108, 2, 30, "Input"],
Cell[19403, 648, 104, 2, 30, "Input"],
Cell[19510, 652, 104, 2, 30, "Input"],
Cell[19617, 656, 110, 2, 30, "Input"],
Cell[19730, 660, 118, 2, 30, "Input"],
Cell[19851, 664, 114, 2, 30, "Input"],
Cell[19968, 668, 114, 2, 30, "Input"],
Cell[20085, 672, 118, 2, 30, "Input"],
Cell[20206, 676, 112, 2, 30, "Input"],
Cell[20321, 680, 112, 2, 30, "Input"],
Cell[20436, 684, 108, 2, 30, "Input"],
Cell[20547, 688, 108, 2, 30, "Input"],
Cell[20658, 692, 108, 2, 30, "Input"],
Cell[20769, 696, 108, 2, 30, "Input"],
Cell[20880, 700, 108, 2, 30, "Input"],
Cell[20991, 704, 108, 2, 30, "Input"],
Cell[21102, 708, 108, 2, 30, "Input"],
Cell[21213, 712, 108, 2, 30, "Input"],
Cell[21324, 716, 108, 2, 30, "Input"],
Cell[21435, 720, 108, 2, 30, "Input"],
Cell[21546, 724, 108, 2, 30, "Input"],
Cell[21657, 728, 108, 2, 30, "Input"],
Cell[21768, 732, 108, 2, 30, "Input"],
Cell[21879, 736, 108, 2, 30, "Input"],
Cell[21990, 740, 108, 2, 30, "Input"],
Cell[22101, 744, 108, 2, 30, "Input"],
Cell[22212, 748, 108, 2, 30, "Input"],
Cell[22323, 752, 108, 2, 30, "Input"],
Cell[22434, 756, 108, 2, 30, "Input"],
Cell[22545, 760, 108, 2, 30, "Input"],
Cell[22656, 764, 108, 2, 30, "Input"],
Cell[22767, 768, 108, 2, 30, "Input"],
Cell[22878, 772, 108, 2, 30, "Input"],
Cell[22989, 776, 108, 2, 30, "Input"],
Cell[23100, 780, 108, 2, 30, "Input"],
Cell[23211, 784, 108, 2, 30, "Input"],
Cell[23322, 788, 122, 2, 30, "Input"],
Cell[23447, 792, 122, 2, 30, "Input"],
Cell[23572, 796, 122, 2, 30, "Input"],
Cell[23697, 800, 122, 2, 30, "Input"],
Cell[23822, 804, 122, 2, 30, "Input"],
Cell[23947, 808, 122, 2, 30, "Input"],
Cell[24072, 812, 122, 2, 30, "Input"],
Cell[24197, 816, 122, 2, 30, "Input"],
Cell[24322, 820, 122, 2, 30, "Input"],
Cell[24447, 824, 122, 2, 30, "Input"],
Cell[24572, 828, 122, 2, 30, "Input"],
Cell[24697, 832, 122, 2, 30, "Input"],
Cell[24822, 836, 122, 2, 30, "Input"],
Cell[24947, 840, 122, 2, 30, "Input"],
Cell[25072, 844, 122, 2, 30, "Input"],
Cell[25197, 848, 122, 2, 30, "Input"],
Cell[25322, 852, 122, 2, 30, "Input"],
Cell[25447, 856, 122, 2, 30, "Input"],
Cell[25572, 860, 122, 2, 30, "Input"],
Cell[25697, 864, 122, 2, 30, "Input"],
Cell[25822, 868, 122, 2, 30, "Input"],
Cell[25947, 872, 122, 2, 30, "Input"],
Cell[26072, 876, 122, 2, 30, "Input"],
Cell[26197, 880, 122, 2, 30, "Input"],
Cell[26322, 884, 122, 2, 30, "Input"],
Cell[26447, 888, 122, 2, 30, "Input"],
Cell[26572, 892, 108, 2, 30, "Input"],
Cell[26683, 896, 108, 2, 30, "Input"],
Cell[26794, 900, 108, 2, 30, "Input"],
Cell[26905, 904, 108, 2, 30, "Input"],
Cell[27016, 908, 108, 2, 30, "Input"],
Cell[27127, 912, 108, 2, 30, "Input"],
Cell[27238, 916, 108, 2, 30, "Input"],
Cell[27349, 920, 108, 2, 30, "Input"],
Cell[27460, 924, 108, 2, 30, "Input"],
Cell[27571, 928, 108, 2, 30, "Input"],
Cell[27682, 932, 108, 2, 30, "Input"],
Cell[27793, 936, 108, 2, 30, "Input"],
Cell[27904, 940, 108, 2, 30, "Input"],
Cell[28015, 944, 108, 2, 30, "Input"],
Cell[28126, 948, 108, 2, 30, "Input"],
Cell[28237, 952, 108, 2, 30, "Input"],
Cell[28348, 956, 108, 2, 30, "Input"],
Cell[28459, 960, 108, 2, 30, "Input"],
Cell[28570, 964, 108, 2, 30, "Input"],
Cell[28681, 968, 108, 2, 30, "Input"],
Cell[28792, 972, 108, 2, 30, "Input"],
Cell[28903, 976, 108, 2, 30, "Input"],
Cell[29014, 980, 108, 2, 30, "Input"],
Cell[29125, 984, 108, 2, 30, "Input"],
Cell[29236, 988, 108, 2, 30, "Input"],
Cell[29347, 992, 108, 2, 30, "Input"],
Cell[29458, 996, 122, 2, 30, "Input"],
Cell[29583, 1000, 122, 2, 30, "Input"],
Cell[29708, 1004, 122, 2, 30, "Input"],
Cell[29833, 1008, 122, 2, 30, "Input"],
Cell[29958, 1012, 122, 2, 30, "Input"],
Cell[30083, 1016, 122, 2, 30, "Input"],
Cell[30208, 1020, 122, 2, 30, "Input"],
Cell[30333, 1024, 122, 2, 30, "Input"],
Cell[30458, 1028, 122, 2, 30, "Input"],
Cell[30583, 1032, 122, 2, 30, "Input"],
Cell[30708, 1036, 122, 2, 30, "Input"],
Cell[30833, 1040, 122, 2, 30, "Input"],
Cell[30958, 1044, 122, 2, 30, "Input"],
Cell[31083, 1048, 122, 2, 30, "Input"],
Cell[31208, 1052, 122, 2, 30, "Input"],
Cell[31333, 1056, 122, 2, 30, "Input"],
Cell[31458, 1060, 122, 2, 30, "Input"],
Cell[31583, 1064, 122, 2, 30, "Input"],
Cell[31708, 1068, 122, 2, 30, "Input"],
Cell[31833, 1072, 122, 2, 30, "Input"],
Cell[31958, 1076, 122, 2, 30, "Input"],
Cell[32083, 1080, 122, 2, 30, "Input"],
Cell[32208, 1084, 122, 2, 30, "Input"],
Cell[32333, 1088, 122, 2, 30, "Input"],
Cell[32458, 1092, 122, 2, 30, "Input"],
Cell[32583, 1096, 122, 2, 30, "Input"],
Cell[32708, 1100, 120, 2, 30, "Input"],
Cell[32831, 1104, 120, 2, 30, "Input"],
Cell[32954, 1108, 120, 2, 30, "Input"],
Cell[33077, 1112, 120, 2, 30, "Input"],
Cell[33200, 1116, 120, 2, 30, "Input"],
Cell[33323, 1120, 120, 2, 30, "Input"],
Cell[33446, 1124, 120, 2, 30, "Input"],
Cell[33569, 1128, 120, 2, 30, "Input"],
Cell[33692, 1132, 120, 2, 30, "Input"],
Cell[33815, 1136, 120, 2, 30, "Input"],
Cell[33938, 1140, 120, 2, 30, "Input"],
Cell[34061, 1144, 120, 2, 30, "Input"],
Cell[34184, 1148, 120, 2, 30, "Input"],
Cell[34307, 1152, 120, 2, 30, "Input"],
Cell[34430, 1156, 120, 2, 30, "Input"],
Cell[34553, 1160, 120, 2, 30, "Input"],
Cell[34676, 1164, 120, 2, 30, "Input"],
Cell[34799, 1168, 120, 2, 30, "Input"],
Cell[34922, 1172, 120, 2, 30, "Input"],
Cell[35045, 1176, 120, 2, 30, "Input"],
Cell[35168, 1180, 120, 2, 30, "Input"],
Cell[35291, 1184, 120, 2, 30, "Input"],
Cell[35414, 1188, 120, 2, 30, "Input"],
Cell[35537, 1192, 120, 2, 30, "Input"],
Cell[35660, 1196, 120, 2, 30, "Input"],
Cell[35783, 1200, 120, 2, 30, "Input"],
Cell[35906, 1204, 134, 2, 30, "Input"],
Cell[36043, 1208, 134, 2, 30, "Input"],
Cell[36180, 1212, 134, 2, 30, "Input"],
Cell[36317, 1216, 134, 2, 30, "Input"],
Cell[36454, 1220, 134, 2, 30, "Input"],
Cell[36591, 1224, 134, 2, 30, "Input"],
Cell[36728, 1228, 134, 2, 30, "Input"],
Cell[36865, 1232, 134, 2, 30, "Input"],
Cell[37002, 1236, 134, 2, 30, "Input"],
Cell[37139, 1240, 134, 2, 30, "Input"],
Cell[37276, 1244, 134, 2, 30, "Input"],
Cell[37413, 1248, 134, 2, 30, "Input"],
Cell[37550, 1252, 134, 2, 30, "Input"],
Cell[37687, 1256, 134, 2, 30, "Input"],
Cell[37824, 1260, 134, 2, 30, "Input"],
Cell[37961, 1264, 134, 2, 30, "Input"],
Cell[38098, 1268, 134, 2, 30, "Input"],
Cell[38235, 1272, 134, 2, 30, "Input"],
Cell[38372, 1276, 134, 2, 30, "Input"],
Cell[38509, 1280, 134, 2, 30, "Input"],
Cell[38646, 1284, 134, 2, 30, "Input"],
Cell[38783, 1288, 134, 2, 30, "Input"],
Cell[38920, 1292, 134, 2, 30, "Input"],
Cell[39057, 1296, 134, 2, 30, "Input"],
Cell[39194, 1300, 134, 2, 30, "Input"],
Cell[39331, 1304, 134, 2, 30, "Input"],
Cell[39468, 1308, 118, 2, 30, "Input"],
Cell[39589, 1312, 104, 2, 30, "Input"],
Cell[39696, 1316, 91, 1, 30, "Input"],
Cell[39790, 1319, 104, 2, 30, "Input"],
Cell[39897, 1323, 104, 2, 30, "Input"],
Cell[40004, 1327, 124, 2, 30, "Input"],
Cell[40131, 1331, 93, 1, 30, "Input"],
Cell[40227, 1334, 110, 2, 30, "Input"],
Cell[40340, 1338, 110, 2, 30, "Input"],
Cell[40453, 1342, 93, 1, 30, "Input"],
Cell[40549, 1345, 91, 1, 30, "Input"],
Cell[40643, 1348, 108, 2, 30, "Input"],
Cell[40754, 1352, 112, 2, 30, "Input"],
Cell[40869, 1356, 132, 2, 30, "Input"],
Cell[41004, 1360, 112, 2, 30, "Input"],
Cell[41119, 1364, 106, 2, 30, "Input"],
Cell[41228, 1368, 104, 2, 30, "Input"],
Cell[41335, 1372, 112, 2, 30, "Input"],
Cell[41450, 1376, 118, 2, 30, "Input"],
Cell[41571, 1380, 93, 1, 30, "Input"],
Cell[41667, 1383, 91, 1, 30, "Input"],
Cell[41761, 1386, 110, 2, 30, "Input"],
Cell[41874, 1390, 110, 2, 30, "Input"],
Cell[41987, 1394, 93, 1, 30, "Input"],
Cell[42083, 1397, 110, 2, 30, "Input"],
Cell[42196, 1401, 106, 2, 30, "Input"],
Cell[42305, 1405, 118, 2, 30, "Input"],
Cell[42426, 1409, 106, 2, 30, "Input"],
Cell[42535, 1413, 110, 2, 30, "Input"],
Cell[42648, 1417, 110, 2, 30, "Input"],
Cell[42761, 1421, 114, 2, 30, "Input"],
Cell[42878, 1425, 114, 2, 30, "Input"],
Cell[42995, 1429, 122, 2, 30, "Input"],
Cell[43120, 1433, 122, 2, 30, "Input"],
Cell[43245, 1437, 104, 2, 30, "Input"],
Cell[43352, 1441, 114, 2, 30, "Input"],
Cell[43469, 1445, 120, 2, 30, "Input"],
Cell[43592, 1449, 122, 2, 30, "Input"],
Cell[43717, 1453, 110, 2, 30, "Input"],
Cell[43830, 1457, 110, 2, 30, "Input"],
Cell[43943, 1461, 126, 2, 30, "Input"],
Cell[44072, 1465, 122, 2, 30, "Input"],
Cell[44197, 1469, 128, 2, 30, "Input"],
Cell[44328, 1473, 130, 2, 30, "Input"],
Cell[44461, 1477, 104, 2, 30, "Input"],
Cell[44568, 1481, 116, 2, 30, "Input"],
Cell[44687, 1485, 118, 2, 30, "Input"],
Cell[44808, 1489, 130, 2, 30, "Input"],
Cell[44941, 1493, 106, 2, 30, "Input"],
Cell[45050, 1497, 106, 2, 30, "Input"],
Cell[45159, 1501, 112, 2, 30, "Input"],
Cell[45274, 1505, 108, 2, 30, "Input"],
Cell[45385, 1509, 114, 2, 30, "Input"],
Cell[45502, 1513, 122, 2, 30, "Input"],
Cell[45627, 1517, 128, 2, 30, "Input"],
Cell[45758, 1521, 108, 2, 30, "Input"],
Cell[45869, 1525, 110, 2, 30, "Input"],
Cell[45982, 1529, 128, 2, 30, "Input"],
Cell[46113, 1533, 112, 2, 30, "Input"],
Cell[46228, 1537, 108, 2, 30, "Input"],
Cell[46339, 1541, 118, 2, 30, "Input"],
Cell[46460, 1545, 104, 2, 30, "Input"],
Cell[46567, 1549, 110, 2, 30, "Input"],
Cell[46680, 1553, 114, 2, 30, "Input"],
Cell[46797, 1557, 114, 2, 30, "Input"],
Cell[46914, 1561, 120, 2, 30, "Input"],
Cell[47037, 1565, 122, 2, 30, "Input"],
Cell[47162, 1569, 114, 2, 30, "Input"],
Cell[47279, 1573, 120, 2, 30, "Input"],
Cell[47402, 1577, 120, 2, 30, "Input"],
Cell[47525, 1581, 128, 2, 30, "Input"],
Cell[47656, 1585, 112, 2, 30, "Input"],
Cell[47771, 1589, 118, 2, 30, "Input"],
Cell[47892, 1593, 118, 2, 30, "Input"],
Cell[48013, 1597, 124, 2, 30, "Input"],
Cell[48140, 1601, 118, 2, 30, "Input"],
Cell[48261, 1605, 120, 2, 30, "Input"],
Cell[48384, 1609, 128, 2, 30, "Input"],
Cell[48515, 1613, 130, 2, 30, "Input"],
Cell[48648, 1617, 124, 2, 30, "Input"],
Cell[48775, 1621, 126, 2, 30, "Input"],
Cell[48904, 1625, 130, 2, 30, "Input"],
Cell[49037, 1629, 132, 2, 30, "Input"],
Cell[49172, 1633, 124, 2, 30, "Input"],
Cell[49299, 1637, 134, 2, 30, "Input"],
Cell[49436, 1641, 126, 2, 30, "Input"],
Cell[49565, 1645, 136, 2, 30, "Input"],
Cell[49704, 1649, 110, 2, 30, "Input"],
Cell[49817, 1653, 108, 2, 30, "Input"],
Cell[49928, 1657, 114, 2, 30, "Input"],
Cell[50045, 1661, 112, 2, 30, "Input"],
Cell[50160, 1665, 110, 2, 30, "Input"],
Cell[50273, 1669, 122, 2, 30, "Input"],
Cell[50398, 1673, 118, 2, 30, "Input"],
Cell[50519, 1677, 118, 2, 30, "Input"],
Cell[50640, 1681, 124, 2, 30, "Input"],
Cell[50767, 1685, 122, 2, 30, "Input"],
Cell[50892, 1689, 120, 2, 30, "Input"],
Cell[51015, 1693, 116, 2, 30, "Input"],
Cell[51134, 1697, 128, 2, 30, "Input"],
Cell[51265, 1701, 128, 2, 30, "Input"],
Cell[51396, 1705, 126, 2, 30, "Input"],
Cell[51525, 1709, 122, 2, 30, "Input"],
Cell[51650, 1713, 134, 2, 30, "Input"],
Cell[51787, 1717, 128, 2, 30, "Input"],
Cell[51918, 1721, 126, 2, 30, "Input"],
Cell[52047, 1725, 128, 2, 30, "Input"],
Cell[52178, 1729, 140, 2, 30, "Input"],
Cell[52321, 1733, 134, 2, 30, "Input"],
Cell[52458, 1737, 132, 2, 30, "Input"],
Cell[52593, 1741, 116, 2, 30, "Input"],
Cell[52712, 1745, 116, 2, 30, "Input"],
Cell[52831, 1749, 122, 2, 30, "Input"],
Cell[52956, 1753, 122, 2, 30, "Input"],
Cell[53081, 1757, 126, 2, 30, "Input"],
Cell[53210, 1761, 126, 2, 30, "Input"],
Cell[53339, 1765, 106, 2, 30, "Input"],
Cell[53448, 1769, 110, 2, 30, "Input"],
Cell[53561, 1773, 112, 2, 30, "Input"],
Cell[53676, 1777, 116, 2, 30, "Input"],
Cell[53795, 1781, 116, 2, 30, "Input"],
Cell[53914, 1785, 120, 2, 30, "Input"],
Cell[54037, 1789, 122, 2, 30, "Input"],
Cell[54162, 1793, 126, 2, 30, "Input"],
Cell[54291, 1797, 118, 2, 30, "Input"],
Cell[54412, 1801, 122, 2, 30, "Input"],
Cell[54537, 1805, 128, 2, 30, "Input"],
Cell[54668, 1809, 132, 2, 30, "Input"],
Cell[54803, 1813, 124, 2, 30, "Input"],
Cell[54930, 1817, 128, 2, 30, "Input"],
Cell[55061, 1821, 134, 2, 30, "Input"],
Cell[55198, 1825, 138, 2, 30, "Input"],
Cell[55339, 1829, 110, 2, 30, "Input"],
Cell[55452, 1833, 110, 2, 30, "Input"],
Cell[55565, 1837, 120, 2, 30, "Input"],
Cell[55688, 1841, 120, 2, 30, "Input"],
Cell[55811, 1845, 120, 2, 30, "Input"],
Cell[55934, 1849, 120, 2, 30, "Input"],
Cell[56057, 1853, 116, 2, 30, "Input"],
Cell[56176, 1857, 116, 2, 30, "Input"],
Cell[56295, 1861, 130, 2, 30, "Input"],
Cell[56428, 1865, 126, 2, 30, "Input"],
Cell[56557, 1869, 136, 2, 30, "Input"],
Cell[56696, 1873, 126, 2, 30, "Input"],
Cell[56825, 1877, 130, 2, 30, "Input"],
Cell[56958, 1881, 126, 2, 30, "Input"],
Cell[57087, 1885, 136, 2, 30, "Input"],
Cell[57226, 1889, 126, 2, 30, "Input"],
Cell[57355, 1893, 104, 2, 30, "Input"],
Cell[57462, 1897, 118, 2, 30, "Input"],
Cell[57583, 1901, 114, 2, 30, "Input"],
Cell[57700, 1905, 112, 2, 30, "Input"],
Cell[57815, 1909, 118, 2, 30, "Input"],
Cell[57936, 1913, 106, 2, 30, "Input"],
Cell[58045, 1917, 112, 2, 30, "Input"],
Cell[58160, 1921, 116, 2, 30, "Input"],
Cell[58279, 1925, 130, 2, 30, "Input"],
Cell[58412, 1929, 120, 2, 30, "Input"],
Cell[58535, 1933, 134, 2, 30, "Input"],
Cell[58672, 1937, 110, 2, 30, "Input"],
Cell[58785, 1941, 108, 2, 30, "Input"],
Cell[58896, 1945, 108, 2, 30, "Input"],
Cell[59007, 1949, 122, 2, 30, "Input"],
Cell[59132, 1953, 120, 2, 30, "Input"],
Cell[59255, 1957, 112, 2, 30, "Input"],
Cell[59370, 1961, 118, 2, 30, "Input"],
Cell[59491, 1965, 118, 2, 30, "Input"],
Cell[59612, 1969, 124, 2, 30, "Input"],
Cell[59739, 1973, 110, 2, 30, "Input"],
Cell[59852, 1977, 104, 2, 30, "Input"],
Cell[59959, 1981, 104, 2, 30, "Input"],
Cell[60066, 1985, 112, 2, 30, "Input"],
Cell[60181, 1989, 93, 1, 36, "Input"],
Cell[60277, 1992, 116, 2, 30, "Input"],
Cell[60396, 1996, 122, 2, 30, "Input"],
Cell[60521, 2000, 128, 2, 30, "Input"],
Cell[60652, 2004, 134, 2, 30, "Input"],
Cell[60789, 2008, 91, 1, 30, "Input"],
Cell[60883, 2011, 120, 2, 30, "Input"],
Cell[61006, 2015, 104, 2, 30, "Input"],
Cell[61113, 2019, 112, 2, 30, "Input"],
Cell[61228, 2023, 112, 2, 30, "Input"],
Cell[61343, 2027, 106, 2, 30, "Input"],
Cell[61452, 2031, 112, 2, 30, "Input"],
Cell[61567, 2035, 116, 2, 30, "Input"],
Cell[61686, 2039, 104, 2, 30, "Input"],
Cell[61793, 2043, 114, 2, 30, "Input"],
Cell[61910, 2047, 116, 2, 30, "Input"],
Cell[62029, 2051, 116, 2, 30, "Input"],
Cell[62148, 2055, 112, 2, 30, "Input"],
Cell[62263, 2059, 93, 1, 30, "Input"],
Cell[62359, 2062, 106, 2, 30, "Input"],
Cell[62468, 2066, 108, 2, 30, "Input"],
Cell[62579, 2070, 91, 1, 30, "Input"],
Cell[62673, 2073, 112, 2, 30, "Input"],
Cell[62788, 2077, 91, 1, 30, "Input"],
Cell[62882, 2080, 91, 1, 30, "Input"],
Cell[62976, 2083, 112, 2, 30, "Input"],
Cell[63091, 2087, 110, 2, 31, "Input"],
Cell[63204, 2091, 124, 2, 31, "Input"],
Cell[63331, 2095, 136, 2, 31, "Input"],
Cell[63470, 2099, 158, 3, 52, "Input"],
Cell[63631, 2104, 142, 2, 31, "Input"],
Cell[63776, 2108, 91, 1, 30, "Input"],
Cell[63870, 2111, 108, 2, 30, "Input"],
Cell[63981, 2115, 118, 2, 30, "Input"],
Cell[64102, 2119, 104, 2, 30, "Input"],
Cell[64209, 2123, 112, 2, 30, "Input"],
Cell[64324, 2127, 130, 2, 30, "Input"],
Cell[64457, 2131, 116, 2, 30, "Input"],
Cell[64576, 2135, 104, 2, 30, "Input"],
Cell[64683, 2139, 91, 1, 30, "Input"],
Cell[64777, 2142, 93, 1, 30, "Input"],
Cell[64873, 2145, 91, 1, 30, "Input"],
Cell[64967, 2148, 89, 1, 30, "Input"],
Cell[65059, 2151, 91, 1, 30, "Input"],
Cell[65153, 2154, 91, 1, 30, "Input"],
Cell[65247, 2157, 110, 2, 30, "Input"],
Cell[65360, 2161, 120, 2, 30, "Input"],
Cell[65483, 2165, 134, 2, 30, "Input"],
Cell[65620, 2169, 114, 2, 30, "Input"],
Cell[65737, 2173, 112, 2, 30, "Input"],
Cell[65852, 2177, 108, 2, 30, "Input"],
Cell[65963, 2181, 112, 2, 30, "Input"],
Cell[66078, 2185, 122, 2, 30, "Input"],
Cell[66203, 2189, 116, 2, 30, "Input"],
Cell[66322, 2193, 124, 2, 30, "Input"],
Cell[66449, 2197, 122, 2, 30, "Input"],
Cell[66574, 2201, 118, 2, 30, "Input"],
Cell[66695, 2205, 122, 2, 30, "Input"],
Cell[66820, 2209, 116, 2, 30, "Input"],
Cell[66939, 2213, 93, 1, 30, "Input"],
Cell[67035, 2216, 126, 2, 30, "Input"],
Cell[67164, 2220, 124, 2, 30, "Input"],
Cell[67291, 2224, 120, 2, 30, "Input"],
Cell[67414, 2228, 124, 2, 30, "Input"],
Cell[67541, 2232, 134, 2, 30, "Input"],
Cell[67678, 2236, 128, 2, 30, "Input"],
Cell[67809, 2240, 120, 2, 30, "Input"],
Cell[67932, 2244, 118, 2, 30, "Input"],
Cell[68053, 2248, 114, 2, 30, "Input"],
Cell[68170, 2252, 118, 2, 30, "Input"],
Cell[68291, 2256, 120, 2, 30, "Input"],
Cell[68414, 2260, 118, 2, 30, "Input"],
Cell[68535, 2264, 114, 2, 30, "Input"],
Cell[68652, 2268, 118, 2, 30, "Input"],
Cell[68773, 2272, 122, 2, 30, "Input"],
Cell[68898, 2276, 124, 2, 30, "Input"],
Cell[69025, 2280, 124, 2, 30, "Input"],
Cell[69152, 2284, 122, 2, 30, "Input"],
Cell[69277, 2288, 122, 2, 30, "Input"],
Cell[69402, 2292, 120, 2, 30, "Input"],
Cell[69525, 2296, 132, 2, 30, "Input"],
Cell[69660, 2300, 134, 2, 30, "Input"],
Cell[69797, 2304, 130, 2, 30, "Input"],
Cell[69930, 2308, 142, 2, 30, "Input"],
Cell[70075, 2312, 132, 2, 30, "Input"],
Cell[70210, 2316, 132, 2, 30, "Input"],
Cell[70345, 2320, 126, 2, 30, "Input"],
Cell[70474, 2324, 126, 2, 30, "Input"],
Cell[70603, 2328, 116, 2, 30, "Input"],
Cell[70722, 2332, 124, 2, 30, "Input"],
Cell[70849, 2336, 114, 2, 30, "Input"],
Cell[70966, 2340, 122, 2, 30, "Input"],
Cell[71091, 2344, 120, 2, 30, "Input"],
Cell[71214, 2348, 118, 2, 30, "Input"],
Cell[71335, 2352, 124, 2, 30, "Input"],
Cell[71462, 2356, 122, 2, 30, "Input"],
Cell[71587, 2360, 124, 2, 30, "Input"],
Cell[71714, 2364, 132, 2, 30, "Input"],
Cell[71849, 2368, 128, 2, 30, "Input"],
Cell[71980, 2372, 126, 2, 30, "Input"],
Cell[72109, 2376, 122, 2, 30, "Input"],
Cell[72234, 2380, 130, 2, 30, "Input"],
Cell[72367, 2384, 120, 2, 30, "Input"],
Cell[72490, 2388, 128, 2, 30, "Input"],
Cell[72621, 2392, 126, 2, 30, "Input"],
Cell[72750, 2396, 124, 2, 30, "Input"],
Cell[72877, 2400, 130, 2, 30, "Input"],
Cell[73010, 2404, 128, 2, 30, "Input"],
Cell[73141, 2408, 122, 2, 30, "Input"],
Cell[73266, 2412, 130, 2, 30, "Input"],
Cell[73399, 2416, 120, 2, 30, "Input"],
Cell[73522, 2420, 128, 2, 30, "Input"],
Cell[73653, 2424, 126, 2, 30, "Input"],
Cell[73782, 2428, 124, 2, 30, "Input"],
Cell[73909, 2432, 130, 2, 30, "Input"],
Cell[74042, 2436, 128, 2, 30, "Input"],
Cell[74173, 2440, 128, 2, 30, "Input"],
Cell[74304, 2444, 130, 2, 30, "Input"],
Cell[74437, 2448, 126, 2, 30, "Input"],
Cell[74566, 2452, 128, 2, 30, "Input"],
Cell[74697, 2456, 112, 2, 30, "Input"],
Cell[74812, 2460, 114, 2, 30, "Input"],
Cell[74929, 2464, 116, 2, 30, "Input"],
Cell[75048, 2468, 118, 2, 30, "Input"],
Cell[75169, 2472, 128, 2, 30, "Input"],
Cell[75300, 2476, 130, 2, 30, "Input"],
Cell[75433, 2480, 140, 2, 30, "Input"],
Cell[75576, 2484, 142, 2, 30, "Input"],
Cell[75721, 2488, 118, 2, 30, "Input"],
Cell[75842, 2492, 126, 2, 30, "Input"],
Cell[75971, 2496, 128, 2, 30, "Input"],
Cell[76102, 2500, 116, 2, 30, "Input"],
Cell[76221, 2504, 118, 2, 30, "Input"],
Cell[76342, 2508, 118, 2, 30, "Input"],
Cell[76463, 2512, 120, 2, 30, "Input"],
Cell[76586, 2516, 122, 2, 30, "Input"],
Cell[76711, 2520, 124, 2, 30, "Input"],
Cell[76838, 2524, 116, 2, 30, "Input"],
Cell[76957, 2528, 126, 2, 30, "Input"],
Cell[77086, 2532, 134, 2, 30, "Input"],
Cell[77223, 2536, 118, 2, 30, "Input"],
Cell[77344, 2540, 128, 2, 30, "Input"],
Cell[77475, 2544, 136, 2, 30, "Input"],
Cell[77614, 2548, 124, 2, 30, "Input"],
Cell[77741, 2552, 126, 2, 30, "Input"],
Cell[77870, 2556, 128, 2, 30, "Input"],
Cell[78001, 2560, 130, 2, 30, "Input"],
Cell[78134, 2564, 124, 2, 30, "Input"],
Cell[78261, 2568, 122, 2, 30, "Input"],
Cell[78386, 2572, 114, 2, 30, "Input"],
Cell[78503, 2576, 114, 2, 30, "Input"],
Cell[78620, 2580, 112, 2, 30, "Input"],
Cell[78735, 2584, 114, 2, 30, "Input"],
Cell[78852, 2588, 124, 2, 30, "Input"],
Cell[78979, 2592, 93, 1, 30, "Input"],
Cell[79075, 2595, 108, 2, 30, "Input"],
Cell[79186, 2599, 104, 2, 30, "Input"],
Cell[79293, 2603, 112, 2, 30, "Input"],
Cell[79408, 2607, 112, 2, 30, "Input"],
Cell[79523, 2611, 116, 2, 30, "Input"],
Cell[79642, 2615, 110, 2, 30, "Input"],
Cell[79755, 2619, 93, 1, 30, "Input"],
Cell[79851, 2622, 104, 2, 30, "Input"],
Cell[79958, 2626, 93, 1, 30, "Input"],
Cell[80054, 2629, 93, 1, 30, "Input"],
Cell[80150, 2632, 106, 2, 30, "Input"],
Cell[80259, 2636, 116, 2, 30, "Input"],
Cell[80378, 2640, 112, 2, 30, "Input"],
Cell[80493, 2644, 120, 2, 30, "Input"],
Cell[80616, 2648, 120, 2, 30, "Input"],
Cell[80739, 2652, 112, 2, 30, "Input"],
Cell[80854, 2656, 114, 2, 30, "Input"],
Cell[80971, 2660, 116, 2, 30, "Input"],
Cell[81090, 2664, 118, 2, 30, "Input"],
Cell[81211, 2668, 122, 2, 30, "Input"],
Cell[81336, 2672, 120, 2, 30, "Input"],
Cell[81459, 2676, 112, 2, 30, "Input"],
Cell[81574, 2680, 116, 2, 30, "Input"],
Cell[81693, 2684, 114, 2, 30, "Input"],
Cell[81810, 2688, 136, 2, 30, "Input"],
Cell[81949, 2692, 128, 2, 30, "Input"],
Cell[82080, 2696, 132, 2, 30, "Input"],
Cell[82215, 2700, 130, 2, 30, "Input"],
Cell[82348, 2704, 122, 2, 30, "Input"],
Cell[82473, 2708, 124, 2, 30, "Input"],
Cell[82600, 2712, 134, 2, 30, "Input"],
Cell[82737, 2716, 136, 2, 30, "Input"],
Cell[82876, 2720, 124, 2, 30, "Input"],
Cell[83003, 2724, 126, 2, 30, "Input"],
Cell[83132, 2728, 112, 2, 30, "Input"],
Cell[83247, 2732, 114, 2, 30, "Input"],
Cell[83364, 2736, 116, 2, 30, "Input"],
Cell[83483, 2740, 118, 2, 30, "Input"],
Cell[83604, 2744, 126, 2, 30, "Input"],
Cell[83733, 2748, 118, 2, 30, "Input"],
Cell[83854, 2752, 122, 2, 30, "Input"],
Cell[83979, 2756, 132, 2, 30, "Input"],
Cell[84114, 2760, 114, 2, 30, "Input"],
Cell[84231, 2764, 118, 2, 30, "Input"],
Cell[84352, 2768, 120, 2, 30, "Input"],
Cell[84475, 2772, 134, 2, 30, "Input"],
Cell[84612, 2776, 114, 2, 30, "Input"],
Cell[84729, 2780, 114, 2, 30, "Input"],
Cell[84846, 2784, 112, 2, 30, "Input"],
Cell[84961, 2788, 106, 2, 30, "Input"],
Cell[85070, 2792, 110, 2, 30, "Input"],
Cell[85183, 2796, 112, 2, 30, "Input"],
Cell[85298, 2800, 106, 2, 30, "Input"],
Cell[85407, 2804, 112, 2, 30, "Input"],
Cell[85522, 2808, 106, 2, 30, "Input"],
Cell[85631, 2812, 110, 2, 30, "Input"],
Cell[85744, 2816, 110, 2, 30, "Input"],
Cell[85857, 2820, 108, 2, 30, "Input"],
Cell[85968, 2824, 108, 2, 30, "Input"],
Cell[86079, 2828, 122, 2, 30, "Input"],
Cell[86204, 2832, 122, 2, 30, "Input"],
Cell[86329, 2836, 124, 2, 30, "Input"],
Cell[86456, 2840, 118, 2, 30, "Input"],
Cell[86577, 2844, 122, 2, 30, "Input"],
Cell[86702, 2848, 112, 2, 30, "Input"],
Cell[86817, 2852, 134, 2, 30, "Input"],
Cell[86954, 2856, 116, 2, 30, "Input"],
Cell[87073, 2860, 124, 2, 30, "Input"],
Cell[87200, 2864, 128, 2, 30, "Input"],
Cell[87331, 2868, 118, 2, 30, "Input"],
Cell[87452, 2872, 120, 2, 30, "Input"],
Cell[87575, 2876, 122, 2, 30, "Input"]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

