(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    293028,       6060]
NotebookOptionsPosition[    289310,       5939]
NotebookOutlinePosition[    290998,       5986]
CellTagsIndexPosition[    290911,       5981]
WindowTitle->StudentTDisplacements - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["Metropolis",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:Metropolis/guide/Metropolis"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {Cell["METROPOLIS PACLET SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Metropolis\"\>":>Documentation`HelpLookup[
       "paclet:Metropolis/guide/Metropolis"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Metropolis/ref/StudentTDisplacements\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Metropolis/ref/StudentTDisplacements"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Metropolis/ref/\
StudentTDisplacements.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Metropolis/ref/StudentTDisplacements", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["StudentTDisplacements", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       RowBox[{"StudentTDisplacements", "]"}], "[", 
       RowBox[{"s", ",", "V", ",", "n"}], "]"}]], "InlineFormula"],
     " \[LineSeparator]gives n random samples from student T distribution \
with mean 0, covaraince s V, and the default Infinity degree."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->69841906],

Cell["The following options can be given:", "Notes",
 CellID->1067943069],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["SamplingPattern",
     BaseStyle->"Link",
     ButtonData->"paclet:Metropolis/ref/SamplingPattern"], 
    RowBox[{"{", 
     RowBox[{"\"\<Eigen\>\"", ",", " ", "Infinity", ",", " ", "True"}], "}"}],
     Cell[TextData[Cell[
    "Specify method of sampling from student T distribution", "TableText"]], 
     "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["IsDiscrete",
     BaseStyle->"Link",
     ButtonData->"paclet:Metropolis/ref/IsDiscrete"], "False", Cell[TextData[
    Cell["Specify whether the random variable takes integers", "TableText"]], 
     "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True}}}},
 CellID->563929935],

Cell["\<\
The option SamplingPattern \[Rule] {DecomposeMethod, Degree, \
IsComponentwise}.  The Degree must be no less than 3.  \
\>", "Notes",
 CellID->484368326],

Cell["Possible settings for DecomposeMethod include:", "Notes",
 CellID->293038167],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], "\"\<Eigen\>\"", Cell[TextData[{
     "Eigen decomposition of matrix ",
     StyleBox["V", "TI"]
    }], "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<Cholesky\>\"", Cell[TextData[{
     "Cholesky decomposition of matrix ",
     StyleBox["V", "TI"]
    }], "TableText"]}
  }]], "2ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True}}}},
 CellID->169206402],

Cell["\<\
If IsComponentwise, the samples are based on the eigenvectors or the columns \
of the low triangular matrix from the cholesky decomposition.\
\>", "Notes",
 CellID->251039541]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->755569806],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection",
 CellID->111341187],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<Metropolis`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->77562214],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"vv", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1.5", ",", "0.9"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0.9", ",", "1"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"s", "=", "0.5"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"size", "=", "501"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dist", "=", 
   RowBox[{"MultinormalDistribution", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}], ",", 
     RowBox[{
      RowBox[{"s", "^", "2"}], " ", "vv"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"StudentTDisplacements", "[", 
    RowBox[{"s", ",", "vv", ",", "size", ",", 
     RowBox[{"SamplingPattern", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<Eigen\>\"", ",", "Infinity", ",", "True"}], "}"}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"s", "^", "2"}], " ", "vv"}], "//", "MatrixForm"}], ",", 
   RowBox[{
    RowBox[{"Covariance", "[", "data", "]"}], "//", "MatrixForm"}]}], 
  "}"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"Correlation", "[", "data", "]"}], "//", "MatrixForm"}], ",", 
   RowBox[{
    RowBox[{"sd", "=", 
     RowBox[{"Sqrt", "[", 
      RowBox[{"Diagonal", "[", "vv", "]"}], "]"}]}], ";", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{
       RowBox[{"Transpose", "[", 
        RowBox[{"vv", "/", "sd"}], "]"}], "/", "sd"}], "]"}], "//", 
     "MatrixForm"}]}]}], "}"}]}], "Input",
 CellLabel->"In[2]:=",
 CellID->437547314],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0.375`", "0.225`"},
       {"0.225`", "0.25`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0.35352599827595693`", "0.21728049952816242`"},
       {"0.21728049952816242`", "0.2331436447377335`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}], "}"}]], "Output",
 ImageSize->{267, 28},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1282071],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0.9999999999999993`", "0.7568299004883129`"},
       {"0.7568299004883129`", "0.9999999999999998`"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]], ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"1.0000000000000002`", "0.7348469228349536`"},
       {"0.7348469228349536`", "1"}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}], "}"}]], "Output",
 ImageSize->{295, 28},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->320561247]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DistributionFitTest", "[", 
  RowBox[{"data", ",", "dist"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->299975583],

Cell[BoxData["5.687545615582122`*^-22"], "Output",
 ImageSize->{94, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->370255386]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"Histogram", "[", 
    RowBox[{
     RowBox[{"data", "[", 
      RowBox[{"[", 
       RowBox[{"All", ",", "i"}], "]"}], "]"}], ",", "Automatic", ",", 
     "\"\<PDF\>\"", ",", 
     RowBox[{"Epilog", "\[Rule]", 
      RowBox[{"First", "@", 
       RowBox[{"Plot", "[", 
        RowBox[{
         RowBox[{"PDF", "[", 
          RowBox[{
           RowBox[{"NormalDistribution", "[", 
            RowBox[{"0", ",", 
             RowBox[{"s", " ", 
              RowBox[{"Sqrt", "[", 
               RowBox[{"vv", "[", 
                RowBox[{"[", 
                 RowBox[{"i", ",", "i"}], "]"}], "]"}], "]"}]}]}], "]"}], ",",
            "x"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", 
           RowBox[{"Min", "[", 
            RowBox[{"data", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "i"}], "]"}], "]"}], "]"}], ",", 
           RowBox[{"Max", "[", 
            RowBox[{"data", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "i"}], "]"}], "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}]}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->93149538],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   GraphicsBox[
    {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
     EdgeForm[Opacity[0.7]], {}, 
     {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
      EdgeForm[Opacity[0.7]], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{-2.2, 0.}, {-2., 0.029940119760479018`}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{15.5, 23.753432282003715`}, {36.694751101023314`, 
           40.27773676735786}}],
         StatusArea[#, 0.029940119760479018`]& ,
         TagBoxNote->"0.029940119760479018"],
        StyleBox["0.029940119760479018`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.029940119760479018`, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{-2., 0.}, {-1.8, 0.009980039920159682}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{22.753432282003715`, 31.00686456400743}, {
           38.416741545246346`, 40.27773676735786}}],
         StatusArea[#, 0.009980039920159682]& ,
         TagBoxNote->"0.009980039920159682"],
        StyleBox["0.009980039920159682`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.009980039920159682, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{-1.8, 0.}, {-1.6, 0.019960079840319365`}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{30.00686456400743, 38.26029684601114}, {
           37.55574632313483, 40.27773676735786}}],
         StatusArea[#, 0.019960079840319365`]& ,
         TagBoxNote->"0.019960079840319365"],
        StyleBox["0.019960079840319365`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.019960079840319365`, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{-1.6, 0.}, {-1.4, 0.059880239520958035`}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{37.26029684601114, 45.51372912801485}, {
           34.11176543468877, 40.27773676735786}}],
         StatusArea[#, 0.059880239520958035`]& ,
         TagBoxNote->"0.059880239520958035"],
        StyleBox["0.059880239520958035`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.059880239520958035`, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{-1.4, 0.}, {-1.2, 0.08982035928143714}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{44.51372912801485, 52.767161410018566`}, {
           31.52877976835422, 40.27773676735786}}],
         StatusArea[#, 0.08982035928143714]& ,
         TagBoxNote->"0.08982035928143714"],
        StyleBox["0.08982035928143714`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.08982035928143714, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{-1.2, 0.}, {-1., 0.10978043912175652`}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{51.767161410018566`, 60.020593692022274`}, {
           29.806789324131188`, 40.27773676735786}}],
         StatusArea[#, 0.10978043912175652`]& ,
         TagBoxNote->"0.10978043912175652"],
        StyleBox["0.10978043912175652`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.10978043912175652`, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{-1., 0.}, {-0.8, 0.1197604790419162}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{59.020593692022274`, 67.27402597402599}, {
           28.94579410201967, 40.27773676735786}}],
         StatusArea[#, 0.1197604790419162]& ,
         TagBoxNote->"0.1197604790419162"],
        StyleBox["0.1197604790419162`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.1197604790419162, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{-0.8, 0.}, {-0.6, 0.23952095808383225`}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{66.27402597402599, 74.5274582560297}, {
           18.613851436681493`, 40.27773676735786}}],
         StatusArea[#, 0.23952095808383225`]& ,
         TagBoxNote->"0.23952095808383225"],
        StyleBox["0.23952095808383225`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.23952095808383225`, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{-0.6, 0.}, {-0.4, 0.2395209580838324}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{73.5274582560297, 81.7808905380334}, {
           18.613851436681482`, 40.27773676735786}}],
         StatusArea[#, 0.2395209580838324]& ,
         TagBoxNote->"0.2395209580838324"],
        StyleBox["0.2395209580838324`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.2395209580838324, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{-0.4, 0.}, {-0.2, 0.688622754491018}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{80.7808905380334, 
           89.03432282003712}, {-20.130933558336707`, 40.27773676735786}}],
         StatusArea[#, 0.688622754491018]& ,
         TagBoxNote->"0.688622754491018"],
        StyleBox["0.688622754491018`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.688622754491018, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{-0.2, 0.}, {0., 0.908183632734531}, "RoundingRadius" -> 
            0]},
          
          ImageSizeCache->{{88.03432282003712, 
           96.28775510204083}, {-39.072828444790055`, 40.27773676735786}}],
         StatusArea[#, 0.908183632734531]& ,
         TagBoxNote->"0.908183632734531"],
        StyleBox["0.908183632734531`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.908183632734531, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0., 0.}, {0.2, 1.0479041916167664`}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{95.28775510204083, 
           103.54118738404455`}, {-51.126761554351255`, 40.27773676735786}}],
         StatusArea[#, 1.0479041916167664`]& ,
         TagBoxNote->"1.0479041916167664"],
        StyleBox["1.0479041916167664`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[1.0479041916167664`, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0.2, 0.}, {0.4, 0.6387225548902196}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{102.54118738404455`, 
           110.79461966604826`}, {-15.825957447779132`, 40.27773676735786}}],
         StatusArea[#, 0.6387225548902196]& ,
         TagBoxNote->"0.6387225548902196"],
        StyleBox["0.6387225548902196`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.6387225548902196, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0.4, 0.}, {0.6, 0.31936127744510984`}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{109.79461966604826`, 118.04805194805196`}, {
           11.72588965978936, 40.27773676735786}}],
         StatusArea[#, 0.31936127744510984`]& ,
         TagBoxNote->"0.31936127744510984"],
        StyleBox["0.31936127744510984`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.31936127744510984`, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0.6, 0.}, {0.8, 0.17964071856287417`}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{117.04805194805196`, 125.30148423005568`}, {
           23.779822769350588`, 40.27773676735786}}],
         StatusArea[#, 0.17964071856287417`]& ,
         TagBoxNote->"0.17964071856287417"],
        StyleBox["0.17964071856287417`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.17964071856287417`, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0.8, 0.}, {1., 0.04990019960079841}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{124.30148423005568`, 132.55491651205938`}, {
           34.97276065680028, 40.27773676735786}}],
         StatusArea[#, 0.04990019960079841]& ,
         TagBoxNote->"0.04990019960079841"],
        StyleBox["0.04990019960079841`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.04990019960079841, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{1., 0.}, {1.2, 0.06986027944111778}, 
            "RoundingRadius" -> 0]},
          ImageSizeCache->{{131.55491651205938`, 139.8083487940631}, {
           33.25077021257725, 40.27773676735786}}],
         StatusArea[#, 0.06986027944111778]& ,
         TagBoxNote->"0.06986027944111778"],
        StyleBox["0.06986027944111778`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.06986027944111778, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{1.2, 0.}, {1.4, 0.06986027944111778}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{138.8083487940631, 147.0617810760668}, {
           33.25077021257725, 40.27773676735786}}],
         StatusArea[#, 0.06986027944111778]& ,
         TagBoxNote->"0.06986027944111778"],
        StyleBox["0.06986027944111778`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.06986027944111778, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{1.4, 0.}, {1.6, 0.03992015968063868}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{146.0617810760668, 154.31521335807054`}, {
           35.8337558789118, 40.27773676735786}}],
         StatusArea[#, 0.03992015968063868]& ,
         TagBoxNote->"0.03992015968063868"],
        StyleBox["0.03992015968063868`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.03992015968063868, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{1.6, 0.}, {1.8, 0.02994011976047905}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{153.31521335807054`, 161.56864564007424`}, {
           36.694751101023314`, 40.27773676735786}}],
         StatusArea[#, 0.02994011976047905]& ,
         TagBoxNote->"0.02994011976047905"],
        StyleBox["0.02994011976047905`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.02994011976047905, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{1.8, 0.}, {2., 0.019960079840319365`}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{160.56864564007424`, 168.82207792207794`}, {
           37.55574632313483, 40.27773676735786}}],
         StatusArea[#, 0.019960079840319365`]& ,
         TagBoxNote->"0.019960079840319365"],
        StyleBox["0.019960079840319365`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.019960079840319365`, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{2., 0.}, {2.2, 0.01996007984031934}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{167.82207792207794`, 176.07551020408167`}, {
           37.55574632313483, 40.27773676735786}}],
         StatusArea[#, 0.01996007984031934]& ,
         TagBoxNote->"0.01996007984031934"],
        StyleBox["0.01996007984031934`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.01996007984031934, {
          GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesOrigin->{-2.2, 0.},
    Epilog->{{{}, {}, {
        Hue[0.67, 0.6, 0.6], 
        RGBColor[1, 0, 0], 
        LineBox[CompressedData["
1:eJwV1nc81d8fB/BLiDbJCBlZZRWSrPc18lVWFA1khVBEtszslBWyk7237HOT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         "]]}}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    PlotRange->NCache[{{
        Rational[-11, 5], 
        Rational[11, 5]}, {All, All}}, {{-2.2, 2.2}, {All, All}}],
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.02], 
       Scaled[0.1]}},
    Ticks->{Automatic, Automatic}], ",", 
   GraphicsBox[
    {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
     EdgeForm[Opacity[0.7]], {}, 
     {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
      EdgeForm[Opacity[0.7]], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{-1.8, 0.}, {-1.6, 0.009980039920159682}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{15.499999999999986`, 25.36530612244897}, {
           40.979632972973334`, 42.96229056342669}}],
         StatusArea[#, 0.009980039920159682]& ,
         TagBoxNote->"0.009980039920159682"],
        StyleBox["0.009980039920159682`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.009980039920159682, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{-1.6, 0.}, {-1.4, 0.01996007984031934}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{24.36530612244897, 34.230612244897955`}, {
           39.99697538251997, 42.96229056342669}}],
         StatusArea[#, 0.01996007984031934]& ,
         TagBoxNote->"0.01996007984031934"],
        StyleBox["0.01996007984031934`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.01996007984031934, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           RectangleBox[{-1.4, 0.}, {-1.2, 0.02994011976047905}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{33.230612244897955`, 43.09591836734693}, {
           39.01431779206661, 42.96229056342669}}],
         StatusArea[#, 0.02994011976047905]& ,
         TagBoxNote->"0.02994011976047905"],
        StyleBox["0.02994011976047905`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.02994011976047905, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{-1.2, 0.}, {-1., 0.09980039920159682}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{42.09591836734693, 51.96122448979591}, {
           32.135714658893086`, 42.96229056342669}}],
         StatusArea[#, 0.09980039920159682]& ,
         TagBoxNote->"0.09980039920159682"],
        StyleBox["0.09980039920159682`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.09980039920159682, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{-1., 0.}, {-0.8, 0.13972055888223556`}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{50.96122448979591, 60.82653061224489}, {
           28.205084297079644`, 42.96229056342669}}],
         StatusArea[#, 0.13972055888223556`]& ,
         TagBoxNote->"0.13972055888223556"],
        StyleBox["0.13972055888223556`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.13972055888223556`, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{-0.8, 0.}, {-0.6, 0.1896207584830339}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{59.82653061224489, 69.69183673469387}, {
           23.29179634481285, 42.96229056342669}}],
         StatusArea[#, 0.1896207584830339]& ,
         TagBoxNote->"0.1896207584830339"],
        StyleBox["0.1896207584830339`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.1896207584830339, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{-0.6, 0.}, {-0.4, 0.4191616766467066}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{68.69183673469387, 78.55714285714285}, {
           0.6906717643855629, 42.96229056342669}}],
         StatusArea[#, 0.4191616766467066]& ,
         TagBoxNote->"0.4191616766467066"],
        StyleBox["0.4191616766467066`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.4191616766467066, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{-0.4, 0.}, {-0.2, 0.6986027944111777}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{77.55714285714285, 
           87.42244897959182}, {-26.823740768308525`, 42.96229056342669}}],
         StatusArea[#, 0.6986027944111777]& ,
         TagBoxNote->"0.6986027944111777"],
        StyleBox["0.6986027944111777`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.6986027944111777, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{-0.2, 0.}, {0., 0.9181636726546906}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{86.42244897959182, 
           96.2877551020408}, {-48.442207758282436`, 42.96229056342669}}],
         StatusArea[#, 0.9181636726546906]& ,
         TagBoxNote->"0.9181636726546906"],
        StyleBox["0.9181636726546906`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.9181636726546906, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0., 0.}, {0.2, 0.8183632734530938}, "RoundingRadius" -> 
            0]},
          
          ImageSizeCache->{{95.2877551020408, 
           105.15306122448979`}, {-38.61563185374884, 42.96229056342669}}],
         StatusArea[#, 0.8183632734530938]& ,
         TagBoxNote->"0.8183632734530938"],
        StyleBox["0.8183632734530938`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.8183632734530938, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0.2, 0.}, {0.4, 0.908183632734531}, "RoundingRadius" -> 
            0]},
          
          ImageSizeCache->{{104.15306122448979`, 
           114.01836734693876`}, {-47.45955016782909, 42.96229056342669}}],
         StatusArea[#, 0.908183632734531]& ,
         TagBoxNote->"0.908183632734531"],
        StyleBox["0.908183632734531`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.908183632734531, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0.4, 0.}, {0.6, 0.3992015968063873}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{113.01836734693876`, 122.88367346938774`}, {
           2.655986945292277, 42.96229056342669}}],
         StatusArea[#, 0.3992015968063873]& ,
         TagBoxNote->"0.3992015968063873"],
        StyleBox["0.3992015968063873`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.3992015968063873, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0.6, 0.}, {0.8, 0.09980039920159677}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{121.88367346938774`, 131.74897959183673`}, {
           32.13571465889309, 42.96229056342669}}],
         StatusArea[#, 0.09980039920159677]& ,
         TagBoxNote->"0.09980039920159677"],
        StyleBox["0.09980039920159677`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.09980039920159677, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0.8, 0.}, {1., 0.09980039920159682}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{130.74897959183673`, 140.6142857142857}, {
           32.135714658893086`, 42.96229056342669}}],
         StatusArea[#, 0.09980039920159682]& ,
         TagBoxNote->"0.09980039920159682"],
        StyleBox["0.09980039920159682`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.09980039920159682, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{1., 0.}, {1.2, 0.0598802395209581}, "RoundingRadius" -> 
            0]},
          
          ImageSizeCache->{{139.6142857142857, 149.47959183673467`}, {
           36.06634502070653, 42.96229056342669}}],
         StatusArea[#, 0.0598802395209581]& ,
         TagBoxNote->"0.0598802395209581"],
        StyleBox["0.0598802395209581`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.0598802395209581, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{1.2, 0.}, {1.4, 0.06986027944111778}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{148.47959183673467`, 158.34489795918364`}, {
           35.08368743025317, 42.96229056342669}}],
         StatusArea[#, 0.06986027944111778]& ,
         TagBoxNote->"0.06986027944111778"],
        StyleBox["0.06986027944111778`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.06986027944111778, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{1.4, 0.}, {1.6, 0.00998003992015967}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{157.34489795918364`, 167.21020408163264`}, {
           40.979632972973334`, 42.96229056342669}}],
         StatusArea[#, 0.00998003992015967]& ,
         TagBoxNote->"0.00998003992015967"],
        StyleBox["0.00998003992015967`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.00998003992015967, {
          GrayLevel[0]}], "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{1.6, 0.}, {1.8, 0.009980039920159682}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{166.21020408163264`, 176.07551020408164`}, {
           40.979632972973334`, 42.96229056342669}}],
         StatusArea[#, 0.009980039920159682]& ,
         TagBoxNote->"0.009980039920159682"],
        StyleBox["0.009980039920159682`", {
          GrayLevel[0]}, StripOnInput -> False]],
       Annotation[#, 
        Style[0.009980039920159682, {
          GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
    AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
    Axes->{True, True},
    AxesOrigin->{-1.8, 0.},
    Epilog->{{{}, {}, {
        Hue[0.67, 0.6, 0.6], 
        RGBColor[1, 0, 0], 
        LineBox[CompressedData["
1:eJwVlnc41e8bxxHlK1GijCRFWSEqFG7ZSlEpIip7ZWeEjOyVzGwJ2dmbxybZ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         "]]}}},
    FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
    GridLines->{None, None},
    PlotRange->NCache[{{
        Rational[-9, 5], 
        Rational[9, 5]}, {All, All}}, {{-1.8, 1.8}, {All, All}}],
    PlotRangePadding->{{
       Scaled[0.02], 
       Scaled[0.02]}, {
       Scaled[0.02], 
       Scaled[0.1]}},
    Ticks->{Automatic, Automatic}]}], "}"}]], "Output",
 ImageSize->{389, 122},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->209009189]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"ContourPlot", "[", 
    RowBox[{
     RowBox[{"PDF", "[", 
      RowBox[{"dist", ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "y"}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"Min", "[", "data", "]"}], ",", 
       RowBox[{"Max", "[", "data", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"y", ",", 
       RowBox[{"Min", "[", "data", "]"}], ",", 
       RowBox[{"Max", "[", "data", "]"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"ListPlot", "[", 
    RowBox[{"data", ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->197763768],

Cell[BoxData[
 GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJyEXXVUVc3XxsAOUFGwWzGwxR5sEFuxXwO7sEXFABQwsLELEwMTJRQYShQQ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    "], {{{}, 
      {RGBColor[0.34289029178016905`, 0.143426832131, 0.5989541021510053], 
       EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxNmgmU1NWVxv9V3U0X1VV0V1e1CmJkbUCig6iRLSQu4AJIs3RDAwZkEVGW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          "]], PolygonBox[CompressedData["
1:eJwllmlslVUQhk97b3vlu/f29uu9FUuMFKoVRLBhiQsBwSC4AcWlSmJEKqBE
QBEBt0iRTYVoJISlQIwLOwL+KoqglLIU3BVijEaEqIQfGAkxsvu8eX9MMu83
c+bMnDPznq9L4zP3TykOIbyLJJGHsyEM40NTUQjHohA+i0NYUhLCbPBd5SFM
qQjhX/Bv4Gr0ewshjEqFUI/cg96YI04ihBewj0XflAlhH/EmEPxiPoQrid8L
+yBiDCH2XPbojG9ffMbjuxBZg74XWYR9Pvg99DZkAfgIexxlr6ZS9iRenng3
EK8/8QZgb+PbU0mvmcfaU+kQeqAPwedMWQj/sf4S69+g1nXYt7NmMWunEa8n
a89jD1c45wvgosoQIvAI8BLVwrenk87xTfC34J3gDeC3wPNj5zqBmrZHjqnY
9ez/CLke5MxuB/diz1ex3xn7LGrxn8z6adj/RL/At+nom8mnJeVvsl1K+6yG
Ee8i9byd8d6zifkde20jZj2+o5DXsK0t+G6+BK9B7xZ77x/AteiDkYHgucQY
hP5x5LWNyBzW/wJ+BX0Q9pHkvx88DVwAb8b/+8h33Ql8B/YY6UZufYh5E/YN
se9yIj478R1NDuPIpyd4Ebgl8llV4LMa36H02Kwi38kn4CfAUznfXdgb0b/A
v796EdmNfj05NmDbSsyfiP1kxrWop9Rb++jBl1jfg5w+BHfkPntzn6/jMwXf
3yP3+lBwA7k/RoyJxBrO/qPZfxP22Sn3/GTOfyZyAv+/kA+4iw6sqSb2o8hp
fEeA70avZc9q4i9VjuAXwXvJZSW4O3gW+GvwHPC14JngPeB3wNdpfsBt4OOR
Z08z+Sn5FLPny8ExKtgrg9SgP46cxfcge07FvyP+h9Bz2GsTrkm1VRV8d5eQ
Tui7iHehyGe6E72h4N5TjQ+ht1PvQHqrXP6xe1S9qjPUWS5mzc/gruwxBt8D
2J8FV+Lfjj6SGA+y9zZkPr4L0+69zvjXV3iGNcvN1DQSvSv59sH2I7KS/q4G
9044hwP4N1FjF/AMzqeV86mlJ9ax1x/YD7K+PW89xn4V9nN579WKzwby2Q3+
tdQ9P49YKeIfIp8yZGbkGlWrvlWh12Q8W+Kcw9SSwKdfypy4A/vJDiHcCD7D
HofJN82ZXM3Z1LA+Qk9GPusT2HdjLwUXoZ9CDoALWc/CEXwq0Z8n5p5ic8z0
2D2r3p3BfivAW8Qp4Cbs3+Q8o5pVnVEX1m8Gl6c8Mzuw/0O9qZTXaG0J59W9
2DlfQz1jY5+NOLMR/Xzed6kcNop7OfOOCffIdu7ultizqju/Gf2jgrlFM70F
fTDx25POQbmEvGdJHHyZWKvSPutunFGO83k/7VnSDM/AfozzbE76DUlHrlG1
6s3YGnkmNBvq6cXgXOTe0Z51Bc+YZk0ctAzbpIxn/TL5nC14xjXr4uy6ct+B
7mK8ODznO9RdKgflEhGjNemeVG8eEwcU+dvxCveYei2PVOV8h7pLcc7+nGdc
s643alXkmlW7Yqym9kN5c7l6eBG5Nse+63HYl6Kvzzh3vVl6u8aUmwt1p6dZ
uzHnt1WcL+4fkDP3iLPF3a1l7r08a+qynkHNot7s+4g3L23ufECcB25CVqTM
MeKaBNKc8jfZxDHiGnFaedacJ+4TZ5WBP4/MzZqBDtTaEvvtEKcfjfxG660W
52Wzzkm5iTPasJdWmgvFaSXofcv9tujN6YPeO2tuEcftxf/vCr/t6umT5JqN
/Lbrzdbbnaw0V4ijE4qXNTc+x/p9+K7TP0iJOUHcsDb2W6Vv69EXRJ5lnUFL
wXesuxbHD8/6jdNbJ06KsuYscZfe7E3434p/TdJviN4S/UPoX0Lfbsu559R7
+uc4h38d9n5Jc8RXGfeAemE6eyxHX572v5dmchK1L4tt0z+F/i1Uk2pTjIac
/zn07yHOEnfpjnXX4uQR6P8Dfbc7PA==
          "]]}]}, 
      {RGBColor[
       0.44183887534050703`, 0.31547169639299993`, 0.7380383064530159], 
       EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmXu8lmO6x9+1Wu96V+9hvet53mcVNYwaMWNri6JCOjiOrZXTEFJpb3NI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          "]], PolygonBox[CompressedData["
1:eJwtmGeYVdUVhs8wc+/ALXPbAQWkDIZmiTQVEENRRFEHS6SoVAuKFBsiIF0Y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          "]], 
         PolygonBox[{{3286, 3285, 3054, 1025, 3827}, {4107, 1187, 4106, 3285, 
          3286}}]}]}, 
      {RGBColor[0.5407874589008451, 0.48751656065499993`, 0.8771225107550266],
        EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmXu8lWMWx3edfTln73322e+79zGJVHwSSpwubtOhKGYw7hGJQjfpIrcI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          "]], PolygonBox[CompressedData["
1:eJwtmXm8zWUex3/3uvfc65xzz/I75zay0wuTra6oiERUYyoRJVtUtrKUNClb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          "]], 
         PolygonBox[{{3822, 1023, 3821, 2771, 2772}, {2772, 2771, 4840, 1618, 
          4842}}]}]}, 
      {RGBColor[0.619636085023625, 0.6172449603912653, 0.9107711563688963], 
       EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtmHn411MWxz/12/TdP5/v9ze0KPRMURGRfUvLTEaLFqXUaF9Iv2QiJE0Y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          "]], PolygonBox[CompressedData["
1:eJwtmHm8VVUVx8+bee/ee+45515KBCdM5kEpRBEkAjVURKYgpgRlVkBSxFk/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          "]], PolygonBox[CompressedData["
1:eJwtkL8vQ3EUxU/8qMajqp6yyaOJjVRiU6V9TGKQiJGIYCKpwaajhJrEhEQM
EsYy8ReQkIhIu1WMTAaJ0efm+4aT89793nvuPSdY3V7YapLUD1rBZqe0AY6T
0l+LdALn+M83SxNwtV26BfOedMPAZ7fUAB8gQ30ITKekGm9FOEffObPDCWmZ
+RXwSj2MSW/wI/1PYKZHOqQ21iE90/sC+qinwRTfV2gU4FHmR8AP2KcWoD9I
TwBi6D2wNw6P03vJe+g5P+YrjfYuO7LsqvFej2Df2S5pAL+99Jz50nWbdOo7
P5nIs3mvolNC9w5eI5sGM+tJd5Pdlmf3JJgFdW4pey4by6iC3gW6c57LwfI4
YvYXjQq8wx33aJcSzo/52vNcloVI1/S/ufULhFFmReNI+8B3mVl2lqFluYj2
OzuW4H+GgT/V
          "]]}]}, 
      {RGBColor[0.6923861898401276, 0.7341341358994086, 0.9124296346853271], 
       EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJxFmHfwVcUVxy/8Ku++d1+57yeiISowSFEw9goiYJSfGgEBscwEsCAqRkUU
KbZkJthBJaJIi1EJ2KiiKCQiRKUoKogFMRIQAVGpgoR8vvPdmfxx55y7e/bs
2dN3j+p/U4/BDaMo2twgiiqA1+ei6FKQU5MoSgpR1I7JX0pRNITx2dBcEkfR
PMb2VUdRc+DqfBT9qTKK1gD7M/Yi+PGMjypG0RPAIxlfB59CVRQ1hs/djDdk
/Aj4f1YTRdex5oTAb3/g+Uu1/68Bn5ZGUTfW9mBdL77e8H9cezI+FXxLI+hj
82jI/HzgQdZ2A06F/xS+Wcg9Fx7Pgs8Fb8xZ2nPGV4Gds/CDvjv8XoDPNubP
h3/P2OfdBs9WyH8m/CZA3yATRQ+hp57gb8JvMF9feNcULE81cCX/M8J4i3IU
rQAew9nnBBmuB84pWK6/M94AfBJrv+Us5ZJ19SVj7ZHpSPZdhyyD2e9V6C8E
/zm2jhdBMw6aPchTj1yf1tgGmjs8b/2P4nwZvsbwb8bYamjW8P2moe12ALiJ
7xZ4Tmd8MvIOqDYv8bkK/gOl25x5a/x05JtUNv0UYFf4toXXuXnPaf09rHml
bB3NBM7m+wf4u+yzO/b+jeA9HNkeA69Fz4dkbbf98NmY2h/GMzY0Mc2d0Bye
Gte6YfBbFPQpKP7Scfsan1N7vIyO7gb2h75d0Xh3yVWwjAMYvzycSf8nsVdv
fGMz+twb5PwR2u2s2QHdtrJ1Kt1+x/igEC8bE9tMtlsP7MT6rdhlI/N38q8g
+x78HvAXsON7RfuC5JVP7oO+H3zq4bMGmoTxtcDN0M0A3wQ8O/BcC59nsvbz
bejjnpzX3s7at/Gf8eCnIfsOvr7Q/MzYg/Cazj6/h3YJayeBH8X8vqJlmF1y
7A6vsN2HVXhf+egr7LEKPrPla8wtrXQMdIPnKuj+wr4TWb8P2nnwfCrrGN6U
Wq7Z4Yx7S5ZnH/AT1uYYz4H/uWgbjgb+yNoSa2pLjmfF9X54dkVX29n3e/ad
VWWbyV5b2eN14KnY5eqg59/C43jmF0M/CvrX4Pd5tW22Ct+aDkyAbyTWSQf4
zwJfDW0rdPw069aFXLQw9dq3gKMrHTOKl++DP8gvVrA+x1gdPE6stTzKXZ/l
TTsLeeorvF7/C1LnE+WV96EZwfiL0NzM/ybwP8jf8s5RylXT4LsUOUeyz5cZ
86or+3xbqn2e8dC0hub+jP3i7UrH0pOJbTSRtfflbIfF8qvUZ/wj+77H+GLG
b4NmD3q/VLkY+HnZOh8J/e68c5Fy0hbwptI5677OOz90gM/uRtb3QdadktpP
OrJ2LP9/Q1ePA5eVbdOWwNNZ30G+ClyG3Lchw1LkHVdte8vWXTKGw+HThTVZ
bP8R+A3g90Izg/l5yHATe70GHMB4BfzvU65gvgXfLv7fQL6dkp+1h9VF0cnY
6dg66/LwQDM7a/vIbmtLlmclY99wrrMVyyWv0dq50EzOut58l7peyfaye32t
cdXJZ5g7yNprM9apdPuTcmDAd5VsR/GU7sYz9iTfEsaWItc51d57cN6+rVxy
QexasJ4zro5Nt4Bz92HuB86zAh3u57sSfAf71jE/CD7fsD6bsW+cBu0u5B8L
n0uhXZh1bLdOnT+k21z41/hbzDcvO7duRx8jkbsSnqOAk7HJxBrntX5l54Gu
jD+CzL3YawywJuNzrGftJ3nXnYPgY/Ou6artjVm7V3Ut6xytXN05sd0kg3LO
01nrdVfZdKJvC49zocsh97eMtc04lh9lrBK6MrJVADvyn1WuzlofGpdODinb
T95kfEHWvjCr6JyiWD5Fe/E/jnO+CczDp5d8GNrWYS/ljy/4hsJ/Ef4cQxvD
8wBzLVLv8yF8pgY5m2Rsn/ahTn0RYk0x9w7fcuUv4BXVxtuFGiad7E5ct5T/
cql1IZ1MyFpGxY9i5jz2aAH+PLa4KtCr7rXPOf9fBb4kdrzMBz+r5HytWiT/
rQ+5TDxaVrtv6wHdPGiuR4bTofsama8ruIeqCT78OvKcppwJv0tSy9Mla5uP
Bb8OeGON82fvKp97fPD5y2LnisfgcUbID8vZ55Gy+7lHgb1Tx8i58OycOhcp
JymOFc+K4YtS73UhsD7nuqn6qb5NfnQM9D80cs07FPkvznmt8qvkEH/RbeWc
I+B3peotstUyNzFvvcwPef5X/Ncx/mtgX3it0TmA2eAn5xfsC29X2x8OML+s
2jEs/SmupRP1oNJjkzr33+ortmacQ5VLDy07Z8vWqk2KP/mSetb1scc2pM5T
irXVJddjxWMev10Z6tQY8FuqbKObgVNLzlED2atD2faW71TGzg8p8+/Etv/D
yHJl2f3Ao9BMK9k3XgDOSi2L+ughqjHIPLTg/ChdTUKHa3LOE+qDWta5do1l
/LnUOhkC/lJqnTcvWr9aq1r2YM7665dxP6T+ZGMx9Behx+jO3jOB0+D/QMY1
MUGXTRgfia6K4I0S+/8RsXOlcmZX9nw/4Mqj94e14xLbTXVHew/LORZ3xZZP
cv6YuEdUHKu37c7/DPj0SNzfqM/5mPnVoecZAO9urO0Cfj5wb4Vx7bdSvPj/
MHGfvjrEyMcht+Rjn1+yrMw5d8tGVYx/UHDeWQlsVXYP1Fq5pOy71grgjUXf
S24A3sWaf7G2Yyncjarch9XF7gObps7ryu/ykycK7o0Hsu8uvtHgzaG9O/Cp
g2d/8BcZ74lcJ8H3I9adAqzKh9iB56yMe5uzcj6PzqXcqR5CvcTTqe9Pukep
L7mctaeqRjJ/RtY+cVyo+cqr8qHBifu8ixj/KrFOL0CeRkX3TiPY58jYdpf9
F5bs/8pVsrn4K4+koQ9UXt8RcnQ18tSG+53unSPzjtdOyLIh9Py646oeK6Yv
Yp+zs6YR7aeJ/Vf3mzYF63M5tCv4poB/UPSdVnXw5dT3OvXg++DTMehEfVZr
4qUfObYN8MzYa1ey9vbYej5ZeT7ju8On8OjDvi8hf6/EviKf6Z/x3UA1fhHj
V+ds0zHQL8zZFnvyvieoNz4L2hbQTWB8AXBg1vHwFHL2jR1z6itPZO9V7Ds0
dk1WvVbdPiGMH19yX/8G3xLWtMt7Xn1ZGvu+sYWzzIXXreBzgBeHWH6YfZsF
GeYnrsGqc4uLvhPqPjhMug/3FOWn90I/+WHJuUB8Xir4Lqo76avAa4qOrWuB
8wq+7+ud446S79QXwGN2eCuQz84LsiXIdWzJvrmHdVVl91jVwNsSn3EIsHvR
bxd6w5iUc89fq3trbB3Uo4Phsf1TPb54iaf6ccWkYmqUcnbwYflyU/7vhf83
0DQJsknGNSX3isuBZxZ9nz0DWEody4rpD7L28bXgq3LOhx8Bjy6bZgX4oYGn
7h/PlVwLVBPeLZpe6zbnXWtUcyakzo2r5P+hzuruqzhUPN7AuTrDJwVvkXGN
Ua2ZDO2D4Q1HsXVYYp/U/VVvLrJFL/jXFK2r0dD/O+ezbwD+J3aMT2GfmxP7
j/zomsBfNU1vFXqLkC6OCrGv3ufk2DVItahZxn55a2J7aK87Y78BqZY9HzsG
FAvrdMcp+v65p+j+T/VddV5vPJJB9qtg7/n8X8G6NuDLwYeAtw54K2BdyXlb
Pfg5oS9trF49vIEoZ1ycca/wbME9h/Kn8qj6V9FvQIadseuR6pL6L/UPig31
l+oNxpRtA9nirqL30NoHGG9bstx6ozoavk3g3zLvvLsi5N4nC+5D9C4o+8mO
E8quAcobei+pDbEtXepuJn+4OvWbzJxQU7YX3WfqftYndb/3JfhOxmcyvwPY
JnGPoTfC6SXTqz+9LHWfpH5zWOJ+RveMHrHfJ/SW9nPoA/YW3U8uCW8FIwrG
O4Qeakl4u/gp67OcJzsUXd8eA+4K8vRWjISYWgY8jn0nQ9+J8Q2J84Pe3hqG
u0Qz8HdyviN/pV4p+EADYLeM6ZVX5oc8ppx6R871JV9wjlOO+l3sfmh6eKuQ
f8vPVdMaZZ1D9H6gO8rekGP/Ck0/9VrM3xS7Px8E/ZjE/Z76viw0GWjivO2n
s++EPhfGG4BH0D/M+MGce5CelT7PQ3njl2WdX6STz4Bx2T13tuzaJRnUD/2z
+P+7+8yiZVS+7xM7dsYj/2b2OqB3NsVx3m8uTct+z1Bd1/nVTygHPlNy3dMd
WXdlvTXqTUOxp3vKvtATR3WOgf+W/Y6g/K86oHum7h6D2GdV2fz1ZvA/Z0k3
ww==
          "]], PolygonBox[CompressedData["
1:eJwtmHm01VUVx3/vvon37r2/OwdIJAYL4UFQtEQQwoGhGDTmAHMls6BChFAE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          "]], PolygonBox[CompressedData["
1:eJwtkstLlGEUxh+tZvS7jM04UdKY6ARRm5EKAqk29RdIZYWLMEhwURBWm1bt
0lArQYNoHME2ZVCtWgctArUsKmzXBa8tGrW71e/wvouH53zvOec5l+80dpxr
PVspqRlsAH/S0m8wmJXGktLJUEqCBAhrpGC9FMMPY6mwTqqDI3wxeLdRSiHy
Fh7g/TooYt8BZfzHE9K3DLVAAewDr4i/hK8TzTOgqVbqIq4R/oX/BPZy6DRM
azySLtPDcx9veQ2BtA3sJn4avb1wL7E94AWzlHjbj8Z23vOgxGz3mO08b3Pk
zYJCShphnma4InJzRmiXmGEU3PT7uJF1tazmBfTnieuGZ4h5DxrQLFZIz9BY
5HsJDKE5jfYwnCYvA45gj/PWQfwwMbd8HauXpG4Vuv/wfa6WPoEWajy1ngK3
V9vvafwP0GhD62LoZt/jd2s7ric2B5bZwSN8q/Cx0Nkr2F9BGbSSfx+dU/j6
0O0HU+RNggP+P2+xN7/LybTbme3uL72tgY/4rxD3wc9iM72m55j4N3DEPuro
fwezzeKb83Ws3hT+kLiXcDs9PMGuzLg7tHusJ2cTubkad4d2j73cRw9IkDOK
71qtu0G7xRU0r9LLqtVhtjXseXiBfhcD95/sf+2yefEp5fqxvvLU2IxeQL/d
+CfoZae/G7ufMWNu8m7G3Zfd2Yi/p2LW7dv2Xvb7/Q4eo9EWutrWw09/1z/g
AeodpV4/vETMF4urdjMl0T5ET4djdzN2O3l6vU3PTfAE3wexW/BvBTnwH1BK
hoo=
          "]]}]}, 
      {RGBColor[0.7648809246386764, 0.8477482899156336, 0.913023035778104], 
       EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJw1mHmQVdURxi/MBu/dd9+b+x6oI7sga4yVkhkNgmJRMsMSIlGM4EJw3GLE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          "]], PolygonBox[CompressedData["
1:eJwtl3uwVXUVx/d9nHO45+yz9777XEVRQUB52XNGuBjFS1IUgmSCBNFRBLW0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          "]], PolygonBox[CompressedData["
1:eJwtlFlIlWEQhkePS57fs3iOFkgJQtlCF15JVhYWpaZFVla2kIqtbgkJFUGb
ddVFQWk3KUJCWViQZUKLpt5YaWFiu1HHhOomczeoZ/j+i5f5zsw778z/fTMn
vqBsU2mwiKwDoeCMV+Q06IoSqcXxAjsUKfIdBDjfwvcN+8ol0gMKnCIZ4SKr
o0UG7Xi2JXITjQYgxP9FiBzyiKSGiBzEuuHFw3NhI4ATlLhFisFJzoXE6sir
RP8s6EAnHF8ndhd9NIeJXPCLzOB3BLiC5mVwB99rYkfhlKHV4hApx/rpJxpk
wUmkhw0eU0trtvlElpHTjk2GsxSMgzEQgV4eMQv7nD66QIVldA+TO0Dtz2AW
ue30V2SZfrSvc+Q0kbuTXgrJyyEnkZxUOKtAG5xWMMW5EF4U/GTiS8Avvv18
kEgS5/fE04j3U+Ml6AbH0TsGRok5+J4peDM5x4A56ByAP9tvuJrzHqTj+0B8
wm1yprF/qDMCsjg30F+uZe5b792HrwpfEr5+fr8FXr/p1ec3tbTmL96rkW/f
xPk+3/MAPOMcILcFjblgnvZn31EMdpQ7GQPlII9e6niPAThf3Ob+9R1aOQ+h
8RRbQe0jYAv+G/jW4OumjhO9fKeZQ53HaPzVxP3YhfgXgSp4k9S4ii2CU+wy
86ZzdwK9PjSW01MJ/gnGdSM51+HWAxc6kSCDcw8amdivwEdOwH57nYFe+q8k
3ucxs64zr7OvO9DoNYt1F9uE1j2wgHgv/Gx8EyCW+LjXzJfOWQqcer5jpdvs
ne7fE/p9DDrAVfhOnTVQzbnVjinnEzkfQSs6CSx2AE4Q2IfeNvw5YCsoQnM3
PdTQcygI85hZ0JkI43338M4h2If05aBGs9e8gb5FOtzF5CZEmvvRe9qHfy+4
BG+c2EXsMp+53xTsFLrTTjMLOhOPwCA9tesc0XcMuAYvjrq12AzwjtxTlokp
R3dYd/mnPXM/osy86dw1wJ9P7m3sONrB9DBimT3RfXHzLfnEJy2zd7p/2o/2
lWnP/zpsnL0/f+EFo+8AZeSXgvWWeZcVujt8+zBIt/tMw+bi3w5C4R2At4Pz
ZvIziedEmf8o/a8Kt+93At5v+hj2mvvXd6gh1knsENq9WgedN1gPXK9ldkR3
JQu9tehm2j1qr9PE95Mbi8Z/yirLJQ==
          "]]}]}, 
      {RGBColor[0.830215456391163, 0.8695356153548397, 0.8837532241013955], 
       EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtmHmY1WUVx3/AMDR3+917f3dASUECSg1aVHZcEnDY1FhSWYTHyEqW2JoQ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          "]], PolygonBox[CompressedData["
1:eJwtl3mMVfUVx38z780becu99707g2hwhDhNgGJMq8CoCFTQEdRQFjE6OsRa
0yhYUEBSQLQii5W2lCJa2hSXLmkAgaQaZLNAtdi0DUltHWFErZJSUhYBwSlu
n2+/94+TnHPP8ju/8zvb7f+tGRO/Wx9COArkga2VEF4BWkshfAW4JQ7hMALL
4U0C/30Uwr9yIfQBBhVDeCoN4eVCCA8jswp8WUbPh+4oh/BqyfJfw/h49PdD
t8Abi0x3LYQ7+HYlvC7gMuwdgz4KnAfeC3iH886i/0xdCAm6M/lWRbcGrET/
SvgvwN8Ifzp+j2wKob0xhP/h763IjseHm/M+407s3gRcg+wH6NwMviUyLv++
iuzGkm3rjBXYX43MrfAmIPMh9nrzrRl8JzamIbu+4tj9BnoD+BBk3oduR2cu
ulOwORE8ApqgX+S8Vdy/C/uvEKuFsf0bBgwpO0byRT79AfsFbP4K2yugc+hO
Q2Yp+r2QWYvsttS2ZHNggg7+tUF/BH8R9E7isbfRMX8H3ifIz5I+33rAzzYZ
1x3OgOc5LwfMwvZs4GxqvnTuh54JjMF2K3A1+JvILsz5vOu4+5hm3hy6AHTh
6/TYtmVDtnYgPwfeYeQfxL87Ks4dxfhpZJuRuaSBmCB/A/5EQAv4SWS+A29d
xbH+ic4gHr/kjAez97kd3uOp7SkHlYvHdCb0NuA5ZA8SgxvhjUJ+H/4+B/8M
+JPwZ8K/O3J89b73Ef/tse0/hU+HkJ8D5Ovs31h82wT/PvgdigG8Ddjbh/0f
Y6O1GsKf8Ol14BzwKXAe/EbgJHc/BQxIfbeLsZdgbz70evRjzrsHe+/h0285
bxX2S/gWN1lW8W+BtwWb1xLfZfBPgXegcw66gP43kK0B/ZGfgc0K8gPx91S9
v6XwNhOPS+H1Qn4quqOy+qmHXg+vgE5bvfP3fHSHlV1LylnlrmpG+aoafwn/
xkGPBb4AAv6cLbteNgL3EM824Hd17h99kJ8KvQV6gWqcs98DjshfzjwI/lNs
rFROclY+dswVe+XIWvzbWnb8dKeqchl7q+vs8y7iv5IY/0e1qRoCn8GZPwOf
x3kzI+eY7OlNU2L/Od8Keb+B3mJ57PqtAHnOui3yXXSnM9D79X7I9mBjNfSv
kb8+5/efC/029JK8e6h66VvIv5Z3Pf0TfFLVstKZDH4amWfyftP7qaVNkfuV
6nuz8MT66sf3IvsFdF9ikUNmmfo2Zz5WcH89QHzG1hyrFfDbwV+Av73eNXGC
81uAi+Cvgd8X/L9Vv71idAT838TnWKPr6Qn4S1L3dn07DK+han2d/wD5MxT+
AmRfwsdL8G098Dl4D/5OgH+oanqpejD4ZfjzYaNj1KU3jtzr1PO6uc+z0Gtz
fr+14ItV48Br2H0dGM6323K2dxV4Y+TeoB5xBLmHYvdi9eQrOP/vsWOn93gT
fELsfLkQnYngf0uci8rJv4I/XHUv1hs8i/5FZd9P/beI/KSi79aJzGbkuxPX
rvJnMrKPQ5/MO+fn8J7fIz794P8Iei74UmBgg2Oq2E7M7ClGm9Ct41sntv6h
mIJHVesrX2chu6fqWtEdiuT+GXQuaLD8PM4fWXSvVc/dTjzeKrs391EPx/97
S+51yue7iF1UNF89fB70XxL3BvWIvSXHXLG/E7lO4OvY6IetEdhoQX5Q6l6j
mlRva0vdq37Btw7w49iYUnC+j8OfLYl7p+b1FOytTjzLVbNPg78Ru/b0fnvB
hySujV2ameA9vZhpwBps/RwYmpinGjqlXpc6NxTP08rf7D00I/eVvIOoVlo1
k8F3p8ZVI3vAN1bcSxTfEvIjK54d2lc6sHV77NmtfqhdQ3fUXdXD3qU+7k7d
i1Vfd6XuEeoVqtGrUs8UzZZB6I/G1gNlzyLNpOc1fyPnlnLiY/DefIvz9km+
XRP5fqqBEdrNEr+nZtgHiX3syvafTnQHRH6rOu0Leu/MP82MMvjuknl7sLc1
8k4mfd15BOcNLrpWtANoF5gWu5epJ6k3aWfT7vYGun8G+sfuXaqfi8F3Rrat
M/7IWS+nzlXleA58dMm1rve/HNmHKs4PzdhlxGZb4v6kGaVd75aic0e0ZtfV
6K9Bvr/2qViXcq2qZtWbzpU9ezSvtJtqZ/koy4cd6pUVx0c5fTn6z3Pep+Dd
nDmO+r0h9izWTG4HH5Xlg3aKbuxVS95VtbMexP+2Zt9FOd1e8s70/9mNvxX8
XRw5FjpzEfjoqv3V+10LviL1bqOdphPfx8TOlcnQB7TbonNT5J6o3the8TzR
DrIO3TT27FbONIM3lE1rpmm2PRG7tlRjP9B9y96VtPMcR79Udq9QT9gP/u1K
1ouhB3Nun7JjrZj31S7d5N6nGRpix1SxVc1dT6wfSxxv7Yxd2PqYb6e1U3FW
A/DDinvvOvjjsdcU+b3UP4cRvx7oTyLrSPebkWWlsxTdJHWtKaer4DfW/HZ6
w/HIL4o9qzQzP8OX2Zm8ZticNJuZBe/MO7jLAnTmA8c55wTwKGc8AuxE99XE
PVn5q547veh/BL2X4qfd8QD0fmAxtpYAB1K/nXaGbvANsfNXOf4ieO/Us1oz
+3ztFpFng2ZEv6pjlM92SO2Staw/6j31r9GaePYq3zWrLkh9X93vQtmreFdU
D90EfkXJuayek3DW8Wy/1s5+FPzRxDzJLAQfzB2GNrreh0PPy+apvl0K71DZ
ua5/smHqXal3CdXsVPDvx9699O0R7XMVzwLNhBM173Da5bQTvK16rnlWauYN
B99Vcy4on3aDD8j+T6Wj3XZ2tp9Lvka8vgReUOik
          "]], PolygonBox[CompressedData["
1:eJwtlEtIlGEUhs84KuivM/prZFc0nCK6LFpotWpn3kISvEUujDaBBk1GXrpC
FgXlJUq0qKiFFlEGQSXowsi0FgktwrFa6CLI28x4d3J6Dt8sXt7vO5f3nO+c
fyaj6vTRmigROQRiQLZL5KlTJAseTxCZAF+SROJwDsOD4DOoc4s0EjeSKJJL
TB4IcV4FtiXS7hBZTjT5quNLFulC4yd8JF6kEFTjL0ejE70xcvJjRX7bIrNo
+8EJ/FVgN708Im4XvErsCrhDXDLxLXABGEM73za6qq/5qhME7dEiAXgBeyU6
K+gsgWUwiX0rAxihxynO0+AM+n/I8cKfqD8IWtG2qdcGV6NTAwR7mLzDIIf4
c+Q2pYpcAwX4njGDvbwrljot1I2Bu7B3g2hincCBv5k4B+eDaH/nHect80Z9
60diB8A4tgU0fGgMgyFQTk42dcvg4nXU4RzG3kp8GzhJzityKrDd434fzHKe
AensYSe16niHk3szcVGwU3sDIWpvxh+Gb3K/Bc5Sxws2onuR+FrOm8jp4LzF
ZXalO8vEnkYvHngUfR/Ixd9NXBm5l4i5DNaw/9N94XuBrwh+niLyjTm/hBvw
NYL1zDcdvX3opROTAVKxp4ArnAfIvQqHuN9mlnmcC0Chy8xaZ17PuZ+4BthD
D5mgD3sttkX4F/ZFzhOWmbfOvRN0AA8zeEv9+Tizd93/ErZ64ofwV3I/Dt6w
vz303gNP0vNf/TYi786B58nZwEzn4CkwDWbJmwEBckrJnYPX2M07/TFynkJj
OsHEao6X/r7i247vIfcH4AkI0d/jJLMn3dcNZlWErTiSrzoHIt/XfthjG50d
tulT+y2lbgnwYyuhlxlq9aPZByrocZWWLqB9PaLd5Db70z3mWeb3PZZsetLe
dE+6ryziMohPo0YQewAsEl9JjagU83+i/yvHLPPusL4f+w/8vfASc18GQX0X
s9xG3HvOHyLftH7bPvLd5I7CfsvMMmib9+i7LPq4S268y3w3+v300Ncp+nrt
NjvQXfwHP2TEuQ==
          "]]}]}, 
      {RGBColor[0.8955499881436497, 0.8913229407940457, 0.854483412424687], 
       EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtl3uU1VUVx3/AMMPcmXvvzPzuEVpopQtaUgiWVC40UVGUh8pD1BAYGBCD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          "]], PolygonBox[CompressedData["
1:eJwtlnds1VUUx29Ld/v62r73UxM0aKRGTRlSBERkFGlpCwZoVQRakBL2KHtV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          "]], PolygonBox[CompressedData["
1:eJwt1ElslkUYwPFpLYWutnz9aBOjxu1gFBKokSokarBLWKJtYhCjVFppRCO1
0BaJ1AVKSsEtURFksQIKAQpuUSggoAfjSQ9KRC+auFzUoIIEBOpvMt/hn2fm
2Z9535lr2jpbFueHEFowBuuyIazFv8VkXgiD1pPKQ5iIIZy4LIQ5dJ9XhPAZ
2jP0hSHMo+sqC+FJTOe3g98MuufxHIYvD2FRQQj7yVMlIdys6Ey+R6tCOIbX
rF9FAftYfveJede6zXpZaQiNbE1oEFuPX+hK1JjM7x4E+Y7Rf6z2JxjR10Ec
QB/zMF1+LnceOWq+wP97+pN4m98X5hgiq7DQOkP2y70ax9Vept4POf8YN2z+
Ufma5RrgswaH6Qoc5NziNHecf7fYxWKfFnO3fT1O6v877DD78Fhz0S3Co5iv
7lvqP0zu0mu7Giv47hO/PzdfnLOvkk2tFWQRv3GYYX0H3VR5fhJTpO5Kvo32
TViPVro+Pd2vx3kY5LcG74t/gG0p28/6+l1fge4r66/xuNjH0K2v3frrJbvt
/+LWIE+/2VejQg/X6mE8WYJSXCH/HN+oWL6pqMNsse/5x4bEbMP2itRj7PVT
Pf+qlyNkr30P6nyvDXTVdC/bv4QL6rbRvWK9Ufx5Z7WpIv2H8X/8yPpDHMp9
lxHyFrVrUa2nWXq6gd8a+gF8U5bmaZT3kv1FXEAPv9Vi8swSMAZXyVdAPst+
St1nyCX6WIoB57XF+U3S8wH7g2jL3ZUFmXSO8Twvqfei/i+St6o5FQ9m0/n2
ZFKtWLPVzB/wW0BOYa/FLvV2Ym/uP9xDTsvdvdvJP+T6E+flfoHuHLlQXEc2
6aP9HzXG6fMM2ZpN69OZlDfmj/3EvgbN3qzGOrLGTNVYbt1E9xS5yrwrcUSN
bb7pjSWpTqzXxV7Pbwl5yH4k/oPsO9V6Q8xc+wb2HvZvxZ/AxPhGoND6Sr33
83sd7dYDdA+xzUen2Kt9m7/FnsYZLKZ7Ar8VhbBV3lG6wtz36jLLKvt+rK9K
PWyoSvPEuWoxBT/m7s5yeY7G/xFn6Q6b7RH26fbT8E7ujdpBTo7viJhaso7t
tvgflKZ3bx97b3xDytJ7Et+V7uJ0Tyr1VoUMsrm3pzm+wXzXyneWvNP+rmx6
s+LbNYFfB78acqW4Dnm201/H93rM4jsTs8enO/FmvBt6OYf/StN7eVyuzXq9
1/Ymcgu2olOefHN+Kc8mOTZjrzp74r1HJVtDfD+y6Z1qzaQ7Fu/ahPJ0R2vK
U61YsyWbeq3OpBnjrP8DLuHa8A==
          "]]}]}, 
      {RGBColor[0.4264283315892971, 0.28867692265817646`, 0.7163769229508321],
        EdgeForm[None], GraphicsGroupBox[{PolygonBox[CompressedData["
1:eJwtk0tIlGEUho9d7P90ptFmKKNNhVEu3LmwrdEFlIKadpLQrhYattBaROlE
uSm62GYmiYixKLEbBZGRGV2EynJahVERdHGioJYlPYf3X3y873/+853znsu3
anfX9s55ZtbOmc9pDWa/F5i1gf2cK5VmzyKzHGfpQrMObLuqzYqLzAYzZq/4
vo/PGXB/Wv7dYJl/Y26H5+AF/Bu5dyfo7l1wlJOHXwc78RvGvwts4Hs1GtaB
Bc4P7HlwOi0+mDArwbsR3gp/D/+DfQYcCuIl9N6sMatAc7bKrAX7eWJuAA+n
zLbC+8AcZxu8stbsdZDmabAJexMNqU+a9RL3KvaD4Km06u0gb0O19PdT35dI
/ifACc4lfA4Rp5c4+Qqzumppdc1ZbM8jaWjG5yt8I3eXwUcWm32A3yPPZCRt
L7x2+EXuluD/UqqlvMRsTVJ5Xe9ofPcy/Ghc1xw9aE6pnyvIPxrJZzlxptD9
Dv2fM6rZa3/jGoI0FyLV4/HXYlsZpMG17Emrxr3gk0izO8L/l5F6NQB/Cp8l
/iR8X9x/n8ND8k1i/0VPxoJq9x6cjPvgtpkgbY/B02lp853akpRPMaVeuJ4D
kfrrms/hM0Qf3uJTALNBO7ADvB20h7fAnqTuHkuofs+1E94YNKP2oOP8QtDM
nLfhsynWcA1dm6v0Xo7T5/VBPfe5ed+d+361uG7it+M7W6N3VAbnEtLsO1If
z7GvVvk81zhx8pF8fCZn47fmb64Q22/Ah4PiF4P65bVM+HuMaxwgz994Z3x3
fLd8B3xfvAavxftaF9S3EWI/iOflc/P7Hsd79p1afhL/G/gxo/l+Ah8FzXTc
dyDIZ4o4/wEe1ard
          "]], PolygonBox[CompressedData["
1:eJwtl3m0T2UUhg+h83G5ptM8rMbValCirKikQaQBDTTITVJKhCJcU2UoiVBi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          "]], PolygonBox[CompressedData["
1:eJwlk11MzXEYx59Izk9HneoUzQ220EUxSwu5wMSmYXVc2MhmxjI7zWm2cBx1
SmJrJ1reerkgxZJDNWkdLznmpdFCuaFGF4xq3u+s+fz3XHx3nu/n9zzP//fy
nAV7ivLc00RkFZqBouJEtkaKrDQi+1Ak3jVLJIJFF34pqkoUCaEO4juoPkJk
yi5S5xRpmSlyF/bXJlI5W8SLfhHnG+3R4RApJ6+evCDsMmtr6fUV9h02AKtB
bbDqBJEA8aBN176RU8d3JqNEGuAF6BJ5O9nfJtZb8ctRNewoiidORh+ni7TH
wOjXRu0A/fbD7ZzNHyuyhfO+gE2hV+w3mW/0EC8mJ4PaFJiPfkn4OWgDLAe2
FzZK3mmjfUvonwk7A6uFhWBnYb2wW/huo/dTEC3SBbuGv230LlJhlbBF+Fz0
mz1t5FxF1LfS5yk9T8AP4se4h3FqnsH8sEOwYdRI3Afz8KBDeC9ny7T6G72z
t7B87j8HP0TeH9gobCRB4yZ4LzyN83s430/iI+gK/YrxteTdJ+81eedQAF/I
nsfIyTJ6j6V8s8qh+99svTl6R+0BcpupDZPrtWYLf8quvefj16Agtf44vfMv
5LlhZfiLfGMX8W6UxAyN099D/Q36lcOekLuNXvPQQr6bCktEx6n7wb32c1eP
8VdRJywb1VDTZ3TtEfeZR+1L6/2Nzv9J9mJQCn6J0b5Z+GW8iY+8fqNv8Ina
z8SHYev5bSTvH3lh9rjDem+js7nOqXu09lpm9E3dnKElVucpAF8Nb8Zfj9WZ
DcKyrVz8hEPPXmHTN7XeNp2ZNsTtsGHym/Dnnfp/rIfdY+2CU+fDmpPnNr2z
YnxDjNbMhZfAJ/mdiNf9PyB+aM0S95SBSlnvxDdwjgr6uWDdsDDsPWwQtt2u
8QjsA3pDTlq01nThb6IeWDp5IWp9RuehkL3k2nVm02Ar0DHO9h+rLKtG
          "]]}]}}, {{}, 
      TagBox[
       TooltipBox[
        {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1H9wz3UcwPG3Ti4/EoV0+acud/rD8nsl+bGuNTeKmSSbsdutxmxtHNss
P2ZjzlF+x/lVCdHQ8uP8Os1K4ZTy4+LQ6Vx3MeqfKU7yeJ8/np7v1+v9er/e
Pz6+eya7MK2gSQgh3z+Zj4Ywtn0IF1uFUMvdkPRYCC/wQK7nQfwtH8V36ICb
j4fwM9/gUzwM143ruIH/s+Yu/mgewqQnQhgjn8+FKMAw+xXzZBTh93YhXEG3
FiG8r7YIl1qq50Z9Cvh/vocDznxEPAC3jAfxHGufV7/LuAu/y3fM5XKxNW/x
EfFyruMLrUPYYN/e4pltnIN7WlfKvznbFaQYH1I3mCt5dtsQKvCc9b307MxP
qRtv/k/3nBnfg9eoXYcEDJXrwd3xknGKPU5yMnfnwfwjp/IQ/sxZUnk1r0KR
PV4Vv2z9TW/T6MxZ4i3mtqEG1eJ0c7XG5eoXiOcjG59jE/42t5onqlvME3g3
/yW/Me6Lf+SW8jLM0GcFj5ZbyBmc5I3r1Y+OvZ1jIk/lDG7iXZqiGSrjd1JX
xWne5wfzw/kYz43fQJ+x7ntAvNJ4BTqKS+I6dQdjP3VJfI8T7b3AXL54lPkS
nhb3lt8c3wLlzrGVv0BXNZfElzHCOfro/57xO+ZyeQLykKBuur5DOJ1T+Yz8
WaxSu1x82rjcXIM+1/FxfFP5r7hUvN35+hs/4vu8wuuwVe41Pq8uOb6t/c87
617jX3meeF88pztXGvcy/h4PWzeKz3G13q+rnStegimokpvKT9qrA+7oX6fH
Cbm+eBN75ct9g1p+Q7zZ2bdgh3i/u9Rwmfz0+GbopMcH/DS/qK45EuP3VbeW
c3gcj+Ms9DQ+HPP2PRTfk7/hn/ALRupz1Z1OIT3+X3KXkfyQvkFtR2dIE7dz
xuHR4ipuK26DViiTK0GO/If4CBX6rIzn8CZzuAbbccyb7OQd+NfcJ/wpbstv
iL8z51gf16PQ/Bo+qVeF88xCXuxpr7d5lzX7cRCzY0/z89xnmvr5PJmLkWDu
6/ibinfXv5/xRrWbkGL+S/2SeYZ8mT338LPutS3+nVB/DQvVZIoX8fF4T16K
BnNL4m/cfou5j7kxsWf7B3+r7wMiMNaQ
          "]]},
        "0.16`"],
       Annotation[#, 0.16, "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1HtsjmcYx/G7G4KOrSeV2LI0Wv+sWBCaajZTVpph1EYMDY04jb1EKx22
zumdQyQOQ9KIzsiyOTaypStFRGw2yf6ZQ7WWJSMkow49rVHs82R/fPu7r+v6
Xdd938/zPs2Y+8mUpQkhhFJ/LvcK4YuXQ/gcC9JCmJ0SQjFOvhLCKbydGsK0
niFUqB3lOYYyPV++FEK19UO1luQQHiXyJYXwgBaqn9U3Us8hnpW8BXKHzf0e
q/U87B1COc3Q8zri8htxV98/uINN4q+wC1k8M83YY95u3NJ7mt6m+XQMGuyT
hQb+RtzAbnEuzYzyzlln7jWcwU3xPX1N6GHOr8403Xox/ww6Sc8sGhPPpIN5
3nKGUWh0z0dyj9GCJe56p0cINWrNqEUWT3vkV1trvzrr5Z7pz7QTHZintkx/
Eu+f9r8g10Dr8bV9Y85QoeczLOcdwveXXKJ6qvOspQXyZ6JetQ10Hb5R62/W
ULPT+TPk+tJXaT+UqL1B92EgqrAf+WYMpTlmFlhfpmPpbb0j5G/Rm95Fodw+
Z6rCARTyved5TrRvpThmfh5/Lu7LNbtLC75VO4LJcnE9RbRavIp/s7hN3KGn
lXbl745m9RdoAn7Ax2qtck0YYM+s6D1GvzF941ER/f7U1tDpvFvN/Yi+4x2c
ly8xYw4Wya+gpQju1BXL+NZ5Zk/5OrHFjCKz43LP1N43Py43y/1r9RfTveam
03KeQt6gXmY9jP+p9XC6SbwZyfiQJ5WmIA19cJwv0YzJ1lOi/Xmm2j9bb0w8
Er3s0xvznbdWPcm6HoOtr6vX4wMU4VMMVMtGnjnX9FzFBN5/aQfa0K7ehtH2
OeIMR/Gmcxym3dz1O7qKjnHX63oPRt8PzYy+Nz0bxYP4a9SzaTf+F/m70BU8
pbhiHXeGP+hYPXXe17t0vVypvhx9ffV0mPsEZ8WT9J2jP8qv8V6q+E9YV2M1
zzH6k/PXRHfx3VWa3UozzXxNvaf+EeiOfP2jUaJnkZl1cgvpHPGQ6NtBu555
cnvMuWFGI6bK/e1+gf93WsS3U72LOAHPnamP/dORYn4aHceXQtdHvy31ZPlE
lMutRIn8NnSqTbD/BvMu2mt29B14LsX0N/EveK7vGZqcI0ctF0/kt9MC+8R4
d1gvpZfMqUz7///5fxQC1Mk=
          "]]},
        "0.14`"],
       Annotation[#, 0.14, "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1GtM11UcgPGj4IWrCIymK9KUCeqbWkBEZqs1IVGXJRMwX7hqKyQq5nQ0
a5U51nIyK23OpZBtrdVylWbqKGFeKnOovXBAYqGzaQSCitOVfc588fic872d
8zv+deqK+sUvjQohrPVHd0oIxzND6OIePo0/rNuzQujAztQQ/uJPeJBLskP4
h1vsL3ErD/DHXJ0WQhWa7Zfbr+Mm1FgnZYSwjIfSQ5gyUQ+/lhzCl/LT7dfI
fTghhKesn0a5OYPussx5l7lSbJiHMKBvl9rL/Lg5q9TuNb8yzpNfwo/o+8J6
j/jfei8i23fVq38Zv+i5Llen9n11H+Ar+WbeiBtya+xLrPvdLXCN/RHxn3EM
R+2/Ef8az5hzSGyduRXmP4GbYqVyDyHZ+eloENthv4rL3XG7dU78Xp6HYWdV
6h1ldoJv3GTeLfv/4nt5q+f0dTtns3i1WBWu6cnRW6unV+5P9OFF8bFm1PJ2
DlxkxjS5PGyNb5AUwn6xAvu18lPV3Y0W59SZXWG9AHutZ8nv5ifVfssz1WRz
sXN/4Af5oHu0Y72aTvsfrd+O7+Ub3+LTzsxUO1muwdwE+9H2ieixXq2mgt/x
Nl3m56lJcW4X0u0b1X0mP4bH4aL1vWYNcD8eU7NSz4hvquOF+mp5jrkvxDeQ
P8W/YbfcOc5HAbKcmYk08Zn685FhPwG5Yg/E3zJ67c/iDErR4duS3aGNk+Ib
8El1Q3Jj9d1h9hh+jxN5mtxE659wFIXutJrL5G6hHCfit+jv5OPu/is2WC/y
zQvxr571eprwbvyNyDfxq+LfmT8Jk5HgLrl8J3LcLSOejYPq0zkVH6FaX5vY
G2YsVVfmjEvuMcPfX4N9v9wVXEOj+J44GykYkR8SH2ediCtmXdd/A43mjfBV
bJFbHP/tqv0c592tDxfMmyP/MOrVfxr/XfICtfOdv4hbxLahR3137Iu/ZfUl
WKl2s9wW7HSXTdyM58UftX+WZ6tbwXdxqVihdyvCFPv7OJdbnZPPBehQk8ft
vI/fRJZ8Ms83O43L9M3D/fFdY9y9zvIr7tYq3ife4cxz/Lt4Bp/iTL4pfhgN
Zs0194B1G6bLfc/3xDflXShUU4wiDJs7iF7vcgadeueqqZFbLl7s7Nfjb4qr
4m/MeePV9FufSL39//3/8vbUag==
          "]]},
        "0.12`"],
       Annotation[#, 0.12, "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1XtM1WUcx/FHGyrI8SR0QismKmtAl/VHQ5zlZXOtvLRkmpdqFWpu2Wg1
7OYlm7XVcHndyiVgLrfUpSEYWaKs25ZkZBcNa7kVOgrQtCBEk17P+uPD+/ne
v+f5/c5hdNmTpeUDQggb/TmZFcJROkHH6Qz9lh5C7jUh9CZDeDkzhN+zQ9iK
3XxvYX4qhHHOJdQpVsP3B27DLqzC8VeHkJkRwmm9piZC6MBXxIbwr8VK6hoa
wnozzg8LYezwEPbw7aXNfHPYG3GdHvv41uND5tU6zxNbZc+V1G7WXepn61Vh
ToP+B+gL9m7x19Xswv18pXwdarPxKTXL8Iiaf8RukbNd7q1Yi/vofXqEivme
lXsbPoO34yj7bBJbwL6s54N4Ff9jfHX0Jbse6/n6xD8zY41Z8/mnm92n/k6x
Fex08QQlqYFdzV9FKfZq9t3OF3zOOerm0gZ9ftRvkR4NYgvxOHsL/2zxNDXz
sFtNSjyHfhFvoyVyq9xhNaW532rql79d7QD5CfZgdi5u5StQc1Buulge3yo7
vUhP6H8vuxxvFluKpXIL9K9zLsRsTNHX+jXhePzULtc5b9bjkPNH7ugwNrNf
dT6CL+lzwuxi+cPljsR+dnD+CZeJt+JkM6bjGHtk2KHdORPb8Fe64p3rxFHx
jtXm4Vn2C+rL1UyRuxIn4+PxHuT/gHXsk1iPmXYaSo3O12IR/03UxM5hH8JC
93MYR7An6T2OPRFX0HKaas9P4jtAjdREV+QG36N+7DG3EAtogvxNen1oRgN9
y3eM8vUchGk02nmJ2HvymnGgz7SIbzF9F+fJKTOzhf9RXIvH+NdhqXuYRX+q
rYjfAXqNf7CdhtBy/uv1yaNL7msg3+X4PrBTmIV98XnqdxGT7AQtVNcY30nc
wp4rdkHt/diNufbYZq+n2fmedwUW4cN8XXSOzlKG2mZMxx455/XsxUHsv/S4
FN9r9vN2/hv/1aOHr8zcvXL30E6aJdZm7hn+SeIz2eVq3hG7T58d+nXHWqrh
68Ne6hBrl9+JJbhUzZviM9jPiU/DDezF/FPib4Kc9njXZt3BrhTbIe9d2hl/
J8RXixXhRPGP8SDl0wEaQ1nq38Bpau+Jv5vON9o7icOoUnyGHqec3/a8T+tT
Y/8gt8keP/Mn+b7HU/h5fN7OLbQmvovq9/N9QGPj88AE1mIOndNzBLbIuwGP
4gQsscMCM+bTV3oVsx+Q26r2G+cWas36/3/If6vc5tA=
          "]]},
        "0.1`"],
       Annotation[#, 0.1, "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1WtMlnUYx/E/6tRSQVPSR8ymOEg0HldjFZ5WT1jkCaRyubWZFmor0eko
dOqqN0mpoOmQnKZuj7nl1sLZi1y88VCKaFTaCYcTQdTmiUmMan3u9eLr73/9
rsP/uu/7YY5ZVDZveUoIYaN/vh4UQuqAEDrpQBqjh1F3fwhTaSPNoPl4CoVD
Q8jlnU4NYf5geVrAS+B6WghPqmmQP8k/RX94IIQmNOC8+UeHhdCP33JfCN3q
O9DCb9Xfhp0DQ7hCa2k7nUwnqUmnv5j5IO0R57u71YyE+/o590Wl+htmbZGv
xg31r6rf71xOt9HiISEcVDePVvC+dD6MOnyut1DNAbpPb8ye1fYtEf+p/iV6
ky7mfUA30S2owlVxB9rRhu/sNcEzj5ObSGP2e5v/FmrMzeM9gTgex2MYzd+q
/hP0qOvFS0GS/6F4IzLM6aZ/4T13vGPPtfY6SNfRCvqa/gJ9G8TT6XqaiHYx
Z5dcp+dezKvSf8G8X3Fa/DMdpO4nWiO3iFdiXh86lD8MzXItKDVrn3gp/Sz6
Bt7b3ug3RAegr55RdDT28Pu7M8N5Pb2mv977/hYr1RXxy+ib7ppgXhWtxlle
dfTO7PwFP8Y7FL0j3jbkmHOG5qn7nja550fkiH+jq+XLo32dn9bXRjPd1U6z
aRYeUntZ/I/f0nV6wn5jeHHn1/W+ged4C+yab8Yy8RLMEc/GSbnz5lzAEeci
fc3q0u18VFxnr6+QK/+NOK43Rb5E3UTey2bM4M+nzXr+wO9Yp24KfZH/rHy9
GQlaLI6lhzACI/EojpgznuYgG1nYqraJn4o09DGrN3rxx5pRyjuF6eJLdBr9
lL8LTe5eKq51TtJz4rPYbOeF3s1tXn/ffqznWOWbVPBmmrGGlovXRH9beFj/
GXc2ogFZyI5ic2553yPMHB49p9rJeN+8e7QLt9GJuxjF36NvLzLdOx6PYDu/
VH4J0s3JlL9p7rvmp4lT8be64/xj+Nc5V22xc8KeRfbdTOfSZ+hw8z6SmyVu
UTeHJj3Das+bNGsV7TKjB3fkdvPu0m7xNb0dZnREv2P3tzm3Yof+mXLbo3fK
z4tqxHHaThvdcw6V8klzprn/ef6BaO9oP/7HWKh3qviiHTL1DlFTQ3fzCrz7
GagV70Sl3A76grmFuORcpi/FnKveT71ZXervIW6/i2Zscl4QfWu1r9CValcM
/v//h/8AYsLdRA==
          "]]},
        "0.08`"],
       Annotation[#, 0.08, "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1W1ol1UYx/GjUuLUuf03JbY1t0RnTmdaEpVKxpSCTNs0l8vVdMsN0YkQ
LTKmpILuQWsqbjJTp0wkUCwso6BHU2wauTKoqVusdMJw9UbEoM+hF9/9zvW7
Hs6573P/We7KmqJ1Q0IIDf78OjKEE6khXKHX00Lowb5RIZSlhDAzKYRVY0J4
lP6SHMIM6ytR1TyCu+L5o0PoT4TQpWZA7pY5XfpvWfejSU2H2jd4x2iquaX2
W45mPe1qjmCy/CH6vPwD/KPWGbTI7GIMqF9Kl+Aof4t4KxLq0zAwIoSTcoN0
Yrpnss7g16hZhxY9jbwmzEA9diCHv5Kuwr/qKmkFOvg7xPXIMudB/G32abl/
6LfOe9qz5nn+t9W0qa915gO0UM0CzMUzmIcJ/P3O1YYx4gRScYy/htdoxihx
i3Urkq3LzR9J99ij1OzV4g9pFW3nH0GPc30u/pP2oV3t62oqcccZq2h1PBf/
M/VtNMOdfOEuqu0931439f2F9ebkqrmn7309LeIO9Quc7Sz/e+yyXqtnI/ZY
v0XfwXHrfDOm4q7386X592i3/qvIN2uImZm0R1yr7iadLj6nt1w8RZwt7qPf
OcNtOoiC+ExxNn3Kmec6/w/md6KKf4lejN+Wnk65E/Q3+qL6Ilyzvorf0Y3p
SKhJd+4C/UvjGc1dQpP5JWa9jBq5V+jQsSHMkV9hPZuu5a9BsbgIw/Xk0anq
8rFLfMYe79FBeyThlHUKbxj9g56h1+kn8Y7op7SSViDH7PE4F++I38YrNmOb
vUe4gyTch+G4H7n8Dd7tYj2LsDC+y/h743WgVf5N77gW2XJ74zeFnXLLaAnG
8Z+UfwKb47PyynBbXEqXI5P/Lt2Ch7ANW7GbXxF/O0g3ZxOvDtvNX0hfwOh4
f/EbQZ36erkp1g+j0LrBvc+jT2Nc/O153gZck+9FD5r4i+hifC33Db7CeOSg
2v0Ns89QzPLubpi5z7sr9y76zH2N7pZrxmq1hfKP8Xv5l83swna5nZhj3nP2
O2xOr5oy9Y38V2meeBK69dV4tg/MeVbveusU95+FTBzkHzfnEN0gt58edJ5W
2qx/I+qwCelmZZmRRgvs+ROv1v7ZvDtxTz2b+ZPoivhdIpv/EU5F1M6mH9MM
WiI/zXqZ/V6K3zg6zZxpfqE5/fzH1V1Qc5Z/nl52xlm8G3J9+FF8CRf1/Jz4
/3/Ff4W71TQ=
          "]]},
        "0.06`"],
       Annotation[#, 0.06, "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1XtM11UYx/Fjq6WJhhc2JyJBA2dG7Qfowmmg5WhddLnuaak1UzRIKisN
DP8IcKK1NFOZXQhLSQYJTsRZSoZZbS281R+SmJCtVptu/dH1ddYfbz7n+Tzn
ec75nvP9/shYVDa3dFAIocGfk0NDyBsWQgJdw0O46poQzg4JIXV0CP3XhtAj
/+XIEI7xc5NDaB4Rwh6c4F0y5zJ6R4VwHn2YmhTC3XQ6vYtOowPm9ulzpfqL
xj+hR79frdcjf4meokPlf7F2Ms3Ud1RKCBm0G8fxBY4hhT8a8+xjp9rdet9p
r7voz/pcxAPW2CBOmNNsPML88UhDN/9Zfa42fo6uQLv9lNN9tF7Nk8bv0QPi
d2gHbaDvokX9MlqCJbG/eL01frPuYrpJXMhvNx5pjeuQjuP8F/QdbPwifR6d
+q6kB2mjmqXGS+I+4p7Qpeduz3hIPtsdLeLV69uuVxFto9tplvxSukWcTJeh
BLv4G/TdiIx4rrjsjPfL/UGb9D6gZh7tpI/R+XhbXao54zAGy+XG0mz+Dnt4
WpwuLqWd9CA6+PvxNS/TM14f7w8d8c6tO56mYbD8Iff1CXZ6pkbU6Nup9jP5
o1htvApH+E32/oxxGdY4j99pjn696pLFk7xn4/RcwPvc3Knyt6jrNi6gE82b
hMPW+xRdvDI6U20Ov0RdofiEukxeu3EdPaPvTLnbkMP7S/5vBFyBQWg27x/z
/sXt5iV4yfrfKG63/j4U83P5s+Ke5dp4N4j/dP4305tQJJehV4G6dDrNeqW8
5Zglvp8/wTiL9pifTVv1SXK+LXQYPa13ZTyj+G5jSHzX0Kq+T78W+k18Dve7
lW7DdrRhLxbL19O58R10B2/Gb5Zupk/RyfzZ9jA9ftf4mL/S2lvltmFv/K7E
bxmXxztDK2+LeCN9mL4Wf2/4C+K7qd9C+gZvCm8y8vF6fB/5E+2nmn4kfoJf
Y1yLPfGuxWuNH6fz0cSrElfTObSGTuDfa/yBdYY7nzreh/Hd4a93Blm8dbw6
41q6jubLr1bTKD4bf1/oy+JH+I/iHt7seO7OYRX/Jbyqrho1GGvPuc4mH3kY
4FW4l+/UfI9TOIPTSOHX6llojW/FRfQkfZDXoLZcr/dpP3+h93SAntevX92P
1r2AYvPP0fvU/EBnmFcrX2HeCnEl3YxNqIq/k7y1dEw8P70vxN95pIrT4r24
/wLrviL3EK2ga1CJo/IJvdOskY4q+SbzD9MjyENxfHZ6B03QGfEbwq0oQiHO
ee+nqO+lA+q/Svr//9B/7czoLw==
          "]]},
        "0.04`"],
       Annotation[#, 0.04, "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        {GrayLevel[0], Opacity[0.4], LineBox[CompressedData["
1:eJwl1FtM1nUcx/GfoBQPIoKS4VrzsImbaz6CW5ajZSvXLIG5iXQjA8eYTWgt
zTtHgboJ1XItqLRWEXJSyxtUPKRxhg6wYOa8KLzjopbrQjSr129dvPn8vp/v
4f/9Hx5WVr22o25eCGGnP2VZISQXhvA9ti4JIS0RwvCiEDr595aGcB9/87vl
H9B62iX3tbq3nVtQIf5G3OC8MjOEFRjOCWEEy7NDyMMyNGSE8JDcQbUnnLNy
QzhJJ8Qzam9j0+IQEuJV6j6xR7fr9+ANuQPYjzLxThx0/jL2m/0FfVNcyN9s
z3y73HA+zN9Oi1GCI+KX6UvYhnZ8hUb+aXoG5XgFzfY4S9+hS+2TiyH3Oog2
3keu+zE+RCtaMGqHQ3Kl+taK16DJ7FL+w/rv2a3Tbrv5lahCj3n9/MP8AXqE
HuVXx33pefM+pb30JJ0wbxN9EgU4Lq4wP8P8+/q79L/O348DOBd35h/jD9Em
2sx/1fxOetncdtqBU7gWd+FtcX4WNeobxdXxG4jP27x/6APvZ5o/pr5Zbo13
N+o8gkfV5GG7nYrjNyFfJL6lvkScJe41+1fxVn0X4n3iCb3l8qn8PvElvCh/
W3zReZ2dd8nPiMfN+42WiZNqUpx/0v+u2b/Q9+gEXU2n9E2jVFyCm/H9xD30
JJ236O9R12fmRewRV6ECd9T/iTNqf5Q7S+v0PKL/eTu9gFq9y3zPdXQf5uQ7
6F16iraprfG8MvXOU/cB72mznkI3r9b7q8MKtHq2+2g+/3N6XpxHL9AruIxv
5a6hC1eRbmYGEhiXP8rrde23kCqupyk0J/6u5H5w3RO0hr+EV+QeMmlb/J3y
v5NPM2sBnuEtlJvjL6Z74zfvPKCmhX4mzuavp4k4n9bzr8vP15+KJC9d7g5/
EV3Le9+5X81xOmiPLP7u+NtTGzzvf91zwvOf8qx+t/tfnt+U2j/4s+IFco+r
n03ny83QDPlteif1VJldiUnec2Y/pnajnkJswBC/J/5/4i/H/PhMzbmOpPr+
uJ/zsFkjmHTNAv5AvHf+KG8MP/M38gcT//8//Q/GDb6l
          "]]},
        "0.02`"],
       Annotation[#, 0.02, "Tooltip"]& ], {}, {}, {}}}], 
   {RGBColor[1, 0, 0], PointBox[CompressedData["
1:eJwVl2c8FQ4Xx4mQQgOlqIxSoRKK1slIUiQisiIqSiEjyazsZJdV/FH23uvY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     "]]}},
  AspectRatio->1,
  Frame->True,
  PlotRange->{{-2.1221124976737116`, 
   2.158212929565548}, {-2.1221124976737116`, 2.158212929565548}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 ImageSize->{184, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->39369532]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"vv", "=", 
   RowBox[{"{", 
    RowBox[{"{", "2", "}"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"s", "=", "0.5"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"deg", "=", "3"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"size", "=", "2001"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"StudentTDisplacements", "[", 
    RowBox[{"s", ",", " ", "vv", ",", "size", ",", 
     RowBox[{"SamplingPattern", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<Cholesky\>\"", ",", "deg", ",", "False"}], "}"}]}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Histogram", "[", 
  RowBox[{"data", ",", "Automatic", ",", "\"\<PDF\>\"", ",", 
   RowBox[{"Epilog", "\[Rule]", 
    RowBox[{"First", "@", 
     RowBox[{"Plot", "[", 
      RowBox[{
       RowBox[{"PDF", "[", 
        RowBox[{
         RowBox[{"StudentTDistribution", "[", 
          RowBox[{"0", ",", 
           RowBox[{"s", " ", 
            RowBox[{"Sqrt", "[", 
             RowBox[{"vv", "[", 
              RowBox[{"[", 
               RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}]}], ",", "deg"}], 
          "]"}], ",", "x"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"Min", "[", "data", "]"}], ",", 
         RowBox[{"Max", "[", "data", "]"}]}], "}"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", "Red"}], ",", 
       RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]}]}]}], 
  "]"}]}], "Input",
 CellLabel->"In[6]:=",
 CellID->84920708],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
   EdgeForm[Opacity[0.7]], {}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[Opacity[0.7]], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-8.4, 0.}, {-8.2, 0.002498750624687643}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{15.500000000000014`, 18.656425813568703`}, {
         38.894666859215015`, 40.27773676735785}}],
       StatusArea[#, 0.002498750624687643]& ,
       TagBoxNote->"0.002498750624687643"],
      StyleBox["0.002498750624687643`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.002498750624687643, {
        GrayLevel[0]}], 
      "Tooltip"]& ], {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-5.6, 0.}, {-5.4, 0.002498750624687665}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{45.68996138996141, 48.84638720353007}, {
         38.894666859215015`, 40.27773676735785}}],
       StatusArea[#, 0.002498750624687665]& ,
       TagBoxNote->"0.002498750624687665"],
      StyleBox["0.002498750624687665`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.002498750624687665, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-5.4, 0.}, {-5.2, 0.0024987506246876537`}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{47.84638720353007, 51.002813017098745`}, {
         38.894666859215015`, 40.27773676735785}}],
       StatusArea[#, 0.0024987506246876537`]& ,
       TagBoxNote->"0.0024987506246876537"],
      StyleBox["0.0024987506246876537`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.0024987506246876537`, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-5.2, 0.}, {-5., 0.0024987506246876537`}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{50.002813017098745`, 53.15923883066742}, {
         38.894666859215015`, 40.27773676735785}}],
       StatusArea[#, 0.0024987506246876537`]& ,
       TagBoxNote->"0.0024987506246876537"],
      StyleBox["0.0024987506246876537`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.0024987506246876537`, {
        GrayLevel[0]}], "Tooltip"]& ], {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-4.8, 0.}, {-4.6, 0.0024987506246876537`}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{54.31566464423609, 57.47209045780476}, {
         38.894666859215015`, 40.27773676735785}}],
       StatusArea[#, 0.0024987506246876537`]& ,
       TagBoxNote->"0.0024987506246876537"],
      StyleBox["0.0024987506246876537`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.0024987506246876537`, {
        GrayLevel[0]}], "Tooltip"]& ], {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-4.4, 0.}, {-4.2, 0.004997501249375307}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{58.62851627137343, 61.784942084942095`}, {
         38.51159695107218, 40.27773676735785}}],
       StatusArea[#, 0.004997501249375307]& ,
       TagBoxNote->"0.004997501249375307"],
      StyleBox["0.004997501249375307`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.004997501249375307, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-4.2, 0.}, {-4., 0.0074962518740629615`}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{60.784942084942095`, 63.94136789851077}, {
         38.12852704292935, 40.27773676735785}}],
       StatusArea[#, 0.0074962518740629615`]& ,
       TagBoxNote->"0.0074962518740629615"],
      StyleBox["0.0074962518740629615`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.0074962518740629615`, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-4., 0.}, {-3.8, 0.0024987506246876537`}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{62.94136789851077, 66.09779371207944}, {
         38.894666859215015`, 40.27773676735785}}],
       StatusArea[#, 0.0024987506246876537`]& ,
       TagBoxNote->"0.0024987506246876537"],
      StyleBox["0.0024987506246876537`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.0024987506246876537`, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-3.8, 0.}, {-3.6, 0.0049975012493753196`}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{65.09779371207944, 68.25421952564811}, {
         38.51159695107218, 40.27773676735785}}],
       StatusArea[#, 0.0049975012493753196`]& ,
       TagBoxNote->"0.0049975012493753196"],
      StyleBox["0.0049975012493753196`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.0049975012493753196`, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-3.6, 0.}, {-3.4, 0.0024987506246876537`}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{67.25421952564811, 70.41064533921679}, {
         38.894666859215015`, 40.27773676735785}}],
       StatusArea[#, 0.0024987506246876537`]& ,
       TagBoxNote->"0.0024987506246876537"],
      StyleBox["0.0024987506246876537`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.0024987506246876537`, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-3.4, 0.}, {-3.2, 0.007496251874062979}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{69.41064533921679, 72.56707115278545}, {
         38.12852704292934, 40.27773676735785}}],
       StatusArea[#, 0.007496251874062979]& ,
       TagBoxNote->"0.007496251874062979"],
      StyleBox["0.007496251874062979`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.007496251874062979, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-3.2, 0.}, {-3., 0.0074962518740629615`}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{71.56707115278545, 74.72349696635412}, {
         38.12852704292935, 40.27773676735785}}],
       StatusArea[#, 0.0074962518740629615`]& ,
       TagBoxNote->"0.0074962518740629615"],
      StyleBox["0.0074962518740629615`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.0074962518740629615`, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-3., 0.}, {-2.8, 0.004997501249375307}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{73.72349696635412, 76.8799227799228}, {
         38.51159695107218, 40.27773676735785}}],
       StatusArea[#, 0.004997501249375307]& ,
       TagBoxNote->"0.004997501249375307"],
      StyleBox["0.004997501249375307`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.004997501249375307, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-2.8, 0.}, {-2.6, 0.017491254372813618`}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{75.8799227799228, 79.03634859349145}, {
         36.596247410358, 40.27773676735785}}],
       StatusArea[#, 0.017491254372813618`]& ,
       TagBoxNote->"0.017491254372813618"],
      StyleBox["0.017491254372813618`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.017491254372813618`, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-2.6, 0.}, {-2.4, 0.032483758120939496`}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{78.03634859349145, 81.19277440706013}, {
         34.297827961501, 40.27773676735785}}],
       StatusArea[#, 0.032483758120939496`]& ,
       TagBoxNote->"0.032483758120939496"],
      StyleBox["0.032483758120939496`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.032483758120939496`, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-2.4, 0.}, {-2.2, 0.019990004997501278`}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{80.19277440706013, 83.3492002206288}, {
         36.21317750221517, 40.27773676735785}}],
       StatusArea[#, 0.019990004997501278`]& ,
       TagBoxNote->"0.019990004997501278"],
      StyleBox["0.019990004997501278`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.019990004997501278`, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-2.2, 0.}, {-2., 0.01749125437281358}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{82.3492002206288, 85.50562603419748}, {
         36.596247410358, 40.27773676735785}}],
       StatusArea[#, 0.01749125437281358]& ,
       TagBoxNote->"0.01749125437281358"],
      StyleBox["0.01749125437281358`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.01749125437281358, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-2., 0.}, {-1.8, 0.05247376311844079}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{84.50562603419748, 87.66205184776615}, {
         31.233268696358312`, 40.27773676735785}}],
       StatusArea[#, 0.05247376311844079]& ,
       TagBoxNote->"0.05247376311844079"],
      StyleBox["0.05247376311844079`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.05247376311844079, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-1.8, 0.}, {-1.6, 0.06496751624187906}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{86.66205184776615, 89.81847766133481}, {
         29.317919155644137`, 40.27773676735785}}],
       StatusArea[#, 0.06496751624187906]& ,
       TagBoxNote->"0.06496751624187906"],
      StyleBox["0.06496751624187906`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.06496751624187906, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-1.6, 0.}, {-1.4, 0.05747126436781604}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{88.81847766133481, 91.97490347490348}, {
         30.46712888007265, 40.27773676735785}}],
       StatusArea[#, 0.05747126436781604]& ,
       TagBoxNote->"0.05747126436781604"],
      StyleBox["0.05747126436781604`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.05747126436781604, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-1.4, 0.}, {-1.2, 0.13493253373313346`}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{90.97490347490348, 94.13132928847216}, {
         18.59196172764475, 40.27773676735785}}],
       StatusArea[#, 0.13493253373313346`]& ,
       TagBoxNote->"0.13493253373313346"],
      StyleBox["0.13493253373313346`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.13493253373313346`, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-1.2, 0.}, {-1., 0.17741129435282363`}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{93.13132928847216, 96.28775510204082}, {
         12.07977328921655, 40.27773676735785}}],
       StatusArea[#, 0.17741129435282363`]& ,
       TagBoxNote->"0.17741129435282363"],
      StyleBox["0.17741129435282363`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.17741129435282363`, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-1., 0.}, {-0.8, 0.1899050474762619}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{95.28775510204082, 98.4441809156095}, {
         10.164423748502376`, 40.27773676735785}}],
       StatusArea[#, 0.1899050474762619]& ,
       TagBoxNote->"0.1899050474762619"],
      StyleBox["0.1899050474762619`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.1899050474762619, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-0.8, 0.}, {-0.6, 0.2748625687156421}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{97.4441809156095, 
         100.60060672917817`}, {-2.8599531283540003`, 40.27773676735785}}],
       StatusArea[#, 0.2748625687156421]& ,
       TagBoxNote->"0.2748625687156421"],
      StyleBox["0.2748625687156421`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.2748625687156421, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-0.6, 0.}, {-0.4, 0.4022988505747127}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{99.60060672917817, 
         102.75703254274684`}, {-22.396518443638612`, 40.27773676735785}}],
       StatusArea[#, 0.4022988505747127]& ,
       TagBoxNote->"0.4022988505747127"],
      StyleBox["0.4022988505747127`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.4022988505747127, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-0.4, 0.}, {-0.2, 0.5897051474262869}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{101.75703254274684`, 
         104.9134583563155}, {-51.12676155435125, 40.27773676735785}}],
       StatusArea[#, 0.5897051474262869]& ,
       TagBoxNote->"0.5897051474262869"],
      StyleBox["0.5897051474262869`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.5897051474262869, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{-0.2, 0.}, {0., 0.5322338830584707}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{103.9134583563155, 
         107.06988416988418`}, {-42.31615366706603, 40.27773676735785}}],
       StatusArea[#, 0.5322338830584707]& ,
       TagBoxNote->"0.5322338830584707"],
      StyleBox["0.5322338830584707`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.5322338830584707, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{0., 0.}, {0.2, 0.5097451274362819}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{106.06988416988418`, 
         109.22630998345285`}, {-38.86852449378051, 40.27773676735785}}],
       StatusArea[#, 0.5097451274362819]& ,
       TagBoxNote->"0.5097451274362819"],
      StyleBox["0.5097451274362819`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.5097451274362819, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{0.2, 0.}, {0.4, 0.4247876061969016}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{108.22630998345285`, 
         111.38273579702151`}, {-25.844147616924133`, 40.27773676735785}}],
       StatusArea[#, 0.4247876061969016]& ,
       TagBoxNote->"0.4247876061969016"],
      StyleBox["0.4247876061969016`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.4247876061969016, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{0.4, 0.}, {0.6, 0.3598200899550225}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{110.38273579702151`, 
         113.53916161059018`}, {-15.884330005210408`, 40.27773676735785}}],
       StatusArea[#, 0.3598200899550225]& ,
       TagBoxNote->"0.3598200899550225"],
      StyleBox["0.3598200899550225`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.3598200899550225, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{0.6, 0.}, {0.8, 0.25987006496751613`}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{112.53916161059018`, 
         115.69558742415886`}, {-0.5615336794969892, 40.27773676735785}}],
       StatusArea[#, 0.25987006496751613`]& ,
       TagBoxNote->"0.25987006496751613"],
      StyleBox["0.25987006496751613`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.25987006496751613`, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{0.8, 0.}, {1., 0.2523738130934533}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{114.69558742415886`, 117.85201323772753`}, {
         0.5876760449314986, 40.27773676735785}}],
       StatusArea[#, 0.2523738130934533]& ,
       TagBoxNote->"0.2523738130934533"],
      StyleBox["0.2523738130934533`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.2523738130934533, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1., 0.}, {1.2, 0.14242878560719643`}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{116.85201323772753`, 120.0084390512962}, {
         17.442752003216242`, 40.27773676735785}}],
       StatusArea[#, 0.14242878560719643`]& ,
       TagBoxNote->"0.14242878560719643"],
      StyleBox["0.14242878560719643`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.14242878560719643`, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1.2, 0.}, {1.4, 0.10744627686156923`}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{119.0084390512962, 122.16486486486487`}, {
         22.80573071721594, 40.27773676735785}}],
       StatusArea[#, 0.10744627686156923`]& ,
       TagBoxNote->"0.10744627686156923"],
      StyleBox["0.10744627686156923`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.10744627686156923`, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1.4, 0.}, {1.6, 0.07746126936531728}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{121.16486486486487`, 124.32129067843354`}, {
         27.402569614929973`, 40.27773676735785}}],
       StatusArea[#, 0.07746126936531728]& ,
       TagBoxNote->"0.07746126936531728"],
      StyleBox["0.07746126936531728`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.07746126936531728, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1.6, 0.}, {1.8, 0.059970014992503755`}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{123.32129067843354`, 126.4777164920022}, {
         30.084058971929807`, 40.27773676735785}}],
       StatusArea[#, 0.059970014992503755`]& ,
       TagBoxNote->"0.059970014992503755"],
      StyleBox["0.059970014992503755`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.059970014992503755`, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{1.8, 0.}, {2., 0.03748125937031485}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{125.4777164920022, 128.6341423055709}, {
         33.53168814521532, 40.27773676735785}}],
       StatusArea[#, 0.03748125937031485]& ,
       TagBoxNote->"0.03748125937031485"],
      StyleBox["0.03748125937031485`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.03748125937031485, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{2., 0.}, {2.2, 0.022488755622188883`}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{127.63414230557089`, 130.79056811913955`}, {
         35.83010759407234, 40.27773676735785}}],
       StatusArea[#, 0.022488755622188883`]& ,
       TagBoxNote->"0.022488755622188883"],
      StyleBox["0.022488755622188883`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.022488755622188883`, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{2.2, 0.}, {2.4, 0.02748625687156426}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{129.79056811913955`, 132.9469939327082}, {
         35.06396777778666, 40.27773676735785}}],
       StatusArea[#, 0.02748625687156426]& ,
       TagBoxNote->"0.02748625687156426"],
      StyleBox["0.02748625687156426`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.02748625687156426, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{2.4, 0.}, {2.6, 0.02498750624687654}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{131.9469939327082, 135.1034197462769}, {
         35.4470376859295, 40.27773676735785}}],
       StatusArea[#, 0.02498750624687654]& ,
       TagBoxNote->"0.02498750624687654"],
      StyleBox["0.02498750624687654`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.02498750624687654, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{2.6, 0.}, {2.8, 0.0124937531234383}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{134.1034197462769, 137.25984555984556`}, {
         37.36238722664367, 40.27773676735785}}],
       StatusArea[#, 0.0124937531234383]& ,
       TagBoxNote->"0.0124937531234383"],
      StyleBox["0.0124937531234383`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.0124937531234383, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{2.8, 0.}, {3., 0.009995002498750615}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{136.25984555984556`, 139.41627137341425`}, {
         37.74545713478651, 40.27773676735785}}],
       StatusArea[#, 0.009995002498750615]& ,
       TagBoxNote->"0.009995002498750615"],
      StyleBox["0.009995002498750615`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.009995002498750615, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{3., 0.}, {3.2, 0.004997501249375307}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{138.41627137341425`, 141.5726971869829}, {
         38.51159695107218, 40.27773676735785}}],
       StatusArea[#, 0.004997501249375307]& ,
       TagBoxNote->"0.004997501249375307"],
      StyleBox["0.004997501249375307`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.004997501249375307, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{3.2, 0.}, {3.4, 0.014992503748125958`}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{140.5726971869829, 143.72912300055157`}, {
         36.97931731850084, 40.27773676735785}}],
       StatusArea[#, 0.014992503748125958`]& ,
       TagBoxNote->"0.014992503748125958"],
      StyleBox["0.014992503748125958`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.014992503748125958`, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{3.4, 0.}, {3.6, 0.004997501249375307}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{142.72912300055157`, 145.88554881412023`}, {
         38.51159695107218, 40.27773676735785}}],
       StatusArea[#, 0.004997501249375307]& ,
       TagBoxNote->"0.004997501249375307"],
      StyleBox["0.004997501249375307`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.004997501249375307, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{3.6, 0.}, {3.8, 0.0024987506246876598`}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{144.88554881412023`, 148.04197462768892`}, {
         38.894666859215015`, 40.27773676735785}}],
       StatusArea[#, 0.0024987506246876598`]& ,
       TagBoxNote->"0.0024987506246876598"],
      StyleBox["0.0024987506246876598`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.0024987506246876598`, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{3.8, 0.}, {4., 0.0074962518740629615`}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{147.04197462768892`, 150.19840044125758`}, {
         38.12852704292935, 40.27773676735785}}],
       StatusArea[#, 0.0074962518740629615`]& ,
       TagBoxNote->"0.0074962518740629615"],
      StyleBox["0.0074962518740629615`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.0074962518740629615`, {
        GrayLevel[0]}], "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{4., 0.}, {4.2, 0.0074962518740629615`}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{149.19840044125758`, 152.35482625482626`}, {
         38.12852704292935, 40.27773676735785}}],
       StatusArea[#, 0.0074962518740629615`]& ,
       TagBoxNote->"0.0074962518740629615"],
      StyleBox["0.0074962518740629615`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.0074962518740629615`, {
        GrayLevel[0]}], "Tooltip"]& ], {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{4.4, 0.}, {4.6, 0.002498750624687665}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{153.51125206839492`, 156.66767788196358`}, {
         38.894666859215015`, 40.27773676735785}}],
       StatusArea[#, 0.002498750624687665]& ,
       TagBoxNote->"0.002498750624687665"],
      StyleBox["0.002498750624687665`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.002498750624687665, {
        GrayLevel[0]}], "Tooltip"]& ], {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{4.8, 0.}, {5., 0.004997501249375307}, "RoundingRadius" -> 
          0]},
        ImageSizeCache->{{157.82410369553227`, 160.98052950910093`}, {
         38.51159695107218, 40.27773676735785}}],
       StatusArea[#, 0.004997501249375307]& ,
       TagBoxNote->"0.004997501249375307"],
      StyleBox["0.004997501249375307`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.004997501249375307, {
        GrayLevel[0]}], "Tooltip"]& ], {}, {}, {}, {}, {}, {}, 
    TagBox[
     TooltipBox[
      TagBox[
       DynamicBox[{
         FEPrivate`If[
          CurrentValue["MouseOver"], 
          EdgeForm[{
            GrayLevel[0.5], 
            AbsoluteThickness[1.5], 
            Opacity[0.66]}], {}, {}], 
         RectangleBox[{6.2, 0.}, {6.4, 0.0024987506246876537`}, 
          "RoundingRadius" -> 0]},
        ImageSizeCache->{{172.91908439051298`, 176.07551020408164`}, {
         38.894666859215015`, 40.27773676735785}}],
       StatusArea[#, 0.0024987506246876537`]& ,
       TagBoxNote->"0.0024987506246876537"],
      StyleBox["0.0024987506246876537`", {
        GrayLevel[0]}, StripOnInput -> False]],
     Annotation[#, 
      Style[0.0024987506246876537`, {
        GrayLevel[0]}], "Tooltip"]& ]}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesOrigin->{-8.4, 0},
  Epilog->{{{}, {}, {
      Hue[0.67, 0.6, 0.6], 
      RGBColor[1, 0, 0], 
      LineBox[CompressedData["
1:eJwVVnc8198XtvdeH7MkoUSRolLnnczskVFIthAihCSE7F1WVqiM7Ch5X7Ky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       "]]}}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  PlotRange->NCache[{{
      Rational[-42, 5], 
      Rational[32, 5]}, {All, All}}, {{-8.4, 6.4}, {All, All}}],
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 ImageSize->{184, 117},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->171799340]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 CellID->38303248],

Cell[TextData[ButtonBox["Metropolis",
 BaseStyle->"Link",
 ButtonData->"paclet:Metropolis/guide/Metropolis"]], "MoreAbout",
 CellID->13856003]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 730},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"StudentTDisplacements - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2013, 2, 10, 17, 35, 59.4449004}", "context" -> "Metropolis`",
     "keywords" -> {}, "index" -> True, "label" -> "Metropolis Paclet Symbol",
     "language" -> "en", "paclet" -> "Metropolis", "status" -> "None", 
    "summary" -> 
    "StudentTDisplacements][s, V, n] gives n random samples from student T \
distribution with mean 0, covaraince s V, and the default Infinity degree.", 
    "synonyms" -> {}, "title" -> "StudentTDisplacements", "type" -> "Symbol", 
    "uri" -> "Metropolis/ref/StudentTDisplacements"}, "LinkTrails" -> "", 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (February 23, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (February 23, 2011)",
   StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6529, 192, 461, 13, 70, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->755569806]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 290768, 5974}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[614, 21, 76, 1, 70, "SymbolColorBar"],
Cell[693, 24, 185, 5, 70, "LinkTrail"],
Cell[881, 31, 2377, 54, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3283, 89, 64, 1, 70, "ObjectName",
 CellID->1224892054],
Cell[3350, 92, 522, 14, 70, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[3909, 111, 579, 17, 70, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->69841906],
Cell[4491, 130, 73, 1, 70, "Notes",
 CellID->1067943069],
Cell[4567, 133, 902, 22, 70, "3ColumnTableMod",
 CellID->563929935],
Cell[5472, 157, 163, 4, 70, "Notes",
 CellID->484368326],
Cell[5638, 163, 83, 1, 70, "Notes",
 CellID->293038167],
Cell[5724, 166, 580, 15, 70, "2ColumnTableMod",
 CellID->169206402],
Cell[6307, 183, 185, 4, 70, "Notes",
 CellID->251039541]
}, Closed]],
Cell[CellGroupData[{
Cell[6529, 192, 461, 13, 70, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->755569806],
Cell[CellGroupData[{
Cell[7015, 209, 148, 5, 70, "ExampleSection",
 CellID->111341187],
Cell[7166, 216, 118, 3, 70, "Input",
 CellID->77562214],
Cell[CellGroupData[{
Cell[7309, 223, 1676, 54, 70, "Input",
 CellID->437547314],
Cell[8988, 279, 1478, 41, 49, "Output",
 CellID->1282071],
Cell[10469, 322, 1512, 41, 49, "Output",
 CellID->320561247]
}, Open  ]],
Cell[CellGroupData[{
Cell[12018, 368, 144, 4, 70, "Input",
 CellID->299975583],
Cell[12165, 374, 180, 5, 36, "Output",
 CellID->370255386]
}, Open  ]],
Cell[CellGroupData[{
Cell[12382, 384, 1292, 37, 70, "Input",
 CellID->93149538],
Cell[13677, 423, 52774, 1282, 70, "Output",
 CellID->209009189]
}, Open  ]],
Cell[CellGroupData[{
Cell[66488, 1710, 701, 21, 70, "Input",
 CellID->197763768],
Cell[67192, 1733, 167186, 2801, 70, "Output",
 CellID->39369532]
}, Open  ]],
Cell[CellGroupData[{
Cell[234415, 4539, 1552, 43, 70, "Input",
 CellID->84920708],
Cell[235970, 4584, 52673, 1326, 70, "Output",
 CellID->171799340]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[288704, 5917, 419, 12, 70, "MoreAboutSection",
 CellID->38303248],
Cell[289126, 5931, 142, 3, 70, "MoreAbout",
 CellID->13856003]
}, Open  ]],
Cell[289283, 5937, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

