(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     10196,        315]
NotebookOptionsPosition[      7489,        235]
NotebookOutlinePosition[      9403,        285]
CellTagsIndexPosition[      9319,        280]
WindowTitle->DiscreteRatioOfUniform - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["RandomGenerator",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:RandomGenerator/guide/RandomGenerator"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {Cell["RANDOMGENERATOR PACKAGE PACLET SYMBOL", "PacletNameCell"], Cell[
    TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"RandomGenerator\"\>":>
       Documentation`HelpLookup[
       "paclet:RandomGenerator/guide/RandomGenerator"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"RandomGenerator/ref/DiscreteRatioOfUniform\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["RandomGenerator/ref/DiscreteRatioOfUniform"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/RandomGenerator/ref/\
DiscreteRatioOfUniform.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "RandomGenerator/ref/DiscreteRatioOfUniform", ".html"]], 
           None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["DiscreteRatioOfUniform", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"DiscreteRatioOfUniform", "[", 
       RowBox[{
        StyleBox["f", "TI"], ",", 
        StyleBox["lb", "TI"], ",", 
        StyleBox["ub", "TI"], ",", 
        ButtonBox["S",
         BaseStyle->"Link",
         ButtonData->"paclet:ref/S"], ",", " ", 
        StyleBox["xm", "TI"], ",", 
        StyleBox["ym", "TI"], ",", 
        StyleBox["cdfm", "TI"], ",", " ", 
        StyleBox["n", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]gives n random draws from the distributed f(x), \
truncted to be in the range [lb, ub]. ym=f(xm) and cdfm=CDF(xm) where ym is \
the maximum of f(xm). f(x) is assumed to be T_ (-1/2) concave, and 1/S is the \
normalization constant of f(x). By defult, cdfm is not given (-1) and n=1."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->39488032],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection",
 CellID->74089152],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<RandomGenerator`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->609034913],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"lam", "=", "2.4"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lb", "=", "2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f", "=", 
   RowBox[{
    FractionBox[
     RowBox[{
      RowBox[{"Exp", "[", 
       RowBox[{"-", "lam"}], "]"}], " ", 
      RowBox[{"lam", "^", "#"}]}], 
     RowBox[{"#", "!"}]], "&"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xm", "=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"IntegerPart", "[", "lam", "]"}], "\[Equal]", "lam"}], ",", 
     RowBox[{"lam", "-", "1"}], ",", 
     RowBox[{"Floor", "[", "lam", "]"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"xm", "=", 
   RowBox[{"Max", "[", 
    RowBox[{"lb", ",", "xm"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"s", "=", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{"f", "[", "x", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "lb", ",", "Infinity"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"DiscreteRatioOfUniform", "[", 
  RowBox[{"f", ",", "lb", ",", "Infinity", ",", "s", ",", "xm", ",", 
   RowBox[{"f", "[", "xm", "]"}], ",", 
   RowBox[{"-", "1"}], ",", "10"}], "]"}]}], "Input",
 CellLabel->"In[2]:=",
 CellID->22448325],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "6", ",", "3", ",", "2", ",", "3", ",", "6", ",", "4", ",", "3", ",", "4", 
   ",", "2", ",", "4"}], "}"}]], "Output",
 ImageSize->{187, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->529581877]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 CellID->38303248],

Cell[TextData[ButtonBox["RandomGenerator",
 BaseStyle->"Link",
 ButtonData->"paclet:RandomGenerator/guide/RandomGenerator"]], "MoreAbout",
 CellID->77280639]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 730},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"DiscreteRatioOfUniform - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2013, 2, 10, 20, 28, 17.8933526}", "context" -> 
    "RandomGenerator`", "keywords" -> {}, "index" -> True, "label" -> 
    "RandomGenerator Package Paclet Symbol", "language" -> "en", "paclet" -> 
    "RandomGenerator Package", "status" -> "None", "summary" -> 
    "DiscreteRatioOfUniform[f, lb, ub, S, xm, ym, cdfm, n] gives n random \
draws from the distributed f(x), truncted to be in the range [lb, ub]. \
ym=f(xm) and cdfm=CDF(xm) where ym is the maximum of f(xm). f(x) is assumed \
to be T_(-1/2) concave, and 1/S is the normalization constant of f(x). By \
defult, cdfm is not given (-1) and n=1.", "synonyms" -> {}, "title" -> 
    "DiscreteRatioOfUniform", "type" -> "Symbol", "uri" -> 
    "RandomGenerator/ref/DiscreteRatioOfUniform"}, "LinkTrails" -> "", 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (February 23, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (February 23, 2011)",
   StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4465, 125, 460, 13, 70, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->39488032]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 9177, 273}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[615, 21, 76, 1, 70, "SymbolColorBar"],
Cell[694, 24, 200, 5, 70, "LinkTrail"],
Cell[897, 31, 2464, 58, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3386, 93, 65, 1, 70, "ObjectName",
 CellID->1224892054],
Cell[3454, 96, 974, 24, 70, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4465, 125, 460, 13, 70, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->39488032],
Cell[CellGroupData[{
Cell[4950, 142, 147, 5, 70, "ExampleSection",
 CellID->74089152],
Cell[5100, 149, 124, 3, 70, "Input",
 CellID->609034913],
Cell[CellGroupData[{
Cell[5249, 156, 1264, 39, 70, "Input",
 CellID->22448325],
Cell[6516, 197, 291, 9, 36, "Output",
 CellID->529581877]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6868, 213, 419, 12, 70, "MoreAboutSection",
 CellID->38303248],
Cell[7290, 227, 157, 3, 70, "MoreAbout",
 CellID->77280639]
}, Open  ]],
Cell[7462, 233, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

