(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[      7713,        228]
NotebookOptionsPosition[      5577,        172]
NotebookOutlinePosition[      7384,        216]
CellTagsIndexPosition[      7341,        213]
WindowTitle->TreeLogLikelihood - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["SMARTree",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:SMARTree/guide/SMARTree"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {Cell["SMARTREE PACLET SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"SMARTree\"\>":>Documentation`HelpLookup[
       "paclet:SMARTree/guide/SMARTree"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"SMARTree/ref/TreeLogLikelihood\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["SMARTree/ref/TreeLogLikelihood"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/SMARTree/ref/\
TreeLogLikelihood.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "SMARTree/ref/TreeLogLikelihood", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell["TreeLogLikelihood", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"TreeLogLikelihood", "[", 
       RowBox[{
       "SNPvec", ",", "tree", ",", "afreqvec", ",", "theta", ",", "epsilon", 
        ",", "modelid"}], "]"}]], "InlineFormula"],
     " \[LineSeparator]returns the log likelihood for a single SNP data \
vector ",
     StyleBox["SNPvec",
      FontSlant->"Italic"],
     "  given ",
     StyleBox["theta",
      FontSlant->"Italic"],
     ", ",
     StyleBox["espilon",
      FontSlant->"Italic"],
     ", the ",
     StyleBox[" tree",
      FontSlant->"Italic"],
     " and the allele frequncy ",
     StyleBox["afreqvec",
      FontSlant->"Italic"],
     " at the SNP site."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"TreeLogLikelihood", "[", 
       RowBox[{
       "SNPmtx", ",", "trees", ",", "afreqmtx", ",", "theta", ",", "epsilon", 
        ",", "modelid"}], "]"}]], "InlineFormula"],
     "\[LineSeparator]returns  a list of log likelihood for multiple SNP data \
matrix ",
     StyleBox["SNPmtx",
      FontSlant->"Italic"],
     " given",
     StyleBox[" theta",
      FontSlant->"Italic"],
     ", ",
     StyleBox["espilon",
      FontSlant->"Italic"],
     ", the ",
     StyleBox["trees",
      FontSlant->"Italic"],
     " and the allele frequncies",
     StyleBox[" afreqmtx",
      FontSlant->"Italic"],
     "  at SNP sites. Each row of ",
     StyleBox["SNPmtx",
      FontSlant->"Italic"],
     " corresponds data at a site. "
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 CellID->38303248],

Cell[TextData[ButtonBox["SMARTree",
 BaseStyle->"Link",
 ButtonData->"paclet:SMARTree/guide/SMARTree"]], "MoreAbout",
 CellID->304580657]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 730},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"TreeLogLikelihood - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2013, 7, 10, 15, 42, 7.0067695}", "context" -> "SMARTree`", 
    "keywords" -> {}, "index" -> True, "label" -> "SMARTree Paclet Symbol", 
    "language" -> "en", "paclet" -> "SMARTree", "status" -> "None", "summary" -> 
    "TreeLogLikelihood[SNPvec, tree, afreqvec, theta, epsilon, modelid] \
returns the log likelihood for a single SNP data vector SNPvec given theta, \
espilon, the tree and the allele frequncy afreqvec at the SNP \
site.TreeLogLikelihood[SNPmtx, trees, afreqmtx, theta, epsilon, modelid] \
returns a list of log likelihood for multiple SNP data matrix SNPmtx given \
theta, espilon, the trees and the allele frequncies afreqmtx at SNP sites. \
Each row of SNPmtx corresponds data at a site. ", "synonyms" -> {}, "title" -> 
    "TreeLogLikelihood", "type" -> "Symbol", "uri" -> 
    "SMARTree/ref/TreeLogLikelihood"}, "LinkTrails" -> "", 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "9.0 for Microsoft Windows (64-bit) (January 25, 2013)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[610, 21, 76, 1, 70, "SymbolColorBar"],
Cell[689, 24, 179, 5, 70, "LinkTrail"],
Cell[871, 31, 2331, 53, 70, "AnchorBarGrid",
 CellID->1],
Cell[3205, 86, 60, 1, 70, "ObjectName",
 CellID->1224892054],
Cell[3268, 89, 1683, 57, 70, "Usage",
 CellID->982511436],
Cell[CellGroupData[{
Cell[4976, 150, 419, 12, 70, "MoreAboutSection",
 CellID->38303248],
Cell[5398, 164, 137, 3, 70, "MoreAbout",
 CellID->304580657]
}, Open  ]],
Cell[5550, 170, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

