(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[      8918,        274]
NotebookOptionsPosition[      6602,        208]
NotebookOutlinePosition[      8237,        249]
CellTagsIndexPosition[      8194,        246]
WindowTitle->initializeSMARTchain - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["SMARTree",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:SMARTree/guide/SMARTree"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {Cell["SMARTREE PACLET SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"SMARTree\"\>":>Documentation`HelpLookup[
       "paclet:SMARTree/guide/SMARTree"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"SMARTree/ref/initializeSMARTchain\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["SMARTree/ref/initializeSMARTchain"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/SMARTree/ref/\
initializeSMARTchain.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "SMARTree/ref/initializeSMARTchain", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell["initializeSMARTchain", "ObjectName",
 CellID->1224892054],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"initializeSMARTchain", "[", 
       RowBox[{
       "inputsnpls", ",", "nsq", ",", "nbp", ",", "initheta", ",", "inirho", 
        ",", "inieps"}], "]"}]], "InlineFormula"],
     " \[LineSeparator]generates initial values for one MCMC chain, and \
returns {{",
     StyleBox["theta",
      FontSlant->"Italic"],
     ", ",
     StyleBox["epsilon",
      FontSlant->"Italic"],
     ",",
     StyleBox[" rho",
      FontSlant->"Italic"],
     "},",
     StyleBox[" treels",
      FontSlant->"Italic"],
     ", adpaptive parameters, ",
     StyleBox["snpls",
      FontSlant->"Italic"],
     "}. In the last column of ",
     StyleBox["snpls",
      FontSlant->"Italic"],
     ", the log likelihood given the initialized ",
     StyleBox["treels",
      FontSlant->"Italic"],
     " over-writes the values in ",
     StyleBox["inputsnpls",
      FontSlant->"Italic"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->258434224],

Cell[TextData[{
 "The ",
 StyleBox["initheta",
  FontSlant->"Italic"],
 " = {shape, scale, min, max}, and the initial theta is sampled from the \
GammaDistribution [shape, scale], truncated to be in the range [min,max]. If \
scale=Infinity, it becomes the UniformDistribution [min, max]."
}], "Notes",
 CellID->1067943069],

Cell[TextData[{
 "The ",
 StyleBox["inirho",
  FontSlant->"Italic"],
 " = {shape, scale, min, max}, and the initial rho is sampled from the \
GammaDistribution [shape, scale], truncated to be in the range [min,max]. If \
scale=Infinity,  it becomes the UniformDistribution [min, max]."
}], "Notes",
 CellID->468035209],

Cell[TextData[{
 "The ",
 StyleBox["iniepsilon",
  FontSlant->"Italic"],
 " = {alpha, beta, min, max}, and the initial epsilon is sampled from the \
BetaDistribution [alpha, beta], truncated to be in the range [min,max]."
}], "Notes",
 CellID->172182771]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 CellID->38303248],

Cell[TextData[ButtonBox["SMARTree",
 BaseStyle->"Link",
 ButtonData->"paclet:SMARTree/guide/SMARTree"]], "MoreAbout",
 CellID->103512236]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 730},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"initializeSMARTchain - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2013, 7, 10, 15, 41, 58.8791552}", "context" -> "SMARTree`", 
    "keywords" -> {}, "index" -> True, "label" -> "SMARTree Paclet Symbol", 
    "language" -> "en", "paclet" -> "SMARTree", "status" -> "None", "summary" -> 
    "initializeSMARTchain[inputsnpls, nsq, nbp, initheta, inirho, inieps] \
generates initial values for one MCMC chain, and returns {{theta, epsilon, \
rho}, treels, adpaptive parameters, snpls}. In the last column of snpls, the \
log likelihood given the initialized treels over-writes the values in \
inputsnpls.", "synonyms" -> {}, "title" -> "initializeSMARTchain", "type" -> 
    "Symbol", "uri" -> "SMARTree/ref/initializeSMARTchain"}, "LinkTrails" -> 
  "", "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "9.0 for Microsoft Windows (64-bit) (January 25, 2013)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[613, 21, 76, 1, 70, "SymbolColorBar"],
Cell[692, 24, 179, 5, 70, "LinkTrail"],
Cell[874, 31, 2343, 53, 70, "AnchorBarGrid",
 CellID->1],
Cell[3220, 86, 63, 1, 70, "ObjectName",
 CellID->1224892054],
Cell[CellGroupData[{
Cell[3308, 91, 1136, 39, 70, "Usage",
 CellID->982511436],
Cell[CellGroupData[{
Cell[4469, 134, 580, 17, 70, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->258434224],
Cell[5052, 153, 322, 8, 70, "Notes",
 CellID->1067943069],
Cell[5377, 163, 318, 8, 70, "Notes",
 CellID->468035209],
Cell[5698, 173, 254, 7, 70, "Notes",
 CellID->172182771]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6001, 186, 419, 12, 70, "MoreAboutSection",
 CellID->38303248],
Cell[6423, 200, 137, 3, 70, "MoreAbout",
 CellID->103512236]
}, Open  ]],
Cell[6575, 206, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

