(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[      8658,        265]
NotebookOptionsPosition[      6290,        193]
NotebookOutlinePosition[      7750,        232]
CellTagsIndexPosition[      7707,        229]
WindowTitle->updateSMARTchain - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["SMARTree",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:SMARTree/guide/SMARTree"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {Cell["SMARTREE PACLET SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"SMARTree\"\>":>Documentation`HelpLookup[
       "paclet:SMARTree/guide/SMARTree"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"SMARTree/ref/updateSMARTchain\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["SMARTree/ref/updateSMARTchain"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/SMARTree/ref/\
updateSMARTchain.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "SMARTree/ref/updateSMARTchain", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell["updateSMARTchain", "ObjectName",
 CellID->1224892054],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"updateSMARTchain", "[", 
       RowBox[{
       "chainstate", ",", "nsq", ",", "nbp", ",", " ", "pritheta", ",", 
        "prirho", ",", "prieps", ",", "isadp", ",", "adprate", ",", "rjfreq", 
        ",", "isprint"}], "]"}]], "InlineFormula"],
     " \[LineSeparator]updates chainstate for one MCMC chain. "
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->623161619],

Cell["\<\
The pritheta = {shape, scale, min, max}, and the theta in prior follows the \
GammaDistribution [shape, scale], truncated to be in the range [min,max]. If \
scale=Infinity, it becomes the UniformDistribution [min, max].\
\>", "Notes",
 CellID->42312707],

Cell["\<\
The prirho = {shape, scale, min, max}, and the rho in prior follows the \
GammaDistribution [shape, scale], truncated to be in the range [min,max]. If \
scale=Infinity,  it becomes the UniformDistribution [min, max].\
\>", "Notes",
 CellID->468035209],

Cell["\<\
The priepsilon = {alpha, beta, min, max}, and  the epsilon in prior follows \
the the BetaDistribution [alpha, beta], truncated to be in the range \
[min,max].\
\>", "Notes",
 CellID->172182771],

Cell["\<\
isadp: whether the proposal distributions are adpatived (isadp=True) or not \
(isadp=False).\
\>", "Notes",
 CellID->1067943069],

Cell["adprate: the rate of adaptation if isadp=True.", "Notes",
 CellID->63709979],

Cell["rjfreq: the number of reversible jump sampler per iteration.", "Notes",
 CellID->127269047],

Cell["\<\
isprint: whether each step of updateSMARTchain is printed on monitor.\
\>", "Notes",
 CellID->644741022]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 CellID->38303248],

Cell[TextData[ButtonBox["SMARTree",
 BaseStyle->"Link",
 ButtonData->"paclet:SMARTree/guide/SMARTree"]], "MoreAbout",
 CellID->580003284]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 730},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"updateSMARTchain - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2013, 7, 10, 15, 42, 17.6021882}", "context" -> "SMARTree`", 
    "keywords" -> {}, "index" -> True, "label" -> "SMARTree Paclet Symbol", 
    "language" -> "en", "paclet" -> "SMARTree", "status" -> "None", "summary" -> 
    "updateSMARTchain[chainstate, nsq, nbp, pritheta, prirho, prieps, \\ \
isadp, adprate, rjfreq, isprint] updates chainstate for one MCMC chain. ", 
    "synonyms" -> {}, "title" -> "updateSMARTchain", "type" -> "Symbol", 
    "uri" -> "SMARTree/ref/updateSMARTchain"}, "LinkTrails" -> "", 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "9.0 for Microsoft Windows (64-bit) (January 25, 2013)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[609, 21, 76, 1, 70, "SymbolColorBar"],
Cell[688, 24, 179, 5, 70, "LinkTrail"],
Cell[870, 31, 2327, 53, 70, "AnchorBarGrid",
 CellID->1],
Cell[3200, 86, 59, 1, 70, "ObjectName",
 CellID->1224892054],
Cell[CellGroupData[{
Cell[3284, 91, 571, 15, 70, "Usage",
 CellID->982511436],
Cell[CellGroupData[{
Cell[3880, 110, 580, 17, 70, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->623161619],
Cell[4463, 129, 263, 5, 70, "Notes",
 CellID->42312707],
Cell[4729, 136, 261, 5, 70, "Notes",
 CellID->468035209],
Cell[4993, 143, 204, 5, 70, "Notes",
 CellID->172182771],
Cell[5200, 150, 138, 4, 70, "Notes",
 CellID->1067943069],
Cell[5341, 156, 82, 1, 70, "Notes",
 CellID->63709979],
Cell[5426, 159, 97, 1, 70, "Notes",
 CellID->127269047],
Cell[5526, 162, 114, 3, 70, "Notes",
 CellID->644741022]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5689, 171, 419, 12, 70, "MoreAboutSection",
 CellID->38303248],
Cell[6111, 185, 137, 3, 70, "MoreAbout",
 CellID->580003284]
}, Open  ]],
Cell[6263, 191, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

